/* Create Domains... */
CREATE DOMAIN DM_CHAR_300 AS VARCHAR(300);

/* Create Table... */
CREATE TABLE H_ONK_N018(ID DM_ID NOT NULL,
ID_REAS DM_INT,
REAS_NAME DM_CHAR_300,
DATEBEG DM_DATE,
DATEEND DM_DATE);


ALTER TABLE H_ONK_N018 ADD EPV COMPUTED BY ((cast(iif(dateend is null, '31.12.9999', dateend) as date)));

CREATE TABLE H_ONK_N019(ID DM_ID NOT NULL,
ID_CONS DM_INT,
CONS_NAME DM_CHAR_300,
DATEBEG DM_DATE,
DATEEND DM_DATE);


ALTER TABLE H_ONK_N019 ADD EPV COMPUTED BY ((cast(iif(dateend is null, '31.12.9999', dateend) as date)));

CREATE TABLE H_ONK_N020(ID DM_ID NOT NULL,
ID_LEKP DM_CHAR_10,
MNN DM_CHAR_1000,
DATEBEG DM_DATE,
DATEEND DM_DATE);


ALTER TABLE H_ONK_N020 ADD EPV COMPUTED BY ((cast(iif(dateend is null, '31.12.9999', dateend) as date)));

CREATE TABLE H_ONK_N021(ID DM_ID NOT NULL,
ID_ZAP DM_CHAR_15,
CODE_SH DM_CHAR_10,
ID_LEKP DM_CHAR_10,
DATEBEG DM_DATE,
DATEEND DM_DATE);


ALTER TABLE H_ONK_N021 ADD EPV COMPUTED BY ((cast(iif(dateend is null, '31.12.9999', dateend) as date)));

CREATE TABLE H_V027(ID DM_ID NOT NULL,
IDCZ DM_INT,
N_CZ DM_CHAR_255,
DATEBEG DM_DATE,
DATEEND DM_DATE);


ALTER TABLE H_V027 ADD EPV COMPUTED BY ((cast(iif(dateend is null, '31.12.9999', dateend) as date)));

CREATE TABLE H_V028(ID DM_ID NOT NULL,
IDVN DM_INT,
N_VN DM_CHAR_255,
DATEBEG DM_DATE,
DATEEND DM_DATE);


ALTER TABLE H_V028 ADD EPV COMPUTED BY ((cast(iif(dateend is null, '31.12.9999', dateend) as date)));

CREATE TABLE H_V029(ID DM_ID NOT NULL,
IDMET DM_INT,
N_MET DM_CHAR_300,
DATEBEG DM_DATE,
DATEEND DM_DATE);


ALTER TABLE H_V029 ADD EPV COMPUTED BY ((cast(iif(dateend is null, '31.12.9999', dateend) as date)));

CREATE TABLE ONK_CONS(ID DM_ID NOT NULL,
PR_CONS DM_INT,
DT_CONS DM_DATE,
ZSD_ID INTEGER);


CREATE TABLE ONK_LEK_PR(ID DM_ID NOT NULL,
REGNUM DM_CHAR_10,
CODE_SH DM_CHAR_10,
ONK_USL_ID DM_ID,
DATE_INJ DM_DATE,
TIME_INJ DM_TIME);



ALTER TABLE CONTRAGENTS ADD TF_OKATO DM_CHAR_5;

ALTER TABLE ONK_DIAG ADD REC_RSLT DM_INT;

ALTER TABLE ONK_DIAG ADD DIAG_DATE DM_DATE;

ALTER TABLE ONK_NAPR ADD MO_CODE DM_LPU;

ALTER TABLE ONK_SL ADD K_FR DM_INT;

ALTER TABLE ONK_SL ADD WEI DM_NUM_3_2;

ALTER TABLE ONK_SL ADD HEI DM_INT;

ALTER TABLE ONK_SL ADD BSA DM_NUM_3_2;

ALTER TABLE ONK_USL ADD PPTR DM_INT;

ALTER TABLE ZS ADD DS_ONK DM_INT;

ALTER TABLE ZSD ADD C_ZAB DM_INT;

/* Empty SP_CALC_STAC for drop H_KSG(KSG) */

ALTER PROCEDURE SP_CALC_STAC(IDA INTEGER)
 AS
 BEGIN EXIT; END;

/* Empty SP_CALC_STAC_2018 for drop H_KSG(KSG) */
ALTER PROCEDURE SP_CALC_STAC_2018(IDA INTEGER)
 AS
 BEGIN EXIT; END;

/* Empty SP_KSG_GET for drop H_KSG(KSG) */
ALTER PROCEDURE SP_KSG_GET(DS1 /* TYPE OF DM_DS */ VARCHAR(7),
DR DATE,
DATE2 /* TYPE OF DM_DATE */ DATE,
CODE_USL /* TYPE OF DM_CHAR_20 */ VARCHAR(20),
SEX /* TYPE OF DM_SEX */ VARCHAR(1),
K_USLF /* TYPE OF DM_NUM_6_2 */ NUMERIC(6,2),
Q_U INTEGER,
DS2 /* DM_DS */ VARCHAR(7),
IDB INTEGER = null,
DOP_CRITERION /* DM_CHAR_10 */ VARCHAR(10) = null)
 RETURNS(KSG INTEGER,
ERR_CODE INTEGER)
 AS
 BEGIN SUSPEND; END;

/* Empty SP_LPU_ANALITICS4 for drop H_KSG(KSG) */
ALTER PROCEDURE SP_LPU_ANALITICS4 RETURNS(Q_U INTEGER,
USL_NAME VARCHAR(50),
CODE_PROF INTEGER,
PROF_NAME VARCHAR(100),
K_USLF NUMERIC(18,3),
ZS_CNT INTEGER,
LPU_ID INTEGER,
LPU_NAME VARCHAR(100),
SUM_USLF NUMERIC(15,2),
KSG VARCHAR(50),
KSG_NAME VARCHAR(250),
ZS_CNT_CHILD INTEGER,
K_USLF_CHILD /* DM_NUM_6_2 */ NUMERIC(6,2),
SUM_USLF_CHILD /* DM_MONEY_15_2 */ NUMERIC(15,2))
 AS
 BEGIN SUSPEND; END;

/* Empty SP_REP_FMPP_STAC for drop H_KSG(KSG) */
ALTER PROCEDURE SP_REP_FMPP_STAC(Y INTEGER,
M1 INTEGER,
M2 INTEGER,
Q_U INTEGER,
IS_OPL INTEGER,
NI INTEGER)
 RETURNS(ROW_NUM INTEGER,
CNT INTEGER,
VOL INTEGER,
SUMP /* DM_MONEY_15_2 */ NUMERIC(15,2),
CNT18 INTEGER,
VOL18 INTEGER,
SUMP18 /* DM_MONEY_15_2 */ NUMERIC(15,2))
 AS
 BEGIN SUSPEND; END;

DROP VIEW V_ZS;

ALTER TABLE H_KSG ALTER COLUMN KSG TYPE DM_CHAR_20;

DESCRIBE FIELD CODE TABLE H_LPU
'';

DESCRIBE FIELD NAME TABLE H_LPU
'';

DESCRIBE FIELD OKATO_CODE TABLE H_LPU
'';

ALTER TABLE KSG_GRP ALTER COLUMN KSG TYPE DM_CHAR_20;

/* Create view: V_ZS */
CREATE VIEW V_ZS(
ID,
Q_U,
MP,
ORDER_V,
CODE_SPEC,
CODE_PROF,
OTD_PROF,
IS_CHIELD,
N_HIST,
DATE_1,
DATE_2,
DS0,
DS1,
DS2,
TAR_USL,
K_USLF,
K_USL,
IDSP,
TARGET,
RESULT,
PATIENT_ID,
FAM,
IM,
OT,
Q_U_NAME,
TARGET_NAME,
SUM_USLF,
HDR_ID,
DIRECTION_NUM,
DIRECTION_DATE,
DH_INFO,
MES_CODE,
SMP_BRIG,
DS3,
DCOUNT,
UID,
PHYS_ID,
CATEGORY,
DISP_STAGE,
DISP_WORK_STATE,
DISP_RESULT,
DISP_H_GROUP,
OUTCOME,
KSG,
CAT_INFO,
IDSP_NAME,
MP_NAME,
ORDER_V_NAME,
DH_INFO_NAME,
CODE_SPEC_NAME,
CODE_PROF_NAME,
IS_CHIELD_NAME,
SMP_BRIG_NAME,
RESULT_NAME,
OUTCOME_NAME,
FOR_POM,
VID_HMP,
METOD_HMP,
AGE_GRP,
CHIELD_WITH_ROP,
FOR_POM_NAME,
REGISTRY_ID,
PAYMENT_TYPE_ID,
PAYMENT_NAME,
REGISTRY_NAME,
SUM_USL,
DOCTOR_FIO,
DOCTOR_COD,
NUM_SP,
IDCASE,
Q_U_2016,
HAS_ERRORS,
CODE_MES1,
COMENTSL,
SMO,
OKATO_SMO,
OKATO_G,
OKATO_P,
SUM_OPL,
N_ZAP,
ZSP_VPOLIS,
ZSP_SPOLIS,
ZSP_NPOLIS,
ZSP_POLIS_BP,
ZSP_POLIS_EP,
ZSP_SMO_OGRN,
ZSP_SMO_CODE,
ZSP_ENP,
ZSP_SEND_DATE,
ZSP_RESP_DATE,
AGE,
DR,
DOC_SER,
DOC_NUM,
SEX,
PODR,
KSLP,
REG_DATE,
AGE_NAME,
M,
Y,
CH_NUM,
INV_STATE,
KSG_NUM,
KSG_PROF_NUM,
NPR_MO,
PER,
VBR,
TAL_D,
TAL_P,
INV,
RSLT_D,
NAZR,
NAZ_SP,
NAZ_V,
NAZ_PMP,
NAZ_PK,
IDSP_NOT_AUTO,
AGE_GRP_NOT_AUTO,
USER_ID,
USER_FIO,
MSE,
BARTHEL_IDX,
CODE_SPEC_V021,
ID_PAC)
 AS 
select z.id,
       z.q_u,
       z.mp,
       z.order_v,
       z.code_spec,
       z.code_prof,
       z.otd_prof,
       z.is_chield,
       z.n_hist,
       z.date_1,
       z.date_2,
       z.ds0,
       z.ds1,
       z.ds2,
       z.tar_usl,
       z.k_uslf,
       z.k_usl,
       z.idsp,
       z.target,
       z.result,  
       z.patient_id,
       p.fam,
       p.im,
       p.ot,
       q_u.name as q_u_name,
       t.name as target_name,
       z.sum_uslf,
       z.hdr_id,
       z.direction_num,
       z.direction_date,
       z.dh_info as dh_info,
       z.mes_code,
       z.smp_brig,
       z.ds3,
       Z.DCOUNT,
       z.uid,
       z.phys_id,
       z.category,
       z.disp_stage,
       z.disp_work_state,
       z.disp_result,
       z.disp_h_group,
       z.outcome,
       z.ksg,
       z.cat_info,
       i.name as idsp_name,
       m.name as mp_name,
       o.name as order_v_name,
       dh.name as dh_info_name,
       iif(z.date_2 >= '01.05.2018', (select name from h_spec_v021 where code = z.code_spec_v021), (select name from h_spec_v015 where code = z.code_spec)) as code_spec_name,
       co.name as code_prof_name,
       iif(z.is_chield = 1, '', '') as is_chield_name,
       sb.name as smp_brig_name,
       r.name as result_name,
       oc.name as outcome_name,
       z.for_pom,
       z.vid_hmp,
       z.metod_hmp,
       z.age_grp,
       z.chield_with_rop,
       fp.name,
       z.registry_id,
       Z.payment_type_id,
       pt.name,
       reg.name,
       z.sum_usl,
       df.fio,
       DF.pcod,
       p.num_sp,  --iif(z.payment_type_id <> 2, p.num_sp, (select ins.ser || ' ' || ins.num from patients_insurance ins where ins.patients_id = p.id and z.date_1 between ins.db and ins.de)),
       z.id_case,
       z.q_u_2016,
       0,--(select first 1 1 from error_list_local err where err.reestr_hdr_id = z.hdr_id and err.uid = z.uid),
       z.mes_code,
       z.comentsl,
       p.smo,
       p.okato_smo,
       p.okato_l,
       p.okato_r,
       z.sum_usl, --(select sum(pi.sum_opl) from patients_invoice pi where pi.zs_id = z.id),
       z.n_zap n_zap,
       zpr.vpolis,
       zpr.spolis,
       zpr.npolis,
       zpr.polis_bp,
       zpr.polis_ep,
       zpr.smo_ogrn,
       zpr.smo_code,
       zpr.enp,
       zp.send_date,
       zpr.resp_date,
       z.age,
       p.dr,
       p.doc_ser,
       p.doc_num,
       p.sex,
       z.podr,
       z.kslp,
       reg.reg_date,
       cast(floor(z.age) as varchar(3)) || '  ' ||
            cast(iif(extract(day from z.date_1) < extract(day from p.dr),
                 iif(extract(month from z.date_1) > extract(month from p.dr), extract(month from z.date_1) - extract(month from p.dr),
                             iif(extract(month from z.date_1) < extract(month from p.dr), 12 - extract(month from p.dr) + extract(month from z.date_1) - 1,
                                 11)),
                 iif(extract(month from z.date_1) > extract(month from p.dr), extract(month from z.date_1) - extract(month from p.dr),
                             iif(extract(month from z.date_1) < extract(month from p.dr), 12 - extract(month from p.dr) + extract(month from z.date_1),
                                   0))) as varchar(2)) || ' ',
       h.m,
       h.y, 
       h.full_name,
       coalesce(inv.status_id,0),
       ksg.ksg_name,
       ksg.prof_name,
       z.npr_mo,
       z.per,
       z.vbr,
       z.tal_d,
       z.tal_p,
       z.inv,
       Z.rslt_d,
       z.nazr,
       z.naz_sp,
       z.naz_v,
       z.naz_pmp,
       z.naz_pk,
       z.idsp_not_auto,
       Z.age_grp_not_auto,
       z.user_id,
       s.fio,
       z.mse,
       z.barthel_idx ,
       z.code_spec_v021,
       z.id_pac
from zs z
join patients p on p.id = z.patient_id
join zs_hdr h on h.id = z.hdr_id
left join invoice inv on inv.id = h.name
left join h_q_u q_u on q_u.id = z.q_u
left join h_target t on t.id = z.target
left join h_idsp i on i.id = z.idsp
left join h_mp m on m.code = z.mp
left join h_order_v o on o.id = z.order_v
left join h_dh_info dh on dh.id = z.dh_info
left join h_spec_v015 cs on cs.code = z.code_spec
left join h_code_otd co on co.code = z.code_prof
left join h_smp_brig sb on sb.id = z.smp_brig
left join h_result r on r.code = z.result
left join h_outcome oc on oc.code = z.outcome
left join h_for_pom fp on fp.code = z.for_pom
left join h_payment_type pt on pt.id = z.payment_type_id
left join v_registry reg on reg.id = z.registry_id
left join doctors_fio df on df.id = z.phys_id
left join zsp zp on zp.zs_id = z.id
left join zsp_resp zpr on zpr.zsp_id = zp.id
left join h_ksg ksg on (cast(ksg.ksg as varchar(50))) = z.ksg and z.q_u = ksg.q_u and z.date_2 between ksg.bp and ksg.epv
left join users s on s.id = z.user_id
where h.is_delete <> 1
;

/* Create Views... */
/* Create view: V_ONK_CONS */
CREATE VIEW V_ONK_CONS(
ID,
PR_CONS,
DT_CONS,
ZSD_ID,
CONS_NAME)
 AS 
select
    c.id,
    c.pr_cons,
    c.dt_cons,
    c.zsd_id,
    n19.cons_name
from onk_cons c
     left join h_onk_n019 n19 on n19.id_cons = c.pr_cons
;

/* Create view: V_ONK_LEK_PR */
CREATE VIEW V_ONK_LEK_PR(
ID,
REGNUM,
CODE_SH,
ONK_USL_ID,
DATE_INJ,
TIME_INJ,
REGNUM_NAME,
SH_NAME)
 AS 
select
    p.id,
    p.regnum,
    p.code_sh,
    p.onk_usl_id,
    p.date_inj,
    p.time_inj,
    '[' || p.regnum || '] ' || n20.mnn,
    '[' || p.code_sh || '] ' || c.name
from onk_lek_pr p
     left join h_onk_n020 n20 on n20.id_lekp = p.regnum
     left join h_ksg_dop_criterian c on c.code = p.code_sh
;

/* Create view: V_ONK_USL */
CREATE VIEW V_ONK_USL(
ID,
ZSD_ID,
PR_CONS,
USL_TIP,
HIR_TIP,
LEK_TIP_L,
LEK_TIP_V,
LUCH_TIP,
PPTR,
USL_TIP_NAME,
HIR_TIP_NAME,
LEK_TIP_L_NAME,
LEK_TIP_V_NAME,
LUCH_TIP_NAME)
 AS 
select
    u.id,
    u.zsd_id,
    u.pr_cons,
    u.usl_tip,
    u.hir_tip,
    u.lek_tip_l,
    u.lek_tip_v,
    u.luch_tip,
    u.pptr,
    n13.tlech_name,
    n14.thir_name,
    n15.tlek_name_l,
    n16.tlek_name_v,
    n17.tluch_name
from onk_usl u
     left join h_onk_n013 n13 on n13.id_tlech = u.usl_tip
     left join h_onk_n014 n14 on n14.id_thir = u.hir_tip
     left join h_onk_n015 n15 on n15.id_tlek_l = u.lek_tip_l
     left join h_onk_n016 n16 on n16.id_tlek_v = u.lek_tip_v
     left join h_onk_n017 n17 on n17.id_tluch = u.luch_tip
;


/* Alter View (Drop, Create)... */
/* Drop altered view: V_ONK_DIAG */
DROP VIEW V_ONK_DIAG;

/* Create altered view: V_ONK_DIAG */
/* Create view: V_ONK_DIAG */
CREATE VIEW V_ONK_DIAG(
ID,
ONK_SL_ID,
DIAG_TIP,
DIAG_RSLT,
DIAG_CODE,
TIP_NAME,
CODE_NAME,
RSLT_NAME,
DIAG_DATE)
 AS 
select
    id,
    onk_sl_id,
    diag_tip,
    diag_rslt,
    diag_code,
    IIF(diag_tip = 1, ' ', ''),
    iif(diag_tip = 1, (select n7.mrf_name from H_ONK_N007 n7 where n7.id_mrf = d.diag_code), (select '[' || n10.kod_igh || '] ' || n10.igh_name from h_onk_n010 n10 where n10.id_igh = d.diag_code)),
    iif(diag_tip = 1, (select n8.r_m_name from H_ONK_N008 n8 where n8.id_r_m = d.diag_rslt), (select '[' || n11.id_r_i || '] ' || n11.r_i_name from h_onk_n011 n11 where n11.id_r_i = d.diag_rslt)),
    d.diag_date
from onk_diag d
;

/* Drop altered view: V_ZSD */
DROP VIEW V_ZSD;

/* Create altered view: V_ZSD */
/* Create view: V_ZSD */
CREATE VIEW V_ZSD(
ID,
ZS_ID,
DATE_1,
DATE_2,
CODE_SPEC,
CODE_PROF,
USL_TYPE,
OTD_PROF,
IS_CHIELD,
DS,
DS2,
SRVPLACE,
CODE_USL,
K_USLF,
PHYS_ID,
MES_CODE,
FIO,
SPEC_NAME,
SRVPLACE1,
DCOUNT,
KSG,
PCOD,
TAR_USL,
PMD_CLOSE,
SUM_USLF,
ORIT,
MP,
USL_NAME,
Q_U,
TARGET,
DISP_STAGE,
DATE_1_ZS,
TOOTH,
ZACHET,
IS_NO_GET_USL,
KSG_BASE,
SUM_BASE,
TAR_BASE,
KSKP_BASE,
COMMENT_LOCAL,
PODR,
TOOTH_LIST,
PROF_NAME,
FAM,
IM,
OT,
DR,
PHONES,
EMAIL,
Q_U_NAME,
KSG_CRITERION,
ZSD_ID,
P_CEL,
DN,
PROFIL_K,
P_PER,
DS_ONK,
KSG_CRITERION2,
CODE_SPEC_V021,
SER_SP,
NUM_SP,
C_ZAB)
 AS 
select zz.ID, zz.zs_id, zz.DATE_1, zz.DATE_2, iif(z.date_2 >= '01.05.2018', zz.code_spec_v021, zz.code_spec), zz.CODE_prof, zz.usl_type,
       zz.OTD_PROF, zz.IS_CHIELD,
       zz.DS, zz.DS2, zz.SRVPLACE, zz.CODE_USL, zz.K_USLF, 
       zz.PHYS_ID, z.mes_code, 
       iif(zz.phys_id = '', '', (select fio from doctors_fio where id = zz.phys_id)) as fio,
       iif(z.date_2 >= '01.05.2018', (select name from h_spec_v021 where code = zz.code_spec_v021), (select name from h_spec_v015 where code = zz.code_spec)) as spec_name, pl.name as srvplace,
       zz.dcount,zz.ksg, iif(zz.phys_id = '', '', (select pcod from doctors_fio where id = zz.phys_id)) as pcod,
       zz.tar_usl, coalesce(zz.pmd_close,0), zz.sum_uslf, zz.orit, zz.mp,
       (select first 1 name from h_usl u where u.code = zz.code_usl
        and u.q_u containing cast(z.q_u as varchar(1)) and u.payment_type_id = z.payment_type_id
        and z.date_1 between u.datebeg and u.dateend),
       z.q_u, z.target, z.disp_stage, z.date_1, zz.tooth_id, coalesce(zz.zachet,0), coalesce(ZZ.is_no_get_usl,0),
       zz.ksg_base, zz.sum_base, zz.tar_base, zz.kskp_base, zz.comment_local, zz.podr,
       iif((coalesce(zz.tooth_id,0) = 0 or coalesce(zz.tooth_list,'')='') and z.q_u = 4, zz.tooth_id, zz.tooth_list),
       o.name, p.fam, p.im, p.ot, p.dr, p.phones, p.email, q.name, zz.ksg_criterion, zz.zsd_id,
       zz.p_cel, zz.dn, zz.profil_k, zz.p_per, zz.ds_onk, zz.ksg_criterion2, zz.code_spec_v021,
       p.ser_sp, p.num_sp, zz.c_zab
from ZSd zz
     left join zs z on z.id = zz.zs_id
     left join patients p on p.id = z.patient_id
--     left join h_spec_v015 cs on cs.code = zz.code_spec
--     left join h_spec_v021 cs2 on cs2.code = zz.code_spec_v021
     left join h_srvplace pl on pl.id = zz.srvplace
     left join h_code_otd o on o.code = zz.code_prof
     left join h_q_u q on q.id = z.q_u
;

/* Create generator... */
CREATE GENERATOR GEN_H_ONK_N018_ID;

CREATE GENERATOR GEN_H_ONK_N019_ID;

CREATE GENERATOR GEN_H_ONK_N020_ID;

CREATE GENERATOR GEN_H_ONK_N021_ID;

CREATE GENERATOR GEN_H_ONK_V021_ID;

CREATE GENERATOR GEN_H_V027_ID;

CREATE GENERATOR GEN_H_V028_ID;

CREATE GENERATOR GEN_H_V029_ID;

CREATE GENERATOR GEN_ONK_CONS_ID;

CREATE GENERATOR GEN_ONK_LEK_PR_ID;

CREATE GENERATOR GEN_ONK_LEK_PR_INJ_DATE_ID;


/* Create Primary Key... */
ALTER TABLE H_ONK_N018 ADD CONSTRAINT PK_H_ONK_N018 PRIMARY KEY (ID);

ALTER TABLE H_ONK_N019 ADD CONSTRAINT PK_H_ONK_N019 PRIMARY KEY (ID);

ALTER TABLE H_ONK_N020 ADD CONSTRAINT PK_H_ONK_N020 PRIMARY KEY (ID);

ALTER TABLE H_ONK_N021 ADD CONSTRAINT PK_H_ONK_N021 PRIMARY KEY (ID);

ALTER TABLE H_V027 ADD CONSTRAINT PK_H_V027 PRIMARY KEY (ID);

ALTER TABLE H_V028 ADD CONSTRAINT PK_H_V028 PRIMARY KEY (ID);

ALTER TABLE H_V029 ADD CONSTRAINT PK_H_V029 PRIMARY KEY (ID);

ALTER TABLE ONK_CONS ADD CONSTRAINT PK_ONK_CONS PRIMARY KEY (ID);

ALTER TABLE ONK_LEK_PR ADD CONSTRAINT PK_ONK_LEK_PR PRIMARY KEY (ID);

/* Alter Procedure... */
/* empty dependent procedure body */
/* Clear: SP_CALC_ALL for: SP_CALC_STAC */

ALTER PROCEDURE SP_CALC_ALL(ZS_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* Alter (SP_CALC_STAC) */
ALTER PROCEDURE SP_CALC_STAC(IDA INTEGER)
 AS
declare variable KSG type of DM_CHAR_50;
declare variable DS type of DM_DS;
declare variable IDB integer;
declare variable SUM_USLF type of DM_MONEY;
declare variable KSKP type of DM_NUM_3_2;
declare variable Q_U integer;
declare variable FINE_KOEF type of DM_NUM_3_2;
declare variable TARIF numeric(15,6);
declare variable Y integer;
declare variable TARIF_USL DM_MONEY;
declare variable DATE2 date;
declare variable IS_TRANSFER DM_INT;
declare variable CL_CNT integer;
declare variable ERR_CODE integer;
declare variable K_DOWN DM_NUM_6_2;
begin
     cl_cnt = (select count(distinct b.ds_class) from ZSD b where b.ZS_ID = :ida);
     is_transfer = (select sum(iif(b.code_usl is null, 1, 0)) from ZSD b where b.ZS_ID = :ida);

     select a.q_u, extract(year from a.date_2), a.date_2
      from zs a
      where a.id = :ida
      into :q_u, :y, :date2;

     for select sp.KSG, sp.ERR_CODE, b.ds, b.id, coalesce(bs.tarif * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0)
      from zs a
      join zsd b on a.id = b.zs_id
      join patients p on p.id = a.patient_id
      join lpu_factors lf on lf.q_u = a.q_u and a.date_2 between lf.bp and lf.epv
      join h_tarif_bs bs on bs.q_u = a.q_u and a.date_2 between bs.bp and bs.epv
      left join sp_ksg_get(b.ds, p.dr, a.date_2, b.code_usl, p.sex, b.k_uslf, a.q_u, b.ds2, b.id) sp on 1=1
      left join h_ksg k on k.ksg = sp.ksg and a.date_2 between k.bp and k.epv and k.q_u = a.q_u
      where b.zs_id = :ida
      into :ksg, :err_code, :ds, :idb, :tarif
      do
      begin
        kskp = 1;
        fine_koef = null;

        if ((q_u = 1) and (y < 2017)) then
          kskp = (select KSKP from SP_CALC_STAC_KSKP(:ida, :idb, :ksg, :cl_cnt));
        if ((q_u = 1) and (y >= 2017) and (y < 2018)) then
          kskp = (select KSKP from sp_calc_stac_kskp_2017(:ida, :idb, :ksg, :cl_cnt));
--        if ((q_u = 1) and (y >= 2018)) then
--          kskp = (select KSKP from sp_calc_stac_kskp_2018(:ida, :idb, :ksg, :cl_cnt));

        fine_koef = (select FINE_KOEF from sp_calc_stac_fine(:ida, :idb, :ksg, :cl_cnt));

        sum_uslf = cast(tarif * kskp * fine_koef as int);

        update zsd b set
         b.ksg_base = :ksg,
         b.tar_base = cast(:tarif as integer),
         b.sum_base = :sum_uslf,
         b.kskp_base = :kskp
         where b.id = :idb;
      end 
--------------------------------------------------------------------------------
      --    6  + 
      if (q_u = 1) then
       if (exists (select 1 from zsd b where b.zs_id = :ida and ((b.ksg in (2) and b.k_uslf >= 6) or (b.ksg in ('O14.1','O34.2','O36.3','O36.4','O42.2') and b.k_uslf >= 2) ))
          and exists (select 1 from zsd b where b.zs_id = :ida and b.ksg in (4, 5))) then
          begin
            --    
            select first 1 b.ksg_base, b.ds
            from zs a
             join zsd b on a.id = b.zs_id
             where b.zs_id = :ida and b.ksg in (4, 5)
             into :ksg, :ds;
       
            update zsd d
            set d.tar_usl = d.tar_base,
                d.sum_uslf = d.sum_base,
                d.ksg = d.ksg_base,
                d.kskp = d.kskp_base
            where d.zs_id = :ida;

            --   
            select coalesce(sum(b.sum_uslf), 0) from zsd b where b.zs_id = :ida
             into :sum_uslf;
    
            update zs a set
             a.tar_usl = :tarif,
             a.sum_uslf = :sum_uslf,
             a.sum_usl = :sum_uslf,
             a.ksg = :ksg,
             a.ds1 = :ds,
             a.kslp = :kskp
             where a.id = :ida;

            exit;
          end
--------------------------------------------------------------------------------
      if ((is_transfer < 2) or (cl_cnt < 2))  then  --   
      begin
        --     
        select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
         from zsd b
         where b.zs_id = :ida
         order by b.tar_base desc
         into :idb, :ksg, :sum_uslf, :tarif;

         --      
         update zsd b set
          b.ksg = :ksg, 
          b.sum_uslf = :sum_uslf,
          b.kskp = b.kskp_base,
          b.tar_usl = b.tar_base
          where b.id = :idb;

         update zsd b set
          b.ksg = null,
          b.sum_uslf = 0,
          b.kskp = 1,
          b.tar_usl = 0
          where b.id <> :idb and b.zs_id = :ida;
 
         update zs a set
          a.tar_usl = :tarif,
          a.sum_uslf = :sum_uslf,
          a.sum_usl = :sum_uslf,
          a.ksg = :ksg,
          a.kslp = :kskp
          where a.id = :ida;
 
      end else
      begin
        select first 1 b.ksg_base, b.sum_base
        from zs a
         join zsd b on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null and b.ds = a.ds1
         order by b.sum_base desc
         into :ksg, :sum_uslf;

        update zsd d
         set d.tar_usl = d.tar_base,
             d.sum_uslf = d.sum_base,
             d.ksg = d.ksg_base,
             d.kskp = d.kskp_base
         where d.zs_id = :ida;
   
        select coalesce(sum(b.sum_uslf), 0), coalesce(sum(b.tar_base), 0) from zsd b
         join zs a on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null
         into :sum_uslf, :tarif;

        update zs a set
         a.tar_usl = :tarif,
         a.sum_uslf = :sum_uslf,
         a.sum_usl = :sum_uslf,
         a.ksg = :ksg,
         a.kslp = :kskp
         where a.id = :ida;
 
      end

      ---------------------------------------------------------------------------------
      --   2016 
      if (exists(select first 1 1 from zsd b
                  join h_tarif_dializ d on d.code_usl = b.code_usl and b.date_2 between d.bp and d.epv
                  and d.q_u containing :q_u where b.zs_id = :ida) and :y = 2016) then
      begin
         for select d.tarif, b.id
             from zsd b
                  join h_tarif_dializ d on d.code_usl = b.code_usl and d.bp <= :date2 and d.epv >= :date2 and d.q_u containing :q_u
             where b.zs_id = :ida
             into :tarif_usl, :idb
             do
             begin
               update zsd b
               set b.sum_uslf = :tarif_usl,
                   b.tar_usl = :tarif_usl
               where b.id = :idb;

               update zs a set
                  a.tar_usl = iif (coalesce(a.tar_usl,0) = 0, :sum_uslf, a.tar_usl),
                  a.sum_uslf = a.sum_uslf + :tarif_usl,
                  a.sum_usl = a.sum_usl + :tarif_usl
                  where a.id = :ida;
 
               update zs a set
                  a.tar_usl = cast(a.sum_uslf/coalesce(a.k_uslf, 1) as integer)
                  where a.id = :ida;

             end
         exit;
      end

end;

/* Alter (SP_CALC_STAC_2018) */
ALTER PROCEDURE SP_CALC_STAC_2018(IDA INTEGER)
 AS
declare variable KSG type of DM_CHAR_50;
declare variable DS type of DM_DS;
declare variable IDB integer;
declare variable SUM_USLF type of DM_MONEY;
declare variable KSKP type of DM_NUM_3_2;
declare variable Q_U integer;
declare variable FINE_KOEF type of DM_NUM_3_2;
declare variable TARIF numeric(15,6);
declare variable Y integer;
declare variable TARIF_USL DM_MONEY;
declare variable DATE2 date;
declare variable IS_TRANSFER DM_INT;
declare variable CL_CNT integer;
declare variable ERR_CODE integer;
declare variable K_DOWN DM_NUM_6_2;
declare variable DS_CLASS DM_CHAR_10;
declare variable KZ DM_NUM_2_5;
declare variable KD DM_NUM_2_5;
declare variable KUS DM_NUM_2_5;
declare variable BS DM_NUM_6_2;
declare variable PROF_NUM integer;
declare variable DATE1 date;
declare variable CODE_USL DM_CHAR_20;
begin
    update zsd d
      set d.ds_class = (select MKB_CLASS from SP_GET_MKB_CLASS(D.ds))
      where d.zs_id = :ida;

    update zsd d
     set d.ksg = null, 
         d.ksg_base = null,
         d.tar_base = null,
         d.sum_base = null,
         d.kskp_base = null,
         d.sum_uslf = 0,
         d.tar_usl = 0,
         d.comment_local = null
     where d.zs_id = :ida;

     cl_cnt = (select count(distinct b.ds_class) from ZSD b where b.ZS_ID = :ida);
     is_transfer = (select sum(iif(b.code_usl is null, 1, 0)) from ZSD b where b.ZS_ID = :ida);

     select a.q_u, extract(year from a.date_2), a.date_2
      from zs a
      where a.id = :ida
      into :q_u, :y, :date2;

     for select sp.KSG, sp.ERR_CODE, b.ds, b.id, coalesce(bs.tarif * kd.kd * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0),
                k.kz, kd.kd,
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0),
                bs.tarif, k.k_down, k.prof_num, b.date_1, coalesce(b.code_usl,'')
      from zs a
      join zsd b on a.id = b.zs_id
      join patients p on p.id = a.patient_id
      join lpu_factors lf on lf.q_u = a.q_u and a.date_2 between lf.bp and lf.epv
      join h_tarif_bs bs on bs.q_u = a.q_u and a.date_2 between bs.bp and bs.epv
      join h_tarif_kd kd on a.date_2 between kd.bp and kd.epv
      left join sp_ksg_get(b.ds, p.dr, a.date_2, b.code_usl, p.sex,
                           (select sum(b1.k_uslf) from ZSD b1 where b1.ZS_ID = :ida and b1.ds_class = b.ds_class and b1.code_usl is null), -- -     
                           a.q_u, b.ds2, b.id, b.ksg_criterion) sp on 1=1
      left join h_ksg k on k.ksg = sp.ksg and a.date_2 between k.bp and k.epv and k.q_u = a.q_u
      where b.zs_id = :ida
      order by b.code_usl
      into :ksg, :err_code, :ds, :idb, :tarif, :kz, :kd, :kus, :bs, :k_down, :prof_num, :date1, :code_usl
      do
      begin
        kskp = 1;
        fine_koef = null;

        if ((q_u = 1) and (err_code is null)) then
          kskp = (select KSKP from sp_calc_stac_kskp_2018(:ida, :idb, :ksg, :cl_cnt));

        fine_koef = (select FINE_KOEF from sp_calc_stac_fine_2018(:ida, :idb, :ksg, :cl_cnt));

        sum_uslf = cast(tarif * kskp * fine_koef as int);

        if (:ksg is not null) then
        begin
            if (:code_usl <> '') then
            begin
                select first 1 d.id
                from zs z
                     join zsd d on d.zs_id = z.id
                where d.zs_id = :ida and coalesce(d.code_usl,'') = ''
                       and :date1 between d.date_1 and d.date_2
                       and not exists(select id from zsd d2 where d2.zs_id = :ida and coalesce(d2.code_usl,'') = '' and d2.date_1 = d.date_2)
                into :idb;
            end

            if ((select first 1 d.id from zsd d where d.zs_id = :ida and d.ksg_base = :ksg) is null) then
            update zsd b set
             b.ksg_base = :ksg,
             b.tar_base = iif(:date2 >= '01.05.2018', cast(:tarif * coalesce(kskp,1) as int), cast(:tarif as integer)),
             b.sum_base = :sum_uslf,
             b.kskp_base = :kskp,
             b.koef_z = :kz, 
             b.koef_d = :kd,
             b.koef_u = :kus,
             b.bs = :bs,
             b.koef_up = :k_down,
             b.reab = iif(:prof_num = 37,1,null)
             where b.id = :idb;
         end
      end 
--------------------------------------------------------------------------------
      --    6  + 
      if (q_u = 1) then
       if (exists (select 1 from zsd b where b.zs_id = :ida and ((b.ksg in (2) and b.k_uslf >= 6) or (b.ksg in ('O14.1','O34.2','O36.3','O36.4','O42.2') and b.k_uslf >= 2) ))
          and exists (select 1 from zsd b where b.zs_id = :ida and b.ksg in (4, 5))) then
          begin
            --    
            select first 1 b.ksg_base, b.ds
            from zs a
             join zsd b on a.id = b.zs_id
             where b.zs_id = :ida and b.ksg in (4, 5)
             into :ksg, :ds;
       
            update zsd d
            set d.tar_usl = d.tar_base,
                d.sum_uslf = d.sum_base,
                d.ksg = d.ksg_base,
                d.kskp = d.kskp_base
            where d.zs_id = :ida;

            --   
            select coalesce(sum(b.sum_uslf), 0) from zsd b where b.zs_id = :ida
             into :sum_uslf;
    
            update zs a set
             a.tar_usl = :tarif,
             a.sum_uslf = :sum_uslf,
             a.sum_usl = :sum_uslf,
             a.ksg = :ksg,
             a.ds1 = :ds,
             a.kslp = :kskp
             where a.id = :ida;

            exit;
          end
--------------------------------------------------------------------------------
      if ((is_transfer < 2) or (cl_cnt < 2))  then  --   
      begin
        --     ,   
        ksg = null;
        select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and ((:q_u = 1 and b.ksg_base >= 325 and b.ksg_base <= 343) or
                                                                                                  (:q_u = 3 and b.ksg_base >= 123 and b.ksg_base <= 134))
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;

        if (:ksg is null)  then
         select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;

         --      
         update zsd b set
          b.ksg = :ksg, 
          b.sum_uslf = :sum_uslf,
          b.kskp = b.kskp_base,
          b.tar_usl = b.tar_base
          where b.id = :idb;

         update zsd b set
          b.ksg = null,
          b.sum_uslf = 0,
          b.kskp = 1,
          b.tar_usl = 0
          where b.id <> :idb and b.zs_id = :ida;
 
         update zs a set
          a.tar_usl = :tarif,
          a.sum_uslf = :sum_uslf,
          a.sum_usl = :sum_uslf,
          a.ksg = :ksg,
          a.kslp = :kskp
          where a.id = :ida;
 
      end else
      begin
        for select d.ds_class
         from zsd d
         where d.zs_id = :ida
         group by 1
         into :ds_class
         do
         begin
            if (((select count(dc.id) from ksg_dont_choice dc join zsd z on z.ksg_base = dc.ksg_ter or z.ksg_base = dc.ksg_surg
                    where z.zs_id = :ida and z.ds_class = :ds_class and :date2 between dc.bp and dc.epv) > 0) and (:q_u = 1)) then
               --    
            select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and b.ds_class = :ds_class and b.code_usl is not null
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;
            else
               --     
            select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and b.ds_class = :ds_class
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;
    
             --      
             update zsd b set
              b.ksg = :ksg, 
              b.sum_uslf = :sum_uslf,
              b.kskp = b.kskp_base,
              b.tar_usl = b.tar_base
              where b.id = :idb;
    
             update zsd b set
              b.ksg = null,
              b.sum_uslf = 0,
              b.kskp = 1,
              b.tar_usl = 0
              where b.id <> :idb and b.zs_id = :ida and b.ds_class = :ds_class;
         end

        select first 1 b.ksg_base, b.sum_base
        from zs a
         join zsd b on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null and b.ds = a.ds1
         order by b.sum_base desc
         into :ksg, :sum_uslf;

--        update zsd d
--         set d.tar_usl = d.tar_base,
--             d.sum_uslf = d.sum_base,
--             d.ksg = d.ksg_base,
--             d.kskp = d.kskp_base
--         where d.zs_id = :ida;
   
        select coalesce(sum(b.sum_uslf), 0), coalesce(sum(b.tar_base), 0)
         from zsd b
         join zs a on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null
         into :sum_uslf, :tarif;

        update zs a set
         a.tar_usl = :tarif,
         a.sum_uslf = :sum_uslf,
         a.sum_usl = :sum_uslf,
         a.ksg = :ksg,
         a.kslp = :kskp
         where a.id = :ida;
 
      end

      ---------------------------------------------------------------------------------
      --   2016 
      /*$$IBEC$$ if (exists(select first 1 1 from zsd b
                  join h_tarif_dializ d on d.code_usl = b.code_usl and b.date_2 between d.bp and d.epv
                  and d.q_u containing :q_u where b.zs_id = :ida) and :y = 2016) then
      begin
         for select d.tarif, b.id
             from zsd b
                  join h_tarif_dializ d on d.code_usl = b.code_usl and d.bp <= :date2 and d.epv >= :date2 and d.q_u containing :q_u
             where b.zs_id = :ida
             into :tarif_usl, :idb
             do
             begin
               update zsd b
               set b.sum_uslf = :tarif_usl,
                   b.tar_usl = :tarif_usl
               where b.id = :idb;

               update zs a set
                  a.tar_usl = iif (coalesce(a.tar_usl,0) = 0, :sum_uslf, a.tar_usl),
                  a.sum_uslf = a.sum_uslf + :tarif_usl,
                  a.sum_usl = a.sum_usl + :tarif_usl
                  where a.id = :ida;
 
               update zs a set
                  a.tar_usl = cast(a.sum_uslf/coalesce(a.k_uslf, 1) as integer)
                  where a.id = :ida;

             end
         exit;
      end $$IBEC$$*/

end;

/* Alter (SP_CHECK_DS_AS_ONK) */
ALTER PROCEDURE SP_CHECK_DS_AS_ONK(ZSD_ID INTEGER)
 RETURNS(IS_ONK INTEGER)
 AS
begin
  select first 1 coalesce(id,0)
   from zs_ds d
   where d.section = 2 and d.section_id = :zsd_id and
         (
          ((d.ds starting 'C' or d.ds starting 'D0') and (d.ds_type = 1)) or
          ((d.ds = 'D70') and (d.ds_type = 1) and
            exists(select first 1 id from zs_ds d2 where d2.section = 2 and d2.section_id = :zsd_id and d2.ds_type = 2 and
                                              (((d2.ds starting 'C') and not(d2.ds starting 'C9')) or (d2.ds = 'C97'))
                   )
           )
          )
   into :is_onk;

   if ((select z.target from zs z where z.id = (select zs_id from zsd where id = :zsd_id)) not in (1,2,3,26)) then
     is_onk = 0;

  suspend;
end;

/* Alter (SP_CHECK_DS_AS_ONK2) */
ALTER PROCEDURE SP_CHECK_DS_AS_ONK2(DS1 DM_DS,
DS2 DM_DS = null)
 RETURNS(IS_ONK INTEGER)
 AS
begin
  if ((:ds1 starting 'C' or :ds1 starting 'D0') or
          ((:ds1 = 'D70') and (((coalesce(:ds2,'') starting 'C') and not(coalesce(:ds2,'') starting 'C9')) or (coalesce(:ds2,'') = 'C97'))))

  then is_onk = 1;
  else
    is_onk = 0;

  suspend;
end;

/* Alter (SP_GET_SPRAV_LIST) */
ALTER PROCEDURE SP_GET_SPRAV_LIST(SPRAV_NAME DM_CHAR_20,
DATE2 DM_DATE)
 RETURNS(CODE DM_INT,
NAME DM_CHAR_1000)
 AS
begin
  if (:sprav_name = 'V002') then
   for select c.code, c.name || '[' || c.code || ']' from h_code_otd c where :date2 between c.datebeg and c.epv order by name
    into :code, :name
    do suspend;

  if (:sprav_name = 'SRVPLACE') then
   for select c.ID, c.name from h_srvplace c order by ID
    into :code, :name
    do suspend;

  if (:sprav_name = 'V024') then
   for select id, '[' || code || '] ' || name name from H_KSG_DOP_CRITERIAN where :date2 between datebeg and epv order by code
    into :code, :name
    do suspend;

  if (:sprav_name = 'V020') then
   for select code, name || '[' || code || '] ' name from h_profil_k where :date2 between datebeg and epv order by name
    into :code, :name
    do suspend;

  if (:sprav_name = 'V015') then
   for select code, name || '[' || code || '] ' name from h_spec_v015 where :date2 between datebeg and epv order by name
    into :code, :name
    do suspend;

  if (:sprav_name = 'V021') then
   for select code, name || '[' || code || '] ' name from h_spec_v021 where :date2 between datebeg and epv order by name
    into :code, :name
    do suspend;

  if (:sprav_name = 'V025') then
   for select id, '[' || code || '] ' || name name from h_target_v025 where :date2 between datebeg and epv order by code
    into :code, :name
    do suspend;

  if (:sprav_name = 'V027') then
   for select idcz, '[' || idcz || '] ' || n_cz name from h_v027 where :date2 between datebeg and epv order by idcz
    into :code, :name
    do suspend;

  if (:sprav_name = 'V028') then
   for select v.idvn, '[' || v.idvn || '] ' || v.n_vn name from h_v028 v where :date2 between datebeg and epv order by idvn
    into :code, :name
    do suspend;

  if (:sprav_name = 'V029') then
   for select v.idmet, '[' || v.idmet || '] ' || v.n_met name from h_v029 v where :date2 between datebeg and epv order by idmet
    into :code, :name
    do suspend;

  if (:sprav_name = 'DOCTORS') then
   for select id, fio from doctors_fio order by fio
    into :code, :name
    do suspend;

  if (:sprav_name = 'P_PER') then
   for select code, name from h_p_per where :date2 between datebeg and epv order by code
    into :code, :name
    do suspend;

  if (:sprav_name = 'DN') then
   for select code, name from h_dn where :date2 between datebeg and epv order by code
    into :code, :name
    do suspend;

  if (:sprav_name = 'H_TARGET') then
   for select ID, name || '[' || id || '] ' from h_target where :date2 between datebeg and epv order by code
    into :code, :name
    do suspend;
end;

/* Alter (SP_KSG_GET) */
ALTER PROCEDURE SP_KSG_GET(DS1 TYPE OF DM_DS,
DR DATE,
DATE2 TYPE OF DM_DATE,
CODE_USL TYPE OF DM_CHAR_20,
SEX TYPE OF DM_SEX,
K_USLF TYPE OF DM_NUM_6_2,
Q_U INTEGER,
DS2 DM_DS,
IDB INTEGER = null,
DOP_CRITERION DM_CHAR_10 = null)
 RETURNS(KSG INTEGER,
ERR_CODE INTEGER)
 AS
declare variable TMP_GRP_ID integer;
declare variable RC integer;
declare variable NEED_STEP_1 integer;
declare variable NEED_STEP_2 type of DM_BOOLEAN;
declare variable KSG_TER integer;
declare variable KSG_SURG integer;
declare variable Y integer;
declare variable IDA integer;
declare variable IS_C00_C80 integer;
begin
     ksg = null;
     ksg_ter = null;
     ksg_surg = null;
     err_code = null;
     tmp_grp_id = gen_id(GEN_KSG_TMP_GROUP_ID, 1);
     y = extract(year from :date2);
     ida = (select first 1 d.zs_id from zsd d where d.id = :idb);

     /*******     00-80**************************/
     if (y = 2018) then
     begin
       if ((substring(:ds1 from 1 for 1) = 'C') and (substring(:ds1 from 2 for 1) <= 8)) then
         is_c00_c80 = 1;
       else
         is_c00_c80 = 0;
     end
     else
       is_c00_c80 = 0;
     /**********************************************************************/

     if (y < 2017) then
     if (:ds1 starting 'C') then
      if (not exists(select 1 from ksg_grp g where g.nms_code = :code_usl and g.ds <> 'C.'
                and :date2 between g.bp and g.epv
                and coalesce(g.age_grp,0) = iif(g.age_grp is not null, iif((:date2-:dr)/365.25 < 18, 4, 5) , 0) )) then
        ds1 = 'C.';
     if (y >= 2017) then
     if (:ds1 starting 'C' and :dop_criterion is null) then
      if (not exists(select 1 from ksg_grp g where g.nms_code = :code_usl and g.ds <> 'C.'
                and :date2 between g.bp and g.epv
                and coalesce(g.age_grp,0) = iif(g.age_grp is not null, iif((:date2-:dr)/365.25 < 18, 5, 6) , 0) )) then
        ds1 = 'C.';
--------------------------------------------------------------------------------
     --       ()
     if (y < 2017) then
     select
           case
             when t1.ao_code = 'T7' then 216
             when (t1.ao_code between 'T1' and 'T6') and (t2.ao_code between 'T1' and 'T6') and (t1.ao_code <> t2.ao_code) then 216
             else null
           end
      from zsd b
      left join h_tarif_polytrauma t1 on t1.ds = b.ds and :date2 between t1.bp and t1.epv
      left join h_tarif_polytrauma t2 on t2.ds = b.ds2 and :date2 between t2.bp and t2.epv
      where b.id = :idb and b.ds3 in ('J94.2','J94.8','J94.9','J93','J93.0','J93.1','J93.8','J93.9', 'J96.0', 'N17', 'T79.4', 'R57.1', 'R57.8')
      into :ksg;

     if (y = 2017) then
      select
           case
             when t1.ao_code = 'T7' then 216
             when (t1.ao_code between 'T1' and 'T6') and (t2.ao_code between 'T1' and 'T6') and (t1.ao_code <> t2.ao_code) then 220
             else null
           end
      from zs_ds d
      left join h_tarif_polytrauma t1 on t1.ds = d.ds and :date2 between t1.bp and t1.epv
      left join h_tarif_polytrauma t2 on t2.ds = d.ds and :date2 between t2.bp and t2.epv
      where d.section = 1 and d.section_id = :ida and d.ds in ('J94.2','J94.8','J94.9','J93','J93.0','J93.1','J93.8','J93.9', 'J96.0', 'N17', 'T79.4', 'R57.1', 'R57.8')
      into :ksg;

     if (y = 2018) then
      select
           case
             when t1.ao_code = 'T7' then 216
             when (t1.ao_code between 'T1' and 'T6') and (t2.ao_code between 'T1' and 'T6') and (t1.ao_code <> t2.ao_code) then 233
             else null
           end
      from zs_ds d
      left join h_tarif_polytrauma t1 on t1.ds = d.ds and :date2 between t1.bp and t1.epv
      left join h_tarif_polytrauma t2 on t2.ds = d.ds and :date2 between t2.bp and t2.epv
      where d.section = 1 and d.section_id = :ida and d.ds in ('J94.2','J94.8','J94.9','J93','J93.0','J93.1','J93.8','J93.9', 'J96.0', 'N17', 'T79.4', 'R57.1', 'R57.8')
      into :ksg;

     if (ksg is not null) then
     begin
       suspend;
       exit;
     end
--------------------------------------------------------------------------------

     if ((select first 1 id from h_tarif_dializ d where :date2 between d.bp and d.epv and d.code_usl = :code_usl) is not null) then
     begin
       ksg = null;
       exit;
     end

--------------------------------------------------------------------------------
     --  1.    
     need_step_1 = (select first 1 1 from ksg_grp m where m.ds = :ds1 and m.q_u = :q_u and :date2 between m.bp and m.epv);

     -- 1
     if (need_step_1 = 1) then
     begin
       insert into KSG_TMP (ID, KSG, NMS_CODE, KZ, GROUP_CODE, STEP_NUM, AGE_GRP, DAYS, SEX, DS, DOP_CRITERIAN)
          select h.id, h.ksg, h.nms_code, k.kz, :tmp_grp_id, 1, h.age_grp, h.days, h.sex, h.ds, h.dop_criterion
           from ksg_grp h
           join h_ksg k on k.ksg = h.ksg and :date2 between k.bp and k.epv
           where ((h.ds = :ds1) or (h.ds = iif(:is_c00_c80 = 1, 'C00-C80', :ds1)))
--                 and (h.nms_code is null or h.nms_code = :code_usl)
                 and :date2 between h.bp and h.epv
                 and h.q_u = k.q_u and h.q_u = :q_u
                 and iif(h.ds2 is not null, h.ds2, :ds2) is not distinct from :ds2;

  
       rc = row_count;

       if (rc = 1) then
        ksg_ter = (select t.ksg from KSG_TMP t where t.group_code=:tmp_grp_id and t.step_num=1);
  
       --  .
       if ((rc > 1) and (:y < 2017)) then
        select ERR_CODE, KSG from SP_KSG_TMP_CRITERION(:tmp_grp_id, 1, :date2, :dr, :k_uslf, :sex)
         into :err_code, :ksg_surg;
       if ((rc > 1) and (:y >= 2017)) then
        select ERR_CODE, KSG from SP_KSG_TMP_CRITERION_2017(:tmp_grp_id,1, :date2, :dr, :k_uslf, :sex, :dop_criterion, :code_usl, :ds1)
         into :err_code, :ksg_ter;

       /*$$IBEC$$ if (rc = 0) then
       begin
                --      " "  ...
         insert into KSG_TMP (ID, KSG, NMS_CODE, KZ, GROUP_CODE, STEP_NUM, AGE_GRP, DAYS, SEX, DS, DOP_CRITERIAN)
        select h.id, h.ksg, h.nms_code, k.kz, :tmp_grp_id, 1, h.age_grp, h.days, h.sex, h.ds, h.dop_criterion
         from ksg_grp h
         join h_ksg k on k.ksg = h.ksg and :date2 between k.bp and k.epv
         where ((h.ds = :ds1) or (h.ds = iif(:is_c00_c80 = 1, 'C00-C80', :ds1)))
               and (h.nms_code is not distinct from :code_usl)
               and :date2 between h.bp and h.epv
               and h.q_u = k.q_u and h.q_u = :q_u
               and iif(h.ds2 is not null, h.ds2, :ds2) is not distinct from :ds2;
  
         rc = row_count;
         if (rc = 0) then
          err_code = 1;  --      
       end $$IBEC$$*/
  

     end
--------------------------------------------------------------------------------
     -- 2 ,    ...
     if ((err_code is not null and code_usl is not null) and
        exists(select first 1 1 from ksg_grp m where m.nms_code = :code_usl
               and m.q_u = :q_u and :date2 between m.bp and m.epv)) then
       err_code = null;

     need_step_2 = iif(err_code is null and code_usl is not null, 1, 0);
--      ...        ,  2  
     if (need_step_2 = 1) then
      if (:code_usl = (select t.nms_code from KSG_TMP t where t.group_code = :tmp_grp_id)) then
       need_step_2 = 0;

     --  2.    
     if (need_step_2 = 1) then
     begin
       insert into KSG_TMP (ID, KSG, NMS_CODE, KZ, GROUP_CODE, STEP_NUM, AGE_GRP, DAYS, SEX, DS, DOP_CRITERIAN)
        select h.id, h.ksg, h.nms_code, k.kz, :tmp_grp_id, 2, h.age_grp, h.days, h.sex, h.ds, h.dop_criterion
         from ksg_grp h
         join h_ksg k on k.ksg = h.ksg and :date2 between k.bp and k.epv
--         join ksg_factors kf on kf.ksg_id = k.id and kf.q_u = k.q_u
         where h.nms_code = :code_usl --and (h.ds is null or h.ds = :ds1)
               and :date2 between h.bp and h.epv
               and h.q_u = k.q_u and h.q_u  = :q_u
               and iif(h.ds2 is not null, h.ds2, :ds2) is not distinct from :ds2;

       rc = row_count;
       if (rc = 1) then
        ksg_surg = (select t.ksg from KSG_TMP t where t.group_code=:tmp_grp_id and t.step_num=2);

       --    
       if ((rc > 1) and (:y < 2017)) then
        select ERR_CODE, KSG from SP_KSG_TMP_CRITERION(:tmp_grp_id, 2, :date2, :dr, :k_uslf, :sex)
         into :err_code, :ksg_surg;
       if ((rc > 1) and (:y >= 2017)) then
        select ERR_CODE, KSG from SP_KSG_TMP_CRITERION_2017(:tmp_grp_id, 2, :date2, :dr, :k_uslf, :sex, :dop_criterion, :code_usl,:ds1)
         into :err_code, :ksg_surg;
     end
--------------------------------------------------------------------------------
    --  3   

    if ((ksg_surg is not null) or (ksg_ter is not null)) then
    begin
      rc = (select count(*) from KSG_TMP t where t.group_code = :tmp_grp_id);
      if (rc = 1) then
       ksg = coalesce(ksg_ter, ksg_surg);
      if (rc = 2) then
      begin
        --   .  .  -  .
        if (exists(select 1 from ksg_dont_choice d
                    where d.ksg_ter = :ksg_ter and d.ksg_surg = :ksg_surg and :date2 between d.bp and d.epv) and (:q_u = 1)) then
         ksg = ksg_surg; else
         -- ...   . 
         ksg = (select first 1 t.ksg from KSG_TMP t where t.group_code=:tmp_grp_id
                 order by t.kz desc);
      end 

      err_code = null;
    end
--------------------------------------------------------------------------------
     -- 216.      
     if (ksg is null and err_code is null and ((select first 1 id from h_tarif_dializ d where :date2 between d.bp and d.epv and d.code_usl = :code_usl) is null)) then
      err_code = 1;

     delete from KSG_TMP t
      where t.group_code = :tmp_grp_id;

     if (err_code is not null) then
         update zsd d
         set d.comment_local = (select name from h_errors where ID = :err_code)
         where d.id = :idb;

     suspend;
end;

/* Alter (SP_LPU_ANALITICS4) */
ALTER PROCEDURE SP_LPU_ANALITICS4 RETURNS(Q_U INTEGER,
USL_NAME VARCHAR(50),
CODE_PROF INTEGER,
PROF_NAME VARCHAR(100),
K_USLF NUMERIC(18,3),
ZS_CNT INTEGER,
LPU_ID INTEGER,
LPU_NAME VARCHAR(100),
SUM_USLF NUMERIC(15,2),
KSG VARCHAR(50),
KSG_NAME VARCHAR(250),
ZS_CNT_CHILD INTEGER,
K_USLF_CHILD DM_NUM_6_2,
SUM_USLF_CHILD DM_MONEY_15_2)
 AS
BEGIN
  FOR
    select c.org_code, c.short_name, r.q_u, ut.name usl_name,
           r.code_prof,
           ho.name as prof_name,
           r.ksg,
           k.ksg_name,
           count(iif(r.age >= 18, r.id, null)),
           sum(iif(r.age >= 18, r.k_uslf, 0)) k_uslf,
           sum(iif(r.age >= 18, r.sum_uslf,0)),
           count(iif(r.age < 18, r.id, null)),
           sum(iif(r.age < 18, r.k_uslf, 0)),
           sum(iif(r.age < 18, r.sum_uslf,0))
    from
    sys$temp_id t
    left join zs r on r.hdr_id = t.temp_id
    join h_q_u ut on ut.id = r.q_u
    join zs_hdr h on h.id = r.hdr_id
    left join invoice i on i.id = h.name
    left join contragents c on c.org_code = i.lpu
    left join h_code_otd ho on ho.code = r.code_prof
    left join h_ksg k on k.ksg = r.ksg and r.date_2 between k.bp and k.epv and k.q_u = r.q_u
    group by 1, 2, 3, 4, 5, 6, 7, 8
    order by c.org_code
    INTO :lpu_id,
         :lpu_name,
         :Q_U,
         :USL_NAME,
         :CODE_PROF,
         :PROF_NAME,
         :ksg,
         :ksg_name,
         :ZS_CNT,
         :K_USLF,
         :sum_uslf,
         :zs_cnt_child,
         :k_uslf_child,
         :sum_uslf_child
  DO
  BEGIN
    if (prof_name is null) then
     prof_name = '<  >';
     if (lpu_id is null) then
     lpu_name = '<    >';
    SUSPEND;
  END

END;

/* Alter (SP_REP_FMPP_STAC) */
ALTER PROCEDURE SP_REP_FMPP_STAC(Y INTEGER,
M1 INTEGER,
M2 INTEGER,
Q_U INTEGER,
IS_OPL INTEGER,
NI INTEGER)
 RETURNS(ROW_NUM INTEGER,
CNT INTEGER,
VOL INTEGER,
SUMP DM_MONEY_15_2,
CNT18 INTEGER,
VOL18 INTEGER,
SUMP18 DM_MONEY_15_2)
 AS
begin
  if ((:q_u = 1) and (:is_opl = 1) and (ni = 0)) then
  begin
    for select case
                    when (z.code_prof = '29' and coalesce(z.ksg,'') = '') then 15
                    when (k.prof_num in ('13','7')) then 15
                    when (z.code_prof = '77' and coalesce(z.ksg,'') = '') then 16
                    when (k.prof_num = '24') then 16
                    when (z.code_prof = '11' and coalesce(z.ksg,'') = '') then 17
                    when (k.prof_num = '4') then 17
                    when (z.code_prof = '75' and coalesce(z.ksg,'') = '') then 18
                    when (k.prof_num = '23') then 18
                    when (z.code_prof ='122' and coalesce(z.ksg,'') = '') then 19
                    when (k.prof_num in ('35','11')) then 19
                    when (z.code_prof ='56' and coalesce(z.ksg,'') = '') then 20
                    when (k.prof_num = '18') then 20
                    when (z.code_prof = '12' and coalesce(z.ksg,'') = '') then 21
                    when (k.prof_num = '5') then 21
                    when (z.code_prof = '4' and coalesce(z.ksg,'') = '') then 22
                    when (k.prof_num = '3') then 22
                    when (z.code_prof = '68' and coalesce(z.ksg,'') = '') then 23
                    when (k.prof_num = '22') then 23
                    when (z.code_prof = '97' and coalesce(z.ksg,'') = '') then 24
                    when (k.prof_num = '27') then 24
                    when (z.code_prof = '55' and coalesce(z.ksg,'') = '') then 25
                    when (k.prof_num = '17') then 25
                    when (z.code_prof = '100' and coalesce(z.ksg,'') = '') then 26
                    when (k.prof_num = '29') then 26
--                    when 100 then 16
                    when (z.code_prof in ('108','19') and coalesce(z.ksg,'') = '') then 28
                    when (k.prof_num in ('30','9')) then 28
                    when (z.code_prof = '54' and coalesce(z.ksg,'') = '') then 29
                    when (k.prof_num = '16') then 29
                    when (z.code_prof = '114' and coalesce(z.ksg,'') = '') then 30
                    when (k.prof_num = '33') then 30
                    when (z.code_prof = '116' and coalesce(z.ksg,'') = '') then 31
                    when (k.prof_num in ('26','34')) then 31
                    when (z.code_prof = '99' and coalesce(z.ksg,'') = '') then 32
                    when (k.prof_num = '28') then 32
                    when (z.code_prof = '30' and coalesce(z.ksg,'') = '') then 33
                    when (k.prof_num = '14') then 33
                    when (z.code_prof = '81' and coalesce(z.ksg,'') = '') then 34
                    when (k.prof_num = '25') then 34
--                    when 81 then 16
                    when (z.code_prof in ('1','164') and coalesce(z.ksg,'') = '') then 36
                    when (k.prof_num = '32') then 36
                    when (z.code_prof = '60' and coalesce(z.ksg,'') = '') then 37
                    when (k.prof_num in ('19','8')) then 37
                    when (z.ksg in ('1','4','5')) then 44
                    when (z.ksg = '2') then 45
                    when (z.code_prof in ('136','137') and coalesce(z.ksg,'') = '') then 38
                    when (k.prof_num = '2') then 38
                    when (z.code_prof in ('162','163') and coalesce(z.ksg,'') = '') then 39
                    when (k.prof_num = '20') then 39
                    when (z.code_prof = '65' and coalesce(z.ksg,'') = '') then 40
                    when (k.prof_num = '21') then 40
                    when (z.code_prof = '53' and coalesce(z.ksg,'') = '') then 41
                    when (k.prof_num = '15') then 41
                    when (z.code_prof = '16' and coalesce(z.ksg,'') = '') then 42
                    when (k.prof_num = '6') then 42
                    when (z.code_prof = '28' and coalesce(z.ksg,'') = '') then 43
                    when (k.prof_num = '12') then 43

                    when (z.code_prof = '14' and coalesce(z.ksg,'') = '') then 47
                    when (z.code_prof = '112' and coalesce(z.ksg,'') = '') then 48
                    when (k.prof_num in ('31','10')) then 48
                    when (k.prof_num = 37) then 46
                    when (z.code_prof = '14') then 47
                    else 50
               end,
               count(iif(z.sum_usl > 0, z.id, null)),
               sum(z.k_usl),
               sum(z.sum_usl),
               count(iif(z.age < 18 and z.sum_usl > 0, z.id, null)),
               sum(iif(z.age < 18, z.k_usl,0)),
               sum(iif(z.age < 18, z.sum_usl, 0))
        from zs z
             join zs_hdr h on h.id = z.hdr_id
             join patients p on p.id = z.patient_id
             left join h_ksg k on k.ksg = z.ksg and k.q_u = z.q_u
        where z.q_u = 1 and z.payment_type_id = 1 and h.is_delete <> 1
              and h.y = :y and h.m between :m1 and :m2 and (p.smo starting '830')
        group by 1
        into :row_num, :cnt, :vol, :sump, :cnt18, :vol18, :sump18
        do
          suspend;
  end

  if ((:q_u = 1) and (:is_opl = 1) and (:ni = 1)) then
  begin
    for select case
                    when (z.code_prof = '29' and coalesce(z.ksg,'') = '') then 15
                    when (k.prof_num in ('13','7')) then 15
                    when (z.code_prof = '77' and coalesce(z.ksg,'') = '') then 16
                    when (k.prof_num = '24') then 16
                    when (z.code_prof = '11' and coalesce(z.ksg,'') = '') then 17
                    when (k.prof_num = '4') then 17
                    when (z.code_prof = '75' and coalesce(z.ksg,'') = '') then 18
                    when (k.prof_num = '23') then 18
                    when (z.code_prof ='122' and coalesce(z.ksg,'') = '') then 19
                    when (k.prof_num in ('35','11')) then 19
                    when (z.code_prof ='56' and coalesce(z.ksg,'') = '') then 20
                    when (k.prof_num = '18') then 20
                    when (z.code_prof = '12' and coalesce(z.ksg,'') = '') then 21
                    when (k.prof_num = '5') then 21
                    when (z.code_prof = '4' and coalesce(z.ksg,'') = '') then 22
                    when (k.prof_num = '3') then 22
                    when (z.code_prof = '68' and coalesce(z.ksg,'') = '') then 23
                    when (k.prof_num = '22') then 23
                    when (z.code_prof = '97' and coalesce(z.ksg,'') = '') then 24
                    when (k.prof_num = '27') then 24
                    when (z.code_prof = '55' and coalesce(z.ksg,'') = '') then 25
                    when (k.prof_num = '17') then 25
                    when (z.code_prof = '100' and coalesce(z.ksg,'') = '') then 26
                    when (k.prof_num = '29') then 26
--                    when 100 then 16
                    when (z.code_prof in ('108','19') and coalesce(z.ksg,'') = '') then 28
                    when (k.prof_num in ('30','9')) then 28
                    when (z.code_prof = '54' and coalesce(z.ksg,'') = '') then 29
                    when (k.prof_num = '16') then 29
                    when (z.code_prof = '114' and coalesce(z.ksg,'') = '') then 30
                    when (k.prof_num = '33') then 30
                    when (z.code_prof = '116' and coalesce(z.ksg,'') = '') then 31
                    when (k.prof_num in ('26','34')) then 31
                    when (z.code_prof = '99' and coalesce(z.ksg,'') = '') then 32
                    when (k.prof_num = '28') then 32
                    when (z.code_prof = '30' and coalesce(z.ksg,'') = '') then 33
                    when (k.prof_num = '14') then 33
                    when (z.code_prof = '81' and coalesce(z.ksg,'') = '') then 34
                    when (k.prof_num = '25') then 34
--                    when 81 then 16
                    when (z.code_prof in ('1','164') and coalesce(z.ksg,'') = '') then 36
                    when (k.prof_num = '32') then 36
                    when (z.code_prof = '60' and coalesce(z.ksg,'') = '') then 37
                    when (k.prof_num in ('19','8')) then 37
                    when (z.ksg in ('1','4','5')) then 44
                    when (z.ksg = '2') then 45
                    when (z.code_prof in ('136','137') and coalesce(z.ksg,'') = '') then 38
                    when (k.prof_num = '2') then 38
                    when (z.code_prof in ('162','163') and coalesce(z.ksg,'') = '') then 39
                    when (k.prof_num = '20') then 39
                    when (z.code_prof = '65' and coalesce(z.ksg,'') = '') then 40
                    when (k.prof_num = '21') then 40
                    when (z.code_prof = '53' and coalesce(z.ksg,'') = '') then 41
                    when (k.prof_num = '15') then 41
                    when (z.code_prof = '16' and coalesce(z.ksg,'') = '') then 42
                    when (k.prof_num = '6') then 42
                    when (z.code_prof = '28' and coalesce(z.ksg,'') = '') then 43
                    when (k.prof_num = '12') then 43

                    when (z.code_prof = '14' and coalesce(z.ksg,'') = '') then 47
                    when (z.code_prof = '112' and coalesce(z.ksg,'') = '') then 48
                    when (k.prof_num in ('31','10')) then 48
                    when (k.prof_num = 37) then 46
                    when (z.code_prof = '14') then 47
                    else 50
               end,
               count(iif(z.sum_usl > 0, z.id, null)),
               sum(z.k_usl),
               sum(z.sum_usl),
               count(iif(z.age < 18 and z.sum_usl > 0, z.id, null)),
               sum(iif(z.age < 18, z.k_usl,0)),
               sum(iif(z.age < 18, z.sum_usl, 0))
        from zs z
             join zs_hdr h on h.id = z.hdr_id
             join patients p on p.id = z.patient_id
             left join h_ksg k on k.ksg = z.ksg and k.q_u = z.q_u
        where z.q_u = 1 and z.payment_type_id = 1 and h.is_delete <> 1
              and h.y = :y and h.m between :m1 and :m2 and (coalesce(p.smo,'') = '' or coalesce(p.smo,'') = '00000')
        group by 1
        into :row_num, :cnt, :vol, :sump, :cnt18, :vol18, :sump18
        do
          suspend;
  end

  if ((:q_u = 1) and (:is_opl = 0)) then
  begin
    for select case
                    when (z.code_prof = '29' and coalesce(z.ksg,'') = '') then 15
                    when (k.prof_num in ('13','7')) then 15
                    when (z.code_prof = '77' and coalesce(z.ksg,'') = '') then 16
                    when (k.prof_num = '24') then 16
                    when (z.code_prof = '11' and coalesce(z.ksg,'') = '') then 17
                    when (k.prof_num = '4') then 17
                    when (z.code_prof = '75' and coalesce(z.ksg,'') = '') then 18
                    when (k.prof_num = '23') then 18
                    when (z.code_prof ='122' and coalesce(z.ksg,'') = '') then 19
                    when (k.prof_num in ('35','11')) then 19
                    when (z.code_prof ='56' and coalesce(z.ksg,'') = '') then 20
                    when (k.prof_num = '18') then 20
                    when (z.code_prof = '12' and coalesce(z.ksg,'') = '') then 21
                    when (k.prof_num = '5') then 21
                    when (z.code_prof = '4' and coalesce(z.ksg,'') = '') then 22
                    when (k.prof_num = '3') then 22
                    when (z.code_prof = '68' and coalesce(z.ksg,'') = '') then 23
                    when (k.prof_num = '22') then 23
                    when (z.code_prof = '97' and coalesce(z.ksg,'') = '') then 24
                    when (k.prof_num = '27') then 24
                    when (z.code_prof = '55' and coalesce(z.ksg,'') = '') then 25
                    when (k.prof_num = '17') then 25
                    when (z.code_prof = '100' and coalesce(z.ksg,'') = '') then 26
                    when (k.prof_num = '29') then 26
--                    when 100 then 16
                    when (z.code_prof in ('108','19') and coalesce(z.ksg,'') = '') then 28
                    when (k.prof_num in ('30','9')) then 28
                    when (z.code_prof = '54' and coalesce(z.ksg,'') = '') then 29
                    when (k.prof_num = '16') then 29
                    when (z.code_prof = '114' and coalesce(z.ksg,'') = '') then 30
                    when (k.prof_num = '33') then 30
                    when (z.code_prof = '116' and coalesce(z.ksg,'') = '') then 31
                    when (k.prof_num in ('26','34')) then 31
                    when (z.code_prof = '99' and coalesce(z.ksg,'') = '') then 32
                    when (k.prof_num = '28') then 32
                    when (z.code_prof = '30' and coalesce(z.ksg,'') = '') then 33
                    when (k.prof_num = '14') then 33
                    when (z.code_prof = '81' and coalesce(z.ksg,'') = '') then 34
                    when (k.prof_num = '25') then 34
--                    when 81 then 16
                    when (z.code_prof in ('1','164') and coalesce(z.ksg,'') = '') then 36
                    when (k.prof_num = '32') then 36
                    when (z.code_prof = '60' and coalesce(z.ksg,'') = '') then 37
                    when (k.prof_num in ('19','8')) then 37
                    when (z.ksg in ('1','4','5')) then 44
                    when (z.ksg = '2') then 45
                    when (z.code_prof in ('136','137') and coalesce(z.ksg,'') = '') then 38
                    when (k.prof_num = '2') then 38
                    when (z.code_prof in ('162','163') and coalesce(z.ksg,'') = '') then 39
                    when (k.prof_num = '20') then 39
                    when (z.code_prof = '65' and coalesce(z.ksg,'') = '') then 40
                    when (k.prof_num = '21') then 40
                    when (z.code_prof = '53' and coalesce(z.ksg,'') = '') then 41
                    when (k.prof_num = '15') then 41
                    when (z.code_prof = '16' and coalesce(z.ksg,'') = '') then 42
                    when (k.prof_num = '6') then 42
                    when (z.code_prof = '28' and coalesce(z.ksg,'') = '') then 43
                    when (k.prof_num = '12') then 43

                    when (z.code_prof = '14' and coalesce(z.ksg,'') = '') then 47
                    when (z.code_prof = '112' and coalesce(z.ksg,'') = '') then 48
                    when (k.prof_num in ('31','10')) then 48
                    when (k.prof_num = 37) then 46
                    when (z.code_prof = '14') then 47
                    else 50
               end,
               count(z.id),
               sum(z.k_uslf),
               sum(z.sum_uslf),
               count(iif(z.age < 18, z.id, null)),
               sum(iif(z.age < 18, z.k_uslf,0)),
               sum(iif(z.age < 18, z.sum_uslf, 0))
        from zs z
             join zs_hdr h on h.id = z.hdr_id
             join patients p on p.id = z.patient_id
             left join h_ksg k on k.ksg = z.ksg and k.q_u = z.q_u
        where z.q_u = 1 and z.payment_type_id = 1 and h.is_delete <> 1
              and h.y = :y and h.m between :m1 and :m2 and (p.smo starting '830' or coalesce(p.smo,'') = ''  or coalesce(p.smo,'') = '00000')
        group by 1
        into :row_num, :cnt, :vol, :sump, :cnt18, :vol18, :sump18
        do
          suspend;
  end

  if ((:q_u = 3) and (:is_opl = 1) and (:ni = 0)) then
  begin
    for select case
                    when (k.prof_num in ('13','7','25')) then 15
                    when (k.prof_num = '22') then 16
                    when (k.prof_num = '27') then 17
                    when (k.prof_num in ('35','11')) then 18
                    when (k.prof_num = '3') then 19
                    when (k.prof_num = '15') then 20
                    when (k.prof_num = '12') then 21
                    when (k.prof_num in ('31','10','28','32','33')) then 22
                    when (k.prof_num in ('30','9')) then 23
                    when (k.prof_num in ('34','26')) then 24
                    when (k.ksg = '1') then 42
                    when (k.prof_num = '2') then 25
                    when (k.prof_num = '29') then 26
                    when (k.prof_num = '6') then 27
                    when (k.prof_num in ('24')) then 28
                    when (k.prof_num = '4') then 29
                    when (k.prof_num = '23') then 30
                    when (k.prof_num in ('18')) then 31
                    when (k.prof_num = '5') then 32
                    when (k.prof_num = '17') then 33
                    when (k.prof_num = '21') then 34
                    when (k.prof_num = '20') then 35
                    when (k.prof_num = '16') then 36
                    when (k.prof_num = '14') then 37
                    when (k.prof_num = '25') then 38
                    when (k.prof_num in ('19','8')) then 39
                    when (k.prof_num = '37') then 40
                    when (k.prof_num = '15') then 41
                    else 44
               end,
               count(iif(z.sum_usl > 0, z.id, null)),
               sum(z.k_usl),
               sum(z.sum_usl),
               count(iif(z.age < 18 and z.sum_usl > 0, z.id, null)),
               sum(iif(z.age < 18, z.k_usl,0)),
               sum(iif(z.age < 18, z.sum_usl, 0))
        from zs z
             join zs_hdr h on h.id = z.hdr_id
             join patients p on p.id = z.patient_id
             left join h_ksg k on k.ksg = z.ksg and k.q_u = z.q_u
        where z.q_u = 3 and z.payment_type_id = 1 and h.is_delete <> 1
              and h.y = :y and h.m between :m1 and :m2 and (p.smo starting '830')
        group by 1
        into :row_num, :cnt, :vol, :sump, :cnt18, :vol18, :sump18
        do
          suspend;
  end

  if ((:q_u = 3) and (:is_opl = 1) and (:ni = 1)) then
  begin
    for select case
                    when (k.prof_num in ('13','7','25')) then 15
                    when (k.prof_num = '22') then 16
                    when (k.prof_num = '27') then 17
                    when (k.prof_num in ('35','11')) then 18
                    when (k.prof_num = '3') then 19
                    when (k.prof_num = '15') then 20
                    when (k.prof_num = '12') then 21
                    when (k.prof_num in ('31','10','28','32','33')) then 22
                    when (k.prof_num in ('30','9')) then 23
                    when (k.prof_num in ('34','26')) then 24
                    when (k.ksg = '1') then 42
                    when (k.prof_num = '2') then 25
                    when (k.prof_num = '29') then 26
                    when (k.prof_num = '6') then 27
                    when (k.prof_num in ('24')) then 28
                    when (k.prof_num = '4') then 29
                    when (k.prof_num = '23') then 30
                    when (k.prof_num in ('18')) then 31
                    when (k.prof_num = '5') then 32
                    when (k.prof_num = '17') then 33
                    when (k.prof_num = '21') then 34
                    when (k.prof_num = '20') then 35
                    when (k.prof_num = '16') then 36
                    when (k.prof_num = '14') then 37
                    when (k.prof_num = '25') then 38
                    when (k.prof_num in ('19','8')) then 39
                    when (k.prof_num = '37') then 40
                    when (k.prof_num = '15') then 41
                    else 44
               end,
               count(iif(z.sum_usl > 0, z.id, null)),
               sum(z.k_usl),
               sum(z.sum_usl),
               count(iif(z.age < 18 and z.sum_usl > 0, z.id, null)),
               sum(iif(z.age < 18, z.k_usl,0)),
               sum(iif(z.age < 18, z.sum_usl, 0))
        from zs z
             join zs_hdr h on h.id = z.hdr_id
             join patients p on p.id = z.patient_id
             left join h_ksg k on k.ksg = z.ksg and k.q_u = z.q_u
        where z.q_u = 3 and z.payment_type_id = 1 and h.is_delete <> 1
              and h.y = :y and h.m between :m1 and :m2 and (coalesce(p.smo,'') = '' or coalesce(p.smo,'') = '00000')
        group by 1
        into :row_num, :cnt, :vol, :sump, :cnt18, :vol18, :sump18
        do
          suspend;
  end

  if ((:q_u = 3) and (:is_opl = 0)) then
  begin
    for select case
                    when (k.prof_num in ('13','7','25')) then 15
                    when (k.prof_num = '22') then 16
                    when (k.prof_num = '27') then 17
                    when (k.prof_num in ('35','11')) then 18
                    when (k.prof_num = '3') then 19
                    when (k.prof_num = '15') then 20
                    when (k.prof_num = '12') then 21
                    when (k.prof_num in ('31','10','28','32','33')) then 22
                    when (k.prof_num in ('30','9')) then 23
                    when (k.prof_num in ('34','26')) then 24
                    when (k.ksg = '1') then 42
                    when (k.prof_num = '2') then 25
                    when (k.prof_num = '29') then 26
                    when (k.prof_num = '6') then 27
                    when (k.prof_num in ('24')) then 28
                    when (k.prof_num = '4') then 29
                    when (k.prof_num = '23') then 30
                    when (k.prof_num in ('18')) then 31
                    when (k.prof_num = '5') then 32
                    when (k.prof_num = '17') then 33
                    when (k.prof_num = '21') then 34
                    when (k.prof_num = '20') then 35
                    when (k.prof_num = '16') then 36
                    when (k.prof_num = '14') then 37
                    when (k.prof_num = '25') then 38
                    when (k.prof_num in ('19','8')) then 39
                    when (k.prof_num = '37') then 40
                    when (k.prof_num = '15') then 41
                    else 44
               end,
               count(z.id),
               sum(z.k_uslf),
               sum(z.sum_uslf),
               count(iif(z.age < 18, z.id, null)),
               sum(iif(z.age < 18, z.k_uslf,0)),
               sum(iif(z.age < 18, z.sum_uslf, 0))
        from zs z
             join zs_hdr h on h.id = z.hdr_id
             join patients p on p.id = z.patient_id
             left join h_ksg k on k.ksg = z.ksg and k.q_u = z.q_u
        where z.q_u = 3 and z.payment_type_id = 1 and h.is_delete <> 1
              and h.y = :y and h.m between :m1 and :m2 and (p.smo starting '830' or coalesce(p.smo,'') = '')
        group by 1
        into :row_num, :cnt, :vol, :sump, :cnt18, :vol18, :sump18
        do
          suspend;
  end


end;

/* Restore proc. body: SP_CALC_ALL */
ALTER PROCEDURE SP_CALC_ALL(ZS_ID INTEGER)
 AS
declare variable TAR DM_MONEY_15_2;
declare variable DATE1 DM_DATE;
declare variable Q_U integer;
declare variable TAR_USL DM_MONEY_15_2;
declare variable TARGET integer;
declare variable IDB integer;
declare variable SUM_USLF DM_MONEY_15_2;
declare variable SEX char(1);
declare variable PTYPE integer;
declare variable AGE_Y integer;
declare variable AGE_GRP integer;
declare variable HDR_ID integer;
declare variable TROMB_CODE DM_CHAR_20;
begin
  select z.date_2, z.q_u, z.target, p.sex, z.payment_type_id, extract(year from z.date_2) - extract(year from p.dr), z.hdr_id
  from zs z
  join patients p on p.id = z.patient_id
  where z.id = :zs_id
  into :date1, :q_u, :target, :sex, :ptype, :age_y, :hdr_id;

  if (:ptype in (2,3)) then exit;

  if (:target in (9,10,11,12,13,14,15,16,17)) then
  begin
   if ((select coalesce(t.days_cnt,0) from h_target t where t.id = :target) <> 0) then
   begin
    update zsd d
     set d.zachet = 1
     where d.date_1 < (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;

    update zsd d
     set d.zachet = 0
     where d.date_1 >= (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;
   end

   update zsd d
    set d.k_uslf = 0
    where (d.zachet = 1 or d.is_no_get_usl = 1) and d.zs_id = :zs_id;
  end

  update zsd d
    set d.tar_usl = null,
        d.sum_uslf = null,
        d.comment_local = null
    where d.zs_id = :zs_id;

  update zs z
    set z.tar_usl = null,
        z.sum_usl = null,
        z.sum_uslf = null
    where z.id = :zs_id;

  if ((select coalesce(i.is_nz,0) from invoice i join zs_hdr h on h.name = i.id where h.id = :hdr_id) = 1) then
  begin
    if (target in (9,10,11,13,14,15,16,17)) then exit;

    tar = (select first 1 s.tarif from h_tarif_nz s where s.q_u = iif(:q_u = 4,2,:q_u) and :date1 between s.bp and s.epv);

    if (q_u = 1) then
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id and d.code_usl is null;
    else
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id;

    if (q_u = 4) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = z.dcount*:tar
      where id = :zs_id;
    else
    if (q_u = 1) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = :tar
      where id = :zs_id;
    else
      update zs z
      set z.tar_usl = :tar,
          z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
      where id = :zs_id;
    exit;
  end
   /********************,    ************************/
  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 < '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin

          select first 1 h.tarif, h.tarif
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
                                 and cast(h.code_spec as varchar(10)) = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec = '16' and a.age < 18, '22', b.code_spec), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf;

          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0)
           where b.id = :idb;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end

  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 >= '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          if ((select d.code_usl from zsd d where d.id = :idb) = 'A23.30.099.005') then
          begin
            tar = 1670;
            sum_uslf = 1670*(select d.k_uslf from zsd d where d.id = :idb);
          end
          else
          if ((select d.code_usl from zsd d where d.id = :idb) = 'A23.30.099.006') then
          begin
            tar = 1180;
            sum_uslf = 1180*(select d.k_uslf from zsd d where d.id = :idb);
          end
          else
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          if (:tar is null) then
          select first 1 h.tarif, h.tarif
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
           join h_tarif_app_spec n on n.name_id = h.name_id
                                 and n.code_spec_v021 = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec_v021 = 39 and a.age < 18, 49, b.code_spec_v021), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf;

          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0)
           where b.id = :idb;

          tar = null;
          sum_uslf = null;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end  

  /********************************************/
  if (:q_u = 4) then
  begin
    tar = (select s.tarif from h_tarif_stom s where :date1 between s.bp and s.epv);

    update zsd d
    set d.tar_usl = :tar,
        d.sum_uslf = d.k_uslf*:tar
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = :tar,
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if (:q_u = 5) then
  begin
--    if (:date1 >= '01.01.2018') then tromb_code = 'A25.30.036';
--    else tromb_code = 'A25.30.035';
    tromb_code = coalesce((select first 1 code_usl from zsd d where d.zs_id = :zs_id and coalesce(code_usl, '') <> ''),'');

    tar = (select s.tarif from h_tarif_smp s where :date1 between s.bp and s.epv);
    tar_usl = coalesce((select coalesce(u.sumf,0) from h_usl u where u.code = :tromb_code
               and u.q_u containing '5' and :date1 between u.datebeg and u.dateend),0);

    update zsd d
    set d.tar_usl = iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl),
        d.sum_uslf = d.k_uslf*iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl)
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = (select max(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if ((:q_u = 1) and ((select 1 from zs z where coalesce(z.metod_hmp,0) > 0 and id = :zs_id) = 1)) then
  begin
    select first 1 v.tarif
    from zs z
         join h_metod_hmp h on h.code = z.metod_hmp and z.date_2 between h.bp and h.epv
         join h_tarif_vmp v on v.tg = h.tg and z.date_2 between v.bp and v.epv
    where z.id = :zs_id
    into :tar;

    update zs a set
        a.tar_usl = :tar,
        a.sum_uslf = :tar,
        a.ksg = null,
        a.kslp = null
    where a.id = :zs_id;

    update zsd b set
          b.ksg = null,
          b.sum_uslf = :tar,
          b.kskp = 0,
          b.tar_usl = :tar
    where b.zs_id = :zs_id and coalesce(b.code_usl,'') = '' and b.date_1 = (select min(date_1) from zsd where zs_id = :zs_id and coalesce(code_usl,'') = '');

    exit;
  end

  /********************************************/
  if (:q_u in (1,3) and :date1 < '01.01.2018') then
    execute procedure SP_CALC_STAC(:zs_id);
  else
    if (:q_u in (1,3) and :date1 >= '01.01.2018') then
      execute procedure sp_calc_stac_2018(:zs_id);

  /****************  ***********************************************/
  tar = null;
  sum_uslf = null;
  for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          if (coalesce(:tar,0) > 0) then
          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0)
           where b.id = :idb;

          tar = null;
          sum_uslf = null;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;


  /*********************-*********************************/
  if ((:q_u = 2) and (:target in (21,22))) then
  begin
   for select b.id
    from zsd b
    join zs z on z.id = b.zs_id
    where z.id = :zs_id
    into :idb
    do
    begin
      tar = (select first 1 t.tarif
             from zsd d
                  join h_tomo_code c on c.nms_code = d.code_usl
                  join h_tarif_tomo t on t.group_num = c.group_num and d.date_2 between t.bp and t.epv
             where d.id = :idb);

      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf = :tar
      where d.id = :idb;
    end

    update zs z
    set z.tar_usl = (select sum(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;

    exit;
  end
  /******************** - 9  ************************/
  if (:q_u = 2 and :target = 9) then
  begin
    execute procedure sp_calc_app_t09(:zs_id);
    exit;
  end

  /******************** - 10,17  -  ************************/
    if (q_u = 2 and target in (10,17)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_10 d on d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and :age_y between d.y1 and d.y2
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 13  ************************/
    if (q_u = 2 and target = 13) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                           and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_13_17 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.age_grp = a.age_grp
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 14,15  ,  ************************/
    if (q_u = 2 and target in (14,15)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_14_15 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.cat_info = a.cat_info
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
  /******************** - 16  ************************/
    if (q_u = 2 and target = 16) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_16 d on a.date_2 between d.bp and d.epv
                                          and d.sex = :sex
                                          and cast(d.code_usl as varchar(20)) = b.code_usl
                                          and d.age_l <= a.age and d.age_r >= a.age
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0) ,
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
end;

/* Creating trigger... */
CREATE TRIGGER H_ONK_N018_BI FOR H_ONK_N018
ACTIVE BEFORE INSERT POSITION 0 
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_h_onk_n018_id,1);
end;

CREATE TRIGGER H_ONK_N019_BI FOR H_ONK_N019
ACTIVE BEFORE INSERT POSITION 0 
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_h_onk_n019_id,1);
end;

CREATE TRIGGER H_ONK_N020_BI FOR H_ONK_N020
ACTIVE BEFORE INSERT POSITION 0 
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_h_onk_n020_id,1);
end;

CREATE TRIGGER H_ONK_N021_BI FOR H_ONK_N021
ACTIVE BEFORE INSERT POSITION 0 
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_h_onk_n021_id,1);
end;

CREATE TRIGGER H_V027_BI FOR H_V027
ACTIVE BEFORE INSERT POSITION 0 
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_h_v027_id,1);
end;

CREATE TRIGGER H_V028_BI FOR H_V028
ACTIVE BEFORE INSERT POSITION 0 
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_h_v028_id,1);
end;

CREATE TRIGGER H_V029_BI FOR H_V029
ACTIVE BEFORE INSERT POSITION 0 
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_h_v029_id,1);
end;

CREATE TRIGGER ONK_CONS_BI FOR ONK_CONS
ACTIVE BEFORE INSERT POSITION 0 
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_onk_cons_id,1);
end;

CREATE TRIGGER ONK_LEK_PR_BI FOR ONK_LEK_PR
ACTIVE BEFORE INSERT POSITION 0 
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_onk_lek_pr_id,1);
end;

CREATE TRIGGER ONK_SL_BD0 FOR ONK_SL
ACTIVE BEFORE DELETE POSITION 0 
AS
begin
  delete from onk_cons c where c.zsd_id = old.zsd_id;
  delete from onk_diag d where d.onk_sl_id = old.zsd_id;
  delete from onk_prot p where p.onk_sl_id = old.zsd_id;
  delete from onk_usl u where u.zsd_id = old.zsd_id;
end;

CREATE TRIGGER ONK_USL_BD0 FOR ONK_USL
ACTIVE BEFORE DELETE POSITION 0 
AS
begin
  delete from onk_lek_pr p where p.onk_usl_id = old.id;
end;


/* Create Views... */

/* Altering existing trigger... */
ALTER TRIGGER ZSD_BD0
AS
begin
  delete from zs_ds d where d.section = 2 and d.section_id = old.id;
  delete from onk_cons c where c.zsd_id = old.id;
  delete from onk_diag d where d.onk_sl_id = old.id;
  delete from onk_napr n where n.zsd_id = old.id;
  delete from onk_prot p where p.onk_sl_id = old.id;
  delete from onk_sl s where s.zsd_id = old.id;
  delete from onk_usl u where u.zsd_id = old.id;
end;

/* Altering existing trigger... */
ALTER TRIGGER ZSD_BU0
AS
declare variable spec varchar(10);
declare variable otd_prof varchar(20);
declare variable phys integer;
declare variable child integer;
declare variable prof varchar(10);
declare variable podr varchar(12);
declare variable mp integer ;
declare variable spec_v021 integer;
begin
  update zs
  set --k_uslf = (select sum(k_uslf) from zsd where zs_id = new.zs_id),
--      ds0 = (select first 1 zz.ds from zsd zz where zz.zs_id = new.zs_id and zz.date_1 =
--              (select min(date_1) from zsd where zs_id = new.zs_id)),
      dcount = (select count(distinct z.date_1) from zsd z where z.zs_id = new.zs_id)
    where id = new.zs_id;

    if ((select min(date_1) from zsd where zs_id = new.zs_id and coalesce(zachet,0) <> 1) is not null) then
    update zs
    set date_1 = (select min(date_1) from zsd where zs_id = new.zs_id and coalesce(zachet,0) <> 1),
        date_2 = (select max(date_2) from zsd where zs_id = new.zs_id and coalesce(zachet,0) <> 1)
    where id = new.zs_id;



  if (((new.date_2 >= (select date_2 from zs where id = new.zs_id))
      and ((select count(id) from zsd where zs_id = new.zs_id and coalesce(pmd_close,0) = 1) = 0))
     or (new.pmd_close = 1))
  then
   begin
     update zs
     set code_spec = new.code_spec,
         code_spec_v021 = new.code_spec_v021,
         otd_prof = new.otd_prof,
--         ds1 = iif(coalesce(new.ds,'') = '', ds1, new.ds),
         phys_id = new.phys_id,
         is_chield = new.is_chield,
         code_prof = new.code_prof,
         podr = new.podr,
         mp = new.mp,
         ds1 = new.ds,
         ds2 = new.ds2,
         ds_onk = new.ds_onk
      where id = new.zs_id;
    end
   else
    begin
      if (new.pmd_close = 0 and old.pmd_close = 1) then
      begin
      for select z.code_spec, z.otd_prof, z.phys_id, z.is_chield, z.code_prof, z.podr, z.mp, z.code_spec_v021 from zsd z
          where  (z.id = (select max(id) from zsd d where d.zs_id = new.zs_id and
                         (d.date_2 = (select max(date_2) from zsd where zs_id = new.zs_id))))
          into :spec, :otd_prof, :phys, :child, :prof, :podr, :mp, :spec_v021
      do
          update zs
          set code_spec = :spec,
              code_spec_v021 = :spec_v021,
             otd_prof = :otd_prof,
--             ds1 = iif(coalesce(:ds1,'') = '', ds1, :ds1),
             phys_id = :phys,
             is_chield = :child,
             code_prof = :prof,
             podr = :podr,
             mp = :mp,
             ds1 = new.ds,
             ds2 = new.ds2,
             ds_onk = new.ds_onk
          where id = new.zs_id;
      end
     end

    if ((select z.payment_type_id from zs z where z.id = new.zs_id) in (3,2)) then
    begin
        update zs
        set sum_uslf = (select sum(sum_uslf) from zsd where zs_id = new.zs_id),
            sum_usl = coalesce((select sum(i.sum_opl) from patients_invoice i where i.zs_id = new.zs_id), 0),
            tar_usl = null
        where id = new.zs_id and payment_type_id <> 1;
    end
end;

/* Alter Procedure... */
/* empty dependent procedure body */
/* Clear: SP_CALC_ALL_CH for: SP_CALC_ALL */
ALTER PROCEDURE SP_CALC_ALL_CH(HDR_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* empty dependent procedure body */
/* Clear: SP_ZS_SET_ZACHET for: SP_CALC_ALL */
ALTER PROCEDURE SP_ZS_SET_ZACHET(HDR_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* empty dependent procedure body */
/* Clear: SP_ZSD_LIST_CREATE for: SP_CALC_ALL */
ALTER PROCEDURE SP_ZSD_LIST_CREATE(ZS_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* Alter (SP_CALC_ALL) */
ALTER PROCEDURE SP_CALC_ALL(ZS_ID INTEGER)
 AS
declare variable TAR DM_MONEY_15_2;
declare variable DATE1 DM_DATE;
declare variable Q_U integer;
declare variable TAR_USL DM_MONEY_15_2;
declare variable TARGET integer;
declare variable IDB integer;
declare variable SUM_USLF DM_MONEY_15_2;
declare variable SEX char(1);
declare variable PTYPE integer;
declare variable AGE_Y integer;
declare variable AGE_GRP integer;
declare variable HDR_ID integer;
declare variable TROMB_CODE DM_CHAR_20;
begin
  select z.date_2, z.q_u, z.target, p.sex, z.payment_type_id, extract(year from z.date_2) - extract(year from p.dr), z.hdr_id
  from zs z
  join patients p on p.id = z.patient_id
  where z.id = :zs_id
  into :date1, :q_u, :target, :sex, :ptype, :age_y, :hdr_id;

  if (:ptype in (2,3)) then exit;

  if (:target in (9,10,11,12,13,14,15,16,17)) then
  begin
   if ((select coalesce(t.days_cnt,0) from h_target t where t.id = :target) <> 0) then
   begin
    update zsd d
     set d.zachet = 1
     where d.date_1 < (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;

    update zsd d
     set d.zachet = 0
     where d.date_1 >= (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;
   end

   update zsd d
    set d.k_uslf = 0
    where (d.zachet = 1 or d.is_no_get_usl = 1) and d.zs_id = :zs_id;
  end

  update zsd d
    set d.tar_usl = null,
        d.sum_uslf = null,
        d.comment_local = null
    where d.zs_id = :zs_id;

  update zs z
    set z.tar_usl = null,
        z.sum_usl = null,
        z.sum_uslf = null
    where z.id = :zs_id;

  if ((select coalesce(i.is_nz,0) from invoice i join zs_hdr h on h.name = i.id where h.id = :hdr_id) = 1) then
  begin
    if (target in (9,10,11,13,14,15,16,17)) then exit;

    tar = (select first 1 s.tarif from h_tarif_nz s where s.q_u = iif(:q_u = 4,2,:q_u) and :date1 between s.bp and s.epv);

    if (q_u = 1) then
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id and d.code_usl is null;
    else
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id;

    if (q_u = 4) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = z.dcount*:tar
      where id = :zs_id;
    else
    if (q_u = 1) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = :tar
      where id = :zs_id;
    else
      update zs z
      set z.tar_usl = :tar,
          z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
      where id = :zs_id;
    exit;
  end
   /********************,    ************************/
  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 < '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin

          select first 1 h.tarif, h.tarif
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
                                 and cast(h.code_spec as varchar(10)) = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec = '16' and a.age < 18, '22', b.code_spec), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf;

          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0)
           where b.id = :idb;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end

  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 >= '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          if ((select d.code_usl from zsd d where d.id = :idb) = 'A23.30.099.005') then
          begin
            tar = 1670;
            sum_uslf = 1670*(select d.k_uslf from zsd d where d.id = :idb);
          end
          else
          if ((select d.code_usl from zsd d where d.id = :idb) = 'A23.30.099.006') then
          begin
            tar = 1180;
            sum_uslf = 1180*(select d.k_uslf from zsd d where d.id = :idb);
          end
          else
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          if (:tar is null) then
          select first 1 h.tarif, h.tarif
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
           join h_tarif_app_spec n on n.name_id = h.name_id
                                 and n.code_spec_v021 = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec_v021 = 39 and a.age < 18, 49, b.code_spec_v021), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf;

          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0)
           where b.id = :idb;

          tar = null;
          sum_uslf = null;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end  

  /********************************************/
  if (:q_u = 4) then
  begin
    tar = (select s.tarif from h_tarif_stom s where :date1 between s.bp and s.epv);

    update zsd d
    set d.tar_usl = :tar,
        d.sum_uslf = d.k_uslf*:tar
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = :tar,
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if (:q_u = 5) then
  begin
--    if (:date1 >= '01.01.2018') then tromb_code = 'A25.30.036';
--    else tromb_code = 'A25.30.035';
    tromb_code = coalesce((select first 1 code_usl from zsd d where d.zs_id = :zs_id and coalesce(code_usl, '') <> ''),'');

    tar = (select s.tarif from h_tarif_smp s where :date1 between s.bp and s.epv);
    tar_usl = coalesce((select coalesce(u.sumf,0) from h_usl u where u.code = :tromb_code
               and u.q_u containing '5' and :date1 between u.datebeg and u.dateend),0);

    update zsd d
    set d.tar_usl = iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl),
        d.sum_uslf = d.k_uslf*iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl)
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = (select max(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if ((:q_u = 1) and ((select 1 from zs z where coalesce(z.metod_hmp,0) > 0 and id = :zs_id) = 1)) then
  begin
    select first 1 v.tarif
    from zs z
         join h_metod_hmp h on h.code = z.metod_hmp and z.date_2 between h.bp and h.epv
         join h_tarif_vmp v on v.tg = h.tg and z.date_2 between v.bp and v.epv
    where z.id = :zs_id
    into :tar;

    update zs a set
        a.tar_usl = :tar,
        a.sum_uslf = :tar,
        a.ksg = null,
        a.kslp = null
    where a.id = :zs_id;

    update zsd b set
          b.ksg = null,
          b.sum_uslf = :tar,
          b.kskp = 0,
          b.tar_usl = :tar
    where b.zs_id = :zs_id and coalesce(b.code_usl,'') = '' and b.date_1 = (select min(date_1) from zsd where zs_id = :zs_id and coalesce(code_usl,'') = '');

    exit;
  end

  /********************************************/
  if (:q_u in (1,3) and :date1 < '01.01.2018') then
    execute procedure SP_CALC_STAC(:zs_id);
  else
    if (:q_u in (1,3) and :date1 >= '01.01.2018') then
      execute procedure sp_calc_stac_2018(:zs_id);

  /****************  ***********************************************/
  tar = null;
  sum_uslf = null;
  for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          if (coalesce(:tar,0) > 0) then
          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0)
           where b.id = :idb;

          tar = null;
          sum_uslf = null;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;


  /*********************-*********************************/
  if ((:q_u = 2) and (:target in (21,22))) then
  begin
   for select b.id
    from zsd b
    join zs z on z.id = b.zs_id
    where z.id = :zs_id
    into :idb
    do
    begin
      tar = (select first 1 t.tarif
             from zsd d
                  join h_tomo_code c on c.nms_code = d.code_usl
                  join h_tarif_tomo t on t.group_num = c.group_num and d.date_2 between t.bp and t.epv
             where d.id = :idb);

      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf = :tar
      where d.id = :idb;
    end

    update zs z
    set z.tar_usl = (select sum(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;

    exit;
  end
  /******************** - 9  ************************/
  if (:q_u = 2 and :target = 9) then
  begin
    execute procedure sp_calc_app_t09(:zs_id);
    exit;
  end

  /******************** - 10,17  -  ************************/
    if (q_u = 2 and target in (10,17)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_10 d on d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and :age_y between d.y1 and d.y2
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 13  ************************/
    if (q_u = 2 and target = 13) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                           and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_13_17 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.age_grp = a.age_grp
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 14,15  ,  ************************/
    if (q_u = 2 and target in (14,15)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_14_15 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.cat_info = a.cat_info
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
  /******************** - 16  ************************/
    if (q_u = 2 and target = 16) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_16 d on a.date_2 between d.bp and d.epv
                                          and d.sex = :sex
                                          and cast(d.code_usl as varchar(20)) = b.code_usl
                                          and d.age_l <= a.age and d.age_r >= a.age
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0) ,
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
end;

/* Alter (SP_CALC_ALL_CH) */
ALTER PROCEDURE SP_CALC_ALL_CH(HDR_ID INTEGER)
 AS
declare variable ZID integer;
begin

 for select z.id
  from zs z
  where z.hdr_id = :hdr_id
  into :zid
  do
    execute procedure SP_CALC_ALL(:ZID);

  update invoice i
  set i.sumv = (select sum(z.sum_uslf) from zs z where z.hdr_id = :hdr_id),
      i.sump = (select sum(z.sum_usl) from zs z where z.hdr_id = :hdr_id)
  where i.id = (select name from zs_hdr h where h.id = :hdr_id);
end;

/* Alter (SP_ZS_SET_ZACHET) */
ALTER PROCEDURE SP_ZS_SET_ZACHET(HDR_ID INTEGER)
 AS
declare variable ZS_ID integer;
declare variable DATE1 DM_DATE;
begin
  for select z.id, z.date_1
      from zs z
      where z.hdr_id = :hdr_id
      into :zs_id, :date1
      do
      begin
        update zsd d
         set d.zachet = 1
         where d.zs_id = :zs_id and d.date_1 < :date1;

        execute procedure SP_CALC_ALL(:ZS_ID);
      end
end;

/* Alter (SP_ZSD_LIST_CREATE) */
ALTER PROCEDURE SP_ZSD_LIST_CREATE(ZS_ID INTEGER)
 AS
declare variable TARGET integer;
begin
  target = (select target from zs where id = :zs_id);

  if (exists (select id from zsd where zs_id = :zs_id)) then
   exit;

  if (target = 9) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.code_usl, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, 'Z00.8', 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_09 d on d.stage = z.disp_stage and d.age = extract(year from z.date_1) - extract(year from p.dr)
                                      and d.sex = p.sex and z.date_2 between d.bp and d.epv
       where z.id = :zs_id and d.code_usl is not null and d.tarif is not null;
  end

  if (target in (10,17)) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.usl_code, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, iif(z.age < 3, 'Z00.1', iif(z.age >= 3 and z.age < 15, 'Z00.2', 'Z00.3')), 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_10 d on d.stage = z.disp_stage and d.sex = p.sex
                                          and z.date_2 between d.bp and d.epv
                                          and z.age between d.y1 and d.y2
       where z.id = :zs_id and d.tarif is not null;
  end

  if (target = 13) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.usl_code, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, iif(z.age < 3, 'Z00.1', iif(z.age >= 3 and z.age < 15, 'Z00.2', 'Z00.3')), 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_13_17 d on d.target = z.target
                                          and d.stage = z.disp_stage and d.sex = p.sex
                                          and z.date_2 between d.bp and d.epv
                                          and d.age_grp = z.age_grp
       where z.id = :zs_id and d.tarif is not null;
  end

  if (target in (14,15)) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.usl_code, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, iif(z.age < 3, 'Z00.1', iif(z.age >= 3 and z.age < 15, 'Z00.2', 'Z00.3')),1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_14_15 d on d.target = z.target
                                          and d.stage = z.disp_stage and d.sex = p.sex
                                          and z.date_2 between d.bp and d.epv
                                          and d.cat_info = z.cat_info
       where z.id = :zs_id and d.tarif is not null;
  end

  if (target = 16) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.code_usl, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, 'Z00.8', 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_16 d on z.date_2 between d.bp and d.epv
                                          and d.sex = p.sex
                                          and d.age_l <= z.age and d.age_r >= z.age
       where z.id = :zs_id and d.tarif is not null;
  end

  insert into ZS_DS (DS, DS_TYPE, SECTION, SECTION_ID, PR, IS_TEMP)
    select d.ds, 1, 2, d.id, 0, 1
    from zsd d
    where d.zs_id = :zs_id;

  execute procedure SP_CALC_ALL(:ZS_ID);
end;
