/* Create Table... */
CREATE TABLE H_F010(ID DM_ID NOT NULL,
OKATO DM_OKATO,
TF_COD DM_INT,
NAME DM_CHAR_250,
BP DM_DATE,
EP DM_DATE);


ALTER TABLE H_F010 ADD EPV COMPUTED BY ((coalesce(EP, cast('31.12.9999' as date))));


/* Create generator... */
CREATE GENERATOR GEN_H_F010_ID;


/* Create Primary Key... */
ALTER TABLE H_F010 ADD CONSTRAINT PK_H_F010 PRIMARY KEY (ID);

/* Alter Procedure... */
/* Alter (SP_GEN_APP_TARIF) */

ALTER PROCEDURE SP_GEN_APP_TARIF(TG_CNT INTEGER,
NAME_ID INTEGER,
VID_POM INTEGER,
BP DATE,
EP DATE)
 AS
declare variable TG integer;
begin
  tg = 1;

  while (:tg <= :tg_cnt) do
  begin
    update or insert into H_TARIF_APP (TG, TARGET, BP, EP, NAME_ID)
    values (:TG, :vid_pom, :BP, :EP, :NAME_ID)
    matching (TG, TARGET, BP, NAME_ID);
    tg = tg + 1;
  end

  if (:ep is null) then
  delete from h_tarif_app a
   where a.tg > :tg_cnt and a.target = :vid_pom and a.name_id = :name_id and bp = :bp and ep is null;
  else
  delete from h_tarif_app a
   where a.tg > :tg_cnt and a.target = :vid_pom and a.name_id = :name_id and bp = :bp and ep = :ep;
end;

/* Creating trigger... */
CREATE TRIGGER H_F010_BI FOR H_F010
ACTIVE BEFORE INSERT POSITION 0 
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_h_f010_id,1);
end;

