/* Create Table... */
CREATE TABLE KLADR_CITY(ID DM_ID NOT NULL,
CODE DM_CHAR_11,
NAME DM_CHAR_100,
SOCR DM_CHAR_10,
IDX DM_CHAR_8,
OKATO DM_CHAR_5);


CREATE TABLE KLADR_STREET(ID DM_ID NOT NULL,
CODE DM_CHAR_15,
NAME DM_CHAR_100,
SOCR DM_CHAR_10,
IDX DM_CHAR_8);



ALTER TABLE H_USL ADD FINANS_TYPE DM_INT;

DESCRIBE FIELD FINANS_TYPE TABLE H_USL
'null  0 -  
1   - ';

ALTER TABLE PATIENTS ADD REGION_CODE DM_CHAR_11;

ALTER TABLE PATIENTS ADD RAYON_CODE DM_CHAR_11;

ALTER TABLE PATIENTS ADD CITY_CODE DM_CHAR_11;

ALTER TABLE PATIENTS ADD STREET_CODE DM_CHAR_15;

ALTER TABLE PATIENTS ADD HOUSE DM_INT;

ALTER TABLE PATIENTS ADD HOUSE_IDX DM_CHAR_3;

ALTER TABLE PATIENTS ADD ROOM DM_INT;

ALTER TABLE PATIENTS ADD ROOM_IDX DM_CHAR_2;

ALTER TABLE PATIENTS ADD ISNOWORKER DM_BOOLEAN;

ALTER TABLE ZSD ADD DOP_TARIF DM_MONEY_15_2;

ALTER TABLE ZSD ADD DOP_SUM DM_MONEY_15_2;

ALTER TABLE ZSD ADD DOP_CODE_USL DM_CHAR_20;

/* Alter View (Drop, Create)... */
/* Drop altered view: V_PATIENTS */

ALTER PROCEDURE SP_GET_REGISTRY_INFO(R_ID INTEGER)
 RETURNS(S /* DM_CHAR_250 */ VARCHAR(250))
 AS
 BEGIN SUSPEND; END;

DROP VIEW V_PATIENTS;

/* Create altered view: V_PATIENTS */
/* Create view: V_PATIENTS */
CREATE VIEW V_PATIENTS(
ID,
SS,
FAM,
IM,
OT,
SEX,
DR,
ADRES,
DOC_TYPE,
DOC_SER,
DOC_NUM,
POLIS_TYPE,
SER_SP,
NUM_SP,
SMO,
OKATO_SMO,
STATUS,
PS_PRZ,
IS_PAID,
JOB,
JOB_ADRES,
POST,
PHONES,
OKATO_R,
OKATO_L,
BPLACE,
ENP,
EMAIL,
ADRES_REG,
MED_HISTORY_NUM,
HIST_NUM,
DOC_PLACE,
DOC_DATE,
SMO_OGRN,
SMO_NAM,
ID_PAC,
INN,
NOVOR,
IS_DELETE,
IS_INSERTING,
ROP_FAM,
ROP_IM,
ROP_OT,
ROP_DR,
ROP_SEX,
ROP_SER_SP,
ROP_NUM_SP,
REG_DATE,
PHONE_MAIN,
INV,
FIO,
PATIENT_TYPE,
SUM_OPL,
PATIENT_TYPE_NAME,
NATIONALITY,
REGION_CODE,
RAYON_CODE,
CITY_CODE,
STREET_CODE,
HOUSE,
HOUSE_IDX,
ROOM,
ROOM_IDX,
ISNOWORKER)
 AS 
select
    p.id,
    p.ss,
    p.fam,
    p.im,
    p.ot,
    p.sex,
    p.dr,
    p.adres,
    p.doc_type,
    p.doc_ser,
    p.doc_num,
    p.polis_type,
    p.ser_sp,
    p.num_sp,
    p.smo,
    p.okato_smo,
    p.status,
    p.ps_prz,
    p.is_paid,
    p.job,
    p.job_adres,
    p.post,
    p.phones,
    p.okato_r,
    p.okato_l,
    p.bplace,
    p.enp,
    p.email,
    p.adres_reg,
    p.med_history_num,
    p.hist_num,
    p.doc_place,
    p.doc_date,
    p.smo_ogrn,
    p.smo_nam,
    p.id_pac,
    p.inn,
    p.novor,
    p.is_delete,
    p.is_inserting,
    r.fam as rop_fam,
    r.im as rop_im,
    r.ot as rop_ot,
    r.dr as rop_dr,
    r.sex as rop_sex,
    r.ser_sp as rop_ser_sp,
    r.num_sp as rop_num_sp,
    (select max(rg.reg_date) from registry rg where rg.patients_id = p.id and rg.is_appeared <> 2) reg_date,
    p.phones,
    P.inv,
    COALESCE(p.fam,' ')||' '||COALESCE(p.im,' ')||' '||COALESCE(p.ot, ' ') fio,
    p.patient_type,
    (select sum(i.sum_opl) from patients_invoice i where i.patient_id = p.id),
    t.name,
    p.nationality,
    P.region_code,
    P.rayon_code,
    P.city_code,
    P.street_code,
    P.house,
    P.house_idx,
    P.room,
    P.room_idx,
    P.isnoworker
from patients p
      left join pat_rop r on r.pat_id = p.id
      left join h_patient_type t on t.id = p.patient_type
WHERE p.is_paid = 0
;

DESCRIBE FIELD SS VIEW V_PATIENTS
'';

DESCRIBE FIELD FAM VIEW V_PATIENTS
'';

DESCRIBE FIELD IM VIEW V_PATIENTS
'';

DESCRIBE FIELD OT VIEW V_PATIENTS
'';

DESCRIBE FIELD SEX VIEW V_PATIENTS
'';

DESCRIBE FIELD DR VIEW V_PATIENTS
' ';

DESCRIBE FIELD ADRES VIEW V_PATIENTS
'';

DESCRIBE FIELD DOC_TYPE VIEW V_PATIENTS
' ';

DESCRIBE FIELD DOC_SER VIEW V_PATIENTS
' ';

DESCRIBE FIELD DOC_NUM VIEW V_PATIENTS
' ';

DESCRIBE FIELD POLIS_TYPE VIEW V_PATIENTS
'  ';

DESCRIBE FIELD SER_SP VIEW V_PATIENTS
'  ';

DESCRIBE FIELD NUM_SP VIEW V_PATIENTS
'  ';

DESCRIBE FIELD SMO VIEW V_PATIENTS
'';

DESCRIBE FIELD JOB VIEW V_PATIENTS
' ';

DESCRIBE FIELD POST VIEW V_PATIENTS
'';

DESCRIBE FIELD PHONES VIEW V_PATIENTS
'';

DESCRIBE FIELD EMAIL VIEW V_PATIENTS
'Email';

DESCRIBE FIELD MED_HISTORY_NUM VIEW V_PATIENTS
' ';

DESCRIBE FIELD INN VIEW V_PATIENTS
'';

DESCRIBE FIELD NOVOR VIEW V_PATIENTS
' ';

DESCRIBE FIELD ROP_FAM VIEW V_PATIENTS
' ';

DESCRIBE FIELD ROP_IM VIEW V_PATIENTS
' ';

DESCRIBE FIELD ROP_OT VIEW V_PATIENTS
' ';

DESCRIBE FIELD REG_DATE VIEW V_PATIENTS
'  ';

DESCRIBE FIELD INV VIEW V_PATIENTS
'';

/* Drop altered view: V_ZSD */
DROP VIEW V_ZSD;

/* Create altered view: V_ZSD */
/* Create view: V_ZSD */
CREATE VIEW V_ZSD(
ID,
ZS_ID,
DATE_1,
DATE_2,
CODE_SPEC,
CODE_PROF,
USL_TYPE,
OTD_PROF,
IS_CHIELD,
DS,
DS2,
SRVPLACE,
CODE_USL,
K_USLF,
PHYS_ID,
MES_CODE,
FIO,
SPEC_NAME,
SRVPLACE1,
DCOUNT,
KSG,
PCOD,
TAR_USL,
PMD_CLOSE,
SUM_USLF,
ORIT,
MP,
USL_NAME,
Q_U,
TARGET,
DISP_STAGE,
DATE_1_ZS,
TOOTH,
ZACHET,
IS_NO_GET_USL,
KSG_BASE,
SUM_BASE,
TAR_BASE,
KSKP_BASE,
COMMENT_LOCAL,
PODR,
TOOTH_LIST,
PROF_NAME,
FAM,
IM,
OT,
DR,
PHONES,
EMAIL,
Q_U_NAME,
KSG_CRITERION,
ZSD_ID,
P_CEL,
DN,
PROFIL_K,
P_PER,
DS_ONK,
KSG_CRITERION2,
CODE_SPEC_V021,
SER_SP,
NUM_SP,
C_ZAB,
FINE_KOEF_SET_DOCTOR,
DOP_TARIF,
DOP_SUM,
DOP_CODE_USL)
 AS 
select zz.ID, zz.zs_id, zz.DATE_1, zz.DATE_2, iif(z.date_2 >= '01.05.2018', zz.code_spec_v021, zz.code_spec), zz.CODE_prof, zz.usl_type,
       zz.OTD_PROF, zz.IS_CHIELD,
       zz.DS, zz.DS2, zz.SRVPLACE, zz.CODE_USL, zz.K_USLF, 
       zz.PHYS_ID, z.mes_code, 
       iif(zz.phys_id = '', '', (select fio from doctors_fio where id = zz.phys_id)) as fio,
       iif(z.date_2 >= '01.05.2018', (select name from h_spec_v021 where code = zz.code_spec_v021), (select name from h_spec_v015 where code = zz.code_spec)) as spec_name, pl.name as srvplace,
       zz.dcount,zz.ksg, iif(zz.phys_id = '', '', (select pcod from doctors_fio where id = zz.phys_id)) as pcod,
       zz.tar_usl, coalesce(zz.pmd_close,0), zz.sum_uslf, zz.orit, zz.mp,
       (select first 1 name from h_usl u where u.code = zz.code_usl
        and u.q_u containing cast(z.q_u as varchar(1)) and u.payment_type_id = z.payment_type_id
        and z.date_1 between u.datebeg and u.dateend),
       z.q_u, z.target, z.disp_stage, z.date_1, zz.tooth_id, coalesce(zz.zachet,0), coalesce(ZZ.is_no_get_usl,0),
       zz.ksg_base, zz.sum_base, zz.tar_base, zz.kskp_base, zz.comment_local, zz.podr,
       iif((coalesce(zz.tooth_id,0) = 0 or coalesce(zz.tooth_list,'')='') and z.q_u = 4, zz.tooth_id, zz.tooth_list),
       o.name, p.fam, p.im, p.ot, p.dr, p.phones, p.email, q.name, zz.ksg_criterion, zz.zsd_id,
       zz.p_cel, zz.dn, zz.profil_k, zz.p_per, zz.ds_onk, zz.ksg_criterion2, zz.code_spec_v021,
       p.ser_sp, p.num_sp, zz.c_zab, z.fine_koef_set_doctor, zz.dop_tarif, zz.dop_sum, zz.dop_code_usl
from ZSd zz
     left join zs z on z.id = zz.zs_id
     left join patients p on p.id = z.patient_id
--     left join h_spec_v015 cs on cs.code = zz.code_spec
--     left join h_spec_v021 cs2 on cs2.code = zz.code_spec_v021
     left join h_srvplace pl on pl.id = zz.srvplace
     left join h_code_otd o on o.code = zz.code_prof
     left join h_q_u q on q.id = z.q_u
;

/* Create index... */
CREATE INDEX KLADR_CITY_IDX1 ON KLADR_CITY(CODE);

CREATE INDEX KLADR_STREET_IDX1 ON KLADR_STREET(CODE);


/* Create generator... */
CREATE GENERATOR GEN_KLADR_CITY_ID;

CREATE GENERATOR GEN_KLADR_STREET_ID;


/* Create Primary Key... */
ALTER TABLE KLADR_CITY ADD CONSTRAINT PK_KLADR_CITY PRIMARY KEY (ID);

ALTER TABLE KLADR_STREET ADD CONSTRAINT PK_KLADR_STREET PRIMARY KEY (ID);

/* Alter Procedure... */
/* empty dependent procedure body */
/* Clear: SP_CALC_ALL_CH for: SP_CALC_ALL */

ALTER PROCEDURE SP_CALC_ALL_CH(HDR_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* empty dependent procedure body */
/* Clear: SP_ZS_SET_ZACHET for: SP_CALC_ALL */
ALTER PROCEDURE SP_ZS_SET_ZACHET(HDR_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* empty dependent procedure body */
/* Clear: SP_ZSD_LIST_CREATE for: SP_CALC_ALL */
ALTER PROCEDURE SP_ZSD_LIST_CREATE(ZS_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* Alter (SP_CALC_ALL) */
ALTER PROCEDURE SP_CALC_ALL(ZS_ID INTEGER)
 AS
declare variable TAR DM_MONEY_15_2;
declare variable DATE1 DM_DATE;
declare variable Q_U integer;
declare variable TAR_USL DM_MONEY_15_2;
declare variable TARGET integer;
declare variable IDB integer;
declare variable SUM_USLF DM_MONEY_15_2;
declare variable SEX char(1);
declare variable PTYPE integer;
declare variable AGE_Y integer;
declare variable AGE_GRP integer;
declare variable HDR_ID integer;
declare variable TROMB_CODE DM_CHAR_20;
declare variable TAR_USL_DOP DM_MONEY_15_2;
declare variable SUM_USLF_DOP DM_MONEY_15_2;
begin
  select z.date_2, z.q_u, z.target, p.sex, z.payment_type_id, extract(year from z.date_2) - extract(year from p.dr), z.hdr_id
  from zs z
  join patients p on p.id = z.patient_id
  where z.id = :zs_id
  into :date1, :q_u, :target, :sex, :ptype, :age_y, :hdr_id;

  if (:ptype in (2,3)) then exit;

  if (:target in (9,10,11,12,13,14,15,16,17)) then
  begin
   if ((select coalesce(t.days_cnt,0) from h_target t where t.id = :target) <> 0) then
   begin
    update zsd d
     set d.zachet = 1
     where d.date_1 < (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;

    update zsd d
     set d.zachet = 0
     where d.date_1 >= (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;
   end

   update zsd d
    set d.k_uslf = 0
    where (d.zachet = 1 or d.is_no_get_usl = 1) and d.zs_id = :zs_id;
  end

  update zsd d
    set d.tar_usl = null,
        d.sum_uslf = null,
        d.comment_local = null,
        d.dop_tarif = null,
        d.dop_sum = null
    where d.zs_id = :zs_id;

  update zs z
    set z.tar_usl = null,
        z.sum_usl = null,
        z.sum_uslf = null
    where z.id = :zs_id;

  if ((select coalesce(i.is_nz,0) from invoice i join zs_hdr h on h.name = i.id where h.id = :hdr_id) = 1) then
  begin
    if (target in (9,10,11,13,14,15,16,17)) then exit;

    tar = (select first 1 s.tarif from h_tarif_nz s where s.q_u = iif(:q_u = 4,2,:q_u) and :date1 between s.bp and s.epv);

    if (q_u = 1) then
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id and d.code_usl is null;
    else
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id;

    if (q_u = 4) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = z.dcount*:tar
      where id = :zs_id;
    else
    if (q_u = 1) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = :tar
      where id = :zs_id;
    else
      update zs z
      set z.tar_usl = :tar,
          z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
      where id = :zs_id;
    exit;
  end
   /********************,    ************************/
  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 < '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin

          select first 1 h.tarif, h.tarif
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
                                 and cast(h.code_spec as varchar(10)) = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec = '16' and a.age < 18, '22', b.code_spec), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf;

          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0)
           where b.id = :idb;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end

  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 >= '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          if ((select d.code_usl from zsd d where d.id = :idb) = 'A23.30.099.005') then
          begin
            tar = 1670;
            sum_uslf = 1670*(select d.k_uslf from zsd d where d.id = :idb);
          end
          else
          if ((select d.code_usl from zsd d where d.id = :idb) = 'A23.30.099.006') then
          begin
            tar = 1180;
            sum_uslf = 1180*(select d.k_uslf from zsd d where d.id = :idb);
          end
          else
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (:tar is null) then
          select first 1 h.tarif, h.tarif
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
           join h_tarif_app_spec n on n.name_id = h.name_id
                                 and n.code_spec_v021 = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec_v021 = 39 and a.age < 18, 49, b.code_spec_v021), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf;

          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          tar = null;
          sum_uslf = null;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end  

  /********************************************/
  if (:q_u = 4) then
  begin
    tar = (select s.tarif from h_tarif_stom s where :date1 between s.bp and s.epv);

    update zsd d
    set d.tar_usl = :tar,
        d.sum_uslf = d.k_uslf*:tar
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = :tar,
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if (:q_u = 5) then
  begin
--    if (:date1 >= '01.01.2018') then tromb_code = 'A25.30.036';
--    else tromb_code = 'A25.30.035';
    tromb_code = coalesce((select first 1 code_usl from zsd d where d.zs_id = :zs_id and coalesce(code_usl, '') <> ''),'');

    tar = (select s.tarif from h_tarif_smp s where :date1 between s.bp and s.epv);
    tar_usl = coalesce((select coalesce(u.sumf,0) from h_usl u where u.code = :tromb_code
               and u.q_u containing '5' and :date1 between u.datebeg and u.dateend),0);

    update zsd d
    set d.tar_usl = iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl),
        d.sum_uslf = d.k_uslf*iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl)
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = (select max(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if ((:q_u = 1) and ((select 1 from zs z where coalesce(z.metod_hmp,0) > 0 and id = :zs_id) = 1)) then
  begin
    select first 1 v.tarif
    from zs z
         join h_metod_hmp h on h.code = z.metod_hmp and z.date_2 between h.bp and h.epv
         join h_tarif_vmp v on v.tg = h.tg and z.date_2 between v.bp and v.epv
    where z.id = :zs_id
    into :tar;

    update zs a set
        a.tar_usl = :tar,
        a.sum_uslf = :tar,
        a.ksg = null,
        a.kslp = null
    where a.id = :zs_id;

    update zsd b set
          b.ksg = null,
          b.sum_uslf = :tar,
          b.kskp = 0,
          b.tar_usl = :tar
    where b.zs_id = :zs_id and coalesce(b.code_usl,'') = '' and b.date_1 = (select min(date_1) from zsd where zs_id = :zs_id and coalesce(code_usl,'') = '');

    exit;
  end

  /********************************************/
  if (:q_u in (1,3) and :date1 < '01.01.2018') then
    execute procedure SP_CALC_STAC(:zs_id);
  else
    if (:q_u in (1,3) and :date1 >= '01.01.2018') then
      execute procedure sp_calc_stac_2018(:zs_id);

  /****************  ***********************************************/
  tar = null;
  sum_uslf = null;
  for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (coalesce(:tar,0) > 0) then
          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          tar = null;
          sum_uslf = null;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;


  /*********************-*********************************/
  if ((:q_u = 2) and (:target in (21,22))) then
  begin
   for select b.id
    from zsd b
    join zs z on z.id = b.zs_id
    where z.id = :zs_id
    into :idb
    do
    begin
      tar = (select first 1 t.tarif
             from zsd d
                  join h_tomo_code c on c.nms_code = d.code_usl
                  join h_tarif_tomo t on t.group_num = c.group_num and d.date_2 between t.bp and t.epv
             where d.id = :idb);

      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf = :tar
      where d.id = :idb;
    end

    update zs z
    set z.tar_usl = (select sum(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;

    exit;
  end
  /******************** - 9  ************************/
  if (:q_u = 2 and :target = 9) then
  begin
    execute procedure sp_calc_app_t09(:zs_id);
    exit;
  end

  /******************** - 10,17  -  ************************/
    if (q_u = 2 and target in (10,17)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_10 d on d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and :age_y between d.y1 and d.y2
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 13  ************************/
    if (q_u = 2 and target = 13) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                           and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_13_17 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.age_grp = a.age_grp
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 14,15  ,  ************************/
    if (q_u = 2 and target in (14,15)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_14_15 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.cat_info = a.cat_info
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
  /******************** - 16  ************************/
    if (q_u = 2 and target = 16) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_16 d on a.date_2 between d.bp and d.epv
                                          and d.sex = :sex
                                          and cast(d.code_usl as varchar(20)) = b.code_usl
                                          and d.age_l <= a.age and d.age_r >= a.age
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0) ,
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
end;

/* Alter (SP_CALC_ALL_CH) */
ALTER PROCEDURE SP_CALC_ALL_CH(HDR_ID INTEGER)
 AS
declare variable ZID integer;
begin

 for select z.id
  from zs z
  where z.hdr_id = :hdr_id
  into :zid
  do
    execute procedure SP_CALC_ALL(:ZID);

  update invoice i
  set i.sumv = (select sum(z.sum_uslf) from zs z where z.hdr_id = :hdr_id),
      i.sump = (select sum(z.sum_usl) from zs z where z.hdr_id = :hdr_id)
  where i.id = (select name from zs_hdr h where h.id = :hdr_id);
end;

/* Alter (SP_GET_REGISTRY_INFO) */
ALTER PROCEDURE SP_GET_REGISTRY_INFO(R_ID INTEGER)
 RETURNS(S DM_CHAR_250)
 AS
declare variable SMO DM_CHAR_250;
declare variable PACIENT DM_CHAR_200;
declare variable DOCTOR DM_CHAR_200;
declare variable DDATE DM_DATE;
declare variable TTIME_START DM_TIME;
declare variable PHONE DM_CHAR_100;
declare variable COMM DM_CHAR_200;
declare variable RESULT DM_CHAR_200;
declare variable TTIME_END DM_TIME;
declare variable IS_SMS DM_INT;
declare variable IS_MAIL DM_INT;
begin
  select p.fio p_fio, coalesce(p.smo,''), d.fio d_fio, r.time_start, r.time_end, r.reg_date, r.komment, p.PHONE_MAIN tel,
         rr.name result, coalesce(r.is_sms,0), coalesce(r.is_mail,0)
  from registry r
       left join v_patients p on p.id = r.patients_id
       join doctors_fio d on d.id = r.doctors_id
       left join h_registry_result rr on rr.id = r.result
  where r.id = :r_id
  into :pacient, :smo, :doctor, :ttime_start, :ttime_end, :ddate, :comm, :phone, :result, :is_sms, :is_mail;

  if (:smo <> '') then
  begin
      s = ': ' || :smo;
      suspend;
  end

  s = ': ' || :pacient;
  suspend;

  s = ': ' || :doctor;
  suspend;

  s = ' : ' || iif(:ddate = current_date, '', :ddate);
  suspend;

  s = ' :  ' || extract(hour from :ttime_start) || ':' || lpad(extract(minute from :ttime_start), 2, '0') || '  ' ||
      extract(hour from :ttime_end) || ':' || lpad(extract(minute from :ttime_end),2,'0');
  suspend;

  s = ' : ' || :phone;
  suspend;

  s = ' : ' || :result || '. ' || iif(:is_sms = 1, ' . ', '') ||iif(:is_mail = 1, ' Email.', '');

  if (s <> '') then
  suspend;
end;

/* Alter (SP_ZS_SET_ZACHET) */
ALTER PROCEDURE SP_ZS_SET_ZACHET(HDR_ID INTEGER)
 AS
declare variable ZS_ID integer;
declare variable DATE1 DM_DATE;
begin
  for select z.id, z.date_1
      from zs z
      where z.hdr_id = :hdr_id
      into :zs_id, :date1
      do
      begin
        update zsd d
         set d.zachet = 1
         where d.zs_id = :zs_id and d.date_1 < :date1;

        execute procedure SP_CALC_ALL(:ZS_ID);
      end
end;

/* Alter (SP_ZSD_LIST_CREATE) */
ALTER PROCEDURE SP_ZSD_LIST_CREATE(ZS_ID INTEGER)
 AS
declare variable TARGET integer;
begin
  target = (select target from zs where id = :zs_id);

  if (exists (select id from zsd where zs_id = :zs_id)) then
   exit;

  if (target = 9) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.code_usl, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, 'Z00.8', 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_09 d on d.stage = z.disp_stage and d.age = extract(year from z.date_1) - extract(year from p.dr)
                                      and d.sex = p.sex and z.date_2 between d.bp and d.epv
       where z.id = :zs_id and d.code_usl is not null and d.tarif is not null;
  end

  if (target in (10,17)) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.usl_code, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, iif(z.age < 3, 'Z00.1', iif(z.age >= 3 and z.age < 15, 'Z00.2', 'Z00.3')), 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_10 d on d.stage = z.disp_stage and d.sex = p.sex
                                          and z.date_2 between d.bp and d.epv
                                          and z.age between d.y1 and d.y2
       where z.id = :zs_id and d.tarif is not null;
  end

  if (target = 13) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.usl_code, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, iif(z.age < 3, 'Z00.1', iif(z.age >= 3 and z.age < 15, 'Z00.2', 'Z00.3')), 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_13_17 d on d.target = z.target
                                          and d.stage = z.disp_stage and d.sex = p.sex
                                          and z.date_2 between d.bp and d.epv
                                          and d.age_grp = z.age_grp
       where z.id = :zs_id and d.tarif is not null;
  end

  if (target in (14,15)) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.usl_code, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, iif(z.age < 3, 'Z00.1', iif(z.age >= 3 and z.age < 15, 'Z00.2', 'Z00.3')),1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_14_15 d on d.target = z.target
                                          and d.stage = z.disp_stage and d.sex = p.sex
                                          and z.date_2 between d.bp and d.epv
                                          and d.cat_info = z.cat_info
       where z.id = :zs_id and d.tarif is not null;
  end

  if (target = 16) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.code_usl, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, 'Z00.8', 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_16 d on z.date_2 between d.bp and d.epv
                                          and d.sex = p.sex
                                          and d.age_l <= z.age and d.age_r >= z.age
       where z.id = :zs_id and d.tarif is not null;
  end

  insert into ZS_DS (DS, DS_TYPE, SECTION, SECTION_ID, PR, IS_TEMP)
    select d.ds, 1, 2, d.id, 0, 1
    from zsd d
    where d.zs_id = :zs_id;

  execute procedure SP_CALC_ALL(:ZS_ID);
end;

/* Creating trigger... */
CREATE TRIGGER H_JOB_BI FOR H_JOB
ACTIVE BEFORE INSERT POSITION 0 
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_h_job_id,1);
end;

CREATE TRIGGER KLADR_CITY_BI FOR KLADR_CITY
ACTIVE BEFORE INSERT POSITION 0 
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_kladr_city_id,1);
end;

CREATE TRIGGER KLADR_STREET_BI FOR KLADR_STREET
ACTIVE BEFORE INSERT POSITION 0 
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_kladr_street_id,1);
end;


