/* Alter View (Drop, Create)... */
/* Drop altered view: V_ONK_NAPR */
DROP VIEW V_ONK_NAPR;

/* Create altered view: V_ONK_NAPR */
/* Create view: V_ONK_NAPR */
CREATE VIEW V_ONK_NAPR(
ID,
NAPR_DATE,
NAPR_V,
MET_ISSL,
NAPR_USL,
ZSD_ID,
NAPR_V_NAME,
MET_ISSL_NAME,
NAPR_USL_NAME)
 AS 
select
    o.id,
    o.napr_date,
    o.napr_v,
    o.met_issl,
    o.napr_usl,
    o.zsd_id,
    n.n_vn,
    m.n_met,
    (select name from h_v001 where code = napr_usl)
from onk_napr o
     LEFT join h_v028 n on n.idvn = o.napr_v
     left join h_v029 m on m.idmet = o.met_issl
;

/* Altering existing trigger... */

ALTER TRIGGER ZSD_BIU0
AS
declare variable mp integer;
declare variable q_u integer;
declare variable tar numeric(15,2);
begin
  q_u = (select q_u from zs where id = new.zs_id);

--  mp = (select mp from doctors_spec s where s.doctor_id = new.phys_id and s.code_spec = new.code_spec);
--   if (:mp is not null) then
--     new.mp = :mp;

--   new.ds_class = (SELECT first 1 MKB_CLASS_NUM FROM H_MKB WHERE CODE = NEW.DS);

  if (new.pmd_close = 1) then
    update zsd
    set pmd_close = 0
    where zs_id = new.zs_id;

  if (new.pmd_close is null) then
    new.pmd_close = 1;

  if ((select z.payment_type_id from zs z where z.id = new.zs_id) in (3,2)) then
  begin
      tar = (select coalesce(u.sumf,0) from h_usl u where u.code = new.code_usl and u.q_u containing :q_u and u.payment_type_id = (select z.payment_type_id from zs z where z.id = new.zs_id));
    
      if (tar > 0) then
      begin
        NEW.sum_uslf = :tar * new.k_uslf;
        NEW.tar_usl = :tar;
      END
  end
--  else
--    if (new.tar_usl = 0 and new.sum_uslf = 0) then new.k_uslf = 0;

  if (new.phys_id is not null and new.code_spec_v021 is null) then
    new.code_spec_v021 = (select first 1 s.code_v021 from doctors_spec s where s.doctor_id = new.phys_id);

  if (new.phys_id is not null and new.mp is null and new.code_spec_v021 is not null) then
    new.mp = (select first 1 m.mp from doctors_spec m where m.doctor_id = new.phys_id and m.code_v021 = new.code_spec_v021);

  if (new.phys_id is not null and new.code_prof is null) then
    new.code_prof = (select first 1 p.prof from doctors_prof p where p.doctor_id = new.phys_id and p.code_spec =
                     (select first 1 s.code_v021 from doctors_spec s where s.doctor_id = new.phys_id));

--  if (new.code_spec is not null) then
--    new.code_spec_v021 = (select first 1 s.code_v021 from h_v015_v021 s where cast(s.code_v015 as varchar(10)) = new.code_spec);
--  else
  if (new.code_spec_v021 is not null) then
    new.code_spec = cast((select first 1 s.code_v015 from h_v015_v021 s where s.code_v021 = new.code_spec_v021) as varchar(10));

--  if (inserting) then
--  update or insert into DOCTORS_SPEC (DOCTOR_ID, CODE_V021, MP)
--    values (new.phys_id, new.code_spec_v021, new.mp)
--    matching (DOCTOR_ID, CODE_V021, MP);
end;
