ALTER PROCEDURE SP_CHECK_ANALIZ_USE(ANALIZ_ID INTEGER)
 RETURNS(ERROR_TEXT /* DM_CHAR_250 */ VARCHAR(250))
 AS
 BEGIN SUSPEND; END;


DROP VIEW PATIENTS_FIO;

ALTER PROCEDURE SP_CHECK_OKATO_SMO(INV_ID INTEGER)
 RETURNS(ROWS_UPDATED INTEGER)
 AS
 BEGIN SUSPEND; END;


DROP VIEW REESTR_ZS;

DROP VIEW V_DISPATCHS_PATIENTS;

DROP VIEW V_LAB_ORDER_PRODUCTS;

ALTER PROCEDURE SP_REP_INV_FACT_REESTR(HDR_ID INTEGER)
 RETURNS(FIO VARCHAR(150),
NUM_SP VARCHAR(20),
HIST_NUM VARCHAR(50),
DATE_1 DATE,
USL_CODE VARCHAR(50),
USL_NAME VARCHAR(500),
TARIF /* DM_MONEY_15_2 */ NUMERIC(15,2),
USL_CNT /* DM_NUM_6_2 */ NUMERIC(6,2),
SUMV /* DM_MONEY_15_2 */ NUMERIC(15,2),
TOOTH_ID /* DM_CHAR_250 */ VARCHAR(250),
DS VARCHAR(7),
DOC_FIO VARCHAR(150),
NPP INTEGER)
 AS
 BEGIN SUSPEND; END;

DROP VIEW V_LAB_ORDERS;

ALTER PROCEDURE SP_GET_REGISTRY_INFO(R_ID INTEGER)
 RETURNS(S /* DM_CHAR_250 */ VARCHAR(250))
 AS
 BEGIN SUSPEND; END;

DROP VIEW V_PATIENTS;

DROP VIEW V_PATIENTS_ACTIONS;

DROP VIEW V_PATIENTS_INVOICE;

DROP VIEW V_REESTR;

DROP VIEW V_REMINDER;

DROP VIEW V_ZS;

DROP VIEW V_ZSD;

ALTER TABLE PATIENTS ALTER COLUMN HOUSE TYPE DM_CHAR_15;

ALTER TABLE PATIENTS ALTER COLUMN ROOM TYPE DM_CHAR_15;

/* Create view: PATIENTS_FIO */
CREATE VIEW PATIENTS_FIO(
ID,
FIO,
SMO,
PATIENT_TYPE)
 AS 
select p.id,
    case when (p.ps_prz = 1)
      then (COALESCE(fam,' ')||' '||COALESCE(im,' ')||' '||COALESCE(ot, ' ') ||
      ' (' || coalesce(p.ser_sp || ' ','') || coalesce('','') || ')')
      when (p.ps_prz = 2)
      then (COALESCE(fam,' ')||' '||COALESCE(im,' ')||' '||COALESCE(ot, ' ') ||
      ' (' || coalesce('' || ' ','') || coalesce(p.num_sp,'') || ')')
      else (COALESCE(fam,' ')||' '||COALESCE(im,' ')||' '||COALESCE(ot, ' ') ||
      ' (' || coalesce(p.ser_sp || ' ','') || coalesce(p.num_sp,'') || ')')
      end fio,
      s.name,
      p.patient_type
from patients  p
     left join h_smo s on s.code = p.smo
;

/* Create view: REESTR_ZS */
CREATE VIEW REESTR_ZS(
ID_ZS_HDR,
NAME_ZS_HDR,
PARENT_ID,
FULL_NAME,
IS_DELETE,
M,
Y,
ID_ZS,
Q_U,
MP,
ORDER_V,
CODE_SPEC,
CODE_PROF,
OTD_PROF,
IS_CHIELD,
N_HIST,
DATE_1,
DATE_2,
DS0,
DS1,
DS2,
TAR_USL,
K_USLF,
K_USL,
SUM_USLF,
SUM_USL,
IDSP,
TARGET,
RESULT,
PHYS_ID,
MES_CODE,
PATIENT_ID,
HDR_ID,
ID_PAT,
SS,
FAM,
IM,
OT,
SEX,
DR,
ADRES,
DOC_TYPE,
DOC_SER,
DOC_NUM,
SER_SP,
NUM_SP,
SMO,
OKATO_SMO,
STATUS,
PS_PRZ,
ID_ROP,
FAM_ROP,
IM_ROP,
OT_ROP,
DR_ROP,
SEX_ROP,
SER_SP_ROP,
NUM_SP_ROP,
PAT_ID,
DH_INFO,
SMP_BRIG,
DS3,
DCOUNT,
KSG,
OKATO_R,
OKATO_L,
UID,
CATEGORY,
DISP_STAGE,
DISP_WORK_STATE,
DISP_RESULT,
DISP_H_GROUP,
PRZ,
ENP,
OUTCOME,
CAT_INFO,
FOR_POM,
VID_HMP,
METOD_HMP,
AGE_GRP,
CHIELD_WITH_ROP,
POLIS_TYPE,
ID_CASE,
SMO_OGRN,
SMO_NAM,
VNOV_M,
VNOV_D,
CONTRAGENT_ID,
LPU_1,
NOVOR,
USL_OK,
PODR,
RSLT_D)
 AS 
select h.ID, h.NAME, h.PARENT_ID, h.FULL_NAME, h.IS_DELETE, h.M, h.Y,
       z.ID, z.Q_U, z.MP, z.ORDER_V, z.CODE_SPEC, z.CODE_PROF, z.OTD_PROF, z.IS_CHIELD, z.N_HIST,
       z.DATE_1, z.DATE_2, z.DS0, z.DS1, z.DS2, z.TAR_USL, z.K_USLF, z.K_USL, z.SUM_USLF,
       z.SUM_USL, z.IDSP, z.TARGET, z.RESULT, z.PHYS_ID, z.MES_CODE, z.PATIENT_ID, z.HDR_ID,
       p.ID, p.SS, p.FAM, p.IM, p.OT, p.SEX, p.DR, p.ADRES, p.DOC_TYPE, p.DOC_SER, p.DOC_NUM,
       p.SER_SP, p.NUM_SP, p.SMO, p.OKATO_SMO, p.STATUS, p.PS_PRZ,
       r.ID, r.FAM, r.IM, r.OT, r.DR, r.SEX, r.SER_SP, r.NUM_SP, r.PAT_ID, z.dh_info,
       z.smp_brig, z.ds3, z.dcount, z.ksg, p.okato_r, p.okato_l, z.uid, z.category,
       Z.disp_stage, z.disp_work_state, z.disp_result, z.disp_h_group, Z.prz, p.enp,z.outcome,
       z.cat_info, z.for_pom, z.vid_hmp, z.metod_hmp, z.age_grp, z.chield_with_rop, p.polis_type, Z.id_case,
       p.smo_ogrn, p.smo_nam, z.vnov_m, z.vnov_d, i.contragent_id, I.lpu, p.novor, Z.usl_ok, Z.podr,
       coalesce(z.rslt_d,0)
from zs_hdr h
left join zs z on z.hdr_id = h.id
left join patients p on p.id = z.patient_id
left join pat_rop r on r.pat_id = p.id
LEFT join invoice i on i.id = h.name
where h.is_delete = 0
;

/* Create view: V_DISPATCHS_PATIENTS */
CREATE VIEW V_DISPATCHS_PATIENTS(
ID,
DISPATCH_ID,
PATIENT_ID,
PATIENT_FIO,
DR,
PHONES,
EMAIL,
DISPATCH_NAME,
RESULT_ID,
RESULT_NAME,
NOTE)
 AS 
select DP.ID,
       DP.DISPATCH_ID,
       DP.PATIENT_ID,
       coalesce(p.fam,'') || ' ' || coalesce(p.im,'') || ' ' || coalesce(p.ot,''),
       p.dr,
       p.phones,
       p.email,
       d.name,
       dp.result_id,
       dr.name,
       dp.note
from DISPATCHS_PATIENTS DP
     left join patients p on p.id = dp.patient_id
     left join dispatchs d on d.id = dp.dispatch_id
     LEFT join h_dispatch_results dr on dr.id = dp.result_id
;

/* Create view: V_LAB_ORDER_PRODUCTS */
CREATE VIEW V_LAB_ORDER_PRODUCTS(
ID,
PATIENT_ID,
BIOMATERIAL_DATE,
BIOMATERIAL_TIME,
COMMENTS,
STATUS_ID,
INZ,
DOCTOR_ID,
DOCTOR_FIO,
STATUS_NAME,
SUM_TOTAL,
FAM,
IM,
OT,
DR,
SEX,
ADRES,
LETTER,
LETTER_FORMAT,
ZS_ID,
CODE,
SHORT_NAME)
 AS 
select O.ID, O.PATIENT_ID, O.BIOMATERIAL_DATE, O.BIOMATERIAL_TIME, O.COMMENTS, O.STATUS_ID, O.INZ, O.DOCTOR_ID,
      d.fio doctor_fio, s.name status_name,
      pr.sum_total,
      p.fam, p.im, p.ot, p.dr, iif(p.sex = '', 'M', 'F') sex, p.adres,
      o.letter, o.letter_format, o.zs_id,
      lp.code,
      lp.short_name
from lab_orders o
join lab_order_products pr on pr.order_id = o.id
join lab_products lp on lp.id = pr.product_id
join doctors_fio d on o.doctor_id = d.id
join lab_orders_status s on s.id = o.status_id
join patients p on p.id = o.patient_id
;

/* Create view: V_LAB_ORDERS */
CREATE VIEW V_LAB_ORDERS(
ID,
PATIENT_ID,
BIOMATERIAL_DATE,
BIOMATERIAL_TIME,
COMMENTS,
STATUS_ID,
INZ,
DOCTOR_ID,
DOCTOR_FIO,
STATUS_NAME,
SUM_TOTAL,
FAM,
IM,
OT,
DR,
SEX,
ADRES,
LETTER,
LETTER_FORMAT,
ZS_ID)
 AS 
select O.ID, O.PATIENT_ID, O.BIOMATERIAL_DATE, O.BIOMATERIAL_TIME, O.COMMENTS, O.STATUS_ID, O.INZ, O.DOCTOR_ID,
      d.fio doctor_fio, s.name status_name,
      (select sum(lp.price) from lab_order_products p join lab_products lp on lp.id = p.product_id where p.order_id = o.id)  sum_total,
      p.fam, p.im, p.ot, p.dr, iif(p.sex = '', 'M', 'F') sex, p.adres,
      o.letter, o.letter_format, o.zs_id
from lab_orders o
join doctors_fio d on o.doctor_id = d.id
join lab_orders_status s on s.id = o.status_id
join patients p on p.id = o.patient_id
;

/* Create view: V_PATIENTS */
CREATE VIEW V_PATIENTS(
ID,
SS,
FAM,
IM,
OT,
SEX,
DR,
ADRES,
DOC_TYPE,
DOC_SER,
DOC_NUM,
POLIS_TYPE,
SER_SP,
NUM_SP,
SMO,
OKATO_SMO,
STATUS,
PS_PRZ,
IS_PAID,
JOB,
JOB_ADRES,
POST,
PHONES,
OKATO_R,
OKATO_L,
BPLACE,
ENP,
EMAIL,
ADRES_REG,
MED_HISTORY_NUM,
HIST_NUM,
DOC_PLACE,
DOC_DATE,
SMO_OGRN,
SMO_NAM,
ID_PAC,
INN,
NOVOR,
IS_DELETE,
IS_INSERTING,
ROP_FAM,
ROP_IM,
ROP_OT,
ROP_DR,
ROP_SEX,
ROP_SER_SP,
ROP_NUM_SP,
REG_DATE,
PHONE_MAIN,
INV,
FIO,
PATIENT_TYPE,
SUM_OPL,
PATIENT_TYPE_NAME,
NATIONALITY,
REGION_CODE,
RAYON_CODE,
CITY_CODE,
STREET_CODE,
HOUSE,
HOUSE_IDX,
ROOM,
ROOM_IDX,
ISNOWORKER)
 AS 
select
    p.id,
    p.ss,
    p.fam,
    p.im,
    p.ot,
    p.sex,
    p.dr,
    p.adres,
    p.doc_type,
    p.doc_ser,
    p.doc_num,
    p.polis_type,
    p.ser_sp,
    p.num_sp,
    p.smo,
    p.okato_smo,
    p.status,
    p.ps_prz,
    p.is_paid,
    p.job,
    p.job_adres,
    p.post,
    p.phones,
    p.okato_r,
    p.okato_l,
    p.bplace,
    p.enp,
    p.email,
    p.adres_reg,
    p.med_history_num,
    p.hist_num,
    p.doc_place,
    p.doc_date,
    p.smo_ogrn,
    p.smo_nam,
    p.id_pac,
    p.inn,
    p.novor,
    p.is_delete,
    p.is_inserting,
    r.fam as rop_fam,
    r.im as rop_im,
    r.ot as rop_ot,
    r.dr as rop_dr,
    r.sex as rop_sex,
    r.ser_sp as rop_ser_sp,
    r.num_sp as rop_num_sp,
    (select max(rg.reg_date) from registry rg where rg.patients_id = p.id and rg.is_appeared <> 2) reg_date,
    p.phones,
    P.inv,
    COALESCE(p.fam,' ')||' '||COALESCE(p.im,' ')||' '||COALESCE(p.ot, ' ') fio,
    p.patient_type,
    (select sum(i.sum_opl) from patients_invoice i where i.patient_id = p.id),
    t.name,
    p.nationality,
    P.region_code,
    P.rayon_code,
    P.city_code,
    P.street_code,
    P.house,
    P.house_idx,
    P.room,
    P.room_idx,
    P.isnoworker
from patients p
      left join pat_rop r on r.pat_id = p.id
      left join h_patient_type t on t.id = p.patient_type
WHERE p.is_paid = 0
;

DESCRIBE FIELD SS VIEW V_PATIENTS
'';

DESCRIBE FIELD FAM VIEW V_PATIENTS
'';

DESCRIBE FIELD IM VIEW V_PATIENTS
'';

DESCRIBE FIELD OT VIEW V_PATIENTS
'';

DESCRIBE FIELD SEX VIEW V_PATIENTS
'';

DESCRIBE FIELD DR VIEW V_PATIENTS
' ';

DESCRIBE FIELD ADRES VIEW V_PATIENTS
'';

DESCRIBE FIELD DOC_TYPE VIEW V_PATIENTS
' ';

DESCRIBE FIELD DOC_SER VIEW V_PATIENTS
' ';

DESCRIBE FIELD DOC_NUM VIEW V_PATIENTS
' ';

DESCRIBE FIELD POLIS_TYPE VIEW V_PATIENTS
'  ';

DESCRIBE FIELD SER_SP VIEW V_PATIENTS
'  ';

DESCRIBE FIELD NUM_SP VIEW V_PATIENTS
'  ';

DESCRIBE FIELD SMO VIEW V_PATIENTS
'';

DESCRIBE FIELD JOB VIEW V_PATIENTS
' ';

DESCRIBE FIELD POST VIEW V_PATIENTS
'';

DESCRIBE FIELD PHONES VIEW V_PATIENTS
'';

DESCRIBE FIELD EMAIL VIEW V_PATIENTS
'Email';

DESCRIBE FIELD MED_HISTORY_NUM VIEW V_PATIENTS
' ';

DESCRIBE FIELD INN VIEW V_PATIENTS
'';

DESCRIBE FIELD NOVOR VIEW V_PATIENTS
' ';

DESCRIBE FIELD ROP_FAM VIEW V_PATIENTS
' ';

DESCRIBE FIELD ROP_IM VIEW V_PATIENTS
' ';

DESCRIBE FIELD ROP_OT VIEW V_PATIENTS
' ';

DESCRIBE FIELD REG_DATE VIEW V_PATIENTS
'  ';

DESCRIBE FIELD INV VIEW V_PATIENTS
'';

/* Create view: V_PATIENTS_ACTIONS */
CREATE VIEW V_PATIENTS_ACTIONS(
ID,
PATIENT_ID,
ACTION_ID,
RESULT_ID,
PATIENT_FIO,
PATIENT_DR,
PHONES,
EMAIL,
RESULT_NAME)
 AS 
select A.ID, A.PATIENT_ID, A.ACTION_ID, A.RESULT_ID,
       coalesce(p.fam,'') || ' ' || coalesce(p.im,'') || ' ' || coalesce(p.ot,''),
       p.dr,
       p.phones,
       p.email,
       r.name
from PATIENTS_ACTIONS A
     left join patients p on p.id = a.patient_id
     left join h_action_results r on r.id = a.result_id
;

/* Create view: V_PATIENTS_INVOICE */
CREATE VIEW V_PATIENTS_INVOICE(
ID,
CH_NUM,
CH_DATE,
ZS_ID,
PATIENT_ID,
DISCOUNT,
DISCOUNT_PROC,
SUMV_TOTAL,
USER_ID,
USER_FIO,
SUMV,
SUM_OPL,
SUM_DOLG,
Y,
M,
PATIENT_FIO,
PATIENT_DR,
ACTION_ID)
 AS 
select I.ID, I.CH_NUM, I.CH_DATE, I.ZS_ID, I.PATIENT_ID,
       i.discount, i.discount_proc, i.sumv_total,
       i.user_id, S.fio, I.sumv, i.sum_opl, i.sum_dolg,
       extract(year from i.ch_date), extract(month from i.ch_date),
       coalesce(p.fam,'') || ' ' || coalesce(p.im,'') || ' ' || coalesce(p.ot,''),
       P.DR, i.action_id
from patients_invoice i
LEFT JOIN USERS S ON S.ID = I.user_id
left join patients p on p.id = i.patient_id
;

/* Create view: V_REESTR */
CREATE VIEW V_REESTR(
ID,
Q_U,
MP,
ORDER_V,
CODE_SPEC,
CODE_PROF,
OTD_PROF,
IS_CHIELD,
N_HIST,
DATE_1,
DATE_2,
DS0,
DS1,
DS2,
TAR_USL,
K_USLF,
K_USL,
SUM_USLF,
SUM_USL,
IDSP,
TARGET,
RESULT,
PHYS_ID,
MES_CODE,
PATIENT_ID,
HDR_ID,
DIRECTION_NUM,
DIRECTION_DATE,
DH_INFO,
DCOUNT,
KSG,
SMP_BRIG,
DS3,
UID,
CATEGORY,
PRZ,
DISP_STAGE,
DISP_WORK_STATE,
DISP_RESULT,
DISP_H_GROUP,
OUTCOME,
CAT_INFO,
ID1,
SS,
FAM,
IM,
OT,
SEX,
DR,
ADRES,
DOC_TYPE,
DOC_SER,
DOC_NUM,
SER_SP,
NUM_SP,
SMO,
OKATO_SMO,
STATUS,
PS_PRZ,
IS_PAID,
JOB,
JOB_ADRES,
POST,
PHONES,
OKATO_R,
OKATO_L,
BPLACE,
ENP,
ID2,
NAME,
ID3,
NAME1,
PARENT_ID,
FULL_NAME,
IS_DELETE,
M,
Y,
TEMP_ID,
TABLE_ID,
ID4,
M1,
Y1,
CH_NUM,
CH_DATE,
STATUS_ID,
CONTRAGENT_ID,
IS_MTR,
LPU,
ID5,
ORG_CODE,
SHORT_NAME,
FULL_NAME1,
ADRES1,
OKPO,
INN,
PHONES1,
EMAILS,
WWW,
TYPE_ID,
IS_MES,
OGRN,
BANK,
RS,
KPP,
OKONH,
BIK,
PARENT_ID1,
CONTRACT_NUM,
CONTRACT_DATE)
 AS 
select r.ID, r.Q_U, r.mp, r.ORDER_V, r.CODE_SPEC, r.CODE_PROF, r.OTD_PROF, r.IS_CHIELD, r.N_HIST, r.DATE_1, r.DATE_2,
       r.DS0, r.DS1, r.DS2, r.TAR_USL, r.K_USLF, r.K_USL, r.SUM_USLF, r.SUM_USL, r.IDSP, r.TARGET, r.RESULT, r.PHYS_ID,
       r.MES_CODE, r.PATIENT_ID, r.HDR_ID, r.DIRECTION_NUM, r.DIRECTION_DATE, r.DH_INFO, r.DCOUNT, r.KSG, r.SMP_BRIG,
       r.DS3, r.UID, r.CATEGORY, r.PRZ, r.DISP_STAGE, r.DISP_WORK_STATE, r.DISP_RESULT, r.DISP_H_GROUP, r.OUTCOME,
       r.CAT_INFO, p.ID, p.SS, p.FAM, p.IM, p.OT, p.SEX, p.DR, p.ADRES, p.DOC_TYPE, p.DOC_SER, p.DOC_NUM,
       p.SER_SP, p.NUM_SP, p.SMO, p.OKATO_SMO, p.STATUS, p.PS_PRZ, p.is_paid, p.JOB, p.JOB_ADRES, p.POST, p.PHONES,
       p.OKATO_R, p.OKATO_L, p.BPLACE, p.ENP, ut.id, ut.NAME, h.ID, h.NAME, h.PARENT_ID, h.FULL_NAME, h.IS_DELETE,
       h.M, h.Y, t.TEMP_ID, t.TABLE_ID, i.ID, i.M, i.Y, i.CH_NUM, i.CH_DATE, i.STATUS_ID, i.CONTRAGENT_ID, i.IS_MTR,
       i.LPU, c.ID, c.ORG_CODE, c.SHORT_NAME, c.FULL_NAME, c.ADRES, c.OKPO, c.INN, c.PHONES, c.EMAILS, c.WWW, c.TYPE_ID,
       c.IS_MES, c.OGRN, c.BANK, c.RS, c.KPP, c.OKONH, c.BIK, c.PARENT_ID, c.CONTRACT_NUM, c.CONTRACT_DATE
          from zs r
          left join patients p on p.id=r.patient_id
          left join h_q_u ut on ut.id = r.q_u
          left join zs_hdr h on h.id = r.hdr_id
          left join sys$temp_id t on t.temp_id = h.id
          left join invoice i on i.id = h.name
          left join contragents c on c.org_code = i.lpu                                                                                                               
where h.is_delete = 0    and t.temp_id is not null
order by h.id
;

/* Create view: V_REMINDER */
CREATE VIEW V_REMINDER(
RID,
ID,
TEXT_MESSAGE,
TDATE,
TTIME,
REPEATED_IN,
ACCEPT,
USER_ID,
PATIENT_ID,
REGISTRY_ID,
USER_ACCEPT,
IS_SMS,
RESULT_MESSAGE,
FIO,
USER_FIO,
USER_FIO_ACCEPT,
PHONE,
STATUS,
IS_MAIL,
RESULT,
REPEAT_TIME)
 AS 
select r.id rid, R.id, r.text_message, r.tdate, r.ttime, r.repeated_in, r.accept, r.user_id, r.patient_id,
       r.registry_id, r.user_accept, coalesce(r.is_sms, 0),
       r.result_message, p.fam || ' ' || p.im || ' ' || coalesce(p.ot,'') ||
       iif(coalesce(p.phones,'') <> '' and (coalesce(r.is_mail,0) <> 1),' .' || coalesce(p.phones,''),'') ||
       iif(coalesce(p.email,'') <> '' and coalesce(r.is_mail,0) = 1,' Email:' || coalesce(p.email,''),''),
       u.fio user_fio, u2.fio user_fio_accept,
       p.phones, r.status, coalesce(R.is_mail,0), rr.name result, r.repeat_time
from REMINDER R
left join patients p on p.id = r.patient_id
left join users u on u.id = r.user_id
left join users u2 on u2.id = r.user_accept
left join registry reg on reg.id = r.registry_id
left join h_registry_result rr on rr.id = reg.result
order by r.accept, tdate desc, ttime desc, r.edit_date desc
;

/* Create view: V_ZS */
CREATE VIEW V_ZS(
ID,
Q_U,
MP,
ORDER_V,
CODE_SPEC,
CODE_PROF,
OTD_PROF,
IS_CHIELD,
N_HIST,
DATE_1,
DATE_2,
DS0,
DS1,
DS2,
TAR_USL,
K_USLF,
K_USL,
IDSP,
TARGET,
RESULT,
PATIENT_ID,
FAM,
IM,
OT,
Q_U_NAME,
TARGET_NAME,
SUM_USLF,
HDR_ID,
DIRECTION_NUM,
DIRECTION_DATE,
DH_INFO,
MES_CODE,
SMP_BRIG,
DS3,
DCOUNT,
UID,
PHYS_ID,
CATEGORY,
DISP_STAGE,
DISP_WORK_STATE,
DISP_RESULT,
DISP_H_GROUP,
OUTCOME,
KSG,
CAT_INFO,
IDSP_NAME,
MP_NAME,
ORDER_V_NAME,
DH_INFO_NAME,
CODE_SPEC_NAME,
CODE_PROF_NAME,
IS_CHIELD_NAME,
SMP_BRIG_NAME,
RESULT_NAME,
OUTCOME_NAME,
FOR_POM,
VID_HMP,
METOD_HMP,
AGE_GRP,
CHIELD_WITH_ROP,
FOR_POM_NAME,
REGISTRY_ID,
PAYMENT_TYPE_ID,
PAYMENT_NAME,
REGISTRY_NAME,
SUM_USL,
DOCTOR_FIO,
DOCTOR_COD,
NUM_SP,
IDCASE,
Q_U_2016,
HAS_ERRORS,
CODE_MES1,
COMENTSL,
SMO,
OKATO_SMO,
OKATO_G,
OKATO_P,
SUM_OPL,
N_ZAP,
ZSP_VPOLIS,
ZSP_SPOLIS,
ZSP_NPOLIS,
ZSP_POLIS_BP,
ZSP_POLIS_EP,
ZSP_SMO_OGRN,
ZSP_SMO_CODE,
ZSP_ENP,
ZSP_SEND_DATE,
ZSP_RESP_DATE,
AGE,
DR,
DOC_SER,
DOC_NUM,
SEX,
PODR,
KSLP,
REG_DATE,
AGE_NAME,
M,
Y,
CH_NUM,
INV_STATE,
KSG_NUM,
KSG_PROF_NUM,
NPR_MO,
PER,
VBR,
TAL_D,
TAL_P,
INV,
RSLT_D,
NAZR,
NAZ_SP,
NAZ_V,
NAZ_PMP,
NAZ_PK,
IDSP_NOT_AUTO,
AGE_GRP_NOT_AUTO,
USER_ID,
USER_FIO,
MSE,
BARTHEL_IDX,
CODE_SPEC_V021,
ID_PAC)
 AS 
select z.id,
       z.q_u,
       z.mp,
       z.order_v,
       z.code_spec,
       z.code_prof,
       z.otd_prof,
       z.is_chield,
       z.n_hist,
       z.date_1,
       z.date_2,
       z.ds0,
       z.ds1,
       z.ds2,
       z.tar_usl,
       z.k_uslf,
       z.k_usl,
       z.idsp,
       z.target,
       z.result,  
       z.patient_id,
       p.fam,
       p.im,
       p.ot,
       q_u.name as q_u_name,
       t.name as target_name,
       z.sum_uslf,
       z.hdr_id,
       z.direction_num,
       z.direction_date,
       z.dh_info as dh_info,
       z.mes_code,
       z.smp_brig,
       z.ds3,
       Z.DCOUNT,
       z.uid,
       z.phys_id,
       z.category,
       z.disp_stage,
       z.disp_work_state,
       z.disp_result,
       z.disp_h_group,
       z.outcome,
       z.ksg,
       z.cat_info,
       i.name as idsp_name,
       m.name as mp_name,
       o.name as order_v_name,
       dh.name as dh_info_name,
       iif(z.date_2 >= '01.05.2018', (select name from h_spec_v021 where code = z.code_spec_v021), (select name from h_spec_v015 where code = z.code_spec)) as code_spec_name,
       co.name as code_prof_name,
       iif(z.is_chield = 1, '', '') as is_chield_name,
       sb.name as smp_brig_name,
       r.name as result_name,
       oc.name as outcome_name,
       z.for_pom,
       z.vid_hmp,
       z.metod_hmp,
       z.age_grp,
       z.chield_with_rop,
       fp.name,
       z.registry_id,
       Z.payment_type_id,
       pt.name,
       reg.name,
       z.sum_usl,
       df.fio,
       DF.pcod,
       p.num_sp,  --iif(z.payment_type_id <> 2, p.num_sp, (select ins.ser || ' ' || ins.num from patients_insurance ins where ins.patients_id = p.id and z.date_1 between ins.db and ins.de)),
       z.id_case,
       z.q_u_2016,
       0,--(select first 1 1 from error_list_local err where err.reestr_hdr_id = z.hdr_id and err.uid = z.uid),
       z.mes_code,
       z.comentsl,
       p.smo,
       p.okato_smo,
       p.okato_l,
       p.okato_r,
       z.sum_usl, --(select sum(pi.sum_opl) from patients_invoice pi where pi.zs_id = z.id),
       z.n_zap n_zap,
       zpr.vpolis,
       zpr.spolis,
       zpr.npolis,
       zpr.polis_bp,
       zpr.polis_ep,
       zpr.smo_ogrn,
       zpr.smo_code,
       zpr.enp,
       zp.send_date,
       zpr.resp_date,
       z.age,
       p.dr,
       p.doc_ser,
       p.doc_num,
       p.sex,
       z.podr,
       z.kslp,
       reg.reg_date,
       cast(floor(z.age) as varchar(3)) || '  ' ||
            cast(iif(extract(day from z.date_1) < extract(day from p.dr),
                 iif(extract(month from z.date_1) > extract(month from p.dr), extract(month from z.date_1) - extract(month from p.dr),
                             iif(extract(month from z.date_1) < extract(month from p.dr), 12 - extract(month from p.dr) + extract(month from z.date_1) - 1,
                                 11)),
                 iif(extract(month from z.date_1) > extract(month from p.dr), extract(month from z.date_1) - extract(month from p.dr),
                             iif(extract(month from z.date_1) < extract(month from p.dr), 12 - extract(month from p.dr) + extract(month from z.date_1),
                                   0))) as varchar(2)) || ' ',
       h.m,
       h.y, 
       h.full_name,
       coalesce(inv.status_id,0),
       ksg.ksg_name,
       ksg.prof_name,
       z.npr_mo,
       z.per,
       z.vbr,
       z.tal_d,
       z.tal_p,
       z.inv,
       Z.rslt_d,
       z.nazr,
       z.naz_sp,
       z.naz_v,
       z.naz_pmp,
       z.naz_pk,
       z.idsp_not_auto,
       Z.age_grp_not_auto,
       z.user_id,
       s.fio,
       z.mse,
       z.barthel_idx ,
       z.code_spec_v021,
       z.id_pac
from zs z
join patients p on p.id = z.patient_id
join zs_hdr h on h.id = z.hdr_id
left join invoice inv on inv.id = h.name
left join h_q_u q_u on q_u.id = z.q_u
left join h_target t on t.id = z.target
left join h_idsp i on i.id = z.idsp
left join h_mp m on m.code = z.mp
left join h_order_v o on o.id = z.order_v
left join h_dh_info dh on dh.id = z.dh_info
left join h_spec_v015 cs on cs.code = z.code_spec
left join h_code_otd co on co.code = z.code_prof
left join h_smp_brig sb on sb.id = z.smp_brig
left join h_result r on r.code = z.result
left join h_outcome oc on oc.code = z.outcome
left join h_for_pom fp on fp.code = z.for_pom
left join h_payment_type pt on pt.id = z.payment_type_id
left join v_registry reg on reg.id = z.registry_id
left join doctors_fio df on df.id = z.phys_id
left join zsp zp on zp.zs_id = z.id
left join zsp_resp zpr on zpr.zsp_id = zp.id
left join h_ksg ksg on (cast(ksg.ksg as varchar(50))) = z.ksg and z.q_u = ksg.q_u and z.date_2 between ksg.bp and ksg.epv
left join users s on s.id = z.user_id
where h.is_delete <> 1
;

/* Create view: V_ZSD */
CREATE VIEW V_ZSD(
ID,
ZS_ID,
DATE_1,
DATE_2,
CODE_SPEC,
CODE_PROF,
USL_TYPE,
OTD_PROF,
IS_CHIELD,
DS,
DS2,
SRVPLACE,
CODE_USL,
K_USLF,
PHYS_ID,
MES_CODE,
FIO,
SPEC_NAME,
SRVPLACE1,
DCOUNT,
KSG,
PCOD,
TAR_USL,
PMD_CLOSE,
SUM_USLF,
ORIT,
MP,
USL_NAME,
Q_U,
TARGET,
DISP_STAGE,
DATE_1_ZS,
TOOTH,
ZACHET,
IS_NO_GET_USL,
KSG_BASE,
SUM_BASE,
TAR_BASE,
KSKP_BASE,
COMMENT_LOCAL,
PODR,
TOOTH_LIST,
PROF_NAME,
FAM,
IM,
OT,
DR,
PHONES,
EMAIL,
Q_U_NAME,
KSG_CRITERION,
ZSD_ID,
P_CEL,
DN,
PROFIL_K,
P_PER,
DS_ONK,
KSG_CRITERION2,
CODE_SPEC_V021,
SER_SP,
NUM_SP,
C_ZAB,
FINE_KOEF_SET_DOCTOR,
DOP_TARIF,
DOP_SUM,
DOP_CODE_USL)
 AS 
select zz.ID, zz.zs_id, zz.DATE_1, zz.DATE_2, iif(z.date_2 >= '01.05.2018', zz.code_spec_v021, zz.code_spec), zz.CODE_prof, zz.usl_type,
       zz.OTD_PROF, zz.IS_CHIELD,
       zz.DS, zz.DS2, zz.SRVPLACE, zz.CODE_USL, zz.K_USLF, 
       zz.PHYS_ID, z.mes_code, 
       iif(zz.phys_id = '', '', (select fio from doctors_fio where id = zz.phys_id)) as fio,
       iif(z.date_2 >= '01.05.2018', (select name from h_spec_v021 where code = zz.code_spec_v021), (select name from h_spec_v015 where code = zz.code_spec)) as spec_name, pl.name as srvplace,
       zz.dcount,zz.ksg, iif(zz.phys_id = '', '', (select pcod from doctors_fio where id = zz.phys_id)) as pcod,
       zz.tar_usl, coalesce(zz.pmd_close,0), zz.sum_uslf, zz.orit, zz.mp,
       (select first 1 name from h_usl u where u.code = zz.code_usl
        and u.q_u containing cast(z.q_u as varchar(1)) and u.payment_type_id = z.payment_type_id
        and z.date_1 between u.datebeg and u.dateend),
       z.q_u, z.target, z.disp_stage, z.date_1, zz.tooth_id, coalesce(zz.zachet,0), coalesce(ZZ.is_no_get_usl,0),
       zz.ksg_base, zz.sum_base, zz.tar_base, zz.kskp_base, zz.comment_local, zz.podr,
       iif((coalesce(zz.tooth_id,0) = 0 or coalesce(zz.tooth_list,'')='') and z.q_u = 4, zz.tooth_id, zz.tooth_list),
       o.name, p.fam, p.im, p.ot, p.dr, p.phones, p.email, q.name, zz.ksg_criterion, zz.zsd_id,
       zz.p_cel, zz.dn, zz.profil_k, zz.p_per, zz.ds_onk, zz.ksg_criterion2, zz.code_spec_v021,
       p.ser_sp, p.num_sp, zz.c_zab, z.fine_koef_set_doctor, zz.dop_tarif, zz.dop_sum, zz.dop_code_usl
from ZSd zz
     left join zs z on z.id = zz.zs_id
     left join patients p on p.id = z.patient_id
--     left join h_spec_v015 cs on cs.code = zz.code_spec
--     left join h_spec_v021 cs2 on cs2.code = zz.code_spec_v021
     left join h_srvplace pl on pl.id = zz.srvplace
     left join h_code_otd o on o.code = zz.code_prof
     left join h_q_u q on q.id = z.q_u
;

/* Alter Procedure... */
/* Alter (SP_ADD_PATIENTS_INVOICE) */

ALTER PROCEDURE SP_ADD_PATIENTS_INVOICE(ZS_ID INTEGER)
 RETURNS(INV_ID INTEGER)
 AS
declare variable USL_ID integer;
declare variable USL_CNT DM_NUM_6_2;
declare variable TARIF DM_MONEY_15_2;
declare variable SUM_USLF DM_MONEY_15_2;
declare variable DENT_LIST DM_CHAR_250;
declare variable PAT_ID integer;
declare variable DATE2 DM_DATE;
declare variable DISCOUNT DM_MONEY_15_2;
declare variable ACTION_ID integer;
declare variable WITH_OTHER_DISCOUNTS integer;
begin
  pat_id = (select patient_id from zs where id = :zs_id);

  insert into PATIENTS_INVOICE (CH_DATE, ZS_ID, PATIENT_ID, registry_id, doctor_id, is_temp)
  values (current_date, :ZS_ID, :pat_id, (select registry_id from zs where id = :zs_id), (select phys_id from zs where id = :zs_id), 1)
  returning id
  into :inv_id;

  usl_cnt = 1;
  tarif = 0;
  with_other_discounts = 1;

  for select u.id, d.tar_usl, d.k_uslf, d.sum_uslf, coalesce(d.tooth_list, d.tooth_id), d.date_2
      from zsd d
           join zs h on h.id = d.zs_id
           join h_usl u on u.code = d.code_usl and u.q_u containing h.q_u and u.payment_type_id = h.payment_type_id
      where d.zs_id = :zs_id
--      group by 1, 2
      into :usl_id, :tarif, :usl_cnt, :sum_uslf, :dent_list, :date2
      do
      begin
        select first 1 coalesce((iif(a.discount_type = 0, :sum_uslf/100*a.discount, a.discount)),0), a.id, coalesce(c.with_other_discounts,0)
         from actions_usl a
             join actions c on c.id = a.action_id
         where a.usl_id = :usl_id and :date2 between a.bp and a.ep
         order by 1 desc
         into :discount, :action_id, :with_other_discounts;
        discount = coalesce(:discount,0);
        insert into PATIENTS_INVOICE_USL (HDR_ID, USL_ID, TARIF, K_USLF, DISCOUNT, DISCOUNT_PROC, SUM_USLF, tooth_list)
        values (:INV_ID, :USL_ID, :TARIF, :usl_cnt,
                :discount,100*:discount/:sum_uslf,
                :sum_uslf - :discount,
                :dent_list);

        if (:action_id is not null) then
        update patients_invoice i
         set i.action_id = :action_id
         where i.id = :inv_id;

        if (:with_other_discounts = 1) then
          update patients_invoice i
           set i.discount_type = (select DISCOUNT_TYPE from SP_GET_PATIENTS_DISCOUNT(:PAT_ID)),
               i.discount_proc = (select DISCOUNT from SP_GET_PATIENTS_DISCOUNT(:PAT_ID))
           where i.id = :inv_id;
      end

  suspend;
end;

/* empty dependent procedure body */
/* Clear: SP_CALC_ALL_CH for: SP_CALC_ALL */
ALTER PROCEDURE SP_CALC_ALL_CH(HDR_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* empty dependent procedure body */
/* Clear: SP_ZS_SET_ZACHET for: SP_CALC_ALL */
ALTER PROCEDURE SP_ZS_SET_ZACHET(HDR_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* empty dependent procedure body */
/* Clear: SP_ZSD_LIST_CREATE for: SP_CALC_ALL */
ALTER PROCEDURE SP_ZSD_LIST_CREATE(ZS_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* Alter (SP_CALC_ALL) */
ALTER PROCEDURE SP_CALC_ALL(ZS_ID INTEGER)
 AS
declare variable TAR DM_MONEY_15_2;
declare variable DATE1 DM_DATE;
declare variable Q_U integer;
declare variable TAR_USL DM_MONEY_15_2;
declare variable TARGET integer;
declare variable IDB integer;
declare variable SUM_USLF DM_MONEY_15_2;
declare variable SEX char(1);
declare variable PTYPE integer;
declare variable AGE_Y integer;
declare variable AGE_GRP integer;
declare variable HDR_ID integer;
declare variable TROMB_CODE DM_CHAR_20;
declare variable TAR_USL_DOP DM_MONEY_15_2;
declare variable SUM_USLF_DOP DM_MONEY_15_2;
begin
  select z.date_2, z.q_u, z.target, p.sex, z.payment_type_id, extract(year from z.date_2) - extract(year from p.dr), z.hdr_id
  from zs z
  join patients p on p.id = z.patient_id
  where z.id = :zs_id
  into :date1, :q_u, :target, :sex, :ptype, :age_y, :hdr_id;

  if (:ptype in (2,3)) then exit;

  if (:target in (9,10,11,12,13,14,15,16,17)) then
  begin
   if ((select coalesce(t.days_cnt,0) from h_target t where t.id = :target) <> 0) then
   begin
    update zsd d
     set d.zachet = 1
     where d.date_1 < (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;

    update zsd d
     set d.zachet = 0
     where d.date_1 >= (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;
   end

   update zsd d
    set d.k_uslf = 0
    where (d.zachet = 1 or d.is_no_get_usl = 1) and d.zs_id = :zs_id;
  end

  update zsd d
    set d.tar_usl = null,
        d.sum_uslf = null,
        d.comment_local = null,
        d.dop_tarif = null,
        d.dop_sum = null
    where d.zs_id = :zs_id;

  update zs z
    set z.tar_usl = null,
        z.sum_usl = null,
        z.sum_uslf = null
    where z.id = :zs_id;

  if ((select coalesce(i.is_nz,0) from invoice i join zs_hdr h on h.name = i.id where h.id = :hdr_id) = 1) then
  begin
    if (target in (9,10,11,13,14,15,16,17)) then exit;

    tar = (select first 1 s.tarif from h_tarif_nz s where s.q_u = iif(:q_u = 4,2,:q_u) and :date1 between s.bp and s.epv);

    if (q_u = 1) then
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id and d.code_usl is null;
    else
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id;

    if (q_u = 4) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = z.dcount*:tar
      where id = :zs_id;
    else
    if (q_u = 1) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = :tar
      where id = :zs_id;
    else
      update zs z
      set z.tar_usl = :tar,
          z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
      where id = :zs_id;
    exit;
  end
   /********************,    ************************/
  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 < '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin

          select first 1 h.tarif, h.tarif
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
                                 and cast(h.code_spec as varchar(10)) = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec = '16' and a.age < 18, '22', b.code_spec), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf;

          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0)
           where b.id = :idb;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end

  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 >= '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (:tar is null) then
          select first 1 h.tarif, h.tarif
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
           join h_tarif_app_spec n on n.name_id = h.name_id
                                 and n.code_spec_v021 = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec_v021 = 39 and a.age < 18, 49, b.code_spec_v021), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf;

          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          tar = null;
          sum_uslf = null;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end  

  /********************************************/
  if (:q_u = 4) then
  begin
    tar = (select s.tarif from h_tarif_stom s where :date1 between s.bp and s.epv);

    update zsd d
    set d.tar_usl = :tar,
        d.sum_uslf = d.k_uslf*:tar
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = :tar,
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if (:q_u = 5) then
  begin
--    if (:date1 >= '01.01.2018') then tromb_code = 'A25.30.036';
--    else tromb_code = 'A25.30.035';
    tromb_code = coalesce((select first 1 code_usl from zsd d where d.zs_id = :zs_id and coalesce(code_usl, '') <> ''),'');

    tar = (select s.tarif from h_tarif_smp s where :date1 between s.bp and s.epv);
    tar_usl = coalesce((select coalesce(u.sumf,0) from h_usl u where u.code = :tromb_code
               and u.q_u containing '5' and :date1 between u.datebeg and u.dateend),0);

    update zsd d
    set d.tar_usl = iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl),
        d.sum_uslf = d.k_uslf*iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl)
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = (select max(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if ((:q_u = 1) and ((select 1 from zs z where coalesce(z.metod_hmp,0) > 0 and id = :zs_id) = 1)) then
  begin
    select first 1 v.tarif
    from zs z
         join h_metod_hmp h on h.code = z.metod_hmp and z.date_2 between h.bp and h.epv
         join h_tarif_vmp v on v.tg = h.tg and z.date_2 between v.bp and v.epv
    where z.id = :zs_id
    into :tar;

    update zs a set
        a.tar_usl = :tar,
        a.sum_uslf = :tar,
        a.ksg = null,
        a.kslp = null
    where a.id = :zs_id;

    update zsd b set
          b.ksg = null,
          b.sum_uslf = :tar,
          b.kskp = 0,
          b.tar_usl = :tar
    where b.zs_id = :zs_id and coalesce(b.code_usl,'') = '' and b.date_1 = (select min(date_1) from zsd where zs_id = :zs_id and coalesce(code_usl,'') = '');

    exit;
  end

  /********************************************/
  if (:q_u in (1,3) and :date1 < '01.01.2018') then
    execute procedure SP_CALC_STAC(:zs_id);
  else
    if (:q_u in (1,3) and :date1 >= '01.01.2018') then
      execute procedure sp_calc_stac_2018(:zs_id);

  /****************  ***********************************************/
  if (q_u <> 4) then
  begin
  tar = null;
  sum_uslf = null;
  for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (coalesce(:tar,0) > 0) then
          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          tar = null;
          sum_uslf = null;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
   end

  /*********************-*********************************/
  if ((:q_u = 2) and (:target in (21,22))) then
  begin
   for select b.id
    from zsd b
    join zs z on z.id = b.zs_id
    where z.id = :zs_id
    into :idb
    do
    begin
      tar = (select first 1 t.tarif
             from zsd d
                  join h_tomo_code c on c.nms_code = d.code_usl
                  join h_tarif_tomo t on t.group_num = c.group_num and d.date_2 between t.bp and t.epv
             where d.id = :idb);

      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf = :tar
      where d.id = :idb;
    end

    update zs z
    set z.tar_usl = (select sum(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;

    exit;
  end
  /******************** - 9  ************************/
  if (:q_u = 2 and :target = 9) then
  begin
    execute procedure sp_calc_app_t09(:zs_id);
    exit;
  end

  /******************** - 10,17  -  ************************/
    if (q_u = 2 and target in (10,17)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_10 d on d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and :age_y between d.y1 and d.y2
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 13  ************************/
    if (q_u = 2 and target = 13) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                           and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_13_17 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.age_grp = a.age_grp
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 14,15  ,  ************************/
    if (q_u = 2 and target in (14,15)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_14_15 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.cat_info = a.cat_info
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
  /******************** - 16  ************************/
    if (q_u = 2 and target = 16) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_16 d on a.date_2 between d.bp and d.epv
                                          and d.sex = :sex
                                          and cast(d.code_usl as varchar(20)) = b.code_usl
                                          and d.age_l <= a.age and d.age_r >= a.age
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0) ,
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
end;

/* Alter (SP_CALC_ALL_CH) */
ALTER PROCEDURE SP_CALC_ALL_CH(HDR_ID INTEGER)
 AS
declare variable ZID integer;
begin

 for select z.id
  from zs z
  where z.hdr_id = :hdr_id
  into :zid
  do
    execute procedure SP_CALC_ALL(:ZID);

  update invoice i
  set i.sumv = (select sum(z.sum_uslf) from zs z where z.hdr_id = :hdr_id),
      i.sump = (select sum(z.sum_usl) from zs z where z.hdr_id = :hdr_id)
  where i.id = (select name from zs_hdr h where h.id = :hdr_id);
end;

/* Alter (SP_CHECK_ANALIZ_USE) */
ALTER PROCEDURE SP_CHECK_ANALIZ_USE(ANALIZ_ID INTEGER)
 RETURNS(ERROR_TEXT DM_CHAR_250)
 AS
declare variable PAT_ANALIZ_ID integer;
declare variable PAT_ID integer;
begin
  select first 1 p.id, p.pat_id from patients_analiz p where p.analiz_id = :analiz_id
  into :pat_analiz_id, :pat_id;

  if (pat_analiz_id is not null) then
    error_text = (select p.fio from patients_fio p where p.id = :pat_id) || ' ' ||
                  (select first 1 a.date_out from patients_analiz a where a.analiz_id = :analiz_id);
  suspend;
end;

/* Alter (SP_CHECK_OKATO_SMO) */
ALTER PROCEDURE SP_CHECK_OKATO_SMO(INV_ID INTEGER)
 RETURNS(ROWS_UPDATED INTEGER)
 AS
declare variable PAT_ID integer;
declare variable OKATO type of DM_OKATO;
begin
     rows_updated = 0;

     for select z.id_pat, h.okato from REESTR_ZS z
      join h_smo h on h.code = z.smo
      where z.id_zs_hdr = :inv_id and coalesce(z.okato_smo, '') = ''
      into :pat_id, :okato
      do
      begin
       update patients p set
        p.okato_smo = :okato
        where p.id = :pat_id;
       rows_updated = rows_updated + 1;
      end

      suspend;
end;

/* Alter (SP_GET_REGISTRY_INFO) */
ALTER PROCEDURE SP_GET_REGISTRY_INFO(R_ID INTEGER)
 RETURNS(S DM_CHAR_250)
 AS
declare variable SMO DM_CHAR_250;
declare variable PACIENT DM_CHAR_200;
declare variable DOCTOR DM_CHAR_200;
declare variable DDATE DM_DATE;
declare variable TTIME_START DM_TIME;
declare variable PHONE DM_CHAR_100;
declare variable COMM DM_CHAR_200;
declare variable RESULT DM_CHAR_200;
declare variable TTIME_END DM_TIME;
declare variable IS_SMS DM_INT;
declare variable IS_MAIL DM_INT;
begin
  select p.fio p_fio, coalesce(p.smo,''), d.fio d_fio, r.time_start, r.time_end, r.reg_date, r.komment, p.PHONE_MAIN tel,
         rr.name result, coalesce(r.is_sms,0), coalesce(r.is_mail,0)
  from registry r
       left join v_patients p on p.id = r.patients_id
       join doctors_fio d on d.id = r.doctors_id
       left join h_registry_result rr on rr.id = r.result
  where r.id = :r_id
  into :pacient, :smo, :doctor, :ttime_start, :ttime_end, :ddate, :comm, :phone, :result, :is_sms, :is_mail;

  if (:smo <> '') then
  begin
      s = ': ' || :smo;
      suspend;
  end

  s = ': ' || :pacient;
  suspend;

  s = ': ' || :doctor;
  suspend;

  s = ' : ' || iif(:ddate = current_date, '', :ddate);
  suspend;

  s = ' :  ' || extract(hour from :ttime_start) || ':' || lpad(extract(minute from :ttime_start), 2, '0') || '  ' ||
      extract(hour from :ttime_end) || ':' || lpad(extract(minute from :ttime_end),2,'0');
  suspend;

  s = ' : ' || :phone;
  suspend;

  s = ' : ' || :result || '. ' || iif(:is_sms = 1, ' . ', '') ||iif(:is_mail = 1, ' Email.', '');

  if (s <> '') then
  suspend;
end;

/* Alter (SP_REP_INV_FACT_REESTR) */
ALTER PROCEDURE SP_REP_INV_FACT_REESTR(HDR_ID INTEGER)
 RETURNS(FIO VARCHAR(150),
NUM_SP VARCHAR(20),
HIST_NUM VARCHAR(50),
DATE_1 DATE,
USL_CODE VARCHAR(50),
USL_NAME VARCHAR(500),
TARIF DM_MONEY_15_2,
USL_CNT DM_NUM_6_2,
SUMV DM_MONEY_15_2,
TOOTH_ID DM_CHAR_250,
DS VARCHAR(7),
DOC_FIO VARCHAR(150),
NPP INTEGER)
 AS
declare variable PID integer;
declare variable N integer;
begin
  n = 1;
  npp = 1;

  for select p.id, p.fam || ' ' || p.im || ' ' || p.ot fio
      from zs z
            join zsd d on d.zs_id = z.id
            join h_usl u on u.code = d.code_usl
                    and u.q_u containing cast(z.q_u as varchar(1)) and u.payment_type_id = z.payment_type_id
                    and z.date_1 between u.datebeg and u.dateend  
            join patients p on p.id = z.patient_id
      where z.hdr_id = :HDR_ID
      group by 1,2
      into :pid, :fio
      do
      begin
      for select
          iif(z.payment_type_id <> 2, p.num_sp, (select coalesce(ins.ser, '') || ' ' || ins.num from patients_insurance ins where ins.patients_id = p.id and z.date_1 between ins.db and ins.de)),
          p.hist_num, d.date_1, u.code,
          u.name usl_name, d.k_uslf, u.sumf, d.sum_uslf,
          substring(d.tooth_list from 1 for char_length(d.tooth_list ) - 1), d.ds, doc.fio
            from zs z
            join zsd d on d.zs_id = z.id
            join h_usl u on u.code = d.code_usl
                    and u.q_u containing cast(z.q_u as varchar(1)) and u.payment_type_id = z.payment_type_id
                    and z.date_1 between u.datebeg and u.dateend  
            join patients p on p.id = z.patient_id
            join doctors_fio doc on doc.id = d.phys_id
            where z.hdr_id = :HDR_ID and p.id = :pid
            into :num_sp, :hist_num, :date_1, :usl_code, :usl_name, :usl_cnt, :tarif, :sumv, :tooth_id, :ds, :doc_fio
            do
            begin
              suspend;
--              fio = '';
                npp = null;
            end

      for select
      iif(z.payment_type_id <> 2, pat.num_sp, (select coalesce(ins.ser, '') || ' ' || ins.num from patients_insurance ins where ins.patients_id = pat.id and z.date_1 between ins.db and ins.de)),
          pat.hist_num, l.biomaterial_date, p.code,
          p.name usl_name, 1, lp.sum_total, lp.sum_total,
          null, z.ds1, doc.fio
        from zs z
        join lab_orders l on l.patient_id = z.patient_id and l.biomaterial_date between z.date_1 and z.date_2
        join lab_order_products lp on lp.order_id = l.id
        join lab_products p on p.id = lp.product_id
        join patients pat on pat.id = z.patient_id
            join doctors_fio doc on doc.id = l.doctor_id
        where z.hdr_id = :HDR_ID and pat.id = :pid
        into :num_sp, :hist_num, :date_1, :usl_code, :usl_name, :usl_cnt, :tarif, :sumv, :tooth_id, :ds, :doc_fio
        do
            begin
              suspend;
--              fio = '';
                npp = null;
            end

      fio = '  ';
      sumv = (select sum(z.sum_uslf) from zs z where z.hdr_id = :HDR_ID and z.patient_id = :pid);
      sumv = sumv + (select sum(l.sum_total) from zs z join v_lab_orders l on l.patient_id = z.patient_id and l.biomaterial_date between z.date_1 and z.date_2 where z.hdr_id = :HDR_ID and z.patient_id = :pid);
      suspend;

      n = n + 1;
      npp = n;
      end
end;

/* Alter (SP_ZS_SET_ZACHET) */
ALTER PROCEDURE SP_ZS_SET_ZACHET(HDR_ID INTEGER)
 AS
declare variable ZS_ID integer;
declare variable DATE1 DM_DATE;
begin
  for select z.id, z.date_1
      from zs z
      where z.hdr_id = :hdr_id
      into :zs_id, :date1
      do
      begin
        update zsd d
         set d.zachet = 1
         where d.zs_id = :zs_id and d.date_1 < :date1;

        execute procedure SP_CALC_ALL(:ZS_ID);
      end
end;

/* Alter (SP_ZSD_LIST_CREATE) */
ALTER PROCEDURE SP_ZSD_LIST_CREATE(ZS_ID INTEGER)
 AS
declare variable TARGET integer;
begin
  target = (select target from zs where id = :zs_id);

  if (exists (select id from zsd where zs_id = :zs_id)) then
   exit;

  if (target = 9) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.code_usl, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, 'Z00.8', 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_09 d on d.stage = z.disp_stage and d.age = extract(year from z.date_1) - extract(year from p.dr)
                                      and d.sex = p.sex and z.date_2 between d.bp and d.epv
       where z.id = :zs_id and d.code_usl is not null and d.tarif is not null;
  end

  if (target in (10,17)) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.usl_code, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, iif(z.age < 3, 'Z00.1', iif(z.age >= 3 and z.age < 15, 'Z00.2', 'Z00.3')), 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_10 d on d.stage = z.disp_stage and d.sex = p.sex
                                          and z.date_2 between d.bp and d.epv
                                          and z.age between d.y1 and d.y2
       where z.id = :zs_id and d.tarif is not null;
  end

  if (target = 13) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.usl_code, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, iif(z.age < 3, 'Z00.1', iif(z.age >= 3 and z.age < 15, 'Z00.2', 'Z00.3')), 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_13_17 d on d.target = z.target
                                          and d.stage = z.disp_stage and d.sex = p.sex
                                          and z.date_2 between d.bp and d.epv
                                          and d.age_grp = z.age_grp
       where z.id = :zs_id and d.tarif is not null;
  end

  if (target in (14,15)) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.usl_code, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, iif(z.age < 3, 'Z00.1', iif(z.age >= 3 and z.age < 15, 'Z00.2', 'Z00.3')),1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_14_15 d on d.target = z.target
                                          and d.stage = z.disp_stage and d.sex = p.sex
                                          and z.date_2 between d.bp and d.epv
                                          and d.cat_info = z.cat_info
       where z.id = :zs_id and d.tarif is not null;
  end

  if (target = 16) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.code_usl, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, 'Z00.8', 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_16 d on z.date_2 between d.bp and d.epv
                                          and d.sex = p.sex
                                          and d.age_l <= z.age and d.age_r >= z.age
       where z.id = :zs_id and d.tarif is not null;
  end

  insert into ZS_DS (DS, DS_TYPE, SECTION, SECTION_ID, PR, IS_TEMP)
    select d.ds, 1, 2, d.id, 0, 1
    from zsd d
    where d.zs_id = :zs_id;

  execute procedure SP_CALC_ALL(:ZS_ID);
end;

