/* Create Table... */
CREATE TABLE H_CODE_USL_DOP(ID DM_ID NOT NULL,
CODE DM_CHAR_10,
NAME DM_CHAR_250,
TYPED DM_BOOL,
FUNICUM DM_INT,
FINANS DM_INT,
PARAM_EX DM_CHAR_250,
USL_ID DM_INT,
UF_ID DM_INT,
UF_ID6 DM_INT);



ALTER TABLE H_OKATO ADD TF_CODE DM_INT;

ALTER TABLE H_SMO ADD INN DM_CHAR_20;

ALTER TABLE ZS ADD GUID_ID DM_GUID;

ALTER TABLE ZSD ADD GUID_ID DM_GUID;

ALTER TABLE ZSD ADD ID_DOP DM_INT;

/* Create Procedure... */

CREATE PROCEDURE SP_GEN_GUID_ZSD(HDR_ID INTEGER)
 AS
 BEGIN EXIT; END;

CREATE PROCEDURE SP_GET_CODE_USL_DOP(ZSD_ID INTEGER,
IS_MAIN_RECORD INTEGER)
 RETURNS(CODE_USL_DOP DM_CHAR_20,
CODE_USL_DOP6 DM_CHAR_20)
 AS
 BEGIN SUSPEND; END;


/* Create generator... */

CREATE GENERATOR GEN_H_CODE_USL_DOP_ID;


/* Create Primary Key... */
ALTER TABLE H_CODE_USL_DOP ADD CONSTRAINT PK_H_CODE_USL_DOP PRIMARY KEY (ID);

/* Alter Procedure... */
/* Alter (SP_CH_CREATE) */

ALTER PROCEDURE SP_CH_CREATE(PARENT_ID INTEGER)
 AS
declare variable SMO DM_CHAR_10;
declare variable Z_ID DM_INT;
declare variable CONTR_ID integer;
declare variable CH_NUM integer;
declare variable INV_ID integer;
declare variable H_ID integer;
declare variable TF DM_CHAR_2;
begin
  ch_num = 1;
  tf = (select coalesce(o.tf_code,'') from contragents c join h_okato o on o.code = c.tf_okato where  c.type_id = 1);
  if (:tf = '')  then tf = '83';
--  else tf = lpad(cast(:tf_code as varchar(2)), 2, '0');
  
  if (tf = '83') then
  for select s.parent_code
      from zs_hdr h
      join zs z on z.hdr_id = h.id
      join patients p on p.id = z.patient_id
      left join h_smo s on s.code = p.smo
      where h.id = :parent_id and p.smo starting :tf
      group by 1
      into :smo
      do
      begin
        contr_id = (select id from contragents c where c.org_code = :smo);
        insert into INVOICE (M, Y, CH_NUM, CH_DATE, STATUS_ID, CONTRAGENT_ID, LPU)
            select M, Y, :ch_num, CH_DATE, STATUS_ID, :contr_id, LPU
            from INVOICE i
            where i.id = (select name from zs_hdr h where h.id = :parent_id)
        returning ID
        into :inv_id;

        insert into ZS_HDR (NAME, PARENT_ID, FULL_NAME, M, Y)
            values(:inv_id, :parent_id, ' ' || :ch_num || '  ' || (select CH_DATE from invoice where id = :inv_id),
                   (select m from zs_hdr where id = :parent_id),
                        (select y from zs_hdr where id = :parent_id))
        returning ID
        into :h_id;

        for select z.id
            from zs_hdr h
                join zs z on z.hdr_id = h.id
                join patients p on p.id = z.patient_id
                left join h_smo s on s.code = p.smo
            where z.hdr_id = :parent_id and s.parent_code = :smo
            into :z_id
            do 
            update zs z
            set z.hdr_id = :h_id
            where z.id = :z_id;

        CH_NUM = :CH_NUM + 1;
      end

  if (tf <> '83') then
  for select p.smo
      from zs_hdr h
      join zs z on z.hdr_id = h.id
      join patients p on p.id = z.patient_id
--      left join h_smo s on s.code = p.smo
      where h.id = :parent_id and p.smo starting :tf
      group by 1
      into :smo
      do
      begin
        contr_id = (select id from contragents c where c.org_code = :smo);
        insert into INVOICE (M, Y, CH_NUM, CH_DATE, STATUS_ID, CONTRAGENT_ID, LPU)
            select M, Y, :ch_num, CH_DATE, STATUS_ID, :contr_id, LPU
            from INVOICE i
            where i.id = (select name from zs_hdr h where h.id = :parent_id)
        returning ID
        into :inv_id;

        insert into ZS_HDR (NAME, PARENT_ID, FULL_NAME, M, Y)
            values(:inv_id, :parent_id, ' ' || :ch_num || '  ' || (select CH_DATE from invoice where id = :inv_id),
                   (select m from zs_hdr where id = :parent_id),
                        (select y from zs_hdr where id = :parent_id))
        returning ID
        into :h_id;

        for select z.id
            from zs_hdr h
                join zs z on z.hdr_id = h.id
                join patients p on p.id = z.patient_id
--                left join h_smo s on s.code = p.smo
            where z.hdr_id = :parent_id and p.smo = :smo
            into :z_id
            do 
            update zs z
            set z.hdr_id = :h_id
            where z.id = :z_id;

        CH_NUM = :CH_NUM + 1;
      end

        insert into INVOICE (M, Y, CH_NUM, CH_DATE, STATUS_ID, CONTRAGENT_ID, LPU, IS_MTR)
            select M, Y, :ch_num, CH_DATE, STATUS_ID, NULL, LPU, 1
            from INVOICE i
            where i.id = (select name from zs_hdr h where h.id = :parent_id)
        returning ID
        into :inv_id;

        insert into ZS_HDR (NAME, PARENT_ID, FULL_NAME, M, Y)
            values(:inv_id, :parent_id, ' ' || :ch_num || '  ' || (select CH_DATE from invoice where id = :inv_id) ||  ' ()',
                  (select m from zs_hdr where id = :parent_id),
                        (select y from zs_hdr where id = :parent_id))
        returning ID
        into :h_id;

        for select z.id
            from zs_hdr h
                join zs z on z.hdr_id = h.id
                join patients p on p.id = z.patient_id
            where z.hdr_id = :parent_id and ((coalesce(p.smo,'') <> '' and coalesce(p.smo,'') not starting :tf) and p.num_sp <> '0000000000000000')
            into :z_id
            do 
            update zs z
            set z.hdr_id = :h_id
            where z.id = :z_id;

        insert into INVOICE (M, Y, CH_NUM, CH_DATE, STATUS_ID, CONTRAGENT_ID, LPU)
            select M, Y, :ch_num, CH_DATE, STATUS_ID, 2147483647, LPU
            from INVOICE i
            where i.id = (select name from zs_hdr h where h.id = :parent_id)
        returning ID
        into :inv_id;

        insert into ZS_HDR (NAME, PARENT_ID, FULL_NAME, M, Y)
            values(:inv_id, :parent_id, ' ' || :ch_num || '  ' || (select CH_DATE from invoice where id = :inv_id) ||  ' (/)',
                  (select m from zs_hdr where id = :parent_id),
                        (select y from zs_hdr where id = :parent_id))
        returning ID
        into :h_id;

        for select z.id
            from zs_hdr h
                join zs z on z.hdr_id = h.id
                join patients p on p.id = z.patient_id
            where z.hdr_id = :parent_id and ((coalesce(p.smo,'') = '') or (p.num_sp = '0000000000000000') )
            into :z_id
            do 
            update zs z
            set z.hdr_id = :h_id
            where z.id = :z_id;
end;

/* Alter (SP_REESTR_EXTRACT_FOR_V2018) */
ALTER PROCEDURE SP_REESTR_EXTRACT_FOR_V2018(H_ID INTEGER)
 AS
declare variable D_ID integer;
declare variable ZS_ID integer;
declare variable DATE1 date;
declare variable DATE2 date;
declare variable PHYS_ID integer;
declare variable CODE_SPEC integer;
declare variable HDR_ID integer;
declare variable STAGE integer;
begin
for select h.id
    from zs_hdr h
    where h.id = :h_id or (h.parent_id = :h_id)
    into :hdr_id
    do
    begin
      update zs z
       set z.vb_p = 1
       where z.hdr_id = :hdr_id and (select count(id) from zsd d where d.zs_id = z.id and z.q_u in (1,3) and coalesce(d.code_usl,'') = '') > 1;
      /******************************************************************/
      for select d.id, z.id, d.date_1, d.date_2
          from zs z
               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u in (1,3) and coalesce(d.code_usl,'') = ''
          into :d_id, :zs_id, :date1, :date2
          do
          begin
            update zsd d
             set d.zsd_id = :d_id
             where d.id = :d_id;
    
            update zsd d
             set d.zsd_id = :d_id
             where d.zs_id = :zs_id and coalesce(d.code_usl,'') <> ''
                   and d.date_1 between :date1 and :date2
                   and not exists(select id from zsd d2 where d2.zs_id = :zs_id and coalesce(d2.code_usl,'') = '' and d2.date_1 = :date2);
          end

      for select d.id, z.id, d.date_1, d.date_2
          from zs z
               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u in (1,3) and not exists(select dd.id from zsd dd where dd.zs_id = z.id and coalesce(dd.code_usl,'') = '')
          order by d.ksg desc
          into :d_id, :zs_id, :date1, :date2
          do
          begin
            update zsd d
             set d.zsd_id = :d_id
             where d.id = :d_id;
    
            update zsd d
             set d.zsd_id = :d_id
             where d.zs_id = :zs_id and coalesce(d.code_usl,'') <> ''
                   and d.date_1 between :date1 and :date2
                   and not exists(select id from zsd d2 where d2.zs_id = :zs_id and coalesce(d2.code_usl,'') = '' and d2.date_1 = :date2)
                   and d.ksg is null;
          end
      /***********  ***********************************************/
      for select z.id, d.phys_id, d.code_spec, d.date_1, d.date_2
          from zs z
               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u in (2,4,5) and z.target not in (9,10,11,12,13,14,15,16,17,21,22)
          group by 1,2,3,4,5
          into :zs_id, :phys_id, :code_spec, :date1, :date2
          do
          begin
            d_id = (select first 1 id from zsd d where d.zs_id = :zs_id and d.phys_id = :phys_id and d.code_spec = :code_spec and d.date_1 = :date1 and d.date_2 = :date2);
    
            update zsd d
             set d.zsd_id = :d_id
             where d.zs_id = :zs_id and d.date_1 between :date1 and :date2 and d.phys_id = :phys_id and d.code_spec = :code_spec;
            d_id = null;
          end
      /***********  ***********************************************/
      for select z.id, z.disp_stage
          from zs z
--               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u in (2) and z.target in (9,10,11,12,13,14,15,16,17) --and d.code_usl in ('1','16')
          group by 1,2
          into :zs_id, :stage
          do
          begin
            d_id = (select first 1 id from zsd d where d.zs_id = :zs_id and (d.code_usl in ('1','16','66','67','68','69') or :stage = 2) order by d.date_1);
            update zsd d
             set d.zsd_id = :d_id
             where d.zs_id = :zs_id;
            d_id = null;
          end
      /***********-***********************************************/
      for select z.id
          from zs z
--               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u = 2 and z.target in (21,22)
          group by 1
          into :zs_id
          do
          begin
            d_id = (select first 1 id from zsd d where d.zs_id = :zs_id order by d.date_1);
            update zsd d
             set d.zsd_id = :d_id
             where d.zs_id = :zs_id;
            d_id = null;
          end
    end
end;

/* Restore proc. body: SP_GEN_GUID_ZSD */
ALTER PROCEDURE SP_GEN_GUID_ZSD(HDR_ID INTEGER)
 AS
declare variable ZID integer;
begin
  for select id
      from zs z
      where hdr_id = :hdr_id
      into :zid
      do
      begin
        update zsd d
         set d.guid_id = uuid_to_char(gen_uuid())
         where d.zs_id = :zid and d.guid_id is null;
        update zsd d
         set d.id_dop = gen_id(gen_zsd_id,1)
         where d.zs_id = :zid and d.id_dop is null;
        update zs z2
         set z2.guid_id = uuid_to_char(gen_uuid())
         where z2.id = :zid and z2.guid_id is null;
      end
end;

/* Restore proc. body: SP_GET_CODE_USL_DOP */
ALTER PROCEDURE SP_GET_CODE_USL_DOP(ZSD_ID INTEGER,
IS_MAIN_RECORD INTEGER)
 RETURNS(CODE_USL_DOP DM_CHAR_20,
CODE_USL_DOP6 DM_CHAR_20)
 AS
declare variable DET integer;
declare variable CODE_USL DM_CHAR_20;
declare variable Q_U integer;
declare variable DIAL integer;
declare variable ZS_ID integer;
begin
  select iif((z.date_2 - p.dr) < 18, 1, 0), iif((coalesce(d.ksg,'') <> '') or (:is_main_record = 1), '', d.code_usl), z.q_u, z.id
   from zs z
        join zsd d on d.zs_id = z.id
        join patients p on p.id = z.patient_id
   where d.id = :zsd_id
   into :det, :code_usl, :q_u, :zs_id;

  if (exists(select first 1 id from zsd d where d.zs_id = :zs_id and d.code_usl starting 'A18.30')) then dial = 2;
  else dial = 1;

  if (coalesce(:code_usl,'') = '') then
  begin
      select d.uf_id, d.uf_id6
       from h_code_usl_dop d
       where d.typed = :det and d.param_ex not containing 'MEDUS'
             and d.funicum = iif(:q_u = 2,1,2)
             and d.param_ex containing 'DIAL=' || cast(:dial as char)
       into :code_usl_dop, :code_usl_dop6;
  end
  else
  begin
       code_usl = replace(code_usl, '', 'A');
       select d.uf_id, d.uf_id6
       from h_code_usl_dop d
       where d.typed = :det and (d.param_ex containing :code_usl || ','
                                 or d.param_ex containing :code_usl || '}')
             and d.funicum = iif(:q_u = 2,1,2)
             and d.param_ex containing 'DIAL=' || cast(:dial as char)
       into :code_usl_dop, :code_usl_dop6;
  end
  suspend;
end;

/* Creating trigger... */
CREATE TRIGGER H_CODE_USL_DOP_BI FOR H_CODE_USL_DOP
ACTIVE BEFORE INSERT POSITION 0 
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_h_code_usl_dop_id,1);
end;


