create or alter procedure SP_CALC_STAC_KSKP_2019 (
    IDA integer,
    IDB integer,
    KSG DM_CHAR_20,
    CL_CNT integer)
returns (
    KSKP type of DM_NUM_3_2)
as
declare variable KSKP1 type of DM_NUM_3_2;
declare variable KSKP2 type of DM_NUM_3_2;
declare variable KSKP3 type of DM_NUM_3_2;
declare variable KSKP4 type of DM_NUM_3_2;
declare variable KSKP5 type of DM_NUM_3_2;
declare variable KSKP6 type of DM_NUM_3_2;
declare variable KSKP7 type of DM_NUM_3_2;
declare variable KSLP12 DM_NUM_3_2;
declare variable KSLP13 DM_NUM_3_2;
declare variable KSLP14 DM_NUM_3_2;
begin

 kskp6 = 1;

 select
       --    
       iif((a.q_u = 1) and (a.age < 1) and ((select first 1 d.ksg from h_ksg_dop d where d.type_num = 2 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null),
           (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 1 and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 1) and (a.age >= 1) and (a.age < 4), (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 2  and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 1) and (a.age < 4 and a.age < 18 and coalesce(a.chield_with_rop,0) = 1), (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 3  and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 1) and (a.age >= 75) and ((select first 1 d.ksg from h_ksg_dop d where d.type_num = 3 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 4  and a.date_2 between t.bp and t.epv), 1),    -- 4
       iif((a.q_u = 1) and (a.ds1 <> 'R54' and a.ds2 = 'R54' and exists(select first 1 id from zsd b where b.zs_id = a.id and b.profil_k = 16) and
           ((select first 1 d.ksg from h_ksg_dop d where d.type_num = 4 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null)),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 5  and a.date_2 between t.bp and t.epv), 1), --5
       iif((a.q_u = 3) and exists(select b.code_usl from zsd b where b.zs_id = a.id and b.code_usl in ('A25.20.004.001', 'A11.20.019', 'A11.20.028')),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 69  and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 3) and exists(select b.code_usl from zsd b where b.zs_id = a.id and b.code_usl in ('A11.20.017.001')),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 74  and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 3) and exists(select b.code_usl from zsd b where b.zs_id = a.id and b.code_usl in ('A11.20.030.001')),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 75  and a.date_2 between t.bp and t.epv), 1)
  from zs a
  join patients p on p.id = a.patient_id
  left join zs_hdr h on h.id = a.hdr_id
  left join invoice i on i.id = h.name
  where a.id = :ida
  into :kskp1, :kskp2, :kskp3, :kskp4, :kskp5, :kslp12, :kslp13, :kslp14;

     if (((select z.q_u from zs z where id = :ida)) = 1) then
     begin
         if (idb is not null) then
          select
                --  
                case
                  when (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) > 30 and ((select d.ksg from h_ksg_dop d where d.type_num = 5 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null)) then
                        case
                          when (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - coalesce(b.orit,0)) >= coalesce(b.orit,0) then 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 30) * 0.25 / 30
                          else 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 30) * 0.4 / 30
                        end
                  when (b.k_uslf > 45 and ((select d.ksg from h_ksg_dop d where d.type_num = 5 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is not null)) then
                        case
                          when (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - coalesce(b.orit,0)) >= coalesce(b.orit,0) then 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 45) * 0.25 / 45
                          else 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 45) * 0.4 / 45
                        end
                  else 1
                end
           from zs a
           join zsd b on a.id = b.zs_id
           where b.id = :idb
           into :kskp6;
    
    
         kskp = kskp1 + (kskp2-1) + (kskp3-1) + (kskp4-1) + (kskp5-1);
         if (kskp > 1.8) then
          kskp = 1.8;
         kskp = kskp + (kskp6-1);
         
         delete from kslp_koef where zs_id = :ida and ksg = :ksg;
         
         if (:kskp1 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (1, :kskp1, :ida, :ksg);
         if (:kskp2 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (2, :kskp2, :ida, :ksg);
         if (:kskp3 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (3, :kskp3, :ida, :ksg);
         if (:kskp4 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (4, :kskp4, :ida, :ksg);
         if (:kskp5 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (5, :kskp5, :ida, :ksg);
         if (:kskp6 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (6, :kskp6, :ida, :ksg);
    end
    else
    begin
      delete from kslp_koef where zs_id = :ida and ksg = :ksg;
         
     if (:kslp12 <> 1) then
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
            values (69, :kslp12, :ida, :ksg);
     if (:kslp13 <> 1) then
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
            values (74, :kslp13, :ida, :ksg);
     if (:kslp14 <> 1) then
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
            values (75, :kslp14, :ida, :ksg);

     kskp = kslp12 + (kslp13-1) + (kslp14-1);
    end
    suspend;        
end;

