/* Alter (SP_REP_DIALIZ_74) */
ALTER PROCEDURE SP_REP_DIALIZ_74(Y INTEGER,
M1 INTEGER,
M2 INTEGER,
Q_U INTEGER)
 RETURNS(SMO VARCHAR(10),
SUM1 NUMERIC(18,2),
TAR DM_MONEY_15_2,
TAR_DOP DM_MONEY_15_2,
CODE_USL DM_CHAR_20)
 AS
BEGIN
  FOR
    select iif(p.smo in ('74057','74053'),'74057',p.smo),
           d.code_usl,
           d.tar_usl, d.dop_tarif, sum(d.k_uslf)
     from zs z
          left join zs_hdr h on h.id = z.hdr_id
          left join zsd d on d.zs_id = z.id
          left join patients p on p.id = z.patient_id
    where h.y = :y and h.m between :m1 and :m2
          and z.q_u = :q_u
          and p.smo in ('74057','74053', '74003')
          and  d.code_usl in ('A18.05.002.001', 'A18.05.002.002', 'A18.05.011')
          and h.is_delete <> 1
    group by 1,2,3,4
    INTO :SMO,
         :code_usl,
         :tar,
         :tar_dop,
         :SUM1
  DO
  BEGIN
    SUSPEND;
  END
END;

/* Alter (SP_REP_DIALIZ_74_ALL) */
ALTER PROCEDURE SP_REP_DIALIZ_74_ALL(Y INTEGER,
M1 INTEGER,
M2 INTEGER)
 RETURNS(SMO VARCHAR(10),
SUM1 NUMERIC(18,2))
 AS
BEGIN
  FOR
    select iif(p.smo in ('74057','74053'), '74057', p.smo),
           sum(z.sum_uslf)
     from zs z
          left join zs_hdr h on h.id = z.hdr_id
          left join patients p on p.id = z.patient_id
    where h.y = :y and h.m between :m1 and :m2
          and h.is_delete <> 1
    group by 1
    INTO :SMO,
         :SUM1
  DO
  BEGIN
    SUSPEND;
  END
END;

/* Alter (SP_REP_DIALIZ_74_KSG) */
ALTER PROCEDURE SP_REP_DIALIZ_74_KSG(Y INTEGER,
M1 INTEGER,
M2 INTEGER)
 RETURNS(SMO VARCHAR(10),
CNT INTEGER,
SUMF DM_MONEY_15_2,
CNT_SHORT INTEGER,
SUMF_SHORT DM_MONEY_15_2)
 AS
BEGIN
  FOR
    select iif(p.smo in ('74057','74053'),'74057',p.smo),
           count(distinct (iif(z.k_uslf > 3, z.id, null))),
           sum(iif(z.k_uslf > 3, d.sum_uslf, 0)),
           count(distinct (iif(z.k_uslf <= 3, z.id, null))),
           sum(iif(z.k_uslf <= 3, d.sum_uslf, 0))
     from zs z
          left join zs_hdr h on h.id = z.hdr_id
          left join zsd d on d.zs_id = z.id
          left join patients p on p.id = z.patient_id
    where h.y = :y and h.m between :m1 and :m2
          and d.ksg = 'ds18.002'
          and p.smo in ('74057','74053', '74003')
          and h.is_delete <> 1
    group by 1
    INTO :SMO,
         :CNT,
         :sumf,
         :cnt_short,
         :sumf_short
  DO
  BEGIN
    SUSPEND;
  END
END;


