ALTER TABLE H_USL_PARAMS ADD XLS_ROW DM_CHAR_10;

ALTER TABLE H_USL_PARAMS ADD XLS_COL DM_CHAR_10;

ALTER TABLE PATIENTS ADD USER_ID DM_INT;

/* Create Procedure... */

CREATE PROCEDURE SP_GET_PROTOCOL_FOR_XLS(PAT_ANALIZ_ID INTEGER,
ROOT_ID INTEGER)
 RETURNS(TEXT_STR VARCHAR(1000),
PARAM_STR VARCHAR(250),
MIN_VALUE NUMERIC(15,2),
MAX_VALUE NUMERIC(15,2),
RESULT_NUM INTEGER,
XLS_ROW DM_CHAR_10,
XLS_COL DM_CHAR_10)
 AS
 BEGIN SUSPEND; END;


/* Alter View (Drop, Create)... */
/* Drop altered view: V_PATIENTS_ANALIZ_PARAMS */
ALTER PROCEDURE SP_GET_PROTOCOL_USL(PAT_ANALIZ_ID INTEGER,
ROOT_ID INTEGER)
 RETURNS(TEXT_STR VARCHAR(1000),
PARAM_STR VARCHAR(250),
MIN_VALUE NUMERIC(15,2),
MAX_VALUE NUMERIC(15,2),
RESULT_NUM INTEGER)
 AS
 BEGIN SUSPEND; END;

ALTER PROCEDURE SP_GET_PROTOCOL_USL_V2(PAT_ANALIZ_ID INTEGER,
ROOT_ID INTEGER)
 RETURNS(TEXT_STR VARCHAR(1000))
 AS
 BEGIN SUSPEND; END;

ALTER PROCEDURE SP_GET_PROTOCOL_USL_V3(PAT_ANALIZ_ID INTEGER,
ROOT_ID INTEGER)
 RETURNS(TEXT_STR VARCHAR(1000))
 AS
 BEGIN SUSPEND; END;

DROP VIEW V_PATIENTS_ANALIZ;

DROP VIEW V_PATIENTS_ANALIZ_PARAMS;

/* Create altered view: V_PATIENTS_ANALIZ_PARAMS */
/* Create view: V_PATIENTS_ANALIZ_PARAMS */
CREATE VIEW V_PATIENTS_ANALIZ_PARAMS(
ID,
PARAM_ID,
KOL_VAL,
HDR_ID,
H_USL_PARAMS_NORM_ID,
PARAM_NAME,
PARAM_PARENT_ID,
USL_ID,
PARAM_UNIT,
MIN_VALUE,
MAX_VALUE,
CATEGORY_NAME,
SEX,
RESULT_TEXT,
CAPTION,
RESULT_NUM,
MEANING_NAME,
MEANING_IS_NORM,
PARAM_TYPE,
NOTE,
CATEGORY_NAME_DOP,
NN,
LVL,
XLS_ROW,
XLS_COL)
 AS 
select p.ID,
       p.PARAM_ID,
       p.KOL_VAL,
       p.HDR_ID,
       p.H_USL_PARAMS_NORM_ID,
       par.name param_name,
       par.parent_id,
       par.usl_id,
       PAR.unit_name,
       n.min_value,
       n.max_value,
       c.name,
       coalesce(c.sex,'') sex,
       IIF(par.param_type = 1, iif(p.kol_val < n.min_value, ' ', iif(p.kol_val > n.max_value, ' ', iif(coalesce(p.kol_val,0) <> 0, '', null))),
           (IIF(P.is_norm = 1 and par.param_type = 2, '',null))) result_text,
       iif(p.kol_val < n.min_value, par.caption_decrease, iif(p.kol_val > n.max_value, par.caption_increase, par.caption)) caption,
       iif(par.param_type = 1, iif(p.kol_val < n.min_value, -1, iif(p.kol_val > n.max_value, 1, 0)), P.is_norm-1) result_num,
       iif(par.param_type = 1, p.kol_val, p.meaning_name),
       P.is_norm,
       par.param_type,
       p.note,
       pc.name,
       par.nn,
       par.lvl,
       par.xls_row,
       par.xls_col
from PATIENTS_ANALIZ_PARAMS p
     join patients_analiz a on a.id = p.hdr_id
     left join h_usl_params_norm n on n.id = p.h_usl_params_norm_id
     left join h_age_category c on c.id = n.age_category_id
     left join h_usl_params par on par.id = p.param_id
     left join h_usl_params_category pc on pc.id = n.category_id
order by par.nn, par.id
;

/* Alter empty procedure SP_ZSD_DUPLICATE with new param-list */

ALTER PROCEDURE SP_ZSD_DUPLICATE(ZSD_ID INTEGER,
ZS_ID INTEGER = null)
 AS
 BEGIN EXIT; END;

/* Alter Procedure... */
/* empty dependent procedure body */
/* Clear: SP_CALC_STAC_2018 for: SP_CALC_STAC_KSKP_2019 */
ALTER PROCEDURE SP_CALC_STAC_2018(IDA INTEGER)
 AS
 BEGIN EXIT; END;

/* Alter (SP_CALC_STAC_KSKP_2019) */
ALTER PROCEDURE SP_CALC_STAC_KSKP_2019(IDA INTEGER,
IDB INTEGER,
KSG DM_CHAR_20,
CL_CNT INTEGER)
 RETURNS(KSKP TYPE OF DM_NUM_3_2)
 AS
declare variable KSKP1 type of DM_NUM_3_2;
declare variable KSKP2 type of DM_NUM_3_2;
declare variable KSKP3 type of DM_NUM_3_2;
declare variable KSKP4 type of DM_NUM_3_2;
declare variable KSKP5 type of DM_NUM_3_2;
declare variable KSKP6 type of DM_NUM_3_2;
declare variable KSKP7 type of DM_NUM_3_2;
declare variable KSLP12 DM_NUM_3_2;
declare variable KSLP13 DM_NUM_3_2;
declare variable KSLP14 DM_NUM_3_2;
declare variable ORIT DM_INT;
begin

 kskp6 = 1;

 select
       --    
       iif((a.q_u = 1) and (a.age < 1) and ((select first 1 d.ksg from h_ksg_dop d where d.type_num = 2 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null),
           (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 1 and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 1) and (a.age >= 1) and (a.age < 4), (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 2  and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 1) and (a.age < 4 and a.age < 18 and coalesce(a.chield_with_rop,0) = 1), (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 3  and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 1) and (a.age >= 75) and ((select first 1 d.ksg from h_ksg_dop d where d.type_num = 3 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 4  and a.date_2 between t.bp and t.epv), 1),    -- 4
       iif((a.q_u = 1) and (a.ds1 <> 'R54' and a.ds2 = 'R54' and exists(select first 1 id from zsd b where b.zs_id = a.id and b.profil_k = 16) and
           ((select first 1 d.ksg from h_ksg_dop d where d.type_num = 4 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null)),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 5  and a.date_2 between t.bp and t.epv), 1), --5
       iif((a.q_u = 3) and exists(select b.code_usl from zsd b where b.zs_id = a.id and b.code_usl in ('A11.20.017')),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 316  and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 3) and exists(select b.code_usl from zsd b where b.zs_id = a.id and b.code_usl in ('A11.20.017.083')),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 319  and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 3) and exists(select b.code_usl from zsd b where b.zs_id = a.id and b.code_usl in ('A11.20.030.001')),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 75  and a.date_2 between t.bp and t.epv), 1)
  from zs a
  join patients p on p.id = a.patient_id
  left join zs_hdr h on h.id = a.hdr_id
  left join invoice i on i.id = h.name
  where a.id = :ida
  into :kskp1, :kskp2, :kskp3, :kskp4, :kskp5, :kslp12, :kslp13, :kslp14;

     if (((select z.q_u from zs z where id = :ida)) = 1) then
     begin
         orit = (select sum(d.k_uslf) from zsd d where d.zs_id = :ida and d.code_usl = 'B03.003.005' and d.date_1 between (select d1.date_1 from zsd d1 where d1.id = :idb) and
                                                                                                                 (select d1.date_2 from zsd d1 where d1.id = :idb) );
         if (idb is not null) then
          select
                --  
                case
                  when (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) > 30 and ((select d.ksg from h_ksg_dop d where d.type_num = 5 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null)) then
                        case
                          when (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - coalesce(:orit,0)) >= coalesce(:orit,0) then 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 30) * 0.25 / 30
                          else 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 30) * 0.4 / 30
                        end
                  when (b.k_uslf > 45 and ((select d.ksg from h_ksg_dop d where d.type_num = 5 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is not null)) then
                        case
                          when (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - coalesce(:orit,0)) >= coalesce(:orit,0) then 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 45) * 0.25 / 45
                          else 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 45) * 0.4 / 45
                        end
                  else 1
                end
           from zs a
           join zsd b on a.id = b.zs_id
           where b.id = :idb
           into :kskp6;
    
    
         kskp = kskp1 + (kskp2-1) + (kskp3-1) + (kskp4-1) + (kskp5-1);
         if (kskp > 1.8) then
          kskp = 1.8;
         kskp = kskp + (kskp6-1);
         
         delete from kslp_koef where zs_id = :ida and ksg = :ksg;
         
         if (:kskp1 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (1, :kskp1, :ida, :ksg);
         if (:kskp2 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (2, :kskp2, :ida, :ksg);
         if (:kskp3 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (3, :kskp3, :ida, :ksg);
         if (:kskp4 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (4, :kskp4, :ida, :ksg);
         if (:kskp5 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (5, :kskp5, :ida, :ksg);
         if (:kskp6 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (6, :kskp6, :ida, :ksg);
    end
    else
    begin
      delete from kslp_koef where zs_id = :ida and ksg = :ksg;
         
     if (:kslp12 <> 1) then
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
            values (316, :kslp12, :ida, :ksg);
     if (:kslp13 <> 1) then
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
            values (319, :kslp13, :ida, :ksg);
     if (:kslp14 <> 1) then
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
            values (75, :kslp14, :ida, :ksg);

     kskp = kslp12 + (kslp13-1) + (kslp14-1);
    end
    suspend;        
end;

/* Alter (SP_GET_PROTOCOL_USL) */
ALTER PROCEDURE SP_GET_PROTOCOL_USL(PAT_ANALIZ_ID INTEGER,
ROOT_ID INTEGER)
 RETURNS(TEXT_STR VARCHAR(1000),
PARAM_STR VARCHAR(250),
MIN_VALUE NUMERIC(15,2),
MAX_VALUE NUMERIC(15,2),
RESULT_NUM INTEGER)
 AS
declare variable LVL_ID integer;
declare variable PARENT_ID integer;
declare variable DOP_STR DM_CHAR_250;
declare variable MEANING_NAME DM_CHAR_100;
declare variable PARAM_UNIT DM_CHAR_100;
declare variable NOTE DM_CHAR_250;
begin
  if (:root_id is null) then root_id = (select first 1 p.param_id from V_PATIENTS_ANALIZ_PARAMS p where p.hdr_id = :pat_analiz_id and p.param_parent_id is null);

  for select p.param_id, p.param_parent_id, iif(:root_id is null, '', p.param_name), p.meaning_name, p.param_unit, coalesce(p.note,''),
             p.min_value, p.max_value, p.result_num
   from V_PATIENTS_ANALIZ_PARAMS p
   where p.hdr_id = :pat_analiz_id and coalesce(p.param_parent_id,0) = coalesce(:root_id,0)
   order by p.param_parent_id, p.id
   into :lvl_id, :root_id, :dop_str, :meaning_name, :param_unit, :note, :min_value, :max_value, :result_num
   do
   begin
     text_str = '  ' || coalesce(:text_str,'') || :dop_str || ': ';

     param_str = coalesce(:meaning_name,'') || ' ' || coalesce(:param_unit,'') || iif((:note <> '') and (coalesce(:meaning_name,'') <> ''), ', ','') || coalesce(:note,'');
     param_unit = '';
     note = '';

     if ((select first 1 id from V_PATIENTS_ANALIZ_PARAMS p where p.hdr_id = :pat_analiz_id and p.param_parent_id = :lvl_id) is null) then
     begin
       text_str = coalesce(:text_str,'');
--       param_str = ' <u>' || coalesce(:meaning_name,'') || '</u> ' || coalesce(:param_unit,'') || iif(:note <> '', ', ','') || coalesce(:note,'');
--       param_unit = '';
--       note = '';
     end
     else
     begin
       suspend;
       text_str = '';
       for select TEXT_STR, param_str, min_value, max_value, result_num
        from SP_GET_PROTOCOL_USL(:PAT_ANALIZ_ID, :lvl_id)
         into :dop_str, :param_str, :min_value, :max_value, :result_num
         do
         begin
           text_str = '    ' || coalesce(:text_str,'') || :dop_str || ' ';
           suspend;
           text_str = '';
           param_str = '';
         end
     end

     if (text_str <> '') then
     begin
       suspend;
       text_str = '';
       param_str = '';
     end
   end
end;

/* Alter (SP_GET_PROTOCOL_USL_V2) */
ALTER PROCEDURE SP_GET_PROTOCOL_USL_V2(PAT_ANALIZ_ID INTEGER,
ROOT_ID INTEGER)
 RETURNS(TEXT_STR VARCHAR(1000))
 AS
declare variable LVL_ID integer;
declare variable PARENT_ID integer;
declare variable DOP_STR DM_CHAR_1000;
declare variable MEANING_NAME DM_CHAR_100;
declare variable PARAM_UNIT DM_CHAR_100;
declare variable NOTE DM_CHAR_250;
declare variable PARAM_NAME DM_CHAR_250;
declare variable IS_MAIN integer;
declare variable IS_LAST integer;
declare variable I integer;
begin
  is_last = 0;

  if (:root_id is null) then
  begin
    root_id = (select first 1 p.param_id from V_PATIENTS_ANALIZ_PARAMS p where p.hdr_id = :pat_analiz_id and p.param_parent_id is null);
    is_main = 1;
  end
  else
    is_main = 0;

  for select p.param_id, p.param_parent_id, p.param_name, (p.meaning_name), iif(coalesce(p.param_unit,'') = '', '', ' ' || p.param_unit), coalesce(p.note,'')
   from V_PATIENTS_ANALIZ_PARAMS p
   where p.hdr_id = :pat_analiz_id and coalesce(p.param_parent_id,0) = coalesce(:root_id,0)
   order by p.nn
   into :lvl_id, :root_id, :param_name, :meaning_name, :param_unit, :note
   do
   begin
     if ((select first 1 id from V_PATIENTS_ANALIZ_PARAMS p where p.hdr_id = :pat_analiz_id and p.param_parent_id = :lvl_id) is null) then
     begin
--       if (char_length(:text_str) > 2) then  i = (char_length(:text_str)-2);
--       if (is_last >= 1) then text_str = substring(:text_str from 1 for i) || ', ';
       is_last = is_last + 1;
       text_str = coalesce(:text_str,'') || coalesce(:param_name,'') || ' <u>' || coalesce(:meaning_name,'___________') || '</u>' ||
                  coalesce(:param_unit,'') || '; ';
     end
     else
     begin
       text_str = coalesce(:text_str,'') || coalesce(:param_name,'') || coalesce(' <u>' ||:meaning_name || '</u>','') ||
                  coalesce(:param_unit,'');--|| coalesce(:note,'');
       for select TEXT_STR
        from sp_get_protocol_usl_v2(:PAT_ANALIZ_ID, :lvl_id)
         into :dop_str
         do
         begin
           is_last = 0;
           text_str = coalesce(:text_str,'')  || ': ' || :dop_str;
         end
     end

     if ((:is_main = 1)) then
     begin
       suspend;
       text_str = '';
     end
   end
   suspend;
end;

/* Alter (SP_GET_PROTOCOL_USL_V3) */
ALTER PROCEDURE SP_GET_PROTOCOL_USL_V3(PAT_ANALIZ_ID INTEGER,
ROOT_ID INTEGER)
 RETURNS(TEXT_STR VARCHAR(1000))
 AS
declare variable LVL_ID integer;
declare variable PARENT_ID integer;
declare variable DOP_STR DM_CHAR_1000;
declare variable MEANING_NAME DM_CHAR_100;
declare variable PARAM_UNIT DM_CHAR_100;
declare variable NOTE DM_CHAR_250;
declare variable PARAM_NAME DM_CHAR_250;
declare variable IS_MAIN integer;
declare variable IS_LAST integer;
declare variable I integer;
declare variable LVL integer;
begin
  is_last = 0;

  if (:root_id is null) then
    root_id = (select first 1 p.param_id from V_PATIENTS_ANALIZ_PARAMS p where p.hdr_id = :pat_analiz_id and p.param_parent_id is null);

  for select p.param_id, p.param_parent_id, p.param_name, (p.meaning_name), iif(coalesce(p.param_unit,'') = '', '', ' ' || p.param_unit), coalesce(p.note,''), lvl
   from V_PATIENTS_ANALIZ_PARAMS p
   where p.hdr_id = :pat_analiz_id and coalesce(p.param_parent_id,0) = coalesce(:root_id,0)
   order by p.nn
   into :lvl_id, :root_id, :param_name, :meaning_name, :param_unit, :note, :lvl
   do
   begin
     if ((select first 1 id from V_PATIENTS_ANALIZ_PARAMS p where p.hdr_id = :pat_analiz_id and p.param_parent_id = :lvl_id) is null) then
     begin

       is_last = is_last + 1;
       text_str = coalesce(:text_str,'') || coalesce(:param_name,'') || ' <u>' || coalesce(:meaning_name,'___________') || '</u>' ||
                  coalesce(:param_unit,'') || '; ';

       if (lvl in (2,3)) then
             begin
               suspend;
               text_str = '';
             end
     end
     else
     begin
       text_str = coalesce(:text_str,'') || coalesce(:param_name,'') || coalesce(' <u>' ||:meaning_name || '</u>','') ||
                  coalesce(:param_unit,'');--|| coalesce(:note,'');

       if (lvl in (2)) then
             begin
               suspend;
               text_str = '';
             end

       for select TEXT_STR
        from sp_get_protocol_usl_v3(:PAT_ANALIZ_ID, :lvl_id)
         into :dop_str
         do
         begin
           is_last = 0;
           text_str = coalesce(:text_str,'')  || iif(coalesce(:text_str,'') <> '', ': ','') || :dop_str;

           if (lvl in (1,2,3)) then
             begin
               suspend;
               text_str = '';
             end
         end
     end

   end
   suspend;
end;

/* Alter (SP_REP_SMP_2017) */
ALTER PROCEDURE SP_REP_SMP_2017(Y INTEGER,
M1 INTEGER,
M2 INTEGER)
 RETURNS(ROW_NUM INTEGER,
SUM_USLF NUMERIC(15,2),
CNT INTEGER,
SUM_USLF_DET DM_MONEY_15_2,
CNT_DET INTEGER,
SMO INTEGER,
SUM_USLF_PENS DM_MONEY_15_2,
CNT_PENS INTEGER)
 AS
begin
  for select iif(s.parent_code is null, iif(coalesce(p.smo,'') <> '', p.smo, null), s.parent_code),
             case
              when (COALESCE(d.code_usl, '') <> '') and (z.result not in (407,408,409,410,411,412,413,414,415)) then 15
              when ((z.for_pom = 1) and (z.result not in (407,408,409,410,411,412,413,414,415))) then 12
              when ((z.for_pom = 2) and (z.result not in (407,408,409,410,411,412,413,414,415))) then 11
              when (z.result in (407,408,409,410,411,412,413,414,415)) then 13
             end, 
         sum(d.k_uslf),
         sum(d.sum_uslf),
         sum(iif(z.age < 18,d.k_uslf,0)),
         sum(iif(z.age < 18,d.sum_uslf,0)),
         sum(iif((z.age >= 55 and p.sex = '') or (z.age >= 60 and p.sex = ''),d.k_uslf,0)),
         sum(iif((z.age >= 55 and p.sex = '') or (z.age >= 60 and p.sex = ''),d.sum_uslf,0))
  from zs z
  join zs_hdr h on h.id = z.hdr_id
  join patients p on p.id = z.patient_id
  join zsd d on d.zs_id = z.id
  left join h_smo s on s.code = p.smo
  where z.q_u = 5 and h.y = :y and h.m >= :m1 and h.m <= :m2 and h.is_delete <> 1
        and z.for_pom <> 3
  group by 1,2
  into :smo, :row_num, :cnt, :sum_uslf, :cnt_det, :sum_uslf_det, :cnt_pens, :sum_uslf_pens
  do
  suspend;
end;

ALTER PROCEDURE SP_ZSD_DUPLICATE(ZSD_ID INTEGER,
ZS_ID INTEGER = null)
 AS
declare variable NEW_ZSD_ID integer;
begin
  new_zsd_id = gen_id(gen_zsd_id,1);

  insert into ZSD (ID, ZS_ID, CODE_PROF, IS_CHIELD, DATE_1, DATE_2, DS, CODE_USL, K_USLF, TAR_USL, SUM_USLF, CODE_SPEC,
                 PHYS_ID, OTD_PROF, SRVPLACE, USL_TYPE, DCOUNT, KSG, PMD_CLOSE, ORIT, MP, DS2, DS3, TOOTH_ID,
                 VID_VME, COMENTU, KSKP, EXTRA_INFO, ZACHET, IS_NO_GET_USL, DS_CLASS, KSG_BASE, SUM_BASE, TAR_BASE,
                 KSKP_BASE, COMMENT_LOCAL, PODR, TARIF_TEST, SUMV_TEST, TOOTH_LIST, VBR, DS1_PR, KSG_CRITERION,
                 P_CEL, DN, PROFIL_K, P_PER, DS_ONK, KSG_CRITERION2, KOEF_Z, KOEF_D, KOEF_U, KOEF_UP, BS, REAB,
                 CODE_SPEC_V021, C_ZAB, FINE_KOEF, DOP_TARIF, DOP_SUM, DOP_CODE_USL, ID_DOP)
  select :new_zsd_id, iif(:zs_id is null, ZS_ID, :zs_id), CODE_PROF, IS_CHIELD, DATE_1, DATE_2, DS, CODE_USL, K_USLF, TAR_USL, SUM_USLF, CODE_SPEC, PHYS_ID,
       OTD_PROF, SRVPLACE, USL_TYPE, DCOUNT, KSG, PMD_CLOSE, ORIT, MP, DS2, DS3, TOOTH_ID, VID_VME, COMENTU, KSKP,
       EXTRA_INFO, ZACHET, IS_NO_GET_USL, DS_CLASS, KSG_BASE, SUM_BASE, TAR_BASE, KSKP_BASE, COMMENT_LOCAL, PODR,
       TARIF_TEST, SUMV_TEST, TOOTH_LIST, VBR, DS1_PR, KSG_CRITERION, P_CEL, DN, PROFIL_K, P_PER, DS_ONK,
       KSG_CRITERION2, KOEF_Z, KOEF_D, KOEF_U, KOEF_UP, BS, REAB, CODE_SPEC_V021, C_ZAB, FINE_KOEF,
       DOP_TARIF, DOP_SUM, DOP_CODE_USL, ID_DOP
  from ZSD z
  where z.id = :zsd_id;

  insert into ZS_DS (DS, DS_TYPE, SECTION, SECTION_ID, PR, IS_TEMP, DN)
    select DS, DS_TYPE, SECTION, :new_zsd_id, PR, IS_TEMP, DN
    from ZS_DS d
    where d.section = 2 and d.section_id = :zsd_id;
end;

/* Alter (SP_ZS_DUBLICATE) */
ALTER PROCEDURE SP_ZS_DUBLICATE(ZS_ID INTEGER,
NEW_ZS_ID INTEGER)
 AS
declare variable ZSD_ID integer;
begin
  insert into ZS (ID, Q_U, MP, ORDER_V, CODE_SPEC, CODE_PROF, OTD_PROF, IS_CHIELD, N_HIST, DATE_1, DATE_2, DS0, DS1, DS2,
                TAR_USL, K_USLF, K_USL, SUM_USLF, SUM_USL, IDSP, TARGET, RESULT, PHYS_ID, MES_CODE, PATIENT_ID, HDR_ID,
                DIRECTION_NUM, DIRECTION_DATE, DH_INFO, DCOUNT, KSG, SMP_BRIG, DS3, CATEGORY, PRZ, DISP_STAGE,
                DISP_WORK_STATE, DISP_RESULT, DISP_H_GROUP, OUTCOME, CAT_INFO, FOR_POM, VID_HMP, METOD_HMP, AGE_GRP,
                CHIELD_WITH_ROP, AGE, REGISTRY_ID, PAYMENT_TYPE_ID, N_HIST_NUM, Q_U_2016, ID_PAC,
                RSLT_D, VNOV_D, NPR_MO, PODR, VNOV_M, COMENTSL, EXTRA_INFO, USL_OK, KSLP, TARIF_TEST, SUMV_TEST, PER,
                VBR, TAL_D, TAL_P, INV, NAZR, NAZ_SP, NAZ_V, NAZ_PMP, NAZ_PK, IDSP_NOT_AUTO, AGE_GRP_NOT_AUTO, USER_ID,
                MSE, BARTHEL_IDX, VB_P, CODE_SPEC_V021, DS_ONK, FINE_KOEF_SET_DOCTOR, DISP)
    select :new_zs_id, Q_U, MP, ORDER_V, CODE_SPEC, CODE_PROF, OTD_PROF, IS_CHIELD, N_HIST, DATE_1, DATE_2, DS0, DS1, DS2, TAR_USL,
           K_USLF, K_USL, SUM_USLF, SUM_USL, IDSP, TARGET, RESULT, PHYS_ID, MES_CODE, PATIENT_ID, HDR_ID, DIRECTION_NUM,
           DIRECTION_DATE, DH_INFO, DCOUNT, KSG, SMP_BRIG, DS3, CATEGORY, PRZ, DISP_STAGE, DISP_WORK_STATE,
           DISP_RESULT, DISP_H_GROUP, OUTCOME, CAT_INFO, FOR_POM, VID_HMP, METOD_HMP, AGE_GRP, CHIELD_WITH_ROP, AGE,
           REGISTRY_ID, PAYMENT_TYPE_ID, N_HIST_NUM, Q_U_2016, ID_PAC, RSLT_D, VNOV_D, NPR_MO, PODR, VNOV_M,
           COMENTSL, EXTRA_INFO, USL_OK, KSLP, TARIF_TEST, SUMV_TEST, PER, VBR, TAL_D, TAL_P, INV, NAZR, NAZ_SP, NAZ_V,
           NAZ_PMP, NAZ_PK, IDSP_NOT_AUTO, AGE_GRP_NOT_AUTO, USER_ID, MSE, BARTHEL_IDX, VB_P, CODE_SPEC_V021, DS_ONK,
           FINE_KOEF_SET_DOCTOR, DISP
    from ZS   
    where id = :zs_id;

    for select d.id
        from zsd d
        where d.zs_id = :zs_id
        into :zsd_id
        do
          execute procedure SP_ZSD_DUPLICATE(:ZSD_ID, :new_zs_id);
end;

/* Restore proc. body: SP_CALC_STAC_2018 */
ALTER PROCEDURE SP_CALC_STAC_2018(IDA INTEGER)
 AS
declare variable KSG type of DM_CHAR_50;
declare variable DS type of DM_DS;
declare variable IDB integer;
declare variable SUM_USLF type of DM_MONEY;
declare variable KSKP type of DM_NUM_3_2;
declare variable Q_U integer;
declare variable FINE_KOEF type of DM_NUM_3_2;
declare variable TARIF numeric(15,6);
declare variable Y integer;
declare variable TARIF_USL DM_MONEY;
declare variable DATE2 date;
declare variable IS_TRANSFER DM_INT;
declare variable CL_CNT integer;
declare variable ERR_CODE integer;
declare variable K_DOWN DM_NUM_6_2;
declare variable DS_CLASS DM_CHAR_10;
declare variable KZ DM_NUM_2_5;
declare variable KD DM_NUM_2_5;
declare variable KUS DM_NUM_2_5;
declare variable BS DM_NUM_6_2;
declare variable PROF_NUM integer;
declare variable DATE1 date;
declare variable CODE_USL DM_CHAR_20;
declare variable FINE_KOEF_SET_DOCTOR DM_BOOLEAN;
declare variable IS_ROUND_JANAO integer;
begin
    if (((select first 1 c.org_code from contragents c where c.type_id = 1))  starting '83' ) then
      is_round_janao = 1;

    update zsd d
      set d.ds_class = (select MKB_CLASS from SP_GET_MKB_CLASS(D.ds))
      where d.zs_id = :ida;

    update zsd d
     set d.ksg = null, 
         d.ksg_base = null,
         d.tar_base = null,
         d.sum_base = null,
         d.kskp_base = null,
         d.sum_uslf = 0,
         d.tar_usl = 0,
         d.comment_local = null
     where d.zs_id = :ida;

     cl_cnt = (select count(distinct b.ds_class) from ZSD b where b.ZS_ID = :ida);
     is_transfer = (select sum(iif(b.code_usl is null, 1, 0)) from ZSD b where b.ZS_ID = :ida);
     delete from kslp_koef where zs_id = :ida ;

     select a.q_u, extract(year from a.date_2), a.date_2, coalesce(a.fine_koef_set_doctor,0)
      from zs a
      where a.id = :ida
      into :q_u, :y, :date2, :fine_koef_set_doctor;

     for select sp.KSG, sp.ERR_CODE, b.ds, b.id, iif(:is_round_janao = 1,
                coalesce(bs.tarif * kd.kd * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0),
                cast(coalesce(bs.tarif * kd.kd * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0) as dm_num_6_2)),
                k.kz, kd.kd,
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0),
                bs.tarif, k.k_down, k.prof_num, b.date_1, coalesce(b.code_usl,''), coalesce(b.fine_koef,1)
      from zs a
      join zsd b on a.id = b.zs_id
      join patients p on p.id = a.patient_id
      join lpu_factors lf on lf.q_u = a.q_u and a.date_2 between lf.bp and lf.epv
      join h_tarif_bs bs on bs.q_u = a.q_u and a.date_2 between bs.bp and bs.epv
      join h_tarif_kd kd on a.date_2 between kd.bp and kd.epv
      left join sp_ksg_get(b.ds, p.dr, a.date_2, b.code_usl, p.sex,
                           (select sum(b1.k_uslf) from ZSD b1 where b1.ZS_ID = :ida and b1.ds_class = b.ds_class and b1.code_usl is null), -- -     
                           a.q_u, b.ds2, b.id, b.ksg_criterion,b.ksg_criterion2) sp on 1=1
      left join h_ksg k on k.ksg = sp.ksg and a.date_2 between k.bp and k.epv and k.q_u = a.q_u
      where b.zs_id = :ida
      order by b.code_usl
      into :ksg, :err_code, :ds, :idb, :tarif, :kz, :kd, :kus, :bs, :k_down, :prof_num, :date1, :code_usl, :fine_koef
      do
      begin
        kskp = 1;
--        fine_koef = null;

        if ((q_u = 1) and (err_code is null) and (date2 < '01.01.2019')) then
          kskp = (select KSKP from sp_calc_stac_kskp_2018(:ida, :idb, :ksg, :cl_cnt));

        if ((q_u in (1,3)) and (err_code is null) and (date2 >= '01.01.2019')) then
          kskp = (select KSKP from sp_calc_stac_kskp_2019(:ida, :idb, :ksg, :cl_cnt));

        if (fine_koef_set_doctor = 0) then
          fine_koef = (select FINE_KOEF from sp_calc_stac_fine_2018(:ida, :idb, :ksg, :cl_cnt));

        if (is_round_janao = 1) then
          sum_uslf = cast(cast(tarif * kskp as int) * fine_koef as int);
        else
          sum_uslf = tarif * kskp * fine_koef;

        if (:ksg is not null) then
        begin
            if (:code_usl <> '') then
            begin
                select first 1 d.id, iif(:fine_koef_set_doctor = 1, d.fine_koef, :fine_koef)
                from zs z
                     join zsd d on d.zs_id = z.id
                where d.zs_id = :ida and coalesce(d.code_usl,'') = ''
                       and :date1 between d.date_1 and d.date_2
                       and not exists(select id from zsd d2 where d2.zs_id = :ida and coalesce(d2.code_usl,'') = '' and d2.date_1 = d.date_2)
                into :idb, :fine_koef;

                if (is_round_janao = 1) then
                  sum_uslf = cast(cast(tarif * kskp as int) * fine_koef as int);
                else
                  sum_uslf = tarif * kskp * fine_koef;
            end

            if ((select first 1 d.id from zsd d where d.zs_id = :ida and d.ksg_base = :ksg) is null) then
            update zsd b set
             b.ksg_base = :ksg,
             b.tar_base = iif(:date2 >= '01.05.2018', iif(:is_round_janao = 1, cast(:tarif * coalesce(kskp,1) as int), :tarif * coalesce(kskp,1)), iif(:is_round_janao = 1, cast(:tarif as integer), :tarif)),
             b.sum_base = :sum_uslf,
             b.kskp_base = :kskp,
             b.koef_z = :kz, 
             b.koef_d = :kd,
             b.koef_u = :kus,
             b.bs = :bs,
             b.koef_up = :k_down,
             b.reab = iif(:prof_num = 37,1,null),
             b.fine_koef = :fine_koef
             where b.id = :idb;
         end
      end 
--------------------------------------------------------------------------------
      --    6  + 
      if (q_u = 1) then
       if (exists (select 1 from zsd b where b.zs_id = :ida and ((b.ksg in ('2','st02.001') and b.k_uslf >= 6) or (b.ksg in ('O14.1','O34.2','O36.3','O36.4','O42.2') and b.k_uslf >= 2) ))
          and exists (select 1 from zsd b where b.zs_id = :ida and b.ksg in ('4', '5', 'st02.003', 'st02.004'))) then
          begin
            --    
            select first 1 b.ksg_base, b.ds
            from zs a
             join zsd b on a.id = b.zs_id
             where b.zs_id = :ida and b.ksg in ('4', '5', 'st02.003', 'st02.004')
             into :ksg, :ds;
       
            update zsd d
            set d.tar_usl = d.tar_base,
                d.sum_uslf = d.sum_base,
                d.ksg = d.ksg_base,
                d.kskp = d.kskp_base
            where d.zs_id = :ida;

            --   
            select coalesce(sum(b.sum_uslf), 0) from zsd b where b.zs_id = :ida
             into :sum_uslf;
    
            update zs a set
             a.tar_usl = :tarif,
             a.sum_uslf = :sum_uslf,
             a.sum_usl = :sum_uslf,
             a.ksg = :ksg,
             a.ds1 = :ds,
             a.kslp = :kskp
             where a.id = :ida;

            exit;
          end
--------------------------------------------------------------------------------
      if ((is_transfer < 2) or (cl_cnt < 2))  then  --   
      begin
        --     ,   
        ksg = null;
        select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and ((:q_u = 1 and b.ksg_base >= '325' and b.ksg_base <= '343') or
                                                                                                  (:q_u = 3 and b.ksg_base >= '123' and b.ksg_base <= '134'))
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;

        if (:ksg is null)  then
         select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;

         --      
         update zsd b set
          b.ksg = :ksg, 
          b.sum_uslf = :sum_uslf,
          b.kskp = b.kskp_base,
          b.tar_usl = b.tar_base
          where b.id = :idb;

         update zsd b set
          b.ksg = null,
          b.sum_uslf = 0,
          b.kskp = 1,
          b.tar_usl = 0
          where b.id <> :idb and b.zs_id = :ida;
 
         update zs a set
          a.tar_usl = :tarif,
          a.sum_uslf = :sum_uslf,
          a.sum_usl = :sum_uslf,
          a.ksg = :ksg,
          a.kslp = :kskp
          where a.id = :ida;
 
      end else
      begin
        for select d.ds_class
         from zsd d
         where d.zs_id = :ida
         group by 1
         into :ds_class
         do
         begin
            if (((select count(dc.id) from ksg_dont_choice dc join zsd z on z.ksg_base = dc.ksg_ter or z.ksg_base = dc.ksg_surg
                    where z.zs_id = :ida and z.ds_class = :ds_class and :date2 between dc.bp and dc.epv) > 0) and (:q_u = 1)) then
               --    
            select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and b.ds_class = :ds_class and b.code_usl is not null
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;
            else
               --     
            select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and b.ds_class = :ds_class
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;
    
             --      
             update zsd b set
              b.ksg = :ksg, 
              b.sum_uslf = :sum_uslf,
              b.kskp = b.kskp_base,
              b.tar_usl = b.tar_base
              where b.id = :idb;
    
             update zsd b set
              b.ksg = null,
              b.sum_uslf = 0,
              b.kskp = 1,
              b.tar_usl = 0
              where b.id <> :idb and b.zs_id = :ida and b.ds_class = :ds_class;
         end

        select first 1 b.ksg_base, b.sum_base
        from zs a
         join zsd b on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null and b.ds = a.ds1
         order by b.sum_base desc
         into :ksg, :sum_uslf;

--        update zsd d
--         set d.tar_usl = d.tar_base,
--             d.sum_uslf = d.sum_base,
--             d.ksg = d.ksg_base,
--             d.kskp = d.kskp_base
--         where d.zs_id = :ida;
   
        select coalesce(sum(b.sum_uslf), 0), coalesce(sum(b.tar_base), 0)
         from zsd b
         join zs a on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null
         into :sum_uslf, :tarif;

        update zs a set
         a.tar_usl = :tarif,
         a.sum_uslf = :sum_uslf,
         a.sum_usl = :sum_uslf,
         a.ksg = :ksg,
         a.kslp = :kskp
         where a.id = :ida;
 
      end
end;

/* Restore proc. body: SP_GET_PROTOCOL_FOR_XLS */
ALTER PROCEDURE SP_GET_PROTOCOL_FOR_XLS(PAT_ANALIZ_ID INTEGER,
ROOT_ID INTEGER)
 RETURNS(TEXT_STR VARCHAR(1000),
PARAM_STR VARCHAR(250),
MIN_VALUE NUMERIC(15,2),
MAX_VALUE NUMERIC(15,2),
RESULT_NUM INTEGER,
XLS_ROW DM_CHAR_10,
XLS_COL DM_CHAR_10)
 AS
declare variable LVL_ID integer;
declare variable PARENT_ID integer;
declare variable DOP_STR DM_CHAR_250;
declare variable MEANING_NAME DM_CHAR_100;
declare variable PARAM_UNIT DM_CHAR_100;
declare variable NOTE DM_CHAR_250;
begin
  if (:root_id is null) then root_id = (select first 1 p.param_id from V_PATIENTS_ANALIZ_PARAMS p where p.hdr_id = :pat_analiz_id and p.param_parent_id is null);

  for select p.param_id, p.param_parent_id, iif(:root_id is null, '', p.param_name), p.meaning_name, p.param_unit, coalesce(p.note,''),
             p.min_value, p.max_value, p.result_num, P.xls_row, P.xls_col
   from V_PATIENTS_ANALIZ_PARAMS p
   where p.hdr_id = :pat_analiz_id and coalesce(p.param_parent_id,0) = coalesce(:root_id,0)
   order by p.param_parent_id, p.id
   into :lvl_id, :root_id, :dop_str, :meaning_name, :param_unit, :note, :min_value, :max_value, :result_num, :xls_row, :xls_col
   do
   begin
     text_str = '  ' || coalesce(:text_str,'') || :dop_str || ': ';

     param_str = coalesce(:meaning_name,'') || ' ' || coalesce(:param_unit,'') || iif((:note <> '') and (coalesce(:meaning_name,'') <> ''), ', ','') || coalesce(:note,'');
     param_unit = '';
     note = '';

     if ((select first 1 id from V_PATIENTS_ANALIZ_PARAMS p where p.hdr_id = :pat_analiz_id and p.param_parent_id = :lvl_id) is null) then
     begin
       text_str = coalesce(:text_str,'');
--       param_str = ' <u>' || coalesce(:meaning_name,'') || '</u> ' || coalesce(:param_unit,'') || iif(:note <> '', ', ','') || coalesce(:note,'');
--       param_unit = '';
--       note = '';
     end
     else
     begin
       suspend;
       text_str = '';
       for select TEXT_STR, param_str, min_value, max_value, result_num
        from SP_GET_PROTOCOL_USL(:PAT_ANALIZ_ID, :lvl_id)
         into :dop_str, :param_str, :min_value, :max_value, :result_num
         do
         begin
           text_str = '    ' || coalesce(:text_str,'') || :dop_str || ' ';
           suspend;
           text_str = '';
           param_str = '';
           xls_row = '';
           xls_col = '';
         end
     end

     if (text_str <> '') then
     begin
       suspend;
       text_str = '';
       param_str = '';
       xls_row = '';
       xls_col = '';
     end
   end
end;

CREATE VIEW V_PATIENTS_ANALIZ(
ID,
ANALIZ_ID,
DATE_OUT,
DATE_IN,
REGISTRY_ID,
USL_CODE,
USL_NAME,
USER_FIO,
DOCTOR_FIO,
PAT_ID,
CONCLUTION,
NOT_NORM,
TARIF,
CATEGORY_NAME,
SUMF,
SUP_OPL)
 AS 
select pan.id, pan.analiz_id, pan.date_out, pan.date_in, pan.registry_id,
       pan.analiz_code usl_code, pan.analiz_name usl_name,
       us.fio user_fio,
       d.fio doctor_fio,
       PAN.pat_id,
       pan.conclution,
       (select first 1 1 from v_patients_analiz_params p where p.hdr_id = pan.id and (coalesce(p.result_num,0) <> 0 or p.meaning_is_norm = 0)),
       pan.analiz_tarif,
       c.name,
       i.sumv_total,
       i.sum_opl
from patients_analiz pan
--     left join h_usl u on u.id = pan.analiz_id
     join users us on us.id = pan.user_id
     left join doctors_fio d on d.id = PAN.doctor_id
     left join h_usl_params_category C ON c.id = pan.category_id
     left join patients_invoice i on i.analiz_id = pan.id
;


/* Alter Procedure... */
/* empty dependent procedure body */
/* Clear: SP_CALC_ALL for: SP_CALC_STAC_2018 */
ALTER PROCEDURE SP_CALC_ALL(ZS_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* Alter (SP_CALC_STAC_2018) */
ALTER PROCEDURE SP_CALC_STAC_2018(IDA INTEGER)
 AS
declare variable KSG type of DM_CHAR_50;
declare variable DS type of DM_DS;
declare variable IDB integer;
declare variable SUM_USLF type of DM_MONEY;
declare variable KSKP type of DM_NUM_3_2;
declare variable Q_U integer;
declare variable FINE_KOEF type of DM_NUM_3_2;
declare variable TARIF numeric(15,6);
declare variable Y integer;
declare variable TARIF_USL DM_MONEY;
declare variable DATE2 date;
declare variable IS_TRANSFER DM_INT;
declare variable CL_CNT integer;
declare variable ERR_CODE integer;
declare variable K_DOWN DM_NUM_6_2;
declare variable DS_CLASS DM_CHAR_10;
declare variable KZ DM_NUM_2_5;
declare variable KD DM_NUM_2_5;
declare variable KUS DM_NUM_2_5;
declare variable BS DM_NUM_6_2;
declare variable PROF_NUM integer;
declare variable DATE1 date;
declare variable CODE_USL DM_CHAR_20;
declare variable FINE_KOEF_SET_DOCTOR DM_BOOLEAN;
declare variable IS_ROUND_JANAO integer;
begin
    if (((select first 1 c.org_code from contragents c where c.type_id = 1))  starting '83' ) then
      is_round_janao = 1;

    update zsd d
      set d.ds_class = (select MKB_CLASS from SP_GET_MKB_CLASS(D.ds))
      where d.zs_id = :ida;

    update zsd d
     set d.ksg = null, 
         d.ksg_base = null,
         d.tar_base = null,
         d.sum_base = null,
         d.kskp_base = null,
         d.sum_uslf = 0,
         d.tar_usl = 0,
         d.comment_local = null
     where d.zs_id = :ida;

     cl_cnt = (select count(distinct b.ds_class) from ZSD b where b.ZS_ID = :ida);
     is_transfer = (select sum(iif(b.code_usl is null, 1, 0)) from ZSD b where b.ZS_ID = :ida);
     delete from kslp_koef where zs_id = :ida ;

     select a.q_u, extract(year from a.date_2), a.date_2, coalesce(a.fine_koef_set_doctor,0)
      from zs a
      where a.id = :ida
      into :q_u, :y, :date2, :fine_koef_set_doctor;

     for select sp.KSG, sp.ERR_CODE, b.ds, b.id, iif(:is_round_janao = 1,
                coalesce(bs.tarif * kd.kd * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0),
                cast(coalesce(bs.tarif * kd.kd * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0) as dm_num_6_2)),
                k.kz, kd.kd,
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0),
                bs.tarif, k.k_down, k.prof_num, b.date_1, coalesce(b.code_usl,''), coalesce(b.fine_koef,1)
      from zs a
      join zsd b on a.id = b.zs_id
      join patients p on p.id = a.patient_id
      join lpu_factors lf on lf.q_u = a.q_u and a.date_2 between lf.bp and lf.epv
      join h_tarif_bs bs on bs.q_u = a.q_u and a.date_2 between bs.bp and bs.epv
      join h_tarif_kd kd on a.date_2 between kd.bp and kd.epv
      left join sp_ksg_get(b.ds, p.dr, a.date_2, b.code_usl, p.sex,
                           (select sum(b1.k_uslf) from ZSD b1 where b1.ZS_ID = :ida and b1.ds_class = b.ds_class and b1.code_usl is null), -- -     
                           a.q_u, b.ds2, b.id, b.ksg_criterion,b.ksg_criterion2) sp on 1=1
      left join h_ksg k on k.ksg = sp.ksg and a.date_2 between k.bp and k.epv and k.q_u = a.q_u
      where b.zs_id = :ida
      order by b.code_usl
      into :ksg, :err_code, :ds, :idb, :tarif, :kz, :kd, :kus, :bs, :k_down, :prof_num, :date1, :code_usl, :fine_koef
      do
      begin
        kskp = 1;
--        fine_koef = null;

        if ((q_u = 1) and (err_code is null) and (date2 < '01.01.2019')) then
          kskp = (select KSKP from sp_calc_stac_kskp_2018(:ida, :idb, :ksg, :cl_cnt));

        if ((q_u in (1,3)) and (err_code is null) and (date2 >= '01.01.2019')) then
          kskp = (select KSKP from sp_calc_stac_kskp_2019(:ida, :idb, :ksg, :cl_cnt));

        if (fine_koef_set_doctor = 0) then
          fine_koef = (select FINE_KOEF from sp_calc_stac_fine_2018(:ida, :idb, :ksg, :cl_cnt));

        if (is_round_janao = 1) then
          sum_uslf = cast(cast(tarif * kskp as int) * fine_koef as int);
        else
          sum_uslf = tarif * kskp * fine_koef;

        if (:ksg is not null) then
        begin
            if (:code_usl <> '') then
            begin
                select first 1 d.id, iif(:fine_koef_set_doctor = 1, d.fine_koef, :fine_koef)
                from zs z
                     join zsd d on d.zs_id = z.id
                where d.zs_id = :ida and coalesce(d.code_usl,'') = ''
                       and :date1 between d.date_1 and d.date_2
                       and not exists(select id from zsd d2 where d2.zs_id = :ida and coalesce(d2.code_usl,'') = '' and d2.date_1 = d.date_2)
                into :idb, :fine_koef;

                if (is_round_janao = 1) then
                  sum_uslf = cast(cast(tarif * kskp as int) * fine_koef as int);
                else
                  sum_uslf = tarif * kskp * fine_koef;
            end

            if ((select first 1 d.id from zsd d where d.zs_id = :ida and d.ksg_base = :ksg) is null) then
            update zsd b set
             b.ksg_base = :ksg,
             b.tar_base = iif(:date2 >= '01.05.2018', iif(:is_round_janao = 1, cast(:tarif * coalesce(kskp,1) as int), :tarif * coalesce(kskp,1)), iif(:is_round_janao = 1, cast(:tarif as integer), :tarif)),
             b.sum_base = :sum_uslf,
             b.kskp_base = :kskp,
             b.koef_z = :kz, 
             b.koef_d = :kd,
             b.koef_u = :kus,
             b.bs = :bs,
             b.koef_up = :k_down,
             b.reab = iif(:prof_num = 37,1,null),
             b.fine_koef = :fine_koef
             where b.id = :idb;
         end
      end 
--------------------------------------------------------------------------------
      --    6  + 
      if (q_u = 1) then
       if (exists (select 1 from zsd b where b.zs_id = :ida and ((b.ksg in ('2','st02.001') and b.k_uslf >= 6) or (b.ksg in ('O14.1','O34.2','O36.3','O36.4','O42.2') and b.k_uslf >= 2) ))
          and exists (select 1 from zsd b where b.zs_id = :ida and b.ksg in ('4', '5', 'st02.003', 'st02.004'))) then
          begin
            --    
            select first 1 b.ksg_base, b.ds
            from zs a
             join zsd b on a.id = b.zs_id
             where b.zs_id = :ida and b.ksg in ('4', '5', 'st02.003', 'st02.004')
             into :ksg, :ds;
       
            update zsd d
            set d.tar_usl = d.tar_base,
                d.sum_uslf = d.sum_base,
                d.ksg = d.ksg_base,
                d.kskp = d.kskp_base
            where d.zs_id = :ida;

            --   
            select coalesce(sum(b.sum_uslf), 0) from zsd b where b.zs_id = :ida
             into :sum_uslf;
    
            update zs a set
             a.tar_usl = :tarif,
             a.sum_uslf = :sum_uslf,
             a.sum_usl = :sum_uslf,
             a.ksg = :ksg,
             a.ds1 = :ds,
             a.kslp = :kskp
             where a.id = :ida;

            exit;
          end
--------------------------------------------------------------------------------
      if ((is_transfer < 2) or (cl_cnt < 2))  then  --   
      begin
        --     ,   
        ksg = null;
        select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and ((:q_u = 1 and b.ksg_base >= '325' and b.ksg_base <= '343') or
                                                                                                  (:q_u = 3 and b.ksg_base >= '123' and b.ksg_base <= '134'))
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;

        if (:ksg is null)  then
         select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;

         --      
         update zsd b set
          b.ksg = :ksg, 
          b.sum_uslf = :sum_uslf,
          b.kskp = b.kskp_base,
          b.tar_usl = b.tar_base
          where b.id = :idb;

         update zsd b set
          b.ksg = null,
          b.sum_uslf = 0,
          b.kskp = 1,
          b.tar_usl = 0
          where b.id <> :idb and b.zs_id = :ida;
 
         update zs a set
          a.tar_usl = :tarif,
          a.sum_uslf = :sum_uslf,
          a.sum_usl = :sum_uslf,
          a.ksg = :ksg,
          a.kslp = :kskp
          where a.id = :ida;
 
      end else
      begin
        for select d.ds_class
         from zsd d
         where d.zs_id = :ida
         group by 1
         into :ds_class
         do
         begin
            if (((select count(dc.id) from ksg_dont_choice dc join zsd z on z.ksg_base = dc.ksg_ter or z.ksg_base = dc.ksg_surg
                    where z.zs_id = :ida and z.ds_class = :ds_class and :date2 between dc.bp and dc.epv) > 0) and (:q_u = 1)) then
               --    
            select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and b.ds_class = :ds_class and b.code_usl is not null
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;
            else
               --     
            select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and b.ds_class = :ds_class
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;
    
             --      
             update zsd b set
              b.ksg = :ksg, 
              b.sum_uslf = :sum_uslf,
              b.kskp = b.kskp_base,
              b.tar_usl = b.tar_base
              where b.id = :idb;
    
             update zsd b set
              b.ksg = null,
              b.sum_uslf = 0,
              b.kskp = 1,
              b.tar_usl = 0
              where b.id <> :idb and b.zs_id = :ida and b.ds_class = :ds_class;
         end

        select first 1 b.ksg_base, b.sum_base
        from zs a
         join zsd b on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null and b.ds = a.ds1
         order by b.sum_base desc
         into :ksg, :sum_uslf;

--        update zsd d
--         set d.tar_usl = d.tar_base,
--             d.sum_uslf = d.sum_base,
--             d.ksg = d.ksg_base,
--             d.kskp = d.kskp_base
--         where d.zs_id = :ida;
   
        select coalesce(sum(b.sum_uslf), 0), coalesce(sum(b.tar_base), 0)
         from zsd b
         join zs a on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null
         into :sum_uslf, :tarif;

        update zs a set
         a.tar_usl = :tarif,
         a.sum_uslf = :sum_uslf,
         a.sum_usl = :sum_uslf,
         a.ksg = :ksg,
         a.kslp = :kskp
         where a.id = :ida;
 
      end
end;

/* Restore proc. body: SP_CALC_ALL */
ALTER PROCEDURE SP_CALC_ALL(ZS_ID INTEGER)
 AS
declare variable TAR DM_MONEY_15_2;
declare variable DATE1 DM_DATE;
declare variable Q_U integer;
declare variable TAR_USL DM_MONEY_15_2;
declare variable TARGET integer;
declare variable IDB integer;
declare variable SUM_USLF DM_MONEY_15_2;
declare variable SEX char(1);
declare variable PTYPE integer;
declare variable AGE_Y integer;
declare variable AGE_GRP integer;
declare variable HDR_ID integer;
declare variable TROMB_CODE DM_CHAR_20;
declare variable TAR_USL_DOP DM_MONEY_15_2;
declare variable SUM_USLF_DOP DM_MONEY_15_2;
begin
  select z.date_2, z.q_u, z.target, p.sex, z.payment_type_id, extract(year from z.date_2) - extract(year from p.dr), z.hdr_id
  from zs z
  join patients p on p.id = z.patient_id
  where z.id = :zs_id
  into :date1, :q_u, :target, :sex, :ptype, :age_y, :hdr_id;

  if (:ptype in (2,3)) then exit;

  if (:target in (9,10,11,12,13,14,15,16,17)) then
  begin
   if ((select coalesce(t.days_cnt,0) from h_target t where t.id = :target) <> 0) then
   begin
    update zsd d
     set d.zachet = 1
     where d.date_1 < (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;

    update zsd d
     set d.zachet = 0
     where d.date_1 >= (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;
   end

   update zsd d
    set d.k_uslf = 0
    where (d.zachet = 1 or d.is_no_get_usl = 1) and d.zs_id = :zs_id;
  end

  update zsd d
    set d.tar_usl = null,
        d.sum_uslf = null,
        d.comment_local = null,
        d.dop_tarif = null,
        d.dop_sum = null
    where d.zs_id = :zs_id;

  update zs z
    set z.tar_usl = null,
        z.sum_usl = null,
        z.sum_uslf = null
    where z.id = :zs_id;

  if ((select coalesce(i.is_nz,0) from invoice i join zs_hdr h on h.name = i.id where h.id = :hdr_id) = 1) then
  begin
    if (target in (9,10,11,13,14,15,16,17)) then exit;

    tar = (select first 1 s.tarif from h_tarif_nz s where s.q_u = iif(:q_u = 4,2,:q_u) and :date1 between s.bp and s.epv);

    if (q_u = 1) then
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id and d.code_usl is null;
    else
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id;

    if (q_u = 4) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = z.dcount*:tar
      where id = :zs_id;
    else
    if (q_u = 1) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = :tar
      where id = :zs_id;
    else
      update zs z
      set z.tar_usl = :tar,
          z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
      where id = :zs_id;
    exit;
  end
   /********************,    ************************/
  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 < '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin

          select first 1 h.tarif, h.tarif
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
                                 and cast(h.code_spec as varchar(10)) = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec = '16' and a.age < 18, '22', b.code_spec), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf;

          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0)
           where b.id = :idb;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end

  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 >= '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (:tar is null) then
          select first 1 h.tarif, h.tarif
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
           join h_tarif_app_spec n on n.name_id = h.name_id
                                 and n.code_spec_v021 = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec_v021 = 39 and a.age < 18, 49, b.code_spec_v021), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf;

          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          tar = null;
          sum_uslf = null;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end  

  /********************************************/
  if (:q_u = 4) then
  begin
    tar = (select s.tarif from h_tarif_stom s where :date1 between s.bp and s.epv);

    update zsd d
    set d.tar_usl = :tar,
        d.sum_uslf = d.k_uslf*:tar
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = :tar,
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if (:q_u = 5) then
  begin
--    if (:date1 >= '01.01.2018') then tromb_code = 'A25.30.036';
--    else tromb_code = 'A25.30.035';
    tromb_code = coalesce((select first 1 code_usl from zsd d where d.zs_id = :zs_id and coalesce(code_usl, '') <> ''),'');

    tar = (select s.tarif from h_tarif_smp s where :date1 between s.bp and s.epv);
    tar_usl = coalesce((select coalesce(u.sumf,0) from h_usl u where u.code = :tromb_code
               and u.q_u containing '5' and :date1 between u.datebeg and u.dateend),0);

    update zsd d
    set d.tar_usl = iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl),
        d.sum_uslf = d.k_uslf*iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl)
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = (select max(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if ((:q_u = 1) and ((select 1 from zs z where coalesce(z.metod_hmp,0) > 0 and id = :zs_id) = 1)) then
  begin
    select first 1 v.tarif
    from zs z
         join h_metod_hmp h on h.code = z.metod_hmp and z.date_2 between h.bp and h.epv
         join h_tarif_vmp v on v.tg = h.tg and z.date_2 between v.bp and v.epv
    where z.id = :zs_id
    into :tar;

    update zs a set
        a.tar_usl = :tar,
        a.sum_uslf = :tar,
        a.ksg = null,
        a.kslp = null
    where a.id = :zs_id;

    update zsd b set
          b.ksg = null,
          b.sum_uslf = :tar,
          b.kskp = 0,
          b.tar_usl = :tar
    where b.zs_id = :zs_id and coalesce(b.code_usl,'') = '' and b.date_1 = (select min(date_1) from zsd where zs_id = :zs_id and coalesce(code_usl,'') = '');

    exit;
  end

  /********************************************/
  if (:q_u in (1,3) and :date1 < '01.01.2018') then
    execute procedure SP_CALC_STAC(:zs_id);
  else
    if (:q_u in (1,3) and :date1 >= '01.01.2018') then
      execute procedure sp_calc_stac_2018(:zs_id);

  /****************  ***********************************************/
  if (q_u <> 4) then
  begin
  tar = null;
  sum_uslf = null;
  for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (coalesce(:tar,0) > 0) then
          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          tar = null;
          sum_uslf = null;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
   end

  /*********************-*********************************/
  if ((:q_u = 2) and (:target in (21,22))) then
  begin
   for select b.id
    from zsd b
    join zs z on z.id = b.zs_id
    where z.id = :zs_id
    into :idb
    do
    begin
      tar = (select first 1 t.tarif
             from zsd d
                  join h_tomo_code c on c.nms_code = d.code_usl
                  join h_tarif_tomo t on t.group_num = c.group_num and d.date_2 between t.bp and t.epv
             where d.id = :idb);

      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf = :tar
      where d.id = :idb;
    end

    update zs z
    set z.tar_usl = (select sum(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;

    exit;
  end
  /******************** - 9  ************************/
  if (:q_u = 2 and :target = 9) then
  begin
    execute procedure sp_calc_app_t09(:zs_id);
    exit;
  end

  /******************** - 10,17  -  ************************/
    if (q_u = 2 and target in (10,17)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_10 d on d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and :age_y between d.y1 and d.y2
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 13  ************************/
    if (q_u = 2 and target = 13) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                           and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_13_17 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.age_grp = a.age_grp
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 14,15  ,  ************************/
    if (q_u = 2 and target in (14,15)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_14_15 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.cat_info = a.cat_info
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
  /******************** - 16  ************************/
    if (q_u = 2 and target = 16) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join zs_hdr h on h.id = a.hdr_id
                   join patients p on p.id = a.patient_id
                   join h_tarif_disp_16 d on a.date_2 between d.bp and d.epv
                                          and d.sex = :sex
                                          and cast(d.code_usl as varchar(20)) = b.code_usl
                                          and d.age_l <= (h.y - extract(year from p.dr)) and d.age_r >= (h.y - extract(year from p.dr))
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0) ,
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
end;


