/* Create Table... */
CREATE TABLE SYS$LOG_FIELDS(LOG_TABLES_ID NUMERIC(18) NOT NULL,
FIELD_NAME VARCHAR(67) CHARACTER SET UTF8 NOT NULL,
OLD_VALUE VARCHAR(255) CHARACTER SET UTF8,
NEW_VALUE VARCHAR(255) CHARACTER SET UTF8);


CREATE TABLE SYS$LOG_KEYS(LOG_TABLES_ID NUMERIC(18) NOT NULL,
KEY_FIELD VARCHAR(67) CHARACTER SET UTF8 NOT NULL,
KEY_VALUE VARCHAR(255) CHARACTER SET UTF8);


CREATE TABLE SYS$LOG_SETTING(ID DM_ID NOT NULL,
TABLE_NAME DM_CHAR_100,
TABLE_CAPTION DM_CHAR_100,
INSERT_SCRIPT DM_BLOB,
UPDATE_SCRIPT DM_BLOB,
DELETE_SCRIPT DM_BLOB);


CREATE TABLE SYS$LOG_SETTING_DETAIL(ID DM_ID NOT NULL,
TABLE_ID DM_ID,
FIELD_NAME DM_CHAR_100,
FIELD_CAPTION DM_CHAR_255,
INSERT_TO_PROTOCOL DM_BOOL,
UPDATE_TO_PROTOCOL DM_BOOL,
DELETE_TO_PROTOCOL DM_BOOL);


CREATE TABLE SYS$LOG_TABLES(ID NUMERIC(18) NOT NULL,
TABLE_NAME VARCHAR(67) CHARACTER SET UTF8 NOT NULL,
OPERATION VARCHAR(1) NOT NULL,
DATE_TIME TIMESTAMP NOT NULL,
USER_NAME VARCHAR(67) NOT NULL,
USER_ID DM_INT);



ALTER TABLE H_SMO ADD DATEBEG DM_DATE;

ALTER TABLE H_SMO ADD DATEEND DM_DATE;

DESCRIBE FIELD DS_ONK TABLE ZS
'   ';

DESCRIBE FIELD DISP TABLE ZS
' ';

/* Alter View (Drop, Create)... */
/* Drop altered view: V_H_SMO */
DROP VIEW V_H_SMO;

/* Create altered view: V_H_SMO */
/* Create view: V_H_SMO */
CREATE VIEW V_H_SMO(
ID,
CODE,
NAME,
OKATO,
OGRN,
TERR_NAME,
DATEBEG,
DATEEND,
IS_ACTIVE)
 AS 
select S.ID, S.CODE, S.NAME, S.OKATO, S.OGRN, o.name terr_name, s.datebeg,
       s.dateend, iif(s.dateend is null,  1, 0)
from h_smo s
join h_okato o on o.code = s.okato
;

DESCRIBE FIELD CODE VIEW V_H_SMO
' ';

DESCRIBE FIELD NAME VIEW V_H_SMO
'';

DESCRIBE FIELD OKATO VIEW V_H_SMO
'';

DESCRIBE FIELD OGRN VIEW V_H_SMO
'';

DESCRIBE FIELD TERR_NAME VIEW V_H_SMO
'';

DESCRIBE FIELD DATEBEG VIEW V_H_SMO
'  ';

DESCRIBE FIELD DATEEND VIEW V_H_SMO
'  ';

DESCRIBE FIELD IS_ACTIVE VIEW V_H_SMO
'';

/* Create index... */
CREATE INDEX SYS$LOG_FIELDS_IDX1 ON SYS$LOG_FIELDS(LOG_TABLES_ID);

CREATE INDEX SYS$LOG_KEYS_IDX1 ON SYS$LOG_KEYS(LOG_TABLES_ID);


/* Create generator... */
CREATE GENERATOR GEN_SYS$LOG_SETTING_DETAIL_ID;

CREATE GENERATOR GEN_SYS$LOG_SETTING_ID;

CREATE GENERATOR GEN_SYS$LOG_TABLES_ID;


/* Create Primary Key... */
ALTER TABLE SYS$LOG_TABLES ADD PRIMARY KEY (ID);

ALTER TABLE SYS$LOG_SETTING ADD CONSTRAINT PK_SYS$LOG_SETTING PRIMARY KEY (ID);

ALTER TABLE SYS$LOG_SETTING_DETAIL ADD CONSTRAINT PK_SYS$LOG_SETTING_DETAIL PRIMARY KEY (ID);

/* Alter Procedure... */
/* Alter (SP_REP_DIALIZ_74) */

ALTER PROCEDURE SP_REP_DIALIZ_74(Y INTEGER,
M1 INTEGER,
M2 INTEGER,
Q_U INTEGER)
 RETURNS(SMO VARCHAR(10),
USL_CNT NUMERIC(18,2),
TAR DM_MONEY_15_2,
TAR_DOP DM_MONEY_15_2,
CODE_USL DM_CHAR_20,
SMO_NAME DM_CHAR_255,
USL_CNT_DOP DM_NUM_3_2)
 AS
declare variable DATE_1 DM_DATE;
BEGIN
date_1 = cast(('01.' || lpad(:m1,2,'') || '.' || :y) as date);
usl_cnt_dop = 1;
tar = 0;
usl_cnt = 0;

for select  s.code, s.name
 from h_smo s
      join contragents c on c.tf_okato = s.okato
 where :date_1 between s.datebeg and coalesce(s.dateend, '31.12.2999')
       and c.type_id = 1
 group by 1, 2
 into :smo, :smo_name
 do
 begin
   for
    select u.code, u.sumf, ud.sumf
     from h_usl u
          left join h_usl ud on ud.finans_type = 1 and ud.q_u containing :q_u and :date_1 between ud.datebeg and ud.dateend
    where  u.code in ('A18.05.002.001', 'A18.05.002.002', 'A18.05.011')
           and u.payment_type_id = 1
           and :date_1 between u.datebeg and u.dateend
    group by 1,2,3
--    order by p.smo
    INTO :code_usl,
         :tar,
         :tar_dop
    do
    begin
      select d.tar_usl, sum(d.k_uslf)
         from zs_hdr h
              left join zs z on h.id = z.hdr_id
              left join patients p on p.id = z.patient_id
              left join zsd d on d.zs_id = z.id
         where h.y = :y and h.m between :m1 and :m2 and h.is_delete <> 1
               and d.code_usl = :code_usl
               and p.smo = :smo
               and z.q_u = :q_u
         group by 1
         into :tar,
              :usl_cnt;

      suspend;
      tar = 0;
      usl_cnt = 0;
    end
 end

 smo_name = '  ';
 for
    select u.code, u.sumf, ud.sumf
     from h_usl u
          left join h_usl ud on ud.finans_type = 1 and ud.q_u containing :q_u and :date_1 between ud.datebeg and ud.dateend
    where  u.code in ('A18.05.002.001', 'A18.05.002.002', 'A18.05.011')
           and u.payment_type_id = 1
           and :date_1 between u.datebeg and u.dateend
    group by 1,2,3
--    order by p.smo
    INTO :code_usl,
         :tar,
         :tar_dop
    do
    begin
      select d.tar_usl, sum(d.k_uslf)
         from zs_hdr h
              left join zs z on h.id = z.hdr_id
              left join patients p on p.id = z.patient_id
              left join zsd d on d.zs_id = z.id
         where h.y = :y and h.m between :m1 and :m2 and h.is_delete <> 1
               and d.code_usl = :code_usl
--               and coalesce(p.smo,'') <> ''
               and z.q_u = :q_u
         group by 1
         into :tar,
              :usl_cnt;

      suspend;
      tar = 0;
      usl_cnt = 0;
    end
END;

/* Creating trigger... */
CREATE TRIGGER SYS$LOG_SETTING_BI FOR SYS$LOG_SETTING
ACTIVE BEFORE INSERT POSITION 0 
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_sys$log_setting_id,1);
end;

CREATE TRIGGER SYS$LOG_SETTING_BI0 FOR SYS$LOG_SETTING
ACTIVE BEFORE INSERT POSITION 0 
AS
declare variable fn varchar(100);
declare variable fd varchar(250);
begin
  if (new.table_name = 'ZS') then
  begin
    new.table_caption = ' ';

    for select substring(fn FROM 3 FOR char_length(Fn) - 2), fd
     from V_SLUCH_FIELDS
     where RELATION_NAME = 'ZS'
     into :fn, :fd
     do
       update or insert into SYS$LOG_SETTING_DETAIL (TABLE_ID, FIELD_NAME, FIELD_CAPTION)
        values (NEW.ID, :fn, :fd)
        matching (TABLE_ID, FIELD_NAME);
  end

  if (new.table_name = 'PATIENTS') then
  begin
    new.table_caption = '';

    for select substring(fn FROM 3 FOR char_length(Fn) - 2), fd
     from V_SLUCH_FIELDS
     where RELATION_NAME = 'PATIENTS'
     into :fn, :fd
     do
       update or insert into SYS$LOG_SETTING_DETAIL (TABLE_ID, FIELD_NAME, FIELD_CAPTION)
        values (NEW.ID, :fn, :fd)
        matching (TABLE_ID, FIELD_NAME);
  end
end;

CREATE TRIGGER SYS$LOG_SETTING_DETAIL_AU0 FOR SYS$LOG_SETTING_DETAIL
ACTIVE BEFORE UPDATE POSITION 0 
AS
declare variable fn varchar(100);
declare variable b dm_blob;
begin
  b = '';
  if (new.insert_to_protocol = 1) then
  begin
    for select trim(d.field_name)
        from SYS$LOG_SETTING_DETAIL d
        where d.insert_to_protocol = 1 and d.table_id = new.table_id
              and d.id <> new.id
        into :fn
        do
          b = :b ||
'
if (new.' || :fn || ' is not null) then
    insert into sys$log_fields (log_tables_id, field_name, old_value, new_value)
           values (:tid, ''' || :fn || ''', null, new.' || :fn || ');
';

    update sys$log_setting s
     set s.insert_script = ('ALTER TRIGGER SYS$' || S.table_name || '_AI
as
declare variable tid integer;
begin
  tid = gen_id(gen_sys$log_tables_id,1);

  insert into sys$log_tables (id, table_name, operation, date_time, user_id)
         values (:tid, ''' || s.table_name || ''', ''I'', ''NOW'', new.user_id);

  insert into sys$log_keys (log_tables_id, key_field, key_value)
         values (:tid, ''ID'', new.id);

if (new.' || trim(new.field_name) || ' is not null) then
    insert into sys$log_fields (log_tables_id, field_name, old_value, new_value)
           values (:tid, ''' || trim(new.field_name) || ''', null, new.' || trim(new.field_name) || ');
'

|| :b ||

'
end;')
     where s.id = new.table_id;
  end
end;

CREATE TRIGGER SYS$LOG_SETTING_DETAIL_BI FOR SYS$LOG_SETTING_DETAIL
ACTIVE BEFORE INSERT POSITION 0 
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_sys$log_setting_detail_id,1);
end;

CREATE TRIGGER SYS$LOG_SETTING_DETAIL_BI0 FOR SYS$LOG_SETTING_DETAIL
ACTIVE BEFORE INSERT POSITION 0 
AS
begin
  if (new.INSERT_TO_PROTOCOL is null) then
    new.INSERT_TO_PROTOCOL = 0;
  if (new.INSERT_TO_PROTOCOL is null) then
    new.update_TO_PROTOCOL = 0;
  if (new.INSERT_TO_PROTOCOL is null) then
    new.delete_TO_PROTOCOL = 0;
end;

CREATE TRIGGER SYS$LOG_TABLES_BI FOR SYS$LOG_TABLES
ACTIVE BEFORE INSERT POSITION 0 
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_sys$log_tables_id,1);
end;
