ALTER PROCEDURE SP_REP_DIALIZ_74(Y INTEGER,
M1 INTEGER,
M2 INTEGER,
Q_U INTEGER)
 RETURNS(SMO VARCHAR(10),
USL_CNT NUMERIC(18,2),
TAR DM_MONEY_15_2,
TAR_DOP DM_MONEY_15_2,
CODE_USL DM_CHAR_20,
SMO_NAME DM_CHAR_255,
USL_CNT_DOP DM_NUM_3_2)
 AS
declare variable DATE_1 DM_DATE;
BEGIN
date_1 = cast(('01.' || lpad(:m1,2,'') || '.' || :y) as date);
usl_cnt_dop = 1;
tar = 0;
usl_cnt = 0;

for select  s.code, s.name
 from h_smo s
      join contragents c on c.tf_okato = s.okato
 where :date_1 between s.datebeg and coalesce(s.dateend, '31.12.2999')
       and c.type_id = 1
 group by 1, 2
 into :smo, :smo_name
 do
 begin
   for
    select u.code, u.sumf, ud.sumf
     from h_usl u
          left join h_usl ud on ud.finans_type = 1 and ud.q_u containing :q_u and :date_1 between ud.datebeg and ud.dateend
    where  u.code in ('A18.05.002.001', 'A18.05.002.002', 'A18.05.011')
           and u.payment_type_id = 1
           and :date_1 between u.datebeg and u.dateend
    group by 1,2,3
--    order by p.smo
    INTO :code_usl,
         :tar,
         :tar_dop
    do
    begin
      select d.tar_usl, sum(d.k_uslf)
         from zs_hdr h
              left join zs z on h.id = z.hdr_id
              left join patients p on p.id = z.patient_id
              left join zsd d on d.zs_id = z.id
         where h.y = :y and h.m between :m1 and :m2 and h.is_delete <> 1
               and d.code_usl = :code_usl
               and p.smo = :smo
               and z.q_u = :q_u
         group by 1
         into :tar,
              :usl_cnt;

      suspend;
      tar = 0;
      usl_cnt = 0;
    end
 end

 smo_name = '  ';
 for
    select u.code, u.sumf, ud.sumf
     from h_usl u
          left join h_usl ud on ud.finans_type = 1 and ud.q_u containing :q_u and :date_1 between ud.datebeg and ud.dateend
    where  u.code in ('A18.05.002.001', 'A18.05.002.002', 'A18.05.011')
           and u.payment_type_id = 1
           and :date_1 between u.datebeg and u.dateend
    group by 1,2,3
--    order by p.smo
    INTO :code_usl,
         :tar,
         :tar_dop
    do
    begin
      select d.tar_usl, sum(d.k_uslf)
         from zs_hdr h
              left join zs z on h.id = z.hdr_id
              left join patients p on p.id = z.patient_id
              left join zsd d on d.zs_id = z.id
              join h_smo s on s.code = p.smo
              join contragents c on c.tf_okato = s.okato
         where h.y = :y and h.m between :m1 and :m2 and h.is_delete <> 1
               and d.code_usl = :code_usl
--               and coalesce(p.smo,'') <> ''
               and z.q_u = :q_u
               and :date_1 between s.datebeg and coalesce(s.dateend, '31.12.2999')
               and c.type_id = 1
         group by 1
         into :tar,
              :usl_cnt;

      suspend;
      tar = 0;
      usl_cnt = 0;
    end
END;


