create or alter procedure SP_CALC_STAC_FINE_2018 (
    IDA integer,
    IDB integer,
    KSG DM_CHAR_20,
    CL_CNT integer)
returns (
    FINE_KOEF type of DM_NUM_3_2)
as
declare variable Q_U integer;
declare variable DATE_2 DM_DATE;
declare variable PERCENT_VALUE DM_NUM_3_2;
declare variable PERCENT_VALUE_MAX DM_NUM_3_2;
begin
     select q_u, date_2 from zs
     where id = :ida
     into :q_u, :date_2;

     fine_koef = 1;
     percent_value = (select min(d.type_num) from h_ksg_dop d where d.type_num in (50,80,100) and :date_2 between d.bp and d.epv and d.q_u = :q_u and d.ksg = :ksg);
     percent_value_max = (select max(d.type_num) from h_ksg_dop d where d.type_num in (50,80,100) and :date_2 between d.bp and d.epv and d.q_u = :q_u and d.ksg = :ksg);

     if (percent_value is not null) then
     begin
         if (idb is not null) then
          select
                case
                  when a.q_u = 1 and iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) <= 3.0 and (:percent_value = :percent_value_max) then :percent_value*0.01
                  when a.q_u = 3 and iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) <= 3.0  and (:percent_value = :percent_value_max) then :percent_value*0.01
                  else 1
                end
           from zs a
           join zsd b on a.id = b.zs_id
           where b.id = :idb
           into :fine_koef;
      end

     suspend;
end;

