CREATE OR ALTER VIEW V_ZS(
    ID,
    Q_U,
    MP,
    ORDER_V,
    CODE_SPEC,
    CODE_PROF,
    OTD_PROF,
    IS_CHIELD,
    N_HIST,
    DATE_1,
    DATE_2,
    DS0,
    DS1,
    DS2,
    TAR_USL,
    K_USLF,
    K_USL,
    IDSP,
    TARGET,
    RESULT,
    PATIENT_ID,
    FAM,
    IM,
    OT,
    Q_U_NAME,
    TARGET_NAME,
    SUM_USLF,
    HDR_ID,
    DIRECTION_NUM,
    DIRECTION_DATE,
    DH_INFO,
    MES_CODE,
    SMP_BRIG,
    DS3,
    DCOUNT,
    UID,
    PHYS_ID,
    CATEGORY,
    DISP_STAGE,
    DISP_WORK_STATE,
    DISP_RESULT,
    DISP_H_GROUP,
    OUTCOME,
    KSG,
    CAT_INFO,
    IDSP_NAME,
    MP_NAME,
    ORDER_V_NAME,
    DH_INFO_NAME,
    CODE_SPEC_NAME,
    CODE_PROF_NAME,
    IS_CHIELD_NAME,
    SMP_BRIG_NAME,
    RESULT_NAME,
    OUTCOME_NAME,
    FOR_POM,
    VID_HMP,
    METOD_HMP,
    AGE_GRP,
    CHIELD_WITH_ROP,
    FOR_POM_NAME,
    REGISTRY_ID,
    PAYMENT_TYPE_ID,
    PAYMENT_NAME,
    REGISTRY_NAME,
    SUM_USL,
    DOCTOR_FIO,
    DOCTOR_COD,
    NUM_SP,
    IDCASE,
    Q_U_2016,
    HAS_ERRORS,
    CODE_MES1,
    COMENTSL,
    SMO,
    OKATO_SMO,
    OKATO_G,
    OKATO_P,
    SUM_OPL,
    N_ZAP,
    ZSP_VPOLIS,
    ZSP_SPOLIS,
    ZSP_NPOLIS,
    ZSP_POLIS_BP,
    ZSP_POLIS_EP,
    ZSP_SMO_OGRN,
    ZSP_SMO_CODE,
    ZSP_ENP,
    ZSP_SEND_DATE,
    ZSP_RESP_DATE,
    AGE,
    DR,
    DOC_SER,
    DOC_NUM,
    SEX,
    PODR,
    KSLP,
    REG_DATE,
    AGE_NAME,
    M,
    Y,
    CH_NUM,
    INV_STATE,
    KSG_NUM,
    KSG_PROF_NUM,
    NPR_MO,
    PER,
    VBR,
    TAL_D,
    TAL_P,
    INV,
    RSLT_D,
    NAZR,
    NAZ_SP,
    NAZ_V,
    NAZ_PMP,
    NAZ_PK,
    IDSP_NOT_AUTO,
    AGE_GRP_NOT_AUTO,
    USER_ID,
    USER_FIO,
    MSE,
    BARTHEL_IDX,
    CODE_SPEC_V021,
    ID_PAC,
    DISP,
    P_CEL,
    C_ZAB,
    KSG_CRITERION,
    PR_NOV,
    MCOD,
    PR_DATE_1,
    PR_DATE_2,
    DN,
    JOB_NAME)
AS
select z.id,
       z.q_u,
       z.mp,
       z.order_v,
       z.code_spec,
       z.code_prof,
       z.otd_prof,
       z.is_chield,
       z.n_hist,
       z.date_1,
       z.date_2,
       z.ds0,
       z.ds1,
       z.ds2,
       z.tar_usl,
       z.k_uslf,
       z.k_usl,
       z.idsp,
       z.target,
       z.result,  
       z.patient_id,
       p.fam,
       p.im,
       p.ot,
       q_u.name as q_u_name,
       t.name as target_name,
       z.sum_uslf,
       z.hdr_id,
       z.direction_num,
       z.direction_date,
       z.dh_info as dh_info,
       z.mes_code,
       z.smp_brig,
       z.ds3,
       Z.DCOUNT,
       z.uid,
       z.phys_id,
       z.category,
       z.disp_stage,
       z.disp_work_state,
       z.disp_result,
       z.disp_h_group,
       z.outcome,
       z.ksg,
       z.cat_info,
       i.name as idsp_name,
       m.name as mp_name,
       o.name as order_v_name,
       dh.name as dh_info_name,
       iif(z.date_2 >= '01.05.2018', (select name from h_spec_v021 where code = z.code_spec_v021), (select name from h_spec_v015 where code = z.code_spec)) as code_spec_name,
       co.name as code_prof_name,
       iif(z.is_chield = 1, '', '') as is_chield_name,
       sb.name as smp_brig_name,
       r.name as result_name,
       oc.name as outcome_name,
       z.for_pom,
       z.vid_hmp,
       z.metod_hmp,
       z.age_grp,
       z.chield_with_rop,
       fp.name,
       z.registry_id,
       Z.payment_type_id,
       pt.name,
       reg.name,
       z.sum_usl,
       df.fio,
       DF.pcod,
       p.num_sp,  --iif(z.payment_type_id <> 2, p.num_sp, (select ins.ser || ' ' || ins.num from patients_insurance ins where ins.patients_id = p.id and z.date_1 between ins.db and ins.de)),
       z.id_case,
       z.q_u_2016,
       0,--(select first 1 1 from error_list_local err where err.reestr_hdr_id = z.hdr_id and err.uid = z.uid),
       z.mes_code,
       z.comentsl,
       p.smo,
       p.okato_smo,
       p.okato_l,
       p.okato_r,
       z.sum_usl, --(select sum(pi.sum_opl) from patients_invoice pi where pi.zs_id = z.id),
       z.n_zap n_zap,
       zpr.vpolis,
       zpr.spolis,
       zpr.npolis,
       zpr.polis_bp,
       zpr.polis_ep,
       zpr.smo_ogrn,
       zpr.smo_code,
       zpr.enp,
       zp.send_date,
       zpr.resp_date,
       z.age,
       p.dr,
       p.doc_ser,
       p.doc_num,
       p.sex,
       z.podr,
       z.kslp,
       reg.reg_date,
       cast(floor(z.age) as varchar(3)) || '  ' ||
            cast(iif(extract(day from z.date_1) < extract(day from p.dr),
                 iif(extract(month from z.date_1) > extract(month from p.dr), extract(month from z.date_1) - extract(month from p.dr),
                             iif(extract(month from z.date_1) < extract(month from p.dr), 12 - extract(month from p.dr) + extract(month from z.date_1) - 1,
                                 11)),
                 iif(extract(month from z.date_1) > extract(month from p.dr), extract(month from z.date_1) - extract(month from p.dr),
                             iif(extract(month from z.date_1) < extract(month from p.dr), 12 - extract(month from p.dr) + extract(month from z.date_1),
                                   0))) as varchar(2)) || ' ',
       h.m,
       h.y, 
       h.full_name,
       coalesce(inv.status_id,0),
       ksg.ksg_name,
       ksg.prof_name,
       z.npr_mo,
       z.per,
       z.vbr,
       z.tal_d,
       z.tal_p,
       z.inv,
       Z.rslt_d,
       z.nazr,
       z.naz_sp,
       z.naz_v,
       z.naz_pmp,
       z.naz_pk,
       z.idsp_not_auto,
       Z.age_grp_not_auto,
       z.user_id,
       s.fio,
       z.mse,
       z.barthel_idx ,
       z.code_spec_v021,
       z.id_pac,
       Z.disp,
       z.p_cel,
       z.c_zab,
       z.ksg_criterion,
       z.pr_nov,
       z.mcod, 
       z.pr_date_1,
       z.pr_date_2,
       z.dn,
       contr.short_name
from zs z
join patients p on p.id = z.patient_id
join zs_hdr h on h.id = z.hdr_id
left join invoice inv on inv.id = h.name
left join h_q_u q_u on q_u.id = z.q_u
left join h_target t on t.id = z.target
left join h_idsp i on i.id = z.idsp
left join h_mp m on m.code = z.mp
left join h_order_v o on o.id = z.order_v
left join h_dh_info dh on dh.id = z.dh_info
left join h_spec_v015 cs on cs.code = z.code_spec
left join h_code_otd co on co.code = z.code_prof
left join h_smp_brig sb on sb.id = z.smp_brig
left join h_result r on r.code = z.result
left join h_outcome oc on oc.code = z.outcome
left join h_for_pom fp on fp.code = z.for_pom
left join h_payment_type pt on pt.id = z.payment_type_id
left join v_registry reg on reg.id = z.registry_id
left join doctors_fio df on df.id = z.phys_id
left join zsp zp on zp.zs_id = z.id
left join zsp_resp zpr on zpr.zsp_id = zp.id
left join h_ksg ksg on (cast(ksg.ksg as varchar(50))) = z.ksg and z.q_u = ksg.q_u and z.date_2 between ksg.bp and ksg.epv
left join users s on s.id = z.user_id
left join contragents contr on contr.id = p.job_id
where h.is_delete <> 1
;

