ALTER TABLE PAT_ROP ADD DOC_PLACE DM_CHAR_250;

ALTER TABLE PAT_ROP ADD DOC_DATE DM_DATE;

/* Alter View (Drop, Create)... */
/* Drop altered view: V_PATIENTS */

ALTER PROCEDURE SP_GET_REGISTRY_INFO(R_ID INTEGER)
 RETURNS(S /* DM_CHAR_250 */ VARCHAR(250))
 AS
 BEGIN SUSPEND; END;

DROP VIEW V_PATIENTS;

/* Create altered view: V_PATIENTS */
/* Create view: V_PATIENTS */
CREATE VIEW V_PATIENTS(
ID,
SS,
FAM,
IM,
OT,
SEX,
DR,
ADRES,
DOC_TYPE,
DOC_SER,
DOC_NUM,
POLIS_TYPE,
SER_SP,
NUM_SP,
SMO,
OKATO_SMO,
STATUS,
PS_PRZ,
IS_PAID,
JOB,
JOB_ADRES,
POST,
PHONES,
OKATO_R,
OKATO_L,
BPLACE,
ENP,
EMAIL,
ADRES_REG,
MED_HISTORY_NUM,
HIST_NUM,
DOC_PLACE,
DOC_DATE,
SMO_OGRN,
SMO_NAM,
ID_PAC,
INN,
NOVOR,
IS_DELETE,
IS_INSERTING,
ROP_FAM,
ROP_IM,
ROP_OT,
ROP_DR,
ROP_SEX,
ROP_SER_SP,
ROP_NUM_SP,
REG_DATE,
PHONE_MAIN,
INV,
FIO,
PATIENT_TYPE,
SUM_OPL,
PATIENT_TYPE_NAME,
NATIONALITY,
REGION_CODE,
RAYON_CODE,
CITY_CODE,
STREET_CODE,
HOUSE,
HOUSE_IDX,
ROOM,
ROOM_IDX,
ISNOWORKER,
JOB_ID,
ROP_DOC_TYPE,
ROP_DOC_SER,
ROP_DOC_NUM,
ROP_DOC_PLACE,
ROP_DOC_DATE)
 AS 
select
    p.id,
    p.ss,
    p.fam,
    p.im,
    p.ot,
    p.sex,
    p.dr,
    p.adres,
    p.doc_type,
    p.doc_ser,
    p.doc_num,
    p.polis_type,
    p.ser_sp,
    p.num_sp,
    p.smo,
    p.okato_smo,
    p.status,
    p.ps_prz,
    p.is_paid,
    p.job,
    p.job_adres,
    p.post,
    p.phones,
    p.okato_r,
    p.okato_l,
    p.bplace,
    p.enp,
    p.email,
    p.adres_reg,
    p.med_history_num,
    p.hist_num,
    p.doc_place,
    p.doc_date,
    p.smo_ogrn,
    p.smo_nam,
    p.id_pac,
    p.inn,
    p.novor,
    p.is_delete,
    p.is_inserting,
    r.fam as rop_fam,
    r.im as rop_im,
    r.ot as rop_ot,
    r.dr as rop_dr,
    r.sex as rop_sex,
    r.ser_sp as rop_ser_sp,
    r.num_sp as rop_num_sp,
    (select max(rg.reg_date) from registry rg where rg.patients_id = p.id and rg.is_appeared <> 2) reg_date,
    p.phones,
    P.inv,
    COALESCE(p.fam,' ')||' '||COALESCE(p.im,' ')||' '||COALESCE(p.ot, ' ') fio,
    p.patient_type,
    (select sum(i.sum_opl) from patients_invoice i where i.patient_id = p.id),
    t.name,
    p.nationality,
    P.region_code,
    P.rayon_code,
    P.city_code,
    P.street_code,
    P.house,
    P.house_idx,
    P.room,
    P.room_idx,
    P.isnoworker,
    p.job_id,
    r.doc_type,
    r.doc_ser,
    r.doc_num,
    r.doc_place,
    r.doc_date
from patients p
      left join pat_rop r on r.pat_id = p.id
      left join h_patient_type t on t.id = p.patient_type
WHERE p.is_paid = 0
;

DESCRIBE FIELD SS VIEW V_PATIENTS
'';

DESCRIBE FIELD FAM VIEW V_PATIENTS
'';

DESCRIBE FIELD IM VIEW V_PATIENTS
'';

DESCRIBE FIELD OT VIEW V_PATIENTS
'';

DESCRIBE FIELD SEX VIEW V_PATIENTS
'';

DESCRIBE FIELD DR VIEW V_PATIENTS
' ';

DESCRIBE FIELD ADRES VIEW V_PATIENTS
'';

DESCRIBE FIELD DOC_TYPE VIEW V_PATIENTS
' ';

DESCRIBE FIELD DOC_SER VIEW V_PATIENTS
' ';

DESCRIBE FIELD DOC_NUM VIEW V_PATIENTS
' ';

DESCRIBE FIELD POLIS_TYPE VIEW V_PATIENTS
'  ';

DESCRIBE FIELD SER_SP VIEW V_PATIENTS
'  ';

DESCRIBE FIELD NUM_SP VIEW V_PATIENTS
'  ';

DESCRIBE FIELD SMO VIEW V_PATIENTS
'';

DESCRIBE FIELD JOB VIEW V_PATIENTS
' ';

DESCRIBE FIELD POST VIEW V_PATIENTS
'';

DESCRIBE FIELD PHONES VIEW V_PATIENTS
'';

DESCRIBE FIELD EMAIL VIEW V_PATIENTS
'Email';

DESCRIBE FIELD MED_HISTORY_NUM VIEW V_PATIENTS
' ';

DESCRIBE FIELD INN VIEW V_PATIENTS
'';

DESCRIBE FIELD NOVOR VIEW V_PATIENTS
' ';

DESCRIBE FIELD ROP_FAM VIEW V_PATIENTS
' ';

DESCRIBE FIELD ROP_IM VIEW V_PATIENTS
' ';

DESCRIBE FIELD ROP_OT VIEW V_PATIENTS
' ';

DESCRIBE FIELD REG_DATE VIEW V_PATIENTS
'  ';

DESCRIBE FIELD INV VIEW V_PATIENTS
'';

/* Alter Procedure... */
/* Alter (SP_GET_REGISTRY_INFO) */


ALTER PROCEDURE SP_GET_REGISTRY_INFO(R_ID INTEGER)
 RETURNS(S DM_CHAR_250)
 AS
declare variable SMO DM_CHAR_250;
declare variable PACIENT DM_CHAR_200;
declare variable DOCTOR DM_CHAR_200;
declare variable DDATE DM_DATE;
declare variable TTIME_START DM_TIME;
declare variable PHONE DM_CHAR_100;
declare variable COMM DM_CHAR_200;
declare variable RESULT DM_CHAR_200;
declare variable TTIME_END DM_TIME;
declare variable IS_SMS DM_INT;
declare variable IS_MAIL DM_INT;
begin
  select p.fio p_fio, coalesce(p.smo,''), d.fio d_fio, r.time_start, r.time_end, r.reg_date, r.komment, p.PHONE_MAIN tel,
         rr.name result, coalesce(r.is_sms,0), coalesce(r.is_mail,0)
  from registry r
       left join v_patients p on p.id = r.patients_id
       join doctors_fio d on d.id = r.doctors_id
       left join h_registry_result rr on rr.id = r.result
  where r.id = :r_id
  into :pacient, :smo, :doctor, :ttime_start, :ttime_end, :ddate, :comm, :phone, :result, :is_sms, :is_mail;

  if (:smo <> '') then
  begin
      s = ': ' || :smo;
      suspend;
  end

  s = ': ' || :pacient;
  suspend;

  s = ': ' || :doctor;
  suspend;

  s = ' : ' || iif(:ddate = current_date, '', :ddate);
  suspend;

  s = ' :  ' || extract(hour from :ttime_start) || ':' || lpad(extract(minute from :ttime_start), 2, '0') || '  ' ||
      extract(hour from :ttime_end) || ':' || lpad(extract(minute from :ttime_end),2,'0');
  suspend;

  s = ' : ' || :phone;
  suspend;

  s = ' : ' || :result || '. ' || iif(:is_sms = 1, ' . ', '') ||iif(:is_mail = 1, ' Email.', '');

  if (s <> '') then
  suspend;
end;

/* Altering existing trigger... */
ALTER TRIGGER PATIENTS_AD0
AS
begin
  delete from  pat_rop
  where pat_id = old.id;

  delete from patients_insurance i
  where i.patients_id = old.id;

  delete from patients_insurance i
  where i.patients_id = old.id;

  delete from registry r
   where r.patients_id = old.id;

  delete from zs z
   where z.patient_id = old.id;
end;

