/* Create Table... */
CREATE TABLE COMB_SURG(ID DM_ID NOT NULL,
SURG1 DM_CHAR_20,
SURG2 DM_CHAR_20,
BP DM_DATE,
EP DM_DATE);


ALTER TABLE COMB_SURG ADD EPV COMPUTED BY (((cast(iif(ep is null, '31.12.9999', ep) as date))));

CREATE TABLE ZS_CRIT(ID DM_ID NOT NULL,
CODE DM_CHAR_10,
ZSD_ID DM_INT);



ALTER TABLE H_KSG_DOP ADD PERCENT_VALUE DM_INT;

ALTER TABLE INVOICE ADD NPP DM_INT;

DESCRIBE FIELD NPP TABLE INVOICE
'  ';

ALTER TABLE INVOICE ADD CONTRAGENT_SIGN DM_CHAR_2;

ALTER TABLE INVOICE ADD CONTRAGENT_OKATO DM_OKATO;

ALTER TABLE KSG_GRP ADD DS3 DM_DS;

ALTER TABLE KSG_TMP ADD DS2 DM_DS;

ALTER TABLE KSG_TMP ADD DS3 DM_DS;

ALTER TABLE KSG_TMP ADD KSG_GRP_ID DM_INT;

ALTER TABLE XML_STRUCTURE ADD IS_SHOW DM_BOOL;

DESCRIBE FIELD IS_SHOW TABLE XML_STRUCTURE
'   ';

ALTER TABLE XML_STRUCTURE ADD OKATO_REG DM_OKATO;

DESCRIBE FIELD OKATO_REG TABLE XML_STRUCTURE
'  ';

ALTER TABLE ZSD ADD IS_ONK DM_BOOLEAN;

DESCRIBE FIELD IS_ONK TABLE ZSD
'  ';

DESCRIBE FIELD ORG_CODE TABLE CONTRAGENTS
' ';

DESCRIBE FIELD SHORT_NAME TABLE CONTRAGENTS
'  ';

DESCRIBE FIELD FULL_NAME TABLE CONTRAGENTS
'  ';

DESCRIBE FIELD ADRES TABLE CONTRAGENTS
' ';

DESCRIBE FIELD PR_CONS TABLE ONK_CONS
' ';

DESCRIBE FIELD DT_CONS TABLE ONK_CONS
' ';

DESCRIBE FIELD DIAG_TIP TABLE ONK_DIAG
'  ';

DESCRIBE FIELD DIAG_RSLT TABLE ONK_DIAG
'  ';

DESCRIBE FIELD DIAG_CODE TABLE ONK_DIAG
'  ';

DESCRIBE FIELD REC_RSLT TABLE ONK_DIAG
'   ';

DESCRIBE FIELD DIAG_DATE TABLE ONK_DIAG
'  ';

DESCRIBE FIELD REGNUM TABLE ONK_LEK_PR
'  ';

DESCRIBE FIELD CODE_SH TABLE ONK_LEK_PR
'   ';

DESCRIBE FIELD DATE_INJ TABLE ONK_LEK_PR
'   ';

DESCRIBE FIELD TIME_INJ TABLE ONK_LEK_PR
'   ';

DESCRIBE FIELD NAPR_DATE TABLE ONK_NAPR
' ';

DESCRIBE FIELD NAPR_V TABLE ONK_NAPR
' ';

DESCRIBE FIELD MET_ISSL TABLE ONK_NAPR
'  ';

DESCRIBE FIELD NAPR_USL TABLE ONK_NAPR
'  (),   ';

DESCRIBE FIELD MO_CODE TABLE ONK_NAPR
' ,   ';

DESCRIBE FIELD PROT TABLE ONK_PROT
'   ';

DESCRIBE FIELD D_PROT TABLE ONK_PROT
'    ';

DESCRIBE FIELD STAD TABLE ONK_SL
' ';

DESCRIBE FIELD ONK_T TABLE ONK_SL
'Tumor';

DESCRIBE FIELD ONK_N TABLE ONK_SL
'Nodus';

DESCRIBE FIELD ONK_M TABLE ONK_SL
'Metastasis';

DESCRIBE FIELD MTSTZ TABLE ONK_SL
'   ';

DESCRIBE FIELD SOD TABLE ONK_SL
'  ';

DESCRIBE FIELD DS1_T TABLE ONK_SL
' ';

DESCRIBE FIELD K_FR TABLE ONK_SL
' ';

DESCRIBE FIELD WEI TABLE ONK_SL
' ';

DESCRIBE FIELD HEI TABLE ONK_SL
'';

DESCRIBE FIELD BSA TABLE ONK_SL
'  ';

DESCRIBE FIELD USL_TIP TABLE ONK_USL
' ';

DESCRIBE FIELD HIR_TIP TABLE ONK_USL
'  ';

DESCRIBE FIELD LEK_TIP_L TABLE ONK_USL
'  ';

DESCRIBE FIELD LEK_TIP_V TABLE ONK_USL
'  ';

DESCRIBE FIELD LUCH_TIP TABLE ONK_USL
'  ';

DESCRIBE FIELD PPTR TABLE ONK_USL
'      ';

DESCRIBE FIELD VB_P TABLE ZS
'  ';

/* Create Procedure... */

CREATE PROCEDURE SP_CALC_STAC_2020(IDA INTEGER)
 AS
 BEGIN EXIT; END;

CREATE PROCEDURE SP_CALC_STAC_FINE_2020(IDA INTEGER,
IDB INTEGER,
KSG DM_CHAR_20,
CL_CNT INTEGER)
 RETURNS(FINE_KOEF TYPE OF DM_NUM_3_2)
 AS
 BEGIN SUSPEND; END;

CREATE PROCEDURE SP_CALC_STAC_KSKP_2020(IDA INTEGER,
IDB INTEGER,
KSG DM_CHAR_20,
CL_CNT INTEGER)
 RETURNS(KSKP DM_NUM_2_6)
 AS
 BEGIN SUSPEND; END;

CREATE PROCEDURE SP_DUPLICATE_XML_STRUCT(STRUCT_ID INTEGER)
 AS
 BEGIN EXIT; END;

CREATE PROCEDURE SP_KSG_GET_2020(IDB INTEGER = null)
 RETURNS(KSG DM_CHAR_20,
ERR_CODE INTEGER)
 AS
 BEGIN SUSPEND; END;


/* Alter View (Drop, Create)... */

DROP VIEW V_INVOICES;

/* Create altered view: V_INVOICES */
/* Create view: V_INVOICES */
CREATE VIEW V_INVOICES(
ID,
INVOICE_NAME,
LPU,
M,
Y,
CONTRAGENT_ID,
CONTRAGENT_CODE,
INV_ID,
NPP)
 AS 
select z.id,  COALESCE(z.full_name,'') || '/ ' ||COALESCE(c.short_name,'') || '/ ' || COALESCE(c2.short_name,''),
       i.lpu, z.m, z.y, i.contragent_id, c2.org_code, i.id, i.npp
from zs_hdr z left join invoice i on i.id = z.name
     left join contragents c on c.org_code = i.lpu
     left join contragents c2 on c2.id = i.contragent_id
where z.is_delete = 0
;

/* Create index... */
CREATE INDEX H_KSG_IDX1 ON H_KSG(KSG);

CREATE INDEX H_KSG_IDX2 ON H_KSG(BP);

CREATE INDEX ZS_CRIT_IDX1 ON ZS_CRIT(CODE);

CREATE INDEX ZS_CRIT_IDX2 ON ZS_CRIT(ZSD_ID);


/* Create generator... */
CREATE GENERATOR GEN_COMB_SURG_ID;

CREATE GENERATOR GEN_ZS_CRIT_ID;


/* Create Primary Key... */
ALTER TABLE COMB_SURG ADD CONSTRAINT PK_COMB_SURG PRIMARY KEY (ID);

ALTER TABLE ZS_CRIT ADD CONSTRAINT PK_ZS_CRIT PRIMARY KEY (ID);

/* Alter Procedure... */
/* empty dependent procedure body */
/* Clear: SP_CALC_ALL_CH for: SP_CALC_ALL */

ALTER PROCEDURE SP_CALC_ALL_CH(HDR_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* empty dependent procedure body */
/* Clear: SP_ZS_SET_ZACHET for: SP_CALC_ALL */
ALTER PROCEDURE SP_ZS_SET_ZACHET(HDR_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* empty dependent procedure body */
/* Clear: SP_ZSD_LIST_CREATE for: SP_CALC_ALL */
ALTER PROCEDURE SP_ZSD_LIST_CREATE(ZS_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* Alter (SP_CALC_ALL) */
ALTER PROCEDURE SP_CALC_ALL(ZS_ID INTEGER)
 AS
declare variable TAR DM_MONEY_15_2;
declare variable DATE1 DM_DATE;
declare variable Q_U integer;
declare variable TAR_USL DM_MONEY_15_2;
declare variable TARGET integer;
declare variable IDB integer;
declare variable SUM_USLF DM_MONEY_15_2;
declare variable SEX char(1);
declare variable PTYPE integer;
declare variable AGE_Y integer;
declare variable AGE_GRP integer;
declare variable HDR_ID integer;
declare variable TROMB_CODE DM_CHAR_20;
declare variable TAR_USL_DOP DM_MONEY_15_2;
declare variable SUM_USLF_DOP DM_MONEY_15_2;
declare variable IDSP integer;
declare variable MMB DM_NUM_3_2;
declare variable OKATO DM_OKATO;
begin
  select z.date_2, z.q_u, z.target, p.sex, z.payment_type_id, extract(year from z.date_2) - extract(year from p.dr), z.hdr_id, iif(coalesce(z.vbr,0) = 0, 1, 1.2)
  from zs z
  join patients p on p.id = z.patient_id
  where z.id = :zs_id
  into :date1, :q_u, :target, :sex, :ptype, :age_y, :hdr_id, :mmb;

  okato = (select first 1 c.tf_okato from contragents c where c.type_id = 1);

  if (:okato is null) then okato = '71140';

  if (:ptype in (2,3)) then exit;

  if (:target in (9,10,11,12,13,14,15,16,17)) then
  begin
   if ((select coalesce(t.days_cnt,0) from h_target t where t.id = :target) <> 0) then
   begin
    update zsd d
     set d.zachet = 1
     where d.date_1 < (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;

    update zsd d
     set d.zachet = 0
     where d.date_1 >= (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;
   end

   update zsd d
    set d.k_uslf = 0
    where (d.zachet = 1 or d.is_no_get_usl = 1 or d.zachet_stac = 1) and d.zs_id = :zs_id;
  end

  update zsd d
    set d.tar_usl = null,
        d.sum_uslf = null,
        d.comment_local = null,
        d.dop_tarif = null,
        d.dop_sum = null
    where d.zs_id = :zs_id;

  update zs z
    set z.tar_usl = null,
        z.sum_usl = null,
        z.sum_uslf = null
    where z.id = :zs_id;

  if ((select coalesce(i.is_nz,0) from invoice i join zs_hdr h on h.name = i.id where h.id = :hdr_id) = 1) then
  begin
    if (target in (9,10,11,13,14,15,16,17)) then exit;

    tar = (select first 1 s.tarif from h_tarif_nz s where s.q_u = iif(:q_u = 4,2,:q_u) and :date1 between s.bp and s.epv);

    if (q_u = 1) then
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id and d.code_usl is null;
    else
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id;

    if (q_u = 4) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = z.dcount*:tar
      where id = :zs_id;
    else
    if (q_u = 1) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = :tar
      where id = :zs_id;
    else
      update zs z
      set z.tar_usl = :tar,
          z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
      where id = :zs_id;
    exit;
  end
   /********************,    ************************/
  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 < '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin

          select first 1 h.tarif, h.tarif
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
                                 and cast(h.code_spec as varchar(10)) = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec = '16' and a.age < 18, '22', b.code_spec), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf;

          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0)
           where b.id = :idb;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end

  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 >= '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (:tar is null) then
          select first 1 h.tarif, h.tarif, a.idsp
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           left join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
                                 and h.idsp = a.idsp
           join h_tarif_app_spec n on n.name_id = h.name_id
                                 and n.code_spec_v021 = iif(b.code_spec_v021 = 39 and a.age < 18, 49, b.code_spec_v021)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf, :idsp;

          if (:okato = '71140') then
          update ZSD b set
           b.tar_usl = iif(:idsp = 30, 0, coalesce(:tar, 0)),
           b.sum_uslf = cast(iif(:idsp = 30, 0, coalesce(:sum_uslf, 0))*:mmb as int),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;
          else
           update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          if (:idsp <> 30) then
          begin
            tar = null;
            sum_uslf = null;
          end
        end

     if ((:idsp = 30) and (:okato = '71140')) then
       update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = cast(coalesce(:sum_uslf, 0)*:mmb as int)
           where b.id = :idb;

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce((select sum(d.tar_usl) from zsd d where d.zs_id = a.id), 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end  

  /********************************************/
  if (:q_u = 4) then
  begin
    tar = (select s.tarif from h_tarif_stom s where :date1 between s.bp and s.epv);

    update zsd d
    set d.tar_usl = :tar,
        d.sum_uslf = cast(d.k_uslf*:tar*:mmb as numeric(15,2))
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = :tar,
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if (:q_u = 5) then
  begin
--    if (:date1 >= '01.01.2018') then tromb_code = 'A25.30.036';
--    else tromb_code = 'A25.30.035';
    tromb_code = coalesce((select first 1 code_usl from zsd d where d.zs_id = :zs_id and coalesce(code_usl, '') <> ''),'');

    tar = (select s.tarif from h_tarif_smp s where :date1 between s.bp and s.epv);
    tar_usl = coalesce((select coalesce(u.sumf,0) from h_usl u where u.code = :tromb_code
               and u.q_u containing '5' and :date1 between u.datebeg and u.dateend),0);

    update zsd d
    set d.tar_usl = iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl),
        d.sum_uslf = d.k_uslf*iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl)
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = (select max(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if ((:q_u = 1) and ((select 1 from zs z where coalesce(z.metod_hmp,0) > 0 and id = :zs_id) = 1)) then
  begin
    select first 1 v.tarif
    from zs z
         join h_metod_hmp h on h.code = z.metod_hmp and z.date_2 between h.bp and h.epv
         join h_tarif_vmp v on v.tg = h.tg and z.date_2 between v.bp and v.epv
    where z.id = :zs_id
    into :tar;

    update zs a set
        a.tar_usl = :tar,
        a.sum_uslf = :tar,
        a.ksg = null,
        a.kslp = null
    where a.id = :zs_id;

    update zsd b set
          b.ksg = null,
          b.sum_uslf = :tar,
          b.kskp = 0,
          b.tar_usl = :tar
    where b.zs_id = :zs_id and coalesce(b.code_usl,'') = '' and b.date_1 = (select min(date_1) from zsd where zs_id = :zs_id and coalesce(code_usl,'') = '');

    exit;
  end

  /********************************************/
  if (:q_u in (1,3) and :date1 < '01.01.2018') then
    execute procedure SP_CALC_STAC(:zs_id);
  else
    if (:q_u in (1,3) and :date1 < '01.01.2020') then
      execute procedure sp_calc_stac_2018(:zs_id);
  else
    if (:q_u in (1,3) and :date1 >= '01.01.2020') then
      execute procedure sp_calc_stac_2020(:zs_id);

  /****************  ***********************************************/
  if (q_u <> 4) then
  begin
  tar = null;
  sum_uslf = null;
  for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (coalesce(:tar,0) > 0) then
          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          tar = null;
          sum_uslf = null;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);
     tar = (select sum(b.tar_usl) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_tarif,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:tar, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
   end

  /*********************-*********************************/
  if ((:q_u = 2) and (:target in (21,22))) then
  begin
   for select b.id
    from zsd b
    join zs z on z.id = b.zs_id
    where z.id = :zs_id
    into :idb
    do
    begin
      tar = (select first 1 t.tarif
             from zsd d
                  join h_tomo_code c on c.nms_code = d.code_usl
                  join h_tarif_tomo t on t.group_num = c.group_num and d.date_2 between t.bp and t.epv
             where d.id = :idb);

      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf = :tar
      where d.id = :idb;
    end

    update zs z
    set z.tar_usl = (select sum(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;

    exit;
  end
  /******************** - 9  ************************/
  if ((:q_u = 2 and :target = 9) or (q_u = 2 and :target = 16 and date1 >= '01.05.2019'))  then
  begin
    execute procedure sp_calc_app_t09(:zs_id);
    exit;
  end

  /******************** - 10,17  -  ************************/
    if (q_u = 2 and target in (10,17)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_10 d on d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and :age_y between d.y1 and d.y2
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = cast(coalesce(b.k_uslf * :tar, 0)*:mmb as int),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 13  ************************/
    if (q_u = 2 and target = 13) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                           and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_13_17 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.age_grp = a.age_grp
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = cast(coalesce(b.k_uslf * :tar, 0)*:mmb as int),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 14,15  ,  ************************/
    if (q_u = 2 and target in (14,15)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_14_15 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.cat_info = a.cat_info
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = cast(coalesce(b.k_uslf * :tar, 0)*:mmb as int),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
  /******************** - 16  ************************/
    if (q_u = 2 and target = 16 and date1 < '01.05.2019') then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join zs_hdr h on h.id = a.hdr_id
                   join patients p on p.id = a.patient_id
                   join h_tarif_disp_16 d on a.date_2 between d.bp and d.epv
                                          and d.sex = :sex
                                          and cast(d.code_usl as varchar(20)) = b.code_usl
                                          and d.age_l <= (h.y - extract(year from p.dr)) and d.age_r >= (h.y - extract(year from p.dr))
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = cast(coalesce(b.k_uslf * :tar, 0)*:mmb as int),
               b.tar_base = coalesce(:tar, 0) ,
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
end;

/* Alter (SP_CALC_ALL_CH) */
ALTER PROCEDURE SP_CALC_ALL_CH(HDR_ID INTEGER)
 AS
declare variable ZID integer;
begin

 for select z.id
  from zs z
  where z.hdr_id = :hdr_id
  into :zid
  do
    execute procedure SP_CALC_ALL(:ZID);

  update invoice i
  set i.sumv = (select sum(z.sum_uslf) from zs z where z.hdr_id = :hdr_id),
      i.sump = (select sum(z.sum_usl) from zs z where z.hdr_id = :hdr_id)
  where i.id = (select name from zs_hdr h where h.id = :hdr_id);
end;

/* Alter (SP_REESTR_EXTRACT_FOR_V2018) */
ALTER PROCEDURE SP_REESTR_EXTRACT_FOR_V2018(H_ID INTEGER)
 AS
declare variable D_ID integer;
declare variable ZS_ID integer;
declare variable DATE1 date;
declare variable DATE2 date;
declare variable PHYS_ID integer;
declare variable CODE_SPEC integer;
declare variable HDR_ID integer;
declare variable STAGE integer;
begin
for select h.id
    from zs_hdr h
    where h.id = :h_id or (h.parent_id = :h_id)
    into :hdr_id
    do
    begin
      update zs z
       set z.vb_p = 1
       where z.hdr_id = :hdr_id and (select count(id) from zsd d where d.zs_id = z.id and z.q_u in (1,3) and coalesce(d.code_usl,'') = '') > 1;
      /******************************************************************/
--      for select d.id, z.id, d.date_1, d.date_2
--          from zs z
--               join zsd d on d.zs_id = z.id
--          where z.hdr_id = :hdr_id and z.q_u in (1,3) and coalesce(d.code_usl,'') = ''
--          into :d_id, :zs_id, :date1, :date2
--          do
--          begin
--            update zsd d
--             set d.zsd_id = :d_id
--             where d.id = :d_id;
--    
--            update zsd d
--             set d.zsd_id = :d_id
--             where d.zs_id = :zs_id and coalesce(d.code_usl,'') <> ''
--                   and d.date_1 between :date1 and :date2
--                   and not exists(select id from zsd d2 where d2.zs_id = :zs_id and coalesce(d2.code_usl,'') = '' and d2.date_1 = d.date_1 and d2.id <> :d_id);
--          end

      for select d.id, z.id, d.date_1, d.date_2
          from zs z
               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u in (1,3) and (not exists(select dd.id from zsd dd where dd.zs_id = z.id
                                                                     and dd.date_1 <=d.date_1 and dd.date_2 >= d.date_2 and dd.id <> d.id) )
--                and d.ksg is not null
          order by d.ksg desc
          into :d_id, :zs_id, :date1, :date2
          do
          begin
            update zsd d
             set d.zsd_id = :d_id
             where d.id = :d_id;
    
            update zsd d
             set d.zsd_id = :d_id
             where d.zs_id = :zs_id and coalesce(d.code_usl,'') <> ''
                   and d.date_1 between :date1 and :date2
                   and not exists(select id from zsd d2 where d2.zs_id = :zs_id and d2.date_1 = d.date_1 and d2.id <> :d_id and d2.id <> d.id);
--                   and d.ksg is null;
          end

--        for select d.id, z.id, z.date_1, z.date_2
--          from zs z
--               join zsd d on d.zs_id = z.id
--          where z.hdr_id = :hdr_id and z.q_u in (1,3) and not exists(select dd.id from zsd dd where dd.zs_id = z.id and coalesce(dd.code_usl,'') = '')
--                and not exists(select dd.id from zsd dd where dd.zs_id = z.id and dd.ksg is not null)
--          into :d_id, :zs_id, :date1, :date2
--          do
--          begin
--            update zsd d
--             set d.zsd_id = :d_id
--             where d.id = :d_id;
--    
--            update zsd d
--             set d.zsd_id = :d_id
--             where d.zs_id = :zs_id and coalesce(d.code_usl,'') <> ''
--                   and d.date_1 between :date1 and :date2
--                   and not exists(select id from zsd d2 where d2.zs_id = :zs_id and coalesce(d2.code_usl,'') = '' and d2.date_1 = :date2)
--                   and d.ksg is null;
--          end
      /***********  ***********************************************/
      for select z.id, d.phys_id, d.code_spec_v021, z.date_1, z.date_2
          from zs z
               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u in (2,5) and z.target not in (9,10,11,12,13,14,15,16,17,21,22)
          group by 1,2,3,4,5
          into :zs_id, :phys_id, :code_spec, :date1, :date2
          do
          begin
            d_id = (select first 1 id from zsd d where d.zs_id = :zs_id /*and d.phys_id = :phys_id*/ and d.code_spec_v021 = :code_spec and d.date_1 between :date1 and :date2 order by d.date_1 desc);
    
            update zsd d
             set d.zsd_id = :d_id
             where d.zs_id = :zs_id and d.date_1 between :date1 and :date2 /*and d.phys_id = :phys_id*/ and d.code_spec_v021 = :code_spec;
            d_id = null;
          end

      /***********  ***********************************************/
      for select z.id, d.phys_id, d.code_spec_v021, d.date_1, d.date_2
          from zs z
               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u in (4) and z.target not in (9,10,11,12,13,14,15,16,17,21,22)
          group by 1,2,3,4,5
          into :zs_id, :phys_id, :code_spec, :date1, :date2
          do
          begin
            d_id = (select first 1 id from zsd d where d.zs_id = :zs_id and d.phys_id = :phys_id and d.code_spec_v021 = :code_spec and d.date_1 = :date1 and d.date_2 = :date2);
    
            update zsd d
             set d.zsd_id = :d_id
             where d.zs_id = :zs_id and d.date_1 between :date1 and :date2 and d.phys_id = :phys_id and d.code_spec_v021 = :code_spec;
            d_id = null;
          end
      /***********  ***********************************************/
      for select z.id, z.disp_stage
          from zs z
--               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u in (2) and z.target in (9,10,11,12,13,14,15,16,17) --and d.code_usl in ('1','16')
          group by 1,2
          into :zs_id, :stage
          do
          begin
            d_id = (select first 1 id from zsd d where d.zs_id = :zs_id and (d.code_usl in ('1','16','66','67','68','69','B04.047.002',
                    'B04.023.002','B04.057.002','B04.018.002','B01.053.001','B04.001.002','B04.028.002','B04.029.004','B04.070.005','B04.047.002','B04.047.002.099') or :stage = 2) order by d.date_1);
            update zsd d
             set d.zsd_id = :d_id
             where d.zs_id = :zs_id;
            d_id = null;
          end
      /***********-***********************************************/
      for select z.id
          from zs z
--               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u = 2 and z.target in (21,22)
          group by 1
          into :zs_id
          do
          begin
            d_id = (select first 1 id from zsd d where d.zs_id = :zs_id order by d.date_1);
            update zsd d
             set d.zsd_id = :d_id
             where d.zs_id = :zs_id;
            d_id = null;
          end
    end
end;

/* Alter (SP_ZS_SET_ZACHET) */
ALTER PROCEDURE SP_ZS_SET_ZACHET(HDR_ID INTEGER)
 AS
declare variable ZS_ID integer;
declare variable DATE1 DM_DATE;
begin
  for select z.id, z.date_1
      from zs z
      where z.hdr_id = :hdr_id
      into :zs_id, :date1
      do
      begin
        update zsd d
         set d.zachet = 1
         where d.zs_id = :zs_id and d.date_1 < :date1;

        execute procedure SP_CALC_ALL(:ZS_ID);
      end
end;

/* Alter (SP_ZSD_LIST_CREATE) */
ALTER PROCEDURE SP_ZSD_LIST_CREATE(ZS_ID INTEGER)
 AS
declare variable TARGET integer;
declare variable DE date;
begin
  target = (select target from zs where id = :zs_id);
  de = (select z.date_2 from zs z where id = :zs_id);

  if (exists (select id from zsd where zs_id = :zs_id)) then
   exit;

  if (target = 9) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.code_usl, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, 'Z00.8', 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_09 d on d.stage = z.disp_stage and d.age = extract(year from z.date_1) - extract(year from p.dr)
                                      and d.sex = p.sex and z.date_2 between d.bp and d.epv
            join h_usl u on u.code = d.code_usl  and d.bp between u.datebeg and u.dateend
       where z.id = :zs_id and d.code_usl is not null and d.tarif is not null and
             u.target containing '9' and u.q_u containing '2' and z.date_2 between bp and epv;
  end

  if (target in (10,17)) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.usl_code, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, iif(z.age < 3, 'Z00.1', iif(z.age >= 3 and z.age < 15, 'Z00.2', 'Z00.3')), 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_10 d on d.stage = z.disp_stage and d.sex = p.sex
                                          and z.date_2 between d.bp and d.epv
                                          and z.age between d.y1 and d.y2
       where z.id = :zs_id and d.tarif is not null;
  end

  if (target = 13) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.usl_code, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, iif(z.age < 3, 'Z00.1', iif(z.age >= 3 and z.age < 15, 'Z00.2', 'Z00.3')), 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_13_17 d on d.target = z.target
                                          and d.stage = z.disp_stage and d.sex = p.sex
                                          and z.date_2 between d.bp and d.epv
                                          and d.age_grp = z.age_grp
       where z.id = :zs_id and d.tarif is not null;
  end

  if (target in (14,15)) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.usl_code, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, iif(z.age < 3, 'Z00.1', iif(z.age >= 3 and z.age < 15, 'Z00.2', 'Z00.3')),1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_14_15 d on d.target = z.target
                                          and d.stage = z.disp_stage and d.sex = p.sex
                                          and z.date_2 between d.bp and d.epv
                                          and d.cat_info = z.cat_info
       where z.id = :zs_id and d.tarif is not null;
  end

  if ((target = 16) and (:de < '01.05.2019')) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.code_usl, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, 'Z00.8', 1
       from zs z
            join patients p on p.id = z.patient_id
            join zs_hdr h on h.id = z.hdr_id
            join h_tarif_disp_16 d on z.date_2 between d.bp and d.epv
                                          and d.sex = p.sex
                                          and d.age_l <= (h.y - extract(year from p.dr)) and d.age_r >= (h.y - extract(year from p.dr))
       where z.id = :zs_id and d.tarif is not null;
  end

  if ((target = 16) and (:de >= '01.05.2019')) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.code_usl, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, 'Z00.8', 1
       from zs z
            join patients p on p.id = z.patient_id
            join zs_hdr h on h.id = z.hdr_id
            join h_tarif_disp_09 d on d.stage = z.disp_stage and d.age = extract(year from z.date_1) - extract(year from p.dr)
                                      and d.sex = p.sex and z.date_2 between d.bp and d.epv
            join h_usl u on u.code = d.code_usl  and d.bp between u.datebeg and u.dateend
       where z.id = :zs_id and d.tarif is not null and
             u.target containing '16' and u.q_u containing '2' and z.date_2 between bp and epv
             and ((u.code <> iif(((extract(year from z.date_1) - extract(year from p.dr)) > 39) and (p.sex = ''), 'B04.001.002.099', '')));
  end

  insert into ZS_DS (DS, DS_TYPE, SECTION, SECTION_ID, PR, IS_TEMP)
    select d.ds, 1, 2, d.id, 0, 1
    from zsd d
    where d.zs_id = :zs_id;

  execute procedure SP_CALC_ALL(:ZS_ID);
end;

/* Restore proc. body: SP_CALC_STAC_2020 */
ALTER PROCEDURE SP_CALC_STAC_2020(IDA INTEGER)
 AS
declare variable KSG type of DM_CHAR_50;
declare variable DS type of DM_DS;
declare variable IDB integer;
declare variable SUM_USLF type of DM_MONEY;
declare variable KSKP numeric(6,6);
declare variable Q_U integer;
declare variable FINE_KOEF type of DM_NUM_3_2;
declare variable TARIF numeric(10,6);
declare variable IS_TRANSFER DM_INT;
declare variable CL_CNT integer;
declare variable ERR_CODE integer;
declare variable K_DOWN DM_NUM_6_2;
declare variable DS_CLASS DM_CHAR_10;
declare variable KZ DM_NUM_2_5;
declare variable KD DM_NUM_2_5;
declare variable KUS DM_NUM_2_5;
declare variable BS DM_NUM_6_2;
declare variable PROF_NUM integer;
declare variable FINE_KOEF_SET_DOCTOR DM_BOOLEAN;
declare variable IS_ROUND_JANAO integer;
declare variable OKATO DM_OKATO;
declare variable DOP_CODE DM_CHAR_40;
declare variable DATE1 DM_DATE;
declare variable DATE2 DM_DATE;
begin
  select c.tf_okato
   from zs_hdr h
        join zs z on z.hdr_id = h.id
        join invoice i on i.id = h.name
        join contragents c on c.id = i.contragent_id
   where z.id = :ida
   into :okato;

   -----------------------------------------------------------------------------
   --    
   for select d.id, d.date_1, d.date_2
          from zs z
               join zsd d on d.zs_id = z.id
          where z.id = :ida and (not exists(select dd.id from zsd dd where dd.zs_id = :ida
                                                                     and dd.date_1 <=d.date_1 and dd.date_2 >= d.date_2 and dd.id <> d.id) )
          order by d.ksg desc
          into :idb, :date1, :date2
          do
          begin
            update zsd d
             set d.zsd_id = :idb
             where d.id = :idb;
    
            update zsd d
             set d.zsd_id = :idb
             where d.zs_id = :ida and coalesce(d.code_usl,'') <> ''
                   and d.date_1 between :date1 and :date2
                   and not exists(select id from zsd d2 where d2.zs_id = :ida and d2.date_1 = d.date_1 and d2.id <> :idb and d2.id <> d.id);
          end
   -----------------------------------------------------------------------------
   if (:okato is  null) then
     okato = (select first 1 c.tf_okato from contragents c where c.type_id = 1);

    if (okato = '71140') then
      is_round_janao = 1;

    update zsd d
      set d.ds_class = (select MKB_CLASS from SP_GET_MKB_CLASS(D.ds))
      where d.zs_id = :ida;

    update zsd d
     set d.ksg = null, 
         d.ksg_base = null,
         d.tar_base = null,
         d.sum_base = null,
         d.kskp_base = null,
         d.sum_uslf = 0,
         d.tar_usl = 0,
         d.comment_local = null
     where d.zs_id = :ida;

    update zs z
     set z.ksg = null,
         z.tar_usl = 0,
         z.sum_usl = 0
     where z.id = :ida;

     cl_cnt = (select count(distinct b.ds_class) from ZSD b where b.ZS_ID = :ida and coalesce(b.code_usl,'') = '');
     is_transfer = (select sum(iif(b.code_usl is null, 1, 0)) from ZSD b where b.ZS_ID = :ida);
     delete from kslp_koef where zs_id = :ida ;

     select a.q_u, a.date_2, coalesce(a.fine_koef_set_doctor,0)
      from zs a
      where a.id = :ida
      into :q_u, :date2, :fine_koef_set_doctor;

     for select sp.KSG, sp.ERR_CODE, b.ds, b.id, iif(:is_round_janao = 1,
                coalesce(bs.tarif * kd.kd * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0),
                coalesce(bs.tarif * kd.kd * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0)),
                k.kz, kd.kd,
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0),
                bs.tarif, k.k_down, k.prof_num, b.date_1, coalesce(b.fine_koef,1)
      from zs a
      join zsd b on a.id = b.zs_id
      join patients p on p.id = a.patient_id
      join lpu_factors lf on lf.q_u = a.q_u and a.date_2 between lf.bp and lf.epv and lf.okato is not distinct from :okato
      join h_tarif_bs bs on bs.q_u = a.q_u and a.date_2 between bs.bp and bs.epv and bs.okato is not distinct from :okato
      join h_tarif_kd kd on a.date_2 between kd.bp and kd.epv and kd.okato is not distinct from :okato
      left join sp_ksg_get_2020(b.id) sp on 1=1
      left join h_ksg k on k.ksg = sp.ksg and a.date_2 between k.bp and k.epv and k.q_u = a.q_u
      where b.zs_id = :ida and b.id = b.zsd_id
      order by b.code_usl
      into :ksg, :err_code, :ds, :idb, :tarif, :kz, :kd, :kus, :bs, :k_down, :prof_num, :date1, :fine_koef
      do
      begin
        kskp = 1;

        if (:okato = '70000') then
        begin
          select first 1 u.code_1, u.code_2
           from zsd d
                join h_usl u on u.code = d.code_usl and u.payment_type_id = 1 and :date1 between u.datebeg and u.dateend and u.q_u containing :q_u
           where d.id = :idb
          into :ksg, :dop_code;
        end

        if ((q_u in (1,3)) and (err_code is null)) then
          kskp = (select KSKP from sp_calc_stac_kskp_2020(:ida, :idb, :ksg, :cl_cnt));

        if (kskp is null) then kskp = 1;

        if (fine_koef_set_doctor = 0) then
          fine_koef = (select FINE_KOEF from sp_calc_stac_fine_2020(:ida, :idb, :ksg, :cl_cnt));

        if (is_round_janao = 1) then
          sum_uslf = cast(cast(tarif * kskp as int) * fine_koef as int);
        else
          sum_uslf = cast(tarif * kskp as numeric(15,2)) * fine_koef;

        if (:ksg is not null) then
        begin
            update zsd b set
             b.ksg_base = :ksg,
             b.tar_base = iif(:is_round_janao = 1, cast(:tarif*coalesce(:kskp,1) as int), cast(:tarif*coalesce(:kskp,1) as numeric(15,2))),
             b.sum_base = :sum_uslf,
             b.kskp_base = :kskp,
             b.koef_z = :kz, 
             b.koef_d = :kd,
             b.koef_u = :kus,
             b.bs = :bs,
             b.koef_up = :k_down,
             b.reab = iif(:prof_num = 37,1,null),
             b.fine_koef = :fine_koef,
             b.dop_code_usl = iif(:okato = '70000', :dop_code, b.dop_code_usl)
             where b.id = :idb;
         end
      end 
--------------------------------------------------------------------------------
      --    6  + 
      if (q_u = 1) then
       if (exists (select 1 from zsd b where b.zs_id = :ida and ((b.ksg in ('st02.001') and b.k_uslf >= 6) or (b.ksg in ('O14.1','O34.2','O36.3','O36.4','O42.2') and b.k_uslf >= 2) ))
          and exists (select 1 from zsd b where b.zs_id = :ida and b.ksg in ('st02.003', 'st02.004'))) then
          begin
            --    
            select first 1 b.ksg_base, b.ds
            from zs a
             join zsd b on a.id = b.zs_id
             where b.zs_id = :ida and b.ksg in ('st02.003', 'st02.004')
             into :ksg, :ds;
       
            update zsd d
            set d.tar_usl = d.tar_base,
                d.sum_uslf = d.sum_base,
                d.ksg = d.ksg_base,
                d.kskp = d.kskp_base
            where d.zs_id = :ida;

            --   
            select coalesce(sum(b.sum_uslf), 0) from zsd b where b.zs_id = :ida
             into :sum_uslf;
    
            update zs a set
             a.tar_usl = :tarif,
             a.sum_uslf = :sum_uslf,
             a.sum_usl = :sum_uslf,
             a.ksg = :ksg,
             a.ds1 = :ds,
             a.kslp = :kskp
             where a.id = :ida;

            exit;
          end
--------------------------------------------------------------------------------
      if ((is_transfer < 2) or (cl_cnt < 2))  then  --   
      begin
        --     ,   
        ksg = null;
--        select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base, b.kskp_base, b.koef_z, b.koef_d, b.koef_u, b.bs, b.koef_up,
--             b.fine_koef
--             from zsd b
--             where b.zs_id = :ida and b.ksg_base is not null --and ((:q_u = 1 and b.ksg_base >= '325' and b.ksg_base <= '343') or
--                                                                                                  (:q_u = 3 and b.ksg_base >= '123' and b.ksg_base <= '134'))
--             order by b.code_usl desc, b.sum_base desc
--             into :idb, :ksg, :sum_uslf, :tarif, :kskp, :kz, :kd, :kus, :bs, :k_down, :fine_koef;

        if (:ksg is null)  then
        begin
         select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base, b.date_1,
             b.kskp_base, b.koef_z, b.koef_d, b.koef_u, b.bs, b.koef_up,
             b.fine_koef
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif, :date1,
                  :kskp, :kz, :kd, :kus, :bs, :k_down, :fine_koef;

         if (((select coalesce(d.code_usl,'') from zsd d where d.id = :idb) <> '')
            and (exists(select d.id from zsd d where d.zs_id = :ida and d.id <> :idb and coalesce(d.code_usl,'') = '' and :date1 between d.date_1 and d.date_2))) then
         select first 1 d.id
             from zsd d
             where d.zs_id = :ida and d.id <> :idb and coalesce(d.code_usl,'') = '' and :date1 between d.date_1 and d.date_2
             order by d.date_1 desc, d.date_2 desc
             into :idb;
        end

         --      
         update zsd b set
             b.ksg = :ksg,
             b.sum_uslf = :sum_uslf,
             b.ksg_base = :ksg,
             b.tar_usl = :tarif,
             b.tar_base = :tarif,
             b.sum_base = :sum_uslf,
             b.kskp_base = :kskp,
             b.koef_z = :kz, 
             b.koef_d = :kd,
             b.koef_u = :kus,
             b.bs = :bs,
             b.koef_up = :k_down,
             b.reab = iif(:prof_num = 37,1,null),
             b.fine_koef = :fine_koef
          where b.id = :idb;

         update zsd b set
             b.ksg = null,
             b.sum_uslf = 0,
             b.kskp = 1,
             b.tar_usl = 0
          where b.id <> :idb and b.zs_id = :ida;
 
         update zs a set
          a.tar_usl = :tarif,
          a.sum_uslf = :sum_uslf,
          a.sum_usl = :sum_uslf,
          a.ksg = :ksg,
          a.kslp = :kskp
          where a.id = :ida;
 
      end else
      begin
        for select d.ds_class
         from zsd d
         where d.zs_id = :ida
         group by 1
         into :ds_class
         do
         begin
            if (((select count(dc.id) from ksg_dont_choice dc join zsd z on z.ksg_base = dc.ksg_ter or z.ksg_base = dc.ksg_surg
                    where z.zs_id = :ida and z.ds_class = :ds_class and :date2 between dc.bp and dc.epv) > 0) and (:q_u = 1)) then
               --    
            select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and b.ds_class = :ds_class and b.code_usl is not null
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;
            else
               --     
            begin
              select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base, b.date_1,
                 b.kskp_base, b.koef_z, b.koef_d, b.koef_u, b.bs, b.koef_up,
                 b.fine_koef
                 from zsd b
                 where b.zs_id = :ida and b.ksg_base is not null and b.ds_class = :ds_class
                 order by b.code_usl desc, b.sum_base desc
                 into :idb, :ksg, :sum_uslf, :tarif, :date1,
                      :kskp, :kz, :kd, :kus, :bs, :k_down, :fine_koef;
    
             if (((select coalesce(d.code_usl,'') from zsd d where d.id = :idb) <> '')
                and (exists(select d.id from zsd d where d.zs_id = :ida and d.id <> :idb and coalesce(d.code_usl,'') = '' and :date1 between d.date_1 and d.date_2))) then
             select first 1 d.id
                 from zsd d
                 where d.zs_id = :ida and d.id <> :idb and coalesce(d.code_usl,'') = '' and :date1 between d.date_1 and d.date_2
                 into :idb;
            end
    
             --      
             update zsd b set
                 b.ksg = :ksg,
                 b.sum_uslf = :sum_uslf,
                 b.ksg_base = :ksg,
                 b.tar_usl = :tarif,
                 b.sum_base = :sum_uslf,
                 b.kskp_base = :kskp,
                 b.koef_z = :kz, 
                 b.koef_d = :kd,
                 b.koef_u = :kus,
                 b.bs = :bs,
                 b.koef_up = :k_down,
                 b.reab = iif(:prof_num = 37,1,null),
                 b.fine_koef = :fine_koef
              where b.id = :idb;
    
             update zsd b set
                 b.ksg = null,
                 b.sum_uslf = 0,
                 b.kskp = 1,
                 b.tar_usl = 0
              where b.id <> :idb and b.zs_id = :ida and b.ds_class = :ds_class;
         end

        select first 1 b.ksg_base, b.sum_base
        from zs a
         join zsd b on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null and b.ds = a.ds1
         order by b.sum_base desc
         into :ksg, :sum_uslf;
   
        select coalesce(sum(b.sum_uslf), 0), coalesce(sum(b.tar_base), 0)
         from zsd b
         join zs a on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null
         into :sum_uslf, :tarif;

        update zs a set
         a.tar_usl = :tarif,
         a.sum_uslf = :sum_uslf,
         a.sum_usl = :sum_uslf,
         a.ksg = :ksg,
         a.kslp = :kskp
         where a.id = :ida;
 
      end
end;

/* Restore proc. body: SP_CALC_STAC_FINE_2020 */
ALTER PROCEDURE SP_CALC_STAC_FINE_2020(IDA INTEGER,
IDB INTEGER,
KSG DM_CHAR_20,
CL_CNT INTEGER)
 RETURNS(FINE_KOEF TYPE OF DM_NUM_3_2)
 AS
declare variable Q_U integer;
declare variable DATE_2 DM_DATE;
declare variable PERCENT_VALUE DM_NUM_3_2;
declare variable PERCENT_VALUE_MAX DM_NUM_3_2;
declare variable RESULT integer;
declare variable K_USLF integer;
declare variable DS_CLASS DM_CHAR_10;
begin
     ds_class = (select d.ds_class from zsd d where d.id = :idb);
     select q_u, date_2, result, (select sum(d.k_uslf) from zsd d where d.zs_id = a.id and d.ds_class = :ds_class)
     from zs a
     where id = :ida
     into :q_u, :date_2, :result, :k_uslf;

     fine_koef = 1;

     if (:result in (102,202,107,207,105,205,106,206) or (:k_uslf <= 3)) then
         percent_value = (select d.percent_value from h_ksg_dop d where d.type_num = 6 and :date_2 between d.bp and d.epv and d.q_u = :q_u and d.ksg = :ksg);
     else
     if (:result in (102,202,107,207,105,205,106,206) and (:k_uslf > 3)) then
         percent_value = (select d.percent_value from h_ksg_dop d where d.type_num = 7 and :date_2 between d.bp and d.epv and d.q_u = :q_u and d.ksg = :ksg);

     if (:k_uslf <= 3 and :result not in (102,202,107,207,105,205,106,206) and
         exists(select d.id from h_ksg_dop d where d.type_num = 8 and :date_2 between d.bp and d.epv and d.q_u = :q_u and d.ksg = :ksg)) then
         percent_value = 100;

     if (percent_value is not null) then
     begin
         fine_koef = :percent_value*0.01;
      end

     suspend;
end
;

/* Restore proc. body: SP_CALC_STAC_KSKP_2020 */
ALTER PROCEDURE SP_CALC_STAC_KSKP_2020(IDA INTEGER,
IDB INTEGER,
KSG DM_CHAR_20,
CL_CNT INTEGER)
 RETURNS(KSKP DM_NUM_2_6)
 AS
declare variable KSKP1 type of DM_NUM_3_2;
declare variable KSKP2 type of DM_NUM_3_2;
declare variable KSKP3 type of DM_NUM_3_2;
declare variable KSKP4 type of DM_NUM_3_2;
declare variable KSKP5 type of DM_NUM_3_2;
declare variable KSKP6 type of DM_NUM_3_2;
declare variable KSLP12 DM_NUM_3_2;
declare variable KSLP13 DM_NUM_3_2;
declare variable KSLP14 DM_NUM_3_2;
declare variable ORIT DM_INT;
declare variable OKATO DM_OKATO;
declare variable KSKP_ZNO DM_BOOL;
declare variable KSKP7 DM_NUM_3_2;
declare variable KSKP8 DM_NUM_3_2;
declare variable KSKP9 DM_NUM_3_2;
declare variable KSKP_SURG_COMB DM_BOOL;
begin
 select c.tf_okato
   from zs_hdr h
        join zs z on z.hdr_id = h.id
        join invoice i on i.id = h.name
        join contragents c on c.id = i.contragent_id
   where z.id = :ida
   into :okato;

   if (:okato is  null) then
     okato = (select first 1 c.tf_okato from contragents c where c.type_id = 1);

 kskp6 = 1;

 if (:okato = '29000') then
 begin
 select
       --    
       iif((a.q_u = 1) and (a.age < 1) and ((select first 1 d.ksg from h_ksg_dop d where d.type_num = 2 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null),
           (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 1 and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 1) and (a.age >= 1) and (a.age < 4), (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 2  and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 1) and (a.age < 4 and a.age < 18 and coalesce(a.chield_with_rop,0) = 1), (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 3  and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 1) and (a.age >= 75) and ((select first 1 d.ksg from h_ksg_dop d where d.type_num = 3 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 4  and a.date_2 between t.bp and t.epv), 1),    -- 4
       iif((a.q_u = 1) and (a.ds1 <> 'R54' and a.ds2 = 'R54' and exists(select first 1 id from zsd b where b.zs_id = a.id and b.profil_k = 16) and
           ((select first 1 d.ksg from h_ksg_dop d where d.type_num = 4 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null)),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 5  and a.date_2 between t.bp and t.epv), 1), --5
       iif((a.q_u = 3) and exists(select b.code_usl from zsd b where b.zs_id = a.id and b.code_usl in ('A11.20.017')),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 316  and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 3) and exists(select b.code_usl from zsd b where b.zs_id = a.id and b.code_usl in ('A11.20.017.083')),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 319  and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 3) and exists(select b.code_usl from zsd b where b.zs_id = a.id and b.code_usl in ('A11.20.030.001')),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 75  and a.date_2 between t.bp and t.epv), 1)
  from zs a
  join patients p on p.id = a.patient_id
  left join zs_hdr h on h.id = a.hdr_id
  left join invoice i on i.id = h.name
  where a.id = :ida
  into :kskp1, :kskp2, :kskp3, :kskp4, :kskp5, :kslp12, :kslp13, :kslp14;
 end

  if (:okato = '71140') then
  begin
      kskp_zno = 0;
      kskp_zno = coalesce((select first 1 1
                 from zs z
                      join zsd d on d.zs_id = z.id
                      join onk_usl u on u.zsd_id = d.id
                      left join onk_usl u2 on u2.zsd_id = d.id and u2.id <> u.id
                 where z.id = :ida and ((u.usl_tip = 2 and u2.usl_tip = 3) or (u.usl_tip = 3 and u2.usl_tip = 2)
                                         or (u.usl_tip = 2 and u2.usl_tip = 1) or (u.usl_tip = 1 and u2.usl_tip = 2)
                                         or (u.usl_tip = 3 and u2.usl_tip = 1) or (u.usl_tip = 1 and u2.usl_tip = 3)
                                         )),0);
      if (kskp_zno = 0) then
        kskp_zno = coalesce((select first 1 1
                 from zs z
                      join zsd d on d.zs_id = z.id
                      join onk_usl u on u.zsd_id = d.id
                 where z.id = :ida and (u.usl_tip = 2 and (select count(*) from zs_crit c where c.zsd_id = d.id and c.code starting 'sh') >= 2)),0);
     kskp_surg_comb = 0;
     kskp_surg_comb = coalesce((select first 1 1
                 from zs z
                      join zsd d on d.zs_id = z.id
                      join zsd d2 on d2.zs_id = z.id and d2.id <> d.id
                 where z.id = :ida and exists(select id from comb_surg s where (s.surg1 = d.code_usl and s.surg2 = d2.code_usl) or (s.surg1 = d2.code_usl and s.surg2 = d.code_usl)
                                         )),0);
      select
       --    
       iif((a.q_u = 1) and (a.age < 1) and ((select first 1 d.ksg from h_ksg_dop d where d.type_num = 2 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null),
           (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 1 and a.date_2 between t.bp and t.epv), 1),
       --  1  4
       iif((a.q_u = 1) and (a.age >= 1) and (a.age < 4), (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 2  and a.date_2 between t.bp and t.epv), 1),
       --    
       iif((a.q_u = 1) and (a.age < 18 and exists(select b.id from zsd b where b.zs_id = a.id and b.code_usl = 'A13.30.006.099')),
           (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 3  and a.date_2 between t.bp and t.epv), 1),
       --  75 
       iif((a.q_u = 1) and (a.age >= 75) and exists(select b.id from zsd b where b.zs_id = a.id and b.code_usl = 'B01.007.001.099')
            and not exists(select b.id from zsd b where b.zs_id = a.id and b.profil_k = 16)
            and ((select first 1 d.ksg from h_ksg_dop d where d.type_num = 3 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 4  and a.date_2 between t.bp and t.epv), 1),    -- 4
       -- 
       iif((a.q_u = 1) and (a.ds1 <> 'R54' and a.ds2 = 'R54' and exists(select first 1 id from zsd b where b.zs_id = a.id and b.profil_k = 16)
            and exists(select first 1 id from zsd b where b.zs_id = a.id and :ksg = 'st38.001')
            and ((select first 1 d.ksg from h_ksg_dop d where d.type_num = 4 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null)),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 5  and a.date_2 between t.bp and t.epv), 1), --5
       --     
       iif((a.q_u = 1) and (:kskp_zno = 1),(select first 1 t.z_sl from h_kslp_type t where t.idkslp = 7 and a.date_2 between t.bp and t.epv), 1),
       --  
       iif((a.q_u = 1) and (:kskp_surg_comb = 1 ),(select first 1 t.z_sl from h_kslp_type t where t.idkslp = 8 and a.date_2 between t.bp and t.epv), 1),
       --   
       iif((a.q_u = 1) and (select first 1 b.code_usl from zsd b where b.zs_id = a.id and b.code_usl in ('A16.03.022.002','A16.03.022.004','A16.03.022.005','A16.03.022.006',
                            'A16.03.024.005','A16.03.024.007','A16.03.024.008','A16.03.024.009','A16.03.024.010','A16.03.033.002','A16.04.014','A16.12.006',
                            'A16.12.006.001','A16.12.006.002','A16.12.006.003','A16.12.008.001','A16.12.008.002','A16.12.012', 'A16.20.032.007','A16.20.103',
                            'A16.20.043.001','A16.20.043.002','A16.20.043.003','A16.20.043.004','A16.20.045','A16.20.047','A16.20.048','A16.20.049.001','16.26.007',
                            'A16.26.011','16.26.013','16.26.014','16.26.018','A16.26.019','A16.26.020','A16.26.021','A16.26.021.001','16.26.022','A16.26.023',
                            '16.26.025','16.26.026','16.26.028','16.26.034','A16.26.075','A16.26.075.001','A16.26.079','A16.26.093.002','A16.26.094','A16.26.147',
                            'A22.26.004','A22.26.005','A22.26.006','A22.26.007', 'A22.26.009','A22.26.010','A22.26.019','A22.26.023')
                            group by 1
                            having count(*) >= 2) is not null,
                            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 9 and a.date_2 between t.bp and t.epv), 1)
      from zs a
      join patients p on p.id = a.patient_id
      left join zs_hdr h on h.id = a.hdr_id
      left join invoice i on i.id = h.name
      where a.id = :ida
      into :kskp1, :kskp2, :kskp3, :kskp4, :kskp5, :kskp7, :kskp8, :kskp9;
  end

     if ((((select z.q_u from zs z where id = :ida)) = 1) and (:ksg not in ('st19.039', 'st19.040','st19.041','st19.042','st19.043','st19.044','st19.045','st19.046','st19.047',
                                                                           'st19.048','st19.049','st19.050','st19.051','st19.052','st19.053','st19.054','st19.055','st19.001',
                                                                           'st19.002','st19.003','st19.004','st19.005','st19.006','st19.007','st19.008','st19.009','st19.010',
                                                                           'st19.011','st19.012','st19.013','st19.014','st19.015'))) then
     begin
         orit = (select sum(d.k_uslf) from zsd d where d.zs_id = :ida and d.code_usl = 'B03.003.005' and d.date_1 between (select d1.date_1 from zsd d1 where d1.id = :idb) and
                                                                                                                 (select d1.date_2 from zsd d1 where d1.id = :idb) );
         if (idb is not null) then
          select
                --  
                case
                  when (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) > 30 and ((select d.ksg from h_ksg_dop d where d.type_num = 5 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null)) then
                        case
                          when (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - coalesce(:orit,0)) >= coalesce(:orit,0) then 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 30) * 0.25 / 30
                          else 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 30) * 0.4 / 30
                        end
                  when (b.k_uslf > 45 and ((select d.ksg from h_ksg_dop d where d.type_num = 5 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is not null)) then
                        case
                          when (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - coalesce(:orit,0)) >= coalesce(:orit,0) then 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 45) * 0.25 / 45
                          else 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 45) * 0.4 / 45
                        end
                  else 1
                end
           from zs a
           join zsd b on a.id = b.zs_id
           where b.id = :idb
           into :kskp6;
     end
    
    
         kskp = kskp1 + (kskp2-1) + (kskp3-1) + (kskp4-1) + (kskp5-1) + (kskp7-1) + (kskp8-1) + (kskp9-1);
         if (kskp > 1.8) then
          kskp = 1.8;
         kskp = kskp + (kskp6-1);
         
         delete from kslp_koef where zs_id = :ida and ksg = :ksg;
         
         if (:kskp1 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (1, :kskp1, :ida, :ksg);
         if (:kskp2 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (2, :kskp2, :ida, :ksg);
         if (:kskp3 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (3, :kskp3, :ida, :ksg);
         if (:kskp4 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (4, :kskp4, :ida, :ksg);
         if (:kskp5 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (5, :kskp5, :ida, :ksg);
         if (:kskp6 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (6, :kskp6, :ida, :ksg);
         if (:kskp7 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (7, :kskp7, :ida, :ksg);
         if (:kskp8 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (8, :kskp8, :ida, :ksg);
         if (:kskp9 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (9, :kskp9, :ida, :ksg);
--    end
--    else
--    begin
--      delete from kslp_koef where zs_id = :ida and ksg = :ksg;

     if (okato in ('29000', '70000')) then
     begin
         insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
           select k.idkslp, k.z_sl, a.id, :ksg
            from zs a
                 join zsd b on b.zs_id = a.id
                 join h_kslp_type k on k.bp <= a.date_2 and k.epv >= a.date_2 and k.terms_of_use = b.code_usl and k.tf_okato = :okato
            where a.id = :ida and a.q_u = 3;

         kskp = (select first 1 k.z_kslp from kslp_koef k where k.zs_id = :ida);
     end

    suspend;        
end;

/* Restore proc. body: SP_DUPLICATE_XML_STRUCT */
ALTER PROCEDURE SP_DUPLICATE_XML_STRUCT(STRUCT_ID INTEGER)
 AS
declare variable NEW_STRUCT_ID integer;
declare variable ID integer;
declare variable FIRST_ID integer;
declare variable OLD_FIRST_ID integer;
begin
  insert into XML_STRUCTURE (ID, NAME, user_id)
    values (null, '_' || (select name from xml_structure s where s.id = :struct_id), 1)
    returning ID
    into :new_struct_id;

  first_id = gen_id(gen_xml_items_id,1);
  old_first_id = (select id from xml_items where parent_id IS NULL and xml_structure_id = :struct_id);

  for select id
      from xml_items i
      where i.xml_structure_id = :struct_id
      into :id
      do
      begin

        insert into XML_ITEMS (ID, XML_STRUCTURE_ID, NAME, CAPTION, NOTE, PARENT_ID, ITEM_TYPE, DATA_ID, DATA_LENGTH,
                           DATA_PRECISION, FORM, VAL_TYPE, VAL, IS_NO_SHOW, VAL_PREFIX, NPP,
                           FIELDS_CONDITION, DATA_DATE_FORMAT)
        select :first_id + (id - :old_first_id), :new_struct_id, NAME, CAPTION, NOTE, :first_id + (id - :old_first_id) + (parent_id - id), ITEM_TYPE, DATA_ID, DATA_LENGTH, DATA_PRECISION, FORM,
               VAL_TYPE, VAL, IS_NO_SHOW, VAL_PREFIX, NPP, FIELDS_CONDITION, DATA_DATE_FORMAT
        from XML_ITEMS x
        where x.id = :id;
      end

  first_id = gen_id(gen_xml_items_id,(select max(id) from xml_items where xml_structure_id = :new_struct_id) + 1);
end;

/* Restore proc. body: SP_KSG_GET_2020 */
ALTER PROCEDURE SP_KSG_GET_2020(IDB INTEGER = null)
 RETURNS(KSG DM_CHAR_20,
ERR_CODE INTEGER)
 AS
declare variable KSG_SURG DM_CHAR_20;
declare variable IDA integer;
declare variable DS1 DM_DS;
declare variable DATE_1 DM_DATE;
declare variable DATE_2 DM_DATE;
declare variable NMS_CODE DM_NMS_CODE;
declare variable DAY_CNT DM_INT;
declare variable SEX DM_SEX;
declare variable DOP_CRITERION DM_CHAR_10;
declare variable RANGE_FR DM_CHAR_10;
declare variable DR DM_DATE;
declare variable DS2 DM_DS;
declare variable DS3 DM_DS;
declare variable Q_U DM_INT;
declare variable DS_CLASS DM_CHAR_10;
declare variable DAYS DM_INT;
declare variable RC DM_INT;
declare variable DS_TMP DM_DS;
declare variable AGE integer;
declare variable TMP_GRP_ID DM_INT;
declare variable DOP_CRITERIAN_TMP DM_CHAR_10;
declare variable KSG_TER DM_CHAR_20;
begin
     ksg = null;
     err_code = null;
     tmp_grp_id = gen_id(GEN_KSG_TMP_GROUP_ID, 1);
     ida = (select first 1 d.zs_id from zsd d where d.id = :idb);
------------------------------------------------------------------------------------------------------------------------
-- 1
     select d.date_1, d.date_2, d.ds, d.code_usl, p.sex, d.ksg_criterion, d.ksg_criterion2, p.dr, z.q_u, d.ds_class,
            d.ds2, d.ds3
     from zsd d
          join zs z on d.zs_id = z.id
          join patients p on p.id = z.patient_id
     where d.id = :idb
     into :date_1, :date_2, :ds1, :nms_code, :sex, :dop_criterion, :range_fr, :dr, :q_u, :ds_class, :ds2, :ds3;

     day_cnt = (select sum(coalesce(b1.k_uslf,0)) from ZSD b1 where b1.ZS_ID = :ida and b1.ds_class = :ds_class and b1.id = b1.zsd_id);

     days = case
              when :day_cnt <= 3 then 1
              else null
            end;

     --- 
     if (:nms_code in ('A25.20.004.001', 'A11.20.019', 'A11.20.028', 'A11.20.031', 'A11.20.017.001', 'A11.20.030.001', 'A11.20.017.081','A11.20.017.082','A11.20.017.083',
                       'A11.20.507', 'A11.20.508', 'A11.20.509')) then
       nms_code = 'A11.20.017';
-----------------------------------------------------------------------------------------------------------------------
     --       ()
      select
           case
             when t1.ao_code = 'T7' then 'st29.007'
             when (t1.ao_code between 'T1' and 'T6') and (t2.ao_code between 'T1' and 'T6') and (t1.ao_code <> t2.ao_code) then 'st29.007'
             else null
           end
      from zs_ds d
      left join h_tarif_polytrauma t1 on t1.ds = d.ds and :date_2 between t1.bp and t1.epv
      left join h_tarif_polytrauma t2 on t2.ds = d.ds and :date_2 between t2.bp and t2.epv
      where d.section = 1 and d.section_id = :ida and d.ds in ('J94.2','J94.8','J94.9','J93','J93.0','J93.1','J93.8','J93.9', 'J96.0', 'N17', 'T79.4', 'R57.1', 'R57.8')
      into :ksg;

     if (ksg is not null) then
     begin
       suspend;
       exit;
     end
--------------------------------------------------------------------------------

     if (:nms_code starting 'A18') then --
     begin
       ksg = null;
       exit;
     end

--------------------------------------------------------------------------------
-- 2  3
     insert into KSG_TMP (ID, KSG, NMS_CODE, KZ, AGE_GRP, DAYS, SEX, DS, DOP_CRITERIAN, dop_criterian2, ds2,  ds3, step_num, group_code)
      select h.id, h.ksg, h.nms_code, k.kz, h.age_grp, h.days, h.sex, h.ds, h.dop_criterion, h.dop_criterion2,
             h.ds2, h.ds3, 0, :tmp_grp_id
       from ksg_grp h
       join h_ksg k on k.ksg = h.ksg and :date_2 between k.bp and k.epv
       where ((h.ds = :ds1) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds, :ds1)) = 1) or (h.ds is null) )     --a
             and ((h.ds2 = :ds2) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds2, :ds2)) = 1) or (h.ds2 is null) ) --b
             and ((h.ds3 = :ds3) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds3, :ds3)) = 1) or (h.ds3 is null) ) --c
             and (h.nms_code = :nms_code or (h.nms_code is null)) --d
             and (h.sex = :sex or (h.sex is null) ) -- f
             and (h.days is not distinct from :days or (h.days is null) ) -- g
             and (h.dop_criterion is not distinct from :dop_criterion or (h.dop_criterion is null) ) --h
             and (h.dop_criterion2 is not distinct from :range_fr or (h.dop_criterion2 is null) ) -- i
             and :date_2 between h.bp and h.epv
             and h.q_u = k.q_u and h.q_u = :q_u;

     --d
     for select d.code_usl
         from zsd d
         where d.zs_id = :ida and d.zsd_id = :idb and d.id <> :idb
         into :nms_code
         do
           insert into KSG_TMP (ID, KSG, NMS_CODE, KZ, AGE_GRP, DAYS, SEX, DS, DOP_CRITERIAN, dop_criterian2, ds2,  ds3, step_num, group_code)
              select h.id, h.ksg, h.nms_code, k.kz, h.age_grp, h.days, h.sex, h.ds, h.dop_criterion, h.dop_criterion2,
                     h.ds2, h.ds3, 0, :tmp_grp_id
               from ksg_grp h
               join h_ksg k on k.ksg = h.ksg and :date_2 between k.bp and k.epv
               where ((h.ds = :ds1) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds, :ds1)) = 1) or (h.ds is null) )     --a
                     and ((h.ds2 = :ds2) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds2, :ds2)) = 1) or (h.ds2 is null) ) --b
                     and ((h.ds3 = :ds3) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds3, :ds3)) = 1) or (h.ds3 is null) ) --c
                     and (h.nms_code = :nms_code) --d
                     and (h.sex = :sex or (h.sex is null) ) -- f
                     and (h.days is not distinct from :days or (h.days is null) ) -- g
                     and (h.dop_criterion is not distinct from :dop_criterion or (h.dop_criterion is null) ) --h
                     and (h.dop_criterion2 is not distinct from :range_fr or (h.dop_criterion2 is null) ) -- i
                     and :date_2 between h.bp and h.epv
                     and h.q_u = k.q_u and h.q_u = :q_u;
     --b
     for select d.ds
         from zs_ds d
         where d.section_id = :idb and d.section = 2 and d.ds_type = 2 and d.ds <> :ds2
         into :ds_tmp
         do
           insert into KSG_TMP (ID, KSG, NMS_CODE, KZ, AGE_GRP, DAYS, SEX, DS, DOP_CRITERIAN, dop_criterian2, ds2,  ds3, step_num, group_code)
              select h.id, h.ksg, h.nms_code, k.kz, h.age_grp, h.days, h.sex, h.ds, h.dop_criterion, h.dop_criterion2,
                     h.ds2, h.ds3, 0, :tmp_grp_id
               from ksg_grp h
               join h_ksg k on k.ksg = h.ksg and :date_2 between k.bp and k.epv
               where ((h.ds = :ds1) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds, :ds1)) = 1) or (h.ds is null) )     --a
                     and ((h.ds2 = :ds_tmp) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds2, :ds_tmp)) = 1)) --b
                     and ((h.ds3 = :ds3) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds3, :ds3)) = 1) or (h.ds3 is null) ) --c
                     and (h.nms_code = :nms_code or (h.nms_code is null)) --d
                     and (h.sex = :sex or (h.sex is null) ) -- f
                     and (h.days is not distinct from :days or (h.days is null) ) -- g
                     and (h.dop_criterion is not distinct from :dop_criterion or (h.dop_criterion is null) ) --h
                     and (h.dop_criterion2 is not distinct from :range_fr or (h.dop_criterion2 is null) ) -- i
                     and :date_2 between h.bp and h.epv
                     and h.q_u = k.q_u and h.q_u = :q_u;

     --c
     for select d.ds
         from zs_ds d
         where d.section_id = :idb and d.section = 2 and d.ds_type = 3 and d.ds <> :ds3
         into :ds_tmp
         do
           insert into KSG_TMP (ID, KSG, NMS_CODE, KZ, AGE_GRP, DAYS, SEX, DS, DOP_CRITERIAN, dop_criterian2, ds2,  ds3, step_num, group_code)
              select h.id, h.ksg, h.nms_code, k.kz, h.age_grp, h.days, h.sex, h.ds, h.dop_criterion, h.dop_criterion2,
                     h.ds2, h.ds3, 0, :tmp_grp_id
               from ksg_grp h
               join h_ksg k on k.ksg = h.ksg and :date_2 between k.bp and k.epv
               where ((h.ds = :ds1) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds, :ds1)) = 1) or (h.ds is null) )     --a
                     and ((h.ds2 = :ds2) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds2, :ds2)) = 1) or (h.ds2 is null) ) --b
                     and ((h.ds3 = :ds_tmp) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds3, :ds_tmp)) = 1)) --c
                     and (h.nms_code = :nms_code or (h.nms_code is null)) --d
                     and (h.sex = :sex or (h.sex is null) ) -- f
                     and (h.days is not distinct from :days or (h.days is null) ) -- g
                     and (h.dop_criterion is not distinct from :dop_criterion or (h.dop_criterion is null) ) --h
                     and (h.dop_criterion2 is not distinct from :range_fr or (h.dop_criterion2 is null) ) -- i
                     and :date_2 between h.bp and h.epv
                     and h.q_u = k.q_u and h.q_u = :q_u;

     --h
     for select c.code
         from zs_crit c
         where c.zsd_id = :idb and c.code <> :dop_criterion and c.code not starting 'fr'
         into :dop_criterian_tmp
         do
           insert into KSG_TMP (ID, KSG, NMS_CODE, KZ, AGE_GRP, DAYS, SEX, DS, DOP_CRITERIAN, dop_criterian2, ds2,  ds3, step_num, group_code)
              select h.id, h.ksg, h.nms_code, k.kz, h.age_grp, h.days, h.sex, h.ds, h.dop_criterion, h.dop_criterion2,
                     h.ds2, h.ds3, 0, :tmp_grp_id
               from ksg_grp h
               join h_ksg k on k.ksg = h.ksg and :date_2 between k.bp and k.epv
               where ((h.ds = :ds1) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds, :ds1)) = 1) or (h.ds is null) )     --a
                     and ((h.ds2 = :ds2) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds2, :ds2)) = 1) or (h.ds2 is null) ) --b
                     and ((h.ds3 = :ds3) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds3, :ds3)) = 1) or (h.ds3 is null) ) --c
                     and (h.nms_code = :nms_code or (h.nms_code is null)) --d
                     and (h.sex = :sex or (h.sex is null) ) -- f
                     and (h.days is not distinct from :days or (h.days is null) ) -- g
                     and (h.dop_criterion is not distinct from :dop_criterian_tmp) --h
                     and (h.dop_criterion2 is not distinct from :range_fr or (h.dop_criterion2 is null) ) -- i
                     and :date_2 between h.bp and h.epv
                     and h.q_u = k.q_u and h.q_u = :q_u;

     rc = (select count(*) from ksg_tmp);

     if (rc > 1) then  --   
       if (exists(select first 1 t.id from ksg_tmp t where t.age_grp is not null)) then
       begin
         age = (extract(year from :date_1) - extract(year from :dr));

         if ((:date_1 - :dr) <= 28) then
           delete from ksg_tmp t
            where t.age_grp not in (1,4,5) and t.age_grp is not null and t.group_code = :tmp_grp_id;
         else
         if ((:date_1 - :dr) between 29 and 90) then
           delete from ksg_tmp t
            where t.age_grp not in (2,4,5) and t.age_grp is not null and t.group_code = :tmp_grp_id;
         else
         if (((:date_1 - :dr) > 91) and (:age < 1)) then
           delete from ksg_tmp t
            where t.age_grp not in (3,4,5) and t.age_grp is not null and t.group_code = :tmp_grp_id;
         else
         if ((:age < 2) and (:age >=1)) then
           delete from ksg_tmp t
            where t.age_grp not in (4,5) and t.age_grp is not null and t.group_code = :tmp_grp_id;
         else
         if ((:age >= 2) and (:age < 18)) then
           delete from ksg_tmp t
            where t.age_grp not in (5) and t.age_grp is not null and t.group_code = :tmp_grp_id;
         else
         if (:age >= 18) then
           delete from ksg_tmp t
            where t.age_grp not in (6) and t.age_grp is not null and t.group_code = :tmp_grp_id;
       end
--------------------------------------------------------------------------------
-- 4
     update ksg_tmp t
      set t.step_num = 1
      where ((t.dop_criterian in ('rb2','rb3','rb4','rb5','rb6','rbs'))
            or (t.days = 1)
            or ((t.ds in ('L08.0','L26','L27.0','L27.2')) and t.age_grp = 1))
            and t.group_code = :tmp_grp_id;

     for select t.ksg
                from ksg_tmp t
                     join ksg_tmp t2 on t2.id <> t.id
                where t.group_code = :tmp_grp_id and exists(select ch.id from ksg_dont_choice ch where ch.ksg_ter = t.nms_code and ch.ksg_surg = t2.nms_code)
         into :ksg_ter
         do
           update ksg_tmp kt
            set kt.step_num = -1
            where kt.ksg = :ksg_ter;
--------------------------------------------------------------------------------
-- 5
     ksg = (select first 1 t.ksg from KSG_TMP t where t.group_code=:tmp_grp_id
                 order by t.step_num desc, t.kz desc);

     if (ksg is null and err_code is null and ((select first 1 id from h_tarif_dializ d where :date_2 between d.bp and d.epv and d.code_usl = :nms_code) is null)) then
      err_code = 1;

     delete from KSG_TMP t
      where t.group_code = :tmp_grp_id;

     if (err_code is not null) then
         update zsd d
         set d.comment_local = (select name from h_errors where ID = :err_code)
         where d.id = :idb;

     suspend;
end;

/* Creating trigger... */
CREATE TRIGGER COMB_SURG_BI FOR COMB_SURG
ACTIVE BEFORE INSERT POSITION 0 
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_comb_surg_id,1);
end;

CREATE TRIGGER INVOICE_BIU0 FOR INVOICE
ACTIVE BEFORE INSERT OR UPDATE POSITION 0 
AS
declare variable org_code varchar(6);
begin
  if (new.contragent_id is not null) then
  begin
    org_code = (select c.org_code from contragents c where c.id = new.contragent_id);
    new.contragent_sign = iif(char_length(:org_code) > 2, 'S', 'T');
    new.contragent_okato = (select c.tf_okato from contragents c where c.id = new.contragent_id);
  end
end;

CREATE TRIGGER ZS_CRIT_AIU0 FOR ZS_CRIT
ACTIVE AFTER INSERT OR UPDATE POSITION 0 
AS
begin
  update zsd d
    set d.ksg_criterion2 = (select first 1 code from zs_crit where zsd_id = new.zsd_id and code starting 'fr')
    where d.id = new.zsd_id;
  update zsd d
   set d.ksg_criterion = (select first 1 code from zs_crit where zsd_id = new.zsd_id and code not starting 'fr')
   where d.id = new.zsd_id;
end;

CREATE TRIGGER ZS_CRIT_BD0 FOR ZS_CRIT
ACTIVE BEFORE DELETE POSITION 0 
AS
begin
  if (old.code starting 'fr') then
   update zsd d
    set d.ksg_criterion2 = (select first 1 code from zs_crit where zsd_id = old.zsd_id and code starting 'fr' and id <> old.id)
    where d.id = old.zsd_id;
  else
  update zsd d
   set d.ksg_criterion = (select first 1 code from zs_crit where zsd_id = old.zsd_id and code not starting 'fr' and id <> old.id)
   where d.id = old.zsd_id;
end;

CREATE TRIGGER ZS_CRIT_BI FOR ZS_CRIT
ACTIVE BEFORE INSERT POSITION 0 
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_zs_crit_id,1);
end;


/* Altering existing trigger... */
ALTER TRIGGER INVOICE_BI
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_invoice_id,1);
  new.npp = 1;
end;

/* Altering existing trigger... */
ALTER TRIGGER INVOICE_BU0
AS
begin
     -- change invoice status
     if (old.status_id <> new.status_id) then
      execute procedure sp_invoice_set_status(new.id, new.status_id);
  if (new.npp is null) then
    new.npp = 1;
end;

/* Altering existing trigger... */
ALTER TRIGGER ZSD_BD0
AS
begin
  delete from zs_ds d where d.section = 2 and d.section_id = old.id;
  delete from onk_cons c where c.zsd_id = old.id;
  delete from onk_diag d where d.onk_sl_id = old.id;
  delete from onk_napr n where n.zsd_id = old.id;
  delete from onk_prot p where p.onk_sl_id = old.id;
  delete from onk_sl s where s.zsd_id = old.id;
  delete from onk_usl u where u.zsd_id = old.id;
  delete from  zs_crit u where u.zsd_id = old.id;
end;

/* Altering existing trigger... */
ALTER TRIGGER ZSD_BIU0
AS
declare variable mp integer;
declare variable q_u integer;
declare variable tar numeric(15,2);
begin
  q_u = (select q_u from zs where id = new.zs_id);

--  mp = (select mp from doctors_spec s where s.doctor_id = new.phys_id and s.code_spec = new.code_spec);
--   if (:mp is not null) then
--     new.mp = :mp;

--   new.ds_class = (SELECT first 1 MKB_CLASS_NUM FROM H_MKB WHERE CODE = NEW.DS);
  new.is_onk = (select IS_ONK from SP_CHECK_DS_AS_ONK2(new.ds, new.ds2));

  if (new.pmd_close = 1) then
    update zsd
    set pmd_close = 0
    where zs_id = new.zs_id;

  if (new.pmd_close is null) then
    new.pmd_close = 1;

  if ((select z.payment_type_id from zs z where z.id = new.zs_id) in (3,2)) then
  begin
      tar = (select coalesce(u.sumf,0) from h_usl u where u.code = new.code_usl and u.q_u containing :q_u and u.payment_type_id = (select z.payment_type_id from zs z where z.id = new.zs_id));
    
      if (tar > 0) then
      begin
        NEW.sum_uslf = :tar * new.k_uslf;
        NEW.tar_usl = :tar;
      END
  end
--  else
--    if (new.tar_usl = 0 and new.sum_uslf = 0) then new.k_uslf = 0;

  if (new.phys_id is not null and new.code_spec_v021 is null) then
    new.code_spec_v021 = (select first 1 s.code_v021 from doctors_spec s where s.doctor_id = new.phys_id);

  if (new.phys_id is not null and new.mp is null and new.code_spec_v021 is not null) then
    new.mp = (select first 1 m.mp from doctors_spec m where m.doctor_id = new.phys_id and m.code_v021 = new.code_spec_v021);

  if (new.phys_id is not null and new.code_prof is null) then
    new.code_prof = (select first 1 p.prof from doctors_prof p where p.doctor_id = new.phys_id and p.code_spec =
                     (select first 1 s.code_v021 from doctors_spec s where s.doctor_id = new.phys_id));

--  if (new.code_spec is not null) then
--    new.code_spec_v021 = (select first 1 s.code_v021 from h_v015_v021 s where cast(s.code_v015 as varchar(10)) = new.code_spec);
--  else
  if (new.code_spec_v021 is not null) then
    new.code_spec = cast((select first 1 s.code_v015 from h_v015_v021 s where s.code_v021 = new.code_spec_v021) as varchar(10));

--  if (inserting) then
--  update or insert into DOCTORS_SPEC (DOCTOR_ID, CODE_V021, MP)
--    values (new.phys_id, new.code_spec_v021, new.mp)
--    matching (DOCTOR_ID, CODE_V021, MP);
  if (coalesce(new.ds,'') = '') then
    new.ds = (select d.ds from zs_ds d where d.section = 2 and d.section_id = new.id and d.ds_type = 1);

  if ((coalesce(new.code_usl,'') = '') and (coalesce(old.code_usl,'') = '') and ((select z.payment_type_id from zs z where z.id = new.zs_id) = 1) and (q_u = 2)
       and ((select z.target from zs z where z.id = new.zs_id) = 1) and (new.date_1 >= '01.01.2019')) then
  begin
    if (exists(select first 1 id from zsd d where d.zs_id = new.zs_id and d.date_1 < new.date_1 and d.code_spec_v021 = new.code_spec_v021)) then
    begin
      if (new.is_chield = 1) then
        new.code_usl = (select first 1 n.code_usl2_det from h_tarif_app_spec s join h_tarif_app_name n on n.id = s.name_id where s.code_spec_v021 = new.code_spec_v021);
      else
        new.code_usl = (select first 1 n.code_usl2 from h_tarif_app_spec s join h_tarif_app_name n on n.id = s.name_id where s.code_spec_v021 = new.code_spec_v021);
    end
    else
    begin
      if (new.is_chield = 1) then
        new.code_usl = (select first 1 n.code_usl1_det from h_tarif_app_spec s join h_tarif_app_name n on n.id = s.name_id where s.code_spec_v021 = new.code_spec_v021);
      else
        new.code_usl = (select first 1 n.code_usl1 from h_tarif_app_spec s join h_tarif_app_name n on n.id = s.name_id where s.code_spec_v021 = new.code_spec_v021);
    end
  end
end;

/* Alter Procedure... */
/* DROP: -- GRANT ALL ON V_PATIENTS TO SYSDBA WITH GRANT OPTION */


