ALTER TRIGGER DOCTORS_MP_BIU0
AS
BEGIN
  EXIT;
END;

ALTER TRIGGER DOCTORS_SPEC_BIU0
AS
BEGIN
  EXIT;
END;

ALTER PROCEDURE SP_PRINT_REPORT_1
RETURNS (
  Q_U INTEGER,
  USL_NAME VARCHAR(50) /* COLLATE WIN1251 - default */,
  K_USLF NUMERIC(6,3),
  SUM_USLF NUMERIC(18,3),
  CNT INTEGER,
  AGE17 BIGINT,
  AGE17_USL NUMERIC(6,2),
  AGE17_SUM NUMERIC(18,2),
  AGE50_55 BIGINT,
  AGE50_55_USL NUMERIC(6,2),
  AGE50_55_SUM NUMERIC(18,2),
  MP_NAME VARCHAR(250) /* COLLATE WIN1251 - default */,
  MP VARCHAR(2) /* COLLATE WIN1251 - default */,
  K_USLF_STOM INTEGER,
  AGE17_USL_STOM INTEGER,
  AGE50_55_USL_STOM INTEGER,
  OUT INTEGER,
  OUT_USL NUMERIC(6,2),
  OUT_SUM NUMERIC(15,2),
  AGE17_MEN INTEGER,
  AGE50_55_MEN INTEGER,
  MEN INTEGER,
  OUT_MEN INTEGER)
AS
BEGIN
  SUSPEND;
END;

DROP VIEW V_H_MP;

DROP VIEW V_H_SMO;

DROP VIEW V_ZS;


/******************************************************************************/
/****                      Creating stored procedures                      ****/
/******************************************************************************/

CREATE PROCEDURE SP_ADD_SMO_FROM_SPRAV(
  SMO_CODE /* DM_SMO */ VARCHAR(10) /* COLLATE WIN1251 - default */)
AS
BEGIN
  EXIT;
END;


/******************************************************************************/
/****                           Altering tables                            ****/
/******************************************************************************/

ALTER TABLE H_MP ALTER COLUMN NAME
  TYPE DM_CHAR_250;

ALTER TABLE H_ONK_N006 ALTER COLUMN DS_GR
  TYPE DM_CHAR_9;

ALTER TABLE H_SMO
  ADD FULL_NAME DM_CHAR_1000 /* COLLATE WIN1251 - default */;

ALTER TABLE H_SMO
  ADD KPP DM_CHAR_9 /* COLLATE WIN1251 - default */;

ALTER TABLE H_SMO
  ADD ADDRESS_JUR DM_CHAR_300 /* COLLATE WIN1251 - default */;

ALTER TABLE H_SMO
  ADD ADDRESS_FACT DM_CHAR_300 /* COLLATE WIN1251 - default */;

ALTER TABLE H_SMO
  ADD PHONE DM_CHAR_100 /* COLLATE WIN1251 - default */;

ALTER TABLE H_SMO
  ADD E_MAIL DM_CHAR_100 /* COLLATE WIN1251 - default */;

ALTER TABLE H_SMO
  ADD WWW DM_CHAR_100 /* COLLATE WIN1251 - default */;

ALTER TABLE H_SMO
  ADD INDEX_JUR DM_CHAR_10 /* COLLATE WIN1251 - default */;

ALTER TABLE H_SMO
  ADD INDEX_FACT DM_CHAR_10 /* COLLATE WIN1251 - default */;


/******************************************************************************/
/****                            Creating views                            ****/
/******************************************************************************/
CREATE VIEW V_H_MP (
    ID,
    NAME,
    CODE)
AS
select
    id,
    code || ' ' || name,
    code
from h_mp;

CREATE VIEW V_H_SMO (
    ID,
    CODE,
    NAME,
    OKATO,
    OGRN,
    TERR_NAME,
    DATEBEG,
    DATEEND,
    IS_ACTIVE,
    FULL_NAME,
    KPP,
    INN,
    ADDRESS_JUR,
    ADDRESS_FACT,
    PHONE,
    E_MAIL,
    WWW,
    INDEX_JUR,
    INDEX_FACT)
AS
select S.ID, S.CODE, S.NAME, S.OKATO, S.OGRN, o.name terr_name, s.datebeg,
       s.dateend, iif(s.dateend is null,  1, 0),
       s.full_name, s.kpp, s.inn, s.address_jur, s.address_fact,
       s.phone, s.e_mail, s.www, s.index_jur, s.index_fact
from h_smo s
join h_okato o on o.code = s.okato;

CREATE VIEW V_ZS (
    ID,
    Q_U,
    MP,
    ORDER_V,
    CODE_SPEC,
    CODE_PROF,
    OTD_PROF,
    IS_CHIELD,
    N_HIST,
    DATE_1,
    DATE_2,
    DS0,
    DS1,
    DS2,
    TAR_USL,
    K_USLF,
    K_USL,
    IDSP,
    TARGET,
    RESULT,
    PATIENT_ID,
    FAM,
    IM,
    OT,
    Q_U_NAME,
    TARGET_NAME,
    SUM_USLF,
    HDR_ID,
    DIRECTION_NUM,
    DIRECTION_DATE,
    DH_INFO,
    MES_CODE,
    SMP_BRIG,
    DS3,
    DCOUNT,
    UID,
    PHYS_ID,
    CATEGORY,
    DISP_STAGE,
    DISP_WORK_STATE,
    DISP_RESULT,
    DISP_H_GROUP,
    OUTCOME,
    KSG,
    CAT_INFO,
    IDSP_NAME,
    MP_NAME,
    ORDER_V_NAME,
    DH_INFO_NAME,
    CODE_SPEC_NAME,
    CODE_PROF_NAME,
    IS_CHIELD_NAME,
    SMP_BRIG_NAME,
    RESULT_NAME,
    OUTCOME_NAME,
    FOR_POM,
    VID_HMP,
    METOD_HMP,
    AGE_GRP,
    CHIELD_WITH_ROP,
    FOR_POM_NAME,
    REGISTRY_ID,
    PAYMENT_TYPE_ID,
    PAYMENT_NAME,
    REGISTRY_NAME,
    SUM_USL,
    DOCTOR_FIO,
    DOCTOR_COD,
    NUM_SP,
    IDCASE,
    Q_U_2016,
    HAS_ERRORS,
    CODE_MES1,
    COMENTSL,
    SMO,
    OKATO_SMO,
    OKATO_G,
    OKATO_P,
    SUM_OPL,
    N_ZAP,
    ZSP_VPOLIS,
    ZSP_SPOLIS,
    ZSP_NPOLIS,
    ZSP_POLIS_BP,
    ZSP_POLIS_EP,
    ZSP_SMO_OGRN,
    ZSP_SMO_CODE,
    ZSP_ENP,
    ZSP_SEND_DATE,
    ZSP_RESP_DATE,
    AGE,
    DR,
    DOC_SER,
    DOC_NUM,
    SEX,
    PODR,
    KSLP,
    REG_DATE,
    AGE_NAME,
    M,
    Y,
    CH_NUM,
    INV_STATE,
    KSG_NUM,
    KSG_PROF_NUM,
    NPR_MO,
    PER,
    VBR,
    TAL_D,
    TAL_P,
    INV,
    RSLT_D,
    NAZR,
    NAZ_SP,
    NAZ_V,
    NAZ_PMP,
    NAZ_PK,
    IDSP_NOT_AUTO,
    AGE_GRP_NOT_AUTO,
    USER_ID,
    USER_FIO,
    MSE,
    BARTHEL_IDX,
    CODE_SPEC_V021,
    ID_PAC,
    DISP,
    P_CEL,
    C_ZAB,
    KSG_CRITERION,
    PR_NOV,
    MCOD,
    PR_DATE_1,
    PR_DATE_2,
    DN,
    JOB_NAME)
AS
select z.id,
       z.q_u,
       z.mp,
       z.order_v,
       z.code_spec,
       z.code_prof,
       z.otd_prof,
       z.is_chield,
       z.n_hist,
       z.date_1,
       z.date_2,
       z.ds0,
       z.ds1,
       z.ds2,
       z.tar_usl,
       z.k_uslf,
       z.k_usl,
       z.idsp,
       z.target,
       z.result,  
       z.patient_id,
       p.fam,
       p.im,
       p.ot,
       q_u.name as q_u_name,
       t.name as target_name,
       z.sum_uslf,
       z.hdr_id,
       z.direction_num,
       z.direction_date,
       z.dh_info as dh_info,
       z.mes_code,
       z.smp_brig,
       z.ds3,
       Z.DCOUNT,
       z.uid,
       z.phys_id,
       z.category,
       z.disp_stage,
       z.disp_work_state,
       z.disp_result,
       z.disp_h_group,
       z.outcome,
       z.ksg,
       z.cat_info,
       i.name as idsp_name,
       m.name as mp_name,
       o.name as order_v_name,
       dh.name as dh_info_name,
       iif(z.date_2 >= '01.05.2018', (select name from h_spec_v021 where code = z.code_spec_v021), (select name from h_spec_v015 where code = z.code_spec)) as code_spec_name,
       co.name as code_prof_name,
       iif(z.is_chield = 1, 'Детское', 'Взрослое') as is_chield_name,
       sb.name as smp_brig_name,
       r.name as result_name,
       oc.name as outcome_name,
       z.for_pom,
       z.vid_hmp,
       z.metod_hmp,
       z.age_grp,
       z.chield_with_rop,
       fp.name,
       z.registry_id,
       Z.payment_type_id,
       pt.name,
       reg.name,
       z.sum_usl,
       df.fio,
       DF.pcod,
       p.num_sp,  --iif(z.payment_type_id <> 2, p.num_sp, (select ins.ser || ' ' || ins.num from patients_insurance ins where ins.patients_id = p.id and z.date_1 between ins.db and ins.de)),
       z.id_case,
       z.q_u_2016,
       0,--(select first 1 1 from error_list_local err where err.reestr_hdr_id = z.hdr_id and err.uid = z.uid),
       z.mes_code,
       z.comentsl,
       p.smo,
       p.okato_smo,
       p.okato_l,
       p.okato_r,
       z.sum_usl, --(select sum(pi.sum_opl) from patients_invoice pi where pi.zs_id = z.id),
       z.n_zap n_zap,
       zpr.vpolis,
       zpr.spolis,
       zpr.npolis,
       zpr.polis_bp,
       zpr.polis_ep,
       zpr.smo_ogrn,
       zpr.smo_code,
       zpr.enp,
       zp.send_date,
       zpr.resp_date,
       z.age,
       p.dr,
       p.doc_ser,
       p.doc_num,
       p.sex,
       z.podr,
       z.kslp,
       reg.reg_date,
       cast(floor(z.age) as varchar(3)) || ' лет ' ||
            cast(iif(extract(day from z.date_1) < extract(day from p.dr),
                 iif(extract(month from z.date_1) > extract(month from p.dr), extract(month from z.date_1) - extract(month from p.dr),
                             iif(extract(month from z.date_1) < extract(month from p.dr), 12 - extract(month from p.dr) + extract(month from z.date_1) - 1,
                                 11)),
                 iif(extract(month from z.date_1) > extract(month from p.dr), extract(month from z.date_1) - extract(month from p.dr),
                             iif(extract(month from z.date_1) < extract(month from p.dr), 12 - extract(month from p.dr) + extract(month from z.date_1),
                                   0))) as varchar(2)) || ' месяцев',
       h.m,
       h.y, 
       h.full_name,
       coalesce(inv.status_id,0),
       ksg.ksg_name,
       ksg.prof_name,
       z.npr_mo,
       z.per,
       z.vbr,
       z.tal_d,
       z.tal_p,
       z.inv,
       Z.rslt_d,
       z.nazr,
       z.naz_sp,
       z.naz_v,
       z.naz_pmp,
       z.naz_pk,
       z.idsp_not_auto,
       Z.age_grp_not_auto,
       z.user_id,
       s.fio,
       z.mse,
       z.barthel_idx ,
       z.code_spec_v021,
       z.id_pac,
       Z.disp,
       z.p_cel,
       z.c_zab,
       z.ksg_criterion,
       z.pr_nov,
       z.mcod, 
       z.pr_date_1,
       z.pr_date_2,
       z.dn,
       contr.short_name
from zs z
join patients p on p.id = z.patient_id
join zs_hdr h on h.id = z.hdr_id
left join invoice inv on inv.id = h.name
left join h_q_u q_u on q_u.id = z.q_u
left join h_target t on t.id = z.target
left join h_idsp i on i.id = z.idsp
left join h_mp m on m.code = z.mp
left join h_order_v o on o.id = z.order_v
left join h_dh_info dh on dh.id = z.dh_info
left join h_spec_v015 cs on cs.code = z.code_spec
left join h_code_otd co on co.code = z.code_prof
left join h_smp_brig sb on sb.id = z.smp_brig
left join h_result r on r.code = z.result
left join h_outcome oc on oc.code = z.outcome
left join h_for_pom fp on fp.code = z.for_pom
left join h_payment_type pt on pt.id = z.payment_type_id
left join v_registry reg on reg.id = z.registry_id
left join doctors_fio df on df.id = z.phys_id
left join zsp zp on zp.zs_id = z.id
left join zsp_resp zpr on zpr.zsp_id = zp.id
left join h_ksg ksg on (cast(ksg.ksg as varchar(50))) = z.ksg and z.q_u = ksg.q_u and z.date_2 between ksg.bp and ksg.epv
left join users s on s.id = z.user_id
left join contragents contr on contr.id = p.job_id
where h.is_delete <> 1;


/******************************************************************************/
/****                          Creating triggers                           ****/
/******************************************************************************/

CREATE TRIGGER CONTRAGENTS_BI FOR CONTRAGENTS
ACTIVE
BEFORE INSERT
POSITION 0 
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_contragents_id,1);
end;


/******************************************************************************/
/****                      Altering stored procedures                      ****/
/******************************************************************************/
ALTER PROCEDURE SP_ADD_SMO_FROM_SPRAV(
  SMO_CODE DM_SMO /* COLLATE WIN1251 - default */)
AS
begin
  insert into CONTRAGENTS (ORG_CODE, SHORT_NAME, FULL_NAME, ADRES, INN, PHONES, EMAILS, WWW, TYPE_ID,
                         OGRN, KPP, TF_OKATO)
    select first 1 s.code, s.name, s.full_name, coalesce(s.index_fact,'') || s.address_fact, s.inn, s.phone,
           s.e_mail, s.www, null, s.ogrn, s.kpp, s.okato
    from h_smo s
    where s.code = :smo_code;
end;


/******************************************************************************/
/****                    Restoring deactivated triggers                    ****/
/******************************************************************************/
ALTER TRIGGER DOCTORS_MP_BIU0
AS
begin
  if (coalesce(new.mp_name,'') = '') then
   NEW.mp_name = (select v.name from h_MP v where v.code = new.MP);
end;

ALTER TRIGGER DOCTORS_SPEC_BIU0
AS
begin
  if (new.code_spec is not null) then
    new.code_v021 = (select first 1 s.code_v021 from h_v015_v021 s where cast(s.code_v015 as varchar(10)) = new.code_spec);
  else
  if (new.code_v021 is not null) then
    new.code_spec = cast((select first 1 s.code_v015 from h_v015_v021 s where s.code_v021 = new.code_v021) as varchar(10));

  if (coalesce(new.spec_name,'') = '') then
   NEW.spec_name = (select v.name from h_spec_v021 v where v.code = new.code_v021);
   
  if (coalesce(new.mp_name,'') = '') then
   NEW.mp_name = (select v.name from h_MP v where v.code = new.MP); 
end;


/******************************************************************************/
/****                   Restoring deactivated procedures                   ****/
/******************************************************************************/
ALTER PROCEDURE SP_PRINT_REPORT_1
RETURNS (
  Q_U INTEGER,
  USL_NAME VARCHAR(50) /* COLLATE WIN1251 - default */,
  K_USLF NUMERIC(6,3),
  SUM_USLF NUMERIC(18,3),
  CNT INTEGER,
  AGE17 BIGINT,
  AGE17_USL NUMERIC(6,2),
  AGE17_SUM NUMERIC(18,2),
  AGE50_55 BIGINT,
  AGE50_55_USL NUMERIC(6,2),
  AGE50_55_SUM NUMERIC(18,2),
  MP_NAME VARCHAR(250) /* COLLATE WIN1251 - default */,
  MP VARCHAR(2) /* COLLATE WIN1251 - default */,
  K_USLF_STOM INTEGER,
  AGE17_USL_STOM INTEGER,
  AGE50_55_USL_STOM INTEGER,
  OUT INTEGER,
  OUT_USL NUMERIC(6,2),
  OUT_SUM NUMERIC(15,2),
  AGE17_MEN INTEGER,
  AGE50_55_MEN INTEGER,
  MEN INTEGER,
  OUT_MEN INTEGER)
AS
BEGIN
  FOR
    select r.q_u, u.name usl_name, m.name as mp_name, m.code as mp_code,
           sum(r.k_uslf) k_uslf, sum(r.sum_uslf) sum_uslf, count(*) cnt,
           sum(r.dcount) k_uslf_stom,
           sum(iif((r.date_1-p.dr)/365.25 < 18, 1, 0)) age17,
           sum(iif((r.date_1-p.dr)/365.25 < 18, r.k_uslf, 0)) age17_usl,
           sum(iif((r.date_1-p.dr)/365.25 < 18, r.sum_uslf, 0)) age17_sum,
           sum(iif((r.date_1-p.dr)/365.25 < 18, r.dcount, 0)) age17_usl_stom,
           sum(iif((((r.date_1-p.dr)/365.25 > 49) and (p.sex = 'Ж')) or (((r.date_1-p.dr)/365.25 > 54) and (p.sex = 'М')), 1, 0)) age50_55,
           sum(iif((((r.date_1-p.dr)/365.25 > 49) and (p.sex = 'Ж')) or (((r.date_1-p.dr)/365.25 > 54) and (p.sex = 'М')), r.k_uslf, 0)) age50_55_usl,
           sum(iif((((r.date_1-p.dr)/365.25 > 49) and (p.sex = 'Ж')) or (((r.date_1-p.dr)/365.25 > 54) and (p.sex = 'М')), r.sum_uslf, 0)) age50_55_sum,
           sum(iif((((r.date_1-p.dr)/365.25 > 49) and (p.sex = 'Ж')) or (((r.date_1-p.dr)/365.25 > 54) and (p.sex = 'М')), r.dcount, 0)) age50_55_usl_stom,
           sum(iif(p.smo in (83001,83002,83003,83004,83005,83006,83007,
                                    83008,83009,83010,83011,83012,83013), 0, 1)) out,
           sum(iif(p.smo in (83001,83002,83003,83004,83005,83006,83007,
                                    83008,83009,83010,83011,83012,83013), 0, r.k_uslf)) out_usl,
           sum(iif(p.smo in (83001,83002,83003,83004,83005,83006,83007,
                                    83008,83009,83010,83011,83012,83013), 0, r.sum_uslf)) out_sum,
           count(distinct p.id),
           count(distinct(iif((r.date_1-p.dr)/365.25 < 18, p.id, null))) age17_men,
           count(distinct(iif((((r.date_1-p.dr)/365.25 > 49) and (p.sex = 'Ж')) or (((r.date_1-p.dr)/365.25 > 54) and (p.sex = 'М')), p.id, null))) age50_55_men,
           count(distinct(iif(p.smo in (83001,83002,83003,83004,83005,83006,83007,
                                    83008,83009,83010,83011,83012,83013), null, p.id))) out_men
    from
    zs r
    join sys$temp_id s on s.temp_id = r.hdr_id
    join patients p on p.id=r.patient_id
    join h_q_u u on u.id=r.q_u
    join h_mp m on m.code = r.mp
    group by 1, 2, 3, 4
    INTO :Q_U,
         :USL_NAME,
         :mp_name,
         :mp,
         :K_USLF,
         :SUM_USLF,
         :CNT,
         :k_uslf_stom,
         :AGE17, :age17_usl, :age17_sum, :age17_usl_stom,
         :age50_55, :age50_55_usl, :age50_55_sum, :age50_55_usl_stom,
         :out, :out_usl, :out_sum,
         :men, :age17_men, :age50_55_men, :out_men
  DO
  BEGIN
    SUSPEND;
  END
END;


/******************************************************************************/
/****                       Updating object comments                       ****/
/******************************************************************************/

DESCRIBE FIELD CODE VIEW V_H_SMO
'Код СМО';

DESCRIBE FIELD NAME VIEW V_H_SMO
'Наименование';

DESCRIBE FIELD OKATO VIEW V_H_SMO
'ОКАТО';

DESCRIBE FIELD OGRN VIEW V_H_SMO
'ОГРН';

DESCRIBE FIELD TERR_NAME VIEW V_H_SMO
'Территория';

DESCRIBE FIELD DATEBEG VIEW V_H_SMO
'Дата начала действия';

DESCRIBE FIELD DATEEND VIEW V_H_SMO
'Дата окончания действия';

DESCRIBE FIELD IS_ACTIVE VIEW V_H_SMO
'Действующая';


