DROP VIEW V_ZS;


/******************************************************************************/
/****                            Creating views                            ****/
/******************************************************************************/
CREATE VIEW V_ZS (
    ID,
    Q_U,
    MP,
    ORDER_V,
    CODE_SPEC,
    CODE_PROF,
    OTD_PROF,
    IS_CHIELD,
    N_HIST,
    DATE_1,
    DATE_2,
    DS0,
    DS1,
    DS2,
    TAR_USL,
    K_USLF,
    K_USL,
    IDSP,
    TARGET,
    RESULT,
    PATIENT_ID,
    FAM,
    IM,
    OT,
    Q_U_NAME,
    TARGET_NAME,
    SUM_USLF,
    HDR_ID,
    DIRECTION_NUM,
    DIRECTION_DATE,
    DH_INFO,
    MES_CODE,
    SMP_BRIG,
    DS3,
    DCOUNT,
    UID,
    PHYS_ID,
    CATEGORY,
    DISP_STAGE,
    DISP_WORK_STATE,
    DISP_RESULT,
    DISP_H_GROUP,
    OUTCOME,
    KSG,
    CAT_INFO,
    IDSP_NAME,
    MP_NAME,
    ORDER_V_NAME,
    DH_INFO_NAME,
    CODE_SPEC_NAME,
    CODE_PROF_NAME,
    IS_CHIELD_NAME,
    SMP_BRIG_NAME,
    RESULT_NAME,
    OUTCOME_NAME,
    FOR_POM,
    VID_HMP,
    METOD_HMP,
    AGE_GRP,
    CHIELD_WITH_ROP,
    FOR_POM_NAME,
    REGISTRY_ID,
    PAYMENT_TYPE_ID,
    PAYMENT_NAME,
    REGISTRY_NAME,
    SUM_USL,
    DOCTOR_FIO,
    DOCTOR_COD,
    NUM_SP,
    IDCASE,
    Q_U_2016,
    HAS_ERRORS,
    CODE_MES1,
    COMENTSL,
    SMO,
    OKATO_SMO,
    OKATO_G,
    OKATO_P,
    SUM_OPL,
    N_ZAP,
    ZSP_VPOLIS,
    ZSP_SPOLIS,
    ZSP_NPOLIS,
    ZSP_POLIS_BP,
    ZSP_POLIS_EP,
    ZSP_SMO_OGRN,
    ZSP_SMO_CODE,
    ZSP_ENP,
    ZSP_SEND_DATE,
    ZSP_RESP_DATE,
    AGE,
    DR,
    DOC_SER,
    DOC_NUM,
    SEX,
    PODR,
    KSLP,
    REG_DATE,
    AGE_NAME,
    M,
    Y,
    CH_NUM,
    INV_STATE,
    KSG_NUM,
    KSG_PROF_NUM,
    NPR_MO,
    PER,
    VBR,
    TAL_D,
    TAL_P,
    INV,
    RSLT_D,
    NAZR,
    NAZ_SP,
    NAZ_V,
    NAZ_PMP,
    NAZ_PK,
    IDSP_NOT_AUTO,
    AGE_GRP_NOT_AUTO,
    USER_ID,
    USER_FIO,
    MSE,
    BARTHEL_IDX,
    CODE_SPEC_V021,
    ID_PAC,
    DISP,
    P_CEL,
    C_ZAB,
    KSG_CRITERION,
    PR_NOV,
    MCOD,
    PR_DATE_1,
    PR_DATE_2,
    DN,
    JOB_NAME,
    LPU)
AS
select z.id,
       z.q_u,
       z.mp,
       z.order_v,
       z.code_spec,
       z.code_prof,
       z.otd_prof,
       z.is_chield,
       z.n_hist,
       z.date_1,
       z.date_2,
       z.ds0,
       z.ds1,
       z.ds2,
       z.tar_usl,
       z.k_uslf,
       z.k_usl,
       z.idsp,
       z.target,
       z.result,  
       z.patient_id,
       p.fam,
       p.im,
       p.ot,
       q_u.name as q_u_name,
       t.name as target_name,
       z.sum_uslf,
       z.hdr_id,
       z.direction_num,
       z.direction_date,
       z.dh_info as dh_info,
       z.mes_code,
       z.smp_brig,
       z.ds3,
       Z.DCOUNT,
       z.uid,
       z.phys_id,
       z.category,
       z.disp_stage,
       z.disp_work_state,
       z.disp_result,
       z.disp_h_group,
       z.outcome,
       z.ksg,
       z.cat_info,
       i.name as idsp_name,
       m.name as mp_name,
       o.name as order_v_name,
       dh.name as dh_info_name,
       iif(z.date_2 >= '01.05.2018', (select name from h_spec_v021 where code = z.code_spec_v021), (select name from h_spec_v015 where code = z.code_spec)) as code_spec_name,
       co.name as code_prof_name,
       iif(z.is_chield = 1, ' ', '') as is_chield_name,
       sb.name as smp_brig_name,
       r.name as result_name,
       oc.name as outcome_name,
       z.for_pom,
       z.vid_hmp,
       z.metod_hmp,
       z.age_grp,
       z.chield_with_rop,
       fp.name,
       z.registry_id,
       Z.payment_type_id,
       pt.name,
       reg.name,
       z.sum_usl,
       df.fio,
       DF.pcod,
       p.num_sp,  --iif(z.payment_type_id <> 2, p.num_sp, (select ins.ser || ' ' || ins.num from patients_insurance ins where ins.patients_id = p.id and z.date_1 between ins.db and ins.de)),
       z.id_case,
       z.q_u_2016,
       0,--(select first 1 1 from error_list_local err where err.reestr_hdr_id = z.hdr_id and err.uid = z.uid),
       z.mes_code,
       z.comentsl,
       p.smo,
       p.okato_smo,
       p.okato_l,
       p.okato_r,
       z.sum_usl, --(select sum(pi.sum_opl) from patients_invoice pi where pi.zs_id = z.id),
       z.n_zap n_zap,
       zpr.vpolis,
       zpr.spolis,
       zpr.npolis,
       zpr.polis_bp,
       zpr.polis_ep,
       zpr.smo_ogrn,
       zpr.smo_code,
       zpr.enp,
       zp.send_date,
       zpr.resp_date,
       z.age,
       p.dr,
       p.doc_ser,
       p.doc_num,
       p.sex,
       z.podr,
       z.kslp,
       reg.reg_date,
       cast(floor(z.age) as varchar(3)) || '  ' ||
            cast(iif(extract(day from z.date_1) < extract(day from p.dr),
                 iif(extract(month from z.date_1) > extract(month from p.dr), extract(month from z.date_1) - extract(month from p.dr),
                             iif(extract(month from z.date_1) < extract(month from p.dr), 12 - extract(month from p.dr) + extract(month from z.date_1) - 1,
                                 11)),
                 iif(extract(month from z.date_1) > extract(month from p.dr), extract(month from z.date_1) - extract(month from p.dr),
                             iif(extract(month from z.date_1) < extract(month from p.dr), 12 - extract(month from p.dr) + extract(month from z.date_1),
                                   0))) as varchar(2)) || ' ',
       h.m,
       h.y, 
       h.full_name,
       coalesce(inv.status_id,0),
       ksg.ksg_name,
       ksg.prof_name,
       z.npr_mo,
       z.per,
       z.vbr,
       z.tal_d,
       z.tal_p,
       z.inv,
       Z.rslt_d,
       z.nazr,
       z.naz_sp,
       z.naz_v,
       z.naz_pmp,
       z.naz_pk,
       z.idsp_not_auto,
       Z.age_grp_not_auto,
       z.user_id,
       s.fio,
       z.mse,
       z.barthel_idx ,
       z.code_spec_v021,
       z.id_pac,
       Z.disp,
       z.p_cel,
       z.c_zab,
       z.ksg_criterion,
       z.pr_nov,
       z.mcod, 
       z.pr_date_1,
       z.pr_date_2,
       z.dn,
       contr.short_name,
       inv.lpu
from zs z
join patients p on p.id = z.patient_id
join zs_hdr h on h.id = z.hdr_id
left join invoice inv on inv.id = h.name
left join h_q_u q_u on q_u.id = z.q_u
left join h_target t on t.id = z.target
left join h_idsp i on i.id = z.idsp
left join h_mp m on m.code = z.mp
left join h_order_v o on o.id = z.order_v
left join h_dh_info dh on dh.id = z.dh_info
left join h_spec_v015 cs on cs.code = z.code_spec
left join h_code_otd co on co.code = z.code_prof
left join h_smp_brig sb on sb.id = z.smp_brig
left join h_result r on r.code = z.result
left join h_outcome oc on oc.code = z.outcome
left join h_for_pom fp on fp.code = z.for_pom
left join h_payment_type pt on pt.id = z.payment_type_id
left join v_registry reg on reg.id = z.registry_id
left join doctors_fio df on df.id = z.phys_id
left join zsp zp on zp.zs_id = z.id
left join zsp_resp zpr on zpr.zsp_id = zp.id
left join h_ksg ksg on (cast(ksg.ksg as varchar(50))) = z.ksg and z.q_u = ksg.q_u and z.date_2 between ksg.bp and ksg.epv
left join users s on s.id = z.user_id
left join contragents contr on contr.id = p.job_id
where h.is_delete <> 1;


/******************************************************************************/
/****                          Altering triggers                           ****/
/******************************************************************************/

ALTER TRIGGER ZSD_BIU0
AS
declare variable mp integer;
declare variable q_u integer;
declare variable tar numeric(15,2);
begin
  q_u = (select q_u from zs where id = new.zs_id);

--  mp = (select mp from doctors_spec s where s.doctor_id = new.phys_id and s.code_spec = new.code_spec);
--   if (:mp is not null) then
--     new.mp = :mp;

--   new.ds_class = (SELECT first 1 MKB_CLASS_NUM FROM H_MKB WHERE CODE = NEW.DS);
  new.is_onk = (select IS_ONK from SP_CHECK_DS_AS_ONK2(new.ds, new.ds2));

  if (new.pmd_close = 1) then
    update zsd
    set pmd_close = 0
    where zs_id = new.zs_id;

  if (new.pmd_close is null) then
    new.pmd_close = 1;

  if ((select z.payment_type_id from zs z where z.id = new.zs_id) in (3,2)) then
  begin
      tar = (select coalesce(u.sumf,0) from h_usl u where u.code = new.code_usl and u.q_u containing :q_u and u.payment_type_id = (select z.payment_type_id from zs z where z.id = new.zs_id));
    
      if (tar > 0) then
      begin
        NEW.sum_uslf = :tar * new.k_uslf;
        NEW.tar_usl = :tar;
      END
  end
--  else
--    if (new.tar_usl = 0 and new.sum_uslf = 0) then new.k_uslf = 0;

  if (new.phys_id is not null and new.code_spec_v021 is null) then
    new.code_spec_v021 = (select first 1 s.code_v021 from doctors_spec s where s.doctor_id = new.phys_id);

  if (new.phys_id is not null and new.mp is null and new.code_spec_v021 is not null) then
    new.mp = (select first 1 m.mp from doctors_spec m where m.doctor_id = new.phys_id and m.code_v021 = new.code_spec_v021);

  if (new.phys_id is not null and new.code_prof is null) then
    new.code_prof = (select first 1 p.prof from doctors_prof p where p.doctor_id = new.phys_id and p.code_spec =
                     (select first 1 s.code_v021 from doctors_spec s where s.doctor_id = new.phys_id));

--  if (new.code_spec is not null) then
--    new.code_spec_v021 = (select first 1 s.code_v021 from h_v015_v021 s where cast(s.code_v015 as varchar(10)) = new.code_spec);
--  else
  if (new.code_spec_v021 is not null) then
    new.code_spec = cast((select first 1 s.code_v015 from h_v015_v021 s where s.code_v021 = new.code_spec_v021) as varchar(10));

--  if (inserting) then
--  update or insert into DOCTORS_SPEC (DOCTOR_ID, CODE_V021, MP)
--    values (new.phys_id, new.code_spec_v021, new.mp)
--    matching (DOCTOR_ID, CODE_V021, MP);
  if (coalesce(new.ds,'') = '') then
    new.ds = (select d.ds from zs_ds d where d.section = 2 and d.section_id = new.id and d.ds_type = 1);

  if ((coalesce(new.code_usl,'') = '') and (coalesce(old.code_usl,'') = '') and ((select z.payment_type_id from zs z where z.id = new.zs_id) = 1) and (q_u = 2)
       and ((select z.target from zs z where z.id = new.zs_id) in (1,26)) and (new.date_1 >= '01.01.2019')) then
  begin
    if (exists(select first 1 id from zsd d where d.zs_id = new.zs_id and d.date_1 < new.date_1 and d.code_spec_v021 = new.code_spec_v021)) then
    begin
      if (new.is_chield = 1) then
        new.code_usl = (select first 1 n.code_usl2_det from h_tarif_app_spec s join h_tarif_app_name n on n.id = s.name_id where s.code_spec_v021 = new.code_spec_v021);
      else
        new.code_usl = (select first 1 n.code_usl2 from h_tarif_app_spec s join h_tarif_app_name n on n.id = s.name_id where s.code_spec_v021 = new.code_spec_v021);
    end
    else
    begin
      if (new.is_chield = 1) then
        new.code_usl = (select first 1 n.code_usl1_det from h_tarif_app_spec s join h_tarif_app_name n on n.id = s.name_id where s.code_spec_v021 = new.code_spec_v021);
      else
        new.code_usl = (select first 1 n.code_usl1 from h_tarif_app_spec s join h_tarif_app_name n on n.id = s.name_id where s.code_spec_v021 = new.code_spec_v021);
    end
  end
end;


/******************************************************************************/
/****                      Altering stored procedures                      ****/
/******************************************************************************/
ALTER PROCEDURE SP_CALC_STAC_2020(
  IDA INTEGER)
AS
declare variable KSG type of DM_CHAR_50;
declare variable DS type of DM_DS;
declare variable IDB integer;
declare variable SUM_USLF type of DM_MONEY;
declare variable KSKP numeric(6,6);
declare variable Q_U integer;
declare variable FINE_KOEF type of DM_NUM_3_2;
declare variable TARIF numeric(10,6);
declare variable IS_TRANSFER DM_INT;
declare variable CL_CNT integer;
declare variable ERR_CODE integer;
declare variable K_DOWN DM_NUM_6_2;
declare variable DS_CLASS DM_CHAR_10;
declare variable KZ DM_NUM_2_5;
declare variable KD DM_NUM_2_5;
declare variable KUS DM_NUM_2_5;
declare variable BS DM_NUM_6_2;
declare variable PROF_NUM integer;
declare variable FINE_KOEF_SET_DOCTOR DM_BOOLEAN;
declare variable IS_ROUND_JANAO integer;
declare variable OKATO DM_OKATO;
declare variable DOP_CODE DM_CHAR_40;
declare variable DATE1 DM_DATE;
declare variable DATE2 DM_DATE;
begin
  okato = (select first 1 c.tf_okato from contragents c where c.type_id = 1);

  if (okato <> '40000') then
  select c.tf_okato
   from zs_hdr h
        join zs z on z.hdr_id = h.id
        join invoice i on i.id = h.name
        join contragents c on c.id = i.contragent_id
   where z.id = :ida
   into :okato;

   -----------------------------------------------------------------------------
   --    
   for select d.id, d.date_1, d.date_2
          from zs z
               join zsd d on d.zs_id = z.id
          where z.id = :ida and (not exists(select dd.id from zsd dd where dd.zs_id = :ida
                                                                     and dd.date_1 <=d.date_1 and dd.date_2 >= d.date_2 and dd.id <> d.id) )
          order by d.ksg desc
          into :idb, :date1, :date2
          do
          begin
            update zsd d
             set d.zsd_id = :idb
             where d.id = :idb;
    
            update zsd d
             set d.zsd_id = :idb
             where d.zs_id = :ida and coalesce(d.code_usl,'') <> ''
                   and d.date_1 between :date1 and :date2
                   and not exists(select id from zsd d2 where d2.zs_id = :ida and d2.date_1 = d.date_1 and d2.id <> :idb and d2.id <> d.id);
          end
   -----------------------------------------------------------------------------
   if (:okato is  null) then
     okato = (select first 1 c.tf_okato from contragents c where c.type_id = 1);

    if (okato = '71140') then
      is_round_janao = 1;

    update zsd d
      set d.ds_class = (select MKB_CLASS from SP_GET_MKB_CLASS(D.ds))
      where d.zs_id = :ida;

    update zsd d
     set d.ksg = null, 
         d.ksg_base = null,
         d.tar_base = null,
         d.sum_base = null,
         d.kskp_base = null,
         d.sum_uslf = 0,
         d.tar_usl = 0,
         d.comment_local = null
     where d.zs_id = :ida;

    update zs z
     set z.ksg = null,
         z.tar_usl = 0,
         z.sum_usl = 0
     where z.id = :ida;

     cl_cnt = (select count(distinct b.ds_class) from ZSD b where b.ZS_ID = :ida and b.zsd_id = b.id);
     is_transfer = (select count(b.id) from ZSD b where b.ZS_ID = :ida and b.zsd_id = b.id);
     delete from kslp_koef where zs_id = :ida ;

     select a.q_u, a.date_2, coalesce(a.fine_koef_set_doctor,0)
      from zs a
      where a.id = :ida
      into :q_u, :date2, :fine_koef_set_doctor;

     for select sp.KSG, sp.ERR_CODE, b.ds, b.id, coalesce(bs.tarif * kd.kd * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0),
                k.kz, kd.kd,
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0),
                bs.tarif, k.k_down, k.prof_num, b.date_1, coalesce(b.fine_koef,1)
      from zs a
      join zsd b on a.id = b.zs_id
      join patients p on p.id = a.patient_id
      join lpu_factors lf on lf.q_u = a.q_u and a.date_2 between lf.bp and lf.epv and lf.okato is not distinct from :okato
      join h_tarif_bs bs on bs.q_u = a.q_u and a.date_2 between bs.bp and bs.epv and bs.okato is not distinct from :okato
      join h_tarif_kd kd on a.date_2 between kd.bp and kd.epv and kd.okato is not distinct from :okato
      left join sp_ksg_get_2020(b.id) sp on 1=1
      left join h_ksg k on k.ksg = sp.ksg and a.date_2 between k.bp and k.epv and k.q_u = a.q_u
      where b.zs_id = :ida and b.id = b.zsd_id
      order by b.code_usl
      into :ksg, :err_code, :ds, :idb, :tarif, :kz, :kd, :kus, :bs, :k_down, :prof_num, :date1, :fine_koef
      do
      begin
        kskp = 1;

        if (:okato = '70000') then
        begin
          select first 1 u.code_1, u.code_2
           from zsd d
                join h_usl u on u.code = d.code_usl and u.payment_type_id = 1 and :date1 between u.datebeg and u.dateend and u.q_u containing :q_u
           where d.id = :idb
          into :ksg, :dop_code;
        end

        if ((q_u in (1,3)) and (err_code is null)) then
          kskp = (select KSKP from sp_calc_stac_kskp_2020(:ida, :idb, :ksg, :cl_cnt));

        if (kskp is null) then kskp = 1;

        if (fine_koef_set_doctor = 0) then
          fine_koef = (select FINE_KOEF from sp_calc_stac_fine_2020(:ida, :idb, :ksg, :cl_cnt));

        if (is_round_janao = 1) then
          sum_uslf = cast(cast(tarif * kskp as numeric(15,4)) * fine_koef as int);
        else
          sum_uslf = cast(tarif * kskp as numeric(15,2)) * fine_koef;

        if (:ksg is not null) then
        begin
            update zsd b set
             b.ksg_base = :ksg,
             b.tar_base = iif(:is_round_janao = 1, cast(:tarif*coalesce(:kskp,1) as int), cast(:tarif*coalesce(:kskp,1) as numeric(15,2))),
             b.sum_base = :sum_uslf,
             b.kskp_base = :kskp,
             b.koef_z = :kz, 
             b.koef_d = :kd,
             b.koef_u = :kus,
             b.bs = :bs,
             b.koef_up = :k_down,
             b.reab = iif(:prof_num = 37,1,null),
             b.fine_koef = :fine_koef,
             b.dop_code_usl = iif(:okato = '70000', :dop_code, b.dop_code_usl)
             where b.id = :idb;
         end
      end 
--------------------------------------------------------------------------------
      --    6  + 
      if (q_u = 1) then
       if (exists (select 1 from zsd b where b.zs_id = :ida and ((b.ksg in ('st02.001') and b.k_uslf >= 6) or (b.ksg in ('O14.1','O34.2','O36.3','O36.4','O42.2') and b.k_uslf >= 2) ))
          and exists (select 1 from zsd b where b.zs_id = :ida and b.ksg in ('st02.003', 'st02.004'))) then
          begin
            --    ,     
            select first 1 b.ksg_base, b.ds
            from zs a
             join zsd b on a.id = b.zs_id
             where b.zs_id = :ida and b.ksg in ('st02.003', 'st02.004')
             into :ksg, :ds;
       
            update zsd d
            set d.tar_usl = d.tar_base,
                d.sum_uslf = d.sum_base,
                d.ksg = d.ksg_base,
                d.kskp = d.kskp_base
            where d.zs_id = :ida;

            --   
            select coalesce(sum(b.sum_uslf), 0) from zsd b where b.zs_id = :ida
             into :sum_uslf;
    
            update zs a set
             a.tar_usl = :tarif,
             a.sum_uslf = :sum_uslf,
             a.sum_usl = :sum_uslf,
             a.ksg = :ksg,
             a.ds1 = :ds,
             a.kslp = :kskp
             where a.id = :ida;

            exit;
          end
--------------------------------------------------------------------------------
      if ((is_transfer < 2) or (cl_cnt < 2))  then  --   
      begin
        --     2- ,   2
        --  ,    ,    
        --  ,    ()
        --     
        if ((exists(select first 1 1 from zsd d where d.zs_id = :ida and ((:q_u = 1 and d.ksg_base starting 'st37') or
                                                                                                  (:q_u = 3 and d.ksg_base starting 'ds37'))))
            or (exists(select first 1 1 from zsd d where d.zs_id = :ida and d.ksg_base in ('st36.009','st36.010','st36.011') and d.profil_k in (10,11) ))
            or (exists(select first 1 1 from zsd d where d.zs_id = :ida and d.ksg_base in ('st19.038','ds19.028')))
            or (((select count(d.id) from zsd d where d.zs_id = :ida and d.ksg_base is not null and d.profil_k = 42) >= 2) and
                 ((select count(u.id) from zsd d join onk_usl u on u.zsd_id = d.id where d.zs_id = :ida and u.usl_tip = 1) >= 2)))   then
            update zsd b set
                 b.ksg = b.ksg_base,
                 b.sum_uslf = b.sum_base,
                 b.tar_usl = b.tar_base,
                 b.kskp = b.kskp_base
            where b.zs_id = :ida and b.ksg_base is not null;
        else
        --     
        begin
          select first 1 id
           from zsd d
           where d.zs_id = :ida and d.ksg_base is not null
           order by d.koef_z desc
           into :idb;

          update zsd b set
             b.ksg = b.ksg_base,
             b.sum_uslf = b.sum_base,
             b.tar_usl = b.tar_base,
             b.kskp = b.kskp_base
           where b.id = :idb;

          update zsd b set
             b.ksg = null,
             b.sum_uslf = 0,
             b.kskp = 1,
             b.tar_usl = 0
            where b.id <> :idb and b.zs_id = :ida;
        end
      end else
      begin
        for select b.ds_class
         from zsd b
         where b.zs_id = :ida
         group by 1
         into :ds_class
         do
         begin
             select first 1 id
               from zsd d
               where d.zs_id = :ida and d.ksg_base is not null and d.ds_class = :ds_class
               order by d.koef_z desc
               into :idb;
    
             update zsd b set
                 b.ksg = b.ksg_base,
                 b.sum_uslf = b.sum_base,
                 b.tar_usl = b.tar_base,
                 b.kskp = b.kskp_base
               where b.id = :idb;

             update zsd b set
              b.ksg = null,
              b.sum_uslf = 0,
              b.kskp = 1,
              b.tar_usl = 0
              where b.id <> :idb and b.zs_id = :ida and b.ds_class = :ds_class;
         end
       end

        select first 1 b.ksg_base
        from zs a
         join zsd b on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null
         order by b.sum_base desc
         into :ksg;
   
        select coalesce(sum(b.sum_uslf), 0), coalesce(sum(b.tar_base), 0)
         from zsd b
         join zs a on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null
         into :sum_uslf, :tarif;

        update zs a set
         a.tar_usl = :tarif,
         a.sum_uslf = :sum_uslf,
         a.sum_usl = :sum_uslf,
         a.ksg = :ksg,
         a.kslp = :kskp
         where a.id = :ida;
end;

ALTER PROCEDURE SP_REESTR_EXTRACT_FOR_V2018(
  H_ID INTEGER)
AS
declare variable D_ID integer;
declare variable ZS_ID integer;
declare variable DATE1 date;
declare variable DATE2 date;
declare variable PHYS_ID integer;
declare variable CODE_SPEC integer;
declare variable HDR_ID integer;
declare variable STAGE integer;
declare variable CODE_USL DM_CHAR_20;
begin
for select h.id
    from zs_hdr h
    where h.id = :h_id or (h.parent_id = :h_id)
    into :hdr_id
    do
    begin
      update zs z
       set z.vb_p = 1
       where z.hdr_id = :hdr_id and (select count(id) from zsd d where d.zs_id = z.id and z.q_u in (1,3) and coalesce(d.code_usl,'') = '') > 1;
      /******************************************************************/
--      for select d.id, z.id, d.date_1, d.date_2
--          from zs z
--               join zsd d on d.zs_id = z.id
--          where z.hdr_id = :hdr_id and z.q_u in (1,3) and coalesce(d.code_usl,'') = ''
--          into :d_id, :zs_id, :date1, :date2
--          do
--          begin
--            update zsd d
--             set d.zsd_id = :d_id
--             where d.id = :d_id;
--    
--            update zsd d
--             set d.zsd_id = :d_id
--             where d.zs_id = :zs_id and coalesce(d.code_usl,'') <> ''
--                   and d.date_1 between :date1 and :date2
--                   and not exists(select id from zsd d2 where d2.zs_id = :zs_id and coalesce(d2.code_usl,'') = '' and d2.date_1 = d.date_1 and d2.id <> :d_id);
--          end

      for select d.id, z.id, d.date_1, d.date_2
          from zs z
               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u in (1,3) and (not exists(select dd.id from zsd dd where dd.zs_id = z.id
                                                                     and dd.date_1 <=d.date_1 and dd.date_2 >= d.date_2 and dd.id <> d.id) )
--                and d.ksg is not null
          order by d.ksg desc
          into :d_id, :zs_id, :date1, :date2
          do
          begin
            update zsd d
             set d.zsd_id = :d_id
             where d.id = :d_id;
    
            update zsd d
             set d.zsd_id = :d_id
             where d.zs_id = :zs_id and coalesce(d.code_usl,'') <> ''
                   and d.date_1 between :date1 and :date2
                   and not exists(select id from zsd d2 where d2.zs_id = :zs_id and d2.date_1 = d.date_1 and d2.id <> :d_id and d2.id <> d.id);
--                   and d.ksg is null;
          end

--        for select d.id, z.id, z.date_1, z.date_2
--          from zs z
--               join zsd d on d.zs_id = z.id
--          where z.hdr_id = :hdr_id and z.q_u in (1,3) and not exists(select dd.id from zsd dd where dd.zs_id = z.id and coalesce(dd.code_usl,'') = '')
--                and not exists(select dd.id from zsd dd where dd.zs_id = z.id and dd.ksg is not null)
--          into :d_id, :zs_id, :date1, :date2
--          do
--          begin
--            update zsd d
--             set d.zsd_id = :d_id
--             where d.id = :d_id;
--    
--            update zsd d
--             set d.zsd_id = :d_id
--             where d.zs_id = :zs_id and coalesce(d.code_usl,'') <> ''
--                   and d.date_1 between :date1 and :date2
--                   and not exists(select id from zsd d2 where d2.zs_id = :zs_id and coalesce(d2.code_usl,'') = '' and d2.date_1 = :date2)
--                   and d.ksg is null;
--          end
      /***********  ***********************************************/
      for select z.id, d.phys_id, d.code_spec_v021, z.date_1, z.date_2
          from zs z
               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u in (2,5) and z.target not in (9,10,11,12,13,14,15,16,17,21,22) and z.idsp <> 28
          group by 1,2,3,4,5
          into :zs_id, :phys_id, :code_spec, :date1, :date2
          do
          begin
            d_id = (select first 1 id from zsd d where d.zs_id = :zs_id /*and d.phys_id = :phys_id*/ and d.code_spec_v021 = :code_spec and d.date_1 between :date1 and :date2 order by d.date_1 desc);
    
            update zsd d
             set d.zsd_id = :d_id
             where d.zs_id = :zs_id and d.date_1 between :date1 and :date2 /*and d.phys_id = :phys_id*/ and d.code_spec_v021 = :code_spec;
            d_id = null;
          end

      /*********************************************************/
      /**    SL*******************************/
      for select z.id, d.phys_id, d.code_spec_v021, z.date_1, z.date_2, d.code_usl
          from zs z
               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u in (2,5) and z.target not in (9,10,11,12,13,14,15,16,17,21,22) and z.idsp = 28 and
                ((d.code_usl starting 'A04') or (d.code_usl starting  'A08'))
--          group by 1,2,3,4,5
          into :zs_id, :phys_id, :code_spec, :date1, :date2, :code_usl
          do
          begin
            update zsd d
             set d.zsd_id = d.id
             where d.zs_id = :zs_id;
            d_id = null;
          end
     /******  sl*****************/
     for select z.id, d.id, d.phys_id, d.code_spec_v021, z.date_1, z.date_2, d.code_usl
          from zs z
               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u in (2,5) and z.target not in (9,10,11,12,13,14,15,16,17,21,22) and z.idsp = 28 and
                ((d.code_usl not starting 'A04') and (d.code_usl not starting 'A08'))
--          group by 1,2,3,4,5,6,7
          into :zs_id, :d_id, :phys_id, :code_spec, :date1, :date2, :code_usl
          do
          begin
            update zsd d
             set d.zsd_id = :d_id
             where d.id = :d_id;

            update zsd d
             set d.zsd_id = :d_id
             where d.zs_id = :zs_id;
            d_id = null;
          end

      /***********  ***********************************************/
      for select z.id, d.phys_id, d.code_spec_v021, d.date_1, d.date_2
          from zs z
               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u in (4) and z.target not in (9,10,11,12,13,14,15,16,17,21,22) and z.idsp <> 28
          group by 1,2,3,4,5
          into :zs_id, :phys_id, :code_spec, :date1, :date2
          do
          begin
            d_id = (select first 1 id from zsd d where d.zs_id = :zs_id and d.phys_id = :phys_id and d.code_spec_v021 = :code_spec and d.date_1 = :date1 and d.date_2 = :date2);
    
            update zsd d
             set d.zsd_id = :d_id
             where d.zs_id = :zs_id and d.date_1 between :date1 and :date2 and d.phys_id = :phys_id and d.code_spec_v021 = :code_spec;
            d_id = null;
          end
      /***********  ***********************************************/
      for select z.id, z.disp_stage
          from zs z
--               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u in (2) and z.target in (9,10,11,12,13,14,15,16,17) --and d.code_usl in ('1','16')
          group by 1,2
          into :zs_id, :stage
          do
          begin
            d_id = (select first 1 id from zsd d where d.zs_id = :zs_id and (d.code_usl in ('1','16','66','67','68','69','B04.047.002',
                    'B04.023.002','B04.057.002','B04.018.002','B01.053.001','B04.001.002','B04.028.002','B04.029.004','B04.070.005','B04.047.002','B04.047.002.099') or :stage = 2) order by d.date_1);
            update zsd d
             set d.zsd_id = :d_id
             where d.zs_id = :zs_id;
            d_id = null;
          end
      /***********-***********************************************/
      for select z.id
          from zs z
--               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u = 2 and z.target in (21,22)
          group by 1
          into :zs_id
          do
          begin
            d_id = (select first 1 id from zsd d where d.zs_id = :zs_id order by d.date_1);
            update zsd d
             set d.zsd_id = :d_id
             where d.zs_id = :zs_id;
            d_id = null;
          end
    end
end;
