/******************************************************************************/
/****                 Deactivating dependencies of objects                 ****/
/******************************************************************************/
DROP VIEW V_ZS;


/******************************************************************************/
/****                            Creating views                            ****/
/******************************************************************************/
CREATE VIEW V_ZS (
    ID,
    Q_U,
    MP,
    ORDER_V,
    CODE_SPEC,
    CODE_PROF,
    OTD_PROF,
    IS_CHIELD,
    N_HIST,
    DATE_1,
    DATE_2,
    DS0,
    DS1,
    DS2,
    TAR_USL,
    K_USLF,
    K_USL,
    IDSP,
    TARGET,
    RESULT,
    PATIENT_ID,
    FAM,
    IM,
    OT,
    Q_U_NAME,
    TARGET_NAME,
    SUM_USLF,
    HDR_ID,
    DIRECTION_NUM,
    DIRECTION_DATE,
    DH_INFO,
    MES_CODE,
    SMP_BRIG,
    DS3,
    DCOUNT,
    UID,
    PHYS_ID,
    CATEGORY,
    DISP_STAGE,
    DISP_WORK_STATE,
    DISP_RESULT,
    DISP_H_GROUP,
    OUTCOME,
    KSG,
    CAT_INFO,
    IDSP_NAME,
    MP_NAME,
    ORDER_V_NAME,
    DH_INFO_NAME,
    CODE_SPEC_NAME,
    CODE_PROF_NAME,
    IS_CHIELD_NAME,
    SMP_BRIG_NAME,
    RESULT_NAME,
    OUTCOME_NAME,
    FOR_POM,
    VID_HMP,
    METOD_HMP,
    AGE_GRP,
    CHIELD_WITH_ROP,
    FOR_POM_NAME,
    REGISTRY_ID,
    PAYMENT_TYPE_ID,
    PAYMENT_NAME,
    REGISTRY_NAME,
    SUM_USL,
    DOCTOR_FIO,
    DOCTOR_COD,
    NUM_SP,
    IDCASE,
    Q_U_2016,
    HAS_ERRORS,
    CODE_MES1,
    COMENTSL,
    SMO,
    OKATO_SMO,
    OKATO_G,
    OKATO_P,
    SUM_OPL,
    N_ZAP,
    ZSP_VPOLIS,
    ZSP_SPOLIS,
    ZSP_NPOLIS,
    ZSP_POLIS_BP,
    ZSP_POLIS_EP,
    ZSP_SMO_OGRN,
    ZSP_SMO_CODE,
    ZSP_ENP,
    ZSP_SEND_DATE,
    ZSP_RESP_DATE,
    AGE,
    DR,
    DOC_SER,
    DOC_NUM,
    SEX,
    PODR,
    KSLP,
    REG_DATE,
    AGE_NAME,
    M,
    Y,
    CH_NUM,
    INV_STATE,
    KSG_NUM,
    KSG_PROF_NUM,
    NPR_MO,
    PER,
    VBR,
    TAL_D,
    TAL_P,
    INV,
    RSLT_D,
    NAZR,
    NAZ_SP,
    NAZ_V,
    NAZ_PMP,
    NAZ_PK,
    IDSP_NOT_AUTO,
    AGE_GRP_NOT_AUTO,
    USER_ID,
    USER_FIO,
    MSE,
    BARTHEL_IDX,
    CODE_SPEC_V021,
    ID_PAC,
    DISP,
    P_CEL,
    C_ZAB,
    KSG_CRITERION,
    PR_NOV,
    MCOD,
    PR_DATE_1,
    PR_DATE_2,
    DN,
    JOB_NAME,
    LPU)
AS
select z.id,
       z.q_u,
       z.mp,
       z.order_v,
       z.code_spec,
       z.code_prof,
       z.otd_prof,
       z.is_chield,
       z.n_hist,
       z.date_1,
       z.date_2,
       z.ds0,
       z.ds1,
       z.ds2,
       z.tar_usl,
       z.k_uslf,
       z.k_usl,
       z.idsp,
       z.target,
       z.result,  
       z.patient_id,
       p.fam,
       p.im,
       p.ot,
       q_u.name as q_u_name,
       t.name as target_name,
       z.sum_uslf,
       z.hdr_id,
       z.direction_num,
       z.direction_date,
       z.dh_info as dh_info,
       z.mes_code,
       z.smp_brig,
       z.ds3,
       Z.DCOUNT,
       z.uid,
       z.phys_id,
       z.category,
       z.disp_stage,
       z.disp_work_state,
       z.disp_result,
       z.disp_h_group,
       z.outcome,
       z.ksg,
       z.cat_info,
       i.name as idsp_name,
       m.name as mp_name,
       o.name as order_v_name,
       dh.name as dh_info_name,
       iif(z.date_2 >= '01.05.2018', (select name from h_spec_v021 where code = z.code_spec_v021), (select name from h_spec_v015 where code = z.code_spec)) as code_spec_name,
       co.name as code_prof_name,
       iif(z.is_chield = 1, ' ', '') as is_chield_name,
       sb.name as smp_brig_name,
       r.name as result_name,
       oc.name as outcome_name,
       z.for_pom,
       z.vid_hmp,
       z.metod_hmp,
       z.age_grp,
       z.chield_with_rop,
       fp.name,
       z.registry_id,
       Z.payment_type_id,
       pt.name,
       reg.name,
       z.sum_usl,
       df.fio,
       DF.pcod,
       p.num_sp,  --iif(z.payment_type_id <> 2, p.num_sp, (select ins.ser || ' ' || ins.num from patients_insurance ins where ins.patients_id = p.id and z.date_1 between ins.db and ins.de)),
       z.id_case,
       z.q_u_2016,
       0,--(select first 1 1 from error_list_local err where err.reestr_hdr_id = z.hdr_id and err.uid = z.uid),
       z.mes_code,
       z.comentsl,
       p.smo,
       p.okato_smo,
       p.okato_l,
       p.okato_r,
       z.sum_usl, --(select sum(pi.sum_opl) from patients_invoice pi where pi.zs_id = z.id),
       z.n_zap n_zap,
       zpr.vpolis,
       zpr.spolis,
       zpr.npolis,
       zpr.polis_bp,
       zpr.polis_ep,
       zpr.smo_ogrn,
       zpr.smo_code,
       zpr.enp,
       zp.send_date,
       zpr.resp_date,
       z.age,
       p.dr,
       p.doc_ser,
       p.doc_num,
       p.sex,
       z.podr,
       z.kslp,
       reg.reg_date,
       cast(floor(z.age) as varchar(3)) || '  ' ||
            cast(iif(extract(day from z.date_1) < extract(day from p.dr),
                 iif(extract(month from z.date_1) > extract(month from p.dr), extract(month from z.date_1) - extract(month from p.dr),
                             iif(extract(month from z.date_1) < extract(month from p.dr), 12 - extract(month from p.dr) + extract(month from z.date_1) - 1,
                                 11)),
                 iif(extract(month from z.date_1) > extract(month from p.dr), extract(month from z.date_1) - extract(month from p.dr),
                             iif(extract(month from z.date_1) < extract(month from p.dr), 12 - extract(month from p.dr) + extract(month from z.date_1),
                                   0))) as varchar(2)) || ' ',
       h.m,
       h.y, 
       h.full_name,
       coalesce(inv.status_id,0),
       ksg.ksg_name,
       ksg.prof_name,
       z.npr_mo,
       z.per,
       z.vbr,
       z.tal_d,
       z.tal_p,
       z.inv,
       Z.rslt_d,
       z.nazr,
       z.naz_sp,
       z.naz_v,
       z.naz_pmp,
       z.naz_pk,
       z.idsp_not_auto,
       Z.age_grp_not_auto,
       z.user_id,
       s.fio,
       z.mse,
       z.barthel_idx ,
       z.code_spec_v021,
       z.id_pac,
       Z.disp,
       z.p_cel,
       z.c_zab,
       z.ksg_criterion,
       z.pr_nov,
       z.mcod, 
       z.pr_date_1,
       z.pr_date_2,
       z.dn,
       contr.short_name,
       inv.lpu
from zs z
join patients p on p.id = z.patient_id
join zs_hdr h on h.id = z.hdr_id
left join invoice inv on inv.id = h.name
left join h_q_u q_u on q_u.id = z.q_u
left join h_target t on t.id = z.target
left join h_idsp i on i.id = z.idsp
left join h_mp m on m.code = z.mp
left join h_order_v o on o.id = z.order_v
left join h_dh_info dh on dh.id = z.dh_info
left join h_spec_v015 cs on cs.code = z.code_spec
left join h_code_otd co on co.code = z.code_prof
left join h_smp_brig sb on sb.id = z.smp_brig
left join h_result r on r.code = z.result
left join h_outcome oc on oc.code = z.outcome
left join h_for_pom fp on fp.code = z.for_pom
left join h_payment_type pt on pt.id = z.payment_type_id
left join v_registry reg on reg.id = z.registry_id
left join doctors_fio df on df.id = z.phys_id
left join zsp zp on zp.zs_id = z.id
left join zsp_resp zpr on zpr.zsp_id = zp.id
left join h_ksg ksg on (cast(ksg.ksg as varchar(50))) = z.ksg and z.q_u = ksg.q_u and z.date_2 between ksg.bp and ksg.epv
left join users s on s.id = z.user_id
left join contragents contr on contr.id = p.job_id
where h.is_delete <> 1;


/******************************************************************************/
/****                          Altering triggers                           ****/
/******************************************************************************/

ALTER TRIGGER XML_ITEMS_BIU0
AS
declare variable i integer;
declare variable y integer;
declare variable s varchar(500);
declare variable f varchar(100);
begin
  i = null;
  y = new.parent_id;
  f = '';

  if ((y is not null) and (new.condition_select_id is null)) then
  begin
      if ((coalesce(new.parent_id,0) <> 0)) then
      begin
        while ((i is null) and (y is not null))  do
        BEGIN
         i = (select x.condition_select_id from xml_items x where x.id = :y and x.val_type <> 2 order by npp);

         if (i is null) then
           i = (select x.id from xml_items x where x.id = :y and x.val_type = 2);
         y = (select parent_id from xml_items where id = :y);
        END
        new.condition_select_id = i;
      end
  end

  if (((new.val_type = 2) and (coalesce(new.val,'') <> '')) and (new.val <> coalesce(old.val,''))) then
  begin
    if (position('from ', new.val) <> 0) then
      s = substring(new.val from position('from ', new.val) + 5 for char_length(new.val) - position('from ',new.val) + 5);
    else
      s = '';

    while (s <> '') do
    begin
      while (position(' ',s) = 1) do
        s = substring(s from 2 for (char_length(s) - 1));

      f = f || '''' || substring(s from 1 for position(' ',s) - 1) || '''';

      if (position('join ', s) <> 0) then
      begin
        s = substring(s from position('join ', s) + 5 for char_length(s) - position('join ',s) + 5);
        f = f || ',';
      end
      else
        s = '';
    end

    new.fields_condition = 'select F.RDB$FIELD_ID ID,
R.RDB$RELATION_NAME RELATION_NAME,
replace(substring(R.RDB$RELATION_NAME from 1 for 3),'' '', '''') || ''.'' || F.RDB$FIELD_NAME as fn,
cast(f.rdb$description as varchar(250)) as fd
from RDB$RELATIONS R
JOIN RDB$RELATION_FIELDS F ON F.RDB$RELATION_NAME = R.RDB$RELATION_NAME
where (F.RDB$SYSTEM_FLAG = 0) AND (R.RDB$RELATION_TYPE = 0)
and (R.RDB$RELATION_NAME in (' || upper(f) || '))
and f.rdb$description <> '' ''
order by fd';
  end

  if ((new.condition_select_id is null) and (new.val_type = 2)) then
      new.condition_select_id = new.id;

  if (new.npp is null) then
    new.npp = (select max(i.npp) from xml_items i where i.parent_id = new.parent_id and i.xml_structure_id = new.xml_structure_id) + 1;

  if (new.npp is null) then
    new.npp = (select max(i.npp) from xml_items i where i.xml_structure_id = new.xml_structure_id) + 1;
--  if ((new.val_type = 1) or (new.val is null))  then new.condition_select_id = null;
  new.item_type = replace(replace(new.item_type, 'O',''),'M','');
  new.item_type = replace(replace(new.item_type, 'o',''),'m','');
end;

ALTER TRIGGER ZSD_BIU0
AS
declare variable mp integer;
declare variable q_u integer;
declare variable tar numeric(15,2);
begin
  q_u = (select q_u from zs where id = new.zs_id);

--  mp = (select mp from doctors_spec s where s.doctor_id = new.phys_id and s.code_spec = new.code_spec);
--   if (:mp is not null) then
--     new.mp = :mp;

--   new.ds_class = (SELECT first 1 MKB_CLASS_NUM FROM H_MKB WHERE CODE = NEW.DS);
  new.is_onk = (select IS_ONK from SP_CHECK_DS_AS_ONK2(new.ds, new.ds2));

  if (new.pmd_close = 1) then
    update zsd
    set pmd_close = 0
    where zs_id = new.zs_id;

  if (new.pmd_close is null) then
    new.pmd_close = 1;

  if ((select z.payment_type_id from zs z where z.id = new.zs_id) in (3,2)) then
  begin
      tar = (select coalesce(u.sumf,0) from h_usl u where u.code = new.code_usl and u.q_u containing :q_u and u.payment_type_id = (select z.payment_type_id from zs z where z.id = new.zs_id));
    
      if (tar > 0) then
      begin
        NEW.sum_uslf = :tar * new.k_uslf;
        NEW.tar_usl = :tar;
      END
  end
--  else
--    if (new.tar_usl = 0 and new.sum_uslf = 0) then new.k_uslf = 0;

  if (new.phys_id is not null and new.code_spec_v021 is null) then
    new.code_spec_v021 = (select first 1 s.code_v021 from doctors_spec s where s.doctor_id = new.phys_id);

  if (new.phys_id is not null and new.mp is null and new.code_spec_v021 is not null) then
    new.mp = (select first 1 m.mp from doctors_spec m where m.doctor_id = new.phys_id and m.code_v021 = new.code_spec_v021);

  if (new.phys_id is not null and new.code_prof is null) then
    new.code_prof = (select first 1 p.prof from doctors_prof p where p.doctor_id = new.phys_id and p.code_spec =
                     (select first 1 s.code_v021 from doctors_spec s where s.doctor_id = new.phys_id));

--  if (new.code_spec is not null) then
--    new.code_spec_v021 = (select first 1 s.code_v021 from h_v015_v021 s where cast(s.code_v015 as varchar(10)) = new.code_spec);
--  else
  if (new.code_spec_v021 is not null) then
    new.code_spec = cast((select first 1 s.code_v015 from h_v015_v021 s where s.code_v021 = new.code_spec_v021) as varchar(10));

--  if (inserting) then
--  update or insert into DOCTORS_SPEC (DOCTOR_ID, CODE_V021, MP)
--    values (new.phys_id, new.code_spec_v021, new.mp)
--    matching (DOCTOR_ID, CODE_V021, MP);
  if (coalesce(new.ds,'') = '') then
    new.ds = (select d.ds from zs_ds d where d.section = 2 and d.section_id = new.id and d.ds_type = 1);

  if ((coalesce(new.code_usl,'') = '') and (coalesce(old.code_usl,'') = '') and ((select z.payment_type_id from zs z where z.id = new.zs_id) = 1) and (q_u = 2)
       and ((select z.target from zs z where z.id = new.zs_id) in (1,26)) and (new.date_1 >= '01.01.2019')) then
  begin
    if (exists(select first 1 id from zsd d where d.zs_id = new.zs_id and d.date_1 < new.date_1 and d.code_spec_v021 = new.code_spec_v021)) then
    begin
      if (new.is_chield = 1) then
        new.code_usl = (select first 1 n.code_usl2_det from h_tarif_app_spec s join h_tarif_app_name n on n.id = s.name_id where s.code_spec_v021 = new.code_spec_v021);
      else
        new.code_usl = (select first 1 n.code_usl2 from h_tarif_app_spec s join h_tarif_app_name n on n.id = s.name_id where s.code_spec_v021 = new.code_spec_v021);
    end
    else
    begin
      if (new.is_chield = 1) then
        new.code_usl = (select first 1 n.code_usl1_det from h_tarif_app_spec s join h_tarif_app_name n on n.id = s.name_id where s.code_spec_v021 = new.code_spec_v021);
      else
        new.code_usl = (select first 1 n.code_usl1 from h_tarif_app_spec s join h_tarif_app_name n on n.id = s.name_id where s.code_spec_v021 = new.code_spec_v021);
    end
  end
end;

ALTER TRIGGER ZSD_BU0
AS
declare variable spec varchar(10);
declare variable otd_prof varchar(20);
declare variable phys integer;
declare variable child integer;
declare variable prof varchar(10);
declare variable podr varchar(12);
declare variable mp integer ;
declare variable spec_v021 integer;
begin
  update zs
  set --k_uslf = (select sum(k_uslf) from zsd where zs_id = new.zs_id),
--      ds0 = (select first 1 zz.ds from zsd zz where zz.zs_id = new.zs_id and zz.date_1 =
--              (select min(date_1) from zsd where zs_id = new.zs_id)),
      dcount = (select count(distinct z.date_1) from zsd z where z.zs_id = new.zs_id)
    where id = new.zs_id;

    if ((select min(date_1) from zsd where zs_id = new.zs_id and coalesce(zachet,0) <> 1) is not null) then
    update zs
    set date_1 = (select min(date_1) from zsd where zs_id = new.zs_id and coalesce(zachet,0) <> 1),
        date_2 = (select max(date_2) from zsd where zs_id = new.zs_id and coalesce(zachet,0) <> 1)
    where id = new.zs_id;



  if (((new.date_2 >= (select date_2 from zs where id = new.zs_id))
      and ((select count(id) from zsd where zs_id = new.zs_id and coalesce(pmd_close,0) = 1) = 0)
      and (new.code_spec_v021 in (49,76)))
     or (new.pmd_close = 1))
  then
   begin
     update zs
     set code_spec = new.code_spec,
         code_spec_v021 = new.code_spec_v021,
         otd_prof = new.otd_prof,
--         ds1 = iif(coalesce(new.ds,'') = '', ds1, new.ds),
         phys_id = new.phys_id,
         is_chield = new.is_chield,
         code_prof = new.code_prof,
         podr = new.podr,
         mp = new.mp,
         ds1 = new.ds,
         ds2 = new.ds2,
         ds_onk = new.ds_onk,
         p_cel = new.p_cel,
         c_zab = new.c_zab,
         ksg_criterion = new.ksg_criterion,
         dn = new.dn
      where id = new.zs_id;
    end
   else
   if (((new.date_2 >= (select date_2 from zs where id = new.zs_id))
      and ((select count(id) from zsd where zs_id = new.zs_id and coalesce(pmd_close,0) = 1) = 0)
      and not exists(select id from zsd where zs_id =new.zs_id and date_2 = new.date_2 and (code_spec_v021 in (49,76))) )
     or (new.pmd_close = 1))
  then
   begin
     update zs
     set code_spec = new.code_spec,
         code_spec_v021 = new.code_spec_v021,
         otd_prof = new.otd_prof,
--         ds1 = iif(coalesce(new.ds,'') = '', ds1, new.ds),
         phys_id = new.phys_id,
         is_chield = new.is_chield,
         code_prof = new.code_prof,
         podr = new.podr,
         mp = new.mp,
         ds1 = new.ds,
         ds2 = new.ds2,
         ds_onk = new.ds_onk,
         p_cel = new.p_cel,
         c_zab = new.c_zab,
         ksg_criterion = new.ksg_criterion,
         dn = new.dn
      where id = new.zs_id;
    end
   else
    begin
      if (new.pmd_close = 0 and old.pmd_close = 1) then
      begin
      for select z.code_spec, z.otd_prof, z.phys_id, z.is_chield, z.code_prof, z.podr, z.mp, z.code_spec_v021 from zsd z
          where  (z.id = (select max(id) from zsd d where d.zs_id = new.zs_id and
                         (d.date_2 = (select max(date_2) from zsd where zs_id = new.zs_id))))
          into :spec, :otd_prof, :phys, :child, :prof, :podr, :mp, :spec_v021
      do
          update zs
          set code_spec = :spec,
              code_spec_v021 = :spec_v021,
             otd_prof = :otd_prof,
--             ds1 = iif(coalesce(:ds1,'') = '', ds1, :ds1),
             phys_id = :phys,
             is_chield = :child,
             code_prof = :prof,
             podr = :podr,
             mp = :mp,
             ds1 = new.ds,
             ds2 = new.ds2,
             ds_onk = new.ds_onk,
             p_cel = new.p_cel,
             c_zab = new.c_zab,
             ksg_criterion = new.ksg_criterion
          where id = new.zs_id;
      end
     end

    if ((select z.payment_type_id from zs z where z.id = new.zs_id) in (3,2)) then
    begin
        update zs
        set sum_uslf = (select sum(sum_uslf) from zsd where zs_id = new.zs_id),
            sum_usl = coalesce((select sum(i.sum_opl) from patients_invoice i where i.zs_id = new.zs_id), 0),
            tar_usl = null
        where id = new.zs_id and payment_type_id <> 1;
    end
    else
    if (((select q_u from zs where id = new.zs_id) = 2) and (coalesce(new.code_usl,'') <> '')
       and ((select target from zs where id = new.zs_id) = 1))  then
       if (exists(select id from h_usl where code = new.code_usl and q_u containing '4' and payment_type_id = 1 and new.date_2 between datebeg and dateend)) then
        update zs z
         set z.q_u = 4
         where id = new.zs_id;

--   if (coalesce(new.code_usl,'') <> '') then
--    if ((select first 1 1 from h_tomo_code c where c.nms_code = new.code_usl) = 1) then
--      update zs z
--       set z.target = iif((select first 1 c.group_num from h_tomo_code c where c.nms_code = new.code_usl) in (1,2), 21, 22)
--       where z.id = new.zs_id and z.q_u = 2;
end;


/******************************************************************************/
/****                      Altering stored procedures                      ****/
/******************************************************************************/
ALTER PROCEDURE SP_CALC_ALL(
  ZS_ID INTEGER)
AS
declare variable TAR DM_MONEY_15_2;
declare variable DATE1 DM_DATE;
declare variable Q_U integer;
declare variable TAR_USL DM_MONEY_15_2;
declare variable TARGET integer;
declare variable IDB integer;
declare variable SUM_USLF DM_MONEY_15_2;
declare variable SEX char(1);
declare variable PTYPE integer;
declare variable AGE_Y integer;
declare variable AGE_GRP integer;
declare variable HDR_ID integer;
declare variable TROMB_CODE DM_CHAR_20;
declare variable TAR_USL_DOP DM_MONEY_15_2;
declare variable SUM_USLF_DOP DM_MONEY_15_2;
declare variable IDSP integer;
declare variable MMB DM_NUM_3_2;
declare variable OKATO DM_OKATO;
declare variable P_CEL DM_CHAR_10;
declare variable CODE_USL DM_CHAR_20;
begin
  select z.date_2, z.q_u, z.target, p.sex, z.payment_type_id, extract(year from z.date_2) - extract(year from p.dr), z.hdr_id, iif(coalesce(z.vbr,0) = 0, 1, 1.2)
  from zs z
  join patients p on p.id = z.patient_id
  where z.id = :zs_id
  into :date1, :q_u, :target, :sex, :ptype, :age_y, :hdr_id, :mmb;

  if (:date1 is null) then
    date1 = current_date;

  if (:mmb = 1) then
   mmb = iif((select first 1 z.id
           from zs z
                join kalendar k on k.k_day = z.date_1
           where z.id = :zs_id and z.target in (9,10,13,17,16) and z.date_1 = z.date_2
                 and k.day_type in (1,2)) is null, 1, 1.2);

  okato = (select first 1 c.tf_okato from contragents c where c.type_id = 1);

  if (:okato is null) then okato = '71140';

  if (:ptype in (2,3)) then exit;

  if (:target in (9,10,11,12,13,14,15,16,17)) then
  begin
   if ((select coalesce(t.days_cnt,0) from h_target t where t.id = :target) <> 0) then
   begin
    update zsd d
     set d.zachet = 1
     where d.date_1 < (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;

    update zsd d
     set d.zachet = 0
     where d.date_1 >= (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;
   end

   update zsd d
    set d.k_uslf = 0
    where (d.zachet = 1 or d.is_no_get_usl = 1 or d.zachet_stac = 1) and d.zs_id = :zs_id;
  end

  update zsd d
    set d.tar_usl = null,
        d.sum_uslf = null,
        d.comment_local = null,
        d.dop_tarif = null,
        d.dop_sum = null
    where d.zs_id = :zs_id;

  update zs z
    set z.tar_usl = null,
        z.sum_usl = null,
        z.sum_uslf = null
    where z.id = :zs_id;

  if ((select coalesce(i.is_nz,0) from invoice i join zs_hdr h on h.name = i.id where h.id = :hdr_id) = 1) then
  begin
    if (target in (9,10,11,13,14,15,16,17)) then exit;

    tar = (select first 1 s.tarif from h_tarif_nz s where s.q_u = iif(:q_u = 4,2,:q_u) and :date1 between s.bp and s.epv);

    if (q_u = 1) then
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id and d.code_usl is null;
    else
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id;

    if (q_u = 4) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = z.dcount*:tar
      where id = :zs_id;
    else
    if (q_u = 1) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = :tar
      where id = :zs_id;
    else
      update zs z
      set z.tar_usl = :tar,
          z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
      where id = :zs_id;
    exit;
  end
   /********************,    ************************/
  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 < '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin

          select first 1 h.tarif, h.tarif
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
                                 and cast(h.code_spec as varchar(10)) = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec = '16' and a.age < 18, '22', b.code_spec), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf;

          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0)
           where b.id = :idb;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end

  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 >= '01.01.2018') and (:date1 < '01.01.2020')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (:tar is null) then
          select first 1 h.tarif, h.tarif, a.idsp
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           left join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
                                 and h.idsp = a.idsp
           join h_tarif_app_spec n on n.name_id = h.name_id
                                 and n.code_spec_v021 = iif(b.code_spec_v021 = 39 and a.age < 18, 49, b.code_spec_v021)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf, :idsp;

          if (:okato = '71140') then
          update ZSD b set
           b.tar_usl = iif(:idsp = 30, 0, coalesce(:tar, 0)),
           b.sum_uslf = cast(iif(:idsp = 30, 0, coalesce(:sum_uslf, 0))*:mmb as int),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;
          else
           update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          if (:idsp <> 30) then
          begin
            tar = null;
            sum_uslf = null;
          end
        end

     if ((:idsp = 30) and (:okato = '71140')) then
       update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = cast(coalesce(:sum_uslf, 0)*:mmb as int)
           where b.id = :idb;

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce((select sum(d.tar_usl) from zsd d where d.zs_id = a.id), 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end  
  -----------------------------------------------------------------------------------------------------
  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17) and (:date1 >= '01.01.2020')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf, b.code_usl
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf, :code_usl;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (:tar is null) then
          select first 1 h.tarif, h.tarif, b.p_cel
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           left join h_tarif_app h on a.date_2 between h.bp and h.epv
                                 and (h.target = iif(b.p_cel in ('1.0','1.2','1.3','2.3','2.5','2.6','3.1') , 0, iif(b.p_cel = '1.1', 1, iif(b.p_cel = '3.0',2,-1))))
           join h_tarif_app_spec n on n.name_id = h.name_id
                                 and n.code_spec_v021 = iif(b.code_spec_v021 = 39 and a.age < 18, 49, b.code_spec_v021)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf, :p_cel;

          if (:okato = '71140') then
          update ZSD b set
           b.tar_usl = iif(:p_cel = '3.0' or ((:code_usl not starting 'A04') and (:code_usl not starting 'A08')) , 0, coalesce(:tar, 0)),
           b.sum_uslf = cast(iif(:p_cel = '3.0' or  ((:code_usl not starting 'A04') and (:code_usl not starting 'A08'))  , 0, coalesce(:sum_uslf, 0))*:mmb as int),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;
          else
           update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          if (:p_cel <> '3.0') then

          begin
            tar = null;
            sum_uslf = null;
          end
        end

     if (((:p_cel = '3.0') or  ((:code_usl not starting 'A04') and (:code_usl not starting 'A08'))  ) and (:okato = '71140')) then
     begin
       update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = cast(coalesce(:sum_uslf, 0)*:mmb as int)
           where b.id = :idb;
     end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce((select sum(d.tar_usl) from zsd d where d.zs_id = a.id), 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end  

  /********************************************/
  if (:q_u = 4) then
  begin
    tar = (select s.tarif from h_tarif_stom s where :date1 between s.bp and s.epv);

    update zsd d
    set d.tar_usl = :tar,
        d.sum_uslf = cast(d.k_uslf*:tar*:mmb as numeric(15,2))
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = :tar,
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if (:q_u = 5) then
  begin
--    if (:date1 >= '01.01.2018') then tromb_code = 'A25.30.036';
--    else tromb_code = 'A25.30.035';
    tromb_code = coalesce((select first 1 code_usl from zsd d where d.zs_id = :zs_id and coalesce(code_usl, '') <> ''),'');

    tar = (select s.tarif from h_tarif_smp s where :date1 between s.bp and s.epv);
    tar_usl = coalesce((select coalesce(u.sumf,0) from h_usl u where u.code = :tromb_code
               and u.q_u containing '5' and :date1 between u.datebeg and u.dateend),0);

    update zsd d
    set d.tar_usl = iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl),
        d.sum_uslf = d.k_uslf*iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl)
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = (select max(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if ((:q_u = 1) and ((select 1 from zs z where coalesce(z.metod_hmp,0) > 0 and id = :zs_id) = 1)) then
  begin
    select first 1 v.tarif
    from zs z
         join h_metod_hmp h on h.code = z.metod_hmp and z.date_2 between h.bp and h.epv
         join h_tarif_vmp v on v.tg = h.tg and z.date_2 between v.bp and v.epv
    where z.id = :zs_id
    into :tar;

    update zs a set
        a.tar_usl = :tar,
        a.sum_uslf = :tar,
        a.ksg = null,
        a.kslp = null
    where a.id = :zs_id;

    update zsd b set
          b.ksg = null,
          b.sum_uslf = :tar,
          b.kskp = 0,
          b.tar_usl = :tar
    where b.zs_id = :zs_id and coalesce(b.code_usl,'') = '' and b.date_1 = (select min(date_1) from zsd where zs_id = :zs_id and coalesce(code_usl,'') = '');

    exit;
  end

  /********************************************/
  if (:q_u in (1,3) and :date1 < '01.01.2018') then
    execute procedure SP_CALC_STAC(:zs_id);
  else
    if (:q_u in (1,3) and :date1 < '01.01.2020') then
      execute procedure sp_calc_stac_2018(:zs_id);
  else
    if (:q_u in (1,3) and :date1 >= '01.01.2020') then
      execute procedure sp_calc_stac_2020(:zs_id);

  /****************  ***********************************************/
  if (q_u <> 4) then
  begin
  tar = null;
  sum_uslf = null;
  for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (coalesce(:tar,0) > 0) then
          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          tar = null;
          sum_uslf = null;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);
     tar = (select sum(b.tar_usl) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_tarif,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:tar, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
   end

  /*********************-*********************************/
  if ((:q_u = 2) and (:target in (21,22))) then
  begin
   for select b.id
    from zsd b
    join zs z on z.id = b.zs_id
    where z.id = :zs_id
    into :idb
    do
    begin
      tar = (select first 1 t.tarif
             from zsd d
                  join h_tomo_code c on c.nms_code = d.code_usl
                  join h_tarif_tomo t on t.group_num = c.group_num and d.date_2 between t.bp and t.epv
             where d.id = :idb);

      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf = :tar
      where d.id = :idb;
    end

    update zs z
    set z.tar_usl = (select sum(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;

    exit;
  end
  /******************** - 9  ************************/
  if ((:q_u = 2 and :target = 9) or (q_u = 2 and :target = 16 and date1 >= '01.05.2019'))  then
  begin
    execute procedure sp_calc_app_t09(:zs_id);
    exit;
  end

  /******************** - 10,17  -  ************************/
    if (q_u = 2 and target in (10,17)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_10 d on d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and :age_y between d.y1 and d.y2
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = cast(coalesce(b.k_uslf * :tar, 0)*:mmb as int),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 13  ************************/
    if (q_u = 2 and target = 13) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                           and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_13_17 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.age_grp = a.age_grp
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = cast(coalesce(b.k_uslf * :tar, 0)*:mmb as int),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 14,15  ,  ************************/
    if (q_u = 2 and target in (14,15)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_14_15 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.cat_info = a.cat_info
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = cast(coalesce(b.k_uslf * :tar, 0)*:mmb as int),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
  /******************** - 16  ************************/
    if (q_u = 2 and target = 16 and date1 < '01.05.2019') then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join zs_hdr h on h.id = a.hdr_id
                   join patients p on p.id = a.patient_id
                   join h_tarif_disp_16 d on a.date_2 between d.bp and d.epv
                                          and d.sex = :sex
                                          and cast(d.code_usl as varchar(20)) = b.code_usl
                                          and d.age_l <= (h.y - extract(year from p.dr)) and d.age_r >= (h.y - extract(year from p.dr))
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = cast(coalesce(b.k_uslf * :tar, 0)*:mmb as int),
               b.tar_base = coalesce(:tar, 0) ,
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
end
;

ALTER PROCEDURE SP_CALC_STAC_2020(
  IDA INTEGER)
AS
declare variable KSG type of DM_CHAR_50;
declare variable DS type of DM_DS;
declare variable IDB integer;
declare variable SUM_USLF type of DM_MONEY;
declare variable KSKP numeric(6,6);
declare variable Q_U integer;
declare variable FINE_KOEF type of DM_NUM_3_2;
declare variable TARIF numeric(10,6);
declare variable IS_TRANSFER DM_INT;
declare variable CL_CNT integer;
declare variable ERR_CODE integer;
declare variable K_DOWN DM_NUM_6_2;
declare variable DS_CLASS DM_CHAR_10;
declare variable KZ DM_NUM_2_5;
declare variable KD DM_NUM_2_5;
declare variable KUS DM_NUM_2_5;
declare variable BS DM_NUM_6_2;
declare variable PROF_NUM integer;
declare variable FINE_KOEF_SET_DOCTOR DM_BOOLEAN;
declare variable IS_ROUND_JANAO integer;
declare variable OKATO DM_OKATO;
declare variable DOP_CODE DM_CHAR_40;
declare variable DATE1 DM_DATE;
declare variable DATE2 DM_DATE;
begin
  okato = (select first 1 c.tf_okato from contragents c where c.type_id = 1);

  if (okato <> '40000') then
  select c.tf_okato
   from zs_hdr h
        join zs z on z.hdr_id = h.id
        join invoice i on i.id = h.name
        join contragents c on c.id = i.contragent_id
   where z.id = :ida
   into :okato;

   -----------------------------------------------------------------------------
   --    
   for select d.id, d.date_1, d.date_2
          from zs z
               join zsd d on d.zs_id = z.id
          where z.id = :ida and (not exists(select dd.id from zsd dd where dd.zs_id = :ida
                                                                     and dd.date_1 <=d.date_1 and dd.date_2 >= d.date_2 and dd.id <> d.id) )
          order by d.ksg desc
          into :idb, :date1, :date2
          do
          begin
            update zsd d
             set d.zsd_id = :idb
             where d.id = :idb;
    
            update zsd d
             set d.zsd_id = :idb
             where d.zs_id = :ida and coalesce(d.code_usl,'') <> ''
                   and d.date_1 between :date1 and :date2
                   and not exists(select id from zsd d2 where d2.zs_id = :ida and d2.date_1 = d.date_1 and d2.id <> :idb and d2.id <> d.id);
          end
   -----------------------------------------------------------------------------
   if (:okato is  null) then
     okato = (select first 1 c.tf_okato from contragents c where c.type_id = 1);

    if (okato = '71140') then
      is_round_janao = 1;

    update zsd d
      set d.ds_class = (select MKB_CLASS from SP_GET_MKB_CLASS(D.ds))
      where d.zs_id = :ida;

    update zsd d
     set d.ksg = null, 
         d.ksg_base = null,
         d.tar_base = null,
         d.sum_base = null,
         d.kskp_base = null,
         d.sum_uslf = 0,
         d.tar_usl = 0,
         d.comment_local = null
     where d.zs_id = :ida;

    update zs z
     set z.ksg = null,
         z.tar_usl = 0,
         z.sum_usl = 0
     where z.id = :ida;

     cl_cnt = (select count(distinct b.ds_class) from ZSD b where b.ZS_ID = :ida and b.zsd_id = b.id);
     is_transfer = (select count(b.id) from ZSD b where b.ZS_ID = :ida and b.zsd_id = b.id);
     delete from kslp_koef where zs_id = :ida ;

     select a.q_u, a.date_2, coalesce(a.fine_koef_set_doctor,0)
      from zs a
      where a.id = :ida
      into :q_u, :date2, :fine_koef_set_doctor;

     for select sp.KSG, sp.ERR_CODE, b.ds, b.id, coalesce(bs.tarif * kd.kd * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0),
                k.kz, kd.kd,
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0),
                bs.tarif, k.k_down, k.prof_num, b.date_1, coalesce(b.fine_koef,1)
      from zs a
      join zsd b on a.id = b.zs_id
      join patients p on p.id = a.patient_id
      join lpu_factors lf on lf.q_u = a.q_u and a.date_2 between lf.bp and lf.epv and lf.okato is not distinct from :okato
      join h_tarif_bs bs on bs.q_u = a.q_u and a.date_2 between bs.bp and bs.epv and bs.okato is not distinct from :okato
      join h_tarif_kd kd on a.date_2 between kd.bp and kd.epv and kd.okato is not distinct from :okato
      left join sp_ksg_get_2020(b.id) sp on 1=1
      left join h_ksg k on k.ksg = sp.ksg and a.date_2 between k.bp and k.epv and k.q_u = a.q_u
      where b.zs_id = :ida and b.id = b.zsd_id
      order by b.code_usl
      into :ksg, :err_code, :ds, :idb, :tarif, :kz, :kd, :kus, :bs, :k_down, :prof_num, :date1, :fine_koef
      do
      begin
        kskp = 1;

        if (:okato = '70000') then
        begin
          select first 1 u.code_1, u.code_2
           from zsd d
                join h_usl u on u.code = d.code_usl and u.payment_type_id = 1 and :date1 between u.datebeg and u.dateend and u.q_u containing :q_u
           where d.id = :idb
          into :ksg, :dop_code;
        end

        if ((q_u in (1,3)) and (err_code is null)) then
          kskp = (select KSKP from sp_calc_stac_kskp_2020(:ida, :idb, :ksg, :cl_cnt));

        if (kskp is null) then kskp = 1;

        if (fine_koef_set_doctor = 0) then
          fine_koef = (select FINE_KOEF from sp_calc_stac_fine_2020(:ida, :idb, :ksg, :cl_cnt));

        if (is_round_janao = 1) then
          sum_uslf = cast(cast(tarif * kskp as numeric(15,4)) * fine_koef as int);
        else
          sum_uslf = cast(tarif * kskp as numeric(15,2)) * fine_koef;

        if (:ksg is not null) then
        begin
            update zsd b set
             b.ksg_base = :ksg,
             b.tar_base = iif(:is_round_janao = 1, cast(:tarif*coalesce(:kskp,1) as int), cast(:tarif*coalesce(:kskp,1) as numeric(15,2))),
             b.sum_base = :sum_uslf,
             b.kskp_base = :kskp,
             b.koef_z = :kz, 
             b.koef_d = :kd,
             b.koef_u = :kus,
             b.bs = :bs,
             b.koef_up = :k_down,
             b.reab = iif(:prof_num = 37,1,null),
             b.fine_koef = :fine_koef,
             b.dop_code_usl = iif(:okato = '70000', :dop_code, b.dop_code_usl)
             where b.id = :idb;
         end
      end 
--------------------------------------------------------------------------------
      --    6  + 
      if (q_u = 1) then
       if (exists (select 1 from zsd b where b.zs_id = :ida and ((b.ksg in ('st02.001') and b.k_uslf >= 6) or (b.ksg in ('O14.1','O34.2','O36.3','O36.4','O42.2') and b.k_uslf >= 2) ))
          and exists (select 1 from zsd b where b.zs_id = :ida and b.ksg in ('st02.003', 'st02.004'))) then
          begin
            --    ,     
            select first 1 b.ksg_base, b.ds
            from zs a
             join zsd b on a.id = b.zs_id
             where b.zs_id = :ida and b.ksg in ('st02.003', 'st02.004')
             into :ksg, :ds;
       
            update zsd d
            set d.tar_usl = d.tar_base,
                d.sum_uslf = d.sum_base,
                d.ksg = d.ksg_base,
                d.kskp = d.kskp_base
            where d.zs_id = :ida;

            --   
            select coalesce(sum(b.sum_uslf), 0) from zsd b where b.zs_id = :ida
             into :sum_uslf;
    
            update zs a set
             a.tar_usl = :tarif,
             a.sum_uslf = :sum_uslf,
             a.sum_usl = :sum_uslf,
             a.ksg = :ksg,
             a.ds1 = :ds,
             a.kslp = :kskp
             where a.id = :ida;

            exit;
          end
--------------------------------------------------------------------------------
      if ((is_transfer < 2) or (cl_cnt < 2))  then  --   
      begin
        --     2- ,   2
        --  ,    ,    
        --  ,    ()
        --     
        if ((exists(select first 1 1 from zsd d where d.zs_id = :ida and ((:q_u = 1 and d.ksg_base starting 'st37') or
                                                                                                  (:q_u = 3 and d.ksg_base starting 'ds37'))))
            or (exists(select first 1 1 from zsd d where d.zs_id = :ida and d.ksg_base in ('st36.009','st36.010','st36.011') and d.profil_k in (10,11) ))
            or (exists(select first 1 1 from zsd d where d.zs_id = :ida and d.ksg_base in ('st19.038','ds19.028')))
            or (((select count(d.id) from zsd d where d.zs_id = :ida and d.ksg_base is not null and d.profil_k = 42) >= 2) and
                 ((select count(u.id) from zsd d join onk_usl u on u.zsd_id = d.id where d.zs_id = :ida and u.usl_tip = 1) >= 2)))   then
            update zsd b set
                 b.ksg = b.ksg_base,
                 b.sum_uslf = b.sum_base,
                 b.tar_usl = b.tar_base,
                 b.kskp = b.kskp_base
            where b.zs_id = :ida and b.ksg_base is not null;
        else
        --     
        begin
          select first 1 id
           from zsd d
           where d.zs_id = :ida and d.ksg_base is not null
           order by d.koef_z desc
           into :idb;

          update zsd b set
             b.ksg = b.ksg_base,
             b.sum_uslf = b.sum_base,
             b.tar_usl = b.tar_base,
             b.kskp = b.kskp_base
           where b.id = :idb;

          update zsd b set
             b.ksg = null,
             b.sum_uslf = 0,
             b.kskp = 1,
             b.tar_usl = 0
            where b.id <> :idb and b.zs_id = :ida;
        end
      end else
      begin
        for select b.ds_class
         from zsd b
         where b.zs_id = :ida
         group by 1
         into :ds_class
         do
         begin
             select first 1 id
               from zsd d
               where d.zs_id = :ida and d.ksg_base is not null and d.ds_class = :ds_class
               order by d.koef_z desc
               into :idb;
    
             update zsd b set
                 b.ksg = b.ksg_base,
                 b.sum_uslf = b.sum_base,
                 b.tar_usl = b.tar_base,
                 b.kskp = b.kskp_base
               where b.id = :idb;

             update zsd b set
              b.ksg = null,
              b.sum_uslf = 0,
              b.kskp = 1,
              b.tar_usl = 0
              where b.id <> :idb and b.zs_id = :ida and b.ds_class = :ds_class;
         end
       end

        select first 1 b.ksg_base
        from zs a
         join zsd b on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null
         order by b.sum_base desc
         into :ksg;
   
        select coalesce(sum(b.sum_uslf), 0), coalesce(sum(b.tar_base), 0)
         from zsd b
         join zs a on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null
         into :sum_uslf, :tarif;

        update zs a set
         a.tar_usl = :tarif,
         a.sum_uslf = :sum_uslf,
         a.sum_usl = :sum_uslf,
         a.ksg = :ksg,
         a.kslp = :kskp
         where a.id = :ida;
end;

ALTER PROCEDURE SP_REESTR_EXTRACT_FOR_V2018(
  H_ID INTEGER)
AS
declare variable D_ID integer;
declare variable ZS_ID integer;
declare variable DATE1 date;
declare variable DATE2 date;
declare variable PHYS_ID integer;
declare variable CODE_SPEC integer;
declare variable HDR_ID integer;
declare variable STAGE integer;
declare variable CODE_USL DM_CHAR_20;
begin
for select h.id
    from zs_hdr h
    where h.id = :h_id or (h.parent_id = :h_id)
    into :hdr_id
    do
    begin
      update zs z
       set z.vb_p = 1
       where z.hdr_id = :hdr_id and (select count(id) from zsd d where d.zs_id = z.id and z.q_u in (1,3) and coalesce(d.code_usl,'') = '') > 1;
      /******************************************************************/
--      for select d.id, z.id, d.date_1, d.date_2
--          from zs z
--               join zsd d on d.zs_id = z.id
--          where z.hdr_id = :hdr_id and z.q_u in (1,3) and coalesce(d.code_usl,'') = ''
--          into :d_id, :zs_id, :date1, :date2
--          do
--          begin
--            update zsd d
--             set d.zsd_id = :d_id
--             where d.id = :d_id;
--    
--            update zsd d
--             set d.zsd_id = :d_id
--             where d.zs_id = :zs_id and coalesce(d.code_usl,'') <> ''
--                   and d.date_1 between :date1 and :date2
--                   and not exists(select id from zsd d2 where d2.zs_id = :zs_id and coalesce(d2.code_usl,'') = '' and d2.date_1 = d.date_1 and d2.id <> :d_id);
--          end

      for select d.id, z.id, d.date_1, d.date_2
          from zs z
               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u in (1,3) and (not exists(select dd.id from zsd dd where dd.zs_id = z.id
                                                                     and dd.date_1 <=d.date_1 and dd.date_2 >= d.date_2 and dd.id <> d.id) )
--                and d.ksg is not null
          order by d.ksg desc
          into :d_id, :zs_id, :date1, :date2
          do
          begin
            update zsd d
             set d.zsd_id = :d_id
             where d.id = :d_id;
    
            update zsd d
             set d.zsd_id = :d_id
             where d.zs_id = :zs_id and coalesce(d.code_usl,'') <> ''
                   and d.date_1 between :date1 and :date2
                   and not exists(select id from zsd d2 where d2.zs_id = :zs_id and d2.date_1 = d.date_1 and d2.id <> :d_id and d2.id <> d.id);
--                   and d.ksg is null;
          end

--        for select d.id, z.id, z.date_1, z.date_2
--          from zs z
--               join zsd d on d.zs_id = z.id
--          where z.hdr_id = :hdr_id and z.q_u in (1,3) and not exists(select dd.id from zsd dd where dd.zs_id = z.id and coalesce(dd.code_usl,'') = '')
--                and not exists(select dd.id from zsd dd where dd.zs_id = z.id and dd.ksg is not null)
--          into :d_id, :zs_id, :date1, :date2
--          do
--          begin
--            update zsd d
--             set d.zsd_id = :d_id
--             where d.id = :d_id;
--    
--            update zsd d
--             set d.zsd_id = :d_id
--             where d.zs_id = :zs_id and coalesce(d.code_usl,'') <> ''
--                   and d.date_1 between :date1 and :date2
--                   and not exists(select id from zsd d2 where d2.zs_id = :zs_id and coalesce(d2.code_usl,'') = '' and d2.date_1 = :date2)
--                   and d.ksg is null;
--          end
      /***********  ***********************************************/
      for select z.id, d.phys_id, d.code_spec_v021, z.date_1, z.date_2
          from zs z
               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u in (2,5) and z.target not in (9,10,11,12,13,14,15,16,17,21,22) and z.idsp <> 28
          group by 1,2,3,4,5
          into :zs_id, :phys_id, :code_spec, :date1, :date2
          do
          begin
            d_id = (select first 1 id from zsd d where d.zs_id = :zs_id /*and d.phys_id = :phys_id*/ and d.code_spec_v021 = :code_spec and d.date_1 between :date1 and :date2 order by d.date_1 desc);
    
            update zsd d
             set d.zsd_id = :d_id
             where d.zs_id = :zs_id and d.date_1 between :date1 and :date2 /*and d.phys_id = :phys_id*/ and d.code_spec_v021 = :code_spec;
            d_id = null;
          end

      /*********************************************************/
      /**    SL*******************************/
      for select z.id, d.phys_id, d.code_spec_v021, z.date_1, z.date_2, d.code_usl
          from zs z
               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u in (2,5) and z.target not in (9,10,11,12,13,14,15,16,17,21,22) and z.idsp = 28 and
                ((d.code_usl starting 'A04') or (d.code_usl starting  'A08'))
--          group by 1,2,3,4,5
          into :zs_id, :phys_id, :code_spec, :date1, :date2, :code_usl
          do
          begin
            update zsd d
             set d.zsd_id = d.id
             where d.zs_id = :zs_id;
            d_id = null;
          end
     /******  sl*****************/
     for select z.id, d.id, d.phys_id, d.code_spec_v021, z.date_1, z.date_2, d.code_usl
          from zs z
               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u in (2,5) and z.target not in (9,10,11,12,13,14,15,16,17,21,22) and z.idsp = 28 and
                ((d.code_usl not starting 'A04') and (d.code_usl not starting 'A08'))
--          group by 1,2,3,4,5,6,7
          into :zs_id, :d_id, :phys_id, :code_spec, :date1, :date2, :code_usl
          do
          begin
            update zsd d
             set d.zsd_id = :d_id
             where d.id = :d_id;

            update zsd d
             set d.zsd_id = :d_id
             where d.zs_id = :zs_id;
            d_id = null;
          end

      /***********  ***********************************************/
      for select z.id, d.phys_id, d.code_spec_v021, d.date_1, d.date_2
          from zs z
               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u in (4) and z.target not in (9,10,11,12,13,14,15,16,17,21,22) and z.idsp <> 28
          group by 1,2,3,4,5
          into :zs_id, :phys_id, :code_spec, :date1, :date2
          do
          begin
            d_id = (select first 1 id from zsd d where d.zs_id = :zs_id and d.phys_id = :phys_id and d.code_spec_v021 = :code_spec and d.date_1 = :date1 and d.date_2 = :date2);
    
            update zsd d
             set d.zsd_id = :d_id
             where d.zs_id = :zs_id and d.date_1 between :date1 and :date2 and d.phys_id = :phys_id and d.code_spec_v021 = :code_spec;
            d_id = null;
          end
      /***********  ***********************************************/
      for select z.id, z.disp_stage
          from zs z
--               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u in (2) and z.target in (9,10,11,12,13,14,15,16,17) --and d.code_usl in ('1','16')
          group by 1,2
          into :zs_id, :stage
          do
          begin
            d_id = (select first 1 id from zsd d where d.zs_id = :zs_id and (d.code_usl in ('1','16','66','67','68','69','B04.047.002',
                    'B04.023.002','B04.057.002','B04.018.002','B01.053.001','B04.001.002','B04.028.002','B04.029.004','B04.070.005','B04.047.002','B04.047.002.099') or :stage = 2) order by d.date_1);
            update zsd d
             set d.zsd_id = :d_id
             where d.zs_id = :zs_id;
            d_id = null;
          end
      /***********-***********************************************/
      for select z.id
          from zs z
--               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u = 2 and z.target in (21,22)
          group by 1
          into :zs_id
          do
          begin
            d_id = (select first 1 id from zsd d where d.zs_id = :zs_id order by d.date_1);
            update zsd d
             set d.zsd_id = :d_id
             where d.zs_id = :zs_id;
            d_id = null;
          end
    end
end;


/******************************************************************************/
/****                       Updating object comments                       ****/
/******************************************************************************/
DESCRIBE FIELD CODE TABLE H_SMO
' ';

DESCRIBE FIELD NAME TABLE H_SMO
' ';

DESCRIBE FIELD OKATO TABLE H_SMO
' ';

DESCRIBE FIELD OGRN TABLE H_SMO
' ';

DESCRIBE FIELD INN TABLE H_SMO
'';

DESCRIBE FIELD FULL_NAME TABLE H_SMO
' ';

DESCRIBE FIELD KPP TABLE H_SMO
'';

DESCRIBE FIELD ADDRESS_JUR TABLE H_SMO
' ';

DESCRIBE FIELD ADDRESS_FACT TABLE H_SMO
' ';

DESCRIBE FIELD PHONE TABLE H_SMO
'';

DESCRIBE FIELD E_MAIL TABLE H_SMO
' ';

DESCRIBE FIELD WWW TABLE H_SMO
'';

DESCRIBE FIELD INDEX_JUR TABLE H_SMO
' . ';

DESCRIBE FIELD INDEX_FACT TABLE H_SMO
' . ';


/******************************************************************************/
/****                      Revoking excess privileges                      ****/
/******************************************************************************/
REVOKE SELECT, INSERT, UPDATE, DELETE, REFERENCES ON V_PATIENTS FROM SYSDBA;

REVOKE SELECT, INSERT, UPDATE, DELETE, REFERENCES ON V_INVOICES FROM SYSDBA;

REVOKE SELECT, INSERT, UPDATE, DELETE, REFERENCES ON V_ONK_LEK_PR FROM SYSDBA;

REVOKE SELECT, INSERT, UPDATE, DELETE, REFERENCES ON V_ZSD FROM SYSDBA;

REVOKE SELECT, INSERT, UPDATE, DELETE, REFERENCES ON V_H_MP FROM SYSDBA;

REVOKE SELECT, INSERT, UPDATE, DELETE, REFERENCES ON V_H_SMO FROM SYSDBA;

REVOKE SELECT, INSERT, UPDATE, DELETE, REFERENCES ON V_H_PODR FROM SYSDBA;
