ALTER PROCEDURE SP_KSG_GET_2020(
  IDB INTEGER = null)
RETURNS (
  KSG DM_CHAR_20 /* COLLATE WIN1251 - default */,
  ERR_CODE INTEGER)
AS
declare variable KSG_SURG DM_CHAR_20;
declare variable IDA integer;
declare variable DS1 DM_DS;
declare variable DATE_1 DM_DATE;
declare variable DATE_2 DM_DATE;
declare variable NMS_CODE DM_NMS_CODE;
declare variable DAY_CNT DM_INT;
declare variable SEX DM_SEX;
declare variable DOP_CRITERION DM_CHAR_10;
declare variable RANGE_FR DM_CHAR_10;
declare variable DR DM_DATE;
declare variable DS2 DM_DS;
declare variable DS3 DM_DS;
declare variable Q_U DM_INT;
declare variable DS_CLASS DM_CHAR_10;
declare variable DAYS DM_INT;
declare variable RC DM_INT;
declare variable DS_TMP DM_DS;
declare variable AGE integer;
declare variable TMP_GRP_ID DM_INT;
declare variable DOP_CRITERIAN_TMP DM_CHAR_10;
declare variable KSG_TER DM_CHAR_20;
begin
     ksg = null;
     err_code = null;
     tmp_grp_id = gen_id(GEN_KSG_TMP_GROUP_ID, 1);
     ida = (select first 1 d.zs_id from zsd d where d.id = :idb);
------------------------------------------------------------------------------------------------------------------------
-- 1
     select d.date_1, d.date_2, d.ds, d.code_usl, p.sex, d.ksg_criterion, d.ksg_criterion2, p.dr, z.q_u, d.ds_class,
            d.ds2, d.ds3, z.age
     from zsd d
          join zs z on d.zs_id = z.id
          join patients p on p.id = z.patient_id
     where d.id = :idb
     into :date_1, :date_2, :ds1, :nms_code, :sex, :dop_criterion, :range_fr, :dr, :q_u, :ds_class, :ds2, :ds3, :age;

     day_cnt = (select sum(coalesce(b1.k_uslf,0)) from ZSD b1 where b1.ZS_ID = :ida and b1.ds_class = :ds_class and b1.id = b1.zsd_id);

     days = case
              when :day_cnt <= 3 then 1
              else null
            end;

     --- 
     if (:nms_code in ('A25.20.004.001', 'A11.20.019', 'A11.20.028', 'A11.20.031', 'A11.20.017.001', 'A11.20.030.001', 'A11.20.017.081','A11.20.017.082','A11.20.017.083',
                       'A11.20.507', 'A11.20.508', 'A11.20.509')) then
       nms_code = 'A11.20.017';
-----------------------------------------------------------------------------------------------------------------------
     --       ()
      select
           case
             when t1.ao_code = 'T7' then 'st29.007'
             when (t1.ao_code between 'T1' and 'T6') and (t2.ao_code between 'T1' and 'T6') and (t1.ao_code <> t2.ao_code) then 'st29.007'
             else null
           end
      from zs_ds d
      left join h_tarif_polytrauma t1 on t1.ds = d.ds and :date_2 between t1.bp and t1.epv
      left join h_tarif_polytrauma t2 on t2.ds = d.ds and :date_2 between t2.bp and t2.epv
      where d.section = 1 and d.section_id = :ida and d.ds in ('J94.2','J94.8','J94.9','J93','J93.0','J93.1','J93.8','J93.9', 'J96.0', 'N17', 'T79.4', 'R57.1', 'R57.8')
      into :ksg;

     if (ksg is not null) then
     begin
       suspend;
       exit;
     end
--------------------------------------------------------------------------------

     if (:nms_code starting 'A18') then --
     begin
       ksg = null;
       exit;
     end

--------------------------------------------------------------------------------
-- 2  3
     insert into KSG_TMP (ID, KSG, NMS_CODE, KZ, AGE_GRP, DAYS, SEX, DS, DOP_CRITERIAN, dop_criterian2, ds2,  ds3, step_num, group_code)
      select h.id, h.ksg, h.nms_code, k.kz, h.age_grp, h.days, h.sex, h.ds, h.dop_criterion, h.dop_criterion2,
             h.ds2, h.ds3, 0, :tmp_grp_id
       from ksg_grp h
       join h_ksg k on k.ksg = h.ksg and :date_2 between k.bp and k.epv
       where ((h.ds = :ds1) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds, :ds1)) = 1) or (h.ds is null) )     --a
             and ((h.ds2 = :ds2) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds2, :ds2)) = 1) or (h.ds2 is null) ) --b
             and ((h.ds3 = :ds3) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds3, :ds3)) = 1) or (h.ds3 is null) ) --c
             and (h.nms_code = :nms_code or (h.nms_code is null)) --d
             and (h.sex = :sex or (h.sex is null) ) -- f
             and (h.days is not distinct from :days or (h.days is null) ) -- g
             and (h.dop_criterion is not distinct from :dop_criterion or (h.dop_criterion is null) ) --h
             and (h.dop_criterion2 is not distinct from :range_fr or (h.dop_criterion2 is null) ) -- i
             and :date_2 between h.bp and h.epv
             and h.q_u = k.q_u and h.q_u = :q_u;

     --d
     for select d.code_usl
         from zsd d
         where d.zs_id = :ida and d.zsd_id = :idb and d.id <> :idb
         into :nms_code
         do
           insert into KSG_TMP (ID, KSG, NMS_CODE, KZ, AGE_GRP, DAYS, SEX, DS, DOP_CRITERIAN, dop_criterian2, ds2,  ds3, step_num, group_code)
              select h.id, h.ksg, h.nms_code, k.kz, h.age_grp, h.days, h.sex, h.ds, h.dop_criterion, h.dop_criterion2,
                     h.ds2, h.ds3, 0, :tmp_grp_id
               from ksg_grp h
               join h_ksg k on k.ksg = h.ksg and :date_2 between k.bp and k.epv
               where ((h.ds = :ds1) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds, :ds1)) = 1) or (h.ds is null) )     --a
                     and ((h.ds2 = :ds2) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds2, :ds2)) = 1) or (h.ds2 is null) ) --b
                     and ((h.ds3 = :ds3) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds3, :ds3)) = 1) or (h.ds3 is null) ) --c
                     and (h.nms_code = :nms_code) --d
                     and (h.sex = :sex or (h.sex is null) ) -- f
                     and (h.days is not distinct from :days or (h.days is null) ) -- g
                     and (h.dop_criterion is not distinct from :dop_criterion or (h.dop_criterion is null) ) --h
                     and (h.dop_criterion2 is not distinct from :range_fr or (h.dop_criterion2 is null) ) -- i
                     and :date_2 between h.bp and h.epv
                     and h.q_u = k.q_u and h.q_u = :q_u;
     --b
     for select d.ds
         from zs_ds d
         where d.section_id = :idb and d.section = 2 and d.ds_type = 2 and d.ds <> :ds2
         into :ds_tmp
         do
           insert into KSG_TMP (ID, KSG, NMS_CODE, KZ, AGE_GRP, DAYS, SEX, DS, DOP_CRITERIAN, dop_criterian2, ds2,  ds3, step_num, group_code)
              select h.id, h.ksg, h.nms_code, k.kz, h.age_grp, h.days, h.sex, h.ds, h.dop_criterion, h.dop_criterion2,
                     h.ds2, h.ds3, 0, :tmp_grp_id
               from ksg_grp h
               join h_ksg k on k.ksg = h.ksg and :date_2 between k.bp and k.epv
               where ((h.ds = :ds1) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds, :ds1)) = 1) or (h.ds is null) )     --a
                     and ((h.ds2 = :ds_tmp) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds2, :ds_tmp)) = 1)) --b
                     and ((h.ds3 = :ds3) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds3, :ds3)) = 1) or (h.ds3 is null) ) --c
                     and (h.nms_code = :nms_code or (h.nms_code is null)) --d
                     and (h.sex = :sex or (h.sex is null) ) -- f
                     and (h.days is not distinct from :days or (h.days is null) ) -- g
                     and (h.dop_criterion is not distinct from :dop_criterion or (h.dop_criterion is null) ) --h
                     and (h.dop_criterion2 is not distinct from :range_fr or (h.dop_criterion2 is null) ) -- i
                     and :date_2 between h.bp and h.epv
                     and h.q_u = k.q_u and h.q_u = :q_u;

     --c
     for select d.ds
         from zs_ds d
         where d.section_id = :idb and d.section = 2 and d.ds_type = 3 and d.ds <> :ds3
         into :ds_tmp
         do
           insert into KSG_TMP (ID, KSG, NMS_CODE, KZ, AGE_GRP, DAYS, SEX, DS, DOP_CRITERIAN, dop_criterian2, ds2,  ds3, step_num, group_code)
              select h.id, h.ksg, h.nms_code, k.kz, h.age_grp, h.days, h.sex, h.ds, h.dop_criterion, h.dop_criterion2,
                     h.ds2, h.ds3, 0, :tmp_grp_id
               from ksg_grp h
               join h_ksg k on k.ksg = h.ksg and :date_2 between k.bp and k.epv
               where ((h.ds = :ds1) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds, :ds1)) = 1) or (h.ds is null) )     --a
                     and ((h.ds2 = :ds2) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds2, :ds2)) = 1) or (h.ds2 is null) ) --b
                     and ((h.ds3 = :ds_tmp) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds3, :ds_tmp)) = 1)) --c
                     and (h.nms_code = :nms_code or (h.nms_code is null)) --d
                     and (h.sex = :sex or (h.sex is null) ) -- f
                     and (h.days is not distinct from :days or (h.days is null) ) -- g
                     and (h.dop_criterion is not distinct from :dop_criterion or (h.dop_criterion is null) ) --h
                     and (h.dop_criterion2 is not distinct from :range_fr or (h.dop_criterion2 is null) ) -- i
                     and :date_2 between h.bp and h.epv
                     and h.q_u = k.q_u and h.q_u = :q_u;

     --h
     for select c.code
         from zs_crit c
         where c.zsd_id = :idb and c.code <> :dop_criterion and c.code not starting 'fr'
         into :dop_criterian_tmp
         do
           insert into KSG_TMP (ID, KSG, NMS_CODE, KZ, AGE_GRP, DAYS, SEX, DS, DOP_CRITERIAN, dop_criterian2, ds2,  ds3, step_num, group_code)
              select h.id, h.ksg, h.nms_code, k.kz, h.age_grp, h.days, h.sex, h.ds, h.dop_criterion, h.dop_criterion2,
                     h.ds2, h.ds3, 0, :tmp_grp_id
               from ksg_grp h
               join h_ksg k on k.ksg = h.ksg and :date_2 between k.bp and k.epv
               where ((h.ds = :ds1) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds, :ds1)) = 1) or (h.ds is null) )     --a
                     and ((h.ds2 = :ds2) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds2, :ds2)) = 1) or (h.ds2 is null) ) --b
                     and ((h.ds3 = :ds3) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds3, :ds3)) = 1) or (h.ds3 is null) ) --c
                     and (h.nms_code = :nms_code or (h.nms_code is null)) --d
                     and (h.sex = :sex or (h.sex is null) ) -- f
                     and (h.days is not distinct from :days or (h.days is null) ) -- g
                     and (h.dop_criterion is not distinct from :dop_criterian_tmp) --h
                     and (h.dop_criterion2 is not distinct from :range_fr or (h.dop_criterion2 is null) ) -- i
                     and :date_2 between h.bp and h.epv
                     and h.q_u = k.q_u and h.q_u = :q_u;

     rc = (select count(*) from ksg_tmp);

     if (rc > 1) then  --   
       if (exists(select first 1 t.id from ksg_tmp t where t.age_grp is not null)) then
       begin
--         age = (extract(year from :date_1) - extract(year from :dr));

         if ((:date_1 - :dr) <= 28) then
           delete from ksg_tmp t
            where t.age_grp not in (1,4,5) and t.age_grp is not null and t.group_code = :tmp_grp_id;
         else
         if ((:date_1 - :dr) between 29 and 90) then
           delete from ksg_tmp t
            where t.age_grp not in (2,4,5) and t.age_grp is not null and t.group_code = :tmp_grp_id;
         else
         if (((:date_1 - :dr) > 91) and (:age < 1)) then
           delete from ksg_tmp t
            where t.age_grp not in (3,4,5) and t.age_grp is not null and t.group_code = :tmp_grp_id;
         else
         if ((:age < 2) and (:age >=1)) then
           delete from ksg_tmp t
            where t.age_grp not in (4,5) and t.age_grp is not null and t.group_code = :tmp_grp_id;
         else
         if ((:age >= 2) and (:age < 18)) then
           delete from ksg_tmp t
            where t.age_grp not in (5) and t.age_grp is not null and t.group_code = :tmp_grp_id;
         else
         if (:age >= 18) then
           delete from ksg_tmp t
            where t.age_grp not in (6) and t.age_grp is not null and t.group_code = :tmp_grp_id;
       end
--------------------------------------------------------------------------------
-- 4
     update ksg_tmp t
      set t.step_num = 1
      where ((t.dop_criterian in ('rb2','rb3','rb4','rb5','rb6','rbs'))
            or (t.days = 1)
            or ((t.ds in ('L08.0','L26','L27.0','L27.2')) and t.age_grp = 1))
            and t.group_code = :tmp_grp_id;

     for select t.ksg
                from ksg_tmp t
                     join ksg_tmp t2 on t2.id <> t.id
                where t.group_code = :tmp_grp_id and exists(select ch.id from ksg_dont_choice ch where ch.ksg_ter = t.nms_code and ch.ksg_surg = t2.nms_code)
         into :ksg_ter
         do
           update ksg_tmp kt
            set kt.step_num = -1
            where kt.ksg = :ksg_ter;
--------------------------------------------------------------------------------
-- 5
     ksg = (select first 1 t.ksg from KSG_TMP t where t.group_code=:tmp_grp_id
                 order by t.step_num desc, t.kz desc);

     if (ksg is null and err_code is null and ((select first 1 id from h_tarif_dializ d where :date_2 between d.bp and d.epv and d.code_usl = :nms_code) is null)) then
      err_code = 1;

     delete from KSG_TMP t
      where t.group_code = :tmp_grp_id;

     if (err_code is not null) then
         update zsd d
         set d.comment_local = (select name from h_errors where ID = :err_code)
         where d.id = :idb;

     suspend;
end;
