ALTER PROCEDURE SP_CALC_ALL(
  ZS_ID INTEGER)
AS
BEGIN
  EXIT;
END;

DROP VIEW V_ZS;


/******************************************************************************/
/****                           Altering tables                            ****/
/******************************************************************************/
ALTER TABLE ZS
  ADD SET_USL_AUTO DM_BOOLEAN;

ALTER TABLE ZS
  ADD OS_SLUCH DM_INT;


/******************************************************************************/
/****                            Creating views                            ****/
/******************************************************************************/
CREATE VIEW V_ZS (
    ID,
    Q_U,
    MP,
    ORDER_V,
    CODE_SPEC,
    CODE_PROF,
    OTD_PROF,
    IS_CHIELD,
    N_HIST,
    DATE_1,
    DATE_2,
    DS0,
    DS1,
    DS2,
    TAR_USL,
    K_USLF,
    K_USL,
    IDSP,
    TARGET,
    RESULT,
    PATIENT_ID,
    FAM,
    IM,
    OT,
    Q_U_NAME,
    TARGET_NAME,
    SUM_USLF,
    HDR_ID,
    DIRECTION_NUM,
    DIRECTION_DATE,
    DH_INFO,
    MES_CODE,
    SMP_BRIG,
    DS3,
    DCOUNT,
    UID,
    PHYS_ID,
    CATEGORY,
    DISP_STAGE,
    DISP_WORK_STATE,
    DISP_RESULT,
    DISP_H_GROUP,
    OUTCOME,
    KSG,
    CAT_INFO,
    IDSP_NAME,
    MP_NAME,
    ORDER_V_NAME,
    DH_INFO_NAME,
    CODE_SPEC_NAME,
    CODE_PROF_NAME,
    IS_CHIELD_NAME,
    SMP_BRIG_NAME,
    RESULT_NAME,
    OUTCOME_NAME,
    FOR_POM,
    VID_HMP,
    METOD_HMP,
    AGE_GRP,
    CHIELD_WITH_ROP,
    FOR_POM_NAME,
    REGISTRY_ID,
    PAYMENT_TYPE_ID,
    PAYMENT_NAME,
    REGISTRY_NAME,
    SUM_USL,
    DOCTOR_FIO,
    DOCTOR_COD,
    NUM_SP,
    IDCASE,
    Q_U_2016,
    HAS_ERRORS,
    CODE_MES1,
    COMENTSL,
    SMO,
    OKATO_SMO,
    OKATO_G,
    OKATO_P,
    SUM_OPL,
    N_ZAP,
    ZSP_VPOLIS,
    ZSP_SPOLIS,
    ZSP_NPOLIS,
    ZSP_POLIS_BP,
    ZSP_POLIS_EP,
    ZSP_SMO_OGRN,
    ZSP_SMO_CODE,
    ZSP_ENP,
    ZSP_SEND_DATE,
    ZSP_RESP_DATE,
    AGE,
    DR,
    DOC_SER,
    DOC_NUM,
    SEX,
    PODR,
    KSLP,
    REG_DATE,
    AGE_NAME,
    M,
    Y,
    CH_NUM,
    INV_STATE,
    KSG_NUM,
    KSG_PROF_NUM,
    NPR_MO,
    PER,
    VBR,
    TAL_D,
    TAL_P,
    INV,
    RSLT_D,
    NAZR,
    NAZ_SP,
    NAZ_V,
    NAZ_PMP,
    NAZ_PK,
    IDSP_NOT_AUTO,
    AGE_GRP_NOT_AUTO,
    USER_ID,
    USER_FIO,
    MSE,
    BARTHEL_IDX,
    CODE_SPEC_V021,
    ID_PAC,
    DISP,
    P_CEL,
    C_ZAB,
    KSG_CRITERION,
    PR_NOV,
    MCOD,
    PR_DATE_1,
    PR_DATE_2,
    DN,
    JOB_NAME,
    LPU,
    SET_USL_AUTO)
AS
select z.id,
       z.q_u,
       z.mp,
       z.order_v,
       z.code_spec,
       z.code_prof,
       z.otd_prof,
       z.is_chield,
       z.n_hist,
       z.date_1,
       z.date_2,
       z.ds0,
       z.ds1,
       z.ds2,
       z.tar_usl,
       z.k_uslf,
       z.k_usl,
       z.idsp,
       z.target,
       z.result,  
       z.patient_id,
       p.fam,
       p.im,
       p.ot,
       q_u.name as q_u_name,
       t.name as target_name,
       z.sum_uslf,
       z.hdr_id,
       z.direction_num,
       z.direction_date,
       z.dh_info as dh_info,
       z.mes_code,
       z.smp_brig,
       z.ds3,
       Z.DCOUNT,
       z.uid,
       z.phys_id,
       z.category,
       z.disp_stage,
       z.disp_work_state,
       z.disp_result,
       z.disp_h_group,
       z.outcome,
       z.ksg,
       z.cat_info,
       i.name as idsp_name,
       m.name as mp_name,
       o.name as order_v_name,
       dh.name as dh_info_name,
       iif(z.date_2 >= '01.05.2018', (select name from h_spec_v021 where code = z.code_spec_v021), (select name from h_spec_v015 where code = z.code_spec)) as code_spec_name,
       co.name as code_prof_name,
       iif(z.is_chield = 1, ' ', '') as is_chield_name,
       sb.name as smp_brig_name,
       r.name as result_name,
       oc.name as outcome_name,
       z.for_pom,
       z.vid_hmp,
       z.metod_hmp,
       z.age_grp,
       z.chield_with_rop,
       fp.name,
       z.registry_id,
       Z.payment_type_id,
       pt.name,
       reg.name,
       z.sum_usl,
       df.fio,
       DF.pcod,
       p.num_sp,  --iif(z.payment_type_id <> 2, p.num_sp, (select ins.ser || ' ' || ins.num from patients_insurance ins where ins.patients_id = p.id and z.date_1 between ins.db and ins.de)),
       z.id_case,
       z.q_u_2016,
       0,--(select first 1 1 from error_list_local err where err.reestr_hdr_id = z.hdr_id and err.uid = z.uid),
       z.mes_code,
       z.comentsl,
       p.smo,
       p.okato_smo,
       p.okato_l,
       p.okato_r,
       z.sum_usl, --(select sum(pi.sum_opl) from patients_invoice pi where pi.zs_id = z.id),
       z.n_zap n_zap,
       zpr.vpolis,
       zpr.spolis,
       zpr.npolis,
       zpr.polis_bp,
       zpr.polis_ep,
       zpr.smo_ogrn,
       zpr.smo_code,
       zpr.enp,
       zp.send_date,
       zpr.resp_date,
       z.age,
       p.dr,
       p.doc_ser,
       p.doc_num,
       p.sex,
       z.podr,
       z.kslp,
       reg.reg_date,
       cast(floor(z.age) as varchar(3)) || '  ' ||
            cast(iif(extract(day from z.date_1) < extract(day from p.dr),
                 iif(extract(month from z.date_1) > extract(month from p.dr), extract(month from z.date_1) - extract(month from p.dr),
                             iif(extract(month from z.date_1) < extract(month from p.dr), 12 - extract(month from p.dr) + extract(month from z.date_1) - 1,
                                 11)),
                 iif(extract(month from z.date_1) > extract(month from p.dr), extract(month from z.date_1) - extract(month from p.dr),
                             iif(extract(month from z.date_1) < extract(month from p.dr), 12 - extract(month from p.dr) + extract(month from z.date_1),
                                   0))) as varchar(2)) || ' ',
       h.m,
       h.y, 
       h.full_name,
       coalesce(inv.status_id,0),
       ksg.ksg_name,
       ksg.prof_name,
       z.npr_mo,
       z.per,
       z.vbr,
       z.tal_d,
       z.tal_p,
       z.inv,
       Z.rslt_d,
       z.nazr,
       z.naz_sp,
       z.naz_v,
       z.naz_pmp,
       z.naz_pk,
       z.idsp_not_auto,
       Z.age_grp_not_auto,
       z.user_id,
       s.fio,
       z.mse,
       z.barthel_idx ,
       z.code_spec_v021,
       z.id_pac,
       Z.disp,
       z.p_cel,
       z.c_zab,
       z.ksg_criterion,
       z.pr_nov,
       z.mcod, 
       z.pr_date_1,
       z.pr_date_2,
       z.dn,
       contr.short_name,
       inv.lpu,
       z.set_usl_auto
from zs z
join patients p on p.id = z.patient_id
join zs_hdr h on h.id = z.hdr_id
left join invoice inv on inv.id = h.name
left join h_q_u q_u on q_u.id = z.q_u
left join h_target t on t.id = z.target
left join h_idsp i on i.id = z.idsp
left join h_mp m on m.code = z.mp
left join h_order_v o on o.id = z.order_v
left join h_dh_info dh on dh.id = z.dh_info
left join h_spec_v015 cs on cs.code = z.code_spec
left join h_code_otd co on co.code = z.code_prof
left join h_smp_brig sb on sb.id = z.smp_brig
left join h_result r on r.code = z.result
left join h_outcome oc on oc.code = z.outcome
left join h_for_pom fp on fp.code = z.for_pom
left join h_payment_type pt on pt.id = z.payment_type_id
left join v_registry reg on reg.id = z.registry_id
left join doctors_fio df on df.id = z.phys_id
left join zsp zp on zp.zs_id = z.id
left join zsp_resp zpr on zpr.zsp_id = zp.id
left join h_ksg ksg on (cast(ksg.ksg as varchar(50))) = z.ksg and z.q_u = ksg.q_u and z.date_2 between ksg.bp and ksg.epv
left join users s on s.id = z.user_id
left join contragents contr on contr.id = p.job_id
where h.is_delete <> 1;


/******************************************************************************/
/****                          Altering triggers                           ****/
/******************************************************************************/

ALTER TRIGGER ZS_BIU0
AS
declare variable hdr integer;
declare variable dr date;
begin
  select p.dr from patients p where p.id = new.patient_id
  into :dr;
  new.age = ((new.date_1 - :dr)/365.25);

  if (new.n_zap is null) then
    new.n_zap = new.id;

  if (new.id_case is null) then
    new.id_case = new.id;

  if (new.id_pac is null) then
    new.id_pac = new.id;

  if (new.payment_type_id is null) then
    new.payment_type_id = 1;

  if (bin_and(new.extra_info, 1) = 1) then
    new.chield_with_rop = 1;

  if (new.date_1 is null) then
  begin
    new.date_1 = current_date;
    new.date_2 = current_date;
  end

  if (new.hdr_id is null) then
  begin
    hdr = (select id from zs_hdr h where h.y = extract(year from new.date_2) and h.m = extract(month from new.date_2)
         and h.name = h.m and is_delete = 0);

    if (hdr is not null) then
      new.hdr_id = hdr;
    else
    begin
      execute procedure ADD_PERIOD_HDR(extract(month from new.date_2), extract(year from new.date_2),
                                       (select M2 from SP_MONTH_TO_STRING(extract(month from new.date_2))),
                                       cast(extract(year from new.date_2) as varchar(4))) ;
      hdr = (select id from zs_hdr h where h.y = extract(year from new.date_2) and h.m = extract(month from new.date_2));
      new.hdr_id = :hdr;
    end
  end

  if ((new.n_hist is null) or (new.n_hist = '')) then
  begin
--    new.n_hist_num = (select max(coalesce(n_hist_num,0)) from zs z where z.patient_id = new.patient_id) + 1;
    new.n_hist = cast(gen_id(gen_nhist, 1) as varchar(50));
  end

  if (new.is_chield is null) then
    new.is_chield = 0;

  if ((new.q_u_2016 is not null) and (new.q_u is null)) then
  begin
      if (new.q_u_2016 = 4 and extract(year from new.date_2) > 2015 ) then
        new.q_u = 5;
      else
      if (new.q_u_2016 = 5 and extract(year from new.date_2) > 2015 ) then
        new.q_u = 4;
      else
      if (new.q_u_2016 = 2 and extract(year from new.date_2) > 2015 ) then
        new.q_u = 3;
      else
      if (new.q_u_2016 = 3 and extract(year from new.date_2) > 2015 ) then
      begin
       if (new.idsp = 9) then
       begin
        new.q_u = 4;
        new.q_u_2016 = 5;
       end
       else
        new.q_u = 2;
      end
      else new.q_u = 1;
  end
  else
  if ((new.q_u is not null)) then
  begin
      if (new.q_u = 4 and extract(year from new.date_2) > 2015 ) then
        new.q_u_2016 = 5;
      else
      if (new.q_u = 5 and extract(year from new.date_2) > 2015 ) then
        new.q_u_2016 = 4;
      else
      if (new.q_u = 2 and extract(year from new.date_2) > 2015 ) then
        new.q_u_2016 = 3;
      else
      if (new.q_u = 3 and extract(year from new.date_2) > 2015 ) then
        new.q_u_2016 = 2;
      else new.q_u_2016 = 1;
  end

  if (new.target in (9,10,11,12,13,14,15,16,17)) then
  begin
    if (new.disp_h_group is null) then
    begin
      new.disp_h_group = case
                           when (new.rslt_d in (1)) then '1'
                           when (new.rslt_d in (2)) then '2'
                           when (new.rslt_d in (3)) then '3'
                           when (new.rslt_d in (31)) then '3'
                           when (new.rslt_d in (32)) then '3'
                           when (new.rslt_d in (4)) then '4'
                           when (new.rslt_d in (5)) then '5'
                           when (new.rslt_d in (11)) then '1'
                           when (new.rslt_d in (12)) then '2'
                           when (new.rslt_d in (14)) then '3'
                           when (new.rslt_d in (15)) then '3'
                         end;
    end
  end
  
  if (not inserting) then
  begin
  if (new.q_u = 1) then
    new.k_uslf = iif(new.date_1 = new.date_2, 1, new.date_2 - new.date_1);
    else
    if (new.q_u = 3) then
    begin
      if (coalesce(new.ksg,'') = '') then
        new.k_uslf = (select sum(d.k_uslf) from zsd d where d.zs_id = new.id and coalesce(d.ksg,'') = '');
      else
        new.k_uslf = (select max(d.k_uslf) from zsd d where d.zs_id = new.id and coalesce(d.ksg,'') <> '');
--        iif(new.date_1 = new.date_2, 1, new.date_2 - new.date_1 + 1);
    end
      else
      if (new.q_u in (4,5)) then
        new.k_uslf = (select sum(d.k_uslf) from zsd d where d.zs_id = new.id);
        else
        if (new.q_u = 2 and new.target in (9,10,13,16,17)) then
          new.k_uslf = (select sum(d.k_uslf)
                        from zsd d left join h_usl u on u.code = d.code_usl
                                                        and u.q_u containing new.q_u
                                                        and new.date_1 between u.datebeg and u.dateend
                                                        and u.payment_type_id = new.payment_type_id
                        where d.zs_id = new.id and coalesce(u.is_usl,0) <> 1);
        else
        if (new.q_u = 2 and new.target not in (9,10,13,16,17)) then
          new.k_uslf = (select sum(d.k_uslf)
                        from zsd d
                        where d.zs_id = new.id);
  end

  if (coalesce(new.idsp_not_auto,0) = 0) then
  new.idsp = case
             when (new.q_u = 1) then 33
             when (new.q_u = 3) then 33
             when (new.q_u = 2) and exists(select first 1 id from zsd d where d.zs_id = new.id and
                                                  ((coalesce(d.code_usl,'') starting 'A06')
                                                  or (coalesce(d.code_usl,'') starting 'A05')
                                                  or (coalesce(d.code_usl,'') starting 'A04')
                                                  or (coalesce(d.code_usl,'') starting 'A03')
                                                  or (coalesce(d.code_usl,'') starting 'A08')
                                                  or (coalesce(d.code_usl,'') starting 'A27')
                                                  or (coalesce(d.code_usl,'') starting 'A07'))) then 28
             when (new.q_u = 5) and exists(select first 1 id from zsd d where d.zs_id = new.id and coalesce(d.code_usl,'') starting '') then 28
             when (new.q_u = 2) and (new.target < 9) and new.k_uslf = 1 then 29
             when (new.q_u = 2) and (new.target < 9) and (new.for_pom = 3) and new.k_uslf > 1 then 30
             when (new.q_u = 2) and (new.target in (9,10,17,13,14,15,16)) then 30
             when (new.q_u = 2) and (new.target in (21,22,23)) then 28
             when (new.q_u = 5) then 36
             when (new.q_u = 4) and (new.target < 9) and new.dcount = 1 then 29
             when (new.q_u = 4) and (new.target < 9) and (new.for_pom = 3) and new.dcount > 1 then 30
             end;

  dr = (select dr from patients where id = new.patient_id);

  if ((coalesce(new.age_grp_not_auto,0) = 0) and (new.target = 13)) then
    new.age_grp = (select AGE_GRP from SP_CALC_AGE_GRP(:dr, new.date_1));
             
  if (new.chield_with_rop = 1) then
    new.extra_info = 1;
  if (new.extra_info = 1) then
    new.chield_with_rop = 1;

  new.usl_ok = case
               when (new.q_u = 1) then 1
               when (new.q_u = 2) then 3
               when (new.q_u = 3) then 2
               when (new.q_u = 5) then 4
               when (new.q_u = 4) then 3
               end;
end;


/******************************************************************************/
/****                      Altering stored procedures                      ****/
/******************************************************************************/
ALTER PROCEDURE SP_CALC_ALL(
  ZS_ID INTEGER)
AS
declare variable TAR DM_MONEY_15_2;
declare variable DATE1 DM_DATE;
declare variable Q_U integer;
declare variable TAR_USL DM_MONEY_15_2;
declare variable TARGET integer;
declare variable IDB integer;
declare variable SUM_USLF DM_MONEY_15_2;
declare variable SEX char(1);
declare variable PTYPE integer;
declare variable AGE_Y integer;
declare variable AGE_GRP integer;
declare variable HDR_ID integer;
declare variable TROMB_CODE DM_CHAR_20;
declare variable TAR_USL_DOP DM_MONEY_15_2;
declare variable SUM_USLF_DOP DM_MONEY_15_2;
declare variable IDSP integer;
declare variable MMB DM_NUM_3_2;
declare variable OKATO DM_OKATO;
declare variable P_CEL DM_CHAR_10;
declare variable CODE_USL DM_CHAR_20;
begin
  select z.date_2, z.q_u, z.target, p.sex, z.payment_type_id, extract(year from z.date_2) - extract(year from p.dr), z.hdr_id, iif(coalesce(z.vbr,0) = 0, 1, 1.2),
         z.idsp
  from zs z
  join patients p on p.id = z.patient_id
  where z.id = :zs_id
  into :date1, :q_u, :target, :sex, :ptype, :age_y, :hdr_id, :mmb, :idsp;

  if (:date1 is null) then
    date1 = current_date;

  update zs z
    set z.os_sluch = null
    where z.id = :zs_id;

  if (:mmb = 1) then
  begin
   mmb = iif((select first 1 z.id
           from zs z
                join kalendar k on k.k_day = z.date_1
           where z.id = :zs_id and z.target in (9,10,13,17,16) and z.date_1 = z.date_2
                 and k.day_type in (1,2)) is null, 1, 1.2);
   if (:mmb > 1) then
    update zs z
    set z.os_sluch = 6
    where z.id = :zs_id;
  end

  okato = (select first 1 c.tf_okato from contragents c where c.type_id = 1);

  if (:okato is null) then okato = '71140';

  if (:ptype in (2,3)) then exit;

  if (:target in (9,10,11,12,13,14,15,16,17)) then
  begin
   if ((select coalesce(t.days_cnt,0) from h_target t where t.id = :target) <> 0) then
   begin
    update zsd d
     set d.zachet = 1
     where d.date_1 < (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;

    update zsd d
     set d.zachet = 0
     where d.date_1 >= (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;
   end

   update zsd d
    set d.k_uslf = 0
    where (d.zachet = 1 or d.is_no_get_usl = 1 or d.zachet_stac = 1) and d.zs_id = :zs_id;
  end

  update zsd d
    set d.tar_usl = null,
        d.sum_uslf = null,
        d.comment_local = null,
        d.dop_tarif = null,
        d.dop_sum = null
    where d.zs_id = :zs_id;

  update zs z
    set z.tar_usl = null,
        z.sum_usl = null,
        z.sum_uslf = null
    where z.id = :zs_id;

  if ((select coalesce(i.is_nz,0) from invoice i join zs_hdr h on h.name = i.id where h.id = :hdr_id) = 1) then
  begin
    if (target in (9,10,11,13,14,15,16,17)) then exit;

    tar = (select first 1 s.tarif from h_tarif_nz s where s.q_u = iif(:q_u = 4,2,:q_u) and :date1 between s.bp and s.epv);

    if (q_u = 1) then
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id and d.code_usl is null;
    else
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id;

    if (q_u = 4) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = z.dcount*:tar
      where id = :zs_id;
    else
    if (q_u = 1) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = :tar
      where id = :zs_id;
    else
      update zs z
      set z.tar_usl = :tar,
          z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
      where id = :zs_id;
    exit;
  end
   /********************,    ************************/
  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 < '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin

          select first 1 h.tarif, h.tarif
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
                                 and cast(h.code_spec as varchar(10)) = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec = '16' and a.age < 18, '22', b.code_spec), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf;

          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0)
           where b.id = :idb;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end

  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 >= '01.01.2018') and (:date1 < '01.01.2020')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (:tar is null) then
          select first 1 h.tarif, h.tarif, a.idsp
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           left join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
                                 and h.idsp = a.idsp
           join h_tarif_app_spec n on n.name_id = h.name_id
                                 and n.code_spec_v021 = iif(b.code_spec_v021 = 39 and a.age < 18, 49, b.code_spec_v021)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf, :idsp;

          if (:okato = '71140') then
          update ZSD b set
           b.tar_usl = iif(:idsp = 30, 0, coalesce(:tar, 0)),
           b.sum_uslf = cast(iif(:idsp = 30, 0, coalesce(:sum_uslf, 0))*:mmb as int),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;
          else
           update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          if (:idsp <> 30) then
          begin
            tar = null;
            sum_uslf = null;
          end
        end

     if ((:idsp = 30) and (:okato = '71140')) then
       update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = cast(coalesce(:sum_uslf, 0)*:mmb as int)
           where b.id = :idb;

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce((select sum(d.tar_usl) from zsd d where d.zs_id = a.id), 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end  
  -----------------------------------------------------------------------------------------------------
  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17) and (:date1 >= '01.01.2020')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf, b.code_usl
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf, :code_usl;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (:tar is null) then
          select first 1 h.tarif, h.tarif, b.p_cel
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           left join h_tarif_app h on a.date_2 between h.bp and h.epv
                                 and (h.target = iif(b.p_cel in ('1.0','1.2','1.3','2.3','2.5','2.6','3.1') , 0, iif(b.p_cel = '1.1', 1, iif(b.p_cel = '3.0',2,-1))))
           join h_tarif_app_spec n on n.name_id = h.name_id
                                 and n.code_spec_v021 = iif(b.code_spec_v021 = 39 and a.age < 18, 49, b.code_spec_v021)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf, :p_cel;

          if (:okato = '71140') then
          update ZSD b set
           b.tar_usl = iif((:p_cel = '3.0' and (:idsp<>28)) or ((:idsp = 28) and (:code_usl not starting 'A04') and (:code_usl not starting 'A08')) , 0, coalesce(:tar, 0)),
           b.sum_uslf = cast(iif((:p_cel = '3.0' and (:idsp<>28)) or ((:idsp = 28) and (:code_usl not starting 'A04') and (:code_usl not starting 'A08')), 0, coalesce(:sum_uslf, 0))*:mmb as int),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;
          else
           update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          if (:p_cel <> '3.0') then

          begin
            tar = null;
            sum_uslf = null;
          end
        end

     if (((:p_cel = '3.0' and (:idsp<>28)) or ((:idsp = 28) and (:code_usl not starting 'A04') and (:code_usl not starting 'A08'))) and (:okato = '71140')) then
     begin
       update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = cast(coalesce(:sum_uslf, 0)*:mmb as int)
           where b.id = :idb;
     end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce((select sum(d.tar_usl) from zsd d where d.zs_id = a.id), 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;

     if (coalesce((select z.set_usl_auto from zs z where z.id = :zs_id),0) = 1) then
       execute procedure SP_SET_USL_ZSD(:ZS_ID);
    exit;
  end  

  /********************************************/
  if (:q_u = 4) then
  begin
    tar = (select s.tarif from h_tarif_stom s where :date1 between s.bp and s.epv);

    update zsd d
    set d.tar_usl = :tar,
        d.sum_uslf = cast(d.k_uslf*:tar*:mmb as numeric(15,2))
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = :tar,
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if (:q_u = 5) then
  begin
--    if (:date1 >= '01.01.2018') then tromb_code = 'A25.30.036';
--    else tromb_code = 'A25.30.035';
    tromb_code = coalesce((select first 1 code_usl from zsd d where d.zs_id = :zs_id and coalesce(code_usl, '') <> ''),'');

    tar = (select s.tarif from h_tarif_smp s where :date1 between s.bp and s.epv);
    tar_usl = coalesce((select coalesce(u.sumf,0) from h_usl u where u.code = :tromb_code
               and u.q_u containing '5' and :date1 between u.datebeg and u.dateend),0);

    update zsd d
    set d.tar_usl = iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl),
        d.sum_uslf = d.k_uslf*iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl)
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = (select max(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if ((:q_u = 1) and ((select 1 from zs z where coalesce(z.metod_hmp,0) > 0 and id = :zs_id) = 1)) then
  begin
    select first 1 v.tarif
    from zs z
         join h_metod_hmp h on h.code = z.metod_hmp and z.date_2 between h.bp and h.epv
         join h_tarif_vmp v on v.tg = h.tg and z.date_2 between v.bp and v.epv
    where z.id = :zs_id
    into :tar;

    update zs a set
        a.tar_usl = :tar,
        a.sum_uslf = :tar,
        a.ksg = null,
        a.kslp = null
    where a.id = :zs_id;

    update zsd b set
          b.ksg = null,
          b.sum_uslf = :tar,
          b.kskp = 0,
          b.tar_usl = :tar
    where b.zs_id = :zs_id and coalesce(b.code_usl,'') = '' and b.date_1 = (select min(date_1) from zsd where zs_id = :zs_id and coalesce(code_usl,'') = '');

    exit;
  end

  /********************************************/
  if (:q_u in (1,3) and :date1 < '01.01.2018') then
    execute procedure SP_CALC_STAC(:zs_id);
  else
    if (:q_u in (1,3) and :date1 < '01.01.2020') then
      execute procedure sp_calc_stac_2018(:zs_id);
  else
    if (:q_u in (1,3) and :date1 >= '01.01.2020') then
      execute procedure sp_calc_stac_2020(:zs_id);

  /****************  ***********************************************/
  if (q_u <> 4) then
  begin
  tar = null;
  sum_uslf = null;
  for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (coalesce(:tar,0) > 0) then
          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          tar = null;
          sum_uslf = null;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);
     tar = (select sum(b.tar_usl) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_tarif,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:tar, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
   end

  /*********************-*********************************/
 /*$$IBEC$$  if ((:q_u = 2) and (:target in (21,22))) then
  begin
   for select b.id
    from zsd b
    join zs z on z.id = b.zs_id
    where z.id = :zs_id
    into :idb
    do
    begin
      tar = (select first 1 t.tarif
             from zsd d
                  join h_tomo_code c on c.nms_code = d.code_usl
                  join h_tarif_tomo t on t.group_num = c.group_num and d.date_2 between t.bp and t.epv
             where d.id = :idb);

      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf = :tar
      where d.id = :idb;
    end

    update zs z
    set z.tar_usl = (select sum(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;

    exit;
  end $$IBEC$$*/
  /******************** - 9  ************************/
  if ((:q_u = 2 and :target = 9) or (q_u = 2 and :target = 16 and date1 >= '01.05.2019'))  then
  begin
    execute procedure sp_calc_app_t09(:zs_id);
    exit;
  end

  /******************** - 10,17  -  ************************/
    if (q_u = 2 and target in (10,17)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_10 d on d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and :age_y between d.y1 and d.y2
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = cast(coalesce(b.k_uslf * :tar, 0)*:mmb as int),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 13  ************************/
    if (q_u = 2 and target = 13) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select first 1 d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                           and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_13_17 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.age_grp = a.age_grp
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = cast(coalesce(b.k_uslf * :tar, 0)*:mmb as int),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 14,15  ,  ************************/
    if (q_u = 2 and target in (14,15)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_14_15 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.cat_info = a.cat_info
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = cast(coalesce(b.k_uslf * :tar, 0)*:mmb as int),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
  /******************** - 16  ************************/
    if (q_u = 2 and target = 16 and date1 < '01.05.2019') then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join zs_hdr h on h.id = a.hdr_id
                   join patients p on p.id = a.patient_id
                   join h_tarif_disp_16 d on a.date_2 between d.bp and d.epv
                                          and d.sex = :sex
                                          and cast(d.code_usl as varchar(20)) = b.code_usl
                                          and d.age_l <= (h.y - extract(year from p.dr)) and d.age_r >= (h.y - extract(year from p.dr))
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = cast(coalesce(b.k_uslf * :tar, 0)*:mmb as int),
               b.tar_base = coalesce(:tar, 0) ,
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
end;

ALTER PROCEDURE SP_SET_USL_ZSD(
  ZS_ID INTEGER)
AS
declare variable ZSD_ID integer;
declare variable DATE1 DM_DATE;
declare variable CODE_SPEC_V021 integer;
declare variable IS_CHIELD integer;
declare variable P_CEL DM_CHAR_10;
begin
  if ((select idsp from zs where id = :zs_id) = 28) then
    exit;

  for select d.id, d.date_1, d.code_spec_v021, coalesce(z.is_chield,0), d.p_cel
   from zs z
        join zsd d on d.zs_id = z.id
   where z.id = :zs_id and z.q_u = 2 and z.target in (1,26)
   order by d.date_1
   into :zsd_id, :date1, :code_spec_v021, :is_chield, :p_cel
   do
   begin
    if (exists(select first 1 id from zsd d where d.zs_id = :zs_id and d.id <> :zsd_id and d.date_1 < :date1 and d.code_spec_v021 = :code_spec_v021)) then
    begin
      if (:is_chield = 1) then
        update zsd
         set code_usl = (select first 1 n.code_usl2_det from h_tarif_app_spec s join h_tarif_app_name n on n.id = s.name_id where s.code_spec_v021 = :code_spec_v021)
         where id = :zsd_id;
      else
        update zsd
         set code_usl = (select first 1 n.code_usl2 from h_tarif_app_spec s join h_tarif_app_name n on n.id = s.name_id where s.code_spec_v021 = :code_spec_v021)
         where id = :zsd_id;
    end
    else
    begin
      if (:is_chield = 1) then
        update zsd
         set code_usl = (select first 1 n.code_usl1_det from h_tarif_app_spec s join h_tarif_app_name n on n.id = s.name_id where s.code_spec_v021 = :code_spec_v021)
         where id = :zsd_id;
      else
        update zsd
         set code_usl = (select first 1 n.code_usl1 from h_tarif_app_spec s join h_tarif_app_name n on n.id = s.name_id where s.code_spec_v021 = :code_spec_v021)
         where id = :zsd_id;
    end
   end

   for select d.id, d.date_1, d.code_spec_v021, coalesce(z.is_chield,0), d.p_cel
   from zs z
        join zsd d on d.zs_id = z.id
   where z.id = :zs_id and z.q_u = 2 and z.target in (1,26)
         and z.p_cel in ('2.3','2.5','2.6','3.1')
   order by d.date_1
   into :zsd_id, :date1, :code_spec_v021, :is_chield, :p_cel
   do
   begin
    if (exists(select first 1 id from zsd d where d.zs_id = :zs_id and d.id <> :zsd_id and d.date_1 < :date1 and d.code_spec_v021 = :code_spec_v021)) then
        update zsd
         set code_usl = coalesce((select first 1 n.code_usl_prof from h_tarif_app_spec s join h_tarif_app_name n on n.id = s.name_id where s.code_spec_v021 = :code_spec_v021),code_usl)
         where id = :zsd_id;
   end

   for select d.id, d.date_1, d.code_spec_v021, coalesce(z.is_chield,0), d.p_cel
   from zs z
        join zsd d on d.zs_id = z.id
   where z.id = :zs_id and z.q_u = 2 and z.target in (1,26)
         and z.p_cel in ('1.3')
   order by d.date_1
   into :zsd_id, :date1, :code_spec_v021, :is_chield, :p_cel
   do
   begin
    if (exists(select first 1 id from zsd d where d.zs_id = :zs_id and d.id <> :zsd_id and d.date_1 < :date1 and d.code_spec_v021 = :code_spec_v021)) then
        update zsd
         set code_usl = coalesce((select first 1 n.code_usl_disp from h_tarif_app_spec s join h_tarif_app_name n on n.id = s.name_id where s.code_spec_v021 = :code_spec_v021),code_usl)
         where id = :zsd_id;
   end
end;

