create or alter procedure SP_SET_USL_ZSD (
    ZS_ID integer)
as
declare variable ZSD_ID integer;
declare variable DATE1 DM_DATE;
declare variable CODE_SPEC_V021 integer;
declare variable IS_CHIELD integer;
declare variable P_CEL DM_CHAR_10;
begin
  if ((select idsp from zs where id = :zs_id) = 28) then
    exit;

  for select d.id, d.date_1, d.code_spec_v021, coalesce(z.is_chield,0), d.p_cel
   from zs z
        join zsd d on d.zs_id = z.id
   where z.id = :zs_id and z.q_u = 2 and z.target in (1,26)
   order by d.date_1
   into :zsd_id, :date1, :code_spec_v021, :is_chield, :p_cel
   do
   begin
    if (exists(select first 1 id from zsd d where d.zs_id = :zs_id and d.id <> :zsd_id and d.date_1 < :date1 and d.code_spec_v021 = :code_spec_v021)) then
    begin
      if (:is_chield = 1) then
        update zsd
         set code_usl = (select first 1 n.code_usl2_det from h_tarif_app_spec s join h_tarif_app_name n on n.id = s.name_id where s.code_spec_v021 = :code_spec_v021)
         where id = :zsd_id;
      else
        update zsd
         set code_usl = (select first 1 n.code_usl2 from h_tarif_app_spec s join h_tarif_app_name n on n.id = s.name_id where s.code_spec_v021 = :code_spec_v021)
         where id = :zsd_id;
    end
    else
    begin
      if (:is_chield = 1) then
        update zsd
         set code_usl = (select first 1 n.code_usl1_det from h_tarif_app_spec s join h_tarif_app_name n on n.id = s.name_id where s.code_spec_v021 = :code_spec_v021)
         where id = :zsd_id;
      else
        update zsd
         set code_usl = (select first 1 n.code_usl1 from h_tarif_app_spec s join h_tarif_app_name n on n.id = s.name_id where s.code_spec_v021 = :code_spec_v021)
         where id = :zsd_id;
    end
   end

   for select d.id, d.date_1, d.code_spec_v021, coalesce(z.is_chield,0), d.p_cel
   from zs z
        join zsd d on d.zs_id = z.id
   where z.id = :zs_id and z.q_u = 2 and z.target in (1,26)
         and z.p_cel in ('2.3','2.5','2.6','3.1')
   order by d.date_1
   into :zsd_id, :date1, :code_spec_v021, :is_chield, :p_cel
   do
   begin
--    if (exists(select first 1 id from zsd d where d.zs_id = :zs_id and d.id <> :zsd_id and d.date_1 < :date1 and d.code_spec_v021 = :code_spec_v021)) then
        update zsd
         set code_usl = coalesce((select first 1 n.code_usl_prof from h_tarif_app_spec s join h_tarif_app_name n on n.id = s.name_id where s.code_spec_v021 = :code_spec_v021),code_usl)
         where id = :zsd_id;
   end

   for select d.id, d.date_1, d.code_spec_v021, coalesce(z.is_chield,0), d.p_cel
   from zs z
        join zsd d on d.zs_id = z.id
   where z.id = :zs_id and z.q_u = 2 and z.target in (1,26)
         and z.p_cel in ('1.3')
   order by d.date_1
   into :zsd_id, :date1, :code_spec_v021, :is_chield, :p_cel
   do
   begin
--    if (exists(select first 1 id from zsd d where d.zs_id = :zs_id and d.id <> :zsd_id and d.date_1 < :date1 and d.code_spec_v021 = :code_spec_v021)) then
        update zsd
         set code_usl = coalesce((select first 1 n.code_usl_disp from h_tarif_app_spec s join h_tarif_app_name n on n.id = s.name_id where s.code_spec_v021 = :code_spec_v021),code_usl)
         where id = :zsd_id;
   end
end;
