ALTER PROCEDURE SP_DUPLICATE_XML_STRUCT(
  STRUCT_ID INTEGER)
AS
BEGIN
  EXIT;
END;

ALTER TRIGGER XML_ITEMS_BIU0
AS
BEGIN
  EXIT;
END;

DROP VIEW V_XML_ITEMS;


ALTER TABLE XML_ITEMS ALTER COLUMN VAL
  TYPE DM_CHAR_500;


/******************************************************************************/
/****                            Creating views                            ****/
/******************************************************************************/
CREATE VIEW V_XML_ITEMS (
    ID,
    XML_STRUCTURE_ID,
    NAME,
    CAPTION,
    NOTE,
    PARENT_ID,
    ITEM_TYPE,
    DATA_ID,
    DATA_LENGTH,
    DATA_PRECISION,
    FORM,
    CONDITION_SELECT_ID,
    VAL_TYPE,
    VAL,
    IS_NO_SHOW,
    DATA_TYPE_NAME,
    NPP,
    DATA_DATE_FORMAT)
AS
select
    X.ID, X.XML_STRUCTURE_ID, X.NAME, X.CAPTION, X.NOTE, X.PARENT_ID, X.ITEM_TYPE, X.DATA_ID, X.DATA_LENGTH,
    X.DATA_PRECISION, X.FORM, X.CONDITION_SELECT_ID, X.VAL_TYPE, X.VAL, X.IS_NO_SHOW,
    dt.name, x.npp, x.data_date_format
from xml_items x
     left join h_data_type dt on dt.id = x.data_id;


/******************************************************************************/
/****                   Creating primary key constraints                   ****/
/******************************************************************************/

ALTER TRIGGER XML_ITEMS_BIU0
AS
declare variable i integer;
declare variable y integer;
declare variable s varchar(500);
declare variable f varchar(500);
begin
  i = null;
  y = new.parent_id;
  f = '';

  if ((y is not null) and (new.condition_select_id is null)) then
  begin
      if ((coalesce(new.parent_id,0) <> 0)) then
      begin
        while ((i is null) and (y is not null))  do
        BEGIN
         i = (select x.condition_select_id from xml_items x where x.id = :y and x.val_type <> 2 order by npp);

         if (i is null) then
           i = (select x.id from xml_items x where x.id = :y and x.val_type = 2);
         y = (select parent_id from xml_items where id = :y);
        END
        new.condition_select_id = i;
      end
  end

  if (((new.val_type = 2) and (coalesce(new.val,'') <> '')) and (new.val <> coalesce(old.val,''))) then
  begin
    if (position('from ', new.val) <> 0) then
      s = substring(new.val from position('from ', new.val) + 5 for char_length(new.val) - position('from ',new.val) + 5);
    else
      s = '';

    while (s <> '') do
    begin
      while (position(' ',s) = 1) do
        s = substring(s from 2 for (char_length(s) - 1));

      f = f || '''' || substring(s from 1 for position(' ',s) - 1) || '''';

      if (position('join ', s) <> 0) then
      begin
        s = substring(s from position('join ', s) + 5 for char_length(s) - position('join ',s) + 5);
        f = f || ',';
      end
      else
        s = '';
    end

    new.fields_condition = 'select F.RDB$FIELD_ID ID,
R.RDB$RELATION_NAME RELATION_NAME,
replace(substring(R.RDB$RELATION_NAME from 1 for 3),'' '', '''') || ''.'' || F.RDB$FIELD_NAME as fn,
cast(f.rdb$description as varchar(250)) as fd
from RDB$RELATIONS R
JOIN RDB$RELATION_FIELDS F ON F.RDB$RELATION_NAME = R.RDB$RELATION_NAME
where (F.RDB$SYSTEM_FLAG = 0) AND (R.RDB$RELATION_TYPE = 0)
and (R.RDB$RELATION_NAME in (' || upper(f) || '))
and f.rdb$description <> '' ''
order by fd';
  end

  if ((new.condition_select_id is null) and (new.val_type = 2)) then
      new.condition_select_id = new.id;

  if (new.npp is null) then
    new.npp = (select max(i.npp) from xml_items i where i.parent_id = new.parent_id and i.xml_structure_id = new.xml_structure_id) + 1;

  if (new.npp is null) then
    new.npp = (select max(i.npp) from xml_items i where i.xml_structure_id = new.xml_structure_id) + 1;
--  if ((new.val_type = 1) or (new.val is null))  then new.condition_select_id = null;
  new.item_type = replace(replace(new.item_type, 'O',''),'M','');
  new.item_type = replace(replace(new.item_type, 'o',''),'m','');
end;


/******************************************************************************/
/****                      Altering stored procedures                      ****/
/******************************************************************************/
ALTER PROCEDURE SP_CALC_STAC_2020(
  IDA INTEGER)
AS
declare variable KSG type of DM_CHAR_50;
declare variable DS type of DM_DS;
declare variable IDB integer;
declare variable SUM_USLF type of DM_MONEY;
declare variable KSKP numeric(6,6);
declare variable Q_U integer;
declare variable FINE_KOEF type of DM_NUM_3_2;
declare variable TARIF numeric(10,6);
declare variable IS_TRANSFER DM_INT;
declare variable CL_CNT integer;
declare variable ERR_CODE integer;
declare variable K_DOWN DM_NUM_6_2;
declare variable DS_CLASS DM_CHAR_10;
declare variable KZ DM_NUM_2_5;
declare variable KD DM_NUM_2_5;
declare variable KUS DM_NUM_2_5;
declare variable BS DM_NUM_6_2;
declare variable PROF_NUM integer;
declare variable FINE_KOEF_SET_DOCTOR DM_BOOLEAN;
declare variable IS_ROUND_JANAO integer;
declare variable OKATO DM_OKATO;
declare variable DOP_CODE DM_CHAR_40;
declare variable DATE1 DM_DATE;
declare variable DATE2 DM_DATE;
begin
  okato = (select first 1 c.tf_okato from contragents c where c.type_id = 1);

  if (okato <> '40000') then
  select c.tf_okato
   from zs_hdr h
        join zs z on z.hdr_id = h.id
        join invoice i on i.id = h.name
        join contragents c on c.id = i.contragent_id
   where z.id = :ida
   into :okato;

   -----------------------------------------------------------------------------
   --    
   for select d.id, d.date_1, d.date_2
          from zs z
               join zsd d on d.zs_id = z.id
          where z.id = :ida and (not exists(select dd.id from zsd dd where dd.zs_id = :ida
                                                                     and dd.date_1 <=d.date_1 and dd.date_2 >= d.date_2 and dd.id <> d.id) )
          order by d.ksg desc
          into :idb, :date1, :date2
          do
          begin
            update zsd d
             set d.zsd_id = :idb
             where d.id = :idb;
    
            update zsd d
             set d.zsd_id = :idb
             where d.zs_id = :ida and coalesce(d.code_usl,'') <> ''
                   and d.date_1 between :date1 and :date2
                   and not exists(select id from zsd d2 where d2.zs_id = :ida and d2.date_1 = d.date_1 and d2.id <> :idb and d2.id <> d.id);
          end
   -----------------------------------------------------------------------------
   if (:okato is  null) then
     okato = (select first 1 c.tf_okato from contragents c where c.type_id = 1);

    if (okato = '71140') then
      is_round_janao = 1;

    update zsd d
      set d.ds_class = (select MKB_CLASS from SP_GET_MKB_CLASS(D.ds))
      where d.zs_id = :ida;

    update zsd d
     set d.ksg = null, 
         d.ksg_base = null,
         d.tar_base = null,
         d.sum_base = null,
         d.kskp_base = null,
         d.sum_uslf = 0,
         d.tar_usl = 0,
         d.comment_local = null
     where d.zs_id = :ida;

    update zs z
     set z.ksg = null,
         z.tar_usl = 0,
         z.sum_usl = 0
     where z.id = :ida;

     cl_cnt = (select count(distinct b.ds_class) from ZSD b where b.ZS_ID = :ida and b.zsd_id = b.id);
     is_transfer = (select count(b.id) from ZSD b where b.ZS_ID = :ida and b.zsd_id = b.id);
     delete from kslp_koef where zs_id = :ida ;

     select a.q_u, a.date_2, coalesce(a.fine_koef_set_doctor,0)
      from zs a
      where a.id = :ida
      into :q_u, :date2, :fine_koef_set_doctor;

     for select sp.KSG, sp.ERR_CODE, b.ds, b.id, coalesce(bs.tarif * kd.kd * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0),
                k.kz, kd.kd,
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0),
                bs.tarif, k.k_down, k.prof_num, b.date_1, coalesce(b.fine_koef,1)
      from zs a
      join zsd b on a.id = b.zs_id
      join patients p on p.id = a.patient_id
      join lpu_factors lf on lf.q_u = a.q_u and a.date_2 between lf.bp and lf.epv and lf.okato is not distinct from :okato
      join h_tarif_bs bs on bs.q_u = a.q_u and a.date_2 between bs.bp and bs.epv and bs.okato is not distinct from :okato
      join h_tarif_kd kd on a.date_2 between kd.bp and kd.epv and kd.okato is not distinct from :okato
      left join sp_ksg_get_2020(b.id) sp on 1=1
      left join h_ksg k on k.ksg = sp.ksg and a.date_2 between k.bp and k.epv and k.q_u = a.q_u
      where b.zs_id = :ida and b.id = b.zsd_id
      order by b.code_usl
      into :ksg, :err_code, :ds, :idb, :tarif, :kz, :kd, :kus, :bs, :k_down, :prof_num, :date1, :fine_koef
      do
      begin
        kskp = 1;

        if (:okato = '70000') then
        begin
          select first 1 u.code_1, u.code_2
           from zsd d
                join h_usl u on u.code = d.code_usl and u.payment_type_id = 1 and :date1 between u.datebeg and u.dateend and u.q_u containing :q_u
           where d.id = :idb
          into :ksg, :dop_code;
        end

        if ((q_u in (1,3)) and (err_code is null)) then
          kskp = (select KSKP from sp_calc_stac_kskp_2020(:ida, :idb, :ksg, :cl_cnt));

        if (kskp is null) then kskp = 1;

        if (fine_koef_set_doctor = 0) then
          fine_koef = (select FINE_KOEF from sp_calc_stac_fine_2020(:ida, :idb, :ksg, :cl_cnt));

        if (is_round_janao = 1) then
          sum_uslf = cast(cast(tarif * kskp as int) * fine_koef as int);
        else
          sum_uslf = cast(tarif * kskp as numeric(15,2)) * fine_koef;

        if (:ksg is not null) then
        begin
            update zsd b set
             b.ksg_base = :ksg,
             b.tar_base = iif(:is_round_janao = 1, cast(:tarif*coalesce(:kskp,1) as int), iif(:okato = '29000', :tarif, cast(:tarif*coalesce(:kskp,1) as numeric(15,2)))),
             b.sum_base = :sum_uslf,
             b.kskp_base = :kskp,
             b.koef_z = :kz, 
             b.koef_d = :kd,
             b.koef_u = :kus,
             b.bs = :bs,
             b.koef_up = :k_down,
             b.reab = iif(:prof_num = 37,1,null),
             b.fine_koef = :fine_koef,
             b.dop_code_usl = iif(:okato = '70000', :dop_code, b.dop_code_usl)
             where b.id = :idb;
         end
      end 
--------------------------------------------------------------------------------
      --    6  + 
      if (q_u = 1) then
       if (exists (select 1 from zsd b where b.zs_id = :ida and ((b.ksg in ('st02.001') and b.k_uslf >= 6) or (b.ksg in ('O14.1','O34.2','O36.3','O36.4','O42.2') and b.k_uslf >= 2) ))
          and exists (select 1 from zsd b where b.zs_id = :ida and b.ksg in ('st02.003', 'st02.004'))) then
          begin
            --    ,     
            select first 1 b.ksg_base, b.ds
            from zs a
             join zsd b on a.id = b.zs_id
             where b.zs_id = :ida and b.ksg in ('st02.003', 'st02.004')
             into :ksg, :ds;
       
            update zsd d
            set d.tar_usl = d.tar_base,
                d.sum_uslf = d.sum_base,
                d.ksg = d.ksg_base,
                d.kskp = d.kskp_base
            where d.zs_id = :ida;

            --   
            select coalesce(sum(b.sum_uslf), 0) from zsd b where b.zs_id = :ida
             into :sum_uslf;
    
            update zs a set
             a.tar_usl = :tarif,
             a.sum_uslf = :sum_uslf,
             a.sum_usl = :sum_uslf,
             a.ksg = :ksg,
             a.ds1 = :ds,
             a.kslp = :kskp
             where a.id = :ida;

            exit;
          end
--------------------------------------------------------------------------------
      if ((is_transfer < 2) or (cl_cnt < 2))  then  --   
      begin
        --     2- ,   2
        --  ,    ,    
        --  ,    ()
        --     
        if ((exists(select first 1 1 from zsd d where d.zs_id = :ida and ((:q_u = 1 and d.ksg_base starting 'st37') or
                                                                                                  (:q_u = 3 and d.ksg_base starting 'ds37'))))
            or (exists(select first 1 1 from zsd d where d.zs_id = :ida and d.ksg_base in ('st36.009','st36.010','st36.011') and d.profil_k in (10,11) ))
            or (exists(select first 1 1 from zsd d where d.zs_id = :ida and d.ksg_base in ('st19.038','ds19.028')))
            or (((select count(d.id) from zsd d where d.zs_id = :ida and d.ksg_base is not null and d.profil_k = 42) >= 2) and
                 ((select count(u.id) from zsd d join onk_usl u on u.zsd_id = d.id where d.zs_id = :ida and u.usl_tip = 1) >= 2)))   then
            update zsd b set
                 b.ksg = b.ksg_base,
                 b.sum_uslf = b.sum_base,
                 b.tar_usl = b.tar_base,
                 b.kskp = b.kskp_base
            where b.zs_id = :ida and b.ksg_base is not null;
        else
        --     
        begin
          select first 1 id
           from zsd d
           where d.zs_id = :ida and d.ksg_base is not null
           order by d.koef_z desc
           into :idb;

          update zsd b set
             b.ksg = b.ksg_base,
             b.sum_uslf = b.sum_base,
             b.tar_usl = b.tar_base,
             b.kskp = b.kskp_base
           where b.id = :idb;

          update zsd b set
             b.ksg = null,
             b.sum_uslf = 0,
             b.kskp = 1,
             b.tar_usl = 0
            where b.id <> :idb and b.zs_id = :ida;
        end
      end else
      begin
        for select b.ds_class
         from zsd b
         where b.zs_id = :ida
         group by 1
         into :ds_class
         do
         begin
             select first 1 id
               from zsd d
               where d.zs_id = :ida and d.ksg_base is not null and d.ds_class = :ds_class
               order by d.koef_z desc
               into :idb;
    
             update zsd b set
                 b.ksg = b.ksg_base,
                 b.sum_uslf = b.sum_base,
                 b.tar_usl = b.tar_base,
                 b.kskp = b.kskp_base
               where b.id = :idb;

             update zsd b set
              b.ksg = null,
              b.sum_uslf = 0,
              b.kskp = 1,
              b.tar_usl = 0
              where b.id <> :idb and b.zs_id = :ida and b.ds_class = :ds_class;
         end
       end

        select first 1 b.ksg_base
        from zs a
         join zsd b on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null
         order by b.sum_base desc
         into :ksg;
   
        select coalesce(sum(b.sum_uslf), 0), coalesce(sum(b.tar_base), 0)
         from zsd b
         join zs a on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null
         into :sum_uslf, :tarif;

        update zs a set
         a.tar_usl = :tarif,
         a.sum_uslf = :sum_uslf,
         a.sum_usl = :sum_uslf,
         a.ksg = :ksg,
         a.kslp = :kskp
         where a.id = :ida;
end;

ALTER PROCEDURE SP_DUPLICATE_XML_STRUCT(
  STRUCT_ID INTEGER)
AS
declare variable NEW_STRUCT_ID integer;
declare variable ID integer;
declare variable FIRST_ID integer;
declare variable OLD_FIRST_ID integer;
begin
  insert into XML_STRUCTURE (ID, NAME, user_id)
    values (null, '_' || (select name from xml_structure s where s.id = :struct_id), 1)
    returning ID
    into :new_struct_id;

  first_id = gen_id(gen_xml_items_id,1);
  old_first_id = (select id from xml_items where parent_id IS NULL and xml_structure_id = :struct_id);

  for select id
      from xml_items i
      where i.xml_structure_id = :struct_id
      into :id
      do
      begin

        insert into XML_ITEMS (ID, XML_STRUCTURE_ID, NAME, CAPTION, NOTE, PARENT_ID, ITEM_TYPE, DATA_ID, DATA_LENGTH,
                           DATA_PRECISION, FORM, VAL_TYPE, VAL, IS_NO_SHOW, VAL_PREFIX, NPP,
                           FIELDS_CONDITION, DATA_DATE_FORMAT)
        select :first_id + (id - :old_first_id), :new_struct_id, NAME, CAPTION, NOTE, :first_id + (id - :old_first_id) + (parent_id - id), ITEM_TYPE, DATA_ID, DATA_LENGTH, DATA_PRECISION, FORM,
               VAL_TYPE, VAL, IS_NO_SHOW, VAL_PREFIX, NPP, FIELDS_CONDITION, DATA_DATE_FORMAT
        from XML_ITEMS x
        where x.id = :id;
      end

  first_id = gen_id(gen_xml_items_id,(select max(id) from xml_items where xml_structure_id = :new_struct_id) + 1);

  update xml_items i
   set i.condition_select_id = null
   where i.xml_structure_id = :new_struct_id;

end;

DESCRIBE FIELD GUID_ID TABLE PATIENTS
'GUID_ID_PATIENTS';

DESCRIBE FIELD GUID_ID TABLE ZS
'GUID_ID_Z_SL';

DESCRIBE FIELD GUID_ID TABLE ZSD
'GUID_ID_SL';

DESCRIBE FIELD GUID_ID_USL TABLE ZSD
'GUID_ID_USL';


