ALTER PROCEDURE SP_PRINT_CH_2015
RETURNS (
  Q_U_CODE /* DM_INT */ INTEGER,
  Q_U_NAME /* DM_CHAR_250 */ VARCHAR(250) /* COLLATE WIN1251 - default */,
  ED_CODE /* DM_INT */ INTEGER,
  ED_NAME /* DM_CHAR_40 */ VARCHAR(40) /* COLLATE WIN1251 - default */,
  MEASURES /* DM_CHAR_100 */ VARCHAR(100) /* COLLATE WIN1251 - default */,
  VALUE_MEASURES /* DM_MONEY */ NUMERIC(11,2),
  EXCEL_ROW INTEGER,
  I INTEGER)
AS
BEGIN
  SUSPEND;
END;


/******************************************************************************/
/****                   Dropping primary key constraints                   ****/
/******************************************************************************/


ALTER TABLE PRINT_CH_ROW DROP CONSTRAINT PK_PRINT_CH_ROW;


/******************************************************************************/
/****                      Creating stored procedures                      ****/
/******************************************************************************/

CREATE PROCEDURE SP_PRINT_CH_2020(
  IS_ONK INTEGER)
RETURNS (
  Q_U_CODE /* DM_INT */ INTEGER,
  Q_U_NAME /* DM_CHAR_250 */ VARCHAR(250) /* COLLATE WIN1251 - default */,
  ED_CODE /* DM_INT */ INTEGER,
  ED_NAME /* DM_CHAR_40 */ VARCHAR(40) /* COLLATE WIN1251 - default */,
  MEASURES /* DM_CHAR_100 */ VARCHAR(100) /* COLLATE WIN1251 - default */,
  VALUE_MEASURES /* DM_MONEY */ NUMERIC(11,2),
  EXCEL_ROW INTEGER,
  I INTEGER)
AS
BEGIN
  SUSPEND;
END;


/******************************************************************************/
/****                           Altering tables                            ****/
/******************************************************************************/

ALTER TABLE PRINT_CH_ROW
  ADD BP DM_DATE NOT NULL;

ALTER TABLE PRINT_CH_ROW
  ADD EP DM_DATE;

ALTER TABLE PRINT_CH_ROW
  ADD CODE_USL DM_CHAR_20 /* COLLATE WIN1251 - default */;

ALTER TABLE PRINT_CH_ROW
  ADD IS_ONK DM_BOOLEAN;

ALTER TABLE PRINT_CH_ROW
  ADD IDSP DM_CHAR_100 /* COLLATE WIN1251 - default */;

ALTER TABLE PRINT_CH_ROW
  ADD ID DM_ID;


/******************************************************************************/
/****                       Creating computed fields                       ****/
/******************************************************************************/
ALTER TABLE PRINT_CH_ROW
  ADD EPV /* DATE */ COMPUTED BY ((coalesce(EP, cast('31.12.9999' as date))));


/******************************************************************************/
/****                          Altering triggers                           ****/
/******************************************************************************/

ALTER TRIGGER PRINT_CH_ROW_BI
as
begin

end;


/******************************************************************************/
/****                      Altering stored procedures                      ****/
/******************************************************************************/
ALTER PROCEDURE SP_PRINT_CH_2015
RETURNS (
  Q_U_CODE DM_INT,
  Q_U_NAME DM_CHAR_250 /* COLLATE WIN1251 - default */,
  ED_CODE DM_INT,
  ED_NAME DM_CHAR_40 /* COLLATE WIN1251 - default */,
  MEASURES DM_CHAR_100 /* COLLATE WIN1251 - default */,
  VALUE_MEASURES DM_MONEY,
  EXCEL_ROW INTEGER,
  I INTEGER)
AS
begin
 measures = '   ';
 i = 0;

 while (i <> 2) do
 begin
  for
   select pr.q_u_code, pr.q_u_name, pr.ed_code, pr.ed_name, :measures, pr.excel_row,
         sum(iif(pr.operation = 1 or (:i = 1 and ((a.target in (21,22)) or (a.for_pom = 2) )) , iif(:i = 0, 1, a.sum_uslf), iif(:i = 0, iif(pr.operation = 2,
             iif(a.q_u in (1,3), a.k_uslf, (select sum(d.k_uslf)                         --   
               from zsd d
--                    left join h_nms_single n on (n.nms_code = d.code_usl and (a.q_u in (1,2) or (a.q_u = 2 and a.target in (21,22)) ))
                    left join h_usl u on (cast(u.id as varchar(20)) = d.code_usl) and u.q_u containing a.q_u and a.date_2 between u.datebeg and u.dateend
--                    left join h_stom s on (s.code = d.code_usl and a.q_u = 4)
               where d.zs_id = a.id and (u.id is null or coalesce(u.is_usl,0) = 0) and a.q_u <> iif(a.q_u in (1,3) and coalesce(d.code_usl,'') <> '', a.q_u, 100))),
             iif(a.q_u = 4, a.dcount,
               (select sum(d.k_uslf)                          --  
               from zsd d
--                    left join h_nms_single n on (n.nms_code = d.code_usl and (a.q_u in (1,2) or (a.q_u = 2 and a.target in (21,22)) ))
                    left join h_usl u on (cast(u.code as varchar(20)) = d.code_usl) and u.q_u containing a.q_u and a.date_2 between u.datebeg and u.dateend
--                    left join h_stom s on (s.code = d.code_usl and a.q_u = 4)
               where d.zs_id = a.id and (not (u.id is null /*$$IBEC$$ or coalesce(u.is_usl,0) = 0 $$IBEC$$*/))))),
               0)))
   from zs_hdr h
       join sys$temp_id t on t.temp_id = h.id
                             and t.table_id = 'zs_hdr'
                             and h.is_delete = 0
       left join invoice i on i.id = h.name
       left join zs a on a.hdr_id = h.id
       join print_ch_row pr on pr.q_u_code = a.q_u
                               and coalesce(pr.is_vmp,0) = iif(coalesce(a.vid_hmp,'')='', 0, 1)
                               and coalesce(pr.target, 0) containing iif(a.q_u = 2, '"' || coalesce(a.target, 0) || '"', 0)
                               and coalesce(pr.for_pom, 0) containing iif(a.q_u = 2, '"' || coalesce(a.for_pom, 0) || '"', 0)
                               and iif(a.q_u = 5 and exists(select 1 from zsd where zs_id = a.id and coalesce(code_usl,'') <> ''), 1, 0) = coalesce(pr.is_tromb,0)
   where i.ch_date between pr.bp and pr.epv
   group by 1,2,3,4,5,6
   into :q_u_code, :q_u_name, :ed_code, :ed_name, :measures, :excel_row, :value_measures
  do
   suspend;
  i = i + 1;
  measures = ', ';
 end

 select 999, '  ', 999, '', ', ', sum(a.sum_uslf)
 from zs_hdr h
       join sys$temp_id t on t.temp_id = h.id
                             and t.table_id = 'zs_hdr'
                             and h.is_delete = 0
       left join zs a on a.hdr_id = h.id
 group by 1,2,3,4,5
 into :q_u_code, :q_u_name, :ed_code, :ed_name, :measures, :value_measures;
 suspend;

end;

ALTER PROCEDURE SP_PRINT_CH_2020(
  IS_ONK INTEGER)
RETURNS (
  Q_U_CODE DM_INT,
  Q_U_NAME DM_CHAR_250 /* COLLATE WIN1251 - default */,
  ED_CODE DM_INT,
  ED_NAME DM_CHAR_40 /* COLLATE WIN1251 - default */,
  MEASURES DM_CHAR_100 /* COLLATE WIN1251 - default */,
  VALUE_MEASURES DM_MONEY,
  EXCEL_ROW INTEGER,
  I INTEGER)
AS
begin
 measures = '   ';
 i = 0;

 if (:is_onk = 0) then
 while (i <> 2) do
 begin
  for
   select pr.q_u_code, pr.q_u_name, pr.ed_code, pr.ed_name, :measures, pr.excel_row,
         sum(iif(pr.operation = 1, iif(:i = 0, 1, a.sum_uslf),
                 iif(:i = 0, iif(pr.operation = 2, iif(a.q_u = 4, a.dcount, a.k_uslf), a.k_uslf), iif(a.idsp = 28 or (a.for_pom = 2), a.sum_uslf,0))
                  )
             )
   from zs_hdr h
       join sys$temp_id t on t.temp_id = h.id
                             and t.table_id = 'zs_hdr'
                             and h.is_delete = 0
       left join invoice i on i.id = h.name
       left join zs a on a.hdr_id = h.id
       join print_ch_row pr on pr.q_u_code = a.q_u
                               and coalesce(pr.is_vmp,0) = iif(coalesce(a.vid_hmp,'')='', 0, 1)
                               and coalesce(pr.target, 0) containing iif(a.q_u = 2 and coalesce(pr.target, '') <> '', '"' || coalesce(a.target, 0) || '"', 0)
                               and coalesce(pr.for_pom, 0) containing iif(a.q_u = 2 and coalesce(pr.for_pom, '') <> '', '"' || coalesce(a.for_pom, 0) || '"', 0)
                               and iif(a.q_u = 5 and exists(select 1 from zsd where zs_id = a.id and coalesce(code_usl,'') <> ''), 1, 0) = coalesce(pr.is_tromb,0)
                               and iif((a.idsp = 28),(select first 1 code_usl from zsd where zs_id = a.id),coalesce(pr.code_usl,'')) starting coalesce(pr.code_usl,'')
                               and coalesce(pr.idsp,0) containing iif(coalesce(pr.idsp,'') <> '', '"' || coalesce(a.idsp, 0) || '"', 0)
   where i.ch_date between pr.bp and pr.epv and coalesce(pr.is_onk,0) = 0 and not exists(select first 1 id from zsd z where z.zs_id = a.id and coalesce(z.is_onk,0) = 1)
   group by 1,2,3,4,5,6
   into :q_u_code, :q_u_name, :ed_code, :ed_name, :measures, :excel_row, :value_measures
  do
   suspend;
  i = i + 1;
  measures = ', ';
 end

 measures = '   ';
 i = 0;

 if (:is_onk = 1) then
 while (i <> 2) do
 begin
  for
   select pr.q_u_code, pr.q_u_name, pr.ed_code, pr.ed_name, :measures, pr.excel_row,
         sum(iif(pr.operation = 1, iif(:i = 0, 1, a.sum_uslf),
                 iif(:i = 0, iif(pr.operation = 2, iif(a.q_u = 4, a.dcount, a.k_uslf), a.k_uslf), iif(a.idsp = 28 or (a.for_pom = 2), a.sum_uslf,0))
                  )
             )
   from zs_hdr h
       join sys$temp_id t on t.temp_id = h.id
                             and t.table_id = 'zs_hdr'
                             and h.is_delete = 0
       left join invoice i on i.id = h.name
       left join zs a on a.hdr_id = h.id
       join print_ch_row pr on pr.q_u_code = a.q_u
                               and coalesce(pr.is_vmp,0) = iif(coalesce(a.vid_hmp,'')='', 0, 1)
                               and coalesce(pr.target, 0) containing iif(a.q_u = 2 and coalesce(pr.target, '') <> '', '"' || coalesce(a.target, 0) || '"', 0)
                               and coalesce(pr.for_pom, 0) containing iif(a.q_u = 2 and coalesce(pr.for_pom, '') <> '', '"' || coalesce(a.for_pom, 0) || '"', 0)
                               and iif(a.q_u = 5 and exists(select 1 from zsd where zs_id = a.id and coalesce(code_usl,'') <> ''), 1, 0) = coalesce(pr.is_tromb,0)
                               and iif((a.idsp = 28),(select first 1 code_usl from zsd where zs_id = a.id),coalesce(pr.code_usl,'')) starting coalesce(pr.code_usl,'')
                               and coalesce(pr.idsp,0) containing iif(coalesce(pr.idsp,'') <> '', '"' || coalesce(a.idsp, 0) || '"', 0)
   where i.ch_date between pr.bp and pr.epv and coalesce(pr.is_onk,0) = 1 and exists(select first 1 id from zsd z where z.zs_id = a.id and coalesce(z.is_onk,0) = 1)
   group by 1,2,3,4,5,6
   into :q_u_code, :q_u_name, :ed_code, :ed_name, :measures, :excel_row, :value_measures
  do
   suspend;
  i = i + 1;
  measures = ', ';
 end

-- select 999, '  ', 999, '', ', ', sum(a.sum_uslf)
-- from zs_hdr h
--       join sys$temp_id t on t.temp_id = h.id
--                             and t.table_id = 'zs_hdr'
--                             and h.is_delete = 0
--       left join zs a on a.hdr_id = h.id
-- group by 1,2,3,4,5
-- into :q_u_code, :q_u_name, :ed_code, :ed_name, :measures, :value_measures;
-- suspend;

end;

