/* Create Table... */
CREATE TABLE ZS_SANK(ID DM_ID NOT NULL,
ZS_ID DM_ID,
S_CODE DM_GUID,
S_SUM DM_MONEY_15_2,
S_TIP DM_INT,
SL_ID DM_GUID,
S_OSN DM_INT,
DATE_ACT DM_DATE,
NUM_ACT DM_CHAR_40,
CODE_EXP DM_CHAR_10,
S_COM DM_CHAR_250,
S_IST DM_INT);



ALTER TABLE H_USL ADD LEAD_TIME DM_INT;

DESCRIBE FIELD LEAD_TIME TABLE H_USL
'   ';

ALTER TABLE REGISTRY ADD CODE_USL DM_CHAR_50;

ALTER TABLE ZS ADD SPOLIS DM_CHAR_20;

DESCRIBE FIELD SPOLIS TABLE ZS
'    ';

ALTER TABLE ZS ADD NPOLIS DM_CHAR_20;

DESCRIBE FIELD NPOLIS TABLE ZS
'    ';

ALTER TABLE ZS ADD SMO DM_CHAR_10;

DESCRIBE FIELD SMO TABLE ZS
'   ';

/* Alter View (Drop, Create)... */
/* Drop altered view: V_H_USL */
DROP VIEW V_H_USL;

/* Create altered view: V_H_USL */
/* Create view: V_H_USL */
CREATE VIEW V_H_USL(
ID,
NAME,
IS_USL,
Q_U,
TARGET,
CODE,
DATEBEG,
DATEEND,
CHIELD_UET,
UET,
SUMF,
PAYMENT_TYPE_ID,
PAYMENT_TYPE_NAME,
USL_CATEGORY_ID,
USL_CATEGORY_NAME,
IS_ANALIZ,
OKATO,
LEAD_TIME)
 AS 
select u.id, u.name, coalesce(u.is_usl,0) is_usl,
       iif(u.q_u containing '1','./','') ||
       iif(u.q_u containing '2','/','') ||
       iif(u.q_u containing '3','../','') ||
       iif(u.q_u containing '4','./','') ||
       iif(u.q_u containing '5','','') q_u,
       u.target,
       u.code,
       u.datebeg,
       u.dateend,
       coalesce(u.chield_uet,0) chield_uet,
       coalesce(u.uet,0) uet,
       coalesce(u.sumf,0) sumf,
       u.payment_type_id,
       pt.name payment_type_name,
       u.usl_category_id,
       c.name usl_category_name,
       coalesce(u.is_analiz,0) is_analiz,
       u.okato,
       u.lead_time
from h_usl u
     left join h_payment_type pt on pt.id = u.payment_type_id
     left join h_usl_category c on c.id = u.usl_category_id
;

DESCRIBE FIELD NAME VIEW V_H_USL
'';

DESCRIBE FIELD IS_USL VIEW V_H_USL
'';

DESCRIBE FIELD Q_U VIEW V_H_USL
' ';

DESCRIBE FIELD TARGET VIEW V_H_USL
' ';

DESCRIBE FIELD CODE VIEW V_H_USL
'';

DESCRIBE FIELD DATEBEG VIEW V_H_USL
' ';

DESCRIBE FIELD DATEEND VIEW V_H_USL
' ';

DESCRIBE FIELD CHIELD_UET VIEW V_H_USL
' ';

DESCRIBE FIELD UET VIEW V_H_USL
'';

DESCRIBE FIELD SUMF VIEW V_H_USL
'';

DESCRIBE FIELD PAYMENT_TYPE_NAME VIEW V_H_USL
' ';

DESCRIBE FIELD USL_CATEGORY_NAME VIEW V_H_USL
'';

DESCRIBE FIELD IS_ANALIZ VIEW V_H_USL
'';

DESCRIBE FIELD OKATO VIEW V_H_USL
'';

/* Drop altered view: V_ZS */
DROP VIEW V_ZS;

/* Create altered view: V_ZS */
/* Create view: V_ZS */
CREATE VIEW V_ZS(
ID,
Q_U,
MP,
ORDER_V,
CODE_SPEC,
CODE_PROF,
OTD_PROF,
IS_CHIELD,
N_HIST,
DATE_1,
DATE_2,
DS0,
DS1,
DS2,
TAR_USL,
K_USLF,
K_USL,
IDSP,
TARGET,
RESULT,
PATIENT_ID,
FAM,
IM,
OT,
Q_U_NAME,
TARGET_NAME,
SUM_USLF,
HDR_ID,
DIRECTION_NUM,
DIRECTION_DATE,
DH_INFO,
MES_CODE,
SMP_BRIG,
DS3,
DCOUNT,
UID,
PHYS_ID,
CATEGORY,
DISP_STAGE,
DISP_WORK_STATE,
DISP_RESULT,
DISP_H_GROUP,
OUTCOME,
KSG,
CAT_INFO,
IDSP_NAME,
MP_NAME,
ORDER_V_NAME,
DH_INFO_NAME,
CODE_SPEC_NAME,
CODE_PROF_NAME,
IS_CHIELD_NAME,
SMP_BRIG_NAME,
RESULT_NAME,
OUTCOME_NAME,
FOR_POM,
VID_HMP,
METOD_HMP,
AGE_GRP,
CHIELD_WITH_ROP,
FOR_POM_NAME,
REGISTRY_ID,
PAYMENT_TYPE_ID,
PAYMENT_NAME,
REGISTRY_NAME,
SUM_USL,
DOCTOR_FIO,
DOCTOR_COD,
NUM_SP,
IDCASE,
Q_U_2016,
HAS_ERRORS,
CODE_MES1,
COMENTSL,
SMO,
OKATO_SMO,
OKATO_G,
OKATO_P,
SUM_OPL,
N_ZAP,
ZSP_VPOLIS,
ZSP_SPOLIS,
ZSP_NPOLIS,
ZSP_POLIS_BP,
ZSP_POLIS_EP,
ZSP_SMO_OGRN,
ZSP_SMO_CODE,
ZSP_ENP,
ZSP_SEND_DATE,
ZSP_RESP_DATE,
AGE,
DR,
DOC_SER,
DOC_NUM,
SEX,
PODR,
KSLP,
REG_DATE,
AGE_NAME,
M,
Y,
CH_NUM,
INV_STATE,
KSG_NUM,
KSG_PROF_NUM,
NPR_MO,
PER,
VBR,
TAL_D,
TAL_P,
INV,
RSLT_D,
NAZR,
NAZ_SP,
NAZ_V,
NAZ_PMP,
NAZ_PK,
IDSP_NOT_AUTO,
AGE_GRP_NOT_AUTO,
USER_ID,
USER_FIO,
MSE,
BARTHEL_IDX,
CODE_SPEC_V021,
ID_PAC,
DISP,
P_CEL,
C_ZAB,
KSG_CRITERION,
PR_NOV,
MCOD,
PR_DATE_1,
PR_DATE_2,
DN,
JOB_NAME,
LPU,
SET_USL_AUTO,
PROFIL_K)
 AS 
select z.id,
       z.q_u,
       z.mp,
       z.order_v,
       z.code_spec,
       z.code_prof,
       z.otd_prof,
       z.is_chield,
       z.n_hist,
       z.date_1,
       z.date_2,
       z.ds0,
       z.ds1,
       z.ds2,
       z.tar_usl,
       z.k_uslf,
       z.k_usl,
       z.idsp,
       z.target,
       z.result,  
       z.patient_id,
       p.fam,
       p.im,
       p.ot,
       q_u.name as q_u_name,
       t.name as target_name,
       z.sum_uslf,
       z.hdr_id,
       z.direction_num,
       z.direction_date,
       z.dh_info as dh_info,
       z.mes_code,
       z.smp_brig,
       z.ds3,
       Z.DCOUNT,
       z.uid,
       z.phys_id,
       z.category,
       z.disp_stage,
       z.disp_work_state,
       z.disp_result,
       z.disp_h_group,
       z.outcome,
       z.ksg,
       z.cat_info,
       i.name as idsp_name,
       m.name as mp_name,
       o.name as order_v_name,
       dh.name as dh_info_name,
       iif(z.date_2 >= '01.05.2018', (select name from h_spec_v021 where code = z.code_spec_v021), (select name from h_spec_v015 where code = z.code_spec)) as code_spec_name,
       co.name as code_prof_name,
       iif(z.is_chield = 1, ' ', '') as is_chield_name,
       sb.name as smp_brig_name,
       r.name as result_name,
       oc.name as outcome_name,
       z.for_pom,
       z.vid_hmp,
       z.metod_hmp,
       z.age_grp,
       z.chield_with_rop,
       fp.name,
       z.registry_id,
       Z.payment_type_id,
       pt.name,
       reg.name,
       z.sum_usl,
       df.fio,
       DF.pcod,
       z.npolis,  --iif(z.payment_type_id <> 2, p.num_sp, (select ins.ser || ' ' || ins.num from patients_insurance ins where ins.patients_id = p.id and z.date_1 between ins.db and ins.de)),
       z.id_case,
       z.q_u_2016,
       0,--(select first 1 1 from error_list_local err where err.reestr_hdr_id = z.hdr_id and err.uid = z.uid),
       z.mes_code,
       z.comentsl,
       z.smo,
       p.okato_smo,
       p.okato_l,
       p.okato_r,
       z.sum_usl, --(select sum(pi.sum_opl) from patients_invoice pi where pi.zs_id = z.id),
       z.n_zap n_zap,
       zpr.vpolis,
       zpr.spolis,
       zpr.npolis,
       zpr.polis_bp,
       zpr.polis_ep,
       zpr.smo_ogrn,
       zpr.smo_code,
       zpr.enp,
       zp.send_date,
       zpr.resp_date,
       z.age,
       p.dr,
       p.doc_ser,
       p.doc_num,
       p.sex,
       z.podr,
       z.kslp,
       reg.reg_date,
       cast(floor(z.age) as varchar(3)) || '  ' ||
            cast(iif(extract(day from z.date_1) < extract(day from p.dr),
                 iif(extract(month from z.date_1) > extract(month from p.dr), extract(month from z.date_1) - extract(month from p.dr),
                             iif(extract(month from z.date_1) < extract(month from p.dr), 12 - extract(month from p.dr) + extract(month from z.date_1) - 1,
                                 11)),
                 iif(extract(month from z.date_1) > extract(month from p.dr), extract(month from z.date_1) - extract(month from p.dr),
                             iif(extract(month from z.date_1) < extract(month from p.dr), 12 - extract(month from p.dr) + extract(month from z.date_1),
                                   0))) as varchar(2)) || ' ',
       h.m,
       h.y, 
       h.full_name,
       coalesce(inv.status_id,0),
       ksg.ksg_name,
       ksg.prof_name,
       z.npr_mo,
       z.per,
       z.vbr,
       z.tal_d,
       z.tal_p,
       z.inv,
       Z.rslt_d,
       z.nazr,
       z.naz_sp,
       z.naz_v,
       z.naz_pmp,
       z.naz_pk,
       z.idsp_not_auto,
       Z.age_grp_not_auto,
       z.user_id,
       s.fio,
       z.mse,
       z.barthel_idx ,
       z.code_spec_v021,
       z.id_pac,
       Z.disp,
       z.p_cel,
       z.c_zab,
       z.ksg_criterion,
       z.pr_nov,
       z.mcod, 
       z.pr_date_1,
       z.pr_date_2,
       z.dn,
       contr.short_name,
       inv.lpu,
       z.set_usl_auto,
       z.profil_k
from zs z
join patients p on p.id = z.patient_id
join zs_hdr h on h.id = z.hdr_id
left join invoice inv on inv.id = h.name
left join h_q_u q_u on q_u.id = z.q_u
left join h_target t on t.id = z.target
left join h_idsp i on i.id = z.idsp
left join h_mp m on m.code = z.mp
left join h_order_v o on o.id = z.order_v
left join h_dh_info dh on dh.id = z.dh_info
left join h_spec_v015 cs on cs.code = z.code_spec
left join h_code_otd co on co.code = z.code_prof
left join h_smp_brig sb on sb.id = z.smp_brig
left join h_result r on r.code = z.result
left join h_outcome oc on oc.code = z.outcome
left join h_for_pom fp on fp.code = z.for_pom
left join h_payment_type pt on pt.id = z.payment_type_id
left join v_registry reg on reg.id = z.registry_id
left join doctors_fio df on df.id = z.phys_id
left join zsp zp on zp.zs_id = z.id
left join zsp_resp zpr on zpr.zsp_id = zp.id
left join h_ksg ksg on (cast(ksg.ksg as varchar(50))) = z.ksg and z.q_u = ksg.q_u and z.date_2 between ksg.bp and ksg.epv
left join users s on s.id = z.user_id
left join contragents contr on contr.id = p.job_id
where h.is_delete <> 1
;

/* Create generator... */
CREATE GENERATOR GEN_ZS_SANK_ID;


/* Create Primary Key... */
ALTER TABLE ZS_SANK ADD CONSTRAINT PK_ZS_SANK PRIMARY KEY (ID);

/* Create Foreign Key... */

ALTER TABLE ZS_SANK ADD CONSTRAINT FK_ZS_SANK_1 FOREIGN KEY (ZS_ID) REFERENCES ZS (ID) ON UPDATE CASCADE ON DELETE CASCADE;

/* Creating trigger... */

CREATE TRIGGER ZS_SANK_BI FOR ZS_SANK
ACTIVE BEFORE INSERT POSITION 0 
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_zs_sank_id,1);
end;


/* Altering existing trigger... */
ALTER TRIGGER ZS_BIU0
AS
declare variable hdr integer;
declare variable dr date;
begin
  select p.dr from patients p where p.id = new.patient_id
  into :dr;
  new.age = ((new.date_1 - :dr)/365.25);

  if (new.n_zap is null) then
    new.n_zap = new.id;

  if (new.id_case is null) then
    new.id_case = new.id;

  if (new.id_pac is null) then
    new.id_pac = new.id;

  if (new.payment_type_id is null) then
    new.payment_type_id = 1;

  if (bin_and(new.extra_info, 1) = 1) then
    new.chield_with_rop = 1;

  if (new.date_1 is null) then
  begin
    new.date_1 = current_date;
    new.date_2 = current_date;
  end

  new.spolis = (select first 1 i.ser from patients_insurance i where i.patients_id = new.patient_id and i.type_id = new.payment_type_id and i.db <= new.date_2 and coalesce(i.de,'31.12.2999') >= new.date_2);
  new.npolis = (select first 1 i.num from patients_insurance i where i.patients_id = new.patient_id and i.type_id = new.payment_type_id and i.db <= new.date_2 and coalesce(i.de,'31.12.2999') >= new.date_2);
  new.smo = (select first 1 i.smo from patients_insurance i where i.patients_id = new.patient_id and i.type_id = new.payment_type_id and i.db <= new.date_2 and coalesce(i.de,'31.12.2999') >= new.date_2);

  if (new.hdr_id is null) then
  begin
    hdr = (select id from zs_hdr h where h.y = extract(year from new.date_2) and h.m = extract(month from new.date_2)
         and h.name = h.m and is_delete = 0);

    if (hdr is not null) then
      new.hdr_id = hdr;
    else
    begin
      execute procedure ADD_PERIOD_HDR(extract(month from new.date_2), extract(year from new.date_2),
                                       (select M2 from SP_MONTH_TO_STRING(extract(month from new.date_2))),
                                       cast(extract(year from new.date_2) as varchar(4))) ;
      hdr = (select id from zs_hdr h where h.y = extract(year from new.date_2) and h.m = extract(month from new.date_2));
      new.hdr_id = :hdr;
    end
  end

  if ((new.n_hist is null) or (new.n_hist = '')) then
  begin
--    new.n_hist_num = (select max(coalesce(n_hist_num,0)) from zs z where z.patient_id = new.patient_id) + 1;
    new.n_hist = cast(gen_id(gen_nhist, 1) as varchar(50));
  end

  if (new.is_chield is null) then
    new.is_chield = 0;

  if ((new.q_u_2016 is not null) and (new.q_u is null)) then
  begin
      if (new.q_u_2016 = 4 and extract(year from new.date_2) > 2015 ) then
        new.q_u = 5;
      else
      if (new.q_u_2016 = 5 and extract(year from new.date_2) > 2015 ) then
        new.q_u = 4;
      else
      if (new.q_u_2016 = 2 and extract(year from new.date_2) > 2015 ) then
        new.q_u = 3;
      else
      if (new.q_u_2016 = 3 and extract(year from new.date_2) > 2015 ) then
      begin
       if (new.idsp = 9) then
       begin
        new.q_u = 4;
        new.q_u_2016 = 5;
       end
       else
        new.q_u = 2;
      end
      else new.q_u = 1;
  end
  else
  if ((new.q_u is not null)) then
  begin
      if (new.q_u = 4 and extract(year from new.date_2) > 2015 ) then
        new.q_u_2016 = 5;
      else
      if (new.q_u = 5 and extract(year from new.date_2) > 2015 ) then
        new.q_u_2016 = 4;
      else
      if (new.q_u = 2 and extract(year from new.date_2) > 2015 ) then
        new.q_u_2016 = 3;
      else
      if (new.q_u = 3 and extract(year from new.date_2) > 2015 ) then
        new.q_u_2016 = 2;
      else new.q_u_2016 = 1;
  end

  if (new.target in (9,10,11,12,13,14,15,16,17)) then
  begin
    if (new.disp_h_group is null) then
    begin
      new.disp_h_group = case
                           when (new.rslt_d in (1)) then '1'
                           when (new.rslt_d in (2)) then '2'
                           when (new.rslt_d in (3)) then '3'
                           when (new.rslt_d in (31)) then '3'
                           when (new.rslt_d in (32)) then '3'
                           when (new.rslt_d in (4)) then '4'
                           when (new.rslt_d in (5)) then '5'
                           when (new.rslt_d in (11)) then '1'
                           when (new.rslt_d in (12)) then '2'
                           when (new.rslt_d in (14)) then '3'
                           when (new.rslt_d in (15)) then '3'
                         end;
    end
  end
  
  if (not inserting) then
  begin
  if (new.q_u = 1) then
    new.k_uslf = iif(new.date_1 = new.date_2, 1, new.date_2 - new.date_1);
    else
    if (new.q_u = 3) then
    begin
      if (coalesce(new.ksg,'') = '') then
        new.k_uslf = (select sum(d.k_uslf) from zsd d where d.zs_id = new.id and coalesce(d.ksg,'') = '');
      else
        new.k_uslf = (select max(d.k_uslf) from zsd d where d.zs_id = new.id and coalesce(d.ksg,'') <> '');
--        iif(new.date_1 = new.date_2, 1, new.date_2 - new.date_1 + 1);
    end
      else
      if (new.q_u in (4,5)) then
        new.k_uslf = (select sum(d.k_uslf) from zsd d where d.zs_id = new.id);
        else
        if (new.q_u = 2 and new.target in (9,10,13,16,17)) then
          new.k_uslf = (select sum(d.k_uslf)
                        from zsd d left join h_usl u on u.code = d.code_usl
                                                        and u.q_u containing new.q_u
                                                        and new.date_1 between u.datebeg and u.dateend
                                                        and u.payment_type_id = new.payment_type_id
                        where d.zs_id = new.id and coalesce(u.is_usl,0) <> 1);
        else
        if (new.q_u = 2 and new.target not in (9,10,13,16,17)) then
          new.k_uslf = (select sum(d.k_uslf)
                        from zsd d
                        where d.zs_id = new.id);
  end

  if (coalesce(new.idsp_not_auto,0) = 0) then
  new.idsp = case
             when (new.q_u = 1) then 33
             when (new.q_u = 3) then 33
             when (new.q_u = 2) and exists(select first 1 id from zsd d where d.zs_id = new.id and
                                                  ((coalesce(d.code_usl,'') starting 'A06')
                                                  or (coalesce(d.code_usl,'') starting 'A05')
                                                  or (coalesce(d.code_usl,'') starting 'A04')
                                                  or (coalesce(d.code_usl,'') starting 'A03')
                                                  or (coalesce(d.code_usl,'') starting 'A08')
                                                  or (coalesce(d.code_usl,'') starting 'A27')
                                                  or (coalesce(d.code_usl,'') starting 'A07'))) then 28
             when (new.q_u = 5) and exists(select first 1 id from zsd d where d.zs_id = new.id and coalesce(d.code_usl,'') starting '') then 28
             when (new.q_u = 2) and (new.target < 9) and new.k_uslf = 1 then 29
             when (new.q_u = 2) and (new.target < 9) and (new.for_pom = 3) and new.k_uslf > 1 then 30
             when (new.q_u = 2) and (new.target in (9,10,17,13,14,15,16)) then 30
             when (new.q_u = 2) and (new.target in (21,22,23)) then 28
             when (new.q_u = 5) then 36
             when (new.q_u = 4) and (new.target < 9) and new.dcount = 1 then 29
             when (new.q_u = 4) and (new.target < 9) and (new.for_pom = 3) and new.dcount > 1 then 30
             end;

  dr = (select dr from patients where id = new.patient_id);

  if ((coalesce(new.age_grp_not_auto,0) = 0) and (new.target = 13)) then
    new.age_grp = (select AGE_GRP from SP_CALC_AGE_GRP(:dr, new.date_1));
             
  if (new.chield_with_rop = 1) then
    new.extra_info = 1;
  if (new.extra_info = 1) then
    new.chield_with_rop = 1;

  new.usl_ok = case
               when (new.q_u = 1) then 1
               when (new.q_u = 2) then 3
               when (new.q_u = 3) then 2
               when (new.q_u = 5) then 4
               when (new.q_u = 4) then 3
               end;
end;
