ALTER TABLE SYS$REGISTRY_SETTING ADD WDAY DM_INT;

DESCRIBE FIELD WDAY TABLE SYS$REGISTRY_SETTING
'  ,    1';

ALTER TABLE ZSD ADD KSG_SET_DOCTOR DM_BOOLEAN;

--ALTER TABLE SYS$REGISTRY_SETTING ALTER COLUMN WEEKEND TYPE DM_BOOLEAN;

/* Alter View (Drop, Create)... */
/* Drop altered view: V_ZSD */
DROP VIEW V_ZSD;

/* Create altered view: V_ZSD */
/* Create view: V_ZSD */
CREATE VIEW V_ZSD(
ID,
ZS_ID,
DATE_1,
DATE_2,
CODE_SPEC,
CODE_PROF,
USL_TYPE,
OTD_PROF,
IS_CHIELD,
DS,
DS2,
SRVPLACE,
CODE_USL,
K_USLF,
PHYS_ID,
MES_CODE,
FIO,
SPEC_NAME,
SRVPLACE1,
DCOUNT,
KSG,
PCOD,
TAR_USL,
PMD_CLOSE,
SUM_USLF,
ORIT,
MP,
USL_NAME,
Q_U,
TARGET,
DISP_STAGE,
DATE_1_ZS,
TOOTH,
ZACHET,
IS_NO_GET_USL,
KSG_BASE,
SUM_BASE,
TAR_BASE,
KSKP_BASE,
COMMENT_LOCAL,
PODR,
TOOTH_LIST,
PROF_NAME,
FAM,
IM,
OT,
DR,
PHONES,
EMAIL,
Q_U_NAME,
KSG_CRITERION,
ZSD_ID,
P_CEL,
DN,
PROFIL_K,
P_PER,
DS_ONK,
KSG_CRITERION2,
CODE_SPEC_V021,
SER_SP,
NUM_SP,
C_ZAB,
FINE_KOEF_SET_DOCTOR,
DOP_TARIF,
DOP_SUM,
DOP_CODE_USL,
INVOICE_NAME,
VID_VME,
ZACHET_STAC,
KOEF_Z,
KOEF_D,
KOEF_U,
FINE_KOEF,
KSLP,
KOEF_UP,
KSG_SET_DOCTOR)
 AS 
select zz.ID, zz.zs_id, zz.DATE_1, zz.DATE_2, iif(z.date_2 >= '01.05.2018', zz.code_spec_v021, zz.code_spec), zz.CODE_prof, zz.usl_type,
       zz.OTD_PROF, zz.IS_CHIELD,
       zz.DS, zz.DS2, zz.SRVPLACE, zz.CODE_USL, zz.K_USLF, 
       zz.PHYS_ID, z.mes_code, 
       iif(zz.phys_id = '', '', (select fio from doctors_fio where id = zz.phys_id)) as fio,
       iif(z.date_2 >= '01.05.2018', (select name from h_spec_v021 where code = zz.code_spec_v021), (select name from h_spec_v015 where code = zz.code_spec)) as spec_name, pl.name as srvplace,
       zz.dcount,zz.ksg, iif(zz.phys_id = '', '', (select pcod from doctors_fio where id = zz.phys_id)) as pcod,
       zz.tar_usl, coalesce(zz.pmd_close,0), zz.sum_uslf, zz.orit, zz.mp,
       (select first 1 name from h_usl u where u.code = zz.code_usl
        and u.q_u containing cast(z.q_u as varchar(1)) and u.payment_type_id = z.payment_type_id
        and z.date_1 between u.datebeg and u.dateend),
       z.q_u, z.target, z.disp_stage, z.date_1, zz.tooth_id, coalesce(zz.zachet,0), coalesce(ZZ.is_no_get_usl,0),
       zz.ksg_base, zz.sum_base, zz.tar_base, zz.kskp_base, zz.comment_local, zz.podr,
       iif((coalesce(zz.tooth_id,0) = 0 or coalesce(zz.tooth_list,'')='') and z.q_u = 4, zz.tooth_id, zz.tooth_list),
       o.name, p.fam, p.im, p.ot, p.dr, p.phones, p.email, q.name, zz.ksg_criterion, zz.zsd_id,
       zz.p_cel, zz.dn, zz.profil_k, zz.p_per, zz.ds_onk, zz.ksg_criterion2, zz.code_spec_v021,
       p.ser_sp, p.num_sp, zz.c_zab, z.fine_koef_set_doctor, zz.dop_tarif, zz.dop_sum, zz.dop_code_usl, h.full_name,
       zz.vid_vme, zz.zachet_stac, zz.koef_z, zz.koef_d, zz.koef_u, zz.fine_koef, zz.kskp, zz.koef_up,
       zz.ksg_set_doctor
from ZSd zz
     left join zs z on z.id = zz.zs_id
     join zs_hdr h on h.id = z.hdr_id
     left join patients p on p.id = z.patient_id
--     left join h_spec_v015 cs on cs.code = zz.code_spec
--     left join h_spec_v021 cs2 on cs2.code = zz.code_spec_v021
     left join h_srvplace pl on pl.id = zz.srvplace
     left join h_code_otd o on o.code = zz.code_prof
     left join h_q_u q on q.id = z.q_u
where h.is_delete <> 1
;

/* Alter Procedure... */
/* empty dependent procedure body */
/* Clear: SP_CALC_ALL for: SP_CALC_STAC_2020 */

ALTER PROCEDURE SP_CALC_ALL(ZS_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* Alter (SP_CALC_STAC_2020) */
ALTER PROCEDURE SP_CALC_STAC_2020(IDA INTEGER)
 AS
declare variable KSG type of DM_CHAR_50;
declare variable DS type of DM_DS;
declare variable IDB integer;
declare variable SUM_USLF type of DM_MONEY;
declare variable KSKP numeric(6,6);
declare variable Q_U integer;
declare variable FINE_KOEF type of DM_NUM_3_2;
declare variable TARIF numeric(10,6);
declare variable IS_TRANSFER DM_INT;
declare variable CL_CNT integer;
declare variable ERR_CODE integer;
declare variable K_DOWN DM_NUM_6_2;
declare variable DS_CLASS DM_CHAR_10;
declare variable KZ DM_NUM_2_5;
declare variable KD DM_NUM_2_5;
declare variable KUS DM_NUM_2_5;
declare variable BS DM_NUM_6_2;
declare variable PROF_NUM integer;
declare variable FINE_KOEF_SET_DOCTOR DM_BOOLEAN;
declare variable IS_ROUND_JANAO integer;
declare variable OKATO DM_OKATO;
declare variable DOP_CODE DM_CHAR_40;
declare variable DATE1 DM_DATE;
declare variable DATE2 DM_DATE;
declare variable KSG_SET_DOCTOR integer;
begin
  okato = (select first 1 c.tf_okato from contragents c where c.type_id = 1);

  if (okato <> '40000') then
  select c.tf_okato
   from zs_hdr h
        join zs z on z.hdr_id = h.id
        join invoice i on i.id = h.name
        join contragents c on c.id = i.contragent_id
   where z.id = :ida
   into :okato;

   -----------------------------------------------------------------------------
   --    
   for select d.id, d.date_1, d.date_2
          from zs z
               join zsd d on d.zs_id = z.id
          where z.id = :ida and (not exists(select dd.id from zsd dd where dd.zs_id = :ida
                                                                     and dd.date_1 <=d.date_1 and dd.date_2 >= d.date_2 and dd.id <> d.id) )
          order by d.ksg desc
          into :idb, :date1, :date2
          do
          begin
            update zsd d
             set d.zsd_id = :idb
             where d.id = :idb;
    
            update zsd d
             set d.zsd_id = :idb
             where d.zs_id = :ida and coalesce(d.code_usl,'') <> ''
                   and d.date_1 between :date1 and :date2
                   and not exists(select id from zsd d2 where d2.zs_id = :ida and d2.date_1 = d.date_1 and d2.id <> :idb and d2.id <> d.id);
          end
   -----------------------------------------------------------------------------
   if (:okato is  null) then
     okato = (select first 1 c.tf_okato from contragents c where c.type_id = 1);

    if (okato = '71140') then
      is_round_janao = 1;

    update zsd d
      set d.ds_class = (select MKB_CLASS from SP_GET_MKB_CLASS(D.ds))
      where d.zs_id = :ida;

    ksg_set_doctor = (select first 1 coalesce(ksg_set_doctor,0) from zsd where zs_id = :ida order by 1 desc);

    update zsd d
     set d.ksg = null, 
         d.ksg_base = iif(:ksg_set_doctor = 0, null, d.ksg_base),
         d.tar_base = null,
         d.sum_base = null,
         d.kskp_base = null,
         d.sum_uslf = 0,
         d.tar_usl = 0,
         d.comment_local = null
     where d.zs_id = :ida;

    update zs z
     set z.ksg = null,
         z.tar_usl = 0,
         z.sum_usl = 0
     where z.id = :ida;

     cl_cnt = (select count(distinct b.ds_class) from ZSD b where b.ZS_ID = :ida and b.zsd_id = b.id);
     is_transfer = (select count(b.id) from ZSD b where b.ZS_ID = :ida and b.zsd_id = b.id);
     delete from kslp_koef where zs_id = :ida ;

     select a.q_u, a.date_2, coalesce(a.fine_koef_set_doctor,0)
      from zs a
      where a.id = :ida
      into :q_u, :date2, :fine_koef_set_doctor;

     for select sp.KSG, sp.ERR_CODE, b.ds, b.id, coalesce(bs.tarif * kd.kd * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0),
                k.kz, kd.kd,
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0),
                bs.tarif, k.k_down, k.prof_num, b.date_1, coalesce(b.fine_koef,1), b.ksg_set_doctor
      from zs a
      join zsd b on a.id = b.zs_id
      join patients p on p.id = a.patient_id
      join lpu_factors lf on lf.q_u = a.q_u and a.date_2 between lf.bp and lf.epv and lf.okato is not distinct from :okato
      join h_tarif_bs bs on bs.q_u = a.q_u and a.date_2 between bs.bp and bs.epv and bs.okato is not distinct from :okato
      join h_tarif_kd kd on a.date_2 between kd.bp and kd.epv and kd.okato is not distinct from :okato
      left join sp_ksg_get_2020(b.id) sp on 1=1
      left join h_ksg k on k.ksg = iif(:ksg_set_doctor = 1, b.ksg_base, sp.ksg) and a.date_2 between k.bp and k.epv and k.q_u = a.q_u
      where b.zs_id = :ida and b.id = b.zsd_id
      order by b.code_usl
      into :ksg, :err_code, :ds, :idb, :tarif, :kz, :kd, :kus, :bs, :k_down, :prof_num, :date1, :fine_koef, :ksg_set_doctor
      do
      begin
        kskp = 1;

        if (coalesce(:ksg_set_doctor,0) = 1) then
          ksg = (select ksg_base from zsd where id = :idb);

        if (:okato = '70000') then
        begin
          select first 1 u.code_1, u.code_2
           from zsd d
                join h_usl u on u.code = d.code_usl and u.payment_type_id = 1 and :date1 between u.datebeg and u.dateend and u.q_u containing :q_u
           where d.id = :idb
          into :ksg, :dop_code;
        end

        if ((q_u in (1,3)) and (err_code is null)) then
          kskp = (select KSKP from sp_calc_stac_kskp_2020(:ida, :idb, :ksg, :cl_cnt));

        if (kskp is null) then kskp = 1;

        if (fine_koef_set_doctor = 0) then
          fine_koef = (select FINE_KOEF from sp_calc_stac_fine_2020(:ida, :idb, :ksg, :cl_cnt));

        if (is_round_janao = 1) then
          sum_uslf = cast(cast(tarif * kskp as int) * fine_koef as int);
        else
          sum_uslf = cast(tarif * kskp as numeric(15,2)) * fine_koef;

        if (:ksg is not null) then
        begin
            update zsd b set
             b.ksg_base = :ksg,
             b.tar_base = iif(:is_round_janao = 1, cast(:tarif*coalesce(:kskp,1) as int), iif(:okato = '29000', :tarif, cast(:tarif*coalesce(:kskp,1) as numeric(15,2)))),
             b.sum_base = :sum_uslf,
             b.kskp_base = :kskp,
             b.koef_z = :kz, 
             b.koef_d = :kd,
             b.koef_u = :kus,
             b.bs = :bs,
             b.koef_up = :k_down,
             b.reab = iif(:prof_num = 37,1,null),
             b.fine_koef = :fine_koef,
             b.dop_code_usl = iif(:okato = '70000', :dop_code, b.dop_code_usl)
             where b.id = :idb;
         end
      end 
--------------------------------------------------------------------------------
      --    6  + 
      if (q_u = 1) then
       if (exists (select 1 from zsd b where b.zs_id = :ida and ((b.ksg in ('st02.001') and b.k_uslf >= 6) or (b.ksg in ('O14.1','O34.2','O36.3','O36.4','O42.2') and b.k_uslf >= 2) ))
          and exists (select 1 from zsd b where b.zs_id = :ida and b.ksg in ('st02.003', 'st02.004'))) then
          begin
            --    ,     
            select first 1 b.ksg_base, b.ds
            from zs a
             join zsd b on a.id = b.zs_id
             where b.zs_id = :ida and b.ksg in ('st02.003', 'st02.004')
             into :ksg, :ds;
       
            update zsd d
            set d.tar_usl = d.tar_base,
                d.sum_uslf = d.sum_base,
                d.ksg = d.ksg_base,
                d.kskp = d.kskp_base
            where d.zs_id = :ida;

            --   
            select coalesce(sum(b.sum_uslf), 0) from zsd b where b.zs_id = :ida
             into :sum_uslf;
    
            update zs a set
             a.tar_usl = :tarif,
             a.sum_uslf = :sum_uslf,
             a.sum_usl = :sum_uslf,
             a.ksg = :ksg,
             a.ds1 = :ds,
             a.kslp = :kskp
             where a.id = :ida;

            exit;
          end
--------------------------------------------------------------------------------
      if ((is_transfer < 2) or (cl_cnt < 2))  then  --   
      begin
        --     2- ,   2
        --  ,    ,    
        --  ,    ()
        --     
        if ((exists(select first 1 1 from zsd d where d.zs_id = :ida and ((:q_u = 1 and d.ksg_base starting 'st37') or
                                                                                                  (:q_u = 3 and d.ksg_base starting 'ds37'))))
            or (exists(select first 1 1 from zsd d where d.zs_id = :ida and d.ksg_base in ('st36.009','st36.010','st36.011') and d.profil_k in (10,11) ))
            or (exists(select first 1 1 from zsd d where d.zs_id = :ida and d.ksg_base in ('st19.038','ds19.028')))
            or (((select count(d.id) from zsd d where d.zs_id = :ida and d.ksg_base is not null and d.profil_k = 42) >= 2) and
                 ((select count(u.id) from zsd d join onk_usl u on u.zsd_id = d.id where d.zs_id = :ida and u.usl_tip = 1) >= 2)))   then
            update zsd b set
                 b.ksg = b.ksg_base,
                 b.sum_uslf = b.sum_base,
                 b.tar_usl = b.tar_base,
                 b.kskp = b.kskp_base
            where b.zs_id = :ida and b.ksg_base is not null;
        else
        --     
        begin
          select first 1 id
           from zsd d
           where d.zs_id = :ida and d.ksg_base is not null
           order by d.koef_z desc
           into :idb;

          update zsd b set
             b.ksg = b.ksg_base,
             b.sum_uslf = b.sum_base,
             b.tar_usl = b.tar_base,
             b.kskp = b.kskp_base
           where b.id = :idb;

          update zsd b set
             b.ksg = null,
             b.sum_uslf = 0,
             b.kskp = 1,
             b.tar_usl = 0
            where b.id <> :idb and b.zs_id = :ida;
        end
      end else
      begin
        for select b.ds_class
         from zsd b
         where b.zs_id = :ida
         group by 1
         into :ds_class
         do
         begin
             select first 1 id
               from zsd d
               where d.zs_id = :ida and d.ksg_base is not null and d.ds_class = :ds_class
               order by d.koef_z desc
               into :idb;
    
             update zsd b set
                 b.ksg = b.ksg_base,
                 b.sum_uslf = b.sum_base,
                 b.tar_usl = b.tar_base,
                 b.kskp = b.kskp_base
               where b.id = :idb;

             update zsd b set
              b.ksg = null,
              b.sum_uslf = 0,
              b.kskp = 1,
              b.tar_usl = 0
              where b.id <> :idb and b.zs_id = :ida and b.ds_class = :ds_class;
         end
       end

        select first 1 b.ksg_base
        from zs a
         join zsd b on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null
         order by b.sum_base desc
         into :ksg;
   
        select coalesce(sum(b.sum_uslf), 0), coalesce(sum(b.tar_base), 0)
         from zsd b
         join zs a on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null
         into :sum_uslf, :tarif;

        update zs a set
         a.tar_usl = :tarif,
         a.sum_uslf = :sum_uslf,
         a.sum_usl = :sum_uslf,
         a.ksg = :ksg,
         a.kslp = :kskp
         where a.id = :ida;
end;

/* empty dependent procedure body */
/* Clear: SP_CALC_STAC_2020 for: SP_KSG_GET_2020 */
ALTER PROCEDURE SP_CALC_STAC_2020(IDA INTEGER)
 AS
 BEGIN EXIT; END;

/* Alter (SP_KSG_GET_2020) */
ALTER PROCEDURE SP_KSG_GET_2020(IDB INTEGER = null)
 RETURNS(KSG DM_CHAR_20,
ERR_CODE INTEGER)
 AS
declare variable KSG_SURG DM_CHAR_20;
declare variable IDA integer;
declare variable DS1 DM_DS;
declare variable DATE_1 DM_DATE;
declare variable DATE_2 DM_DATE;
declare variable NMS_CODE DM_NMS_CODE;
declare variable DAY_CNT DM_INT;
declare variable SEX DM_SEX;
declare variable DOP_CRITERION DM_CHAR_10;
declare variable RANGE_FR DM_CHAR_10;
declare variable DR DM_DATE;
declare variable DS2 DM_DS;
declare variable DS3 DM_DS;
declare variable Q_U DM_INT;
declare variable DS_CLASS DM_CHAR_10;
declare variable DAYS DM_INT;
declare variable RC DM_INT;
declare variable DS_TMP DM_DS;
declare variable AGE DM_NUM_6_2;
declare variable TMP_GRP_ID DM_INT;
declare variable DOP_CRITERIAN_TMP DM_CHAR_10;
declare variable KSG_TER DM_CHAR_20;
begin
     ksg = null;
     err_code = null;
     tmp_grp_id = gen_id(GEN_KSG_TMP_GROUP_ID, 1);
     ida = (select first 1 d.zs_id from zsd d where d.id = :idb);
------------------------------------------------------------------------------------------------------------------------
-- 1
     select d.date_1, d.date_2, d.ds, d.code_usl, p.sex, d.ksg_criterion, d.ksg_criterion2, p.dr, z.q_u, d.ds_class,
            d.ds2, d.ds3, z.age
     from zsd d
          join zs z on d.zs_id = z.id
          join patients p on p.id = z.patient_id
     where d.id = :idb
     into :date_1, :date_2, :ds1, :nms_code, :sex, :dop_criterion, :range_fr, :dr, :q_u, :ds_class, :ds2, :ds3, :age;

     day_cnt = (select sum(coalesce(b1.k_uslf,0)) from ZSD b1 where b1.ZS_ID = :ida and b1.ds_class = :ds_class and b1.id = b1.zsd_id);

     days = case
              when :day_cnt <= 3 then 1
              else null
            end;

     --- 
     if (:nms_code in ('A25.20.004.001', 'A11.20.019', 'A11.20.028', 'A11.20.031', 'A11.20.017.001', 'A11.20.030.001', 'A11.20.017.081','A11.20.017.082','A11.20.017.083',
                       'A11.20.507', 'A11.20.508', 'A11.20.509','A11.20.030.001.01')) then
       nms_code = 'A11.20.017';
-----------------------------------------------------------------------------------------------------------------------
     --       ()
      select
           case
             when t1.ao_code = 'T7' then 'st29.007'
             when (t1.ao_code between 'T1' and 'T6') and (t2.ao_code between 'T1' and 'T6') and (t1.ao_code <> t2.ao_code) then 'st29.007'
             else null
           end
      from zs_ds d
      left join h_tarif_polytrauma t1 on t1.ds = d.ds and :date_2 between t1.bp and t1.epv
      left join h_tarif_polytrauma t2 on t2.ds = d.ds and :date_2 between t2.bp and t2.epv
      where d.section = 1 and d.section_id = :ida and d.ds in ('J94.2','J94.8','J94.9','J93','J93.0','J93.1','J93.8','J93.9', 'J96.0', 'N17', 'T79.4', 'R57.1', 'R57.8')
      into :ksg;

     if (ksg is not null) then
     begin
       suspend;
       exit;
     end
--------------------------------------------------------------------------------

     if (:nms_code starting 'A18') then --
     begin
       ksg = null;
       exit;
     end

--------------------------------------------------------------------------------
-- 2  3
     insert into KSG_TMP (ID, KSG, NMS_CODE, KZ, AGE_GRP, DAYS, SEX, DS, DOP_CRITERIAN, dop_criterian2, ds2,  ds3, step_num, group_code)
      select h.id, h.ksg, h.nms_code, k.kz, h.age_grp, h.days, h.sex, h.ds, h.dop_criterion, h.dop_criterion2,
             h.ds2, h.ds3, 0, :tmp_grp_id
       from ksg_grp h
       join h_ksg k on k.ksg = h.ksg and :date_2 between k.bp and k.epv
       where ((h.ds = :ds1) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds, :ds1)) = 1) or (h.ds is null) )     --a
             and ((h.ds2 = :ds2) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds2, :ds2)) = 1) or (h.ds2 is null) ) --b
             and ((h.ds3 = :ds3) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds3, :ds3)) = 1) or (h.ds3 is null) ) --c
             and (h.nms_code = :nms_code or (h.nms_code is null)) --d
             and (h.sex = :sex or (h.sex is null) ) -- f
             and (h.days is not distinct from :days or (h.days is null) ) -- g
             and (h.dop_criterion is not distinct from :dop_criterion or (h.dop_criterion is null) ) --h
             and (h.dop_criterion2 is not distinct from :range_fr or (h.dop_criterion2 is null) ) -- i
             and :date_2 between h.bp and h.epv
             and h.q_u = k.q_u and h.q_u = :q_u;

     --d
     for select d.code_usl
         from zsd d
         where d.zs_id = :ida and d.zsd_id = :idb and d.id <> :idb
         into :nms_code
         do
           insert into KSG_TMP (ID, KSG, NMS_CODE, KZ, AGE_GRP, DAYS, SEX, DS, DOP_CRITERIAN, dop_criterian2, ds2,  ds3, step_num, group_code)
              select h.id, h.ksg, h.nms_code, k.kz, h.age_grp, h.days, h.sex, h.ds, h.dop_criterion, h.dop_criterion2,
                     h.ds2, h.ds3, 0, :tmp_grp_id
               from ksg_grp h
               join h_ksg k on k.ksg = h.ksg and :date_2 between k.bp and k.epv
               where ((h.ds = :ds1) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds, :ds1)) = 1) or (h.ds is null) )     --a
                     and ((h.ds2 = :ds2) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds2, :ds2)) = 1) or (h.ds2 is null) ) --b
                     and ((h.ds3 = :ds3) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds3, :ds3)) = 1) or (h.ds3 is null) ) --c
                     and (h.nms_code = :nms_code) --d
                     and (h.sex = :sex or (h.sex is null) ) -- f
                     and (h.days is not distinct from :days or (h.days is null) ) -- g
                     and (h.dop_criterion is not distinct from :dop_criterion or (h.dop_criterion is null) ) --h
                     and (h.dop_criterion2 is not distinct from :range_fr or (h.dop_criterion2 is null) ) -- i
                     and :date_2 between h.bp and h.epv
                     and h.q_u = k.q_u and h.q_u = :q_u;
     --b
     for select d.ds
         from zs_ds d
         where d.section_id = :idb and d.section = 2 and d.ds_type = 2 and d.ds <> :ds2
         into :ds_tmp
         do
           insert into KSG_TMP (ID, KSG, NMS_CODE, KZ, AGE_GRP, DAYS, SEX, DS, DOP_CRITERIAN, dop_criterian2, ds2,  ds3, step_num, group_code)
              select h.id, h.ksg, h.nms_code, k.kz, h.age_grp, h.days, h.sex, h.ds, h.dop_criterion, h.dop_criterion2,
                     h.ds2, h.ds3, 0, :tmp_grp_id
               from ksg_grp h
               join h_ksg k on k.ksg = h.ksg and :date_2 between k.bp and k.epv
               where ((h.ds = :ds1) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds, :ds1)) = 1) or (h.ds is null) )     --a
                     and ((h.ds2 = :ds_tmp) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds2, :ds_tmp)) = 1)) --b
                     and ((h.ds3 = :ds3) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds3, :ds3)) = 1) or (h.ds3 is null) ) --c
                     and (h.nms_code = :nms_code or (h.nms_code is null)) --d
                     and (h.sex = :sex or (h.sex is null) ) -- f
                     and (h.days is not distinct from :days or (h.days is null) ) -- g
                     and (h.dop_criterion is not distinct from :dop_criterion or (h.dop_criterion is null) ) --h
                     and (h.dop_criterion2 is not distinct from :range_fr or (h.dop_criterion2 is null) ) -- i
                     and :date_2 between h.bp and h.epv
                     and h.q_u = k.q_u and h.q_u = :q_u;

     --c
     for select d.ds
         from zs_ds d
         where d.section_id = :idb and d.section = 2 and d.ds_type = 3 and d.ds <> :ds3
         into :ds_tmp
         do
           insert into KSG_TMP (ID, KSG, NMS_CODE, KZ, AGE_GRP, DAYS, SEX, DS, DOP_CRITERIAN, dop_criterian2, ds2,  ds3, step_num, group_code)
              select h.id, h.ksg, h.nms_code, k.kz, h.age_grp, h.days, h.sex, h.ds, h.dop_criterion, h.dop_criterion2,
                     h.ds2, h.ds3, 0, :tmp_grp_id
               from ksg_grp h
               join h_ksg k on k.ksg = h.ksg and :date_2 between k.bp and k.epv
               where ((h.ds = :ds1) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds, :ds1)) = 1) or (h.ds is null) )     --a
                     and ((h.ds2 = :ds2) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds2, :ds2)) = 1) or (h.ds2 is null) ) --b
                     and ((h.ds3 = :ds_tmp) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds3, :ds_tmp)) = 1)) --c
                     and (h.nms_code = :nms_code or (h.nms_code is null)) --d
                     and (h.sex = :sex or (h.sex is null) ) -- f
                     and (h.days is not distinct from :days or (h.days is null) ) -- g
                     and (h.dop_criterion is not distinct from :dop_criterion or (h.dop_criterion is null) ) --h
                     and (h.dop_criterion2 is not distinct from :range_fr or (h.dop_criterion2 is null) ) -- i
                     and :date_2 between h.bp and h.epv
                     and h.q_u = k.q_u and h.q_u = :q_u;

     --h
     for select c.code
         from zs_crit c
         where c.zsd_id = :idb and c.code <> :dop_criterion and c.code not starting 'fr'
         into :dop_criterian_tmp
         do
           insert into KSG_TMP (ID, KSG, NMS_CODE, KZ, AGE_GRP, DAYS, SEX, DS, DOP_CRITERIAN, dop_criterian2, ds2,  ds3, step_num, group_code)
              select h.id, h.ksg, h.nms_code, k.kz, h.age_grp, h.days, h.sex, h.ds, h.dop_criterion, h.dop_criterion2,
                     h.ds2, h.ds3, 0, :tmp_grp_id
               from ksg_grp h
               join h_ksg k on k.ksg = h.ksg and :date_2 between k.bp and k.epv
               where ((h.ds = :ds1) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds, :ds1)) = 1) or (h.ds is null) )     --a
                     and ((h.ds2 = :ds2) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds2, :ds2)) = 1) or (h.ds2 is null) ) --b
                     and ((h.ds3 = :ds3) or ((select IS_LIKE from SP_CHECK_DS_GRP(h.ds3, :ds3)) = 1) or (h.ds3 is null) ) --c
                     and (h.nms_code = :nms_code or (h.nms_code is null)) --d
                     and (h.sex = :sex or (h.sex is null) ) -- f
                     and (h.days is not distinct from :days or (h.days is null) ) -- g
                     and (h.dop_criterion is not distinct from :dop_criterian_tmp) --h
                     and (h.dop_criterion2 is not distinct from :range_fr or (h.dop_criterion2 is null) ) -- i
                     and :date_2 between h.bp and h.epv
                     and h.q_u = k.q_u and h.q_u = :q_u;

     rc = (select count(*) from ksg_tmp);

     if (rc > 1) then  --   
       if (exists(select first 1 t.id from ksg_tmp t where t.age_grp is not null)) then
       begin
         if ((:date_1 - :dr) <= 28) then
           delete from ksg_tmp t
            where t.age_grp not in (1,4,5) and t.age_grp is not null and t.group_code = :tmp_grp_id;
         else
         if ((:date_1 - :dr) between 29 and 90) then
           delete from ksg_tmp t
            where t.age_grp not in (2,4,5) and t.age_grp is not null and t.group_code = :tmp_grp_id;
         else
         if (((:date_1 - :dr) > 91) and (:age < 1)) then
           delete from ksg_tmp t
            where t.age_grp not in (3,4,5) and t.age_grp is not null and t.group_code = :tmp_grp_id;
         else
         if ((:age < 2) and (:age >=1)) then
           delete from ksg_tmp t
            where t.age_grp not in (4,5) and t.age_grp is not null and t.group_code = :tmp_grp_id;
         else
         if ((:age >= 2) and (:age < 18)) then
           delete from ksg_tmp t
            where t.age_grp not in (5) and t.age_grp is not null and t.group_code = :tmp_grp_id;
         else
         if (:age >= 18) then
           delete from ksg_tmp t
            where t.age_grp not in (6) and t.age_grp is not null and t.group_code = :tmp_grp_id;
       end
--------------------------------------------------------------------------------
-- 4
     update ksg_tmp t
      set t.step_num = 1
      where ((t.dop_criterian in ('rb2','rb3','rb4','rb5','rb6','rbs'))
            or (t.days = 1)
            or ((t.ds in ('L08.0','L26','L27.0','L27.2')) and t.age_grp = 1))
            and t.group_code = :tmp_grp_id;

     for select t.ksg
                from ksg_tmp t
                     join ksg_tmp t2 on t2.id <> t.id
                where t.group_code = :tmp_grp_id and exists(select ch.id from ksg_dont_choice ch where ch.ksg_ter = t.nms_code and ch.ksg_surg = t2.nms_code)
         into :ksg_ter
         do
           update ksg_tmp kt
            set kt.step_num = -1
            where kt.ksg = :ksg_ter;
--------------------------------------------------------------------------------
-- 5
     ksg = (select first 1 t.ksg from KSG_TMP t where t.group_code=:tmp_grp_id
                 order by t.step_num desc, t.kz desc);

     if (ksg is null and err_code is null and ((select first 1 id from h_tarif_dializ d where :date_2 between d.bp and d.epv and d.code_usl = :nms_code) is null)) then
      err_code = 1;

     delete from KSG_TMP t
      where t.group_code = :tmp_grp_id;

     if (err_code is not null) then
         update zsd d
         set d.comment_local = (select name from h_errors where ID = :err_code)
         where d.id = :idb;

     suspend;
end;

/* Restore proc. body: SP_CALC_ALL */
ALTER PROCEDURE SP_CALC_ALL(ZS_ID INTEGER)
 AS
declare variable TAR DM_MONEY_15_2;
declare variable DATE1 DM_DATE;
declare variable Q_U integer;
declare variable TAR_USL DM_MONEY_15_2;
declare variable TARGET integer;
declare variable IDB integer;
declare variable SUM_USLF DM_MONEY_15_2;
declare variable SEX char(1);
declare variable PTYPE integer;
declare variable AGE_Y integer;
declare variable AGE_GRP integer;
declare variable HDR_ID integer;
declare variable TROMB_CODE DM_CHAR_20;
declare variable TAR_USL_DOP DM_MONEY_15_2;
declare variable SUM_USLF_DOP DM_MONEY_15_2;
declare variable IDSP integer;
declare variable MMB DM_NUM_3_2;
declare variable OKATO DM_OKATO;
declare variable P_CEL DM_CHAR_10;
declare variable CODE_USL DM_CHAR_20;
begin
  select z.date_2, z.q_u, z.target, p.sex, z.payment_type_id, extract(year from z.date_2) - extract(year from p.dr), z.hdr_id, iif(coalesce(z.vbr,0) = 0, 1, 1.2),
         z.idsp
  from zs z
  join patients p on p.id = z.patient_id
  where z.id = :zs_id
  into :date1, :q_u, :target, :sex, :ptype, :age_y, :hdr_id, :mmb, :idsp;

  if (:date1 is null) then
    date1 = current_date;

  update zs z
    set z.os_sluch = null
    where z.id = :zs_id;

  if (:mmb = 1) then
  begin
   mmb = iif((select first 1 z.id
           from zs z
                join kalendar k on k.k_day = z.date_1
           where z.id = :zs_id  and z.disp_stage = 1 and z.target in (9,10,13,17,16) and z.date_1 = z.date_2
                 and k.day_type in (1,2)) is null, 1, 1.2);
   if (:mmb > 1) then
    update zs z
    set z.os_sluch = 6
    where z.id = :zs_id;
  end

  okato = (select first 1 c.tf_okato from contragents c where c.type_id = 1);

  if (:okato is null) then okato = '71140';

  if (:ptype in (2,3)) then exit;

  if (:target in (9,10,11,12,13,14,15,16,17)) then
  begin
   if ((select coalesce(t.days_cnt,0) from h_target t where t.id = :target) <> 0) then
   begin
    update zsd d
     set d.zachet = 1
     where d.date_1 < (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;

    update zsd d
     set d.zachet = 0
     where d.date_1 >= (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;
   end

   update zsd d
    set d.k_uslf = 0
    where (d.zachet = 1 or d.is_no_get_usl = 1 or d.zachet_stac = 1) and d.zs_id = :zs_id;
  end

  update zsd d
    set d.tar_usl = null,
        d.sum_uslf = null,
        d.comment_local = null,
        d.dop_tarif = null,
        d.dop_sum = null
    where d.zs_id = :zs_id;

  update zs z
    set z.tar_usl = null,
        z.sum_usl = null,
        z.sum_uslf = null
    where z.id = :zs_id;

  if ((select coalesce(i.is_nz,0) from invoice i join zs_hdr h on h.name = i.id where h.id = :hdr_id) = 1) then
  begin
    if (target in (9,10,11,13,14,15,16,17)) then exit;

    tar = (select first 1 s.tarif from h_tarif_nz s where s.q_u = iif(:q_u = 4,2,:q_u) and :date1 between s.bp and s.epv);

    if (q_u = 1) then
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id and d.code_usl is null;
    else
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id;

    if (q_u = 4) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = z.dcount*:tar
      where id = :zs_id;
    else
    if (q_u = 1) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = :tar
      where id = :zs_id;
    else
      update zs z
      set z.tar_usl = :tar,
          z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
      where id = :zs_id;
    exit;
  end
   /********************,    ************************/
  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 < '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin

          select first 1 h.tarif, h.tarif
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
                                 and cast(h.code_spec as varchar(10)) = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec = '16' and a.age < 18, '22', b.code_spec), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf;

          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0)
           where b.id = :idb;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end

  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 >= '01.01.2018') and (:date1 < '01.01.2020')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (:tar is null) then
          select first 1 h.tarif, h.tarif, a.idsp
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           left join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
                                 and h.idsp = a.idsp
           join h_tarif_app_spec n on n.name_id = h.name_id
                                 and n.code_spec_v021 = iif(b.code_spec_v021 = 39 and a.age < 18, 49, b.code_spec_v021)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf, :idsp;

          if (:okato = '71140') then
          update ZSD b set
           b.tar_usl = iif(:idsp = 30, 0, coalesce(:tar, 0)),
           b.sum_uslf = cast(iif(:idsp = 30, 0, coalesce(:sum_uslf, 0))*:mmb as int),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;
          else
           update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          if (:idsp <> 30) then
          begin
            tar = null;
            sum_uslf = null;
          end
        end

     if ((:idsp = 30) and (:okato = '71140')) then
       update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = cast(coalesce(:sum_uslf, 0)*:mmb as int)
           where b.id = :idb;

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce((select sum(d.tar_usl) from zsd d where d.zs_id = a.id), 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end  
  -----------------------------------------------------------------------------------------------------
  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17) and (:date1 >= '01.01.2020')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf, b.code_usl
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf, :code_usl;

         if (okato = '28000') then         -- .     
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf, b.code_usl
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.vid_vme,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf, :code_usl;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (:tar is null) then
          select first 1 h.tarif, h.tarif, b.p_cel
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           left join h_tarif_app h on a.date_2 between h.bp and h.epv
                                 and (h.target = iif(b.p_cel in ('1.0','1.2','1.3','2.3','2.5','2.6','3.1') , 0, iif(b.p_cel = '1.1', 1, iif(b.p_cel = '3.0',2,-1))))
           join h_tarif_app_spec n on n.name_id = h.name_id
                                 and n.code_spec_v021 = iif(b.code_spec_v021 = 39 and a.age < 18, 49, b.code_spec_v021)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf, :p_cel;

          if (:okato = '71140') then
          update ZSD b set
           b.tar_usl = iif((:p_cel = '3.0' and (:idsp<>28)) or ((:idsp = 28) and (:code_usl not starting 'A04') and (:code_usl not starting 'A08')) , 0, coalesce(:tar, 0)),
           b.sum_uslf = cast(iif((:p_cel = '3.0' and (:idsp<>28)) or ((:idsp = 28) and (:code_usl not starting 'A04') and (:code_usl not starting 'A08')), 0, coalesce(:sum_uslf, 0))*:mmb as int),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;
          else
           update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          if (:p_cel <> '3.0') then

          begin
            tar = null;
            sum_uslf = null;
          end
        end

     if (((:p_cel = '3.0' and (:idsp<>28)) or ((:idsp = 28) and (:code_usl not starting 'A04') and (:code_usl not starting 'A08'))) and (:okato = '71140')) then
     begin
       update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = cast(coalesce(:sum_uslf, 0)*:mmb as int)
           where b.id = :idb;
     end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce((select sum(d.tar_usl) from zsd d where d.zs_id = a.id), 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;

     if (coalesce((select z.set_usl_auto from zs z where z.id = :zs_id),0) = 1) then
       execute procedure SP_SET_USL_ZSD(:ZS_ID);
    exit;
  end  

  /********************************************/
  if (:q_u = 4) then
  begin
    tar = (select s.tarif from h_tarif_stom s where :date1 between s.bp and s.epv);

    update zsd d
    set d.tar_usl = :tar,
        d.sum_uslf = cast(d.k_uslf*:tar*:mmb as numeric(15,2))
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = :tar,
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if (:q_u = 5) then
  begin
--    if (:date1 >= '01.01.2018') then tromb_code = 'A25.30.036';
--    else tromb_code = 'A25.30.035';
    tromb_code = coalesce((select first 1 code_usl from zsd d where d.zs_id = :zs_id and coalesce(code_usl, '') <> ''),'');

    tar = (select s.tarif from h_tarif_smp s where :date1 between s.bp and s.epv);
    tar_usl = coalesce((select coalesce(u.sumf,0) from h_usl u where u.code = :tromb_code
               and u.q_u containing '5' and :date1 between u.datebeg and u.dateend),0);

    update zsd d
    set d.tar_usl = iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl),
        d.sum_uslf = d.k_uslf*iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl)
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = (select max(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if ((:q_u = 1) and ((select 1 from zs z where coalesce(z.metod_hmp,0) > 0 and id = :zs_id) = 1)) then
  begin
    select first 1 v.tarif
    from zs z
         join h_metod_hmp h on h.code = z.metod_hmp and z.date_2 between h.bp and h.epv
         join h_tarif_vmp v on v.tg = h.tg and z.date_2 between v.bp and v.epv
    where z.id = :zs_id
    into :tar;

    update zs a set
        a.tar_usl = :tar,
        a.sum_uslf = :tar,
        a.ksg = null,
        a.kslp = null
    where a.id = :zs_id;

    update zsd b set
          b.ksg = null,
          b.sum_uslf = :tar,
          b.kskp = 0,
          b.tar_usl = :tar
    where b.zs_id = :zs_id and coalesce(b.code_usl,'') = '' and b.date_1 = (select min(date_1) from zsd where zs_id = :zs_id and coalesce(code_usl,'') = '');

    exit;
  end

  /********************************************/
  if (:q_u in (1,3) and :date1 < '01.01.2018') then
    execute procedure SP_CALC_STAC(:zs_id);
  else
    if (:q_u in (1,3) and :date1 < '01.01.2020') then
      execute procedure sp_calc_stac_2018(:zs_id);
  else
    if (:q_u in (1,3) and :date1 >= '01.01.2020') then
      execute procedure sp_calc_stac_2020(:zs_id);

  /****************  ***********************************************/
  if (q_u <> 4) then
  begin
  tar = null;
  sum_uslf = null;
  for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (coalesce(:tar,0) > 0) then
          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          tar = null;
          sum_uslf = null;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);
     tar = (select sum(b.tar_usl) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_tarif,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:tar, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
   end

  /*********************-*********************************/
 /*$$IBEC$$  if ((:q_u = 2) and (:target in (21,22))) then
  begin
   for select b.id
    from zsd b
    join zs z on z.id = b.zs_id
    where z.id = :zs_id
    into :idb
    do
    begin
      tar = (select first 1 t.tarif
             from zsd d
                  join h_tomo_code c on c.nms_code = d.code_usl
                  join h_tarif_tomo t on t.group_num = c.group_num and d.date_2 between t.bp and t.epv
             where d.id = :idb);

      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf = :tar
      where d.id = :idb;
    end

    update zs z
    set z.tar_usl = (select sum(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;

    exit;
  end $$IBEC$$*/
  /******************** - 9  ************************/
  if ((:q_u = 2 and :target = 9) or (q_u = 2 and :target = 16 and date1 >= '01.05.2019'))  then
  begin
    execute procedure sp_calc_app_t09(:zs_id);
    exit;
  end

  /******************** - 10,17  -  ************************/
    if (q_u = 2 and target in (10,17)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_10 d on d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and :age_y between d.y1 and d.y2
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = cast(coalesce(b.k_uslf * :tar, 0)*:mmb as int),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(tar_usl) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 13  ************************/
    if (q_u = 2 and target = 13) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select first 1 d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                           and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_13_17 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.age_grp = a.age_grp
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = cast(coalesce(b.k_uslf * :tar, 0)*:mmb as int),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(tar_usl) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 14,15  ,  ************************/
    if (q_u = 2 and target in (14,15)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_14_15 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.cat_info = a.cat_info
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = cast(coalesce(b.k_uslf * :tar, 0)*:mmb as int),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(tar_usl) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
  /******************** - 16  ************************/
    if (q_u = 2 and target = 16 and date1 < '01.05.2019') then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join zs_hdr h on h.id = a.hdr_id
                   join patients p on p.id = a.patient_id
                   join h_tarif_disp_16 d on a.date_2 between d.bp and d.epv
                                          and d.sex = :sex
                                          and cast(d.code_usl as varchar(20)) = b.code_usl
                                          and d.age_l <= (h.y - extract(year from p.dr)) and d.age_r >= (h.y - extract(year from p.dr))
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = cast(coalesce(b.k_uslf * :tar, 0)*:mmb as int),
               b.tar_base = coalesce(:tar, 0) ,
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
end;

/* Restore proc. body: SP_CALC_STAC_2020 */
ALTER PROCEDURE SP_CALC_STAC_2020(IDA INTEGER)
 AS
declare variable KSG type of DM_CHAR_50;
declare variable DS type of DM_DS;
declare variable IDB integer;
declare variable SUM_USLF type of DM_MONEY;
declare variable KSKP numeric(6,6);
declare variable Q_U integer;
declare variable FINE_KOEF type of DM_NUM_3_2;
declare variable TARIF numeric(10,6);
declare variable IS_TRANSFER DM_INT;
declare variable CL_CNT integer;
declare variable ERR_CODE integer;
declare variable K_DOWN DM_NUM_6_2;
declare variable DS_CLASS DM_CHAR_10;
declare variable KZ DM_NUM_2_5;
declare variable KD DM_NUM_2_5;
declare variable KUS DM_NUM_2_5;
declare variable BS DM_NUM_6_2;
declare variable PROF_NUM integer;
declare variable FINE_KOEF_SET_DOCTOR DM_BOOLEAN;
declare variable IS_ROUND_JANAO integer;
declare variable OKATO DM_OKATO;
declare variable DOP_CODE DM_CHAR_40;
declare variable DATE1 DM_DATE;
declare variable DATE2 DM_DATE;
declare variable KSG_SET_DOCTOR integer;
begin
  okato = (select first 1 c.tf_okato from contragents c where c.type_id = 1);

  if (okato <> '40000') then
  select c.tf_okato
   from zs_hdr h
        join zs z on z.hdr_id = h.id
        join invoice i on i.id = h.name
        join contragents c on c.id = i.contragent_id
   where z.id = :ida
   into :okato;

   -----------------------------------------------------------------------------
   --    
   for select d.id, d.date_1, d.date_2
          from zs z
               join zsd d on d.zs_id = z.id
          where z.id = :ida and (not exists(select dd.id from zsd dd where dd.zs_id = :ida
                                                                     and dd.date_1 <=d.date_1 and dd.date_2 >= d.date_2 and dd.id <> d.id) )
          order by d.ksg desc
          into :idb, :date1, :date2
          do
          begin
            update zsd d
             set d.zsd_id = :idb
             where d.id = :idb;
    
            update zsd d
             set d.zsd_id = :idb
             where d.zs_id = :ida and coalesce(d.code_usl,'') <> ''
                   and d.date_1 between :date1 and :date2
                   and not exists(select id from zsd d2 where d2.zs_id = :ida and d2.date_1 = d.date_1 and d2.id <> :idb and d2.id <> d.id);
          end
   -----------------------------------------------------------------------------
   if (:okato is  null) then
     okato = (select first 1 c.tf_okato from contragents c where c.type_id = 1);

    if (okato = '71140') then
      is_round_janao = 1;

    update zsd d
      set d.ds_class = (select MKB_CLASS from SP_GET_MKB_CLASS(D.ds))
      where d.zs_id = :ida;

    ksg_set_doctor = (select first 1 coalesce(ksg_set_doctor,0) from zsd where zs_id = :ida order by 1 desc);

    update zsd d
     set d.ksg = null, 
         d.ksg_base = iif(:ksg_set_doctor = 0, null, d.ksg_base),
         d.tar_base = null,
         d.sum_base = null,
         d.kskp_base = null,
         d.sum_uslf = 0,
         d.tar_usl = 0,
         d.comment_local = null
     where d.zs_id = :ida;

    update zs z
     set z.ksg = null,
         z.tar_usl = 0,
         z.sum_usl = 0
     where z.id = :ida;

     cl_cnt = (select count(distinct b.ds_class) from ZSD b where b.ZS_ID = :ida and b.zsd_id = b.id);
     is_transfer = (select count(b.id) from ZSD b where b.ZS_ID = :ida and b.zsd_id = b.id);
     delete from kslp_koef where zs_id = :ida ;

     select a.q_u, a.date_2, coalesce(a.fine_koef_set_doctor,0)
      from zs a
      where a.id = :ida
      into :q_u, :date2, :fine_koef_set_doctor;

     for select sp.KSG, sp.ERR_CODE, b.ds, b.id, coalesce(bs.tarif * kd.kd * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0),
                k.kz, kd.kd,
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0),
                bs.tarif, k.k_down, k.prof_num, b.date_1, coalesce(b.fine_koef,1), b.ksg_set_doctor
      from zs a
      join zsd b on a.id = b.zs_id
      join patients p on p.id = a.patient_id
      join lpu_factors lf on lf.q_u = a.q_u and a.date_2 between lf.bp and lf.epv and lf.okato is not distinct from :okato
      join h_tarif_bs bs on bs.q_u = a.q_u and a.date_2 between bs.bp and bs.epv and bs.okato is not distinct from :okato
      join h_tarif_kd kd on a.date_2 between kd.bp and kd.epv and kd.okato is not distinct from :okato
      left join sp_ksg_get_2020(b.id) sp on 1=1
      left join h_ksg k on k.ksg = iif(:ksg_set_doctor = 1, b.ksg_base, sp.ksg) and a.date_2 between k.bp and k.epv and k.q_u = a.q_u
      where b.zs_id = :ida and b.id = b.zsd_id
      order by b.code_usl
      into :ksg, :err_code, :ds, :idb, :tarif, :kz, :kd, :kus, :bs, :k_down, :prof_num, :date1, :fine_koef, :ksg_set_doctor
      do
      begin
        kskp = 1;

        if (coalesce(:ksg_set_doctor,0) = 1) then
          ksg = (select ksg_base from zsd where id = :idb);

        if (:okato = '70000') then
        begin
          select first 1 u.code_1, u.code_2
           from zsd d
                join h_usl u on u.code = d.code_usl and u.payment_type_id = 1 and :date1 between u.datebeg and u.dateend and u.q_u containing :q_u
           where d.id = :idb
          into :ksg, :dop_code;
        end

        if ((q_u in (1,3)) and (err_code is null)) then
          kskp = (select KSKP from sp_calc_stac_kskp_2020(:ida, :idb, :ksg, :cl_cnt));

        if (kskp is null) then kskp = 1;

        if (fine_koef_set_doctor = 0) then
          fine_koef = (select FINE_KOEF from sp_calc_stac_fine_2020(:ida, :idb, :ksg, :cl_cnt));

        if (is_round_janao = 1) then
          sum_uslf = cast(cast(tarif * kskp as int) * fine_koef as int);
        else
          sum_uslf = cast(tarif * kskp as numeric(15,2)) * fine_koef;

        if (:ksg is not null) then
        begin
            update zsd b set
             b.ksg_base = :ksg,
             b.tar_base = iif(:is_round_janao = 1, cast(:tarif*coalesce(:kskp,1) as int), iif(:okato = '29000', :tarif, cast(:tarif*coalesce(:kskp,1) as numeric(15,2)))),
             b.sum_base = :sum_uslf,
             b.kskp_base = :kskp,
             b.koef_z = :kz, 
             b.koef_d = :kd,
             b.koef_u = :kus,
             b.bs = :bs,
             b.koef_up = :k_down,
             b.reab = iif(:prof_num = 37,1,null),
             b.fine_koef = :fine_koef,
             b.dop_code_usl = iif(:okato = '70000', :dop_code, b.dop_code_usl)
             where b.id = :idb;
         end
      end 
--------------------------------------------------------------------------------
      --    6  + 
      if (q_u = 1) then
       if (exists (select 1 from zsd b where b.zs_id = :ida and ((b.ksg in ('st02.001') and b.k_uslf >= 6) or (b.ksg in ('O14.1','O34.2','O36.3','O36.4','O42.2') and b.k_uslf >= 2) ))
          and exists (select 1 from zsd b where b.zs_id = :ida and b.ksg in ('st02.003', 'st02.004'))) then
          begin
            --    ,     
            select first 1 b.ksg_base, b.ds
            from zs a
             join zsd b on a.id = b.zs_id
             where b.zs_id = :ida and b.ksg in ('st02.003', 'st02.004')
             into :ksg, :ds;
       
            update zsd d
            set d.tar_usl = d.tar_base,
                d.sum_uslf = d.sum_base,
                d.ksg = d.ksg_base,
                d.kskp = d.kskp_base
            where d.zs_id = :ida;

            --   
            select coalesce(sum(b.sum_uslf), 0) from zsd b where b.zs_id = :ida
             into :sum_uslf;
    
            update zs a set
             a.tar_usl = :tarif,
             a.sum_uslf = :sum_uslf,
             a.sum_usl = :sum_uslf,
             a.ksg = :ksg,
             a.ds1 = :ds,
             a.kslp = :kskp
             where a.id = :ida;

            exit;
          end
--------------------------------------------------------------------------------
      if ((is_transfer < 2) or (cl_cnt < 2))  then  --   
      begin
        --     2- ,   2
        --  ,    ,    
        --  ,    ()
        --     
        if ((exists(select first 1 1 from zsd d where d.zs_id = :ida and ((:q_u = 1 and d.ksg_base starting 'st37') or
                                                                                                  (:q_u = 3 and d.ksg_base starting 'ds37'))))
            or (exists(select first 1 1 from zsd d where d.zs_id = :ida and d.ksg_base in ('st36.009','st36.010','st36.011') and d.profil_k in (10,11) ))
            or (exists(select first 1 1 from zsd d where d.zs_id = :ida and d.ksg_base in ('st19.038','ds19.028')))
            or (((select count(d.id) from zsd d where d.zs_id = :ida and d.ksg_base is not null and d.profil_k = 42) >= 2) and
                 ((select count(u.id) from zsd d join onk_usl u on u.zsd_id = d.id where d.zs_id = :ida and u.usl_tip = 1) >= 2)))   then
            update zsd b set
                 b.ksg = b.ksg_base,
                 b.sum_uslf = b.sum_base,
                 b.tar_usl = b.tar_base,
                 b.kskp = b.kskp_base
            where b.zs_id = :ida and b.ksg_base is not null;
        else
        --     
        begin
          select first 1 id
           from zsd d
           where d.zs_id = :ida and d.ksg_base is not null
           order by d.koef_z desc
           into :idb;

          update zsd b set
             b.ksg = b.ksg_base,
             b.sum_uslf = b.sum_base,
             b.tar_usl = b.tar_base,
             b.kskp = b.kskp_base
           where b.id = :idb;

          update zsd b set
             b.ksg = null,
             b.sum_uslf = 0,
             b.kskp = 1,
             b.tar_usl = 0
            where b.id <> :idb and b.zs_id = :ida;
        end
      end else
      begin
        for select b.ds_class
         from zsd b
         where b.zs_id = :ida
         group by 1
         into :ds_class
         do
         begin
             select first 1 id
               from zsd d
               where d.zs_id = :ida and d.ksg_base is not null and d.ds_class = :ds_class
               order by d.koef_z desc
               into :idb;
    
             update zsd b set
                 b.ksg = b.ksg_base,
                 b.sum_uslf = b.sum_base,
                 b.tar_usl = b.tar_base,
                 b.kskp = b.kskp_base
               where b.id = :idb;

             update zsd b set
              b.ksg = null,
              b.sum_uslf = 0,
              b.kskp = 1,
              b.tar_usl = 0
              where b.id <> :idb and b.zs_id = :ida and b.ds_class = :ds_class;
         end
       end

        select first 1 b.ksg_base
        from zs a
         join zsd b on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null
         order by b.sum_base desc
         into :ksg;
   
        select coalesce(sum(b.sum_uslf), 0), coalesce(sum(b.tar_base), 0)
         from zsd b
         join zs a on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null
         into :sum_uslf, :tarif;

        update zs a set
         a.tar_usl = :tarif,
         a.sum_uslf = :sum_uslf,
         a.sum_usl = :sum_uslf,
         a.ksg = :ksg,
         a.kslp = :kskp
         where a.id = :ida;
end;

/* Alter Procedure... */
/* empty dependent procedure body */
/* Clear: SP_CALC_ALL_CH for: SP_CALC_ALL */
ALTER PROCEDURE SP_CALC_ALL_CH(HDR_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* empty dependent procedure body */
/* Clear: SP_ZS_SET_ZACHET for: SP_CALC_ALL */
ALTER PROCEDURE SP_ZS_SET_ZACHET(HDR_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* empty dependent procedure body */
/* Clear: SP_ZSD_LIST_CREATE for: SP_CALC_ALL */
ALTER PROCEDURE SP_ZSD_LIST_CREATE(ZS_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* Alter (SP_CALC_ALL) */
ALTER PROCEDURE SP_CALC_ALL(ZS_ID INTEGER)
 AS
declare variable TAR DM_MONEY_15_2;
declare variable DATE1 DM_DATE;
declare variable Q_U integer;
declare variable TAR_USL DM_MONEY_15_2;
declare variable TARGET integer;
declare variable IDB integer;
declare variable SUM_USLF DM_MONEY_15_2;
declare variable SEX char(1);
declare variable PTYPE integer;
declare variable AGE_Y integer;
declare variable AGE_GRP integer;
declare variable HDR_ID integer;
declare variable TROMB_CODE DM_CHAR_20;
declare variable TAR_USL_DOP DM_MONEY_15_2;
declare variable SUM_USLF_DOP DM_MONEY_15_2;
declare variable IDSP integer;
declare variable MMB DM_NUM_3_2;
declare variable OKATO DM_OKATO;
declare variable P_CEL DM_CHAR_10;
declare variable CODE_USL DM_CHAR_20;
begin
  select z.date_2, z.q_u, z.target, p.sex, z.payment_type_id, extract(year from z.date_2) - extract(year from p.dr), z.hdr_id, iif(coalesce(z.vbr,0) = 0, 1, 1.2),
         z.idsp
  from zs z
  join patients p on p.id = z.patient_id
  where z.id = :zs_id
  into :date1, :q_u, :target, :sex, :ptype, :age_y, :hdr_id, :mmb, :idsp;

  if (:date1 is null) then
    date1 = current_date;

  update zs z
    set z.os_sluch = null
    where z.id = :zs_id;

  if (:mmb = 1) then
  begin
   mmb = iif((select first 1 z.id
           from zs z
                join kalendar k on k.k_day = z.date_1
           where z.id = :zs_id  and z.disp_stage = 1 and z.target in (9,10,13,17,16) and z.date_1 = z.date_2
                 and k.day_type in (1,2)) is null, 1, 1.2);
   if (:mmb > 1) then
    update zs z
    set z.os_sluch = 6
    where z.id = :zs_id;
  end

  okato = (select first 1 c.tf_okato from contragents c where c.type_id = 1);

  if (:okato is null) then okato = '71140';

  if (:ptype in (2,3)) then exit;

  if (:target in (9,10,11,12,13,14,15,16,17)) then
  begin
   if ((select coalesce(t.days_cnt,0) from h_target t where t.id = :target) <> 0) then
   begin
    update zsd d
     set d.zachet = 1
     where d.date_1 < (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;

    update zsd d
     set d.zachet = 0
     where d.date_1 >= (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;
   end

   update zsd d
    set d.k_uslf = 0
    where (d.zachet = 1 or d.is_no_get_usl = 1 or d.zachet_stac = 1) and d.zs_id = :zs_id;
  end

  update zsd d
    set d.tar_usl = null,
        d.sum_uslf = null,
        d.comment_local = null,
        d.dop_tarif = null,
        d.dop_sum = null
    where d.zs_id = :zs_id;

  update zs z
    set z.tar_usl = null,
        z.sum_usl = null,
        z.sum_uslf = null
    where z.id = :zs_id;

  if ((select coalesce(i.is_nz,0) from invoice i join zs_hdr h on h.name = i.id where h.id = :hdr_id) = 1) then
  begin
    if (target in (9,10,11,13,14,15,16,17)) then exit;

    tar = (select first 1 s.tarif from h_tarif_nz s where s.q_u = iif(:q_u = 4,2,:q_u) and :date1 between s.bp and s.epv);

    if (q_u = 1) then
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id and d.code_usl is null;
    else
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id;

    if (q_u = 4) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = z.dcount*:tar
      where id = :zs_id;
    else
    if (q_u = 1) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = :tar
      where id = :zs_id;
    else
      update zs z
      set z.tar_usl = :tar,
          z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
      where id = :zs_id;
    exit;
  end
   /********************,    ************************/
  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 < '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin

          select first 1 h.tarif, h.tarif
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
                                 and cast(h.code_spec as varchar(10)) = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec = '16' and a.age < 18, '22', b.code_spec), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf;

          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0)
           where b.id = :idb;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end

  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 >= '01.01.2018') and (:date1 < '01.01.2020')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (:tar is null) then
          select first 1 h.tarif, h.tarif, a.idsp
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           left join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
                                 and h.idsp = a.idsp
           join h_tarif_app_spec n on n.name_id = h.name_id
                                 and n.code_spec_v021 = iif(b.code_spec_v021 = 39 and a.age < 18, 49, b.code_spec_v021)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf, :idsp;

          if (:okato = '71140') then
          update ZSD b set
           b.tar_usl = iif(:idsp = 30, 0, coalesce(:tar, 0)),
           b.sum_uslf = cast(iif(:idsp = 30, 0, coalesce(:sum_uslf, 0))*:mmb as int),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;
          else
           update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          if (:idsp <> 30) then
          begin
            tar = null;
            sum_uslf = null;
          end
        end

     if ((:idsp = 30) and (:okato = '71140')) then
       update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = cast(coalesce(:sum_uslf, 0)*:mmb as int)
           where b.id = :idb;

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce((select sum(d.tar_usl) from zsd d where d.zs_id = a.id), 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end  
  -----------------------------------------------------------------------------------------------------
  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17) and (:date1 >= '01.01.2020')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf, b.code_usl
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf, :code_usl;

         if (okato = '28000') then         -- .     
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf, b.code_usl
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.vid_vme,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf, :code_usl;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (:tar is null) then
          select first 1 h.tarif, h.tarif, b.p_cel
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           left join h_tarif_app h on a.date_2 between h.bp and h.epv
                                 and (h.target = iif(b.p_cel in ('1.0','1.2','1.3','2.3','2.5','2.6','3.1') , 0, iif(b.p_cel = '1.1', 1, iif(b.p_cel = '3.0',2,-1))))
           join h_tarif_app_spec n on n.name_id = h.name_id
                                 and n.code_spec_v021 = iif(b.code_spec_v021 = 39 and a.age < 18, 49, b.code_spec_v021)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf, :p_cel;

          if (:okato = '71140') then
          update ZSD b set
           b.tar_usl = iif((:p_cel = '3.0' and (:idsp<>28)) or ((:idsp = 28) and (:code_usl not starting 'A04') and (:code_usl not starting 'A08')) , 0, coalesce(:tar, 0)),
           b.sum_uslf = cast(iif((:p_cel = '3.0' and (:idsp<>28)) or ((:idsp = 28) and (:code_usl not starting 'A04') and (:code_usl not starting 'A08')), 0, coalesce(:sum_uslf, 0))*:mmb as int),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;
          else
           update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          if (:p_cel <> '3.0') then

          begin
            tar = null;
            sum_uslf = null;
          end
        end

     if (((:p_cel = '3.0' and (:idsp<>28)) or ((:idsp = 28) and (:code_usl not starting 'A04') and (:code_usl not starting 'A08'))) and (:okato = '71140')) then
     begin
       update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = cast(coalesce(:sum_uslf, 0)*:mmb as int)
           where b.id = :idb;
     end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce((select sum(d.tar_usl) from zsd d where d.zs_id = a.id), 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;

     if (coalesce((select z.set_usl_auto from zs z where z.id = :zs_id),0) = 1) then
       execute procedure SP_SET_USL_ZSD(:ZS_ID);
    exit;
  end  

  /********************************************/
  if (:q_u = 4) then
  begin
    tar = (select s.tarif from h_tarif_stom s where :date1 between s.bp and s.epv);

    update zsd d
    set d.tar_usl = :tar,
        d.sum_uslf = cast(d.k_uslf*:tar*:mmb as numeric(15,2))
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = :tar,
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if (:q_u = 5) then
  begin
--    if (:date1 >= '01.01.2018') then tromb_code = 'A25.30.036';
--    else tromb_code = 'A25.30.035';
    tromb_code = coalesce((select first 1 code_usl from zsd d where d.zs_id = :zs_id and coalesce(code_usl, '') <> ''),'');

    tar = (select s.tarif from h_tarif_smp s where :date1 between s.bp and s.epv);
    tar_usl = coalesce((select coalesce(u.sumf,0) from h_usl u where u.code = :tromb_code
               and u.q_u containing '5' and :date1 between u.datebeg and u.dateend),0);

    update zsd d
    set d.tar_usl = iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl),
        d.sum_uslf = d.k_uslf*iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl)
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = (select max(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if ((:q_u = 1) and ((select 1 from zs z where coalesce(z.metod_hmp,0) > 0 and id = :zs_id) = 1)) then
  begin
    select first 1 v.tarif
    from zs z
         join h_metod_hmp h on h.code = z.metod_hmp and z.date_2 between h.bp and h.epv
         join h_tarif_vmp v on v.tg = h.tg and z.date_2 between v.bp and v.epv
    where z.id = :zs_id
    into :tar;

    update zs a set
        a.tar_usl = :tar,
        a.sum_uslf = :tar,
        a.ksg = null,
        a.kslp = null
    where a.id = :zs_id;

    update zsd b set
          b.ksg = null,
          b.sum_uslf = :tar,
          b.kskp = 0,
          b.tar_usl = :tar
    where b.zs_id = :zs_id and coalesce(b.code_usl,'') = '' and b.date_1 = (select min(date_1) from zsd where zs_id = :zs_id and coalesce(code_usl,'') = '');

    exit;
  end

  /********************************************/
  if (:q_u in (1,3) and :date1 < '01.01.2018') then
    execute procedure SP_CALC_STAC(:zs_id);
  else
    if (:q_u in (1,3) and :date1 < '01.01.2020') then
      execute procedure sp_calc_stac_2018(:zs_id);
  else
    if (:q_u in (1,3) and :date1 >= '01.01.2020') then
      execute procedure sp_calc_stac_2020(:zs_id);

  /****************  ***********************************************/
  if (q_u <> 4) then
  begin
  tar = null;
  sum_uslf = null;
  for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (coalesce(:tar,0) > 0) then
          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          tar = null;
          sum_uslf = null;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);
     tar = (select sum(b.tar_usl) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_tarif,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:tar, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
   end

  /*********************-*********************************/
 /*$$IBEC$$  if ((:q_u = 2) and (:target in (21,22))) then
  begin
   for select b.id
    from zsd b
    join zs z on z.id = b.zs_id
    where z.id = :zs_id
    into :idb
    do
    begin
      tar = (select first 1 t.tarif
             from zsd d
                  join h_tomo_code c on c.nms_code = d.code_usl
                  join h_tarif_tomo t on t.group_num = c.group_num and d.date_2 between t.bp and t.epv
             where d.id = :idb);

      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf = :tar
      where d.id = :idb;
    end

    update zs z
    set z.tar_usl = (select sum(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;

    exit;
  end $$IBEC$$*/
  /******************** - 9  ************************/
  if ((:q_u = 2 and :target = 9) or (q_u = 2 and :target = 16 and date1 >= '01.05.2019'))  then
  begin
    execute procedure sp_calc_app_t09(:zs_id);
    exit;
  end

  /******************** - 10,17  -  ************************/
    if (q_u = 2 and target in (10,17)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_10 d on d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and :age_y between d.y1 and d.y2
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = cast(coalesce(b.k_uslf * :tar, 0)*:mmb as int),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(tar_usl) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 13  ************************/
    if (q_u = 2 and target = 13) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select first 1 d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                           and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_13_17 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.age_grp = a.age_grp
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = cast(coalesce(b.k_uslf * :tar, 0)*:mmb as int),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(tar_usl) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 14,15  ,  ************************/
    if (q_u = 2 and target in (14,15)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_14_15 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.cat_info = a.cat_info
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = cast(coalesce(b.k_uslf * :tar, 0)*:mmb as int),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(tar_usl) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
  /******************** - 16  ************************/
    if (q_u = 2 and target = 16 and date1 < '01.05.2019') then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join zs_hdr h on h.id = a.hdr_id
                   join patients p on p.id = a.patient_id
                   join h_tarif_disp_16 d on a.date_2 between d.bp and d.epv
                                          and d.sex = :sex
                                          and cast(d.code_usl as varchar(20)) = b.code_usl
                                          and d.age_l <= (h.y - extract(year from p.dr)) and d.age_r >= (h.y - extract(year from p.dr))
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = cast(coalesce(b.k_uslf * :tar, 0)*:mmb as int),
               b.tar_base = coalesce(:tar, 0) ,
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
end;

/* Alter (SP_CALC_ALL_CH) */
ALTER PROCEDURE SP_CALC_ALL_CH(HDR_ID INTEGER)
 AS
declare variable ZID integer;
begin

 for select z.id
  from zs z
  where z.hdr_id = :hdr_id
  into :zid
  do
    execute procedure SP_CALC_ALL(:ZID);

  update invoice i
  set i.sumv = (select sum(z.sum_uslf) from zs z where z.hdr_id = :hdr_id),
      i.sump = (select sum(z.sum_usl) from zs z where z.hdr_id = :hdr_id)
  where i.id = (select name from zs_hdr h where h.id = :hdr_id);
end;

/* Alter (SP_CALC_STAC_2020) */
ALTER PROCEDURE SP_CALC_STAC_2020(IDA INTEGER)
 AS
declare variable KSG type of DM_CHAR_50;
declare variable DS type of DM_DS;
declare variable IDB integer;
declare variable SUM_USLF type of DM_MONEY;
declare variable KSKP numeric(6,6);
declare variable Q_U integer;
declare variable FINE_KOEF type of DM_NUM_3_2;
declare variable TARIF numeric(10,6);
declare variable IS_TRANSFER DM_INT;
declare variable CL_CNT integer;
declare variable ERR_CODE integer;
declare variable K_DOWN DM_NUM_6_2;
declare variable DS_CLASS DM_CHAR_10;
declare variable KZ DM_NUM_2_5;
declare variable KD DM_NUM_2_5;
declare variable KUS DM_NUM_2_5;
declare variable BS DM_NUM_6_2;
declare variable PROF_NUM integer;
declare variable FINE_KOEF_SET_DOCTOR DM_BOOLEAN;
declare variable IS_ROUND_JANAO integer;
declare variable OKATO DM_OKATO;
declare variable DOP_CODE DM_CHAR_40;
declare variable DATE1 DM_DATE;
declare variable DATE2 DM_DATE;
declare variable KSG_SET_DOCTOR integer;
begin
  okato = (select first 1 c.tf_okato from contragents c where c.type_id = 1);

  if (okato <> '40000') then
  select c.tf_okato
   from zs_hdr h
        join zs z on z.hdr_id = h.id
        join invoice i on i.id = h.name
        join contragents c on c.id = i.contragent_id
   where z.id = :ida
   into :okato;

   -----------------------------------------------------------------------------
   --    
   for select d.id, d.date_1, d.date_2
          from zs z
               join zsd d on d.zs_id = z.id
          where z.id = :ida and (not exists(select dd.id from zsd dd where dd.zs_id = :ida
                                                                     and dd.date_1 <=d.date_1 and dd.date_2 >= d.date_2 and dd.id <> d.id) )
          order by d.ksg desc
          into :idb, :date1, :date2
          do
          begin
            update zsd d
             set d.zsd_id = :idb
             where d.id = :idb;
    
            update zsd d
             set d.zsd_id = :idb
             where d.zs_id = :ida and coalesce(d.code_usl,'') <> ''
                   and d.date_1 between :date1 and :date2
                   and not exists(select id from zsd d2 where d2.zs_id = :ida and d2.date_1 = d.date_1 and d2.id <> :idb and d2.id <> d.id);
          end
   -----------------------------------------------------------------------------
   if (:okato is  null) then
     okato = (select first 1 c.tf_okato from contragents c where c.type_id = 1);

    if (okato = '71140') then
      is_round_janao = 1;

    update zsd d
      set d.ds_class = (select MKB_CLASS from SP_GET_MKB_CLASS(D.ds))
      where d.zs_id = :ida;

    ksg_set_doctor = (select first 1 coalesce(ksg_set_doctor,0) from zsd where zs_id = :ida order by 1 desc);

    update zsd d
     set d.ksg = null, 
         d.ksg_base = iif(:ksg_set_doctor = 0, null, d.ksg_base),
         d.tar_base = null,
         d.sum_base = null,
         d.kskp_base = null,
         d.sum_uslf = 0,
         d.tar_usl = 0,
         d.comment_local = null
     where d.zs_id = :ida;

    update zs z
     set z.ksg = null,
         z.tar_usl = 0,
         z.sum_usl = 0
     where z.id = :ida;

     cl_cnt = (select count(distinct b.ds_class) from ZSD b where b.ZS_ID = :ida and b.zsd_id = b.id);
     is_transfer = (select count(b.id) from ZSD b where b.ZS_ID = :ida and b.zsd_id = b.id);
     delete from kslp_koef where zs_id = :ida ;

     select a.q_u, a.date_2, coalesce(a.fine_koef_set_doctor,0)
      from zs a
      where a.id = :ida
      into :q_u, :date2, :fine_koef_set_doctor;

     for select sp.KSG, sp.ERR_CODE, b.ds, b.id, coalesce(bs.tarif * kd.kd * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0),
                k.kz, kd.kd,
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0),
                bs.tarif, k.k_down, k.prof_num, b.date_1, coalesce(b.fine_koef,1), b.ksg_set_doctor
      from zs a
      join zsd b on a.id = b.zs_id
      join patients p on p.id = a.patient_id
      join lpu_factors lf on lf.q_u = a.q_u and a.date_2 between lf.bp and lf.epv and lf.okato is not distinct from :okato
      join h_tarif_bs bs on bs.q_u = a.q_u and a.date_2 between bs.bp and bs.epv and bs.okato is not distinct from :okato
      join h_tarif_kd kd on a.date_2 between kd.bp and kd.epv and kd.okato is not distinct from :okato
      left join sp_ksg_get_2020(b.id) sp on 1=1
      left join h_ksg k on k.ksg = iif(:ksg_set_doctor = 1, b.ksg_base, sp.ksg) and a.date_2 between k.bp and k.epv and k.q_u = a.q_u
      where b.zs_id = :ida and b.id = b.zsd_id
      order by b.code_usl
      into :ksg, :err_code, :ds, :idb, :tarif, :kz, :kd, :kus, :bs, :k_down, :prof_num, :date1, :fine_koef, :ksg_set_doctor
      do
      begin
        kskp = 1;

        if (coalesce(:ksg_set_doctor,0) = 1) then
          ksg = (select ksg_base from zsd where id = :idb);

        if (:okato = '70000') then
        begin
          select first 1 u.code_1, u.code_2
           from zsd d
                join h_usl u on u.code = d.code_usl and u.payment_type_id = 1 and :date1 between u.datebeg and u.dateend and u.q_u containing :q_u
           where d.id = :idb
          into :ksg, :dop_code;
        end

        if ((q_u in (1,3)) and (err_code is null)) then
          kskp = (select KSKP from sp_calc_stac_kskp_2020(:ida, :idb, :ksg, :cl_cnt));

        if (kskp is null) then kskp = 1;

        if (fine_koef_set_doctor = 0) then
          fine_koef = (select FINE_KOEF from sp_calc_stac_fine_2020(:ida, :idb, :ksg, :cl_cnt));

        if (is_round_janao = 1) then
          sum_uslf = cast(cast(tarif * kskp as int) * fine_koef as int);
        else
          sum_uslf = cast(tarif * kskp as numeric(15,2)) * fine_koef;

        if (:ksg is not null) then
        begin
            update zsd b set
             b.ksg_base = :ksg,
             b.tar_base = iif(:is_round_janao = 1, cast(:tarif*coalesce(:kskp,1) as int), iif(:okato = '29000', :tarif, cast(:tarif*coalesce(:kskp,1) as numeric(15,2)))),
             b.sum_base = :sum_uslf,
             b.kskp_base = :kskp,
             b.koef_z = :kz, 
             b.koef_d = :kd,
             b.koef_u = :kus,
             b.bs = :bs,
             b.koef_up = :k_down,
             b.reab = iif(:prof_num = 37,1,null),
             b.fine_koef = :fine_koef,
             b.dop_code_usl = iif(:okato = '70000', :dop_code, b.dop_code_usl)
             where b.id = :idb;
         end
      end 
--------------------------------------------------------------------------------
      --    6  + 
      if (q_u = 1) then
       if (exists (select 1 from zsd b where b.zs_id = :ida and ((b.ksg in ('st02.001') and b.k_uslf >= 6) or (b.ksg in ('O14.1','O34.2','O36.3','O36.4','O42.2') and b.k_uslf >= 2) ))
          and exists (select 1 from zsd b where b.zs_id = :ida and b.ksg in ('st02.003', 'st02.004'))) then
          begin
            --    ,     
            select first 1 b.ksg_base, b.ds
            from zs a
             join zsd b on a.id = b.zs_id
             where b.zs_id = :ida and b.ksg in ('st02.003', 'st02.004')
             into :ksg, :ds;
       
            update zsd d
            set d.tar_usl = d.tar_base,
                d.sum_uslf = d.sum_base,
                d.ksg = d.ksg_base,
                d.kskp = d.kskp_base
            where d.zs_id = :ida;

            --   
            select coalesce(sum(b.sum_uslf), 0) from zsd b where b.zs_id = :ida
             into :sum_uslf;
    
            update zs a set
             a.tar_usl = :tarif,
             a.sum_uslf = :sum_uslf,
             a.sum_usl = :sum_uslf,
             a.ksg = :ksg,
             a.ds1 = :ds,
             a.kslp = :kskp
             where a.id = :ida;

            exit;
          end
--------------------------------------------------------------------------------
      if ((is_transfer < 2) or (cl_cnt < 2))  then  --   
      begin
        --     2- ,   2
        --  ,    ,    
        --  ,    ()
        --     
        if ((exists(select first 1 1 from zsd d where d.zs_id = :ida and ((:q_u = 1 and d.ksg_base starting 'st37') or
                                                                                                  (:q_u = 3 and d.ksg_base starting 'ds37'))))
            or (exists(select first 1 1 from zsd d where d.zs_id = :ida and d.ksg_base in ('st36.009','st36.010','st36.011') and d.profil_k in (10,11) ))
            or (exists(select first 1 1 from zsd d where d.zs_id = :ida and d.ksg_base in ('st19.038','ds19.028')))
            or (((select count(d.id) from zsd d where d.zs_id = :ida and d.ksg_base is not null and d.profil_k = 42) >= 2) and
                 ((select count(u.id) from zsd d join onk_usl u on u.zsd_id = d.id where d.zs_id = :ida and u.usl_tip = 1) >= 2)))   then
            update zsd b set
                 b.ksg = b.ksg_base,
                 b.sum_uslf = b.sum_base,
                 b.tar_usl = b.tar_base,
                 b.kskp = b.kskp_base
            where b.zs_id = :ida and b.ksg_base is not null;
        else
        --     
        begin
          select first 1 id
           from zsd d
           where d.zs_id = :ida and d.ksg_base is not null
           order by d.koef_z desc
           into :idb;

          update zsd b set
             b.ksg = b.ksg_base,
             b.sum_uslf = b.sum_base,
             b.tar_usl = b.tar_base,
             b.kskp = b.kskp_base
           where b.id = :idb;

          update zsd b set
             b.ksg = null,
             b.sum_uslf = 0,
             b.kskp = 1,
             b.tar_usl = 0
            where b.id <> :idb and b.zs_id = :ida;
        end
      end else
      begin
        for select b.ds_class
         from zsd b
         where b.zs_id = :ida
         group by 1
         into :ds_class
         do
         begin
             select first 1 id
               from zsd d
               where d.zs_id = :ida and d.ksg_base is not null and d.ds_class = :ds_class
               order by d.koef_z desc
               into :idb;
    
             update zsd b set
                 b.ksg = b.ksg_base,
                 b.sum_uslf = b.sum_base,
                 b.tar_usl = b.tar_base,
                 b.kskp = b.kskp_base
               where b.id = :idb;

             update zsd b set
              b.ksg = null,
              b.sum_uslf = 0,
              b.kskp = 1,
              b.tar_usl = 0
              where b.id <> :idb and b.zs_id = :ida and b.ds_class = :ds_class;
         end
       end

        select first 1 b.ksg_base
        from zs a
         join zsd b on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null
         order by b.sum_base desc
         into :ksg;
   
        select coalesce(sum(b.sum_uslf), 0), coalesce(sum(b.tar_base), 0)
         from zsd b
         join zs a on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null
         into :sum_uslf, :tarif;

        update zs a set
         a.tar_usl = :tarif,
         a.sum_uslf = :sum_uslf,
         a.sum_usl = :sum_uslf,
         a.ksg = :ksg,
         a.kslp = :kskp
         where a.id = :ida;
end;

/* Alter (SP_ZS_SET_ZACHET) */
ALTER PROCEDURE SP_ZS_SET_ZACHET(HDR_ID INTEGER)
 AS
declare variable ZS_ID integer;
declare variable DATE1 DM_DATE;
begin
  for select z.id, z.date_1
      from zs z
      where z.hdr_id = :hdr_id
      into :zs_id, :date1
      do
      begin
        update zsd d
         set d.zachet = 1
         where d.zs_id = :zs_id and d.date_1 < :date1;

        execute procedure SP_CALC_ALL(:ZS_ID);
      end
end;

/* Alter (SP_ZSD_LIST_CREATE) */
ALTER PROCEDURE SP_ZSD_LIST_CREATE(ZS_ID INTEGER)
 AS
declare variable TARGET integer;
declare variable DE date;
begin
  target = (select target from zs where id = :zs_id);
  de = (select z.date_2 from zs z where id = :zs_id);

  if (exists (select id from zsd where zs_id = :zs_id)) then
   exit;

  if (target = 9) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.code_usl, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, 'Z00.8', 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_09 d on d.stage = z.disp_stage and d.age = extract(year from z.date_1) - extract(year from p.dr)
                                      and d.sex = p.sex and z.date_2 between d.bp and d.epv
            join h_usl u on u.code = d.code_usl  and d.bp between u.datebeg and u.dateend
       where z.id = :zs_id and d.code_usl is not null and d.tarif is not null and
             u.target containing '9' and u.q_u containing '2' and z.date_2 between bp and epv;
  end

  if (target in (10,17)) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.usl_code, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, iif(z.age < 3, 'Z00.1', iif(z.age >= 3 and z.age < 15, 'Z00.2', 'Z00.3')), 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_10 d on d.stage = z.disp_stage and d.sex = p.sex
                                          and z.date_2 between d.bp and d.epv
                                          and z.age between d.y1 and d.y2
       where z.id = :zs_id and d.tarif is not null;
  end

  if (target = 13) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.usl_code, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, iif(z.age < 3, 'Z00.1', iif(z.age >= 3 and z.age < 15, 'Z00.2', 'Z00.3')), 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_13_17 d on d.target = z.target
                                          and d.stage = z.disp_stage and d.sex = p.sex
                                          and z.date_2 between d.bp and d.epv
                                          and d.age_grp = z.age_grp
       where z.id = :zs_id and d.tarif is not null;
  end

  if (target in (14,15)) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.usl_code, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, iif(z.age < 3, 'Z00.1', iif(z.age >= 3 and z.age < 15, 'Z00.2', 'Z00.3')),1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_14_15 d on d.target = z.target
                                          and d.stage = z.disp_stage and d.sex = p.sex
                                          and z.date_2 between d.bp and d.epv
                                          and d.cat_info = z.cat_info
       where z.id = :zs_id and d.tarif is not null;
  end

  if ((target = 16) and (:de < '01.05.2019')) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.code_usl, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, 'Z00.8', 1
       from zs z
            join patients p on p.id = z.patient_id
            join zs_hdr h on h.id = z.hdr_id
            join h_tarif_disp_16 d on z.date_2 between d.bp and d.epv
                                          and d.sex = p.sex
                                          and d.age_l <= (h.y - extract(year from p.dr)) and d.age_r >= (h.y - extract(year from p.dr))
       where z.id = :zs_id and d.tarif is not null;
  end

  if ((target = 16) and (:de >= '01.05.2019')) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.code_usl, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, 'Z00.8', 1
       from zs z
            join patients p on p.id = z.patient_id
            join zs_hdr h on h.id = z.hdr_id
            join h_tarif_disp_09 d on d.stage = z.disp_stage and d.age = extract(year from z.date_1) - extract(year from p.dr)
                                      and d.sex = p.sex and z.date_2 between d.bp and d.epv
            join h_usl u on u.code = d.code_usl  and d.bp between u.datebeg and u.dateend
       where z.id = :zs_id and d.tarif is not null and
             u.target containing '16' and u.q_u containing '2' and z.date_2 between bp and epv
             and ((u.code <> iif(((extract(year from z.date_1) - extract(year from p.dr)) > 39) and (p.sex = ''), 'B04.001.002.099', '')));
  end

  insert into ZS_DS (DS, DS_TYPE, SECTION, SECTION_ID, PR, IS_TEMP)
    select d.ds, 1, 2, d.id, 0, 1
    from zsd d
    where d.zs_id = :zs_id;

  execute procedure SP_CALC_ALL(:ZS_ID);
end;

