ALTER TRIGGER ZS_BIU0
AS
declare variable hdr integer;
declare variable dr date;
begin
  select p.dr from patients p where p.id = new.patient_id
  into :dr;
  new.age = ((new.date_1 - :dr)/365.25);

  if (new.n_zap is null) then
    new.n_zap = new.id;

  if (new.id_case is null) then
    new.id_case = new.id;

  if (new.id_pac is null) then
    new.id_pac = new.id;

  if (new.payment_type_id is null) then
    new.payment_type_id = 1;

  if (bin_and(new.extra_info, 1) = 1) then
    new.chield_with_rop = 1;

  if (new.date_1 is null) then
  begin
    new.date_1 = current_date;
    new.date_2 = current_date;
  end

  new.spolis = (select first 1 i.ser from patients_insurance i where i.patients_id = new.patient_id and i.type_id = new.payment_type_id and i.db <= new.date_2 and coalesce(i.de,'31.12.2999') >= new.date_2);
  new.npolis = (select first 1 i.num from patients_insurance i where i.patients_id = new.patient_id and i.type_id = new.payment_type_id and i.db <= new.date_2 and coalesce(i.de,'31.12.2999') >= new.date_2);
  new.smo = (select first 1 i.smo from patients_insurance i where i.patients_id = new.patient_id and i.type_id = new.payment_type_id and i.db <= new.date_2 and coalesce(i.de,'31.12.2999') >= new.date_2);

  if (new.hdr_id is null) then
  begin
    hdr = (select id from zs_hdr h where h.y = extract(year from new.date_2) and h.m = extract(month from new.date_2)
         and h.name = h.m and is_delete = 0);

    if (hdr is not null) then
      new.hdr_id = hdr;
    else
    begin
      execute procedure ADD_PERIOD_HDR(extract(month from new.date_2), extract(year from new.date_2),
                                       (select M2 from SP_MONTH_TO_STRING(extract(month from new.date_2))),
                                       cast(extract(year from new.date_2) as varchar(4))) ;
      hdr = (select id from zs_hdr h where h.y = extract(year from new.date_2) and h.m = extract(month from new.date_2));
      new.hdr_id = :hdr;
    end
  end

  if ((new.n_hist is null) or (new.n_hist = '')) then
  begin
--    new.n_hist_num = (select max(coalesce(n_hist_num,0)) from zs z where z.patient_id = new.patient_id) + 1;
    new.n_hist = cast(gen_id(gen_nhist, 1) as varchar(50));
  end

  if (new.is_chield is null) then
    new.is_chield = 0;

  if ((new.q_u_2016 is not null) and (new.q_u is null)) then
  begin
      if (new.q_u_2016 = 4 and extract(year from new.date_2) > 2015 ) then
        new.q_u = 5;
      else
      if (new.q_u_2016 = 5 and extract(year from new.date_2) > 2015 ) then
        new.q_u = 4;
      else
      if (new.q_u_2016 = 2 and extract(year from new.date_2) > 2015 ) then
        new.q_u = 3;
      else
      if (new.q_u_2016 = 3 and extract(year from new.date_2) > 2015 ) then
      begin
       if (new.idsp = 9) then
       begin
        new.q_u = 4;
        new.q_u_2016 = 5;
       end
       else
        new.q_u = 2;
      end
      else new.q_u = 1;
  end
  else
  if ((new.q_u is not null)) then
  begin
      if (new.q_u = 4 and extract(year from new.date_2) > 2015 ) then
        new.q_u_2016 = 5;
      else
      if (new.q_u = 5 and extract(year from new.date_2) > 2015 ) then
        new.q_u_2016 = 4;
      else
      if (new.q_u = 2 and extract(year from new.date_2) > 2015 ) then
        new.q_u_2016 = 3;
      else
      if (new.q_u = 3 and extract(year from new.date_2) > 2015 ) then
        new.q_u_2016 = 2;
      else new.q_u_2016 = 1;
  end

  if (new.target in (9,10,11,12,13,14,15,16,17)) then
  begin
    if (new.disp_h_group is null) then
    begin
      new.disp_h_group = case
                           when (new.rslt_d in (1)) then '1'
                           when (new.rslt_d in (2)) then '2'
                           when (new.rslt_d in (3)) then '3'
                           when (new.rslt_d in (31)) then '3'
                           when (new.rslt_d in (32)) then '3'
                           when (new.rslt_d in (4)) then '4'
                           when (new.rslt_d in (5)) then '5'
                           when (new.rslt_d in (11)) then '1'
                           when (new.rslt_d in (12)) then '2'
                           when (new.rslt_d in (14)) then '3'
                           when (new.rslt_d in (15)) then '3'
                         end;
    end
  end
  
  if (not inserting) then
  begin
  if (new.q_u = 1) then
    new.k_uslf = iif(new.date_1 = new.date_2, 1, new.date_2 - new.date_1);
    else
    if (new.q_u = 3) then
    begin
      if (coalesce(new.ksg,'') = '') then
        new.k_uslf = (select sum(d.k_uslf) from zsd d where d.zs_id = new.id and coalesce(d.ksg,'') = '');
      else
        new.k_uslf = (select max(d.k_uslf) from zsd d where d.zs_id = new.id and coalesce(d.ksg,'') <> '');
--        iif(new.date_1 = new.date_2, 1, new.date_2 - new.date_1 + 1);
    end
      else
      if (new.q_u in (4,5)) then
        new.k_uslf = (select sum(d.k_uslf) from zsd d where d.zs_id = new.id);
        else
        if (new.q_u = 2 and new.target in (9,10,13,16,17)) then
          new.k_uslf = (select sum(d.k_uslf)
                        from zsd d left join h_usl u on u.code = d.code_usl
                                                        and u.q_u containing new.q_u
                                                        and new.date_1 between u.datebeg and u.dateend
                                                        and u.payment_type_id = new.payment_type_id
                        where d.zs_id = new.id and coalesce(u.is_usl,0) <> 1);
        else
        if (new.q_u = 2 and new.target not in (9,10,13,16,17)) then
          new.k_uslf = (select sum(d.k_uslf)
                        from zsd d
                        where d.zs_id = new.id);
  end

  if (coalesce(new.idsp_not_auto,0) = 0) then
  new.idsp = case
             when (new.q_u = 1) then 33
             when (new.q_u = 3) then 33
             when (new.q_u = 2) and exists(select first 1 id from zsd d where d.zs_id = new.id and
                                                  ((coalesce(d.code_usl,'') starting 'A06')
                                                  or (coalesce(d.code_usl,'') starting 'A05')
                                                  or (coalesce(d.code_usl,'') starting 'A04')
                                                  or (coalesce(d.code_usl,'') starting 'A03')
                                                  or (coalesce(d.code_usl,'') starting 'A08')
                                                  or (coalesce(d.code_usl,'') starting 'A27')
                                                  or (coalesce(d.code_usl,'') starting 'A07'))) then 28
             when (new.q_u = 5) and exists(select first 1 id from zsd d where d.zs_id = new.id and coalesce(d.code_usl,'') <> '') then 28
             when (new.q_u = 2) and (new.target < 9) and new.k_uslf = 1 then 29
             when (new.q_u = 2) and (new.target < 9) and (new.for_pom = 3) and new.k_uslf > 1 then 30
             when (new.q_u = 2) and (new.target in (9,10,17,13,14,15,16)) then 30
             when (new.q_u = 2) and (new.target in (21,22,23)) then 28
             when (new.q_u = 5) then 36
             when (new.q_u = 4) and (new.target < 9) and new.dcount = 1 then 29
             when (new.q_u = 4) and (new.target < 9) and (new.for_pom = 3) and new.dcount > 1 then 30
             end;

  dr = (select dr from patients where id = new.patient_id);

  if ((coalesce(new.age_grp_not_auto,0) = 0) and (new.target = 13)) then
    new.age_grp = (select AGE_GRP from SP_CALC_AGE_GRP(:dr, new.date_1));
             
  if (new.chield_with_rop = 1) then
    new.extra_info = 1;
  if (new.extra_info = 1) then
    new.chield_with_rop = 1;

  new.usl_ok = case
               when (new.q_u = 1) then 1
               when (new.q_u = 2) then 3
               when (new.q_u = 3) then 2
               when (new.q_u = 5) then 4
               when (new.q_u = 4) then 3
               end;
end;

