/* Create Table... */
CREATE TABLE REGISTRY_CALENDAR_COLOR(STATE DM_INT NOT NULL,
CLR DM_CHAR_100);


DESCRIBE FIELD STATE TABLE REGISTRY_CALENDAR_COLOR
'1 -  
2 -  
3 -  
4 - 
5 - 
6 -  
7 -  ';


/* Create Primary Key... */
ALTER TABLE REGISTRY_CALENDAR_COLOR ADD CONSTRAINT PK_REGISTRY_CALENDAR_COLOR PRIMARY KEY (STATE);

/* Alter Procedure... */
/* Alter (SP_CHECK_FULL_DAY) */

ALTER PROCEDURE SP_CHECK_FULL_DAY(D DM_DATE,
DOCTOR_ID INTEGER)
 RETURNS(FILL_STATE INTEGER)
 AS
declare variable T_BEG DM_TIME;
declare variable T_END DM_TIME;
declare variable T2_BEG DM_TIME;
declare variable T2_END DM_TIME;
begin
  fill_state = 2;
  t2_beg = null;
  t2_end = null;

  if (not exists(select 1 from registry r where r.dd = :d and r.doctors_id = :doctor_id)) then fill_state = 0;
  else
    if ((select count(r.id) from registry r where r.dd = :d and r.doctors_id = :doctor_id) = 1) then fill_state = 1;
    else
      if (((select min(time_start) from registry r where r.dd = :d and r.doctors_id = :doctor_id) > (select s.time_start from sys$registry_setting s where wday = EXTRACT(WEEKDAY FROM :d))) or
         ((select max(time_end) from registry r where r.dd = :d and r.doctors_id = :doctor_id) < (select s.time_end from sys$registry_setting s where wday = EXTRACT(WEEKDAY FROM :d)))) then fill_state = 1;
      else
        for select r.time_start, r.time_end
          from registry r
          where r.dd = :d and r.doctors_id = :doctor_id
          order by r.time_start
          into :t_beg, :t_end
          do
          begin
            if (not :t2_end is null) then
              if (:t_beg - :t2_end > 0) then
                fill_state = 1;

            t2_end = :t_end;
          end
   suspend;
end;

