ALTER TABLE H_TARIF_BS ADD OKATO DM_OKATO;

DESCRIBE FIELD OKATO TABLE H_TARIF_BS
'  ';

ALTER TABLE H_TARIF_KD ADD OKATO DM_OKATO;

ALTER TABLE LPU_FACTORS ADD OKATO DM_OKATO;

ALTER PROCEDURE SP_ADD_NEW_ANALIZ_PARAM(PAT_ANALIZ_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* Empty SP_EXTRACT_USL_DATA for drop H_USL(NAME) */
ALTER PROCEDURE SP_EXTRACT_USL_DATA(USL_ID INTEGER)
 RETURNS(STR /* DM_CHAR_450 */ VARCHAR(450))
 AS
 BEGIN SUSPEND; END;

/* Empty SP_REP_INV_FACT for drop H_USL(NAME) */
ALTER PROCEDURE SP_REP_INV_FACT(HDR_ID INTEGER)
 RETURNS(USL_CODE VARCHAR(50),
USL_NAME VARCHAR(500),
CONTRAGENT_ID INTEGER,
TARIF /* DM_MONEY_15_2 */ NUMERIC(15,2),
USL_CNT /* DM_NUM_6_2 */ NUMERIC(6,2),
SUMV /* DM_MONEY_15_2 */ NUMERIC(15,2))
 AS
 BEGIN SUSPEND; END;

/* Empty SP_REP_INV_FACT_REESTR for drop H_USL(NAME) */
ALTER PROCEDURE SP_REP_INV_FACT_REESTR(HDR_ID INTEGER)
 RETURNS(FIO VARCHAR(150),
NUM_SP VARCHAR(20),
HIST_NUM VARCHAR(50),
DATE_1 DATE,
USL_CODE VARCHAR(50),
USL_NAME VARCHAR(500),
TARIF /* DM_MONEY_15_2 */ NUMERIC(15,2),
USL_CNT /* DM_NUM_6_2 */ NUMERIC(6,2),
SUMV /* DM_MONEY_15_2 */ NUMERIC(15,2),
TOOTH_ID /* DM_CHAR_250 */ VARCHAR(250),
DS VARCHAR(7),
DOC_FIO VARCHAR(150),
NPP INTEGER)
 AS
 BEGIN SUSPEND; END;

DROP VIEW V_ACTIONS_USL;

DROP VIEW V_H_USL;

DROP VIEW V_PATIENTS_INVOICE_USL;

DROP VIEW V_ZSD;

ALTER TRIGGER PATIENTS_ANALIZ_BI
 AS Declare variable I integer;
BEGIN I = 0; END;

ALTER TABLE H_USL ALTER COLUMN NAME TYPE DM_CHAR_1000;

/* Create view: V_ACTIONS_USL */
CREATE VIEW V_ACTIONS_USL(
ID,
USL_ID,
ACTION_ID,
DISCOUNT,
DISCOUNT_TYPE,
BP,
EP,
CODE,
NAME,
SUMF,
SUM_TOTAL)
 AS 
select A.ID, A.USL_ID, A.ACTION_ID, A.DISCOUNT,
      iif(a.discount_type = 0, '%', '.'),
      A.BP, A.EP,
       u.code, u.name, u.sumf, cast((u.sumf - iif(a.discount_type = 0, a.discount*u.sumf/100, a.discount)) as numeric(15,2))
from ACTIONS_USL A  
     left join h_usl u on u.id = a.usl_id
;

/* Create view: V_H_USL */
CREATE VIEW V_H_USL(
ID,
NAME,
IS_USL,
Q_U,
TARGET,
CODE,
DATEBEG,
DATEEND,
CHIELD_UET,
UET,
SUMF,
PAYMENT_TYPE_ID,
PAYMENT_TYPE_NAME,
USL_CATEGORY_ID,
USL_CATEGORY_NAME,
IS_ANALIZ)
 AS 
select u.id, u.name, coalesce(u.is_usl,0) is_usl,
       iif(u.q_u containing '1','./','') ||
       iif(u.q_u containing '2','/','') ||
       iif(u.q_u containing '3','../','') ||
       iif(u.q_u containing '4','./','') ||
       iif(u.q_u containing '5','','') q_u,
       u.target,
       u.code,
       u.datebeg,
       u.dateend,
       coalesce(u.chield_uet,0) chield_uet,
       coalesce(u.uet,0) uet,
       coalesce(u.sumf,0) sumf,
       u.payment_type_id,
       pt.name payment_type_name,
       u.usl_category_id,
       c.name usl_category_name,
       coalesce(u.is_analiz,0) is_analiz
from h_usl u
     left join h_payment_type pt on pt.id = u.payment_type_id
     left join h_usl_category c on c.id = u.usl_category_id
;

DESCRIBE FIELD NAME VIEW V_H_USL
'';

DESCRIBE FIELD IS_USL VIEW V_H_USL
'';

DESCRIBE FIELD Q_U VIEW V_H_USL
' ';

DESCRIBE FIELD TARGET VIEW V_H_USL
' ';

DESCRIBE FIELD CODE VIEW V_H_USL
'';

DESCRIBE FIELD DATEBEG VIEW V_H_USL
' ';

DESCRIBE FIELD DATEEND VIEW V_H_USL
' ';

DESCRIBE FIELD CHIELD_UET VIEW V_H_USL
' ';

DESCRIBE FIELD UET VIEW V_H_USL
'';

DESCRIBE FIELD SUMF VIEW V_H_USL
'';

DESCRIBE FIELD PAYMENT_TYPE_NAME VIEW V_H_USL
' ';

DESCRIBE FIELD USL_CATEGORY_NAME VIEW V_H_USL
'';

DESCRIBE FIELD IS_ANALIZ VIEW V_H_USL
'';

/* Create view: V_PATIENTS_INVOICE_USL */
CREATE VIEW V_PATIENTS_INVOICE_USL(
ID,
CH_NUM,
CH_DATE,
ZS_ID,
PATIENT_ID,
USL_ID,
TARIF,
K_USLF,
DISCOUNT,
SUM_USLF,
USL_CODE,
USL_NAME,
D_ID,
DISCOUNT_INV,
DISCOUNT_PROC_INV,
DISCOUNT_PROC,
SUMV_TOTAL,
TOOTH_LIST,
USER_ID,
USER_FIO,
SUMV,
SUM_OPL,
SUM_DOLG,
NOTE)
 AS 
select I.ID, I.CH_NUM, I.CH_DATE, I.ZS_ID, I.PATIENT_ID, U.USL_ID,
       U.TARIF, U.K_USLF, U.DISCOUNT, U.SUM_USLF,
       iif(usl.id is null, p.code, usl.code),
       iif(usl.id is null, p.name, usl.name),
       u.id,
       i.discount, i.discount_proc,u.discount_proc, i.sumv_total, COALESCE(u.tooth_list, cast(u.dent_id as varchar(2))),
       i.user_id, S.fio, I.sumv, i.sum_opl, i.sum_dolg,
       (select first 1 ('   "' || a.name || '" ' || au.discount || iif(au.discount_type = 0, ' %', ' .'))
         from actions_usl au
              join actions a on a.id = au.action_id
         where au.usl_id = u.usl_id and i.ch_date between au.bp and au.ep
         order by au.discount desc)
from patients_invoice i
join patients_invoice_usl u on u.hdr_id = i.id
left join h_usl usl on usl.id = u.usl_id
left join lab_products p on p.id = u.lab_product_id
LEFT JOIN USERS S ON S.ID = I.user_id
;

/* Create view: V_ZSD */
CREATE VIEW V_ZSD(
ID,
ZS_ID,
DATE_1,
DATE_2,
CODE_SPEC,
CODE_PROF,
USL_TYPE,
OTD_PROF,
IS_CHIELD,
DS,
DS2,
SRVPLACE,
CODE_USL,
K_USLF,
PHYS_ID,
MES_CODE,
FIO,
SPEC_NAME,
SRVPLACE1,
DCOUNT,
KSG,
PCOD,
TAR_USL,
PMD_CLOSE,
SUM_USLF,
ORIT,
MP,
USL_NAME,
Q_U,
TARGET,
DISP_STAGE,
DATE_1_ZS,
TOOTH,
ZACHET,
IS_NO_GET_USL,
KSG_BASE,
SUM_BASE,
TAR_BASE,
KSKP_BASE,
COMMENT_LOCAL,
PODR,
TOOTH_LIST,
PROF_NAME,
FAM,
IM,
OT,
DR,
PHONES,
EMAIL,
Q_U_NAME,
KSG_CRITERION,
ZSD_ID,
P_CEL,
DN,
PROFIL_K,
P_PER,
DS_ONK,
KSG_CRITERION2,
CODE_SPEC_V021,
SER_SP,
NUM_SP,
C_ZAB,
FINE_KOEF_SET_DOCTOR,
DOP_TARIF,
DOP_SUM,
DOP_CODE_USL)
 AS 
select zz.ID, zz.zs_id, zz.DATE_1, zz.DATE_2, iif(z.date_2 >= '01.05.2018', zz.code_spec_v021, zz.code_spec), zz.CODE_prof, zz.usl_type,
       zz.OTD_PROF, zz.IS_CHIELD,
       zz.DS, zz.DS2, zz.SRVPLACE, zz.CODE_USL, zz.K_USLF, 
       zz.PHYS_ID, z.mes_code, 
       iif(zz.phys_id = '', '', (select fio from doctors_fio where id = zz.phys_id)) as fio,
       iif(z.date_2 >= '01.05.2018', (select name from h_spec_v021 where code = zz.code_spec_v021), (select name from h_spec_v015 where code = zz.code_spec)) as spec_name, pl.name as srvplace,
       zz.dcount,zz.ksg, iif(zz.phys_id = '', '', (select pcod from doctors_fio where id = zz.phys_id)) as pcod,
       zz.tar_usl, coalesce(zz.pmd_close,0), zz.sum_uslf, zz.orit, zz.mp,
       (select first 1 name from h_usl u where u.code = zz.code_usl
        and u.q_u containing cast(z.q_u as varchar(1)) and u.payment_type_id = z.payment_type_id
        and z.date_1 between u.datebeg and u.dateend),
       z.q_u, z.target, z.disp_stage, z.date_1, zz.tooth_id, coalesce(zz.zachet,0), coalesce(ZZ.is_no_get_usl,0),
       zz.ksg_base, zz.sum_base, zz.tar_base, zz.kskp_base, zz.comment_local, zz.podr,
       iif((coalesce(zz.tooth_id,0) = 0 or coalesce(zz.tooth_list,'')='') and z.q_u = 4, zz.tooth_id, zz.tooth_list),
       o.name, p.fam, p.im, p.ot, p.dr, p.phones, p.email, q.name, zz.ksg_criterion, zz.zsd_id,
       zz.p_cel, zz.dn, zz.profil_k, zz.p_per, zz.ds_onk, zz.ksg_criterion2, zz.code_spec_v021,
       p.ser_sp, p.num_sp, zz.c_zab, z.fine_koef_set_doctor, zz.dop_tarif, zz.dop_sum, zz.dop_code_usl
from ZSd zz
     left join zs z on z.id = zz.zs_id
     join zs_hdr h on h.id = z.hdr_id
     left join patients p on p.id = z.patient_id
--     left join h_spec_v015 cs on cs.code = zz.code_spec
--     left join h_spec_v021 cs2 on cs2.code = zz.code_spec_v021
     left join h_srvplace pl on pl.id = zz.srvplace
     left join h_code_otd o on o.code = zz.code_prof
     left join h_q_u q on q.id = z.q_u
where h.is_delete <> 1
;

/* Alter View (Drop, Create)... */
/* Drop altered view: V_H_TARIF_BS */
DROP VIEW V_H_TARIF_BS;

/* Create altered view: V_H_TARIF_BS */
/* Create view: V_H_TARIF_BS */
CREATE VIEW V_H_TARIF_BS(
ID,
Q_U,
BP,
EP,
TARIF,
EPV,
OKATO)
 AS 
select B.ID, q.name, B.BP, B.EP, B.TARIF, B.EPV, b.okato
from H_TARIF_BS B  
     join h_q_u q on q.id = b.q_u
;

/* Drop altered view: V_LPU_FACTORS */
DROP VIEW V_LPU_FACTORS;

/* Create altered view: V_LPU_FACTORS */
/* Create view: V_LPU_FACTORS */
CREATE VIEW V_LPU_FACTORS(
ID,
Q_U,
KUS,
BP,
EP,
EPV,
OKATO)
 AS 
select L.ID, q.name q_u, L.KUS, L.BP, L.EP, L.EPV, L.okato
from LPU_FACTORS L  
     join h_q_u q on q.id = l.q_u
;

/* Drop altered view: V_ZS */
DROP VIEW V_ZS;

/* Create altered view: V_ZS */
/* Create view: V_ZS */
CREATE VIEW V_ZS(
ID,
Q_U,
MP,
ORDER_V,
CODE_SPEC,
CODE_PROF,
OTD_PROF,
IS_CHIELD,
N_HIST,
DATE_1,
DATE_2,
DS0,
DS1,
DS2,
TAR_USL,
K_USLF,
K_USL,
IDSP,
TARGET,
RESULT,
PATIENT_ID,
FAM,
IM,
OT,
Q_U_NAME,
TARGET_NAME,
SUM_USLF,
HDR_ID,
DIRECTION_NUM,
DIRECTION_DATE,
DH_INFO,
MES_CODE,
SMP_BRIG,
DS3,
DCOUNT,
UID,
PHYS_ID,
CATEGORY,
DISP_STAGE,
DISP_WORK_STATE,
DISP_RESULT,
DISP_H_GROUP,
OUTCOME,
KSG,
CAT_INFO,
IDSP_NAME,
MP_NAME,
ORDER_V_NAME,
DH_INFO_NAME,
CODE_SPEC_NAME,
CODE_PROF_NAME,
IS_CHIELD_NAME,
SMP_BRIG_NAME,
RESULT_NAME,
OUTCOME_NAME,
FOR_POM,
VID_HMP,
METOD_HMP,
AGE_GRP,
CHIELD_WITH_ROP,
FOR_POM_NAME,
REGISTRY_ID,
PAYMENT_TYPE_ID,
PAYMENT_NAME,
REGISTRY_NAME,
SUM_USL,
DOCTOR_FIO,
DOCTOR_COD,
NUM_SP,
IDCASE,
Q_U_2016,
HAS_ERRORS,
CODE_MES1,
COMENTSL,
SMO,
OKATO_SMO,
OKATO_G,
OKATO_P,
SUM_OPL,
N_ZAP,
ZSP_VPOLIS,
ZSP_SPOLIS,
ZSP_NPOLIS,
ZSP_POLIS_BP,
ZSP_POLIS_EP,
ZSP_SMO_OGRN,
ZSP_SMO_CODE,
ZSP_ENP,
ZSP_SEND_DATE,
ZSP_RESP_DATE,
AGE,
DR,
DOC_SER,
DOC_NUM,
SEX,
PODR,
KSLP,
REG_DATE,
AGE_NAME,
M,
Y,
CH_NUM,
INV_STATE,
KSG_NUM,
KSG_PROF_NUM,
NPR_MO,
PER,
VBR,
TAL_D,
TAL_P,
INV,
RSLT_D,
NAZR,
NAZ_SP,
NAZ_V,
NAZ_PMP,
NAZ_PK,
IDSP_NOT_AUTO,
AGE_GRP_NOT_AUTO,
USER_ID,
USER_FIO,
MSE,
BARTHEL_IDX,
CODE_SPEC_V021,
ID_PAC,
DISP,
P_CEL,
C_ZAB)
 AS 
select z.id,
       z.q_u,
       z.mp,
       z.order_v,
       z.code_spec,
       z.code_prof,
       z.otd_prof,
       z.is_chield,
       z.n_hist,
       z.date_1,
       z.date_2,
       z.ds0,
       z.ds1,
       z.ds2,
       z.tar_usl,
       z.k_uslf,
       z.k_usl,
       z.idsp,
       z.target,
       z.result,  
       z.patient_id,
       p.fam,
       p.im,
       p.ot,
       q_u.name as q_u_name,
       t.name as target_name,
       z.sum_uslf,
       z.hdr_id,
       z.direction_num,
       z.direction_date,
       z.dh_info as dh_info,
       z.mes_code,
       z.smp_brig,
       z.ds3,
       Z.DCOUNT,
       z.uid,
       z.phys_id,
       z.category,
       z.disp_stage,
       z.disp_work_state,
       z.disp_result,
       z.disp_h_group,
       z.outcome,
       z.ksg,
       z.cat_info,
       i.name as idsp_name,
       m.name as mp_name,
       o.name as order_v_name,
       dh.name as dh_info_name,
       iif(z.date_2 >= '01.05.2018', (select name from h_spec_v021 where code = z.code_spec_v021), (select name from h_spec_v015 where code = z.code_spec)) as code_spec_name,
       co.name as code_prof_name,
       iif(z.is_chield = 1, '', '') as is_chield_name,
       sb.name as smp_brig_name,
       r.name as result_name,
       oc.name as outcome_name,
       z.for_pom,
       z.vid_hmp,
       z.metod_hmp,
       z.age_grp,
       z.chield_with_rop,
       fp.name,
       z.registry_id,
       Z.payment_type_id,
       pt.name,
       reg.name,
       z.sum_usl,
       df.fio,
       DF.pcod,
       p.num_sp,  --iif(z.payment_type_id <> 2, p.num_sp, (select ins.ser || ' ' || ins.num from patients_insurance ins where ins.patients_id = p.id and z.date_1 between ins.db and ins.de)),
       z.id_case,
       z.q_u_2016,
       0,--(select first 1 1 from error_list_local err where err.reestr_hdr_id = z.hdr_id and err.uid = z.uid),
       z.mes_code,
       z.comentsl,
       p.smo,
       p.okato_smo,
       p.okato_l,
       p.okato_r,
       z.sum_usl, --(select sum(pi.sum_opl) from patients_invoice pi where pi.zs_id = z.id),
       z.n_zap n_zap,
       zpr.vpolis,
       zpr.spolis,
       zpr.npolis,
       zpr.polis_bp,
       zpr.polis_ep,
       zpr.smo_ogrn,
       zpr.smo_code,
       zpr.enp,
       zp.send_date,
       zpr.resp_date,
       z.age,
       p.dr,
       p.doc_ser,
       p.doc_num,
       p.sex,
       z.podr,
       z.kslp,
       reg.reg_date,
       cast(floor(z.age) as varchar(3)) || '  ' ||
            cast(iif(extract(day from z.date_1) < extract(day from p.dr),
                 iif(extract(month from z.date_1) > extract(month from p.dr), extract(month from z.date_1) - extract(month from p.dr),
                             iif(extract(month from z.date_1) < extract(month from p.dr), 12 - extract(month from p.dr) + extract(month from z.date_1) - 1,
                                 11)),
                 iif(extract(month from z.date_1) > extract(month from p.dr), extract(month from z.date_1) - extract(month from p.dr),
                             iif(extract(month from z.date_1) < extract(month from p.dr), 12 - extract(month from p.dr) + extract(month from z.date_1),
                                   0))) as varchar(2)) || ' ',
       h.m,
       h.y, 
       h.full_name,
       coalesce(inv.status_id,0),
       ksg.ksg_name,
       ksg.prof_name,
       z.npr_mo,
       z.per,
       z.vbr,
       z.tal_d,
       z.tal_p,
       z.inv,
       Z.rslt_d,
       z.nazr,
       z.naz_sp,
       z.naz_v,
       z.naz_pmp,
       z.naz_pk,
       z.idsp_not_auto,
       Z.age_grp_not_auto,
       z.user_id,
       s.fio,
       z.mse,
       z.barthel_idx ,
       z.code_spec_v021,
       z.id_pac,
       Z.disp,
       z.c_zab,
       z.p_cel
from zs z
join patients p on p.id = z.patient_id
join zs_hdr h on h.id = z.hdr_id
left join invoice inv on inv.id = h.name
left join h_q_u q_u on q_u.id = z.q_u
left join h_target t on t.id = z.target
left join h_idsp i on i.id = z.idsp
left join h_mp m on m.code = z.mp
left join h_order_v o on o.id = z.order_v
left join h_dh_info dh on dh.id = z.dh_info
left join h_spec_v015 cs on cs.code = z.code_spec
left join h_code_otd co on co.code = z.code_prof
left join h_smp_brig sb on sb.id = z.smp_brig
left join h_result r on r.code = z.result
left join h_outcome oc on oc.code = z.outcome
left join h_for_pom fp on fp.code = z.for_pom
left join h_payment_type pt on pt.id = z.payment_type_id
left join v_registry reg on reg.id = z.registry_id
left join doctors_fio df on df.id = z.phys_id
left join zsp zp on zp.zs_id = z.id
left join zsp_resp zpr on zpr.zsp_id = zp.id
left join h_ksg ksg on (cast(ksg.ksg as varchar(50))) = z.ksg and z.q_u = ksg.q_u and z.date_2 between ksg.bp and ksg.epv
left join users s on s.id = z.user_id
where h.is_delete <> 1
;

/* Alter Procedure... */
/* Alter (SP_ADD_NEW_ANALIZ_PARAM) */

ALTER PROCEDURE SP_ADD_NEW_ANALIZ_PARAM(PAT_ANALIZ_ID INTEGER)
 AS
declare variable PARAM_ID integer;
declare variable ANALIZ_ID integer;
begin
  analiz_id = (select a.analiz_id from patients_analiz a where a.id = :pat_analiz_id);

  update PATIENTS_ANALIZ
    set ANALIZ_NAME = (select u.name from h_usl u where u.id = :analiz_id),
        ANALIZ_CODE = (select u.code from h_usl u where u.id = :analiz_id),
        ANALIZ_TARIF = (select u.sumf from h_usl u where u.id = :analiz_id)
    where (ID = :pat_analiz_id);

  if (analiz_id is not null) then
  begin
      FOR select p.id
          from h_usl_params p
          where p.usl_id = :analiz_id
          into :param_id
          do
          update or insert into PATIENTS_ANALIZ_PARAMS (PARAM_ID, HDR_ID)
            values (:PARAM_ID, :pat_analiz_id)
            matching (PARAM_ID, HDR_ID);
    
      param_id = null;
    
      for select d.id
          from H_USL_PARAMS_DOP d
          where d.usl_id = :analiz_id
          into :param_id
          do
            update or insert into PATIENTS_ANALIZ_PARAMS_DOP (PARAM_DOP_ID, PAT_ANALIZ_ID)
             values (:PARAM_ID, :PAT_ANALIZ_ID)
             matching (PARAM_DOP_ID, PAT_ANALIZ_ID);
  end
end;

/* empty dependent procedure body */
/* Clear: SP_CALC_ALL_CH for: SP_CALC_ALL */
ALTER PROCEDURE SP_CALC_ALL_CH(HDR_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* empty dependent procedure body */
/* Clear: SP_ZS_SET_ZACHET for: SP_CALC_ALL */
ALTER PROCEDURE SP_ZS_SET_ZACHET(HDR_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* empty dependent procedure body */
/* Clear: SP_ZSD_LIST_CREATE for: SP_CALC_ALL */
ALTER PROCEDURE SP_ZSD_LIST_CREATE(ZS_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* Alter (SP_CALC_ALL) */
ALTER PROCEDURE SP_CALC_ALL(ZS_ID INTEGER)
 AS
declare variable TAR DM_MONEY_15_2;
declare variable DATE1 DM_DATE;
declare variable Q_U integer;
declare variable TAR_USL DM_MONEY_15_2;
declare variable TARGET integer;
declare variable IDB integer;
declare variable SUM_USLF DM_MONEY_15_2;
declare variable SEX char(1);
declare variable PTYPE integer;
declare variable AGE_Y integer;
declare variable AGE_GRP integer;
declare variable HDR_ID integer;
declare variable TROMB_CODE DM_CHAR_20;
declare variable TAR_USL_DOP DM_MONEY_15_2;
declare variable SUM_USLF_DOP DM_MONEY_15_2;
declare variable IDSP integer;
begin
  select z.date_2, z.q_u, z.target, p.sex, z.payment_type_id, extract(year from z.date_2) - extract(year from p.dr), z.hdr_id
  from zs z
  join patients p on p.id = z.patient_id
  where z.id = :zs_id
  into :date1, :q_u, :target, :sex, :ptype, :age_y, :hdr_id;

  if (:ptype in (2,3)) then exit;

  if (:target in (9,10,11,12,13,14,15,16,17)) then
  begin
   if ((select coalesce(t.days_cnt,0) from h_target t where t.id = :target) <> 0) then
   begin
    update zsd d
     set d.zachet = 1
     where d.date_1 < (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;

    update zsd d
     set d.zachet = 0
     where d.date_1 >= (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;
   end

   update zsd d
    set d.k_uslf = 0
    where (d.zachet = 1 or d.is_no_get_usl = 1) and d.zs_id = :zs_id;
  end

  update zsd d
    set d.tar_usl = null,
        d.sum_uslf = null,
        d.comment_local = null,
        d.dop_tarif = null,
        d.dop_sum = null
    where d.zs_id = :zs_id;

  update zs z
    set z.tar_usl = null,
        z.sum_usl = null,
        z.sum_uslf = null
    where z.id = :zs_id;

  if ((select coalesce(i.is_nz,0) from invoice i join zs_hdr h on h.name = i.id where h.id = :hdr_id) = 1) then
  begin
    if (target in (9,10,11,13,14,15,16,17)) then exit;

    tar = (select first 1 s.tarif from h_tarif_nz s where s.q_u = iif(:q_u = 4,2,:q_u) and :date1 between s.bp and s.epv);

    if (q_u = 1) then
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id and d.code_usl is null;
    else
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id;

    if (q_u = 4) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = z.dcount*:tar
      where id = :zs_id;
    else
    if (q_u = 1) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = :tar
      where id = :zs_id;
    else
      update zs z
      set z.tar_usl = :tar,
          z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
      where id = :zs_id;
    exit;
  end
   /********************,    ************************/
  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 < '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin

          select first 1 h.tarif, h.tarif
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
                                 and cast(h.code_spec as varchar(10)) = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec = '16' and a.age < 18, '22', b.code_spec), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf;

          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0)
           where b.id = :idb;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end

  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 >= '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (:tar is null) then
          select first 1 h.tarif, h.tarif, a.idsp
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
                                 and h.idsp = a.idsp
           join h_tarif_app_spec n on n.name_id = h.name_id
                                 and n.code_spec_v021 = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec_v021 = 39 and a.age < 18, 49, b.code_spec_v021), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf, :idsp;

          update ZSD b set
           b.tar_usl = iif(:idsp = 30, 0, coalesce(:tar, 0)),
           b.sum_uslf = iif(:idsp = 30, 0, coalesce(:sum_uslf, 0)),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          tar = null;

          if (:idsp <> 30) then
            sum_uslf = null;
        end

     if (:idsp = 30) then
       update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0)
           where b.id = :idb;

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end  

  /********************************************/
  if (:q_u = 4) then
  begin
    tar = (select s.tarif from h_tarif_stom s where :date1 between s.bp and s.epv);

    update zsd d
    set d.tar_usl = :tar,
        d.sum_uslf = d.k_uslf*:tar
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = :tar,
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if (:q_u = 5) then
  begin
--    if (:date1 >= '01.01.2018') then tromb_code = 'A25.30.036';
--    else tromb_code = 'A25.30.035';
    tromb_code = coalesce((select first 1 code_usl from zsd d where d.zs_id = :zs_id and coalesce(code_usl, '') <> ''),'');

    tar = (select s.tarif from h_tarif_smp s where :date1 between s.bp and s.epv);
    tar_usl = coalesce((select coalesce(u.sumf,0) from h_usl u where u.code = :tromb_code
               and u.q_u containing '5' and :date1 between u.datebeg and u.dateend),0);

    update zsd d
    set d.tar_usl = iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl),
        d.sum_uslf = d.k_uslf*iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl)
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = (select max(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if ((:q_u = 1) and ((select 1 from zs z where coalesce(z.metod_hmp,0) > 0 and id = :zs_id) = 1)) then
  begin
    select first 1 v.tarif
    from zs z
         join h_metod_hmp h on h.code = z.metod_hmp and z.date_2 between h.bp and h.epv
         join h_tarif_vmp v on v.tg = h.tg and z.date_2 between v.bp and v.epv
    where z.id = :zs_id
    into :tar;

    update zs a set
        a.tar_usl = :tar,
        a.sum_uslf = :tar,
        a.ksg = null,
        a.kslp = null
    where a.id = :zs_id;

    update zsd b set
          b.ksg = null,
          b.sum_uslf = :tar,
          b.kskp = 0,
          b.tar_usl = :tar
    where b.zs_id = :zs_id and coalesce(b.code_usl,'') = '' and b.date_1 = (select min(date_1) from zsd where zs_id = :zs_id and coalesce(code_usl,'') = '');

    exit;
  end

  /********************************************/
  if (:q_u in (1,3) and :date1 < '01.01.2018') then
    execute procedure SP_CALC_STAC(:zs_id);
  else
    if (:q_u in (1,3) and :date1 >= '01.01.2018') then
      execute procedure sp_calc_stac_2018(:zs_id);

  /****************  ***********************************************/
  if (q_u <> 4) then
  begin
  tar = null;
  sum_uslf = null;
  for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (coalesce(:tar,0) > 0) then
          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          tar = null;
          sum_uslf = null;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
   end

  /*********************-*********************************/
  if ((:q_u = 2) and (:target in (21,22))) then
  begin
   for select b.id
    from zsd b
    join zs z on z.id = b.zs_id
    where z.id = :zs_id
    into :idb
    do
    begin
      tar = (select first 1 t.tarif
             from zsd d
                  join h_tomo_code c on c.nms_code = d.code_usl
                  join h_tarif_tomo t on t.group_num = c.group_num and d.date_2 between t.bp and t.epv
             where d.id = :idb);

      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf = :tar
      where d.id = :idb;
    end

    update zs z
    set z.tar_usl = (select sum(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;

    exit;
  end
  /******************** - 9  ************************/
  if (:q_u = 2 and :target = 9) then
  begin
    execute procedure sp_calc_app_t09(:zs_id);
    exit;
  end

  /******************** - 10,17  -  ************************/
    if (q_u = 2 and target in (10,17)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_10 d on d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and :age_y between d.y1 and d.y2
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 13  ************************/
    if (q_u = 2 and target = 13) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                           and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_13_17 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.age_grp = a.age_grp
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 14,15  ,  ************************/
    if (q_u = 2 and target in (14,15)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_14_15 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.cat_info = a.cat_info
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
  /******************** - 16  ************************/
    if (q_u = 2 and target = 16) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join zs_hdr h on h.id = a.hdr_id
                   join patients p on p.id = a.patient_id
                   join h_tarif_disp_16 d on a.date_2 between d.bp and d.epv
                                          and d.sex = :sex
                                          and cast(d.code_usl as varchar(20)) = b.code_usl
                                          and d.age_l <= (h.y - extract(year from p.dr)) and d.age_r >= (h.y - extract(year from p.dr))
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0) ,
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
end;

/* Alter (SP_CALC_ALL_CH) */
ALTER PROCEDURE SP_CALC_ALL_CH(HDR_ID INTEGER)
 AS
declare variable ZID integer;
begin

 for select z.id
  from zs z
  where z.hdr_id = :hdr_id
  into :zid
  do
    execute procedure SP_CALC_ALL(:ZID);

  update invoice i
  set i.sumv = (select sum(z.sum_uslf) from zs z where z.hdr_id = :hdr_id),
      i.sump = (select sum(z.sum_usl) from zs z where z.hdr_id = :hdr_id)
  where i.id = (select name from zs_hdr h where h.id = :hdr_id);
end;

/* empty dependent procedure body */
/* Clear: SP_CALC_ALL for: SP_CALC_STAC_2018 */
ALTER PROCEDURE SP_CALC_ALL(ZS_ID INTEGER)
 AS
 BEGIN EXIT; END;

/* Alter (SP_CALC_STAC_2018) */
ALTER PROCEDURE SP_CALC_STAC_2018(IDA INTEGER)
 AS
declare variable KSG type of DM_CHAR_50;
declare variable DS type of DM_DS;
declare variable IDB integer;
declare variable SUM_USLF type of DM_MONEY;
declare variable KSKP type of DM_NUM_3_2;
declare variable Q_U integer;
declare variable FINE_KOEF type of DM_NUM_3_2;
declare variable TARIF numeric(15,6);
declare variable Y integer;
declare variable TARIF_USL DM_MONEY;
declare variable DATE2 date;
declare variable IS_TRANSFER DM_INT;
declare variable CL_CNT integer;
declare variable ERR_CODE integer;
declare variable K_DOWN DM_NUM_6_2;
declare variable DS_CLASS DM_CHAR_10;
declare variable KZ DM_NUM_2_5;
declare variable KD DM_NUM_2_5;
declare variable KUS DM_NUM_2_5;
declare variable BS DM_NUM_6_2;
declare variable PROF_NUM integer;
declare variable DATE1 date;
declare variable CODE_USL DM_CHAR_20;
declare variable FINE_KOEF_SET_DOCTOR DM_BOOLEAN;
declare variable IS_ROUND_JANAO integer;
declare variable OKATO DM_OKATO;
begin
  select c.tf_okato
   from zs_hdr h
        join zs z on z.hdr_id = h.id
        join invoice i on i.id = h.name
        join contragents c on c.id = i.contragent_id
   where z.id = :ida
   into :okato;

--   if (:okato is  null) then
--     okato = (select first 1 c.tf_okato from contragents c where c.type_id = 1);

    if (((select first 1 c.org_code from contragents c where c.type_id = 1))  starting '83' ) then
      is_round_janao = 1;

    update zsd d
      set d.ds_class = (select MKB_CLASS from SP_GET_MKB_CLASS(D.ds))
      where d.zs_id = :ida;

    update zsd d
     set d.ksg = null, 
         d.ksg_base = null,
         d.tar_base = null,
         d.sum_base = null,
         d.kskp_base = null,
         d.sum_uslf = 0,
         d.tar_usl = 0,
         d.comment_local = null
     where d.zs_id = :ida;

     cl_cnt = (select count(distinct b.ds_class) from ZSD b where b.ZS_ID = :ida);
     is_transfer = (select sum(iif(b.code_usl is null, 1, 0)) from ZSD b where b.ZS_ID = :ida);
     delete from kslp_koef where zs_id = :ida ;

     select a.q_u, extract(year from a.date_2), a.date_2, coalesce(a.fine_koef_set_doctor,0)
      from zs a
      where a.id = :ida
      into :q_u, :y, :date2, :fine_koef_set_doctor;

     for select sp.KSG, sp.ERR_CODE, b.ds, b.id, iif(:is_round_janao = 1,
                coalesce(bs.tarif * kd.kd * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0),
                cast(coalesce(bs.tarif * kd.kd * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0) as dm_num_6_2)),
                k.kz, kd.kd,
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0),
                bs.tarif, k.k_down, k.prof_num, b.date_1, coalesce(b.code_usl,''), coalesce(b.fine_koef,1)
      from zs a
      join zsd b on a.id = b.zs_id
      join patients p on p.id = a.patient_id
      join lpu_factors lf on lf.q_u = a.q_u and a.date_2 between lf.bp and lf.epv and lf.okato is not distinct from :okato
      join h_tarif_bs bs on bs.q_u = a.q_u and a.date_2 between bs.bp and bs.epv and bs.okato is not distinct from :okato
      join h_tarif_kd kd on a.date_2 between kd.bp and kd.epv and kd.okato is not distinct from :okato
      left join sp_ksg_get(b.ds, p.dr, a.date_2, b.code_usl, p.sex,
                           (select sum(b1.k_uslf) from ZSD b1 where b1.ZS_ID = :ida and b1.ds_class = b.ds_class and b1.code_usl is null), -- -     
                           a.q_u, b.ds2, b.id, b.ksg_criterion,b.ksg_criterion2) sp on 1=1
      left join h_ksg k on k.ksg = sp.ksg and a.date_2 between k.bp and k.epv and k.q_u = a.q_u
      where b.zs_id = :ida
      order by b.code_usl
      into :ksg, :err_code, :ds, :idb, :tarif, :kz, :kd, :kus, :bs, :k_down, :prof_num, :date1, :code_usl, :fine_koef
      do
      begin
        kskp = 1;
--        fine_koef = null;

        if ((q_u = 1) and (err_code is null) and (date2 < '01.01.2019')) then
          kskp = (select KSKP from sp_calc_stac_kskp_2018(:ida, :idb, :ksg, :cl_cnt));

        if ((q_u in (1,3)) and (err_code is null) and (date2 >= '01.01.2019')) then
          kskp = (select KSKP from sp_calc_stac_kskp_2019(:ida, :idb, :ksg, :cl_cnt));

        if (kskp is null) then kskp = 1;

        if (fine_koef_set_doctor = 0) then
          fine_koef = (select FINE_KOEF from sp_calc_stac_fine_2018(:ida, :idb, :ksg, :cl_cnt));

        if (is_round_janao = 1) then
          sum_uslf = cast(cast(tarif * kskp as int) * fine_koef as int);
        else
          sum_uslf = tarif * kskp * fine_koef;

        if (:ksg is not null) then
        begin
            /*$$IBEC$$ if (:code_usl <> '') then
            begin
                select first 1 d.id, iif(:fine_koef_set_doctor = 1, d.fine_koef, :fine_koef)
                from zs z
                     join zsd d on d.zs_id = z.id
                where d.zs_id = :ida and coalesce(d.code_usl,'') = ''
                       and :date1 between d.date_1 and d.date_2
                       and not exists(select id from zsd d2 where d2.zs_id = :ida and coalesce(d2.code_usl,'') = '' and d2.date_1 = d.date_2)
                into :idb, :fine_koef;

                if (is_round_janao = 1) then
                  sum_uslf = cast(cast(tarif * kskp as int) * fine_koef as int);
                else
                  sum_uslf = tarif * kskp * fine_koef;
            end $$IBEC$$*/

            if ((select first 1 d.id from zsd d where d.zs_id = :ida and d.ksg_base = :ksg) is null) then
            update zsd b set
             b.ksg_base = :ksg,
             b.tar_base = iif(:date2 >= '01.05.2018', iif(:is_round_janao = 1, cast(:tarif * coalesce(:kskp,1) as int), :tarif * coalesce(:kskp,1)), iif(:is_round_janao = 1, cast(:tarif as integer), :tarif)),
             b.sum_base = :sum_uslf,
             b.kskp_base = :kskp,
             b.koef_z = :kz, 
             b.koef_d = :kd,
             b.koef_u = :kus,
             b.bs = :bs,
             b.koef_up = :k_down,
             b.reab = iif(:prof_num = 37,1,null),
             b.fine_koef = :fine_koef
             where b.id = :idb;
         end
      end 
--------------------------------------------------------------------------------
      --    6  + 
      if (q_u = 1) then
       if (exists (select 1 from zsd b where b.zs_id = :ida and ((b.ksg in ('2','st02.001') and b.k_uslf >= 6) or (b.ksg in ('O14.1','O34.2','O36.3','O36.4','O42.2') and b.k_uslf >= 2) ))
          and exists (select 1 from zsd b where b.zs_id = :ida and b.ksg in ('4', '5', 'st02.003', 'st02.004'))) then
          begin
            --    
            select first 1 b.ksg_base, b.ds
            from zs a
             join zsd b on a.id = b.zs_id
             where b.zs_id = :ida and b.ksg in ('4', '5', 'st02.003', 'st02.004')
             into :ksg, :ds;
       
            update zsd d
            set d.tar_usl = d.tar_base,
                d.sum_uslf = d.sum_base,
                d.ksg = d.ksg_base,
                d.kskp = d.kskp_base
            where d.zs_id = :ida;

            --   
            select coalesce(sum(b.sum_uslf), 0) from zsd b where b.zs_id = :ida
             into :sum_uslf;
    
            update zs a set
             a.tar_usl = :tarif,
             a.sum_uslf = :sum_uslf,
             a.sum_usl = :sum_uslf,
             a.ksg = :ksg,
             a.ds1 = :ds,
             a.kslp = :kskp
             where a.id = :ida;

            exit;
          end
--------------------------------------------------------------------------------
      if ((is_transfer < 2) or (cl_cnt < 2))  then  --   
      begin
        --     ,   
        ksg = null;
        select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base, b.kskp_base, b.koef_z, b.koef_d, b.koef_u, b.bs, b.koef_up,
             b.fine_koef
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and ((:q_u = 1 and b.ksg_base >= '325' and b.ksg_base <= '343') or
                                                                                                  (:q_u = 3 and b.ksg_base >= '123' and b.ksg_base <= '134'))
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif, :kskp, :kz, :kd, :kus, :bs, :k_down, :fine_koef;

        if (:ksg is null)  then
        begin
         select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base, b.date_1,
             b.kskp_base, b.koef_z, b.koef_d, b.koef_u, b.bs, b.koef_up,
             b.fine_koef
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif, :date1,
                  :kskp, :kz, :kd, :kus, :bs, :k_down, :fine_koef;

         if (((select coalesce(d.code_usl,'') from zsd d where d.id = :idb) <> '')
            and (exists(select d.id from zsd d where d.zs_id = :ida and d.id <> :idb and coalesce(d.code_usl,'') = '' and :date1 between d.date_1 and d.date_2))) then
         select first 1 d.id
             from zsd d
             where d.zs_id = :ida and d.id <> :idb and coalesce(d.code_usl,'') = '' and :date1 between d.date_1 and d.date_2
             into :idb;
        end

         --      
         update zsd b set
             b.ksg = :ksg,
             b.sum_uslf = :sum_uslf,
             b.ksg_base = :ksg,
             b.tar_usl = :tarif,
             b.sum_base = :sum_uslf,
             b.kskp_base = :kskp,
             b.koef_z = :kz, 
             b.koef_d = :kd,
             b.koef_u = :kus,
             b.bs = :bs,
             b.koef_up = :k_down,
             b.reab = iif(:prof_num = 37,1,null),
             b.fine_koef = :fine_koef
          where b.id = :idb;

         update zsd b set
             b.ksg = null,
             b.sum_uslf = 0,
             b.kskp = 1,
             b.tar_usl = 0,
             b.ksg_base = null,
             b.tar_base = null,
             b.sum_base = 0,
             b.kskp_base = null,
             b.koef_z = null,
             b.koef_d = null,
             b.koef_u = null,
             b.bs = null,
             b.koef_up = null,
             b.fine_koef = null
          where b.id <> :idb and b.zs_id = :ida;
 
         update zs a set
          a.tar_usl = :tarif,
          a.sum_uslf = :sum_uslf,
          a.sum_usl = :sum_uslf,
          a.ksg = :ksg,
          a.kslp = :kskp
          where a.id = :ida;
 
      end else
      begin
        for select d.ds_class
         from zsd d
         where d.zs_id = :ida
         group by 1
         into :ds_class
         do
         begin
            if (((select count(dc.id) from ksg_dont_choice dc join zsd z on z.ksg_base = dc.ksg_ter or z.ksg_base = dc.ksg_surg
                    where z.zs_id = :ida and z.ds_class = :ds_class and :date2 between dc.bp and dc.epv) > 0) and (:q_u = 1)) then
               --    
            select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and b.ds_class = :ds_class and b.code_usl is not null
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;
            else
               --     
            begin
              select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base, b.date_1,
                 b.kskp_base, b.koef_z, b.koef_d, b.koef_u, b.bs, b.koef_up,
                 b.fine_koef
                 from zsd b
                 where b.zs_id = :ida and b.ksg_base is not null and b.ds_class = :ds_class
                 order by b.code_usl desc, b.sum_base desc
                 into :idb, :ksg, :sum_uslf, :tarif, :date1,
                      :kskp, :kz, :kd, :kus, :bs, :k_down, :fine_koef;
    
             if (((select coalesce(d.code_usl,'') from zsd d where d.id = :idb) <> '')
                and (exists(select d.id from zsd d where d.zs_id = :ida and d.id <> :idb and coalesce(d.code_usl,'') = '' and :date1 between d.date_1 and d.date_2))) then
             select first 1 d.id
                 from zsd d
                 where d.zs_id = :ida and d.id <> :idb and coalesce(d.code_usl,'') = '' and :date1 between d.date_1 and d.date_2
                 into :idb;
            end
    
             --      
             update zsd b set
                 b.ksg = :ksg,
                 b.sum_uslf = :sum_uslf,
                 b.ksg_base = :ksg,
                 b.tar_usl = :tarif,
                 b.sum_base = :sum_uslf,
                 b.kskp_base = :kskp,
                 b.koef_z = :kz, 
                 b.koef_d = :kd,
                 b.koef_u = :kus,
                 b.bs = :bs,
                 b.koef_up = :k_down,
                 b.reab = iif(:prof_num = 37,1,null),
                 b.fine_koef = :fine_koef
              where b.id = :idb;
    
             update zsd b set
                 b.ksg = null,
                 b.sum_uslf = 0,
                 b.kskp = 1,
                 b.tar_usl = 0,
                 b.ksg_base = null,
                 b.tar_base = null,
                 b.sum_base = 0,
                 b.kskp_base = null,
                 b.koef_z = null,
                 b.koef_d = null,
                 b.koef_u = null,
                 b.bs = null,
                 b.koef_up = null,
                 b.fine_koef = null
              where b.id <> :idb and b.zs_id = :ida and b.ds_class = :ds_class;
         end

        select first 1 b.ksg_base, b.sum_base
        from zs a
         join zsd b on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null and b.ds = a.ds1
         order by b.sum_base desc
         into :ksg, :sum_uslf;

--        update zsd d
--         set d.tar_usl = d.tar_base,
--             d.sum_uslf = d.sum_base,
--             d.ksg = d.ksg_base,
--             d.kskp = d.kskp_base
--         where d.zs_id = :ida;
   
        select coalesce(sum(b.sum_uslf), 0), coalesce(sum(b.tar_base), 0)
         from zsd b
         join zs a on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null
         into :sum_uslf, :tarif;

        update zs a set
         a.tar_usl = :tarif,
         a.sum_uslf = :sum_uslf,
         a.sum_usl = :sum_uslf,
         a.ksg = :ksg,
         a.kslp = :kskp
         where a.id = :ida;
 
      end
end;

/* empty dependent procedure body */
/* Clear: SP_CALC_STAC_2018 for: SP_CALC_STAC_KSKP_2019 */
ALTER PROCEDURE SP_CALC_STAC_2018(IDA INTEGER)
 AS
 BEGIN EXIT; END;

/* Alter (SP_CALC_STAC_KSKP_2019) */
ALTER PROCEDURE SP_CALC_STAC_KSKP_2019(IDA INTEGER,
IDB INTEGER,
KSG DM_CHAR_20,
CL_CNT INTEGER)
 RETURNS(KSKP TYPE OF DM_NUM_3_2)
 AS
declare variable KSKP1 type of DM_NUM_3_2;
declare variable KSKP2 type of DM_NUM_3_2;
declare variable KSKP3 type of DM_NUM_3_2;
declare variable KSKP4 type of DM_NUM_3_2;
declare variable KSKP5 type of DM_NUM_3_2;
declare variable KSKP6 type of DM_NUM_3_2;
declare variable KSKP7 type of DM_NUM_3_2;
declare variable KSLP12 DM_NUM_3_2;
declare variable KSLP13 DM_NUM_3_2;
declare variable KSLP14 DM_NUM_3_2;
declare variable ORIT DM_INT;
declare variable OKATO DM_OKATO;
begin
 okato = (select first 1 c.tf_okato from contragents c where c.type_id = 1);

 kskp6 = 1;

 if (:okato = '29000') then
 select
       --    
       iif((a.q_u = 1) and (a.age < 1) and ((select first 1 d.ksg from h_ksg_dop d where d.type_num = 2 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null),
           (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 1 and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 1) and (a.age >= 1) and (a.age < 4), (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 2  and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 1) and (a.age < 4 and a.age < 18 and coalesce(a.chield_with_rop,0) = 1), (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 3  and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 1) and (a.age >= 75) and ((select first 1 d.ksg from h_ksg_dop d where d.type_num = 3 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 4  and a.date_2 between t.bp and t.epv), 1),    -- 4
       iif((a.q_u = 1) and (a.ds1 <> 'R54' and a.ds2 = 'R54' and exists(select first 1 id from zsd b where b.zs_id = a.id and b.profil_k = 16) and
           ((select first 1 d.ksg from h_ksg_dop d where d.type_num = 4 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null)),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 5  and a.date_2 between t.bp and t.epv), 1), --5
       iif((a.q_u = 3) and exists(select b.code_usl from zsd b where b.zs_id = a.id and b.code_usl in ('A11.20.017')),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 316  and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 3) and exists(select b.code_usl from zsd b where b.zs_id = a.id and b.code_usl in ('A11.20.017.083')),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 319  and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 3) and exists(select b.code_usl from zsd b where b.zs_id = a.id and b.code_usl in ('A11.20.030.001')),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 75  and a.date_2 between t.bp and t.epv), 1)
  from zs a
  join patients p on p.id = a.patient_id
  left join zs_hdr h on h.id = a.hdr_id
  left join invoice i on i.id = h.name
  where a.id = :ida
  into :kskp1, :kskp2, :kskp3, :kskp4, :kskp5, :kslp12, :kslp13, :kslp14;

  if (:okato = '71140') then
 select
       --    
       iif((a.q_u = 1) and (a.age < 1) and ((select first 1 d.ksg from h_ksg_dop d where d.type_num = 2 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null),
           (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 1 and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 1) and (a.age >= 1) and (a.age < 4), (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 2  and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 1) and (a.age < 4 and a.age < 18 and coalesce(a.chield_with_rop,0) = 1), (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 3  and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 1) and (a.age >= 75) and ((select first 1 d.ksg from h_ksg_dop d where d.type_num = 3 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 4  and a.date_2 between t.bp and t.epv), 1),    -- 4
       iif((a.q_u = 1) and (a.ds1 <> 'R54' and a.ds2 = 'R54' and exists(select first 1 id from zsd b where b.zs_id = a.id and b.profil_k = 16) and
           ((select first 1 d.ksg from h_ksg_dop d where d.type_num = 4 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null)),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 5  and a.date_2 between t.bp and t.epv), 1), --5
       iif((a.q_u = 3) and exists(select b.code_usl from zsd b where b.zs_id = a.id and b.code_usl in ('A25.20.004.001','A11.20.019','A11.20.028')),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 12  and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 3) and exists(select b.code_usl from zsd b where b.zs_id = a.id and b.code_usl in ('A11.20.017.001')),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 13  and a.date_2 between t.bp and t.epv), 1),
       iif((a.q_u = 3) and exists(select b.code_usl from zsd b where b.zs_id = a.id and b.code_usl in ('A11.20.030.001')),
            (select first 1 t.z_sl from h_kslp_type t where t.idkslp = 14  and a.date_2 between t.bp and t.epv), 1)
  from zs a
  join patients p on p.id = a.patient_id
  left join zs_hdr h on h.id = a.hdr_id
  left join invoice i on i.id = h.name
  where a.id = :ida
  into :kskp1, :kskp2, :kskp3, :kskp4, :kskp5, :kslp12, :kslp13, :kslp14;

     if (((select z.q_u from zs z where id = :ida)) = 1) then
     begin
         orit = (select sum(d.k_uslf) from zsd d where d.zs_id = :ida and d.code_usl = 'B03.003.005' and d.date_1 between (select d1.date_1 from zsd d1 where d1.id = :idb) and
                                                                                                                 (select d1.date_2 from zsd d1 where d1.id = :idb) );
         if (idb is not null) then
          select
                --  
                case
                  when (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) > 30 and ((select d.ksg from h_ksg_dop d where d.type_num = 5 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is null)) then
                        case
                          when (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - coalesce(:orit,0)) >= coalesce(:orit,0) then 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 30) * 0.25 / 30
                          else 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 30) * 0.4 / 30
                        end
                  when (b.k_uslf > 45 and ((select d.ksg from h_ksg_dop d where d.type_num = 5 and a.date_2 between d.bp and d.epv and d.q_u = 1 and d.ksg = :ksg) is not null)) then
                        case
                          when (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - coalesce(:orit,0)) >= coalesce(:orit,0) then 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 45) * 0.25 / 45
                          else 1 + (iif(:cl_cnt < 2, a.k_uslf, b.k_uslf) - 45) * 0.4 / 45
                        end
                  else 1
                end
           from zs a
           join zsd b on a.id = b.zs_id
           where b.id = :idb
           into :kskp6;
    
    
         kskp = kskp1 + (kskp2-1) + (kskp3-1) + (kskp4-1) + (kskp5-1);
         if (kskp > 1.8) then
          kskp = 1.8;
         kskp = kskp + (kskp6-1);
         
         delete from kslp_koef where zs_id = :ida and ksg = :ksg;
         
         if (:kskp1 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (1, :kskp1, :ida, :ksg);
         if (:kskp2 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (2, :kskp2, :ida, :ksg);
         if (:kskp3 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (3, :kskp3, :ida, :ksg);
         if (:kskp4 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (4, :kskp4, :ida, :ksg);
         if (:kskp5 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (5, :kskp5, :ida, :ksg);
         if (:kskp6 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (6, :kskp6, :ida, :ksg);
    end
    else
    begin
      delete from kslp_koef where zs_id = :ida and ksg = :ksg;

     if (okato = '29000') then
     begin
         if (:kslp12 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (316, :kslp12, :ida, :ksg);
         if (:kslp13 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (319, :kslp13, :ida, :ksg);
         if (:kslp14 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (75, :kslp14, :ida, :ksg);
     end

     if (okato = '71140') then
     begin
         if (:kslp12 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (12, :kslp12, :ida, :ksg);
         if (:kslp13 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (13, :kslp13, :ida, :ksg);
         if (:kslp14 <> 1) then
             insert into KSLP_KOEF (IDKSLP, Z_KSLP, ZS_ID, KSG)
                values (14, :kslp14, :ida, :ksg);
     end

     kskp = coalesce((kslp12 + (kslp13-1) + (kslp14-1)),1);
    end
    suspend;        
end;

/* Alter (SP_EXTRACT_USL_DATA) */
ALTER PROCEDURE SP_EXTRACT_USL_DATA(USL_ID INTEGER)
 RETURNS(STR DM_CHAR_450)
 AS
declare variable MAIN_ID integer;
declare variable PARAM_ID integer;
declare variable STR_TMP DM_CHAR_250;
declare variable PARAM2_ID integer;
declare variable PARAM3_ID integer;
declare variable PARAM4_ID integer;
begin
  str = 'execute block
        as
        declare variable usl_id integer;
        declare variable first_id integer;
        declare variable first1_id integer;
        declare variable first2_id integer;
        declare variable first3_id integer;
        declare variable first4_id integer;
        begin';
  suspend;

  str = 'insert into H_USL (ID, NAME, IS_USL, Q_U, TARGET, CODE, DATEBEG, DATEEND, SUMF, PAYMENT_TYPE_ID, IS_ANALIZ) ';
  suspend;

  str = (select 'values (null,''' ||  NAME || ''', ' || IS_USL || ', ' || iif(Q_U is null,'null','''' || Q_U || '''') || ', ' ||
                iif(TARGET is null, 'null', '''' || target || '''') || ', ''' || CODE || ''', ''' ||
                DATEBEG || ''', ''' || DATEEND || ''', ' || SUMF || ', ' ||
                PAYMENT_TYPE_ID || ', ' || IS_ANALIZ || ') returning ID into :USL_ID;'
        from H_USL where id = :usl_id);
  suspend;

  str = 'INSERT INTO H_USL_PARAMS (ID, USL_ID, NAME, UNIT_NAME, CAPTION, CAPTION_INCREASE, CAPTION_DECREASE, PARENT_ID, PARAM_TYPE, NN) ';
  suspend;

  str = (select 'values ( null, :usl_id, ''' || NAME || ''', ' || iif(unit_name is null, 'null', ''|| unit_name ||'') || ',' ||
                iif(caption is null, 'null', ''|| caption ||'') || ', ' || iif(caption_increase is null, 'null', ''|| caption_increase ||'') ||
                ',' || iif(caption_decrease is null, 'null', ''|| caption_decrease ||'') || ', null,' ||
                 iif(p.param_type is null, 'null', p.param_type) || ', ' || iif(nn is null, 'null', nn) || ') returning ID into :FIRST_ID;'
         from H_USL_PARAMS p
         where p.usl_id = :usl_id and p.parent_id is null);
  suspend;

  main_id = (select id from h_usl_params p where p.usl_id = :usl_id and p.parent_id is null);

  str = 'INSERT INTO H_USL_PARAMS (ID, USL_ID, NAME, UNIT_NAME, CAPTION, CAPTION_INCREASE, CAPTION_DECREASE, PARENT_ID, PARAM_TYPE, NN) ';

  for select 'values ( null, :usl_id, ''' || NAME || ''', ' || iif(unit_name is null, 'null', ''''|| unit_name ||'''') || ',' ||
                iif(caption is null, 'null', ''''|| caption ||'''') || ', ' || iif(caption_increase is null, 'null', ''''|| caption_increase ||'''') ||
                ',' || iif(caption_decrease is null, 'null', ''''|| caption_decrease ||'''') || ',:first_id,' ||
                 iif(p.param_type is null, 'null', p.param_type) || ', ' || iif(nn is null, 'null', nn) || ') returning ID into :FIRST1_ID;', p.id
       from h_usl_params p
       where p.parent_id = :main_id
       into :str_tmp, :param_id
       do
       begin
         suspend;

         str = :str_tmp;
         suspend;

         if ((select first 1 id from h_usl_params_norm n where n.usl_params_id = :param_id) is not null) then
         begin
             str = 'insert into H_USL_PARAMS_NORM (ID, USL_PARAMS_ID, MIN_VALUE, MAX_VALUE, AGE_CATEGORY_ID, MEANING, CAPTION, IS_NORM, NORM_VALUE, CATEGORY_ID) ';

             for select 'values (null, :FIRST1_ID, ' || iif(MIN_VALUE is null, 'null', MIN_Value) || ', ' || iif(MAX_VALUE is null, 'null', MAX_Value) ||
                        ', null, ' || iif(MEANING is null,'null', '''' || MEANING || '''') ||
                        ', ' || iif(CAPTION is null, 'null', '''' || CAPTION || '''') || ', ' || IS_NORM || ', ' || iif(NORM_VALUE is null, 'null', NORM_VALUE) || ', null);'
                        from H_USL_PARAMS_NORM n
                 where n.usl_params_id = :param_id
                 into :str_tmp
                 do
                 begin
                   suspend;

                   str = :str_tmp;
                   suspend;
                   str = 'insert into H_USL_PARAMS_NORM (ID, USL_PARAMS_ID, MIN_VALUE, MAX_VALUE, AGE_CATEGORY_ID, MEANING, CAPTION, IS_NORM, NORM_VALUE, CATEGORY_ID) ';
                 end
         end
         -------------------------------------2-------------------------------------------
         if ((select first 1 id from h_usl_params p where p.usl_id = :usl_id and p.parent_id = :param_id) is not null) then
         begin
             str = 'INSERT INTO H_USL_PARAMS (ID, USL_ID, NAME, UNIT_NAME, CAPTION, CAPTION_INCREASE, CAPTION_DECREASE, PARENT_ID, PARAM_TYPE, NN) ';

             for select 'values ( null, :usl_id, ''' || NAME || ''', ' || iif(unit_name is null, 'null', ''''|| unit_name ||'''') || ',' ||
                iif(caption is null, 'null', ''''|| caption ||'''') || ', ' || iif(caption_increase is null, 'null', ''''|| caption_increase ||'''') ||
                ',' || iif(caption_decrease is null, 'null', ''''|| caption_decrease ||'''') || ',:first1_id,' ||
                 iif(p.param_type is null, 'null', p.param_type) || ', ' || iif(nn is null, 'null', nn) || ') returning ID into :FIRST2_ID;', p.id
               from h_usl_params p
               where p.parent_id = :param_id
               into :str_tmp, :param2_id
               do
               begin
                 suspend;
        
                 str = :str_tmp;
                 suspend;
        
                 if ((select first 1 id from h_usl_params_norm n where n.usl_params_id = :param2_id) is not null) then
                 begin
                     str = 'insert into H_USL_PARAMS_NORM (ID, USL_PARAMS_ID, MIN_VALUE, MAX_VALUE, AGE_CATEGORY_ID, MEANING, CAPTION, IS_NORM, NORM_VALUE, CATEGORY_ID) ';
        
                     for select 'values (null, :FIRST2_ID, ' || iif(MIN_VALUE is null, 'null', MIN_Value) || ', ' || iif(MAX_VALUE is null, 'null', MAX_Value) ||
                                ', null, ' || iif(MEANING is null,'null', '''' || MEANING || '''') ||
                                ', ' || iif(CAPTION is null, 'null', '''' || CAPTION || '''') || ', ' || IS_NORM || ', ' || iif(NORM_VALUE is null, 'null', NORM_VALUE) || ', null);'
                                from H_USL_PARAMS_NORM n
                         where n.usl_params_id = :param2_id
                         into :str_tmp
                         do
                         begin
                           suspend;
        
                           str = :str_tmp;
                           suspend;
                           str = 'insert into H_USL_PARAMS_NORM (ID, USL_PARAMS_ID, MIN_VALUE, MAX_VALUE, AGE_CATEGORY_ID, MEANING, CAPTION, IS_NORM, NORM_VALUE, CATEGORY_ID) ';
                         end
                 end
        
                 --------------------------------3-----------------------------------------
                 if ((select first 1 id from h_usl_params p where p.usl_id = :usl_id and p.parent_id = :param2_id) is not null) then
                 begin
                     str = 'INSERT INTO H_USL_PARAMS (ID, USL_ID, NAME, UNIT_NAME, CAPTION, CAPTION_INCREASE, CAPTION_DECREASE, PARENT_ID, PARAM_TYPE, NN) ';
        
                     for select 'values ( null, :usl_id, ''' || NAME || ''', ' || iif(unit_name is null, 'null', ''''|| unit_name ||'''') || ',' ||
                iif(caption is null, 'null', ''''|| caption ||'''') || ', ' || iif(caption_increase is null, 'null', ''''|| caption_increase ||'''') ||
                ',' || iif(caption_decrease is null, 'null', ''''|| caption_decrease ||'''') || ',:first2_id,' ||
                 iif(p.param_type is null, 'null', p.param_type) || ', ' || iif(nn is null, 'null', nn) || ') returning ID into :FIRST3_ID;', p.id
                       from h_usl_params p
                       where p.parent_id = :param2_id
                       into :str_tmp, :param3_id
                       do
                       begin
                         suspend;
                
                         str = :str_tmp;
                         suspend;
                
                         if ((select first 1 id from h_usl_params_norm n where n.usl_params_id = :param2_id) is not null) then
                         begin
                             str = 'insert into H_USL_PARAMS_NORM (ID, USL_PARAMS_ID, MIN_VALUE, MAX_VALUE, AGE_CATEGORY_ID, MEANING, CAPTION, IS_NORM, NORM_VALUE, CATEGORY_ID) ';
                
                             for select 'values (null, :FIRST3_ID, ' || iif(MIN_VALUE is null, 'null', MIN_Value) || ', ' || iif(MAX_VALUE is null, 'null', MAX_Value) ||
                                        ', null, ' || iif(MEANING is null,'null', '''' || MEANING || '''') ||
                                        ', ' || iif(CAPTION is null, 'null', '''' || CAPTION || '''') || ', ' || IS_NORM || ', ' || iif(NORM_VALUE is null, 'null', NORM_VALUE) || ', null);'
                                        from H_USL_PARAMS_NORM n
                                 where n.usl_params_id = :param3_id
                                 into :str_tmp
                                 do
                                 begin
                                   suspend;
                
                                   str = :str_tmp;
                                   suspend;
                                   str = 'insert into H_USL_PARAMS_NORM (ID, USL_PARAMS_ID, MIN_VALUE, MAX_VALUE, AGE_CATEGORY_ID, MEANING, CAPTION, IS_NORM, NORM_VALUE, CATEGORY_ID) ';
                                 end
                         end
                
                         ----------------------------4-------------------------------------------------

                         if ((select first 1 id from h_usl_params p where p.usl_id = :usl_id and p.parent_id = :param3_id) is not null) then
                         begin
                             str = 'INSERT INTO H_USL_PARAMS (ID, USL_ID, NAME, UNIT_NAME, CAPTION, CAPTION_INCREASE, CAPTION_DECREASE, PARENT_ID, PARAM_TYPE, NN) ';
                
                             for select 'values ( null, :usl_id, ''' || NAME || ''', ' || iif(unit_name is null, 'null', ''''|| unit_name ||'''') || ',' ||
                        iif(caption is null, 'null', ''''|| caption ||'''') || ', ' || iif(caption_increase is null, 'null', ''''|| caption_increase ||'''') ||
                        ',' || iif(caption_decrease is null, 'null', ''''|| caption_decrease ||'''') || ',:first3_id,' ||
                         iif(p.param_type is null, 'null', p.param_type) || ', ' || iif(nn is null, 'null', nn) || ') returning ID into :FIRST4_ID;', p.id
                               from h_usl_params p
                               where p.parent_id = :param3_id
                               into :str_tmp, :param4_id
                               do
                               begin
                                 suspend;
                        
                                 str = :str_tmp;
                                 suspend;
                        
                                 if ((select first 1 id from h_usl_params_norm n where n.usl_params_id = :param2_id) is not null) then
                                 begin
                                     str = 'insert into H_USL_PARAMS_NORM (ID, USL_PARAMS_ID, MIN_VALUE, MAX_VALUE, AGE_CATEGORY_ID, MEANING, CAPTION, IS_NORM, NORM_VALUE, CATEGORY_ID) ';
                        
                                     for select 'values (null, :FIRST4_ID, ' || iif(MIN_VALUE is null, 'null', MIN_Value) || ', ' || iif(MAX_VALUE is null, 'null', MAX_Value) ||
                                                ', null, ' || iif(MEANING is null,'null', '''' || MEANING || '''') ||
                                                ', ' || iif(CAPTION is null, 'null', '''' || CAPTION || '''') || ', ' || IS_NORM || ', ' || iif(NORM_VALUE is null, 'null', NORM_VALUE) || ', null);'
                                                from H_USL_PARAMS_NORM n
                                         where n.usl_params_id = :param4_id
                                         into :str_tmp
                                         do
                                         begin
                                           suspend;
                        
                                           str = :str_tmp;
                                           suspend;
                                           str = 'insert into H_USL_PARAMS_NORM (ID, USL_PARAMS_ID, MIN_VALUE, MAX_VALUE, AGE_CATEGORY_ID, MEANING, CAPTION, IS_NORM, NORM_VALUE, CATEGORY_ID) ';
                                         end
                                 end
                        
                        
                            
                                 str = 'INSERT INTO H_USL_PARAMS (ID, USL_ID, NAME, UNIT_NAME, CAPTION, CAPTION_INCREASE, CAPTION_DECREASE, PARENT_ID, PARAM_TYPE, NN) ';
                               end
                           end

                         ----------------------------4-------------------------------------------------
                    
                         str = 'INSERT INTO H_USL_PARAMS (ID, USL_ID, NAME, UNIT_NAME, CAPTION, CAPTION_INCREASE, CAPTION_DECREASE, PARENT_ID, PARAM_TYPE, NN) ';
                       end
                   end

                 --------------------------------3-----------------------------------------
            
                 str = 'INSERT INTO H_USL_PARAMS (ID, USL_ID, NAME, UNIT_NAME, CAPTION, CAPTION_INCREASE, CAPTION_DECREASE, PARENT_ID, PARAM_TYPE, NN) ';
               end
           end
         ----------------------------------------2----------------------------------------
         str = 'INSERT INTO H_USL_PARAMS (ID, USL_ID, NAME, UNIT_NAME, CAPTION, CAPTION_INCREASE, CAPTION_DECREASE, PARENT_ID, PARAM_TYPE, NN) ';
       end

  str = 'end';
  suspend;
end
;

/* Alter (SP_REESTR_EXTRACT_FOR_V2018) */
ALTER PROCEDURE SP_REESTR_EXTRACT_FOR_V2018(H_ID INTEGER)
 AS
declare variable D_ID integer;
declare variable ZS_ID integer;
declare variable DATE1 date;
declare variable DATE2 date;
declare variable PHYS_ID integer;
declare variable CODE_SPEC integer;
declare variable HDR_ID integer;
declare variable STAGE integer;
begin
for select h.id
    from zs_hdr h
    where h.id = :h_id or (h.parent_id = :h_id)
    into :hdr_id
    do
    begin
      update zs z
       set z.vb_p = 1
       where z.hdr_id = :hdr_id and (select count(id) from zsd d where d.zs_id = z.id and z.q_u in (1,3) and coalesce(d.code_usl,'') = '') > 1;
      /******************************************************************/
      for select d.id, z.id, d.date_1, d.date_2
          from zs z
               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u in (1,3) and coalesce(d.code_usl,'') = ''
          into :d_id, :zs_id, :date1, :date2
          do
          begin
            update zsd d
             set d.zsd_id = :d_id
             where d.id = :d_id;
    
            update zsd d
             set d.zsd_id = :d_id
             where d.zs_id = :zs_id and coalesce(d.code_usl,'') <> ''
                   and d.date_1 between :date1 and :date2
                   and not exists(select id from zsd d2 where d2.zs_id = :zs_id and coalesce(d2.code_usl,'') = '' and d2.date_1 = :date2);
          end

      for select d.id, z.id, d.date_1, d.date_2
          from zs z
               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u in (1,3) and not exists(select dd.id from zsd dd where dd.zs_id = z.id and coalesce(dd.code_usl,'') = '')
          order by d.ksg desc
          into :d_id, :zs_id, :date1, :date2
          do
          begin
            update zsd d
             set d.zsd_id = :d_id
             where d.id = :d_id;
    
            update zsd d
             set d.zsd_id = :d_id
             where d.zs_id = :zs_id and coalesce(d.code_usl,'') <> ''
                   and d.date_1 between :date1 and :date2
                   and not exists(select id from zsd d2 where d2.zs_id = :zs_id and coalesce(d2.code_usl,'') = '' and d2.date_1 = :date2)
                   and d.ksg is null;
          end
      /***********  ***********************************************/
      for select z.id, d.phys_id, d.code_spec_v021, z.date_1, z.date_2
          from zs z
               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u in (2,4,5) and z.target not in (9,10,11,12,13,14,15,16,17,21,22)
          group by 1,2,3,4,5
          into :zs_id, :phys_id, :code_spec, :date1, :date2
          do
          begin
            d_id = (select first 1 id from zsd d where d.zs_id = :zs_id and d.phys_id = :phys_id and d.code_spec_v021 = :code_spec and d.date_1 between :date1 and :date2);
    
            update zsd d
             set d.zsd_id = :d_id
             where d.zs_id = :zs_id and d.date_1 between :date1 and :date2 and d.phys_id = :phys_id and d.code_spec_v021 = :code_spec;
            d_id = null;
          end
      /***********  ***********************************************/
      for select z.id, z.disp_stage
          from zs z
--               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u in (2) and z.target in (9,10,11,12,13,14,15,16,17) --and d.code_usl in ('1','16')
          group by 1,2
          into :zs_id, :stage
          do
          begin
            d_id = (select first 1 id from zsd d where d.zs_id = :zs_id and (d.code_usl in ('1','16','66','67','68','69') or :stage = 2) order by d.date_1);
            update zsd d
             set d.zsd_id = :d_id
             where d.zs_id = :zs_id;
            d_id = null;
          end
      /***********-***********************************************/
      for select z.id
          from zs z
--               join zsd d on d.zs_id = z.id
          where z.hdr_id = :hdr_id and z.q_u = 2 and z.target in (21,22)
          group by 1
          into :zs_id
          do
          begin
            d_id = (select first 1 id from zsd d where d.zs_id = :zs_id order by d.date_1);
            update zsd d
             set d.zsd_id = :d_id
             where d.zs_id = :zs_id;
            d_id = null;
          end
    end
end
;

/* Alter (SP_REP_INV_FACT) */
ALTER PROCEDURE SP_REP_INV_FACT(HDR_ID INTEGER)
 RETURNS(USL_CODE VARCHAR(50),
USL_NAME VARCHAR(500),
CONTRAGENT_ID INTEGER,
TARIF DM_MONEY_15_2,
USL_CNT DM_NUM_6_2,
SUMV DM_MONEY_15_2)
 AS
begin
  for select u.code, u.name usl_name,  i.contragent_id, u.sumf, sum(d.k_uslf) k_uslf, sum(d.sum_uslf) sum_uslf
        from zs z
        join zsd d on d.zs_id = z.id
        join h_usl u on u.code = d.code_usl
                and u.q_u containing cast(z.q_u as varchar(1)) and u.payment_type_id = z.payment_type_id
                and z.date_1 between u.datebeg and u.dateend  
        join zs_hdr h on h.id = z.hdr_id
        join invoice i on i.id = h.name
        where z.hdr_id = :hdr_id
        group by 1,2,3,4
        into :usl_code, :usl_name ,:contragent_id, :tarif, :usl_cnt, :sumv
        do
          suspend;

  for select p.code, p.name usl_name,  i.contragent_id, lp.sum_total, 1 k_uslf, lp.sum_total sum_uslf
        from zs z
        join lab_orders l on l.biomaterial_date between z.date_1 and z.date_2 and l.patient_id = z.patient_id
        join lab_order_products lp on lp.order_id = l.id
        left join lab_products p on p.id = lp.product_id
        join zs_hdr h on h.id = z.hdr_id
        join invoice i on i.id = h.name
        where z.hdr_id = :hdr_id
        group by 1,2,3,4
        into :usl_code, :usl_name ,:contragent_id, :tarif, :usl_cnt, :sumv
        do
          suspend;
end;

/* Alter (SP_REP_INV_FACT_REESTR) */
ALTER PROCEDURE SP_REP_INV_FACT_REESTR(HDR_ID INTEGER)
 RETURNS(FIO VARCHAR(150),
NUM_SP VARCHAR(20),
HIST_NUM VARCHAR(50),
DATE_1 DATE,
USL_CODE VARCHAR(50),
USL_NAME VARCHAR(500),
TARIF DM_MONEY_15_2,
USL_CNT DM_NUM_6_2,
SUMV DM_MONEY_15_2,
TOOTH_ID DM_CHAR_250,
DS VARCHAR(7),
DOC_FIO VARCHAR(150),
NPP INTEGER)
 AS
declare variable PID integer;
declare variable N integer;
begin
  n = 1;
  npp = 1;

  for select p.id, p.fam || ' ' || p.im || ' ' || p.ot fio
      from zs z
            join zsd d on d.zs_id = z.id
            join h_usl u on u.code = d.code_usl
                    and u.q_u containing cast(z.q_u as varchar(1)) and u.payment_type_id = z.payment_type_id
                    and z.date_1 between u.datebeg and u.dateend  
            join patients p on p.id = z.patient_id
      where z.hdr_id = :HDR_ID
      group by 1,2
      into :pid, :fio
      do
      begin
      for select
          iif(z.payment_type_id <> 2, p.num_sp, (select coalesce(ins.ser, '') || ' ' || ins.num from patients_insurance ins where ins.patients_id = p.id and z.date_1 between ins.db and ins.de)),
          p.hist_num, d.date_1, u.code,
          u.name usl_name, d.k_uslf, u.sumf, d.sum_uslf,
          substring(d.tooth_list from 1 for char_length(d.tooth_list ) - 1), d.ds, doc.fio
            from zs z
            join zsd d on d.zs_id = z.id
            join h_usl u on u.code = d.code_usl
                    and u.q_u containing cast(z.q_u as varchar(1)) and u.payment_type_id = z.payment_type_id
                    and z.date_1 between u.datebeg and u.dateend  
            join patients p on p.id = z.patient_id
            join doctors_fio doc on doc.id = d.phys_id
            where z.hdr_id = :HDR_ID and p.id = :pid
            into :num_sp, :hist_num, :date_1, :usl_code, :usl_name, :usl_cnt, :tarif, :sumv, :tooth_id, :ds, :doc_fio
            do
            begin
              suspend;
--              fio = '';
                npp = null;
            end

      for select
      iif(z.payment_type_id <> 2, pat.num_sp, (select coalesce(ins.ser, '') || ' ' || ins.num from patients_insurance ins where ins.patients_id = pat.id and z.date_1 between ins.db and ins.de)),
          pat.hist_num, l.biomaterial_date, p.code,
          p.name usl_name, 1, lp.sum_total, lp.sum_total,
          null, z.ds1, doc.fio
        from zs z
        join lab_orders l on l.patient_id = z.patient_id and l.biomaterial_date between z.date_1 and z.date_2
        join lab_order_products lp on lp.order_id = l.id
        join lab_products p on p.id = lp.product_id
        join patients pat on pat.id = z.patient_id
            join doctors_fio doc on doc.id = l.doctor_id
        where z.hdr_id = :HDR_ID and pat.id = :pid
        into :num_sp, :hist_num, :date_1, :usl_code, :usl_name, :usl_cnt, :tarif, :sumv, :tooth_id, :ds, :doc_fio
        do
            begin
              suspend;
--              fio = '';
                npp = null;
            end

      fio = '  ';
      sumv = (select sum(z.sum_uslf) from zs z where z.hdr_id = :HDR_ID and z.patient_id = :pid);
      sumv = sumv + (select sum(l.sum_total) from zs z join v_lab_orders l on l.patient_id = z.patient_id and l.biomaterial_date between z.date_1 and z.date_2 where z.hdr_id = :HDR_ID and z.patient_id = :pid);
      suspend;

      n = n + 1;
      npp = n;
      end
end;

/* Alter (SP_ZS_SET_ZACHET) */
ALTER PROCEDURE SP_ZS_SET_ZACHET(HDR_ID INTEGER)
 AS
declare variable ZS_ID integer;
declare variable DATE1 DM_DATE;
begin
  for select z.id, z.date_1
      from zs z
      where z.hdr_id = :hdr_id
      into :zs_id, :date1
      do
      begin
        update zsd d
         set d.zachet = 1
         where d.zs_id = :zs_id and d.date_1 < :date1;

        execute procedure SP_CALC_ALL(:ZS_ID);
      end
end;

/* Alter (SP_ZSD_LIST_CREATE) */
ALTER PROCEDURE SP_ZSD_LIST_CREATE(ZS_ID INTEGER)
 AS
declare variable TARGET integer;
begin
  target = (select target from zs where id = :zs_id);

  if (exists (select id from zsd where zs_id = :zs_id)) then
   exit;

  if (target = 9) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.code_usl, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, 'Z00.8', 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_09 d on d.stage = z.disp_stage and d.age = extract(year from z.date_1) - extract(year from p.dr)
                                      and d.sex = p.sex and z.date_2 between d.bp and d.epv
       where z.id = :zs_id and d.code_usl is not null and d.tarif is not null;
  end

  if (target in (10,17)) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.usl_code, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, iif(z.age < 3, 'Z00.1', iif(z.age >= 3 and z.age < 15, 'Z00.2', 'Z00.3')), 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_10 d on d.stage = z.disp_stage and d.sex = p.sex
                                          and z.date_2 between d.bp and d.epv
                                          and z.age between d.y1 and d.y2
       where z.id = :zs_id and d.tarif is not null;
  end

  if (target = 13) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.usl_code, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, iif(z.age < 3, 'Z00.1', iif(z.age >= 3 and z.age < 15, 'Z00.2', 'Z00.3')), 1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_13_17 d on d.target = z.target
                                          and d.stage = z.disp_stage and d.sex = p.sex
                                          and z.date_2 between d.bp and d.epv
                                          and d.age_grp = z.age_grp
       where z.id = :zs_id and d.tarif is not null;
  end

  if (target in (14,15)) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.usl_code, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, iif(z.age < 3, 'Z00.1', iif(z.age >= 3 and z.age < 15, 'Z00.2', 'Z00.3')),1
       from zs z
            join patients p on p.id = z.patient_id
            join h_tarif_disp_14_15 d on d.target = z.target
                                          and d.stage = z.disp_stage and d.sex = p.sex
                                          and z.date_2 between d.bp and d.epv
                                          and d.cat_info = z.cat_info
       where z.id = :zs_id and d.tarif is not null;
  end

  if (target = 16) then
  begin
      insert into zsd(zs_id, code_usl, is_chield, pmd_close, date_1, date_2, sum_uslf, tar_usl, k_uslf, ds, IS_TEMP)
      select z.id, d.code_usl, 0, 0, z.date_1, z.date_1, d.tarif, d.tarif, 1, 'Z00.8', 1
       from zs z
            join patients p on p.id = z.patient_id
            join zs_hdr h on h.id = z.hdr_id
            join h_tarif_disp_16 d on z.date_2 between d.bp and d.epv
                                          and d.sex = p.sex
                                          and d.age_l <= (h.y - extract(year from p.dr)) and d.age_r >= (h.y - extract(year from p.dr))
       where z.id = :zs_id and d.tarif is not null;
  end

  insert into ZS_DS (DS, DS_TYPE, SECTION, SECTION_ID, PR, IS_TEMP)
    select d.ds, 1, 2, d.id, 0, 1
    from zsd d
    where d.zs_id = :zs_id;

  execute procedure SP_CALC_ALL(:ZS_ID);
end;

/* Restore proc. body: SP_CALC_ALL */
ALTER PROCEDURE SP_CALC_ALL(ZS_ID INTEGER)
 AS
declare variable TAR DM_MONEY_15_2;
declare variable DATE1 DM_DATE;
declare variable Q_U integer;
declare variable TAR_USL DM_MONEY_15_2;
declare variable TARGET integer;
declare variable IDB integer;
declare variable SUM_USLF DM_MONEY_15_2;
declare variable SEX char(1);
declare variable PTYPE integer;
declare variable AGE_Y integer;
declare variable AGE_GRP integer;
declare variable HDR_ID integer;
declare variable TROMB_CODE DM_CHAR_20;
declare variable TAR_USL_DOP DM_MONEY_15_2;
declare variable SUM_USLF_DOP DM_MONEY_15_2;
declare variable IDSP integer;
begin
  select z.date_2, z.q_u, z.target, p.sex, z.payment_type_id, extract(year from z.date_2) - extract(year from p.dr), z.hdr_id
  from zs z
  join patients p on p.id = z.patient_id
  where z.id = :zs_id
  into :date1, :q_u, :target, :sex, :ptype, :age_y, :hdr_id;

  if (:ptype in (2,3)) then exit;

  if (:target in (9,10,11,12,13,14,15,16,17)) then
  begin
   if ((select coalesce(t.days_cnt,0) from h_target t where t.id = :target) <> 0) then
   begin
    update zsd d
     set d.zachet = 1
     where d.date_1 < (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;

    update zsd d
     set d.zachet = 0
     where d.date_1 >= (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;
   end

   update zsd d
    set d.k_uslf = 0
    where (d.zachet = 1 or d.is_no_get_usl = 1) and d.zs_id = :zs_id;
  end

  update zsd d
    set d.tar_usl = null,
        d.sum_uslf = null,
        d.comment_local = null,
        d.dop_tarif = null,
        d.dop_sum = null
    where d.zs_id = :zs_id;

  update zs z
    set z.tar_usl = null,
        z.sum_usl = null,
        z.sum_uslf = null
    where z.id = :zs_id;

  if ((select coalesce(i.is_nz,0) from invoice i join zs_hdr h on h.name = i.id where h.id = :hdr_id) = 1) then
  begin
    if (target in (9,10,11,13,14,15,16,17)) then exit;

    tar = (select first 1 s.tarif from h_tarif_nz s where s.q_u = iif(:q_u = 4,2,:q_u) and :date1 between s.bp and s.epv);

    if (q_u = 1) then
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id and d.code_usl is null;
    else
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id;

    if (q_u = 4) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = z.dcount*:tar
      where id = :zs_id;
    else
    if (q_u = 1) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = :tar
      where id = :zs_id;
    else
      update zs z
      set z.tar_usl = :tar,
          z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
      where id = :zs_id;
    exit;
  end
   /********************,    ************************/
  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 < '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin

          select first 1 h.tarif, h.tarif
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
                                 and cast(h.code_spec as varchar(10)) = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec = '16' and a.age < 18, '22', b.code_spec), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf;

          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0)
           where b.id = :idb;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end

  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 >= '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (:tar is null) then
          select first 1 h.tarif, h.tarif, a.idsp
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
                                 and h.idsp = a.idsp
           join h_tarif_app_spec n on n.name_id = h.name_id
                                 and n.code_spec_v021 = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec_v021 = 39 and a.age < 18, 49, b.code_spec_v021), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf, :idsp;

          update ZSD b set
           b.tar_usl = iif(:idsp = 30, 0, coalesce(:tar, 0)),
           b.sum_uslf = iif(:idsp = 30, 0, coalesce(:sum_uslf, 0)),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          tar = null;

          if (:idsp <> 30) then
            sum_uslf = null;
        end

     if (:idsp = 30) then
       update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0)
           where b.id = :idb;

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end  

  /********************************************/
  if (:q_u = 4) then
  begin
    tar = (select s.tarif from h_tarif_stom s where :date1 between s.bp and s.epv);

    update zsd d
    set d.tar_usl = :tar,
        d.sum_uslf = d.k_uslf*:tar
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = :tar,
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if (:q_u = 5) then
  begin
--    if (:date1 >= '01.01.2018') then tromb_code = 'A25.30.036';
--    else tromb_code = 'A25.30.035';
    tromb_code = coalesce((select first 1 code_usl from zsd d where d.zs_id = :zs_id and coalesce(code_usl, '') <> ''),'');

    tar = (select s.tarif from h_tarif_smp s where :date1 between s.bp and s.epv);
    tar_usl = coalesce((select coalesce(u.sumf,0) from h_usl u where u.code = :tromb_code
               and u.q_u containing '5' and :date1 between u.datebeg and u.dateend),0);

    update zsd d
    set d.tar_usl = iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl),
        d.sum_uslf = d.k_uslf*iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl)
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = (select max(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if ((:q_u = 1) and ((select 1 from zs z where coalesce(z.metod_hmp,0) > 0 and id = :zs_id) = 1)) then
  begin
    select first 1 v.tarif
    from zs z
         join h_metod_hmp h on h.code = z.metod_hmp and z.date_2 between h.bp and h.epv
         join h_tarif_vmp v on v.tg = h.tg and z.date_2 between v.bp and v.epv
    where z.id = :zs_id
    into :tar;

    update zs a set
        a.tar_usl = :tar,
        a.sum_uslf = :tar,
        a.ksg = null,
        a.kslp = null
    where a.id = :zs_id;

    update zsd b set
          b.ksg = null,
          b.sum_uslf = :tar,
          b.kskp = 0,
          b.tar_usl = :tar
    where b.zs_id = :zs_id and coalesce(b.code_usl,'') = '' and b.date_1 = (select min(date_1) from zsd where zs_id = :zs_id and coalesce(code_usl,'') = '');

    exit;
  end

  /********************************************/
  if (:q_u in (1,3) and :date1 < '01.01.2018') then
    execute procedure SP_CALC_STAC(:zs_id);
  else
    if (:q_u in (1,3) and :date1 >= '01.01.2018') then
      execute procedure sp_calc_stac_2018(:zs_id);

  /****************  ***********************************************/
  if (q_u <> 4) then
  begin
  tar = null;
  sum_uslf = null;
  for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (coalesce(:tar,0) > 0) then
          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          tar = null;
          sum_uslf = null;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
   end

  /*********************-*********************************/
  if ((:q_u = 2) and (:target in (21,22))) then
  begin
   for select b.id
    from zsd b
    join zs z on z.id = b.zs_id
    where z.id = :zs_id
    into :idb
    do
    begin
      tar = (select first 1 t.tarif
             from zsd d
                  join h_tomo_code c on c.nms_code = d.code_usl
                  join h_tarif_tomo t on t.group_num = c.group_num and d.date_2 between t.bp and t.epv
             where d.id = :idb);

      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf = :tar
      where d.id = :idb;
    end

    update zs z
    set z.tar_usl = (select sum(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;

    exit;
  end
  /******************** - 9  ************************/
  if (:q_u = 2 and :target = 9) then
  begin
    execute procedure sp_calc_app_t09(:zs_id);
    exit;
  end

  /******************** - 10,17  -  ************************/
    if (q_u = 2 and target in (10,17)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_10 d on d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and :age_y between d.y1 and d.y2
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 13  ************************/
    if (q_u = 2 and target = 13) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                           and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_13_17 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.age_grp = a.age_grp
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 14,15  ,  ************************/
    if (q_u = 2 and target in (14,15)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_14_15 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.cat_info = a.cat_info
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
  /******************** - 16  ************************/
    if (q_u = 2 and target = 16) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join zs_hdr h on h.id = a.hdr_id
                   join patients p on p.id = a.patient_id
                   join h_tarif_disp_16 d on a.date_2 between d.bp and d.epv
                                          and d.sex = :sex
                                          and cast(d.code_usl as varchar(20)) = b.code_usl
                                          and d.age_l <= (h.y - extract(year from p.dr)) and d.age_r >= (h.y - extract(year from p.dr))
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0) ,
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
end;

/* Restore proc. body: SP_CALC_STAC_2018 */
ALTER PROCEDURE SP_CALC_STAC_2018(IDA INTEGER)
 AS
declare variable KSG type of DM_CHAR_50;
declare variable DS type of DM_DS;
declare variable IDB integer;
declare variable SUM_USLF type of DM_MONEY;
declare variable KSKP type of DM_NUM_3_2;
declare variable Q_U integer;
declare variable FINE_KOEF type of DM_NUM_3_2;
declare variable TARIF numeric(15,6);
declare variable Y integer;
declare variable TARIF_USL DM_MONEY;
declare variable DATE2 date;
declare variable IS_TRANSFER DM_INT;
declare variable CL_CNT integer;
declare variable ERR_CODE integer;
declare variable K_DOWN DM_NUM_6_2;
declare variable DS_CLASS DM_CHAR_10;
declare variable KZ DM_NUM_2_5;
declare variable KD DM_NUM_2_5;
declare variable KUS DM_NUM_2_5;
declare variable BS DM_NUM_6_2;
declare variable PROF_NUM integer;
declare variable DATE1 date;
declare variable CODE_USL DM_CHAR_20;
declare variable FINE_KOEF_SET_DOCTOR DM_BOOLEAN;
declare variable IS_ROUND_JANAO integer;
declare variable OKATO DM_OKATO;
begin
  select c.tf_okato
   from zs_hdr h
        join zs z on z.hdr_id = h.id
        join invoice i on i.id = h.name
        join contragents c on c.id = i.contragent_id
   where z.id = :ida
   into :okato;

--   if (:okato is  null) then
--     okato = (select first 1 c.tf_okato from contragents c where c.type_id = 1);

    if (((select first 1 c.org_code from contragents c where c.type_id = 1))  starting '83' ) then
      is_round_janao = 1;

    update zsd d
      set d.ds_class = (select MKB_CLASS from SP_GET_MKB_CLASS(D.ds))
      where d.zs_id = :ida;

    update zsd d
     set d.ksg = null, 
         d.ksg_base = null,
         d.tar_base = null,
         d.sum_base = null,
         d.kskp_base = null,
         d.sum_uslf = 0,
         d.tar_usl = 0,
         d.comment_local = null
     where d.zs_id = :ida;

     cl_cnt = (select count(distinct b.ds_class) from ZSD b where b.ZS_ID = :ida);
     is_transfer = (select sum(iif(b.code_usl is null, 1, 0)) from ZSD b where b.ZS_ID = :ida);
     delete from kslp_koef where zs_id = :ida ;

     select a.q_u, extract(year from a.date_2), a.date_2, coalesce(a.fine_koef_set_doctor,0)
      from zs a
      where a.id = :ida
      into :q_u, :y, :date2, :fine_koef_set_doctor;

     for select sp.KSG, sp.ERR_CODE, b.ds, b.id, iif(:is_round_janao = 1,
                coalesce(bs.tarif * kd.kd * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0),
                cast(coalesce(bs.tarif * kd.kd * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0) as dm_num_6_2)),
                k.kz, kd.kd,
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0),
                bs.tarif, k.k_down, k.prof_num, b.date_1, coalesce(b.code_usl,''), coalesce(b.fine_koef,1)
      from zs a
      join zsd b on a.id = b.zs_id
      join patients p on p.id = a.patient_id
      join lpu_factors lf on lf.q_u = a.q_u and a.date_2 between lf.bp and lf.epv and lf.okato is not distinct from :okato
      join h_tarif_bs bs on bs.q_u = a.q_u and a.date_2 between bs.bp and bs.epv and bs.okato is not distinct from :okato
      join h_tarif_kd kd on a.date_2 between kd.bp and kd.epv and kd.okato is not distinct from :okato
      left join sp_ksg_get(b.ds, p.dr, a.date_2, b.code_usl, p.sex,
                           (select sum(b1.k_uslf) from ZSD b1 where b1.ZS_ID = :ida and b1.ds_class = b.ds_class and b1.code_usl is null), -- -     
                           a.q_u, b.ds2, b.id, b.ksg_criterion,b.ksg_criterion2) sp on 1=1
      left join h_ksg k on k.ksg = sp.ksg and a.date_2 between k.bp and k.epv and k.q_u = a.q_u
      where b.zs_id = :ida
      order by b.code_usl
      into :ksg, :err_code, :ds, :idb, :tarif, :kz, :kd, :kus, :bs, :k_down, :prof_num, :date1, :code_usl, :fine_koef
      do
      begin
        kskp = 1;
--        fine_koef = null;

        if ((q_u = 1) and (err_code is null) and (date2 < '01.01.2019')) then
          kskp = (select KSKP from sp_calc_stac_kskp_2018(:ida, :idb, :ksg, :cl_cnt));

        if ((q_u in (1,3)) and (err_code is null) and (date2 >= '01.01.2019')) then
          kskp = (select KSKP from sp_calc_stac_kskp_2019(:ida, :idb, :ksg, :cl_cnt));

        if (kskp is null) then kskp = 1;

        if (fine_koef_set_doctor = 0) then
          fine_koef = (select FINE_KOEF from sp_calc_stac_fine_2018(:ida, :idb, :ksg, :cl_cnt));

        if (is_round_janao = 1) then
          sum_uslf = cast(cast(tarif * kskp as int) * fine_koef as int);
        else
          sum_uslf = tarif * kskp * fine_koef;

        if (:ksg is not null) then
        begin
            /*$$IBEC$$ if (:code_usl <> '') then
            begin
                select first 1 d.id, iif(:fine_koef_set_doctor = 1, d.fine_koef, :fine_koef)
                from zs z
                     join zsd d on d.zs_id = z.id
                where d.zs_id = :ida and coalesce(d.code_usl,'') = ''
                       and :date1 between d.date_1 and d.date_2
                       and not exists(select id from zsd d2 where d2.zs_id = :ida and coalesce(d2.code_usl,'') = '' and d2.date_1 = d.date_2)
                into :idb, :fine_koef;

                if (is_round_janao = 1) then
                  sum_uslf = cast(cast(tarif * kskp as int) * fine_koef as int);
                else
                  sum_uslf = tarif * kskp * fine_koef;
            end $$IBEC$$*/

            if ((select first 1 d.id from zsd d where d.zs_id = :ida and d.ksg_base = :ksg) is null) then
            update zsd b set
             b.ksg_base = :ksg,
             b.tar_base = iif(:date2 >= '01.05.2018', iif(:is_round_janao = 1, cast(:tarif * coalesce(:kskp,1) as int), :tarif * coalesce(:kskp,1)), iif(:is_round_janao = 1, cast(:tarif as integer), :tarif)),
             b.sum_base = :sum_uslf,
             b.kskp_base = :kskp,
             b.koef_z = :kz, 
             b.koef_d = :kd,
             b.koef_u = :kus,
             b.bs = :bs,
             b.koef_up = :k_down,
             b.reab = iif(:prof_num = 37,1,null),
             b.fine_koef = :fine_koef
             where b.id = :idb;
         end
      end 
--------------------------------------------------------------------------------
      --    6  + 
      if (q_u = 1) then
       if (exists (select 1 from zsd b where b.zs_id = :ida and ((b.ksg in ('2','st02.001') and b.k_uslf >= 6) or (b.ksg in ('O14.1','O34.2','O36.3','O36.4','O42.2') and b.k_uslf >= 2) ))
          and exists (select 1 from zsd b where b.zs_id = :ida and b.ksg in ('4', '5', 'st02.003', 'st02.004'))) then
          begin
            --    
            select first 1 b.ksg_base, b.ds
            from zs a
             join zsd b on a.id = b.zs_id
             where b.zs_id = :ida and b.ksg in ('4', '5', 'st02.003', 'st02.004')
             into :ksg, :ds;
       
            update zsd d
            set d.tar_usl = d.tar_base,
                d.sum_uslf = d.sum_base,
                d.ksg = d.ksg_base,
                d.kskp = d.kskp_base
            where d.zs_id = :ida;

            --   
            select coalesce(sum(b.sum_uslf), 0) from zsd b where b.zs_id = :ida
             into :sum_uslf;
    
            update zs a set
             a.tar_usl = :tarif,
             a.sum_uslf = :sum_uslf,
             a.sum_usl = :sum_uslf,
             a.ksg = :ksg,
             a.ds1 = :ds,
             a.kslp = :kskp
             where a.id = :ida;

            exit;
          end
--------------------------------------------------------------------------------
      if ((is_transfer < 2) or (cl_cnt < 2))  then  --   
      begin
        --     ,   
        ksg = null;
        select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base, b.kskp_base, b.koef_z, b.koef_d, b.koef_u, b.bs, b.koef_up,
             b.fine_koef
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and ((:q_u = 1 and b.ksg_base >= '325' and b.ksg_base <= '343') or
                                                                                                  (:q_u = 3 and b.ksg_base >= '123' and b.ksg_base <= '134'))
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif, :kskp, :kz, :kd, :kus, :bs, :k_down, :fine_koef;

        if (:ksg is null)  then
        begin
         select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base, b.date_1,
             b.kskp_base, b.koef_z, b.koef_d, b.koef_u, b.bs, b.koef_up,
             b.fine_koef
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif, :date1,
                  :kskp, :kz, :kd, :kus, :bs, :k_down, :fine_koef;

         if (((select coalesce(d.code_usl,'') from zsd d where d.id = :idb) <> '')
            and (exists(select d.id from zsd d where d.zs_id = :ida and d.id <> :idb and coalesce(d.code_usl,'') = '' and :date1 between d.date_1 and d.date_2))) then
         select first 1 d.id
             from zsd d
             where d.zs_id = :ida and d.id <> :idb and coalesce(d.code_usl,'') = '' and :date1 between d.date_1 and d.date_2
             into :idb;
        end

         --      
         update zsd b set
             b.ksg = :ksg,
             b.sum_uslf = :sum_uslf,
             b.ksg_base = :ksg,
             b.tar_usl = :tarif,
             b.sum_base = :sum_uslf,
             b.kskp_base = :kskp,
             b.koef_z = :kz, 
             b.koef_d = :kd,
             b.koef_u = :kus,
             b.bs = :bs,
             b.koef_up = :k_down,
             b.reab = iif(:prof_num = 37,1,null),
             b.fine_koef = :fine_koef
          where b.id = :idb;

         update zsd b set
             b.ksg = null,
             b.sum_uslf = 0,
             b.kskp = 1,
             b.tar_usl = 0,
             b.ksg_base = null,
             b.tar_base = null,
             b.sum_base = 0,
             b.kskp_base = null,
             b.koef_z = null,
             b.koef_d = null,
             b.koef_u = null,
             b.bs = null,
             b.koef_up = null,
             b.fine_koef = null
          where b.id <> :idb and b.zs_id = :ida;
 
         update zs a set
          a.tar_usl = :tarif,
          a.sum_uslf = :sum_uslf,
          a.sum_usl = :sum_uslf,
          a.ksg = :ksg,
          a.kslp = :kskp
          where a.id = :ida;
 
      end else
      begin
        for select d.ds_class
         from zsd d
         where d.zs_id = :ida
         group by 1
         into :ds_class
         do
         begin
            if (((select count(dc.id) from ksg_dont_choice dc join zsd z on z.ksg_base = dc.ksg_ter or z.ksg_base = dc.ksg_surg
                    where z.zs_id = :ida and z.ds_class = :ds_class and :date2 between dc.bp and dc.epv) > 0) and (:q_u = 1)) then
               --    
            select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and b.ds_class = :ds_class and b.code_usl is not null
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;
            else
               --     
            begin
              select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base, b.date_1,
                 b.kskp_base, b.koef_z, b.koef_d, b.koef_u, b.bs, b.koef_up,
                 b.fine_koef
                 from zsd b
                 where b.zs_id = :ida and b.ksg_base is not null and b.ds_class = :ds_class
                 order by b.code_usl desc, b.sum_base desc
                 into :idb, :ksg, :sum_uslf, :tarif, :date1,
                      :kskp, :kz, :kd, :kus, :bs, :k_down, :fine_koef;
    
             if (((select coalesce(d.code_usl,'') from zsd d where d.id = :idb) <> '')
                and (exists(select d.id from zsd d where d.zs_id = :ida and d.id <> :idb and coalesce(d.code_usl,'') = '' and :date1 between d.date_1 and d.date_2))) then
             select first 1 d.id
                 from zsd d
                 where d.zs_id = :ida and d.id <> :idb and coalesce(d.code_usl,'') = '' and :date1 between d.date_1 and d.date_2
                 into :idb;
            end
    
             --      
             update zsd b set
                 b.ksg = :ksg,
                 b.sum_uslf = :sum_uslf,
                 b.ksg_base = :ksg,
                 b.tar_usl = :tarif,
                 b.sum_base = :sum_uslf,
                 b.kskp_base = :kskp,
                 b.koef_z = :kz, 
                 b.koef_d = :kd,
                 b.koef_u = :kus,
                 b.bs = :bs,
                 b.koef_up = :k_down,
                 b.reab = iif(:prof_num = 37,1,null),
                 b.fine_koef = :fine_koef
              where b.id = :idb;
    
             update zsd b set
                 b.ksg = null,
                 b.sum_uslf = 0,
                 b.kskp = 1,
                 b.tar_usl = 0,
                 b.ksg_base = null,
                 b.tar_base = null,
                 b.sum_base = 0,
                 b.kskp_base = null,
                 b.koef_z = null,
                 b.koef_d = null,
                 b.koef_u = null,
                 b.bs = null,
                 b.koef_up = null,
                 b.fine_koef = null
              where b.id <> :idb and b.zs_id = :ida and b.ds_class = :ds_class;
         end

        select first 1 b.ksg_base, b.sum_base
        from zs a
         join zsd b on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null and b.ds = a.ds1
         order by b.sum_base desc
         into :ksg, :sum_uslf;

--        update zsd d
--         set d.tar_usl = d.tar_base,
--             d.sum_uslf = d.sum_base,
--             d.ksg = d.ksg_base,
--             d.kskp = d.kskp_base
--         where d.zs_id = :ida;
   
        select coalesce(sum(b.sum_uslf), 0), coalesce(sum(b.tar_base), 0)
         from zsd b
         join zs a on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null
         into :sum_uslf, :tarif;

        update zs a set
         a.tar_usl = :tarif,
         a.sum_uslf = :sum_uslf,
         a.sum_usl = :sum_uslf,
         a.ksg = :ksg,
         a.kslp = :kskp
         where a.id = :ida;
 
      end
end;

/* Altering existing trigger... */
ALTER TRIGGER PATIENTS_ANALIZ_BI
as
declare variable norm_id integer;
begin
  if (new.id is null) then
    new.id = gen_id(gen_patients_analiz_id,1);

  new.ANALIZ_NAME = (select u.name from h_usl u where u.id = new.analiz_id);
  new.ANALIZ_CODE = (select u.code from h_usl u where u.id = new.analiz_id);
  new.ANALIZ_TARIF = (select u.sumf from h_usl u where u.id = new.analiz_id);
end;

/* Altering existing trigger... */
ALTER TRIGGER ZSD_BIU0
AS
declare variable mp integer;
declare variable q_u integer;
declare variable tar numeric(15,2);
begin
  q_u = (select q_u from zs where id = new.zs_id);

--  mp = (select mp from doctors_spec s where s.doctor_id = new.phys_id and s.code_spec = new.code_spec);
--   if (:mp is not null) then
--     new.mp = :mp;

--   new.ds_class = (SELECT first 1 MKB_CLASS_NUM FROM H_MKB WHERE CODE = NEW.DS);

  if (new.pmd_close = 1) then
    update zsd
    set pmd_close = 0
    where zs_id = new.zs_id;

  if (new.pmd_close is null) then
    new.pmd_close = 1;

  if ((select z.payment_type_id from zs z where z.id = new.zs_id) in (3,2)) then
  begin
      tar = (select coalesce(u.sumf,0) from h_usl u where u.code = new.code_usl and u.q_u containing :q_u and u.payment_type_id = (select z.payment_type_id from zs z where z.id = new.zs_id));
    
      if (tar > 0) then
      begin
        NEW.sum_uslf = :tar * new.k_uslf;
        NEW.tar_usl = :tar;
      END
  end
--  else
--    if (new.tar_usl = 0 and new.sum_uslf = 0) then new.k_uslf = 0;

  if (new.phys_id is not null and new.code_spec_v021 is null) then
    new.code_spec_v021 = (select first 1 s.code_v021 from doctors_spec s where s.doctor_id = new.phys_id);

  if (new.phys_id is not null and new.mp is null and new.code_spec_v021 is not null) then
    new.mp = (select first 1 m.mp from doctors_spec m where m.doctor_id = new.phys_id and m.code_v021 = new.code_spec_v021);

  if (new.phys_id is not null and new.code_prof is null) then
    new.code_prof = (select first 1 p.prof from doctors_prof p where p.doctor_id = new.phys_id and p.code_spec =
                     (select first 1 s.code_v021 from doctors_spec s where s.doctor_id = new.phys_id));

--  if (new.code_spec is not null) then
--    new.code_spec_v021 = (select first 1 s.code_v021 from h_v015_v021 s where cast(s.code_v015 as varchar(10)) = new.code_spec);
--  else
  if (new.code_spec_v021 is not null) then
    new.code_spec = cast((select first 1 s.code_v015 from h_v015_v021 s where s.code_v021 = new.code_spec_v021) as varchar(10));

--  if (inserting) then
--  update or insert into DOCTORS_SPEC (DOCTOR_ID, CODE_V021, MP)
--    values (new.phys_id, new.code_spec_v021, new.mp)
--    matching (DOCTOR_ID, CODE_V021, MP);
  if (coalesce(new.ds,'') = '') then
    new.ds = (select d.ds from zs_ds d where d.section = 2 and d.section_id = new.id and d.ds_type = 1);

  if ((coalesce(new.code_usl,'') = '') and ((select z.payment_type_id from zs z where z.id = new.zs_id) = 1) and (q_u = 2)
       and ((select z.target from zs z where z.id = new.zs_id) = 1) and (new.date_1 >= '01.01.2019')) then
  begin
    if (exists(select first 1 id from zsd d where d.zs_id = new.zs_id and d.date_1 < new.date_1 and d.code_spec_v021 = new.code_spec_v021)) then
    begin
      if (new.is_chield = 1) then
        new.code_usl = (select first 1 n.code_usl2_det from h_tarif_app_spec s join h_tarif_app_name n on n.id = s.name_id where s.code_spec_v021 = new.code_spec_v021);
      else
        new.code_usl = (select first 1 n.code_usl2 from h_tarif_app_spec s join h_tarif_app_name n on n.id = s.name_id where s.code_spec_v021 = new.code_spec_v021);
    end
    else
    begin
      if (new.is_chield = 1) then
        new.code_usl = (select first 1 n.code_usl1_det from h_tarif_app_spec s join h_tarif_app_name n on n.id = s.name_id where s.code_spec_v021 = new.code_spec_v021);
      else
        new.code_usl = (select first 1 n.code_usl1 from h_tarif_app_spec s join h_tarif_app_name n on n.id = s.name_id where s.code_spec_v021 = new.code_spec_v021);
    end
  end
end;

/* Altering existing trigger... */
ALTER TRIGGER ZSD_BU0
AS
declare variable spec varchar(10);
declare variable otd_prof varchar(20);
declare variable phys integer;
declare variable child integer;
declare variable prof varchar(10);
declare variable podr varchar(12);
declare variable mp integer ;
declare variable spec_v021 integer;
begin
  update zs
  set --k_uslf = (select sum(k_uslf) from zsd where zs_id = new.zs_id),
--      ds0 = (select first 1 zz.ds from zsd zz where zz.zs_id = new.zs_id and zz.date_1 =
--              (select min(date_1) from zsd where zs_id = new.zs_id)),
      dcount = (select count(distinct z.date_1) from zsd z where z.zs_id = new.zs_id)
    where id = new.zs_id;

    if ((select min(date_1) from zsd where zs_id = new.zs_id and coalesce(zachet,0) <> 1) is not null) then
    update zs
    set date_1 = (select min(date_1) from zsd where zs_id = new.zs_id and coalesce(zachet,0) <> 1),
        date_2 = (select max(date_2) from zsd where zs_id = new.zs_id and coalesce(zachet,0) <> 1)
    where id = new.zs_id;



  if (((new.date_2 >= (select date_2 from zs where id = new.zs_id))
      and ((select count(id) from zsd where zs_id = new.zs_id and coalesce(pmd_close,0) = 1) = 0))
     or (new.pmd_close = 1))
  then
   begin
     update zs
     set code_spec = new.code_spec,
         code_spec_v021 = new.code_spec_v021,
         otd_prof = new.otd_prof,
--         ds1 = iif(coalesce(new.ds,'') = '', ds1, new.ds),
         phys_id = new.phys_id,
         is_chield = new.is_chield,
         code_prof = new.code_prof,
         podr = new.podr,
         mp = new.mp,
         ds1 = new.ds,
         ds2 = new.ds2,
         ds_onk = new.ds_onk,
         p_cel = new.p_cel,
         c_zab = new.c_zab
      where id = new.zs_id;
    end
   else
    begin
      if (new.pmd_close = 0 and old.pmd_close = 1) then
      begin
      for select z.code_spec, z.otd_prof, z.phys_id, z.is_chield, z.code_prof, z.podr, z.mp, z.code_spec_v021 from zsd z
          where  (z.id = (select max(id) from zsd d where d.zs_id = new.zs_id and
                         (d.date_2 = (select max(date_2) from zsd where zs_id = new.zs_id))))
          into :spec, :otd_prof, :phys, :child, :prof, :podr, :mp, :spec_v021
      do
          update zs
          set code_spec = :spec,
              code_spec_v021 = :spec_v021,
             otd_prof = :otd_prof,
--             ds1 = iif(coalesce(:ds1,'') = '', ds1, :ds1),
             phys_id = :phys,
             is_chield = :child,
             code_prof = :prof,
             podr = :podr,
             mp = :mp,
             ds1 = new.ds,
             ds2 = new.ds2,
             ds_onk = new.ds_onk,
             p_cel = new.p_cel,
             c_zab = new.c_zab
          where id = new.zs_id;
      end
     end

    if ((select z.payment_type_id from zs z where z.id = new.zs_id) in (3,2)) then
    begin
        update zs
        set sum_uslf = (select sum(sum_uslf) from zsd where zs_id = new.zs_id),
            sum_usl = coalesce((select sum(i.sum_opl) from patients_invoice i where i.zs_id = new.zs_id), 0),
            tar_usl = null
        where id = new.zs_id and payment_type_id <> 1;
    end
    else
    if (((select q_u from zs where id = new.zs_id) = 2) and (coalesce(new.code_usl,'') <> '')
       and ((select target from zs where id = new.zs_id) = 1))  then
       if (exists(select id from h_usl where code = new.code_usl and q_u containing '4' and payment_type_id = 1 and new.date_2 between datebeg and dateend)) then
        update zs z
         set z.q_u = 4
         where id = new.zs_id;

   if (coalesce(new.code_usl,'') <> '') then
    if ((select first 1 1 from h_tomo_code c where c.nms_code = new.code_usl) = 1) then
      update zs z
       set z.target = iif((select first 1 c.group_num from h_tomo_code c where c.nms_code = new.code_usl) in (1,2), 21, 22)
       where z.id = new.zs_id and z.q_u = 2;
end;

/* Alter Procedure... */
/* Alter (SP_CALC_ALL) */
ALTER PROCEDURE SP_CALC_ALL(ZS_ID INTEGER)
 AS
declare variable TAR DM_MONEY_15_2;
declare variable DATE1 DM_DATE;
declare variable Q_U integer;
declare variable TAR_USL DM_MONEY_15_2;
declare variable TARGET integer;
declare variable IDB integer;
declare variable SUM_USLF DM_MONEY_15_2;
declare variable SEX char(1);
declare variable PTYPE integer;
declare variable AGE_Y integer;
declare variable AGE_GRP integer;
declare variable HDR_ID integer;
declare variable TROMB_CODE DM_CHAR_20;
declare variable TAR_USL_DOP DM_MONEY_15_2;
declare variable SUM_USLF_DOP DM_MONEY_15_2;
declare variable IDSP integer;
begin
  select z.date_2, z.q_u, z.target, p.sex, z.payment_type_id, extract(year from z.date_2) - extract(year from p.dr), z.hdr_id
  from zs z
  join patients p on p.id = z.patient_id
  where z.id = :zs_id
  into :date1, :q_u, :target, :sex, :ptype, :age_y, :hdr_id;

  if (:ptype in (2,3)) then exit;

  if (:target in (9,10,11,12,13,14,15,16,17)) then
  begin
   if ((select coalesce(t.days_cnt,0) from h_target t where t.id = :target) <> 0) then
   begin
    update zsd d
     set d.zachet = 1
     where d.date_1 < (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;

    update zsd d
     set d.zachet = 0
     where d.date_1 >= (:date1 - (select t.days_cnt from h_target t where t.id = :target)) and d.zs_id = :zs_id;
   end

   update zsd d
    set d.k_uslf = 0
    where (d.zachet = 1 or d.is_no_get_usl = 1) and d.zs_id = :zs_id;
  end

  update zsd d
    set d.tar_usl = null,
        d.sum_uslf = null,
        d.comment_local = null,
        d.dop_tarif = null,
        d.dop_sum = null
    where d.zs_id = :zs_id;

  update zs z
    set z.tar_usl = null,
        z.sum_usl = null,
        z.sum_uslf = null
    where z.id = :zs_id;

  if ((select coalesce(i.is_nz,0) from invoice i join zs_hdr h on h.name = i.id where h.id = :hdr_id) = 1) then
  begin
    if (target in (9,10,11,13,14,15,16,17)) then exit;

    tar = (select first 1 s.tarif from h_tarif_nz s where s.q_u = iif(:q_u = 4,2,:q_u) and :date1 between s.bp and s.epv);

    if (q_u = 1) then
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id and d.code_usl is null;
    else
      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf =:tar
      where d.zs_id = :zs_id;

    if (q_u = 4) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = z.dcount*:tar
      where id = :zs_id;
    else
    if (q_u = 1) then
      update zs z
      set z.tar_usl = :tar,
        z.sum_uslf = :tar
      where id = :zs_id;
    else
      update zs z
      set z.tar_usl = :tar,
          z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
      where id = :zs_id;
    exit;
  end
   /********************,    ************************/
  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 < '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin

          select first 1 h.tarif, h.tarif
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
                                 and cast(h.code_spec as varchar(10)) = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec = '16' and a.age < 18, '22', b.code_spec), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf;

          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0)
           where b.id = :idb;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end

  if (:q_u = 2 and :target not in (9,10,11,12,13,14,15,16,17,21,22) and (:date1 >= '01.01.2018')) then
  begin
    for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (:tar is null) then
          select first 1 h.tarif, h.tarif, a.idsp
          from zs a
           join zsd b on a.id = b.zs_id
           join h_tarif_app_tgroup t on a.date_2 between t.bp and t.epv
           join h_tarif_app h on h.tg = t.tg
                                 and a.date_2 between h.bp and h.epv
                                 and (h.target = iif(a.for_pom = 2, 1, 0))
                                 and h.idsp = a.idsp
           join h_tarif_app_spec n on n.name_id = h.name_id
                                 and n.code_spec_v021 = iif(coalesce(a.vbr,0) = 0, iif(b.code_spec_v021 = 39 and a.age < 18, 49, b.code_spec_v021), 0)
           where b.id = :idb
           order by h.target nulls last
           into :tar, :sum_uslf, :idsp;

          update ZSD b set
           b.tar_usl = iif(:idsp = 30, 0, coalesce(:tar, 0)),
           b.sum_uslf = iif(:idsp = 30, 0, coalesce(:sum_uslf, 0)),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          tar = null;

          if (:idsp <> 30) then
            sum_uslf = null;
        end

     if (:idsp = 30) then
       update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0)
           where b.id = :idb;

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
    exit;
  end  

  /********************************************/
  if (:q_u = 4) then
  begin
    tar = (select s.tarif from h_tarif_stom s where :date1 between s.bp and s.epv);

    update zsd d
    set d.tar_usl = :tar,
        d.sum_uslf = d.k_uslf*:tar
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = :tar,
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if (:q_u = 5) then
  begin
--    if (:date1 >= '01.01.2018') then tromb_code = 'A25.30.036';
--    else tromb_code = 'A25.30.035';
    tromb_code = coalesce((select first 1 code_usl from zsd d where d.zs_id = :zs_id and coalesce(code_usl, '') <> ''),'');

    tar = (select s.tarif from h_tarif_smp s where :date1 between s.bp and s.epv);
    tar_usl = coalesce((select coalesce(u.sumf,0) from h_usl u where u.code = :tromb_code
               and u.q_u containing '5' and :date1 between u.datebeg and u.dateend),0);

    update zsd d
    set d.tar_usl = iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl),
        d.sum_uslf = d.k_uslf*iif(coalesce(d.code_usl,'') = '', :tar, :tar_usl)
    where d.zs_id = :zs_id;
    
    update zs z
    set z.tar_usl = (select max(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;
  end

  /******************** ************************/
  if ((:q_u = 1) and ((select 1 from zs z where coalesce(z.metod_hmp,0) > 0 and id = :zs_id) = 1)) then
  begin
    select first 1 v.tarif
    from zs z
         join h_metod_hmp h on h.code = z.metod_hmp and z.date_2 between h.bp and h.epv
         join h_tarif_vmp v on v.tg = h.tg and z.date_2 between v.bp and v.epv
    where z.id = :zs_id
    into :tar;

    update zs a set
        a.tar_usl = :tar,
        a.sum_uslf = :tar,
        a.ksg = null,
        a.kslp = null
    where a.id = :zs_id;

    update zsd b set
          b.ksg = null,
          b.sum_uslf = :tar,
          b.kskp = 0,
          b.tar_usl = :tar
    where b.zs_id = :zs_id and coalesce(b.code_usl,'') = '' and b.date_1 = (select min(date_1) from zsd where zs_id = :zs_id and coalesce(code_usl,'') = '');

    exit;
  end

  /********************************************/
  if (:q_u in (1,3) and :date1 < '01.01.2018') then
    execute procedure SP_CALC_STAC(:zs_id);
  else
    if (:q_u in (1,3) and :date1 >= '01.01.2018') then
      execute procedure sp_calc_stac_2018(:zs_id);

  /****************  ***********************************************/
  if (q_u <> 4) then
  begin
  tar = null;
  sum_uslf = null;
  for
       select b.id
       from zsd b
       where b.zs_id = :zs_id
       into :idb
        do
        begin
          select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
          from zs a
           join zsd b on a.id = b.zs_id
           join h_usl u on u.code = coalesce(b.code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                           and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1
           where b.id = :idb and b.code_usl is not null and coalesce(u.sumf,0) > 0
           into :tar, :sum_uslf;

          tar_usl_dop = null;
          sum_uslf_dop = null;

          if ((select d.dop_code_usl from zsd d where d.id = :idb) is not null) then
              select first 1 u.sumf, coalesce(u.sumf,0)*b.k_uslf
              from zs a
               join zsd b on a.id = b.zs_id
               join h_usl u on u.code = coalesce(b.dop_code_usl,'') and u.q_u containing a.q_u and (u.target is null or (u.target containing a.target))
                               and u.datebeg <= a.date_2 and u.dateend >=a.date_2  and u.payment_type_id = 1 and u.finans_type is not null
               where b.id = :idb and b.dop_code_usl is not null and coalesce(u.sumf,0) > 0
               into :tar_usl_dop, :sum_uslf_dop;

          if (coalesce(:tar,0) > 0) then
          update ZSD b set
           b.tar_usl = coalesce(:tar, 0),
           b.sum_uslf = coalesce(:sum_uslf, 0),
           b.dop_tarif = coalesce(:tar_usl_dop,0),
           b.dop_sum = coalesce(:sum_uslf_dop,0)
           where b.id = :idb;

          tar = null;
          sum_uslf = null;
        end

     sum_uslf = (select sum(b.sum_uslf) from zsd b where b.zs_id = :zs_id) + (select sum(coalesce(b.dop_sum,0)) from zsd b where b.zs_id = :zs_id);

     update zs a set
      a.tar_usl = coalesce(:sum_uslf, 0),
      a.sum_uslf = coalesce(:sum_uslf, 0)
      where a.id = :zs_id;
   end

  /*********************-*********************************/
  if ((:q_u = 2) and (:target in (21,22))) then
  begin
   for select b.id
    from zsd b
    join zs z on z.id = b.zs_id
    where z.id = :zs_id
    into :idb
    do
    begin
      tar = (select first 1 t.tarif
             from zsd d
                  join h_tomo_code c on c.nms_code = d.code_usl
                  join h_tarif_tomo t on t.group_num = c.group_num and d.date_2 between t.bp and t.epv
             where d.id = :idb);

      update zsd d
      set d.tar_usl = :tar,
          d.sum_uslf = :tar
      where d.id = :idb;
    end

    update zs z
    set z.tar_usl = (select sum(tar_usl) from zsd where zs_id = :zs_id),
        z.sum_uslf = (select sum(sum_uslf) from zsd where zs_id = :zs_id)
    where id = :zs_id;

    exit;
  end
  /******************** - 9  ************************/
  if (:q_u = 2 and :target = 9) then
  begin
    execute procedure sp_calc_app_t09(:zs_id);
    exit;
  end

  /******************** - 10,17  -  ************************/
    if (q_u = 2 and target in (10,17)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_10 d on d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and :age_y between d.y1 and d.y2
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 13  ************************/
    if (q_u = 2 and target = 13) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                           and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_13_17 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.age_grp = a.age_grp
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end

  /******************** - 14,15  ,  ************************/
    if (q_u = 2 and target in (14,15)) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join h_tarif_disp_14_15 d on d.target = a.target
                                          and d.stage = a.disp_stage and d.sex = :sex
                                          and a.date_2 between d.bp and d.epv
                                          and cast(d.usl_code as varchar(20)) = b.code_usl
                                          and d.cat_info = a.cat_info
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0),
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
  /******************** - 16  ************************/
    if (q_u = 2 and target = 16) then
    begin
      for select b.id
          from zsd b
               join zs z on z.id = b.zs_id
          where z.id = :zs_id
          into :idb
          do
          begin
            tar = (select d.tarif from zs a
                   join zsd b on b.zs_id = a.id and b.date_1 between a.date_1 and a.date_2
                                          and coalesce(b.is_no_get_usl,0) <> 1
                                          and b.date_1 >= a.date_1   --    
                   join zs_hdr h on h.id = a.hdr_id
                   join patients p on p.id = a.patient_id
                   join h_tarif_disp_16 d on a.date_2 between d.bp and d.epv
                                          and d.sex = :sex
                                          and cast(d.code_usl as varchar(20)) = b.code_usl
                                          and d.age_l <= (h.y - extract(year from p.dr)) and d.age_r >= (h.y - extract(year from p.dr))
                   where b.id = :idb);

            update zsd b set
               b.sum_uslf = coalesce(b.k_uslf * :tar, 0),
               b.tar_base = coalesce(:tar, 0) ,
               b.tar_usl =  coalesce(:tar, 0),
               b.k_uslf = iif(coalesce(:tar, 0) = 0, 0, b.k_uslf)
               where b.id = :idb;
          end

      update zs z
      set z.sum_uslf = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id),
          z.tar_usl = (select sum(sum_uslf) from zsd d where d.zs_id = :zs_id)
      where z.id = :zs_id;

      exit;
    end
end;

/* Alter (SP_CALC_STAC_2018) */
ALTER PROCEDURE SP_CALC_STAC_2018(IDA INTEGER)
 AS
declare variable KSG type of DM_CHAR_50;
declare variable DS type of DM_DS;
declare variable IDB integer;
declare variable SUM_USLF type of DM_MONEY;
declare variable KSKP type of DM_NUM_3_2;
declare variable Q_U integer;
declare variable FINE_KOEF type of DM_NUM_3_2;
declare variable TARIF numeric(15,6);
declare variable Y integer;
declare variable TARIF_USL DM_MONEY;
declare variable DATE2 date;
declare variable IS_TRANSFER DM_INT;
declare variable CL_CNT integer;
declare variable ERR_CODE integer;
declare variable K_DOWN DM_NUM_6_2;
declare variable DS_CLASS DM_CHAR_10;
declare variable KZ DM_NUM_2_5;
declare variable KD DM_NUM_2_5;
declare variable KUS DM_NUM_2_5;
declare variable BS DM_NUM_6_2;
declare variable PROF_NUM integer;
declare variable DATE1 date;
declare variable CODE_USL DM_CHAR_20;
declare variable FINE_KOEF_SET_DOCTOR DM_BOOLEAN;
declare variable IS_ROUND_JANAO integer;
declare variable OKATO DM_OKATO;
begin
  select c.tf_okato
   from zs_hdr h
        join zs z on z.hdr_id = h.id
        join invoice i on i.id = h.name
        join contragents c on c.id = i.contragent_id
   where z.id = :ida
   into :okato;

--   if (:okato is  null) then
--     okato = (select first 1 c.tf_okato from contragents c where c.type_id = 1);

    if (((select first 1 c.org_code from contragents c where c.type_id = 1))  starting '83' ) then
      is_round_janao = 1;

    update zsd d
      set d.ds_class = (select MKB_CLASS from SP_GET_MKB_CLASS(D.ds))
      where d.zs_id = :ida;

    update zsd d
     set d.ksg = null, 
         d.ksg_base = null,
         d.tar_base = null,
         d.sum_base = null,
         d.kskp_base = null,
         d.sum_uslf = 0,
         d.tar_usl = 0,
         d.comment_local = null
     where d.zs_id = :ida;

     cl_cnt = (select count(distinct b.ds_class) from ZSD b where b.ZS_ID = :ida);
     is_transfer = (select sum(iif(b.code_usl is null, 1, 0)) from ZSD b where b.ZS_ID = :ida);
     delete from kslp_koef where zs_id = :ida ;

     select a.q_u, extract(year from a.date_2), a.date_2, coalesce(a.fine_koef_set_doctor,0)
      from zs a
      where a.id = :ida
      into :q_u, :y, :date2, :fine_koef_set_doctor;

     for select sp.KSG, sp.ERR_CODE, b.ds, b.id, iif(:is_round_janao = 1,
                coalesce(bs.tarif * kd.kd * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0),
                cast(coalesce(bs.tarif * kd.kd * k.k_down * k.kz *
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0), 0) as dm_num_6_2)),
                k.kz, kd.kd,
                iif((select 1 from h_ksg_dop d where d.type_num = 1 and a.date_2 between d.bp and d.epv and d.q_u = a.q_u and d.ksg = sp.ksg) IS NULL , lf.kus, 1.0),
                bs.tarif, k.k_down, k.prof_num, b.date_1, coalesce(b.code_usl,''), coalesce(b.fine_koef,1)
      from zs a
      join zsd b on a.id = b.zs_id
      join patients p on p.id = a.patient_id
      join lpu_factors lf on lf.q_u = a.q_u and a.date_2 between lf.bp and lf.epv and lf.okato is not distinct from :okato
      join h_tarif_bs bs on bs.q_u = a.q_u and a.date_2 between bs.bp and bs.epv and bs.okato is not distinct from :okato
      join h_tarif_kd kd on a.date_2 between kd.bp and kd.epv and kd.okato is not distinct from :okato
      left join sp_ksg_get(b.ds, p.dr, a.date_2, b.code_usl, p.sex,
                           (select sum(b1.k_uslf) from ZSD b1 where b1.ZS_ID = :ida and b1.ds_class = b.ds_class and b1.code_usl is null), -- -     
                           a.q_u, b.ds2, b.id, b.ksg_criterion,b.ksg_criterion2) sp on 1=1
      left join h_ksg k on k.ksg = sp.ksg and a.date_2 between k.bp and k.epv and k.q_u = a.q_u
      where b.zs_id = :ida
      order by b.code_usl
      into :ksg, :err_code, :ds, :idb, :tarif, :kz, :kd, :kus, :bs, :k_down, :prof_num, :date1, :code_usl, :fine_koef
      do
      begin
        kskp = 1;
--        fine_koef = null;

        if ((q_u = 1) and (err_code is null) and (date2 < '01.01.2019')) then
          kskp = (select KSKP from sp_calc_stac_kskp_2018(:ida, :idb, :ksg, :cl_cnt));

        if ((q_u in (1,3)) and (err_code is null) and (date2 >= '01.01.2019')) then
          kskp = (select KSKP from sp_calc_stac_kskp_2019(:ida, :idb, :ksg, :cl_cnt));

        if (kskp is null) then kskp = 1;

        if (fine_koef_set_doctor = 0) then
          fine_koef = (select FINE_KOEF from sp_calc_stac_fine_2018(:ida, :idb, :ksg, :cl_cnt));

        if (is_round_janao = 1) then
          sum_uslf = cast(cast(tarif * kskp as int) * fine_koef as int);
        else
          sum_uslf = tarif * kskp * fine_koef;

        if (:ksg is not null) then
        begin
            /*$$IBEC$$ if (:code_usl <> '') then
            begin
                select first 1 d.id, iif(:fine_koef_set_doctor = 1, d.fine_koef, :fine_koef)
                from zs z
                     join zsd d on d.zs_id = z.id
                where d.zs_id = :ida and coalesce(d.code_usl,'') = ''
                       and :date1 between d.date_1 and d.date_2
                       and not exists(select id from zsd d2 where d2.zs_id = :ida and coalesce(d2.code_usl,'') = '' and d2.date_1 = d.date_2)
                into :idb, :fine_koef;

                if (is_round_janao = 1) then
                  sum_uslf = cast(cast(tarif * kskp as int) * fine_koef as int);
                else
                  sum_uslf = tarif * kskp * fine_koef;
            end $$IBEC$$*/

            if ((select first 1 d.id from zsd d where d.zs_id = :ida and d.ksg_base = :ksg) is null) then
            update zsd b set
             b.ksg_base = :ksg,
             b.tar_base = iif(:date2 >= '01.05.2018', iif(:is_round_janao = 1, cast(:tarif * coalesce(:kskp,1) as int), :tarif * coalesce(:kskp,1)), iif(:is_round_janao = 1, cast(:tarif as integer), :tarif)),
             b.sum_base = :sum_uslf,
             b.kskp_base = :kskp,
             b.koef_z = :kz, 
             b.koef_d = :kd,
             b.koef_u = :kus,
             b.bs = :bs,
             b.koef_up = :k_down,
             b.reab = iif(:prof_num = 37,1,null),
             b.fine_koef = :fine_koef
             where b.id = :idb;
         end
      end 
--------------------------------------------------------------------------------
      --    6  + 
      if (q_u = 1) then
       if (exists (select 1 from zsd b where b.zs_id = :ida and ((b.ksg in ('2','st02.001') and b.k_uslf >= 6) or (b.ksg in ('O14.1','O34.2','O36.3','O36.4','O42.2') and b.k_uslf >= 2) ))
          and exists (select 1 from zsd b where b.zs_id = :ida and b.ksg in ('4', '5', 'st02.003', 'st02.004'))) then
          begin
            --    
            select first 1 b.ksg_base, b.ds
            from zs a
             join zsd b on a.id = b.zs_id
             where b.zs_id = :ida and b.ksg in ('4', '5', 'st02.003', 'st02.004')
             into :ksg, :ds;
       
            update zsd d
            set d.tar_usl = d.tar_base,
                d.sum_uslf = d.sum_base,
                d.ksg = d.ksg_base,
                d.kskp = d.kskp_base
            where d.zs_id = :ida;

            --   
            select coalesce(sum(b.sum_uslf), 0) from zsd b where b.zs_id = :ida
             into :sum_uslf;
    
            update zs a set
             a.tar_usl = :tarif,
             a.sum_uslf = :sum_uslf,
             a.sum_usl = :sum_uslf,
             a.ksg = :ksg,
             a.ds1 = :ds,
             a.kslp = :kskp
             where a.id = :ida;

            exit;
          end
--------------------------------------------------------------------------------
      if ((is_transfer < 2) or (cl_cnt < 2))  then  --   
      begin
        --     ,   
        ksg = null;
        select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base, b.kskp_base, b.koef_z, b.koef_d, b.koef_u, b.bs, b.koef_up,
             b.fine_koef
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and ((:q_u = 1 and b.ksg_base >= '325' and b.ksg_base <= '343') or
                                                                                                  (:q_u = 3 and b.ksg_base >= '123' and b.ksg_base <= '134'))
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif, :kskp, :kz, :kd, :kus, :bs, :k_down, :fine_koef;

        if (:ksg is null)  then
        begin
         select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base, b.date_1,
             b.kskp_base, b.koef_z, b.koef_d, b.koef_u, b.bs, b.koef_up,
             b.fine_koef
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif, :date1,
                  :kskp, :kz, :kd, :kus, :bs, :k_down, :fine_koef;

         if (((select coalesce(d.code_usl,'') from zsd d where d.id = :idb) <> '')
            and (exists(select d.id from zsd d where d.zs_id = :ida and d.id <> :idb and coalesce(d.code_usl,'') = '' and :date1 between d.date_1 and d.date_2))) then
         select first 1 d.id
             from zsd d
             where d.zs_id = :ida and d.id <> :idb and coalesce(d.code_usl,'') = '' and :date1 between d.date_1 and d.date_2
             into :idb;
        end

         --      
         update zsd b set
             b.ksg = :ksg,
             b.sum_uslf = :sum_uslf,
             b.ksg_base = :ksg,
             b.tar_usl = :tarif,
             b.sum_base = :sum_uslf,
             b.kskp_base = :kskp,
             b.koef_z = :kz, 
             b.koef_d = :kd,
             b.koef_u = :kus,
             b.bs = :bs,
             b.koef_up = :k_down,
             b.reab = iif(:prof_num = 37,1,null),
             b.fine_koef = :fine_koef
          where b.id = :idb;

         update zsd b set
             b.ksg = null,
             b.sum_uslf = 0,
             b.kskp = 1,
             b.tar_usl = 0,
             b.ksg_base = null,
             b.tar_base = null,
             b.sum_base = 0,
             b.kskp_base = null,
             b.koef_z = null,
             b.koef_d = null,
             b.koef_u = null,
             b.bs = null,
             b.koef_up = null,
             b.fine_koef = null
          where b.id <> :idb and b.zs_id = :ida;
 
         update zs a set
          a.tar_usl = :tarif,
          a.sum_uslf = :sum_uslf,
          a.sum_usl = :sum_uslf,
          a.ksg = :ksg,
          a.kslp = :kskp
          where a.id = :ida;
 
      end else
      begin
        for select d.ds_class
         from zsd d
         where d.zs_id = :ida
         group by 1
         into :ds_class
         do
         begin
            if (((select count(dc.id) from ksg_dont_choice dc join zsd z on z.ksg_base = dc.ksg_ter or z.ksg_base = dc.ksg_surg
                    where z.zs_id = :ida and z.ds_class = :ds_class and :date2 between dc.bp and dc.epv) > 0) and (:q_u = 1)) then
               --    
            select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base
             from zsd b
             where b.zs_id = :ida and b.ksg_base is not null and b.ds_class = :ds_class and b.code_usl is not null
             order by b.code_usl desc, b.sum_base desc
             into :idb, :ksg, :sum_uslf, :tarif;
            else
               --     
            begin
              select first 1 b.id, b.ksg_base, b.sum_base, b.tar_base, b.date_1,
                 b.kskp_base, b.koef_z, b.koef_d, b.koef_u, b.bs, b.koef_up,
                 b.fine_koef
                 from zsd b
                 where b.zs_id = :ida and b.ksg_base is not null and b.ds_class = :ds_class
                 order by b.code_usl desc, b.sum_base desc
                 into :idb, :ksg, :sum_uslf, :tarif, :date1,
                      :kskp, :kz, :kd, :kus, :bs, :k_down, :fine_koef;
    
             if (((select coalesce(d.code_usl,'') from zsd d where d.id = :idb) <> '')
                and (exists(select d.id from zsd d where d.zs_id = :ida and d.id <> :idb and coalesce(d.code_usl,'') = '' and :date1 between d.date_1 and d.date_2))) then
             select first 1 d.id
                 from zsd d
                 where d.zs_id = :ida and d.id <> :idb and coalesce(d.code_usl,'') = '' and :date1 between d.date_1 and d.date_2
                 into :idb;
            end
    
             --      
             update zsd b set
                 b.ksg = :ksg,
                 b.sum_uslf = :sum_uslf,
                 b.ksg_base = :ksg,
                 b.tar_usl = :tarif,
                 b.sum_base = :sum_uslf,
                 b.kskp_base = :kskp,
                 b.koef_z = :kz, 
                 b.koef_d = :kd,
                 b.koef_u = :kus,
                 b.bs = :bs,
                 b.koef_up = :k_down,
                 b.reab = iif(:prof_num = 37,1,null),
                 b.fine_koef = :fine_koef
              where b.id = :idb;
    
             update zsd b set
                 b.ksg = null,
                 b.sum_uslf = 0,
                 b.kskp = 1,
                 b.tar_usl = 0,
                 b.ksg_base = null,
                 b.tar_base = null,
                 b.sum_base = 0,
                 b.kskp_base = null,
                 b.koef_z = null,
                 b.koef_d = null,
                 b.koef_u = null,
                 b.bs = null,
                 b.koef_up = null,
                 b.fine_koef = null
              where b.id <> :idb and b.zs_id = :ida and b.ds_class = :ds_class;
         end

        select first 1 b.ksg_base, b.sum_base
        from zs a
         join zsd b on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null and b.ds = a.ds1
         order by b.sum_base desc
         into :ksg, :sum_uslf;

--        update zsd d
--         set d.tar_usl = d.tar_base,
--             d.sum_uslf = d.sum_base,
--             d.ksg = d.ksg_base,
--             d.kskp = d.kskp_base
--         where d.zs_id = :ida;
   
        select coalesce(sum(b.sum_uslf), 0), coalesce(sum(b.tar_base), 0)
         from zsd b
         join zs a on a.id = b.zs_id
         where b.zs_id = :ida and b.ksg is not null
         into :sum_uslf, :tarif;

        update zs a set
         a.tar_usl = :tarif,
         a.sum_uslf = :sum_uslf,
         a.sum_usl = :sum_uslf,
         a.ksg = :ksg,
         a.kslp = :kskp
         where a.id = :ida;
 
      end
end;


